register_book(&s, "|1|2|", "Administration", "Subpart 1.2  Administration\n1.201 Maintenance of the FAR.\n1.201-1 The two councils.\n(a) Subject to the authorities discussed in 1.103 , revisions to the FAR will be prepared and issued through the coordinated action of two councils, the Defense Acquisition Regulations Council (DAR Council) and the Civilian Agency Acquisition Council (CAA Council). Members of these councils shall  \n(1) Represent their agencies on a full-time basis;\n(2) Be selected for their superior qualifications in terms of acquisition experience and demonstrated professional expertise; and\n(3) Be funded by their respective agencies.\n(b) The chairperson of the CAA Council shall be the representative of the Administrator of General Services. The other members of this council shall be one each representative from the  \n(1) Departments of Agriculture, Commerce, Energy, Health and Human Services, Homeland Security, Interior, Labor, State, Transportation, and Treasury; and\n(2) Environmental Protection Agency, Social Security Administration, Small Business Administration, and Department of Veterans Affairs.\n(c) The Director of the DAR Council shall be the representative of the Secretary of Defense. The operation of the DAR Council will be as prescribed by the Secretary of Defense. Membership shall include representatives of the military departments, the Defense Logistics Agency, the Defense Contract Management Agency, and the National Aeronautics and Space Administration.\n(d) Responsibility for processing revisions to the FAR is apportioned by the two councils so that each council has cognizance over specified parts or subparts.\n(e) Each council shall be responsible for  \n(1) Agreeing on all revisions with the other council;\n(2) Submitting to the FAR Secretariat (see 1.201-2 ) the information required under paragraphs 1.501-2 (b) and (e) for publication in the Federal Register of a notice soliciting comments on a proposed revision to the FAR;\n(3) Considering all comments received in response to notice of proposed revisions;\n(4) Arranging for public meetings;\n(5) Preparing any final revision in the appropriate FAR format and language; and\n(6) Submitting any final revision to the FAR Secretariat for publication in the Federal Register and printing for distribution.\n1.201-2 FAR Secretariat.\n(a) The General Services Administration is responsible for establishing and operating the FAR Secretariat to print, publish, and distribute the FAR through the Code of Federal Regulations system (including a loose-leaf edition with periodic updates).\n(b) Additionally, the FAR Secretariat shall provide the two councils with centralized services for  \n(1) Keeping a synopsis of current FAR cases and their status;\n(2) Maintaining official files;\n(3) Assisting parties interested in reviewing the files on completed cases; and\n(4) Performing miscellaneous administrative tasks pertaining to the maintenance of the FAR.\n1.202 Agency compliance with the FAR.\nAgency compliance with the FAR (see 1.304 ) is the responsibility of the Secretary of Defense (for the military departments and defense agencies), the Administrator of General Services (for civilian agencies other than NASA), and the Administrator of NASA (for NASA activities).");
register_book(&s, "|1|3|", "Agency Acquisition Regulations", "Subpart 1.3  Agency Acquisition Regulations\n1.301 Policy.\n(a)(1) Subject to the authorities in paragraph (c) of this section and other statutory authority, an agency head may issue or authorize the issuance of agency acquisition regulations that implement or supplement the FAR and incorporate, together with the FAR, agency policies, procedures, contract clauses, solicitation provisions, and forms that govern the contracting process or otherwise control the relationship between the agency, including any of its suborganizations, and contractors or prospective contractors.\n(2) Subject to the authorities in paragraph (c) of this section and other statutory authority, an agency head may issue or authorize the issuance of internal agency guidance at any organizational level ( e.g., designations and delegations of authority, assignments of responsibilities, work-flow procedures, and internal reporting requirements).\n(b) Agency heads shall establish procedures to ensure that agency acquisition regulations are published for comment in the Federal Register in conformance with the procedures in Subpart 1.5 and as required by section 22 of the Office of Federal Procurement Policy Act, as amended ( 41 U.S.C. 418b ), and other applicable statutes, when they have a significant effect beyond the internal operating procedures of the agency or have a significant cost or administrative impact on contractors or offerors. However, publication is not required for issuances that merely implement or supplement higher level issuances that have previously undergone the public comment process, unless such implementation or supplementation results in an additional significant cost or administrative impact on contractors or offerors or effect beyond the internal operating procedures of the issuing organization. Issuances under 1.301 (a)(2) need not be publicized for public comment.\n(c) When adopting acquisition regulations, agencies shall ensure that they comply with the Paperwork Reduction Act ( 44 U.S.C. 3501 , et seq. ) as implemented in 5 CFR 1320 (see 1.106 ) and the Regulatory Flexibility Act ( 5 U.S.C. 601 , et seq. ). Normally, when a law requires publication of a proposed regulation, the Regulatory Flexibility Act applies and agencies must prepare written analyses, or certifications as provided in the law.\n(d) Agency acquisition regulations implementing or supplementing the FAR are, for  \n(1) The military departments and defense agencies, issued subject to the authority of the Secretary of Defense;\n(2) NASA activities, issued subject to the authorities of the Administrator of NASA; and\n(3) The civilian agencies other than NASA, issued by the heads of those agencies subject to the overall authority of the Administrator of General Services or independent authority the agency may have.\n1.302 Limitations.\nAgency acquisition regulations shall be limited to  \n(a) Those necessary to implement FAR policies and procedures within the agency; and\n(b) Additional policies, procedures, solicitation provisions, or contract clauses that supplement the FAR to satisfy the specific needs of the agency.\n1.303 Publication and codification.\n(a) Agency-wide acquisition regulations shall be published in the Federal Register as required by law, shall be codified under an assigned chapter in Title 48, Code of Federal Regulations , and shall parallel the FAR in format, arrangement, and numbering system (but see 1.105-1 (c)). Coverage in an agency acquisition regulation that implements a specific part, subpart, section, or subsection of the FAR shall be numbered and titled to correspond to the appropriate FAR number and title. Supplementary material for which there is no counterpart in the FAR shall be codified using chapter, part, subpart, section, or subsection numbers of 70 and up ( e.g., for the Department of Interior, whose assigned chapter number in Title 48 is 14, Part 1470, Subpart 1401.70, section 1401.370, or subsection 1401.301-70).\n(b) Issuances under 1.301 (a)(2) need not be published in the Federal Register .\n1.304 Agency control and compliance procedures.\n(a) Under the authorities of 1.301 (d), agencies shall control and limit issuance of agency acquisition regulations and, in particular, local agency directives that restrain the flexibilities found in the FAR, and shall establish formal procedures for the review of these documents to assure compliance with this Part 1 .\n(b) Agency acquisition regulations shall not  \n(1) Unnecessarily repeat, paraphrase, or otherwise restate material contained in the FAR or higher-level agency acquisition regulations; or\n(2) Except as required by law or as provided in Subpart 1.4 , conflict or be inconsistent with FAR content.\n(c) Agencies shall evaluate all regulatory coverage in agency acquisition regulations to determine if it could apply to other agencies. Coverage that is not peculiar to one agency shall be recommended for inclusion in the FAR.");
register_book(&s, "|1|4|", "Deviations from the FAR", "Subpart 1.4  Deviations from the FAR\n1.400 Scope of subpart.\nThis subpart prescribes the policies and procedures for authorizing deviations from the FAR. Exceptions pertaining to the use of forms prescribed by the FAR are covered in Part 53 rather than in this subpart.\n1.401 Definition.\nDeviation  means any one or combination of the following:\n(a) The issuance or use of a policy, procedure, solicitation provision (see definition in 2.101 ), contract clause (see definition in 2.101 ), method, or practice of conducting acquisition actions of any kind at any stage of the acquisition process that is inconsistent with the FAR.\n(b) The omission of any solicitation provision or contract clause when its prescription requires its use.\n(c) The use of any solicitation provision or contract clause with modified or alternate language that is not authorized by the FAR (see definition of  modification  in 52.101 (a) and definition of  alternate  in 2.101 (a)).\n(d) The use of a solicitation provision or contract clause prescribed by the FAR on a  substantially as follows  or  substantially the same as  basis (see definitions in 2.101 and 52.101 (a)), if such use is inconsistent with the intent, principle, or substance of the prescription or related coverage on the subject matter in the FAR.\n(e) The authorization of lesser or greater limitations on the use of any solicitation provision, contract clause, policy, or procedure prescribed by the FAR.\n(f) The issuance of policies or procedures that govern the contracting process or otherwise control contracting relationships that are not incorporated into agency acquisition regulations in accordance with 1.301 (a).\n1.402 Policy.\nUnless precluded by law, executive order, or regulation, deviations from the FAR may be granted as specified in this subpart when necessary to meet the specific needs and requirements of each agency. The development and testing of new techniques and methods of acquisition should not be stifled simply because such action would require a FAR deviation. The fact that deviation authority is required should not, of itself, deter agencies in their development and testing of new techniques and acquisition methods. Refer to 31.101 for instructions concerning deviations pertaining to the subject matter of Part 31 , Contract Cost Principles and Procedures. Deviations are not authorized with respect to 30.201-3 and 30.201-4 , or the requirements of the Cost Accounting Standards Board (CASB) rules and regulations (48 CFR Chapter 99 (FAR Appendix )). Refer to 30.201-5 for instructions concerning waivers pertaining to Cost Accounting Standards.\n1.403 Individual deviations.\nIndividual deviations affect only one contract action, and, unless 1.405 (e) is applicable, may be authorized by the agency head. The contracting officer must document the justification and agency approval in the contract file.\n1.404 Class deviations.\nClass deviations affect more than one contract action. When an agency knows that it will require a class deviation on a permanent basis, it should propose a FAR revision, if appropriate. Civilian agencies, other than NASA, must furnish a copy of each approved class deviation to the FAR Secretariat.\n(a) For civilian agencies except NASA, class deviations may be authorized by agency heads or their designees, unless 1.405 (e) is applicable. Delegation of this authority shall not be made below the head of a contracting activity. Authorization of class deviations by agency officials is subject to the following limitations:\n(1) An agency official who may authorize a class deviation, before doing so, shall consult with the chairperson of the Civilian Agency Acquisition Council (CAA Council), unless that agency official determines that urgency precludes such consultation.\n(2) Recommended revisions to the FAR shall be transmitted to the FAR Secretariat by agency heads or their designees for authorizing class deviations.\n(b) For DoD, class deviations shall be controlled, processed, and approved in accordance with the Defense FAR Supplement.\n(c) For NASA, class deviations shall be controlled and approved by the Assistant Administrator for Procurement. Deviations shall be processed in accordance with agency regulations.\n1.405 Deviations pertaining to treaties and executive agreements.\n(a)  Executive agreements,  as used in this section, means Government-to-Government agreements, including agreements with international organizations, to which the United States is a party.\n(b) Any deviation from the FAR required to comply with a treaty to which the United States is a party is authorized, unless the deviation would be inconsistent with FAR coverage based on a law enacted after the execution of the treaty.\n(c) Any deviation from the FAR required to comply with an executive agreement is authorized unless the deviation would be inconsistent with FAR coverage based on law.\n(d) For civilian agencies other than NASA, a copy of the text deviation authorized under paragraph (b) or (c) of this section shall be transmitted to the FAR Secretariat through a central agency control point.\n(e) For civilian agencies other than NASA, if a deviation required to comply with a treaty or an executive agreement is not authorized by paragraph (b) or (c) of this section, then the request for deviation shall be processed through the FAR Secretariat to the Civilian Agency Acquisition Council.");
register_book(&s, "|1|5|", "Agency and Public Participation", "Subpart 1.5  Agency and Public Participation\n1.501 Solicitation of agency and public views.\n1.501-1 Definition.\nSignificant revisions,  as used in this subpart, means revisions that alter the substantive meaning of any coverage in the FAR System having a significant cost or administrative impact on contractors or offerors, or significant effect beyond the internal operating procedures of the issuing agency. This expression, for example, does not include editorial, stylistic, or other revisions that have no impact on the basic meaning of the coverage being revised.\n1.501-2 Opportunity for public comments.\n(a) Views of agencies and nongovernmental parties or organizations will be considered in formulating acquisition policies and procedures.\n(b) The opportunity to submit written comments on proposed significant revisions shall be provided by placing a notice in the Federal Register . Each of these notices shall include  \n(1) The text of the revision or, if it is impracticable to publish the full text, a summary of the proposal;\n(2) The address and telephone number of the individual from whom copies of the revision, in full text, can be requested and to whom comments thereon should be addressed; and\n(3) When 1.501-3 (b) is applicable, a statement that the revision is effective on a temporary basis pending completion of the public comment period.\n(c) A minimum of 30 days and, normally, at least 60 days will be given for the receipt of comments.\n1.501-3 Exceptions.\n(a) Comments need not be solicited when the proposed coverage does not constitute a significant revision.\n(b) Advance comments need not be solicited when urgent and compelling circumstances make solicitation of comments impracticable prior to the effective date of the coverage, such as when a new statute must be implemented in a relatively short period of time. In such case, the coverage shall be issued on a temporary basis and shall provide for at least a 30 day public comment period.\n1.502 Unsolicited proposed revisions.\nConsideration shall also be given to unsolicited recommendations for revisions that have been submitted in writing with sufficient data and rationale to permit their evaluation.\n1.503 Public meetings.\nPublic meetings may be appropriate when a decision to adopt, amend, or delete FAR coverage is likely to benefit from significant additional views and discussion.");
register_book(&s, "|1|6|", "Career Development, Contracting Authori", "Subpart 1.6  Career Development, Contracting Authority, and Responsibilities\n1.601 General.\n(a) Unless specifically prohibited by another provision of law, authority and responsibility to contract for authorized supplies and services are vested in the agency head. The agency head may establish contracting activities and delegate broad authority to manage the agency  s contracting functions to heads of such contracting activities. Contracts may be entered into and signed on behalf of the Government only by contracting officers. In some agencies, a relatively small number of high level officials are designated contracting officers solely by virtue of their positions. Contracting officers below the level of a head of a contracting activity shall be selected and appointed under 1.603 .\n(b) Agency heads may mutually agree to  \n(1) Assign contracting functions and responsibilities from one agency to another; and\n(2) Create joint or combined offices to exercise acquisition functions and responsibilities.\n1.602 Contracting officers.\n1.602-1 Authority.\n(a) Contracting officers have authority to enter into, administer, or terminate contracts and make related determinations and findings. Contracting officers may bind the Government only to the extent of the authority delegated to them. Contracting officers shall receive from the appointing authority (see 1.603-1 ) clear instructions in writing regarding the limits of their authority. Information on the limits of the contracting officers  authority shall be readily available to the public and agency personnel.\n(b) No contract shall be entered into unless the contracting officer ensures that all requirements of law, executive orders, regulations, and all other applicable procedures, including clearances and approvals, have been met.\n1.602-2 Responsibilities.\nContracting officers are responsible for ensuring performance of all necessary actions for effective contracting, ensuring compliance with the terms of the contract, and safeguarding the interests of the United States in its contractual relationships. In order to perform these responsibilities, contracting officers should be allowed wide latitude to exercise business judgment. Contracting officers shall  \n(a) Ensure that the requirements of 1.602-1 (b) have been met, and that sufficient funds are available for obligation;\n(b) Ensure that contractors receive impartial, fair, and equitable treatment; \n(c) Request and consider the advice of specialists in audit, law, engineering, information security, transportation, and other fields, as appropriate; and\n(d) Designate and authorize, in writing and in accordance with agency procedures, a contracting officer  s representative (COR) on all contracts and orders other than those that are firm-fixed price, and for firm-fixed-price contracts and orders as appropriate, unless the contracting officer retains and executes the COR duties. See 7.104 (e). A COR  \n(1) Shall be a Government employee, unless otherwise authorized in agency regulations;\n(2) Shall be certified and maintain certification in accordance with the current Office of Management and Budget memorandum on the Federal Acquisition Certification for Contracting Officer Representatives (FAC-COR) guidance, or for DoD, in accordance with the current applicable DoD policy guidance;\n(3) Shall be qualified by training and experience commensurate with the responsibilities to be delegated in accordance with agency procedures;\n(4) May not be delegated responsibility to perform functions that have been delegated under 42.202 to a contract administration office, but may be assigned some duties at 42.302 by the contracting officer;\n(5) Has no authority to make any commitments or changes that affect price, quality, quantity, delivery, or other terms and conditions of the contract nor in any way direct the contractor or its subcontractors to operate in conflict with the contract terms and conditions;\n(6) Shall be nominated either by the requiring activity or in accordance with agency procedures; and \n(7) Shall be designated in writing, with copies furnished to the contractor and the contract administration office  \n(i) Specifying the extent of the COR  s authority to act on behalf of the contracting officer;\n(ii) Identifying the limitations on the COR  s authority;\n(iii) Specifying the period covered by the designation;\n(iv) Stating the authority is not redelegable; and\n(v) Stating that the COR may be personally liable for unauthorized acts.\n1.602-3 Ratification of unauthorized commitments.\n(a) Definitions .\nRatification,  as used in this subsection, means the act of approving an unauthorized commitment by an official who has the authority to do so.\nUnauthorized commitment,  as used in this subsection, means an agreement that is not binding solely because the Government representative who made it lacked the authority to enter into that agreement on behalf of the Government.\n(b) Policy.\n(1) Agencies should take positive action to preclude, to the maximum extent possible, the need for ratification actions. Although procedures are provided in this section for use in those cases where the ratification of an unauthorized commitment is necessary, these procedures may not be used in a manner that encourages such commitments being made by Government personnel.\n(2) Subject to the limitations in paragraph (c) of this subsection, the head of the contracting activity, unless a higher level official is designated by the agency, may ratify an unauthorized commitment.\n(3) The ratification authority in paragraph (b)(2) of this subsection may be delegated in accordance with agency procedures, but in no case shall the authority be delegated below the level of chief of the contracting office.\n(4) Agencies should process unauthorized commitments using the ratification authority of this subsection instead of referring such actions to the Government Accountability Office for resolution. (See 1.602-3 (d).)\n(5) Unauthorized commitments that would involve claims subject to resolution under the Contract Disputes Act of 1978 should be processed in accordance with Subpart 33.2 , Disputes and Appeals.\n(c) Limitations . The authority in paragraph (b)(2) of this subsection may be exercised only when  \n(1) Supplies or services have been provided to and accepted by the Government, or the Government otherwise has obtained or will obtain a benefit resulting from performance of the unauthorized commitment;\n(2) The ratifying official has the authority to enter into a contractual commitment;\n(3) The resulting contract would otherwise have been proper if made by an appropriate contracting officer;\n(4) The contracting officer reviewing the unauthorized commitment determines the price to be fair and reasonable;\n(5) The contracting officer recommends payment and legal counsel concurs in the recommendation, unless agency procedures expressly do not require such concurrence;\n(6) Funds are available and were available at the time the unauthorized commitment was made; and\n(7) The ratification is in accordance with any other limitations prescribed under agency procedures.\n(d) Nonratifiable commitments . Cases that are not ratifiable under this subsection may be subject to resolution as recommended by the Government Accountability Office under its claim procedure (GAO Policy and Procedures Manual for Guidance of Federal Agencies, Title 4, Chapter 2), or as authorized by FAR Subpart 50.1 . Legal advice should be obtained in these cases.\n1.603 Selection, appointment, and termination of appointment for contracting officers.\n1.603-1 General.\nSubsection 414(4) of Title 41, United States Code, requires agency heads to establish and maintain a procurement career management program and a system for the selection, appointment, and termination of appointment of contracting officers. Agency heads or their designees may select and appoint contracting officers and terminate their appointments. These selections and appointments shall be consistent with Office of Federal Procurement Policy  s (OFPP) standards for skill-based training in performing contracting and purchasing duties as published in OFPP Policy Letter No. 05-01, Developing and Managing the Acquisition Workforce, April 15, 2005.\n1.603-2 Selection.\nIn selecting contracting officers, the appointing official shall consider the complexity and dollar value of the acquisitions to be assigned and the candidate  s experience, training, education, business acumen, judgment, character, and reputation. Examples of selection criteria include  \n(a) Experience in Government contracting and administration, commercial purchasing, or related fields;\n(b) Education or special training in business administration, law, accounting, engineering, or related fields;\n(c) Knowledge of acquisition policies and procedures, including this and other applicable regulations;\n(d) Specialized knowledge in the particular assigned field of contracting; and\n(e) Satisfactory completion of acquisition training courses.\n1.603-3 Appointment.\n(a) Contracting officers shall be appointed in writing on an SF 1402 , Certificate of Appointment, which shall state any limitations on the scope of authority to be exercised, other than limitations contained in applicable law or regulation. Appointing officials shall maintain files containing copies of all appointments that have not been terminated.\n(b) Agency heads are encouraged to delegate micro-purchase authority to individuals who are employees of an executive agency or members of the Armed Forces of the United States who will be using the supplies or services being purchased. Individuals delegated this authority are not required to be appointed on an SF 1402 , but shall be appointed in writing in accordance with agency procedures.\n1.603-4 Termination.\nTermination of a contracting officer appointment will be by letter, unless the Certificate of Appointment contains other provisions for automatic termination. Terminations may be for reasons such as reassignment, termination of employment, or unsatisfactory performance. No termination shall operate retroactively.\n1.604 Contracting Officer  s Representative (COR).\nA contracting officer  s representative (COR) assists in the technical monitoring or administration of a contract (see 1.602-2 (d)). The COR shall maintain a file for each assigned contract. The file must include, at a minimum -\n(a) A copy of the contracting officer  s letter of designation and other documents describing the COR  s duties and responsibilities;\n(b) A copy of the contract administration functions delegated to a contract administration office which may not be delegated to the COR (see 1.602-2 (d)(4)); and\n(c) Documentation of COR actions taken in accordance with the delegation of authority.");
register_book(&s, "|1|7|", "Determinations and Findings", "Subpart 1.7  Determinations and Findings\n1.700 Scope of subpart.\nThis subpart prescribes general policies and procedures for the use of determinations and findings (D&F  s). Requirements for specific types of D&F  s can be found with the appropriate subject matter.\n1.701 Definition.\nDetermination and Findings  means a special form of written approval by an authorized official that is required by statute or regulation as a prerequisite to taking certain contract actions. The  determination  is a conclusion or decision supported by the  findings.    The findings are statements of fact or rationale essential to support the determination and must cover each requirement of the statute or regulation.\n1.702 General.\n(a) A D&F shall ordinarily be for an individual contract action. Unless otherwise prohibited, class D&F  s may be executed for classes of contract actions (see 1.703 ). The approval granted by a D&F is restricted to the proposed contract action(s) reasonably described in that D&F. D&F  s may provide for a reasonable degree of flexibility. Furthermore, in their application, reasonable variations in estimated quantities or prices are permitted, unless the D&F specifies otherwise.\n(b) When an option is anticipated, the D&F shall state the approximate quantity to be awarded initially and the extent of the increase to be permitted by the option.\n1.703 Class determinations and findings.\n(a) A class D&F provides authority for a class of contract actions. A class may consist of contract actions for the same or related supplies or services or other contract actions that require essentially identical justification.\n(b) The findings in a class D&F shall fully support the proposed action either for the class as a whole or for each action. A class D&F shall be for a specified period, with the expiration date stated in the document.\n(c) The contracting officer shall ensure that individual actions taken pursuant to the authority of a class D&F are within the scope of the D&F.\n1.704 Content.\nEach D&F shall set forth enough facts and circumstances to clearly and convincingly justify the specific determination made. As a minimum, each D&F shall include, in the prescribed agency format, the following information:\n(a) Identification of the agency and of the contracting activity and specific identification of the document as a  Determination and Findings.  \n(b) Nature and/or description of the action being approved.\n(c) Citation of the appropriate statute and/or regulation upon which the D&F is based.\n(d) Findings that detail the particular circumstances, facts, or reasoning essential to support the determination. Necessary supporting documentation shall be obtained from appropriate requirements and technical personnel.\n(e) A determination, based on the findings, that the proposed action is justified under the applicable statute or regulation.\n(f) Expiration date of the D&F, if required (see 1.706 ).\n(g) The signature of the official authorized to sign the D&F (see 1.707 ) and the date signed.\n1.705 Supersession and modification.\n(a) If a D&F is superseded by another D&F, that action shall not render invalid any action taken under the original D&F prior to the date of its supersession.\n(b) The contracting officer need not cancel the solicitation if the D&F, as modified, supports the contract action.\n1.706 Expiration.\nExpiration dates are required for class D&F  s and are optional for individual D&F  s. Authority to act under an individual D&F expires when it is exercised or on an expiration date specified in the document, whichever occurs first. Authority to act under a class D&F expires on the expiration date specified in the document. When a solicitation has been furnished to prospective offerors before the expiration date, the authority under the D&F will continue until award of the contract(s) resulting from the solicitation.\n1.707 Signatory authority.\nWhen a D&F is required, it shall be signed by the appropriate official in accordance with agency regulations. Authority to sign or delegate signature authority for the various D&F  s is as shown in the applicable FAR part.\n*    *    *    *    *    *");
register_book(&s, "|2|2|", "Definitions Clause", "Subpart 2.2  Definitions Clause\n2.201 Contract clause.\nInsert the clause at 52.202-1 , Definitions, in solicitations and contracts that exceed the simplified acquisition threshold.\n*    *    *    *    *    *");
register_book(&s, "|3|2|", "Contractor Gratuities to Government Per", "Subpart 3.2  Contractor Gratuities to Government Personnel\n3.201 Applicability.\nThis subpart applies to all executive agencies, except that coverage concerning exemplary damages applies only to the Department of Defense ( 10 U.S.C. 2207 ).\n3.202 Contract clause.\nThe contracting officer shall insert the clause at 52.203-3 , Gratuities, in solicitations and contracts with a value exceeding the simplified acquisition threshold, except those for personal services and those between military departments or defense agencies and foreign governments that do not obligate any funds appropriated to the Department of Defense.\n3.203 Reporting suspected violations of the Gratuities clause.\nAgency personnel shall report suspected violations of the Gratuities clause to the contracting officer or other designated official in accordance with agency procedures. The agency reporting procedures shall be published as an implementation of this section 3.203 and shall clearly specify  \n(a) What to report and how to report it; and\n(b) The channels through which reports must pass, including the function and authority of each official designated to review them.\n3.204 Treatment of violations.\n(a) Before taking any action against a contractor, the agency head or a designee shall determine, after notice and hearing under agency procedures, whether the contractor, its agent, or another representative, under a contract containing the Gratuities clause  \n(1) Offered or gave a gratuity ( e.g., an entertainment or gift) to an officer, official, or employee of the Government; and\n(2) Intended by the gratuity to obtain a contract or favorable treatment under a contract (intent generally must be inferred).\n(b) Agency procedures shall afford the contractor an opportunity to appear with counsel, submit documentary evidence, present witnesses, and confront any person the agency presents. The procedures should be as informal as practicable, consistent with principles of fundamental fairness.\n(c) When the agency head or designee determines that a violation has occurred, the Government may  \n(1) Terminate the contractor  s right to proceed;\n(2) Initiate debarment or suspension measures as set forth in Subpart 9.4 ; and\n(3) Assess exemplary damages, if the contract uses money appropriated to the Department of Defense.");
register_book(&s, "|3|3|", "Reports of Suspected Antitrust Violatio", "Subpart 3.3  Reports of Suspected Antitrust Violations\n3.301 General.\n(a) Practices that eliminate competition or restrain trade usually lead to excessive prices and may warrant criminal, civil, or administrative action against the participants. Examples of anticompetitive practices are collusive bidding, follow-the-leader pricing, rotated low bids, collusive price estimating systems, and sharing of the business.\n(b) Contracting personnel are an important potential source of investigative leads for antitrust enforcement and should therefore be sensitive to indications of unlawful behavior by offerors and contractors. Agency personnel shall report, in accordance with agency regulations, evidence of suspected antitrust violations in acquisitions for possible referral to  \n(1) The Attorney General under 3.303 ; and\n(2) The agency office responsible for contractor debarment and suspension under Subpart 9.4 .\n3.302 Definitions.\nAs used in this subpart  \nIdentical bids  means bids for the same line item that are determined to be identical as to unit price or total line item amount, with or without the application of evaluation factors ( e.g., discount or transportation cost).\nLine item  means an item of supply or service, specified in a solicitation, that the offeror must separately price.\n3.303 Reporting suspected antitrust violations.\n(a) Agencies are required by 41 U.S.C. 253b(i) and 10 U.S.C. 2305(b)(9) to report to the Attorney General any bids or proposals that evidence a violation of the antitrust laws. These reports are in addition to those required by Subpart 9.4 .\n(b) The antitrust laws are intended to ensure that markets operate competitively. Any agreement or mutual understanding among competing firms that restrains the natural operation of market forces is suspect. Paragraph (c) of this section identifies behavior patterns that are often associated with antitrust violations. Activities meeting the descriptions in paragraph (c) are not necessarily improper, but they are sufficiently questionable to warrant notifying the appropriate authorities, in accordance with agency procedures.\n(c) Practices or events that may evidence violations of the antitrust laws include  \n(1) The existence of an  industry price list  or  price agreement  to which contractors refer in formulating their offers;\n(2) A sudden change from competitive bidding to identical bidding;\n(3) Simultaneous price increases or follow-the-leader pricing;\n(4) Rotation of bids or proposals, so that each competitor takes a turn in sequence as low bidder, or so that certain competitors bid low only on some sizes of contracts and high on other sizes;\n(5) Division of the market, so that certain competitors bid low only for contracts let by certain agencies, or for contracts in certain geographical areas, or on certain products, and bid high on all other jobs;\n(6) Establishment by competitors of a collusive price estimating system;\n(7) The filing of a joint bid by two or more competitors when at least one of the competitors has sufficient technical capability and productive capacity for contract performance;\n(8) Any incidents suggesting direct collusion among competitors, such as the appearance of identical calculation or spelling errors in two or more competitive offers or the submission by one firm of offers for other firms; and\n(9) Assertions by the employees, former employees, or competitors of offerors, that an agreement to restrain trade exists.\n(d) Identical bids shall be reported under this section if the agency has some reason to believe that the bids resulted from collusion.\n(e) For offers from foreign contractors for contracts to be performed outside the United States and its outlying areas, contracting officers may refer suspected collusive offers to the authorities of the foreign government concerned for appropriate action.\n(f) Agency reports shall be addressed to the  \nAttorney General U.S. Department of Justice Washington DC 20530 Attention: Assistant Attorney General Antitrust Division\nand shall include  \n(1) A brief statement describing the suspected practice and the reason for the suspicion; and\n(2) The name, address, and telephone number of an individual in the agency who can be contacted for further information.\n(g) Questions concerning this reporting requirement may be communicated by telephone directly to the Office of the Assistant Attorney General, Antitrust Division.");
register_book(&s, "|3|4|", "Contingent Fees", "Subpart 3.4  Contingent Fees\n3.400 Scope of subpart.\nThis subpart prescribes policies and procedures that restrict contingent fee arrangements for soliciting or obtaining Government contracts to those permitted by 10 U.S.C. 2306(b) and 41 U.S.C. 254(a) .\n3.401 Definitions.\nAs used in this subpart  \nBona fide agency  means an established commercial or selling agency, maintained by a contractor for the purpose of securing business, that neither exerts nor proposes to exert improper influence to solicit or obtain Government contracts nor holds itself out as being able to obtain any Government contract or contracts through improper influence.\nBona fide employee  means a person, employed by a contractor and subject to the contractor  s supervision and control as to time, place, and manner of performance, who neither exerts nor proposes to exert improper influence to solicit or obtain Government contracts nor holds out as being able to obtain any Government contract or contracts through improper influence.\nContingent fee  means any commission, percentage, brokerage, or other fee that is contingent upon the success that a person or concern has in securing a Government contract.\nImproper influence  means any influence that induces or tends to induce a Government employee or officer to give consideration or to act regarding a Government contract on any basis other than the merits of the matter.\n3.402 Statutory requirements.\nContractors  arrangements to pay contingent fees for soliciting or obtaining Government contracts have long been considered contrary to public policy because such arrangements may lead to attempted or actual exercise of improper influence. In 10 U.S.C. 2306(b) and 41 U.S.C. 254(a) , Congress affirmed this public policy but permitted certain exceptions. These statutes  \n(a) Require in every negotiated contract a warranty by the contractor against contingent fees;\n(b) Permit, as an exception to the warranty, contingent fee arrangements between contractors and bona fide employees or bona fide agencies; and\n(c) Provide that, for breach or violation of the warranty by the contractor, the Government may annul the contract without liability or deduct from the contract price or consideration, or otherwise recover, the full amount of the contingent fee.\n3.403 Applicability.\nThis subpart applies to all contracts. Statutory requirements for negotiated contracts are, as a matter of policy, extended to sealed bid contracts.\n3.404 Contract clause.\nThe contracting officer shall insert the clause at 52.203-5 , Covenant Against Contingent Fees, in all solicitations and contracts exceeding the simplified acquisition threshold, other than those for commercial items (see Parts 2 and 12 ).\n3.405 Misrepresentations or violations of the Covenant Against Contingent Fees.\n(a) Government personnel who suspect or have evidence of attempted or actual exercise of improper influence, misrepresentation of a contingent fee arrangement, or other violation of the Covenant Against Contingent Fees shall report the matter promptly to the contracting officer or appropriate higher authority in accordance with agency procedures.\n(b) When there is specific evidence or other reasonable basis to suspect one or more of the violations in paragraph (a) of this section, the chief of the contracting office shall review the facts and, if appropriate, take or direct one or more of the following, or other, actions:\n(1) If before award, reject the bid or proposal.\n(2) If after award, enforce the Government  s right to annul the contract or to recover the fee.\n(3) Initiate suspension or debarment action under Subpart 9.4 .\n(4) Refer suspected fraudulent or criminal matters to the Department of Justice, as prescribed in agency regulations.\n3.406 Records.\nFor enforcement purposes, agencies shall preserve any specific evidence of one or more of the violations in 3.405 (a), together with all other pertinent data, including a record of actions taken. Contracting offices shall not retire or destroy these records until it is certain that they are no longer needed for enforcement purposes. If the original record is maintained in a central file, a copy must be retained in the contract file.");
register_book(&s, "|3|5|", "Other Improper Business Practices", "Subpart 3.5  Other Improper Business Practices\n3.501 Buying-in.\n3.501-1 Definition.\nBuying-in,  as used in this section, means submitting an offer below anticipated costs, expecting to  \n(1) Increase the contract amount after award ( e.g., through unnecessary or excessively priced change orders); or\n(2) Receive follow-on contracts at artificially high prices to recover losses incurred on the buy-in contract.\n3.501-2 General.\n(a) Buying-in may decrease competition or result in poor contract performance. The contracting officer must take appropriate action to ensure buying-in losses are not recovered by the contractor through the pricing of  \n(1) Change orders; or\n(2) Follow-on contracts subject to cost analysis.\n(b) The Government should minimize the opportunity for buying-in by seeking a price commitment covering as much of the entire program concerned as is practical by using  \n(1) Multiyear contracting, with a requirement in the solicitation that a price be submitted only for the total multiyear quantity; or\n(2) Priced options for additional quantities that, together with the firm contract quantity, equal the program requirements (see Subpart 17.2 ).\n(c) Other safeguards are available to the contracting officer to preclude recovery of buying-in losses ( e.g., amortization of nonrecurring costs (see 15.408 , Table 15-2 , paragraph A, column (2) under  Formats for Submission of Line Item Summaries  ) and treatment of unreasonable price quotations (see 15.405 ).\n3.502 Subcontractor kickbacks.\n3.502-1 Definitions.\nAs used in this section  \nKickback  means any money, fee, commission, credit, gift, gratuity, thing of value, or compensation of any kind which is provided, directly or indirectly, to any prime contractor, prime contractor employee, subcontractor, or subcontractor employee for the purpose of improperly obtaining or rewarding favorable treatment in connection with a prime contract or in connection with a subcontract relating to a prime contract.\nPerson  means a corporation, partnership, business association of any kind, trust, joint-stock company, or individual.\nPrime contract  means a contract or contractual action entered into by the United States for the purpose of obtaining supplies, materials, equipment, or services of any kind.\nPrime Contractor  means a person who has entered into a prime contract with the United States.\nPrime Contractor employee  means any officer, partner, employee, or agent of a prime contractor.\nSubcontract  means a contract or contractual action entered into by a prime contractor or subcontractor for the purpose of obtaining supplies, materials, equipment, or services of any kind under a prime contract.\nSubcontractor  (1) means any person, other than the prime contractor, who offers to furnish or furnishes any supplies, materials, equipment, or services of any kind under a prime contract or a subcontract entered into in connection with such prime contract; and (2) includes any person who offers to furnish or furnishes general supplies to the prime contractor or a higher tier subcontractor.\n3.502-2 Subcontractor kickbacks.\nThe Anti-Kickback Act of 1986 ( 41 U.S.C. 51-58 ) was passed to deter subcontractors from making payments and contractors from accepting payments for the purpose of improperly obtaining or rewarding favorable treatment in connection with a prime contract or a subcontract relating to a prime contract. The Act  \n(a) Prohibits any person from  \n(1) Providing, attempting to provide, or offering to provide any kickback;\n(2) Soliciting, accepting, or attempting to accept any kickback; or\n(3) Including, directly or indirectly, the amount of any kickback in the contract price charged by a subcontractor to a prime contractor or a higher tier subcontractor or in the contract price charged by a prime contractor to the United States.\n(b) Imposes criminal penalties on any person who knowingly and willfully engages in the prohibited conduct addressed in paragraph (a) of this subsection.\n(c) Provides for the recovery of civil penalties by the United States from any person who knowingly engages in such prohibited conduct and from any person whose employee, subcontractor, or subcontractor employee provides, accepts, or charges a kickback.\n(d) Provides that  \n(1) The contracting officer may offset the amount of a kickback against monies owed by the United States to the prime contractor under the prime contract to which such kickback relates;\n(2) The contracting officer may direct a prime contractor to withhold from any sums owed to a subcontractor under a subcontract of the prime contract the amount of any kickback which was or may be offset against the prime contractor under paragraph (d)(1) of this subsection; and\n(3) An offset under paragraph (d)(1) or a direction under paragraph (d)(2) of this subsection is a claim by the Government for the purposes of the Contract Disputes Act of 1978.\n(e) Authorizes contracting officers to order that sums withheld under paragraph (d)(2) of this subsection be paid to the contracting agency, or if the sum has already been offset against the prime contractor, that it be retained by the prime contractor.\n(f) Requires the prime contractor to notify the contracting officer when the withholding under paragraph (d)(2) of this subsection has been accomplished unless the amount withheld has been paid to the Government.\n(g) Requires a prime contractor or subcontractor to report in writing to the inspector general of the contracting agency, the head of the contracting agency if the agency does not have an inspector general, or the Department of Justice any possible violation of the Act when the prime contractor or subcontractor has reasonable grounds to believe such violation may have occurred.\n(h) Provides that, for the purpose of ascertaining whether there has been a violation of the Act with respect to any prime contract, the Government Accountability Office and the inspector general of the contracting agency, or a representative of such contracting agency designated by the head of the agency if the agency does not have an inspector general, shall have access to and may inspect the facilities and audit the books and records, including any electronic data or records, of any prime contractor or subcontractor under a prime contract awarded by such agency.\n(i) Requires each contracting agency to include in each prime contract exceeding $150,000 for other than commercial items (see Part 12 ), a requirement that the prime contractor shall  \n(1) Have in place and follow reasonable procedures designed to prevent and detect violations of the Act in its own operations and direct business relationships ( e.g., company ethics rules prohibiting kickbacks by employees, agents, or subcontractors; education programs for new employees and subcontractors, explaining policies about kickbacks, related company procedures and the consequences of detection; procurement procedures to minimize the opportunity for kickbacks; audit procedures designed to detect kickbacks; periodic surveys of subcontractors to elicit information about kickbacks; procedures to report kickbacks to law enforcement officials; annual declarations by employees of gifts or gratuities received from subcontractors; annual employee declarations that they have violated no company ethics rules; personnel practices that document unethical or illegal behavior and make such information available to prospective employers); and\n(2) Cooperate fully with any Federal agency investigating a possible violation of the Act.\n(j) Notwithstanding paragraph (i) of this subsection, a prime contractor shall cooperate fully with any Federal government agency investigating a violation of Section 3 of the Anti-Kickback Act of 1986 ( 41 U.S.C. 51-58 ).\n3.502-3 Contract clause.\nThe contracting officer shall insert the clause at 52.203-7 , Anti-Kickback Procedures, in solicitations and contracts exceeding the simplified acquisition threshold, other than those for commercial items (see Part 12 ).\n3.503 Unreasonable restrictions on subcontractor sales.\n3.503-1 Policy.\n10 U.S.C. 2402 and 41 U.S.C. 253g require that subcontractors not be unreasonably precluded from making direct sales to the Government of any supplies or services made or furnished under a contract. However, this does not preclude contractors from asserting rights that are otherwise authorized by law or regulation.\n3.503-2 Contract clause.\nThe contracting officer shall insert the clause at 52.203-6 , Restrictions on Subcontractor Sales to the Government, in solicitations and contracts exceeding the simplified acquisition threshold. For the acquisition of commercial items, the contracting officer shall use the clause with its Alternate I.");
register_book(&s, "|3|6|", "Contracts with Government Employees or", "Subpart 3.6  Contracts with Government Employees or Organizations Owned or Controlled by Them\n3.601 Policy.\n(a) Except as specified in 3.602 , a contracting officer shall not knowingly award a contract to a Government employee or to a business concern or other organization owned or substantially owned or controlled by one or more Government employees. This policy is intended to avoid any conflict of interest that might arise between the employees  interests and their Government duties, and to avoid the appearance of favoritism or preferential treatment by the Government toward its employees.\n(b) For purposes of this subpart, special Government employees (as defined in 18 U.S.C. 202 ) performing services as experts, advisors, or consultants, or as members of advisory committees, are not considered Government employees unless  \n(1) The contract arises directly out of the individual  s activity as a special Government employee;\n(2) In the individual  s capacity as a special Government employee, the individual is in a position to influence the award of the contract; or\n(3) Another conflict of interest is determined to exist.\n3.602 Exceptions.\nThe agency head, or a designee not below the level of the head of the contracting activity, may authorize an exception to the policy in 3.601 only if there is a most compelling reason to do so, such as when the Government  s needs cannot reasonably be otherwise met.\n3.603 Responsibilities of the contracting officer.\n(a) Before awarding a contract, the contracting officer shall obtain an authorization under 3.602 if  \n(1) The contracting officer knows, or has reason to believe, that a prospective contractor is one to which award is otherwise prohibited under 3.601 ; and\n(2) There is a most compelling reason to make an award to that prospective contractor.\n(b) The contracting officer shall comply with the requirements and guidance in Subpart 9.5 before awarding a contract to an organization owned or substantially owned or controlled by Government employees.");
register_book(&s, "|3|7|", "Voiding and Rescinding Contracts", "Subpart 3.7  Voiding and Rescinding Contracts\n3.700 Scope of subpart.\n(a) This subpart prescribes Governmentwide policies and procedures for exercising discretionary authority to declare void and rescind contracts in relation to which  \n(1) There has been a final conviction for bribery, conflict of interest, disclosure or receipt of contractor bid or proposal information or source selection information in exchange for a thing of value or to give anyone a competitive advantage in the award of a Federal agency procurement contract, or similar misconduct; or\n(2) There has been an agency head determination that contractor bid or proposal information or source selection information has been disclosed or received in exchange for a thing of value, or for the purpose of obtaining or giving anyone a competitive advantage in the award of a Federal agency procurement contract.\n(b) This subpart does not prescribe policies or procedures for, or govern the exercise of, any other remedy available to the Government with respect to such contracts, including but not limited to, the common law right of avoidance, rescission, or cancellation.\n3.701 Purpose.\nThis subpart provides  \n(a) An administrative remedy with respect to contracts in relation to which there has been  \n(1) A final conviction for bribery, conflict of interest, disclosure or receipt of contractor bid or proposal information or source selection information in exchange for a thing of value or to give anyone a competitive advantage in the award of a Federal agency procurement contract, or similar misconduct; or\n(2) An agency head determination that contractor bid or proposal information or source selection information has been disclosed or received in exchange for a thing of value, or for the purpose of obtaining or giving anyone a competitive advantage in the award of a Federal agency procurement contract; and\n(b) A means to deter similar misconduct in the future by those who are involved in the award, performance, and administration of Government contracts.\n3.702 Definition.\nFinal conviction  means a conviction, whether entered on a verdict or plea, including a plea of nolo contendere, for which a sentence has been imposed.\n3.703 Authority.\n(a) Section 1(e) of Public Law 87-849, 18 U.S.C. 218 (  the Act  ), empowers the President or the heads of executive agencies acting under regulations prescribed by the President, to declare void and rescind contracts and other transactions enumerated in the Act, in relation to which there has been a final conviction for bribery, conflict of interest, or any other violation of Chapter 11 of Title 18 of the United States Code ( 18 U.S.C. 201-224 ). Executive Order 12448, November 4, 1983, delegates the President  s authority under the Act to the heads of the executive agencies and military departments.\n(b) Subsection 27(e)(3) of the Office of Federal Procurement Policy Act ( 41 U.S.C. 423 ) (the OFPP Act), as amended, requires a Federal agency, upon receiving information that a contractor or a person has engaged in conduct constituting a violation of subsection 27(a) or (b) of the OFPP Act, to consider recission of a contract with respect to which  \n(1) The contractor or someone acting for the contractor has been convicted for an offense punishable under subsection 27(e)(1) of the OFPP Act; or\n(2) The head of the agency, or designee, has determined, based upon a preponderance of the evidence, that the contractor or someone acting for the contractor has engaged in conduct constituting such an offense.\n3.704 Policy.\n(a) In cases in which there is a final conviction for any violation of 18 U.S.C. 201-224 involving or relating to contracts awarded by an agency, the agency head or designee, shall consider the facts available and, if appropriate, may declare void and rescind contracts, and recover the amounts expended and property transferred by the agency in accordance with the policies and procedures of this subpart.\n(b) Since a final conviction under 18 U.S.C. 201-224 relating to a contract also may justify the conclusion that the party involved is not presently responsible, the agency should consider initiating debarment proceedings in accordance with Subpart 9.4 , Debarment, Suspension, and Ineligibility, if debarment has not been initiated, or is not in effect at the time the final conviction is entered.\n(c) If there is a final conviction for an offense punishable under subsection 27(e) of the OFPP Act, or if the head of the agency, or designee, has determined, based upon a preponderance of the evidence, that the contractor or someone acting for the contractor has engaged in conduct constituting such an offense, then the head of the contracting activity shall consider, in addition to any other penalty prescribed by law or regulation  \n(1) Declaring void and rescinding contracts, as appropriate, and recovering the amounts expended under the contracts by using the procedures at 3.705 (see 3.104-7 ); and\n(2) Recommending the initiation of suspension or debarment proceedings in accordance with Subpart 9.4 .\n3.705 Procedures.\n(a) Reporting . The facts concerning any final conviction for any violation of 18 U.S.C. 201-224 involving or relating to agency contracts shall be reported promptly to the agency head or designee for that official  s consideration. The agency head or designee shall promptly notify the Civil Division, Department of Justice, that the action is being considered under this subpart.\n(b) Decision . Following an assessment of the facts, the agency head or designee may declare void and rescind contracts with respect to which a final conviction has been entered, and recover the amounts expended and the property transferred by the agency under the terms of the contracts involved.\n(c) Decision-making process . Agency procedures governing the voiding and rescinding decision-making process shall be as informal as practicable, consistent with the principles of fundamental fairness. As a minimum, however, agencies shall provide the following:\n(1) A notice of proposed action to declare void and rescind the contract shall be made in writing and sent by certified mail, return receipt requested.\n(2) A thirty calendar day period after receipt of the notice, for the contractor to submit pertinent information before any final decision is made.\n(3) Upon request made within the period for submission of pertinent information, an opportunity shall be afforded for a hearing at which witnesses may be presented, and any witness the agency presents may be confronted. However, no inquiry shall be made regarding the validity of a conviction.\n(4) If the agency head or designee decides to declare void and rescind the contracts involved, that official shall issue a written decision which  \n(i) States that determination;\n(ii) Reflects consideration of the fair value of any tangible benefits received and retained by the agency; and\n(iii) States the amount due and the property to be returned to the agency.\n(d) Notice of proposed action . The notice of proposed action, as a minimum shall  \n(1) Advise that consideration is being given to declaring void and rescinding contracts awarded by the agency, and recovering the amounts expended and property transferred therefor, under the provisions of 18 U.S.C. 218 ;\n(2) Specifically identify the contracts affected by the action;\n(3) Specifically identify the offense or final conviction on which the action is based;\n(4) State the amounts expended and property transferred under each of the contracts involved, and the money and the property demanded to be returned;\n(5) Identify any tangible benefits received and retained by the agency under the contract, and the value of those benefits, as calculated by the agency;\n(6) Advise that pertinent information may be submitted within 30 calendar days after receipt of the notice, and that, if requested within that time, a hearing shall be held at which witnesses may be presented and any witness the agency presents may be confronted; and\n(7) Advise that action shall be taken only after the agency head or designee issues a final written decision on the proposed action.\n(e) Final agency decision . The final agency decision shall be based on the information available to the agency head or designee, including any pertinent information submitted or, if a hearing was held, presented at the hearing. If the agency decision declares void and rescinds the contract, the final decision shall specify the amounts due and property to be returned to the agency, and reflect consideration of the fair value of any tangible benefits received and retained by the agency. Notice of the decision shall be sent promptly by certified mail, return receipt requested. Rescission of contracts under the authority of the Act and demand for recovery of the amounts expended and property transferred therefor, is not a claim within the meaning of the Contract Disputes Act of 1978 (CDA), 41 U.S.C. 801-813 , or Part 32 . Therefore, the procedures required by the CDA and the FAR for the issuance of a final contracting officer decision are not applicable to final agency decisions under this subpart, and shall not be followed.");
register_book(&s, "|3|8|", "Limitations on the Payment of Funds to", "Subpart 3.8  Limitations on the Payment of Funds to Influence Federal Transactions\n3.800 Scope of subpart.\nThis subpart prescribes policies and procedures implementing 31 U.S.C. 1352 ,  Limitation on use of appropriated funds to influence certain Federal contracting and financial transactions.  \n3.801 Definitions.\nAs used in this subpart  \nAgency  means   executive agency  as defined in 2.101 .\nCovered Federal action  means any of the following actions:\n(1) Awarding any Federal contract.\n(2) Making any Federal grant.\n(3) Making any Federal loan.\n(4) Entering into any cooperative agreement.\n(5) Extending, continuing, renewing, amending, or modifying any Federal contract, grant, loan, or cooperative agreement.\nIndian tribe  and  tribal organization  have the meaning provided in section 4 of the Indian Self-Determination and Education Assistance Act ( 25 U.S.C. 450b ) and include Alaskan Natives.\nInfluencing or attempting to influence  means making, with the intent to influence, any communication to or appearance before an officer or employee of any agency, a Member of Congress, an officer or employee of Congress, or an employee of a Member of Congress in connection with any covered Federal action.\nLocal government  means a unit of government in a State and, if chartered, established, or otherwise recognized by a State for the performance of a governmental duty, including a local public authority, a special district, an intrastate district, a council of governments, a sponsor group representative organization, and any other instrumentality of a local government.\nOfficer or employee of an agency  includes the following individuals who are employed by an agency:\n(1) An individual who is appointed to a position in the Government under Title 5, United States Code, including a position under a temporary appointment.\n(2) A member of the uniformed services, as defined in subsection 101(3), Title 37, United States Code.\n(3) A special Government employee, as defined in section 202, Title 18, United States Code.\n(4) An individual who is a member of a Federal advisory committee, as defined by the Federal Advisory Committee Act, Title 5, United States Code, appendix 2.\nPerson  means an individual, corporation, company, association, authority, firm, partnership, society, State, and local government, regardless of whether such entity is operated for profit or not for profit. This term excludes an Indian tribe, tribal organization, or any other Indian organization eligible to receive Federal contracts, grants, cooperative agreements, or loans from an agency, but only with respect to expenditures by such tribe or organization that are made for purposes specified in paragraph 3.802 (a) and are permitted by other Federal law.\nReasonable compensation  means, with respect to a regularly employed officer or employee of any person, compensation that is consistent with the normal compensation for such officer or employee for work that is not furnished to, not funded by, or not furnished in cooperation with the Federal Government.\nReasonable payment  means, with respect to professional and other technical services, a payment in an amount that is consistent with the amount normally paid for such services in the private sector.\nRecipient  includes the contractor and all subcontractors. This term excludes an Indian tribe, tribal organization, or any other Indian organization eligible to receive Federal contracts, grants, cooperative agreements, or loans from an agency, but only with respect to expenditures by such tribe or organization that are made for purposes specified in paragraph 3.802 (a) and are permitted by other Federal law.\nRegularly employed  means, with respect to an officer or employee of a person requesting or receiving a Federal contract, an officer or employee who is employed by such person for at least 130 working days within 1 year immediately preceding the date of the submission that initiates agency consideration of such person for receipt of such contract. An officer or employee who is employed by such person for less than 130 working days within 1 year immediately preceding the date of the submission that initiates agency consideration of such person shall be considered to be regularly employed as soon as he or she is employed by such person for 130 working days.\nState  means a State of the United States, the District of Columbia, an outlying area of the United States, an agency or instrumentality of a State, and multi-State, regional, or interstate entity having governmental duties and powers.\n3.802 Statutory prohibition and requirement.\n(a) 31 U.S.C. 1352 prohibits a recipient of a Federal contract, grant, loan, or cooperative agreement from using appropriated funds to pay any person for influencing or attempting to influence an officer or employee of any agency, a Member of Congress, an officer or employee of Congress, or an employee of a Member of Congress in connection with any covered Federal actions.\n(1) For purposes of this subpart the term  appropriated funds  does not include profit or fee from a covered Federal action.\n(2) To the extent a person can demonstrate that the person has sufficient monies, other than Federal appropriated funds, the Government shall assume that these other monies were spent for any influencing activities that would be unallowable if paid for with Federal appropriated funds.\n(b) 31 U.S.C. 1352 also requires offerors to furnish a declaration consisting of both a certification and a disclosure, with periodic updates of the disclosure after contract award. These requirements are contained in the provision at 52.203-11 , Certification and Disclosure Regarding Payments to Influence Certain Federal Transactions, and the clause at 52.203-12 , Limitation on Payments to Influence Certain Federal Transactions.\n3.803 Exceptions.\n(a) The prohibition of paragraph 3.802 (a) does not apply under the following conditions:\n(1) Agency and legislative liaison by own employees .\n(i) Payment of reasonable compensation made to an officer or employee of a person requesting or receiving a covered Federal action if the payment is for agency and legislative liaison activities not directly related to a covered Federal action. For purposes of this paragraph, providing any information specifically requested by an agency or Congress is permitted at any time.\n(ii) Participating with an agency in discussions that are not related to a specific solicitation for any covered Federal action, but that concern  \n(A) The qualities and characteristics (including individual demonstrations) of the person  s products or services, conditions or terms of sale, and service capabilities; or\n(B) The application or adaptation of the person  s products or services for an agency  s use.\n(iii) Providing prior to formal solicitation of any covered Federal action any information not specifically requested but necessary for an agency to make an informed decision about initiation of a covered Federal action.\n(iv) Participating in technical discussions regarding the preparation of an unsolicited proposal prior to its official submission.\n(v) Making capability presentations prior to formal solicitation of any covered Federal action when seeking an award from an agency pursuant to the provisions of the Small Business Act, as amended by Pub. L. 95-507, and subsequent amendments.\n(2) Professional and technical services.\n(i) Payment of reasonable compensation made to an officer or employee of a person requesting or receiving a covered Federal action, if payment is for professional or technical services rendered directly in the preparation, submission, or negotiation of any bid, proposal, or application for that Federal action or for meeting requirements imposed by or pursuant to law as a condition for receiving that Federal action;\n(ii) Any reasonable payment to a person, other than an officer or employee of a person requesting or receiving a covered Federal action, if the payment is for professional or technical services rendered directly in the preparation, submission, or negotiation of any bid, proposal, or application for that Federal action, or for meeting requirements imposed by or pursuant to law as a condition for receiving that Federal action. Persons other than officers or employees of a person requesting or receiving a covered Federal action include consultants and trade associations.\n(iii) As used in paragraph (a)(2) of this section  professional and technical services  are limited to advice and analysis directly applying any professional or technical discipline. For example, drafting of a legal document accompanying a bid or proposal by a lawyer is allowable. Similarly, technical advice provided by an engineer on the performance or operational capability of a piece of equipment rendered directly in the negotiation of a contract is allowable. However, communications with the intent to influence made by a professional or a technical person are not allowable under this section unless they provide advice and analysis directly applying their professional or technical expertise and unless the advice or analysis is rendered directly and solely in the preparation, submission or negotiation of a covered Federal action. Thus, for example, communications with the intent to influence made by a lawyer that do not provide legal advice or analysis directly and solely related to the legal aspects of his or her client  s proposal, but generally advocate one proposal over another, are not allowable under this section because the lawyer is not providing professional legal services. Similarly, communications with the intent to influence made by an engineer providing an engineering analysis prior to the preparation or submission of a bid or proposal are not allowable under this section since the engineer is providing technical services but not directly in the preparation, submission or negotiation of a covered Federal action.\n(iv) Requirements imposed by or pursuant to law as a condition for receiving a covered Federal award include those required by law or regulation and any other requirements in the actual award documents.\n(b) Only those communications and services expressly authorized by paragraph (a) of this section are permitted.\n(c) The disclosure requirements of paragraph 3.802 (b) do not apply with respect to payments of reasonable compensation made to regularly employed officers or employees of a person.\n3.804 Policy.\nThe contracting officer shall obtain certifications and disclosures as required by the provision at 52.203-11 , Certification and Disclosure Regarding Payments to Influence Certain Federal Transactions, prior to the award of any contract exceeding $150,000.\n3.805 Exemption.\nThe Secretary of Defense may exempt, on a case-by-case basis, a covered Federal action from the prohibitions of this subpart whenever the Secretary determines, in writing, that such an exemption is in the national interest. The Secretary shall transmit a copy of the exemption to Congress immediately after making the determination.\n3.806 Processing suspected violations.\nThe contracting officer shall report suspected violations of the requirements of 31 U.S.C. 1352 in accordance with agency procedures.\n3.807 Civil penalties.\nAgencies shall impose and collect civil penalties pursuant to the provisions of the Program Fraud and Civil Remedies Act, 31 U.S.C. 3803 (except subsection (c)), 3804-3808, and 3812, insofar as the provisions therein are not inconsistent with the requirements of this subpart.\n3.808 Solicitation provision and contract clause.\n(a) Insert the provision at 52.203-11 , Certification and Disclosure Regarding Payments to Influence Certain Federal Transactions, in solicitations expected to exceed $150,000.\n(b) Insert the clause at 52.203-12 , Limitation on Payments to Influence Certain Federal Transactions, in solicitations and contracts expected to exceed $150,000.");
register_book(&s, "|3|9|", "Whistleblower Protections for Contracto", "Subpart 3.9  Whistleblower Protections for Contractor Employees\n3.900 Scope of subpart.\nThis subpart implements three different statutory whistleblower programs. This subpart does not implement 10 U.S.C. 2409 , which is applicable only to DoD, NASA, and the Coast Guard.\n(a) 41 U.S.C. 4705 (in effect before July 1, 2013 and on or after January 2, 2017). Sections 3.901 through 3.906 of this subpart implement 41 U.S.C. 4705 , applicable to civilian agencies other than NASA and the Coast Guard, except as provided in paragraph (c) of this section. These sections are not in effect for the duration of the pilot program described in paragraph (b) of this section.\n(b) 41 U.S.C. 4712 (in effect on July 1, 2013 through January 1, 2017). Section 3.908 of this subpart implements the pilot program, applicable to civilian agencies other than NASA and the Coast Guard, except as provided in paragraph (c) of this section.\n(c) Contracts funded by the American Recovery and Reinvestment Act. Section 3.907 of this subpart implements section 1553 of the American Recovery and Reinvestment Act of 2009 (Pub. L. 111-5), and applies to all contracts funded in whole or in part by that Act.\n3.901 Definitions.\nAs used in this subpart  \nAuthorized official of an agency  means an officer or employee responsible for contracting, program management, audit, inspection, investigation, or enforcement of any law or regulation relating to Government procurement or the subject matter of the contract.\nAuthorized official of the Department of Justice  means any person responsible for the investigation, enforcement, or prosecution of any law or regulation.\nInspector General  means an Inspector General appointed under the Inspector General Act of 1978, as amended. In the Department of Defense that is the DoD Inspector General. In the case of an executive agency that does not have an Inspector General, the duties shall be performed by an official designated by the head of the executive agency.\n3.902 [Reserved]\n3.903 Policy.\nGovernment contractors shall not discharge, demote or otherwise discriminate against an employee as a reprisal for disclosing information to a Member of Congress, or an authorized official of an agency or of the Department of Justice, relating to a substantial violation of law related to a contract (including the competition for or negotiation of a contract).\n3.904 Procedures for filing complaints.\n(a) Any employee of a contractor who believes that he or she has been discharged, demoted, or otherwise discriminated against contrary to the policy in 3.903 may file a complaint with the Inspector General of the agency that awarded the contract.\n(b) The complaint shall be signed and shall contain  \n(1) The name of the contractor;\n(2) The contract number, if known; if not, a description reasonably sufficient to identify the contract(s) involved;\n(3) The substantial violation of law giving rise to the disclosure;\n(4) The nature of the disclosure giving rise to the discriminatory act; and\n(5) The specific nature and date of the reprisal.\n3.905 Procedures for investigating complaints.\n(a) Upon receipt of a complaint, the Inspector General shall conduct an initial inquiry. If the Inspector General determines that the complaint is frivolous or for other reasons does not merit further investigation, the Inspector General shall advise the complainant that no further action on the complaint will be taken.\n(b) If the Inspector General determines that the complaint merits further investigation, the Inspector General shall notify the complainant, contractor, and head of the contracting activity. The Inspector General shall conduct an investigation and provide a written report of findings to the head of the agency or designee.\n(c) Upon completion of the investigation, the head of the agency or designee shall ensure that the Inspector General provides the report of findings to  \n(1) The complainant and any person acting on the complainant  s behalf;\n(2) The contractor alleged to have committed the violation; and\n(3) The head of the contracting activity.\n(d) The complainant and contractor shall be afforded the opportunity to submit a written response to the report of findings within 30 days to the head of the agency or designee. Extensions of time to file a written response may be granted by the head of the agency or designee.\n(e) At any time, the head of the agency or designee may request additional investigative work be done on the complaint.\n3.906 Remedies.\n(a) If the head of the agency or designee determines that a contractor has subjected one of its employees to a reprisal for providing information to a Member of Congress, or an authorized official of an agency or of the Department of Justice, the head of the agency or designee may take one or more of the following actions:\n(1) Order the contractor to take affirmative action to abate the reprisal.\n(2) Order the contractor to reinstate the person to the position that the person held before the reprisal, together with the compensation (including back pay), employment benefits, and other terms and conditions of employment that would apply to the person in that position if the reprisal had not been taken.\n(3) Order the contractor to pay the complainant an amount equal to the aggregate amount of all costs and expenses (including attorneys  fees and expert witnesses  fees) that were reasonably incurred by the complainant for, or in connection with, bringing the complaint regarding the reprisal.\n(b) Whenever a contractor fails to comply with an order, the head of the agency or designee shall request the Department of Justice to file an action for enforcement of such order in the United States district court for a district in which the reprisal was found to have occurred. In any action brought under this section, the court may grant appropriate relief, including injunctive relief and compensatory and exemplary damages.\n(c) Any person adversely affected or aggrieved by an order issued under this section may obtain review of the order  s conformance with the law, and this subpart, in the United States Court of Appeals for a circuit in which the reprisal is alleged in the order to have occurred. No petition seeking such review may be filed more than 60 days after issuance of the order by the head of the agency or designee. Review shall conform to Chapter 7 of Title 5, United States Code. \n3.907 Whistleblower Protections Under the American Recovery and Reinvestment Act of 2009 (the Recovery Act).\n3.907-1 Definitions.\nAs used in this section  \nBoard  means the Recovery Accountability and Transparency Board established by Section 1521 of the Recovery Act. \nCovered funds  means any contract payment, grant payment, or other payment received by a contractor if  \n(1) The Federal Government provides any portion of the money or property that is provided, requested, or demanded; and\n(2) At least some of the funds are appropriated or otherwise made available by the Recovery Act.\nCovered information  means information that the employee reasonably believes is evidence of gross mismanagement of the contract or subcontract related to covered funds, gross waste of covered funds, a substantial and specific danger to public health or safety related to the implementation or use of covered funds, an abuse of authority related to the implementation or use of covered funds, or a violation of law, rule, or regulation related to an agency contract (including the competition for or negotiation of a contract) awarded or issued relating to covered funds.\nInspector General  means an Inspector General appointed under the Inspector General Act of 1978. In the Department of Defense that is the DoD Inspector General. In the case of an executive agency that does not have an Inspector General, the duties shall be performed by an official designated by the head of the executive agency.\nNon-Federal employer,  as used in this section, means any employer that receives Recovery Act funds, including a contractor, subcontractor, or other recipient of funds pursuant to a contract or other agreement awarded and administered in accordance with the Federal Acquisition Regulation.\n3.907-2 Policy.\nNon-Federal employers are prohibited from discharging, demoting, or otherwise discriminating against an employee as a reprisal for disclosing covered information to any of the following entities or their representatives:\n(1) The Board.\n(2) An Inspector General.\n(3) The Comptroller General.\n(4) A member of Congress.\n(5) A State or Federal regulatory or law enforcement agency.\n(6) A person with supervisory authority over the employee or such other person working for the employer who has the authority to investigate, discover, or terminate misconduct.\n(7) A court or grand jury.\n(8) The head of a Federal agency.\n3.907-3 Procedures for filing complaints.\n(a) An employee who believes that he or she has been subjected to reprisal prohibited by the Recovery Act, Section 1553 as set forth in 3.907-2 , may submit a complaint regarding the reprisal to the Inspector General of the agency that awarded the contract.\n(b) The complaint shall be signed and shall contain  \n(1) The name of the contractor;\n(2) The contract number, if known; if not, a description reasonably sufficient to identify the contract(s) involved;\n(3) The covered information giving rise to the disclosure;\n(4) The nature of the disclosure giving rise to the discriminatory act; and\n(5) The specific nature and date of the reprisal.\n(c) A contracting officer who receives a complaint of reprisal of the type described in 3.907-2 shall forward it to the Office of Inspector General and to other designated officials in accordance with agency procedures ( e.g. , agency legal counsel).\n3.907-4 Procedures for investigating complaints.\nInvestigation of complaints will be in accordance with section 1553 of the Recovery Act.\n3.907-5 Access to investigative file of Inspector General. \n(a) The employee alleging reprisal under this section shall have access to the investigation file of the Inspector General, in accordance with the Privacy Act, 5 U.S.C.  552a . The investigation of the Inspector General shall be deemed closed for the purposes of disclosure under such section when an employee files an appeal to the agency head or a court of competent jurisdiction.\n(b) In the event the employee alleging reprisal brings a civil action under section 1553(c)(3) of the Recovery Act, the employee alleging the reprisal and the non-Federal employer shall have access to the investigative file of the Inspector General in accordance with the Privacy Act.\n(c) The Inspector General may exclude from disclosures made under 3.907-5 (a) or (b)  \n(1) Information protected from disclosure by a provision of law; and\n(2) Any additional information the Inspector General determines disclosure of which would impede a continuing investigation, provided that such information is disclosed once such disclosure would no longer impede such investigation, unless the Inspector General determines that the disclosure of law enforcement techniques, procedures, or information could reasonably be expected to risk circumvention of the law or disclose the identity of a confidential source.\n(d) An Inspector General investigating an alleged reprisal under this section may not respond to any inquiry or disclose any information from or about any person alleging such reprisal, except in accordance with 5 U.S.C. 552a or as required by any other applicable Federal law.\n3.907-6 Remedies and enforcement authority.\n(a) Burden of Proof . \n(1) Disclosure as contributing factor in reprisal.\n(i) An employee alleging a reprisal under this section shall be deemed to have affirmatively established the occurrence of the reprisal if the employee demonstrates that a disclosure described in section 3.907-2 was a contributing factor in the reprisal.\n(ii) A disclosure may be demonstrated as a contributing factor in a reprisal for purposes of this paragraph by circumstantial evidence, including  \n(A) Evidence that the official undertaking the reprisal knew of the disclosure; or\n(B) Evidence that the reprisal occurred within a period of time after the disclosure such that a reasonable person could conclude that the disclosure was a contributing factor in the reprisal.\n(2) Opportunity for rebuttal . The head of an agency may not find the occurrence of a reprisal with respect to a reprisal that is affirmatively established under section 3.907-6 (a)(1) if the non-Federal employer demonstrates by clear and convincing evidence that the non-Federal employer would have taken the action constituting the reprisal in the absence of the disclosure.\n(b) No later than 30 days after receiving an Inspector General report in accordance with section 1553 of the Recovery Act, the head of the agency concerned shall determine whether there is sufficient basis to conclude that the non-Federal employer has subjected the complainant to a reprisal prohibited by subsection 3.907-2 and shall either issue an order denying relief in whole or in part or shall take one or more of the following actions:\n(1) Order the employer to take affirmative action to abate the reprisal.\n(2) Order the employer to reinstate the person to the position that the person held before the reprisal, together with the compensation (including back pay), compensatory damages, employment benefits, and other terms and conditions of employment that would apply to the person in that position if the reprisal had not been taken.\n(3) Order the employer to pay the complainant an amount equal to the aggregate amount of all costs and expenses (including attorneys  fees and expert witnesses  fees) that were reasonably incurred by the complainant for, or in connection with, bringing the complaint regarding the reprisal.\n(c)(1) The complainant shall be deemed to have exhausted all administrative remedies with respect to the complaint, and the complainant may bring a de novo action at law or equity against the employer to seek compensatory damages and other relief available under this section in the appropriate district court of United States, which shall have jurisdiction over such an action without regard to the amount in controversy if  \n(i) The head of an agency  \n(A) Issues an order denying relief in whole or in part under paragraph (a) of this section;\n(B) Has not issued an order within 210 days after the submission of a complaint in accordance with section 1553 of the Recovery Act, or in the case of an extension of time in accordance with section 1553 of the Recovery Act, within 30 days after the expiration of the extension of time; or\n(C) Decides in accordance with section 1553 of the Recovery Act not to investigate or to discontinue an investigation; and\n(ii) There is no showing that such delay or decision is due to the bad faith of the complainant.\n(2) Such an action shall, at the request of either party to the action, be tried by the court with a jury.\n(d) Whenever an employer fails to comply with an order issued under this section, the head of the agency shall request the Department of Justice to file an action for enforcement of such order in the United States district court for a district in which the reprisal was found to have occurred. In any action brought under this section, the court may grant appropriate relief, including injunctive relief, compensatory and exemplary damages, and attorneys fees and costs.\n(e) Any person adversely affected or aggrieved by an order issued under paragraph (b) of this subsection may obtain review of the order  s conformance with the law, and this section, in the United States Court of Appeals for a circuit in which the reprisal is alleged in the order to have occurred. No petition seeking such review may be filed more than 60 days after issuance of the order by the head of the agency.\n3.907-7 Contract clause.\nUse the clause at 52.203-15 , Whistleblower Protections Under the American Recovery and Reinvestment Act of 2009 in all solicitations and contracts funded in whole or in part with Recovery Act funds.\n3.908 Pilot program for enhancement of contractor employee whistleblower protections.\n3.908-1 Scope of section.\n(a) This section implements 41 U.S.C. 4712 .\n(b) This section does not apply to  \n(1) DoD, NASA, and the Coast Guard; or\n(2) Any element of the intelligence community, as defined in section 3(4) of the National Security Act of 1947 (50 U.S.C. 3003(4)). This section does not apply to any disclosure made by an employee of a contractor or subcontractor of an element of the intelligence community if such disclosure-\n(i) Relates to an activity of an element of the intelligence community; or\n(ii) Was discovered during contract or subcontract services provided to an element of the intelligence community.\n3.908-2 Definitions.\nAs used in this section  \nAbuse of authority  means an arbitrary and capricious exercise of authority that is inconsistent with the mission of the executive agency concerned or the successful performance of a contract of such agency.\nInspector General  means an Inspector General appointed under the Inspector General Act of 1978 and any Inspector General that receives funding from, or has oversight over contracts awarded for, or on behalf of, the executive agency concerned. \n3.908-3 Policy.\n(a) Contractors and subcontractors are prohibited from discharging, demoting, or otherwise discriminating against an employee as a reprisal for disclosing, to any of the entities listed at paragraph (b) of this subsection, information that the employee reasonably believes is evidence of gross mismanagement of a Federal contract, a gross waste of Federal funds, an abuse of authority relating to a Federal contract, a substantial and specific danger to public health or safety, or a violation of law, rule, or regulation related to a Federal contract (including the competition for or negotiation of a contract). A reprisal is prohibited even if it is undertaken at the request of an executive branch official, unless the request takes the form of a non-discretionary directive and is within the authority of the executive branch official making the request.\n(b) Entities to whom disclosure may be made.\n(1) A Member of Congress or a representative of a committee of Congress.\n(2) An Inspector General.\n(3) The Government Accountability Office.\n(4) A Federal employee responsible for contract oversight or management at the relevant agency. \n(5) An authorized official of the Department of Justice or other law enforcement agency.\n(6) A court or grand jury.\n(7) A management official or other employee of the contractor or subcontractor who has the responsibility to investigate, discover, or address misconduct.\n(c) An employee who initiates or provides evidence of contractor or subcontractor misconduct in any judicial or administrative proceeding relating to waste, fraud, or abuse on a Federal contract shall be deemed to have made a disclosure.\n3.908-4 Filing complaints.\nA contractor or subcontractor employee who believes that he or she has been discharged, demoted, or otherwise discriminated against contrary to the policy in 3.908-3 of this section may submit a complaint with the Inspector General of the agency concerned. Procedures for submitting fraud, waste, abuse, and whistleblower complaints are generally accessible on agency Office of Inspector General Hotline or Whistleblower Internet sites. A complaint by the employee may not be brought under 41 U.S.C. 4712 more than three years after the date on which the alleged reprisal took place.\n3.908-5 Procedures for investigating complaints.\nInvestigation of complaints by the Inspector General will be in accordance with 41 U.S.C. 4712 (b).\n3.908-6 Statutory remedies.\n(a) Agency response to Inspector General report. Not later than 30 days after receiving an Inspector General report in accordance with 41 U.S.C. 4712 , the head of the agency shall  \n(1) Determine whether sufficient basis exists to conclude that the contractor or subcontractor has subjected the employee who submitted the complaint to a reprisal as prohibited by 3.908-3; and\n(2) Issue an order denying relief or take one or more of the following actions:\n(i) Order the contractor to take affirmative action to abate the reprisal.\n(ii) Order the contractor or subcontractor to reinstate the complainant-employee to the position that the person held before the reprisal, together with compensatory damages (including back pay), employment benefits, and other terms and conditions of employment that would apply to the person in that position if the reprisal had not been taken.\n(iii) Order the contractor or subcontractor to pay the complainant-employee an amount equal to the aggregate amount of all costs and expenses (including attorneys' fees and expert witnesses  fees) that were reasonably incurred by the complainant for, or in connection with, bringing the complaint regarding the reprisal, as determined by the head of the agency.\n(b) Complainant  s right to go to court. If the head of the agency issues an order denying relief or has not issued an order within 210 days after the submission of the complaint or within 30 days after the expiration of an extension of time granted in accordance with 41 U.S.C. 4712 (b)(2)(B) for the submission of the Inspector General  s report on the investigative findings of the complaint to the head of the agency, the contractor or subcontractor, and the complainant, and there is no showing that such delay is due to the bad faith of the complainant  \n(1) The complainant shall be deemed to have exhausted all administrative remedies with respect to the complaint; and\n(2) The complainant may bring a de novo action at law or equity against the contractor or subcontractor to seek compensatory damages and other relief available under 41 U.S.C. 4712 in the appropriate district court of the United States, which shall have jurisdiction over such an action without regard to the amount in controversy. Such an action shall, at the request of either party to the action, be tried by the court with a jury. An action under this authority may not be brought more than two years after the date on which remedies are deemed to have been exhausted.\n(c) Admissibility in evidence . An Inspector General determination and an agency head order denying relief under this section shall be admissible in evidence in any de novo action at law or equity brought pursuant to 41 U.S.C. 4712 . \n(d) No waiver . The rights and remedies provided for in 41 U.S.C. 4712 may not be waived by any agreement, policy, form, or condition of employment.\n3.908-7 Enforcement of orders.\n(a) Whenever a contractor or subcontractor fails to comply with an order issued under 3.908-6(a)(2) of this section, the head of the agency concerned shall file an action for enforcement of the order in the U.S. district court for a district in which the reprisal was found to have occurred. In any action brought pursuant to this authority, the court may grant appropriate relief, including injunctive relief, compensatory and exemplary damages, and attorney fees and costs. The complainant-employee upon whose behalf an order was issued may also file such an action or join in an action filed by the head of the agency.\n(b) Any person adversely affected or aggrieved by an order issued under 3.908-6(a)(2) may obtain review of the order  s conformance with 41 U.S.C. 4712 and its implementing regulations, in the U.S. court of appeals for a circuit in which the reprisal is alleged in the order to have occurred. No petition seeking such review may be filed more than 60 days after issuance of the order by the head of the agency. Filing such an appeal shall not act to stay the enforcement of the order of the head of an agency, unless a stay is specifically entered by the court.\n3.908-8 Classified information.\n41 U.S.C. 4712 does not provide any right to disclose classified information not otherwise provided by law.\n3.908-9 Contract clause.\nThe contracting officer shall insert the clause at 52.203-17 , Contractor Employee Whistleblower Rights and Requirement to Inform Employees of Whistleblower Rights, in all solicitations and contracts that exceed the simplified acquisition threshold.");
register_book(&s, "|3|10|", "Contractor Code of Business Ethics and", "Subpart 3.10  Contractor Code of Business Ethics and Conduct\n3.1000 Scope of subpart.\nThis subpart prescribes policies and procedures for the establishment of contractor codes of business ethics and conduct, and display of agency Office of Inspector General (OIG) fraud hotline posters. \n3.1001 Definitions.\nAs used in this subpart  \nSubcontract  means any contract entered into by a subcontractor to furnish supplies or services for performance of a prime contract or a subcontract.\nSubcontractor  means any supplier, distributor, vendor, or firm that furnished supplies or services to or for a prime contractor or another subcontractor. \nUnited States  means the 50 States, the District of Columbia, and outlying areas. \n3.1002 Policy.\n(a) Government contractors must conduct themselves with the highest degree of integrity and honesty.\n(b) Contractors should have a written code of business ethics and conduct. To promote compliance with such code of business ethics and conduct, contractors should have an employee business ethics and compliance training program and an internal control system that  \n(1) Are suitable to the size of the company and extent of its involvement in Government contracting;\n(2) Facilitate timely discovery and disclosure of improper conduct in connection with Government contracts; and \n(3) Ensure corrective measures are promptly instituted and carried out. \n3.1003 Requirements.\n(a) Contractor requirements. \n(1) Although the policy at 3.1002 applies as guidance to all Government contractors, the contractual requirements set forth in the clauses at 52.203-13 , Contractor Code of Business Ethics and Conduct, and 52.203-14 , Display of Hotline Poster(s), are mandatory if the contracts meet the conditions specified in the clause prescriptions at 3.1004 .\n(2) Whether or not the clause at 52.203-13 is applicable, a contractor may be suspended and/or debarred for knowing failure by a principal to timely disclose to the Government, in connection with the award, performance, or closeout of a Government contract performed by the contractor or a subcontract awarded thereunder, credible evidence of a violation of Federal criminal law involving fraud, conflict of interest, bribery, or gratuity violations found in Title 18 of the United States Code or a violation of the civil False Claims Act. Knowing failure to timely disclose credible evidence of any of the above violations remains a cause for suspension and/or debarment until 3 years after final payment on a contract (see 9.406-2 (b)(1)(vi) and 9.407-2 (a)(8)).\n(3) The Payment clauses at FAR 52.212-4 (i)(5), 52.232-25 (d), 52.232-26 (c), and 52.232-27 (l) require that, if the contractor becomes aware that the Government has overpaid on a contract financing or invoice payment, the contractor shall remit the overpayment amount to the Government. A contractor may be suspended and/or debarred for knowing failure by a principal to timely disclose credible evidence of a significant overpayment, other than overpayments resulting from contract financing payments as defined in 32.001 (see 9.406-2 (b)(1)(vi) and 9.407-2 (a)(8)).\n(b) Notification of possible contractor violation . If the contracting officer is notified of possible contractor violation of Federal criminal law involving fraud, conflict of interest, bribery, or gratuity violations found in Title 18 U.S.C.; or a violation of the civil False Claims Act, the contracting officer shall  \n(1) Coordinate the matter with the agency Office of the Inspector General; or \n(2) Take action in accordance with agency procedures. \n(c) Fraud Hotline Poster. \n(1) Agency OIGs are responsible for determining the need for, and content of, their respective agency OIG fraud hotline poster(s).\n(2) When requested by the Department of Homeland Security, agencies shall ensure that contracts funded with disaster assistance funds require display of any fraud hotline poster applicable to the specific contract. As established by the agency OIG, such posters may be displayed in lieu of, or in addition to, the agency  s standard poster.\n3.1004 Contract clauses.\n(a) Insert the clause at FAR 52.203-13 , Contractor Code of Business Ethics and Conduct, in solicitations and contracts if the value of the contract is expected to exceed $5,000,000 and the performance period is 120 days or more.\n(b)(1) Unless the contract is for the acquisition of a commercial item or will be performed entirely outside the United States, insert the clause at FAR 52.203-14 , Display of Hotline Poster(s), if  \n(i) The contract exceeds $5,000,000 or a lesser amount established by the agency; and\n(ii)(A) The agency has a fraud hotline poster; or\n(B) The contract is funded with disaster assistance funds.\n(2) In paragraph (b)(3) of the clause, the contracting officer shall  \n(i) Identify the applicable posters; and\n(ii) Insert the website link(s) or other contact information for obtaining the agency and/or Department of Homeland Security poster.\n(3) In paragraph (d) of the clause, if the agency has established policies and procedures for display of the OIG fraud hotline poster at a lesser amount, the contracting officer shall replace  $5,000,000  with the lesser amount that the agency has established.");
register_book(&s, "|3|11|", "Preventing Personal Conflicts of Intere", "Subpart 3.11  Preventing Personal Conflicts of Interest for Contractor Employees Performing Acquisition Functions\n3.1100 Scope of subpart.\nThis subpart implements the policy on personal conflicts of interest by employees of Government contractors as required by section 841(a) of the Duncan Hunter National Defense Authorization Act for Fiscal Year 2009 (Pub. L. 110-417) ( 41 U.S.C. 2303 ).\n3.1101 Definitions.\nAs used in this subpart  \nAcquisition function closely associated with inherently governmental functions  means supporting or providing advice or recommendations with regard to the following activities of a Federal agency:\n(1) Planning acquisitions.\n(2) Determining what supplies or services are to be acquired by the Government, including developing statements of work.\n(3) Developing or approving any contractual documents, to include documents defining requirements, incentive plans, and evaluation criteria.\n(4) Evaluating contract proposals.\n(5) Awarding Government contracts.\n(6) Administering contracts (including ordering changes or giving technical direction in contract performance or contract quantities, evaluating contractor performance, and accepting or rejecting contractor products or services).\n(7) Terminating contracts.\n(8) Determining whether contract costs are reasonable, allocable, and allowable.\nCovered employee  means an individual who performs an acquisition function closely associated with inherently governmental functions and is  \n(1) An employee of the contractor; or\n(2) A subcontractor that is a self-employed individual treated as a covered employee of the contractor because there is no employer to whom such an individual could submit the required disclosures.\nPersonal conflict of interest  means a situation in which a covered employee has a financial interest, personal activity, or relationship that could impair the employee  s ability to act impartially and in the best interest of the Government when performing under the contract. (A de minimis interest that would not  impair the employee  s ability to act impartially and in the best interest of the Government  is not covered under this definition.)\n(1) Among the sources of personal conflicts of interest are  \n(i) Financial interests of the covered employee, of close family members, or of other members of the covered employee  s household;\n(ii) Other employment or financial relationships (including seeking or negotiating for prospective employment or business); and\n(iii) Gifts, including travel.\n(2) For example, financial interests referred to in paragraph (1) of this definition may arise from  \n(i) Compensation, including wages, salaries, commissions, professional fees, or fees for business referrals;\n(ii) Consulting relationships (including commercial and professional consulting and service arrangements, scientific and technical advisory board memberships, or serving as an expert witness in litigation);\n(iii) Services provided in exchange for honorariums or travel expense reimbursements;\n(iv) Research funding or other forms of research support;\n(v) Investment in the form of stock or bond ownership or partnership interest (excluding diversified mutual fund investments);\n(vi) Real estate investments;\n(vii) Patents, copyrights, and other intellectual property interests; or\n(viii) Business ownership and investment interests.\n3.1102 Policy.\nThe Government  s policy is to require contractors to  \n(a) Identify and prevent personal conflicts of interest of their covered employees; and\n(b) Prohibit covered employees who have access to non-public information by reason of performance on a Government contract from using such information for personal gain.\n3.1103 Procedures.\n(a) By use of the contract clause at 52.203-16 , as prescribed at 3.1106 , the contracting officer shall require each contractor whose employees perform acquisition functions closely associated with inherently Government functions to  \n(1) Have procedures in place to screen covered employees for potential personal conflicts of interest by  \n(i) Obtaining and maintaining from each covered employee, when the employee is initially assigned to the task under the contract, a disclosure of interests that might be affected by the task to which the employee has been assigned, as follows:\n(A) Financial interests of the covered employee, of close family members, or of other members of the covered employee  s household.\n(B) Other employment or financial relationships of the covered employee (including seeking or negotiating for prospective employment or business).\n(C) Gifts, including travel; and\n(ii) Requiring each covered employee to update the disclosure statement whenever the employee  s personal or financial circumstances change in such a way that a new personal conflict of interest might occur because of the task the covered employee is performing.\n(2) For each covered employee  \n(i) Prevent personal conflicts of interest, including not assigning or allowing a covered employee to perform any task under the contract for which the Contractor has identified a personal conflict of interest for the employee that the Contractor or employee cannot satisfactorily prevent or mitigate in consultation with the contracting agency;\n(ii) Prohibit use of non-public information accessed through performance of a Government contract for personal gain; and\n(iii) Obtain a signed non-disclosure agreement to prohibit disclosure of non-public information accessed through performance of a Government contract.\n(3) Inform covered employees of their obligation  \n(i) To disclose and prevent personal conflicts of interest;\n(ii) Not to use non-public information accessed through performance of a Government contract for personal gain; and\n(iii) To avoid even the appearance of personal conflicts of interest;\n(4) Maintain effective oversight to verify compliance with personal conflict-of-interest safeguards;\n(5) Take appropriate disciplinary action in the case of covered employees who fail to comply with policies established pursuant to this section; and\n(6) Report to the contracting officer any personal conflict-of-interest violation by a covered employee as soon as identified. This report shall include a description of the violation and the proposed actions to be taken by the contractor in response to the violation, with follow-up reports of corrective actions taken, as necessary.\n(b) If a contractor reports a personal conflict-of-interest violation by a covered employee to the contracting officer in accordance with paragraph (b)(6) of the clause at 52.203-16 , Preventing Personal Conflicts of Interest, the contracting officer shall  \n(1) Review the actions taken by the contractor;\n(2) Determine whether any action taken by the contractor has resolved the violation satisfactorily; and\n(3) If the contracting officer determines that the contractor has not resolved the violation satisfactorily, take any appropriate action in consultation with agency legal counsel.\n3.1104 Mitigation or waiver.\n(a) In exceptional circumstances, if the contractor cannot satisfactorily prevent a personal conflict of interest as required by paragraph (b)(2)(i) of the clause at 52.203-16 , Preventing Personal Conflicts of Interest, the contractor may submit a request, through the contracting officer, for the head of the contracting activity to  \n(1) Agree to a plan to mitigate the personal conflict of interest; or\n(2) Waive the requirement to prevent personal conflicts of interest. \n(b) If the head of the contracting activity determines in writing that such action is in the best interest of the Government, the head of the contracting activity may impose conditions that provide mitigation of a personal conflict of interest or grant a waiver.\n(c) This authority shall not be redelegated.\n3.1105 Violations.\nIf the contracting officer suspects violation by the contractor of a requirement of paragraph (b), (c)(3), or (d) of the clause at 52.203-16 , Preventing Personal Conflicts of Interest, the contracting officer shall contact the agency legal counsel for advice and/or recommendations on a course of action.\n3.1106 Contract clause.\n(a) Insert the clause at 52.203-16 , Preventing Personal Conflicts of Interest, in solicitations and contracts that  \n(1) Exceed the simplified acquisition threshold; and\n(2) Include a requirement for services by contractor employee(s) that involve performance of acquisition functions closely associated with inherently governmental functions for, or on behalf of, a Federal agency or department.\n(b) If only a portion of a contract is for the performance of acquisition functions closely associated with inherently governmental functions, then the contracting officer shall still insert the clause, but shall limit applicability of the clause to that portion of the contract that is for the performance of such services.\n(c) Do not insert the clause in solicitations or contracts with a self-employed individual if the acquisition functions closely associated with inherently governmental functions are to be performed entirely by the self-employed individual, rather than an employee of the contractor.\n*    *    *    *    *    *");
register_book(&s, "|4|2|", "Contract Distribution", "Subpart 4.2  Contract Distribution\n4.201 Procedures.\nContracting officers shall distribute copies of contracts or modifications within 10 working days after execution by all parties. As a minimum, the contracting officer shall  \n(a) Distribute simultaneously one signed copy or reproduction of the signed contract to the contractor and the paying office;\n(b) When a contract is assigned to another office for contract administration (see Subpart 42.2 ), provide to that office  \n(1) One copy or reproduction of the signed contract and of each modification; and\n(2) A copy of the contract distribution list, showing those offices that should receive copies of modifications, and any changes to the list as they occur;\n(c) Distribute one copy to each accounting and finance office (funding office) whose funds are cited in the contract;\n(d) When the contract is not assigned for administration but contains a Cost Accounting Standards clause, provide one copy of the contract to the cognizant administrative contracting officer and mark the copy  For Cost Accounting Standards Administration Only  (see 30.601 (b));\n(e) Provide one copy of each contract or modification that requires audit service to the appropriate field audit office listed in the  Directory of Federal Contract Audit Offices  (copies of this directory can be ordered from the  \nU.S. Government Printing Office Superintendent of Document Washington, DC 20402\nreferencing stock numbers 008-007-03189-9 and 008-007-03190-2 for Volumes I and II, respectively); and\n(f) Provide copies of contracts and modifications to those organizations required to perform contract administration support functions ( e.g., when manufacturing is performed at multiple sites, the contract administration office cognizant of each location).\n4.202 Agency distribution requirements.\nAgencies shall limit additional distribution requirements to the minimum necessary for proper performance of essential functions. When contracts are assigned for administration to a contract administration office located in an agency different from that of the contracting office (see Part 42 ), the two agencies shall agree on any necessary distribution in addition to that prescribed in 4.201 .\n4.203 Taxpayer identification information.\n(a) If the contractor has furnished a Taxpayer Identification Number (TIN) when completing the solicitation provision at 52.204-3 , Taxpayer Identification, or paragraph (l) of the solicitation provision at 52.212-3 , Offeror Representations and Certifications  Commercial Items, the contracting officer shall, unless otherwise provided in agency procedures, attach a copy of the completed solicitation provision as the last page of the copy of the contract sent to the payment office.\n(b) If the TIN or type of organization is derived from a source other than the provision at 52.204-3 or 52.212-3 (l), the contracting officer shall annotate the last page of the contract or order forwarded to the payment office to state the contractor  s TIN and type of organization, unless this information is otherwise provided to the payment office in accordance with agency procedures.\n(c) If the contractor provides its TIN or type of organization to the contracting officer after award, the contracting officer shall forward the information to the payment office within 7 days of its receipt.\n(d) Federal Supply Schedule contracts. Each contracting officer that places an order under a Federal Supply Schedule contract (see Subpart 8.4 ) shall provide the TIN and type of organization information to the payment office in accordance with paragraph (b) of this section.\n(e) Basic ordering agreements and indefinite-delivery contracts (other than Federal Supply Schedule contracts).\n(1) Each contracting officer that issues a basic ordering agreement or indefinite-delivery contract (other than a Federal Supply Schedule contract) shall provide to contracting officers placing orders under the agreement or contract (if the contractor is not required to provide this information to the System for Award Management)  \n(i) A copy of the agreement or contract with a copy of the completed solicitation provision at 52.204-3 or 52.212-3 (l) as the last page of the agreement or contract; or\n(ii) The contractor  s TIN and type of organization information.\n(2) Each contracting officer that places an order under a basic ordering agreement or indefinite-delivery contract (other than a Federal Supply Schedule contract) shall provide the TIN and type of organization information to the payment office in accordance with paragraph (a) or (b) of this section.");
register_book(&s, "|4|3|", "Paper Documents", "Subpart 4.3  Paper Documents\n4.300 Scope of subpart.\nThis subpart provides policies and procedures on contractor-submitted paper documents.\n4.301 Definition.\nPrinted or copied double-sided,  as used in this subpart, means printing or reproducing a document so that information is on both sides of a sheet of paper.\n4.302 Policy. \n(a) Section 3(a) of E.O. 13423, Strengthening Federal Environmental, Energy, and Transportation Management, directs agencies to implement waste prevention. In addition, section 2(e) of E.O. 13514, Federal Leadership in Environmental, Energy, and Economic Performance, directs agencies to eliminate waste. Electronic commerce methods (see 4.502 ) and double-sided printing and copying are best practices for waste prevention.\n(b) When electronic commerce methods (see 4.502 ) are not used, agencies shall require contractors to submit paper documents to the Government relating to an acquisition printed or copied double-sided on at least 30 percent postconsumer fiber paper whenever practicable. If the contractor cannot print or copy double-sided, it shall print or copy single-sided on at least 30 percent postconsumer fiber paper.\n4.303 Contract clause.\nInsert the clause at 52.204-4 , Printed or Copied Double-Sided on Recycled Paper, in solicitations and contracts that exceed the simplified acquisition threshold.");
register_book(&s, "|4|4|", "Safeguarding Classified Information Wit", "Subpart 4.4  Safeguarding Classified Information Within Industry\n4.401 [Reserved]\n4.402 General.\n(a) Executive Order 12829, January 6, 1993 (58 FR 3479, January 8, 1993), entitled  National Industrial Security Program  (NISP), establishes a program to safeguard Federal Government classified information that is released to contractors, licensees, and grantees of the United States Government. Executive Order 12829 amends Executive Order 10865, February 20, 1960 (25 FR 1583, February 25, 1960), entitled  Safeguarding Classified Information Within Industry,  as amended by Executive Order 10909, January 17, 1961 (26 FR 508, January 20, 1961).\n(b) The National Industrial Security Program Operating Manual (NISPOM) incorporates the requirements of these Executive orders. The Secretary of Defense, in consultation with all affected agencies and with the concurrence of the Secretary of Energy, the Chairman of the Nuclear Regulatory Commission, and the Director of Central Intelligence, is responsible for issuance and maintenance of this Manual. The following DoD publications implement the program:\n(1) National Industrial Security Program Operating Manual (NISPOM) (DoD 5220.22-M).\n(2) Industrial Security Regulation (DoD 5220.22-R).\n(c) Procedures for the protection of information relating to foreign classified contracts awarded to U.S. industry, and instructions for the protection of U.S. information relating to classified contracts awarded to foreign firms, are prescribed in Chapter 10 of the NISPOM.\n(d) Part 27  Patents, Data, and Copyrights, contains policy and procedures for safeguarding classified information in patent applications and patents.\n4.403 Responsibilities of contracting officers.\n(a) Presolicitation phase . Contracting officers shall review all proposed solicitations to determine whether access to classified information may be required by offerors, or by a contractor during contract performance.\n(1) If access to classified information of another agency may be required, the contracting officer shall  \n(i) Determine if the agency is covered by the NISP; and\n(ii) Follow that agency  s procedures for determining the security clearances of firms to be solicited.\n(2) If the classified information required is from the contracting officer  s agency, the contracting officer shall follow agency procedures.\n(b) Solicitation phase . Contracting officers shall  \n(1) Ensure that the classified acquisition is conducted as required by the NISP or agency procedures, as appropriate; and\n(2) Include  \n(i) An appropriate Security Requirements clause in the solicitation (see 4.404 ); and\n(ii) As appropriate, in solicitations and contracts when the contract may require access to classified information, a requirement for security safeguards in addition to those provided in the clause ( 52.204-2 , Security Requirements).\n(c) Award phase . Contracting officers shall inform contractors and subcontractors of the security classifications and requirements assigned to the various documents, materials, tasks, subcontracts, and components of the classified contract as follows:\n(1) Agencies covered by the NISP shall use the Contract Security Classification Specification, DD Form 254 . The contracting officer, or authorized representative, is the approving official for the form and shall ensure that it is prepared and distributed in accordance with the Industrial Security Regulation.\n(2) Contracting officers in agencies not covered by the NISP shall follow agency procedures.\n4.404 Contract clause.\n(a) The contracting officer shall insert the clause at 52.204-2 , Security Requirements, in solicitations and contracts when the contract may require access to classified information, unless the conditions specified in paragraph (d) of this section apply.\n(b) If a cost contract (see 16.302 ) for research and development with an educational institution is contemplated, the contracting officer shall use the clause with its Alternate I.\n(c) If a construction or architect-engineer contract where employee identification is required for security reasons is contemplated, the contracting officer shall use the clause with its Alternate II.\n(d) If the contracting agency is not covered by the NISP and has prescribed a clause and alternates that are substantially the same as those at 52.204-2 , the contracting officer shall use the agency-prescribed clause as required by agency procedures.");
register_book(&s, "|4|5|", "Electronic Commerce in Contracting", "Subpart 4.5  Electronic Commerce in Contracting\n4.500 Scope of subpart.\nThis subpart provides policy and procedures for the establishment and use of electronic commerce in Federal acquisition as required by Section 30 of the Office of Federal Procurement Policy (OFPP) Act ( 41 U.S.C. 426 ).\n4.501 [Reserved]\n4.502 Policy.\n(a) The Federal Government shall use electronic commerce whenever practicable or cost-effective. The use of terms commonly associated with paper transactions ( e.g.,   copy,    document,    page,    printed,    sealed envelope,  and  stamped  ) shall not be interpreted to restrict the use of electronic commerce. Contracting officers may supplement electronic transactions by using other media to meet the requirements of any contract action governed by the FAR ( e.g., transmit hard copy of drawings).\n(b) Agencies may exercise broad discretion in selecting the hardware and software that will be used in conducting electronic commerce. However, as required by Section 30 of the OFPP Act ( 41 U.S.C. 426 ), the head of each agency, after consulting with the Administrator of OFPP, shall ensure that systems, technologies, procedures, and processes used by the agency to conduct electronic commerce  \n(1) Are implemented uniformly throughout the agency, to the maximum extent practicable;\n(2) Are implemented only after considering the full or partial use of existing infrastructures;\n(3) Facilitate access to Government acquisition opportunities by small business concerns, small disadvantaged business concerns, women-owned, veteran-owned, HUBZone, and service-disabled veteran-owned small business concerns;\n(4) Include a single means of providing widespread public notice of acquisition opportunities through the Governmentwide point of entry and a means of responding to notices or solicitations electronically; and\n(5) Comply with nationally and internationally recognized standards that broaden interoperability and ease the electronic interchange of information, such as standards established by the National Institute of Standards and Technology.\n(c) Before using electronic commerce, the agency head shall ensure that the agency systems are capable of ensuring authentication and confidentiality commensurate with the risk and magnitude of the harm from loss, misuse, or unauthorized access to or modification of the information.\n(d) Agencies may accept electronic signatures and records in connection with Government contracts.");
register_book(&s, "|4|6|", "Contract Reporting", "Subpart 4.6  Contract Reporting\n4.600 Scope of subpart.\nThis subpart prescribes uniform reporting requirements for the Federal Procurement Data System (FPDS).\n4.601 Definitions.\nAs used in this subpart  \nContract action  means any oral or written action that results in the purchase, rent, or lease of supplies or equipment, services, or construction using appropriated dollars over the micro-purchase threshold, or modifications to these actions regardless of dollar value. Contract action does not include grants, cooperative agreements, other transactions, real property leases, requisitions from Federal stock, training authorizations, or other non-FAR based transactions.\nContract action report (CAR)  means contract action data required to be entered into the Federal Procurement Data System (FPDS).\nDefinitive contract  means any contract that must be reported to FPDS other than an indefinite delivery vehicle. This definition is only for FPDS, and is not intended to apply to Part 16 .\nEntitlement program  means a Federal program that guarantees a certain level of benefits to persons or other entities who meet requirements set by law, such as Social Security, farm price supports, or unemployment benefits.\nGeneric DUNS number  means a DUNS number assigned to a category of vendors not specific to any individual or entity.\nIndefinite delivery vehicle (IDV)  means an indefinite delivery contract or agreement that has one or more of the following clauses:\n(1) 52.216-18 , Ordering.\n(2) 52.216-19 , Order Limitations.\n(3) 52.216-20 , Definite Quantity.\n(4) 52.216-21 , Requirements.\n(5) 52.216-22 , Indefinite Quantity.\n(6) Any other clause allowing ordering.\n4.602 General.\n(a) The FPDS provides a comprehensive web-based tool for agencies to report contract actions. The resulting data provides  \n(1) A basis for recurring and special reports to the President, the Congress, the Government Accountability Office, Federal executive agencies, and the general public;\n(2) A means of measuring and assessing the effect of Federal contracting on the Nation  s economy and the extent to which small, veteran-owned small, service-disabled veteran-owned small, HUBZone small, small disadvantaged, women-owned small business concerns, and AbilityOne nonprofit agencies operating under the Javits-Wagner-O  Day Act, are sharing in Federal contracts;\n(3) A means of measuring and assessing the effect of Federal contracting for promoting sustainable technologies, materials, products, and high-performance sustainable buildings. This is accomplished by collecting and reporting agency data on sustainable acquisition, including types of products purchased, the purchase costs, and the exceptions used for other than sustainable acquisition; and\n(4) A means of measuring and assessing the effect of other policy and management initiatives ( e.g. , performance based acquisitions and competition).\n(b) FPDS does not provide reports for certain acquisition information used in the award of a contract action ( e.g. , subcontracting data, funding data, or accounting data).\n(c) The FPDS Web site, https://www.fpds.gov , provides instructions for submitting data. It also provides  \n(1) A complete list of departments, agencies, and other entities that submit data to the FPDS;\n(2) Technical and end-user guidance;\n(3) A computer-based tutorial; and\n(4) Information concerning reports not generated in FPDS.\n4.603 Policy.\n(a) In accordance with the Federal Funding Accountability and Transparency Act of 2006 (Pub. L. 109-282), all unclassified Federal award data must be publicly accessible.\n(b) Executive agencies shall use FPDS to maintain publicly available information about all unclassified contract actions exceeding the micro-purchase threshold, and any modifications to those actions that change previously reported contract action report data, regardless of dollar value.\n(c) Agencies awarding assisted acquisitions or direct acquisitions must report these actions and identify the Program/Funding Agency and Office Codes from the applicable agency codes maintained by each agency at FPDS. These codes represent the agency and office that has provided the predominant amount of funding for the contract action. For assisted acquisitions, the requesting agency will receive socioeconomic credit for meeting agency small business goals, where applicable. Requesting agencies shall provide the appropriate agency/bureau component code as part of the written interagency agreement between the requesting and servicing agencies (see 17.502-1 (b)(1)).\n(d) Agencies awarding contract actions with a mix of appropriated and non-appropriated funding shall only report the full appropriated portion of the contract action in FPDS.\n4.604 Responsibilities.\n(a) The Senior Procurement Executive in coordination with the head of the contracting activity is responsible for developing and monitoring a process to ensure timely and accurate reporting of contractual actions to FPDS.\n(b)(1) The responsibility for the completion and accuracy of the individual contract action report (CAR) resides with the contracting officer who awarded the contract action. CARs in a draft or error status in FPDS are not considered complete.\n(2) The CAR must be confirmed for accuracy by the contracting officer prior to release of the contract award. The CAR must then be completed in FPDS within three business days after contract award. \n(3) For any action awarded in accordance with FAR 6.302-2 or pursuant to any of the authorities listed at FAR subpart 18.2 , the CAR must be completed in FPDS within 30 days after contract award.\n(4) When the contracting office receives written notification that a contractor has changed its size status in accordance with the clause at 52.219-28 , Post-Award Small Business Program Representation, the contracting officer must submit a modification contract action report to ensure that the updated size status is entered in FPDS.\n(c) The chief acquisition officer of each agency required to report its contract actions must submit to the General Services Administration (GSA), in accordance with FPDS guidance, within 120 days after the end of each fiscal year, an annual certification of whether, and to what degree, agency CAR data for the preceding fiscal year is complete and accurate.\n4.605 Procedures.\n(a) Procurement Instrument Identifier (PIID) . Agencies shall have in place a process that ensures that each PIID reported to FPDS is unique Governmentwide, for all solicitations, contracts, blanket purchase agreements, basic agreements, basic ordering agreements, or orders in accordance with 4.1601 , and will remain so for at least 20 years from the date of contract award. Other pertinent PIID instructions for FPDS reporting can be found at https://www.fpds.gov.\n(b) Data Universal Numbering System. The contracting officer must identify and report a Data Universal Numbering System (DUNS) number (Contractor Identification Number) for the successful offeror on a contract action. The DUNS number reported must identify the successful offeror's name and address as stated in the offer and resultant contract, and as registered in the System for Award Management database in accordance with the provision at 52.204-7 , System for Award Management. The contracting officer must ask the offeror to provide its DUNS number by using either the provision at 52.204-6 , Data Universal Numbering System Number, the provision at 52.204-7 , System for Award Management, or the provision at 52.212-1 , Instructions to Offerors  Commercial Items.\n(c) Generic DUNS number. \n(1) The use of a generic DUNS number should be limited, and only used in the situations described in paragraph (c)(2) of this section. Use of a generic DUNS number does not supersede the requirements of either provisions 52.204-6 or 52.204-7 (if present in the solicitation) for the contractor to have a DUNS number assigned.\n(2) Authorized generic DUNS numbers, maintained by the Integrated Acquisition Environment (IAE) program office ( https://www.acquisition.gov ), may be used to report contracts in lieu of the contractor's actual DUNS number only for  \n(i) Contract actions valued at or below $25,000 that are awarded to a contractor that is  \n(A) A student;\n(B) A dependent of either a veteran, foreign service officer, or military member assigned outside the United States and its outlying areas (as defined in 2.101 ); or\n(C) Located outside the United States and its outlying areas for work to be performed outside the United States and its outlying areas and the contractor does not otherwise have a DUNS number;\n(ii) Contracts valued above $25,000 awarded to individuals located outside the United States and its outlying areas for work to be performed outside the United States and its outlying areas; or\n(iii) Contracts when specific public identification of the contracted party could endanger the mission, contractor, or recipients of the acquired goods or services. The contracting officer must include a written determination in the contract file of a decision applicable to authority under this paragraph (c)(2)(iii).\n(d) American Recovery and Reinvestment Act actions. The contracting officer, when entering data in FPDS, shall use the instructions at https://www.fpds.gov to identify any action funded in whole or in part by the American Recovery and Reinvestment Act of 2009 (Pub. L. 111-5).\n4.606 Reporting Data.\n(a) Actions required to be reported to FPDS .\n(1) As a minimum, agencies must report the following contract actions over the micro-purchase threshold, regardless of solicitation process used, and agencies must report any modification to these contract actions that change previously reported contract action data, regardless of dollar value:\n(i) Definitive contracts, including purchase orders and imprest fund buys over the micro-purchase threshold awarded by a contracting officer. \n(ii) Indefinite delivery vehicle (identified as an  IDV  in FPDS). Examples of IDVs include the following:\n(A) Task and Delivery Order Contracts (see Subpart 16.5 ), including  \n(1) Government-wide acquisition contracts.\n(2) Multi-agency contracts.\n(B) GSA Federal supply schedules.\n(C) Blanket Purchase Agreements (see 13.303 ).\n(D) Basic Ordering Agreements (see 16.703 ).\n(E) Any other agreement or contract against which individual orders or purchases may be placed.\n(iii) All calls and orders awarded under the indefinite delivery vehicles identified in paragraph (a)(1)(ii) of this section.\n(2) The GSA Office of Charge Card Management will provide the Government purchase card data, at a minimum annually, and GSA will incorporate that data into FPDS for reports.\n(3) Agencies may use the FPDS Express Reporting capability for consolidated multiple action reports for a vendor when it would be overly burdensome to report each action individually. When used, Express Reporting should be done at least monthly.\n(b) Reporting Other Actions . Agencies may submit actions other than those listed at paragraph (a)(1) of this section only if they are able to be segregated from FAR-based actions and this is approved in writing by the FPDS Program Office. Prior to the commencement of reporting, agencies must contact the FPDS Program Office if they desire to submit any of the following types of activity:\n(1) Transactions at or below the micro-purchase threshold, except as provided in paragraph (a)(2) of this section.\n(2) Any non-appropriated fund (NAF) or NAF portion of a contract action using a mix of appropriated and nonappropriated funding.\n(3) Lease and supplemental lease agreements for real property.\n(4) Grants and entitlement actions.\n(c) Actions not reported . The following types of contract actions are not to be reported to FPDS:\n(1) Imprest fund transactions below the micro-purchase threshold, including those made via the Government purchase card (unless specific agency procedures prescribe reporting these actions).\n(2) Orders from GSA stock and the GSA Global Supply Program.\n(3) Purchases made at GSA or AbilityOne service stores, as these items stocked for resale have already been reported by GSA.\n(4) Purchases made using non-appropriated fund activity cards, chaplain fund cards, individual Government personnel training orders, and Defense Printing orders.\n(5) Actions that, pursuant to other authority, will not be entered in FPDS ( e.g. , reporting of the information would compromise national security).\n(6) Contract actions in which the required data would constitute classified information.\n(7) Resale activity ( i.e. , commissary or exchange activity).\n(8) Revenue generating arrangements ( i.e. , concessions).\n(9) Training expenditures not issued as orders or contracts.\n(10) Interagency agreements other than inter-agency acquisitions required to be reported at 4.606(a)(1).\n(11) Letters of obligation used in the A-76 process.\n(d) Agencies not subject to the FAR. Agencies not subject to the FAR may be required by other authority ( e.g. , statute, OMB, or internal agency policy) to report certain information to FPDS. Those agencies not subject to the FAR must first receive approval from the FPDS Program Office prior to reporting to FPDS.\n4.607 Solicitation provisions and contract clause.\n(a) Insert the provision at 52.204-5 , Women-Owned Business (Other Then Small Business), in all solicitations that  \n(1) Are not set aside for small business concerns;\n(2) Exceed the simplified acquisition threshold; and\n(3) Are for contracts that will be performed in the United States or its outlying areas.\n(b) Insert the provision at 52.204-6 , Data Universal Numbering System Number, in solicitations that do not contain the provision at 52.204-7 , System for Award Management, or meet a condition at 4.605(c)(2).\n(c) Insert the clause at 52.204-12 , Data Universal Numbering System Number Maintenance, in solicitations and resulting contracts that contain the provision at 52.204-6 , Data Universal Numbering System.");
register_book(&s, "|4|7|", "Contractor Records Retention", "Subpart 4.7  Contractor Records Retention\n4.700 Scope of subpart.\nThis subpart provides policies and procedures for retention of records by contractors to meet the records review requirements of the Government. In this subpart, the terms  contracts  and  contractors  include  subcontracts  and  subcontractors.  \n4.701 Purpose.\nThe purpose of this subpart is to generally describe records retention requirements and to allow reductions in the retention period for specific classes of records under prescribed circumstances.\n4.702 Applicability.\n(a) This subpart applies to records generated under contracts that contain one of the following clauses:\n(1) Audit and Records  Sealed Bidding ( 52.214-26 ).\n(2) Audit and Records  Negotiation ( 52.215-2 ).\n(b) This subpart is not mandatory on Department of Energy contracts for which the Comptroller General allows alternative records retention periods. Apart from this exception, this subpart applies to record retention periods under contracts that are subject to Chapter 137, Title 10, U.S.C. , or 40 U.S.C. 101 , et seq .\n4.703 Policy.\n(a) Except as stated in 4.703 (b), contractors shall make available records, which includes books, documents, accounting procedures and practices, and other data, regardless of type and regardless of whether such items are in written form, in the form of computer data, or in any other form, and other supporting evidence to satisfy contract negotiation, administration, and audit requirements of the contracting agencies and the Comptroller General for  \n(1) 3 years after final payment or, for certain records;\n(2) The period specified in 4.705 through 4.705-3 , whichever of these periods expires first.\n(b) Contractors shall make available the foregoing records and supporting evidence for a longer period of time than is required in 4.703 (a) if  \n(1) A retention period longer than that cited in 4.703 (a) is specified in any contract clause; or\n(2) The contractor, for its own purposes, retains the foregoing records and supporting evidence for a longer period. Under this circumstance, the retention period shall be the period of the contractor  s retention or 3 years after final payment, whichever period expires first.\n(3) The contractor does not meet the original due date for submission of final indirect cost rate proposals specified in paragraph (d)(2) of the clause at 52.216-7 , Allowable Cost and Payment. Under these circumstances, the retention periods in 4.705 shall be automatically extended one day for each day the proposal is not submitted after the original due date.\n(c) Nothing in this section shall be construed to preclude a contractor from duplicating or storing original records in electronic form unless they contain significant information not shown on the record copy. Original records need not be maintained or produced in an audit if the contractor or subcontractor provides photographic or electronic images of the original records and meets the following requirements:\n(1) The contractor or subcontractor has established procedures to ensure that the imaging process preserves accurate images of the original records, including signatures and other written or graphic images, and that the imaging process is reliable and secure so as to maintain the integrity of the records.\n(2) The contractor or subcontractor maintains an effective indexing system to permit timely and convenient access to the imaged records.\n(3) The contractor or subcontractor retains the original records for a minimum of one year after imaging to permit periodic validation of the imaging systems.\n(d) If the information described in paragraph (a) of this section is maintained on a computer, contractors shall retain the computer data on a reliable medium for the time periods prescribed. Contractors may transfer computer data in machine readable form from one reliable computer medium to another. Contractors  computer data retention and transfer procedures shall maintain the integrity, reliability, and security of the original computer data. Contractors shall also retain an audit trail describing the data transfer. For the record retention time periods prescribed, contractors shall not destroy, discard, delete, or write over such computer data.\n4.704 Calculation of retention periods.\n(a) The retention periods in 4.705 are calculated from the end of the contractor  s fiscal year in which an entry is made charging or allocating a cost to a Government contract or subcontract. If a specific record contains a series of entries, the retention period is calculated from the end of the contractor  s fiscal year in which the final entry is made. The contractor should cut off the records in annual blocks and retain them for block disposal under the prescribed retention periods.\n(b) When records generated during a prior contract are relied upon by a contractor for certified cost or pricing data in negotiating a succeeding contract, the prescribed periods shall run from the date of the succeeding contract.\n(c) If two or more of the record categories described in 4.705 are interfiled and screening for disposal is not practical, the contractor shall retain the entire record series for the longest period prescribed for any category of records.\n4.705 Specific retention periods.\nThe contractor shall retain the records identified in 4.705-1 through 4.705-3 for the periods designated, provided retention is required under 4.702 . Records are identified in this subpart in terms of their purpose or use and not by specific name or form number. Although the descriptive identifications may not conform to normal contractor usage or filing practices, these identifications apply to all contractor records that come within the description.\n4.705-1 Financial and cost accounting records.\n(a) Accounts receivable invoices, adjustments to the accounts, invoice registers, carrier freight bills, shipping orders, and other documents which detail the material or services billed on the related invoices: Retain 4 years.\n(b) Material, work order, or service order files, consisting of purchase requisitions or purchase orders for material or services, or orders for transfer of material or supplies: Retain 4 years.\n(c) Cash advance recapitulations, prepared as posting entries to accounts receivable ledgers for amounts of expense vouchers prepared for employees  travel and related expenses: Retain 4 years.\n(d) Paid, canceled, and voided checks, other than those issued for the payment of salary and wages: Retain 4 years.\n(e) Accounts payable records to support disbursements of funds for materials, equipment, supplies, and services, containing originals or copies of the following and related documents: remittance advices and statements, vendors  invoices, invoice audits and distribution slips, receiving and inspection reports or comparable certifications of receipt and inspection of material or services, and debit and credit memoranda: Retain 4 years.\n(f) Labor cost distribution cards or equivalent documents: Retain 2 years.\n(g) Petty cash records showing description of expenditures, to whom paid, name of person authorizing payment, and date, including copies of vouchers and other supporting documents: Retain 2 years.\n4.705-2 Pay administration records.\n(a) Payroll sheets, registers, or their equivalent, of salaries and wages paid to individual employees for each payroll period; change slips; and tax withholding statements: Retain 4 years.\n(b) Clock cards or other time and attendance cards: Retain 2 years.\n(c) Paid checks, receipts for wages paid in cash, or other evidence of payments for services rendered by employees: Retain 2 years.\n4.705-3 Acquisition and supply records.\n(a) Store requisitions for materials, supplies, equipment, and services: Retain 2 years.\n(b) Work orders for maintenance and other services: Retain 4 years.\n(c) Equipment records, consisting of equipment usage and status reports and equipment repair orders: Retain 4 years.\n(d) Expendable property records, reflecting accountability for the receipt and use of material in the performance of a contract: Retain 4 years.\n(e) Receiving and inspection report records, consisting of reports reflecting receipt and inspection of supplies, equipment, and materials: Retain 4 years.\n(f) Purchase order files for supplies, equipment, material, or services used in the performance of a contract; supporting documentation and backup files including, but not limited to, invoices, and memoranda; e.g., memoranda of negotiations showing the principal elements of subcontract price negotiations (see 52.244-2 ): Retain 4 years.\n(g) Production records of quality control, reliability, and inspection: Retain 4 years.\n(h) Property records (see FAR 45.101 and 52.245-1 ): Retain 4 years.");
register_book(&s, "|4|8|", "Government Contract Files", "Subpart 4.8  Government Contract Files\n4.800 Scope of subpart.\nThis subpart prescribes requirements for establishing, maintaining, and disposing of contract files.\n4.801 General.\n(a) The head of each office performing contracting, contract administration, or paying functions shall establish files containing the records of all contractual actions.\n(b) The documentation in the files (see 4.803 ) shall be sufficient to constitute a complete history of the transaction for the purpose of  \n(1) Providing a complete background as a basis for informed decisions at each step in the acquisition process;\n(2) Supporting actions taken;\n(3) Providing information for reviews and investigations; and\n(4) Furnishing essential facts in the event of litigation or congressional inquiries.\n(c) The files to be established include  \n(1) A file for cancelled solicitations;\n(2) A file for each contract; and\n(3) A file such as a contractor general file, containing documents relating  for example  to  \n(i) No specific contract;\n(ii) More than one contract; or\n(iii) The contractor in a general way ( e.g., contractor  s management systems, past performance, or capabilities).\n4.802 Contract files.\n(a) A contract file should generally consist of  \n(1) The contracting office contract file that documents the basis for the acquisition and the award, the assignment of contract administration (including payment responsibilities), and any subsequent actions taken by the contracting office;\n(2) The contract administration office contract file that documents actions reflecting the basis for and the performance of contract administration responsibilities; and\n(3) The paying office contract file that documents actions prerequisite to, substantiating, and reflecting contract payments.\n(b) Normally, each file should be kept separately; however, if appropriate, any or all of the files may be combined; e.g., if all functions or any combination of the functions are performed by the same office.\n(c) Files must be maintained at organizational levels that ensure  \n(1) Effective documentation of contract actions;\n(2) Ready accessibility to principal users;\n(3) Minimal establishment of duplicate and working files;\n(4) The safeguarding of classified documents; and\n(5) Conformance with agency regulations for file location and maintenance.\n(d) If the contract files or file segments are decentralized ( e.g., by type or function) to various organizational elements or to other outside offices, responsibility for their maintenance must be assigned. A central control and, if needed, a locator system should be established to ensure the ability to locate promptly any contract files.\n(e) Contents of contract files that are contractor bid or proposal information or source selection information as defined in 2.101 must be protected from disclosure to unauthorized persons (see 3.104-4 ).\n(f) Agencies may retain contract files in any medium (paper, electronic, microfilm, etc.) or any combination of media, as long as the requirements of this subpart are satisfied.\n4.803 Contents of contract files.\nThe following are examples of the records normally contained, if applicable, in contract files:\n(a) Contracting office contract file.\n(1) Purchase request, acquisition planning information, and other presolicitation documents.\n(2) Justifications and approvals, determinations and findings, and associated documents.\n(3) Evidence of availability of funds.\n(4) Synopsis of proposed acquisition as required by Part 5 or a reference to the synopsis.\n(5) The list of sources solicited, and a list of any firms or persons whose requests for copies of the solicitation were denied, together with the reasons for denial.\n(6) Set-aside decision including the type and extent of market research conducted.\n(7) Government estimate of contract price.\n(8) A copy of the solicitation and all amendments thereto.\n(9) Security requirements and evidence of required clearances.\n(10) A copy of each offer or quotation, the related abstract, and records of determinations concerning late offers or quotations. Unsuccessful offers or quotations may be maintained separately, if cross-referenced to the contract file. The only portions of the unsuccessful offer or quotation that need be retained are  \n(i) Completed solicitation sections A, B, and K;\n(ii) Technical and management proposals;\n(iii) Cost/price proposals; and\n(iv) Any other pages of the solicitation that the offeror or quoter has altered or annotated.\n(11) Contractor  s representations and certifications (see 4.1201 (c)).\n(12) Preaward survey reports or reference to previous preaward survey reports relied upon.\n(13) Source selection documentation.\n(14) Contracting officer  s determination of the contractor  s responsibility.\n(15) Small Business Administration Certificate of Competency.\n(16) Records of contractor  s compliance with labor policies including equal employment opportunity policies.\n(17) Data and information related to the contracting officer  s determination of a fair and reasonable price. This may include  \n(i) Certified cost or pricing data;\n(ii) Data other than certified cost or pricing data;\n(iii) Justification for waiver from the requirement to submit certified cost or pricing data; or\n(iv) Certificates of Current Cost or Pricing Data.\n(18) Packaging and transportation data.\n(19) Cost or price analysis.\n(20) Audit reports or reasons for waiver.\n(21) Record of negotiation.\n(22) Justification for type of contract.\n(23) Authority for deviations from this regulation, statutory requirements, or other restrictions.\n(24) Required approvals of award and evidence of legal review.\n(25) Notice of award.\n(26) The original of  \n(i) The signed contract or award;\n(ii) All contract modifications; and\n(iii) Documents supporting modifications executed by the contracting office.\n(27) Synopsis of award or reference thereto.\n(28) Notice to unsuccessful quoters or offerors and record of any debriefing.\n(29) Acquisition management reports (see Subpart 4.6 ).\n(30) Bid, performance, payment, or other bond documents, or a reference thereto, and notices to sureties.\n(31) Report of postaward conference.\n(32) Notice to proceed, stop orders, and any overtime premium approvals granted at the time of award.\n(33) Documents requesting and authorizing modification in the normal assignment of contract administration functions and responsibility.\n(34) Approvals or disapprovals of requests for waivers or deviations from contract requirements.\n(35) Rejected engineering change proposals.\n(36) Royalty, invention, and copyright reports (including invention disclosures) or reference thereto.\n(37) Contract completion documents.\n(38) Documentation regarding termination actions for which the contracting office is responsible.\n(39) Cross-references to pertinent documents that are filed elsewhere.\n(40) Any additional documents on which action was taken or that reflect actions by the contracting office pertinent to the contract.\n(41) A current chronological list identifying the awarding and successor contracting officers, with inclusive dates of responsibility.\n(42) When limiting competition to women-owned small business (WOSB) concerns eligible under the WOSB Program or economically disadvantaged women-owned small business (EDWOSB) concerns in accordance with subpart 19.15 , include documentation  \n(i) Of the type and extent of market research; and\n(ii) That the NAICS code assigned to the acquisition is for an industry that SBA has designated as  \n(A) Underrepresented for economically disadvantaged women-owned small business set-asides, or\n(B) Substantially underrepresented for women-owned small business set-asides.\n(b) Contract administration office contract file.\n(1) Copy of the contract and all modifications, together with official record copies of supporting documents executed by the contract administration office.\n(2) Any document modifying the normal assignment of contract administration functions and responsibility.\n(3) Security requirements.\n(4) Certified cost or pricing data, Certificates of Current Cost or Pricing Data, or data other than certified cost or pricing data; cost or price analysis; and other documentation supporting contractual actions executed by the contract administration office.\n(5) Preaward survey information.\n(6) Purchasing system information.\n(7) Consent to subcontract or purchase.\n(8) Performance and payment bonds and surety information.\n(9) Postaward conference records.\n(10) Orders issued under the contract.\n(11) Notice to proceed and stop orders.\n(12) Insurance policies or certificates of insurance or references to them.\n(13) Documents supporting advance or progress payments.\n(14) Progressing, expediting, and production surveillance records.\n(15) Quality assurance records.\n(16) Property administration records.\n(17) Documentation regarding termination actions for which the contract administration office is responsible.\n(18) Cross reference to other pertinent documents that are filed elsewhere.\n(19) Any additional documents on which action was taken or that reflect actions by the contract administration office pertinent to the contract.\n(20) Contract completion documents.\n(c) Paying office contract file.\n(1) Copy of the contract and any modifications.\n(2) Bills, invoices, vouchers, and supporting documents.\n(3) Record of payments or receipts.\n(4) Other pertinent documents.\n4.804 Closeout of contract files.\n4.804-1 Closeout by the office administering the contract.\n(a) Except as provided in paragraph (c) of this section, time standards for closing out contract files are as follows:\n(1) Files for contracts using simplified acquisition procedures should be considered closed when the contracting officer receives evidence of receipt of property and final payment, unless otherwise specified by agency regulations.\n(2) Files for firm-fixed-price contracts, other than those using simplified acquisition procedures, should be closed within 6 months after the date on which the contracting officer receives evidence of physical completion.\n(3) Files for contracts requiring settlement of indirect cost rates should be closed within 36 months of the month in which the contracting officer receives evidence of physical completion.\n(4) Files for all other contracts should be closed within 20 months of the month in which the contracting officer receives evidence of physical completion.\n(b) When closing out the contract files at 4.804-1 (a)(2), (3), and (4), the contracting officer shall use the closeout procedures at 4.804-5 . However, these closeout actions may be modified to reflect the extent of administration that has been performed. Quick closeout procedures (see 42.708 ) should be used, when appropriate, to reduce administrative costs and to enable deobligation of excess funds.\n(c) A contract file shall not be closed if  \n(1) The contract is in litigation or under appeal; or\n(2) In the case of a termination, all termination actions have not been completed.\n4.804-2 Closeout of the contracting office files if another office administers the contract.\n(a) Contract files for contracts using simplified acquisition procedures should be considered closed when the contracting officer receives evidence of receipt of property and final payment, unless otherwise specified by agency regulation.\n(b) All other contract files shall be closed as soon as practicable after the contracting officer receives a contract completion statement from the contract administration office. The contracting officer shall ensure that all contractual actions required have been completed and shall prepare a statement to that effect. This statement is authority to close the contract file and shall be made a part of the official contract file.\n4.804-3 Closeout of paying office contract files.\nThe paying office shall close the contract file upon issuance of the final payment voucher.\n4.804-4 Physically completed contracts.\n(a) Except as provided in paragraph (b) of this section, a contract is considered to be physically completed when  \n(1)(i) The contractor has completed the required deliveries and the Government has inspected and accepted the supplies;\n(ii) The contractor has performed all services and the Government has accepted these services; and\n(iii) All option provisions, if any, have expired; or\n(2) The Government has given the contractor a notice of complete contract termination.\n(b) Rental, use, and storage agreements are considered to be physically completed when  \n(1) The Government has given the contractor a notice of complete contract termination; or\n(2) The contract period has expired.\n4.804-5 Procedures for closing out contract files.\n(a) The contract administration office is responsible for initiating (automated or manual) administrative closeout of the contract after receiving evidence of its physical completion. At the outset of this process, the contract administration office must review the contract funds status and notify the contracting office of any excess funds the contract administration office might deobligate. When complete, the administrative closeout procedures must ensure that  \n(1) Disposition of classified material is completed;\n(2) Final patent report is cleared . If a final patent report is required, the contracting officer may proceed with contract closeout in accordance with the following procedures, or as otherwise prescribed by agency procedures:\n(i) Final patent reports should be cleared within 60 days of receipt.\n(ii) If the final patent report is not received, the contracting officer shall notify the contractor of the contractor  s obligations and the Government  s rights under the applicable patent rights clause, in accordance with 27.303 . If the contractor fails to respond to this notification, the contracting officer may proceed with contract closeout upon consultation with the agency legal counsel responsible for patent matters regarding the contractor  s failure to respond.\n(3) Final royalty report is cleared;\n(4) There is no outstanding value engineering change proposal;\n(5) Plant clearance report is received;\n(6) Property clearance is received;\n(7) All interim or disallowed costs are settled;\n(8) Price revision is completed;\n(9) Subcontracts are settled by the prime contractor;\n(10) Prior year indirect cost rates are settled;\n(11) Termination docket is completed;\n(12) Contract audit is completed;\n(13) Contractor  s closing statement is completed;\n(14) Contractor  s final invoice has been submitted; and\n(15) Contract funds review is completed and excess funds deobligated.\n(b) When the actions in paragraph (a) of this subsection have been verified, the contracting officer administering the contract must ensure that a contract completion statement, containing the following information, is prepared:\n(1) Contract administration office name and address (if different from the contracting office).\n(2) Contracting office name and address.\n(3) Contract number.\n(4) Last modification number.\n(5) Last call or order number.\n(6) Contractor name and address.\n(7) Dollar amount of excess funds, if any.\n(8) Voucher number and date, if final payment has been made.\n(9) Invoice number and date, if the final approved invoice has been forwarded to a disbursing office of another agency or activity and the status of the payment is unknown.\n(10) A statement that all required contract administration actions have been fully and satisfactorily accomplished.\n(11) Name and signature of the contracting officer.\n(12) Date.\n(c) When the statement is completed, the contracting officer must ensure that  \n(1) The signed original is placed in the contracting office contract file (or forwarded to the contracting office for placement in the files if the contract administration office is different from the contracting office); and\n(2) A signed copy is placed in the appropriate contract administration file if administration is performed by a contract administration office.\n4.805 Storage, handling, and disposal of contract files.\n(a) Agencies must prescribe procedures for the handling, storing, and disposing of contract files. These procedures must take into account documents held in all types of media, including microfilm and various electronic media. Agencies may change the original medium to facilitate storage as long as the requirements of Part 4 , law, and other regulations are satisfied. The process used to create and store records must record and reproduce the original document, including signatures and other written and graphic images completely, accurately, and clearly. Data transfer, storage, and retrieval procedures must protect the original data from alteration. Unless law or other regulations require signed originals to be kept, they may be destroyed after the responsible agency official verifies that record copies on alternate media and copies reproduced from the record copy are accurate, complete, and clear representations of the originals. Agency procedures for contract file disposal must include provisions that the documents specified in paragraph (b) of this section may not be destroyed before the times indicated, and may be retained longer if the responsible agency official determines that the files have future value to the Government. When original documents have been converted to alternate media for storage, the requirements in paragraph (b) of this section also apply to the record copies in the alternate media.\n(b) If administrative records are mixed with program records and cannot be economically segregated, the entire file should be kept for the period of time approved for the program records. Similarly, if documents described in the following table are part of a subject or case file that documents activities that are not described in the table, they should be treated in the same manner as the files of which they are a part. The retention periods for acquisitions at or below the simplified acquisition threshold also apply to acquisitions conducted prior to July 3, 1995, that used small purchase procedures. The retention periods for acquisitions above the simplified acquisition threshold also apply to acquisitions conducted prior to July 3, 1995, that used other than small purchase procedures. \nDocument\nRetention Period\n(1) Records pertaining to Contract Disputes Act actions.\n6 years and 3 months after final action or decision for files created prior to October 1, 1979. 1 year after final action or decision for files created on or after October 1, 1979.\n(2) Contracts (and related records or documents, including successful proposals) exceeding the simplified acquisition threshold for other than construction.\n6 years and 3 months after final payment.\n(3) Contracts (and related records or documents, including successful proposals) at or below the simplified acquisition threshold for other than construction.\n3 years after final payment.\n(4) Construction contracts:\n(i) Above $2,000.\n6 years and 3 months after final payment.\n(ii) $2,000 or less.\n3 years after final payment.\n(iii) Related records or documents, including successful proposals, except for contractor's payrolls (see (b)(4)(iv)).\nSame as contract file.\n(iv) Contractor's payrolls submitted in accordance with Department of Labor regulations, with related certifications, anti-kickback affidavits, and other related papers.\n3 years after contract completion unless contract performance is the subject of an enforcement action on that date.\n(5) Solicited and unsolicited unsuccessful offers, quotations, bids, and proposals:\n.\n(i) Relating to contracts above the simplified acquisition threshold.\nIf filed separately from contract file, until contract is completed. Otherwise, the same as related contract file.\n(ii) Relating to contracts at or below the simplified acquisition threshold.\n1 year after date of award or until final payment, whichever is later.\n(6) Files for canceled solicitations.\n5 years after cancellation.\n(7) Other copies of procurement file records used by component elements of a contracting office for administrative purposes.\nUpon termination or completion.\n(8) Documents pertaining generally to the contractor as described at 4.801 (c)(3).\nUntil superseded or obsolete.\n(9) Data submitted to the Federal Procurement Data System (FPDS). Electronic data file maintained by fiscal year, containing unclassified records of all procurements other than simplified acquisitions, and information required under 4.603 .\n5 years after submittal to FPDS.\n(10) Investigations, cases pending or in litigation (including protests), or similar matters.\nUntil final clearance or settlement, or, if related to a document identified in (b)(1) - (9), for the retention period specified for the related document, whichever is later.");
register_book(&s, "|4|9|", "Taxpayer Identification Number Informat", "Subpart 4.9  Taxpayer Identification Number Information\n4.900 Scope of subpart.\nThis subpart provides policies and procedures for obtaining  \n(a) Taxpayer Identification Number (TIN) information that may be used for debt collection purposes; and\n(b) Contract information and payment information for submittal to the payment office for Internal Revenue Service (IRS) reporting purposes.\n4.901 Definition.\nCommon parent,  as used in this subpart, means that corporate entity that owns or controls an affiliated group of corporations that files its Federal income tax returns on a consolidated basis, and of which the offeror is a member.\n4.902 General.\n(a) Debt collection . 31 U.S.C. 7701(c) requires each contractor doing business with a Government agency to furnish its TIN to that agency. 31 U.S.C. 3325(d) requires the Government to include, with each certified voucher prepared by the Government payment office and submitted to a disbursing official, the TIN of the contractor receiving payment under the voucher. The TIN may be used by the Government to collect and report on any delinquent amounts arising out of the contractor  s relationship with the Government.\n(b) Information reporting to the IRS . The TIN is also required for Government reporting of certain contract information (see 4.903 ) and payment information (see 4.904 ) to the IRS.\n4.903 Reporting contract information to the IRS.\n(a) 26 U.S.C. 6050M , as implemented in 26 CFR, requires heads of Federal executive agencies to report certain information to the IRS.\n(b)(1) The required information applies to contract modifications  \n(i) Increasing the amount of a contract awarded before January 1, 1989, by $50,000 or more; and\n(ii) Entered into on or after April 1, 1990.\n(2) The reporting requirement also applies to certain contracts and modifications thereto in excess of $25,000 entered into on or after January 1, 1989.\n(c) The information to report is  \n(1) Name, address, and TIN of the contractor;\n(2) Name and TIN of the common parent (if any);\n(3) Date of the contract action;\n(4) Amount obligated on the contract action; and\n(5) Estimated contract completion date.\n(d) Transmit the information to the IRS through the Federal Procurement Data System (see Subpart 4.6 and implementing instructions).\n4.904 Reporting payment information to the IRS.\n26 U.S.C. 6041 and 6041A, as implemented in 26 CFR, in part, require payors, including Government agencies, to report to the IRS, on Form 1099, payments made to certain contractors. 26 U.S.C. 6109 requires a contractor to provide its TIN if a Form 1099 is required. The payment office is responsible for submitting reports to the IRS.\n4.905 Solicitation provision.\nThe contracting officer shall insert the provision at 52.204-3 , Taxpayer Identification, in solicitations that  \n(a) Do not include the provision at 52.204-7 , System for Award Management; and\n(b) Are not conducted under the procedures of Part 12 .");
register_book(&s, "|4|10|", "Contract Line Items", "Subpart 4.10  Contract Line Items\n4.1001 Policy.\nContracts may identify the items or services to be acquired as separately identified line items. Contract line items should provide unit prices or lump sum prices for separately identifiable contract deliverables, and associated delivery schedules or performance periods. Line items may be further subdivided or stratified for administrative purposes ( e.g., to provide for traceable accounting classification citations).");
register_book(&s, "|4|11|", "System for Award Management", "Subpart 4.11  System for Award Management\n4.1100 Scope.\nThis subpart prescribes policies and procedures for requiring contractor registration in the System for Award Management (SAM) database to  \n(a) Increase visibility of vendor sources (including their geographical locations) for specific supplies and services; and\n(b) Establish a common source of vendor data for the Government.\n4.1101 Definition.\nAs used in this subpart  \nAgreement  means basic agreement, basic ordering agreement, or blanket purchase agreement.\n4.1102 Policy.\n(a) Prospective contractors shall be registered in the SAM database prior to award of a contract or agreement, except for  \n(1) Purchases under the micro-purchase threshold that use a Governmentwide commercial purchase card as both the purchasing and payment mechanism, as opposed to using the purchase card for payment only;\n(2) Classified contracts (see 2.101 ) when registration in the SAM database, or use of SAM data, could compromise the safeguarding of classified information or national security;\n(3) Contracts awarded by  \n(i) Deployed contracting officers in the course of military operations, including, but not limited to, contingency operations as defined in 10 U.S.C. 101(a)(13) or humanitarian or peacekeeping operations as defined in 10 U.S.C. 2302(7) ; \n(ii) Contracting officers located outside the United States and its outlying areas, as defined in 2.101, for work to be performed in support of diplomatic or developmental operations, including those performed in support of foreign assistance programs overseas, in an area that has been designated by the Department of State as a danger pay post (see http:// aoprals.state.gov/Web920/danger_pay_all.asp ); or\n(iii) Contracting officers in the conduct of emergency operations, such as responses to natural or environmental disasters or national or civil emergencies, e.g., Robert T. Stafford Disaster Relief and Emergency Assistance Act ( 42 U.S.C. 5121 );\n(4) Contracts with individuals for performance outside the United States and its outlying areas;\n(5) Contracts to support unusual or compelling needs (see 6.302-2 );\n(6) Contract actions at or below $25,000 awarded to foreign vendors for work performed outside the United States, if it is impractical to obtain System for Award Management registration; and\n(7) Micro-purchases that do not use the electronic funds transfer (EFT) method for payment and are not required to be reported (see Subpart 4.6 ).\n(b) If practical, the contracting officer shall modify the contract or agreement awarded under paragraph (a)(3) of this section to require SAM registration.\n(c) \n(1) \n(i) If a contractor has legally changed its business name,  doing business as  name, or division name (whichever is shown on the contract), or has transferred the assets used in performing the contract, but has not completed the necessary requirements regarding novation and change-of-name agreements in Subpart 42.12 , the contractor shall provide the responsible contracting officer a minimum of one business day  s written notification of its intention to change the name in the SAM database; comply with the requirements of Subpart 42.12 ; and agree in writing to the timeline and procedures specified by the responsible contracting officer. The contractor must provide with the notification sufficient documentation to support the legally changed name.\n(ii) If the contractor fails to comply with the requirements of paragraph (c)(1)(i) of the clause at 52.204-13 , System for Award Management Maintenance, or fails to perform the agreement at 52.204-13 , paragraph (c)(1)(i)(C), and, in the absence of a properly executed novation or change-of-name agreement, the SAM information that shows the contractor to be other than the contractor indicated in the contract will be considered to be incorrect information within the meaning of the  Suspension of Payment  paragraph of the EFT clause of the contract.\n(2) The contractor shall not change the name or address for electronic funds transfer payments (EFT) or manual payments, as appropriate, in the SAM record to reflect an assignee for the purpose of assignment of claims (see Subpart 32.8 , Assignment of Claims).\n(3) Assignees shall be separately registered in the SAM database. Information provided to the contractor  s SAM record that indicates payments, including those made by EFT, to an ultimate recipient other than that contractor will be considered to be incorrect information within the meaning of the  Suspension of payment  paragraph of the EFT clause of the contract.\n4.1103 Procedures.\n(a) Unless the acquisition is exempt under 4.1102 , the contracting officer  \n(1) Shall verify that the prospective contractor is registered in the SAM database (see paragraph (b) of this section) before awarding a contract or agreement. Contracting officers are encouraged to check the SAM early in the acquisition process, after the competitive range has been established, and then communicate to the unregistered offerors that they must register;\n(2) Should use the DUNS number or, if applicable, the DUNS+4 number, to verify registration  \n(i) Via the Internet via https://www.acquisition.gov ;\n(ii) As otherwise provided by agency procedures; and\n(3) Need not verify registration before placing an order or call if the contract or agreement includes the provision at 52.204-7 , or the clause at 52.212-4 , or a similar agency clause, except when use of the Governmentwide commercial purchase card is contemplated as a method of payment. (See 32.1108 (b)(2)).\n(b) If the contracting officer, when awarding a contract or agreement, determines that a prospective contractor is not registered in the SAM database and an exception to the registration requirements for the award does not apply (see 4.1102 ), the contracting officer shall  \n(1) If the needs of the requiring activity allow for a delay, make award after the apparently successful offeror has registered in the SAM database. The contracting officer shall advise the offeror of the number of days it will be allowed to become registered. If the offeror does not become registered by the required date, the contracting officer shall award to the next otherwise successful registered offeror following the same procedures ( i.e., if the next apparently successful offeror is not registered, the contracting officer shall advise the offeror of the number of days it will be allowed to become registered, etc.); or\n(2) If the needs of the requiring activity do not allow for a delay, proceed to award to the next otherwise successful registered offeror, provided that written approval is obtained at one level above the contracting officer; or\n(3) If the contract action is being awarded pursuant to 6.302-2 , the contractor must be registered in the System for Award Management within 30 days after contract award, or at least three days prior to submission of the first invoice, whichever occurs first.\n(c) Agencies shall protect against improper disclosure of contractor SAM information.\n(d) The contracting officer shall, on contractual documents transmitted to the payment office, provide the DUNS number, or, if applicable, the DUNS+4, in accordance with agency procedures.\n4.1104 Disaster Response Registry.\nContracting officers shall consult the Disaster Response Registry via https://www.acquisition.gov when contracting for debris removal, distribution of supplies, reconstruction, and other disaster or emergency relief activities inside the United States and outlying areas. (See 26.205 ).\n4.1105 Solicitation provision and contract clauses.\n(a)(1) Except as provided in 4.1102 (a), use the provisions at 52.204-7 , System for Award Management, in solicitations.\n(2) If the solicitation is anticipated to be awarded in accordance with 4.1102 (a)(5), the contracting officer shall use the provision at 52.204-7 , System for Award Management, with its Alternate I.\n(b) Insert the clause at 52.204-13 , System for Award Management Maintenance, in solicitations that contain the provision at 52.204-7 , and resulting contracts.");
register_book(&s, "|4|12|", "Representations and Certifications", "Subpart 4.12  Representations and Certifications \n4.1200 Scope.\nThis subpart prescribes policies and procedures for requiring submission and maintenance of representations and certifications via the System for Award Management (SAM) to  \n(a) Eliminate the administrative burden for contractors of submitting the same information to various contracting offices; and\n(b) Establish a common source for this information to procurement offices across the Government.\n4.1201 Policy.\n(a) Prospective contractors shall complete electronic annual representations and certifications at SAM accessed via https://www.acquisition.gov as a part of required registration (see FAR 4.1102 ).\n(b)(1) Prospective contractors shall update the representations and certifications submitted to SAM as necessary, but at least annually, to ensure they are kept current, accurate, and complete. The representations and certifications are effective until one year from date of submission or update to SAM.\n(2) When any of the conditions in paragraph (b) of the clause at 52.219-28 , Post-Award Small Business Program Rerepresentation, apply, contractors that represented they were small businesses prior to award of a contract must update the representations and certifications in SAM as directed by the clause. Contractors that represented they were other than small businesses prior to award of a contract may update the representations and certifications in SAM as directed by the clause, if their size status has changed since contract award.\n(c) Data in SAM is archived and is electronically retrievable. Therefore, when a prospective contractor has completed representations and certifications electronically via SAM, the contracting officer must reference the date of SAM verification in the contract file, or include a paper copy of the electronically-submitted representations and certifications in the file. Either of these actions satisfies contract file documentation requirements of 4.803 (a)(11). However, if an offeror identifies changes to SAM data pursuant to the FAR provisions at 52.204-8 (d) or 52.212-3 (b), the contracting officer must include a copy of the changes in the contract file.\n4.1202 Solicitation provision and contract clause.\nExcept for commercial item solicitations issued under FAR part 12 , insert in solicitations the provision at 52.204-8 , Annual Representations and Certifications. The contracting officer shall check the applicable provisions at 52.204-8 (c)(2). When the provision at 52.204-7 , System for Award Management, is included in the solicitation, do not include the following representations and certifications:\n(a) 52.203-2 , Certificate of Independent Price Determination.\n(b) 52.203-11 , Certification and Disclosure Regarding Payments to Influence Certain Federal Transactions.\n(c) 52.204-3 , Taxpayer Identification.\n(d) 52.204-5 , Women-Owned Business (Other Than Small Business).\n(e) 52.209-2 , Prohibition on Contracting with Inverted Domestic Corporations  Representation.\n(f) 52.209-5 , Certification Regarding Responsibility Matters.\n(g) 52.214-14 , Place of Performance  Sealed Bidding.\n(h) 52.215-6 , Place of Performance.\n(i) 52.219-1 , Small Business Program Representations (Basic & Alternate I).\n(j) 52.219-2 , Equal Low Bids.\n(k) 52.219-22 , Small Disadvantaged Business Status (Basic & Alternate I).\n(l) 52.222-18 , Certification Regarding Knowledge of Child Labor for Listed End Products.\n(m) 52.222-22 , Previous Contracts and Compliance Reports.\n(n) 52.222-25 , Affirmative Action Compliance.\n(o) 52.222-38 , Compliance with Veterans  Employment Reporting Requirements.\n(p) 52.222-48 , Exemption from Application of the Service Contract Act to Contracts for Maintenance, Calibration, or Repair of Certain Equipment Certification.\n(q) 52.222-52 , Exemption from Application of the Service Contract Act to Contracts for Certain Services  Certification.\n(r) 52.223-1 , Biobased Product Certification.\n(s) 52.223-4 , Recovered Material Certification.\n(t) 52.223-9 , Estimate of Percentage of Recovered Material Content for EPA-Designated Items (Alternate I only).\n(u) 52.225-2 , Buy American Act Certificate.\n(v) 52.225-4 , Buy American Act  Free Trade Agreements  Israeli Trade Act Certificate (Basic, Alternates I, II, and III).\n(w) 52.225-6 , Trade Agreements Certificate.\n(x) 52.225-20 , Prohibition on Conducting Restricted Business Operations in Sudan  Certification.\n(y) 52.225-25 , Prohibition on Contracting with Entities Engaging in Certain Activities or Transactions Relating to Iran-Representation and Certifications.\n(z) 52.226-2 , Historically Black College or University and Minority Institution Representation.\n(aa) 52.227-6 , Royalty Information (Basic & Alternate I).\n(bb) 52.227-15 , Representation of Limited Rights Data and Restricted Computer Software.");
register_book(&s, "|4|13|", "Personal Identity Verification", "Subpart 4.13  Personal Identity Verification\n4.1300 Scope of subpart.\nThis subpart provides policy and procedures associated with Personal Identity Verification as required by  \n(a) Federal Information Processing Standards Publication (FIPS PUB) Number 201,  Personal Identity Verification of Federal Employees and Contractors  ; and\n(b) Office of Management and Budget (OMB) Guidance M-05-24, dated August 5, 2005,  Implementation of Homeland Security Presidential Directive (HSPD) 12-Policy for a Common Identification Standard for Federal Employees and Contractors.  \n4.1301 Policy.\n(a) Agencies must follow FIPS PUB Number 201 and the associated OMB implementation guidance for personal identity verification for all affected contractor and subcontractor personnel when contract performance requires contractors to have routine physical access to a Federally-controlled facility and/or routine access to a Federally-controlled information system.\n(b) Agencies must include their implementation of FIPS PUB 201 and OMB Guidance M-05-24 in solicitations and contracts that require the contractor to have routine physical access to a Federally-controlled facility and/or routine access to a Federally-controlled information system.\n(c) Agencies must designate an official responsible for verifying contractor employee personal identity.\n(d)(1) Agency procedures for the return of Personal Identity Verification (PIV) products shall ensure that Government contractors account for all forms of Government-provided identification issued to Government contractor employees under a contract, i.e ., the PIV cards or other similar badges, and shall ensure that contractors return such identification to the issuing agency as soon as any of the following occurs, unless otherwise determined by the agency:\n(i) When no longer needed for contract performance.\n(ii) Upon completion of a contractor employee  s employment.\n(iii) Upon contract completion or termination.\n(2) The contracting officer may delay final payment under a contract if the contractor fails to comply with these requirements.\n4.1302 Acquisition of approved products and services for personal identity verification.\n(a) In order to comply with FIPS PUB 201, agencies must purchase only approved personal identity verification products and services.\n(b) Agencies may acquire the approved products and services from the GSA, Federal Supply Schedule 70, Special Item Number (SIN) 132-62, HSPD-12 Product and Service Components, in accordance with ordering procedures outlined in FAR Subpart 8.4 .\n(c) When acquiring personal identity verification products and services not using the process in paragraph (b) of this section, agencies must ensure that the applicable products and services are approved as compliant with FIPS PUB 201 including  \n(1) Certifying the products and services procured meet all applicable Federal standards and requirements;\n(2) Ensuring interoperability and conformance to applicable Federal standards for the lifecycle of the components; and\n(3) Maintaining a written plan for ensuring ongoing conformance to applicable Federal standards for the lifecycle of the components.\n(d) For more information on personal identity verification products and services see \nhttp://www.idmanagement.gov.\n4.1303 Contract clause.\nThe contracting officer shall insert the clause at 52.204-9 , Personal Identity Verification of Contractor Personnel, in solicitations and contracts when contract performance requires contractors to have routine physical access to a Federally-controlled facility and/or routine access to a Federally-controlled information system. The clause shall not be used when contractors require only intermittent access to Federally-controlled facilities.");
register_book(&s, "|4|14|", "Reporting Executive Compensation and Fi", "Subpart 4.14  Reporting Executive Compensation and First-Tier Subcontract Awards\n4.1400 Scope of subpart.\nThis subpart implements section 2 of the Federal Funding Accountability and Transparency Act of 2006 (Pub. L. 109-282), as amended by section 6202 of the Government Funding Transparency Act of 2008 (Pub. L. 110-252), which requires contractors to report subcontract award data and the total compensation of the five most highly compensated executives of the contractor and subcontractor. The public may view first-tier subcontract award data at http://usaspending.gov .\n4.1401 Applicability.\n(a) This subpart applies to all contracts with a value of $25,000 or more. Nothing in this subpart requires the disclosure of classified information.\n(b) Reporting of subcontract information will be limited to the first-tier subcontractor.\n4.1402 Procedures.\n(a) Agencies shall ensure that contractors comply with the reporting requirements of 52.204-10 , Reporting Executive Compensation and First-Tier Subcontract Awards. Agencies shall review contractor reports on a quarterly basis to ensure the information is consistent with contract information. The agency is not required to address data for which the agency would not normally have supporting information, such as the compensation information required of contractors and first-tier subcontractors. However, the agency shall inform the contractor of any inconsistencies with the contract information and require that the contractor correct the report, or provide a reasonable explanation as to why it believes the information is correct. Agencies may review the reports at http://www.fsrs.gov .\n(b) When contracting officers report the contract action to the Federal Procurement Data System (FPDS) in accordance with FAR Subpart 4.6 , certain data will then pre-populate from FPDS, to assist contractors in completing and submitting their reports. If data originating from FPDS is found by the contractor to be in error when the contractor completes the subcontract report, the contractor should notify the Government contracting officer, who is responsible for correcting the data in FPDS. Contracts reported using the generic DUNS number allowed at FAR 4.605 (c)(2) will interfere with the contractor  s ability to comply with this reporting requirement, because the data will not pre-populate from FPDS.\n(c) If the contractor fails to comply with the reporting requirements, the contracting officer shall exercise appropriate contractual remedies. In addition, the contracting officer shall make the contractor  s failure to comply with the reporting requirements a part of the contractor  s performance information under Subpart 42.15 .\n(d) There is a reporting exception in 52.204-10 (g) for contractors and subcontractors who had gross income in the previous tax year under $300,000.\n4.1403 Contract clause.\n(a) The contracting officer shall insert the clause at 52.204-10 , Reporting Executive Compensation and First-Tier Subcontract Awards, in all solicitations and contracts of $25,000 or more.\n(b) The clause is not prescribed for contracts that are not required to be reported in the Federal Procurement Data System (FPDS) (see Subpart 4.6 ).");
register_book(&s, "|4|15|", "American Recovery and Reinvestment Act-", "Subpart 4.15  American Recovery and Reinvestment Act  Reporting Requirements\n4.1500 Scope of subpart.\nThis subpart implements section 1512(c) of Division A of the American Recovery and Reinvestment Act of 2009 (Pub. L. 111-5) (Recovery Act), which requires, as a condition of receipt of funds, quarterly reporting on the use of funds. The subpart also implements the data elements of the Federal Funding Accountability and Transparency Act of 2006, as amended (Pub. L. 109-282). Contractors that receive awards (or modifications to existing awards) funded, in whole or in part by the Recovery Act, must report information including, but not limited to  \n(a) The dollar amount of contractor invoices;\n(b) The supplies delivered and services performed;\n(c) An assessment of the completion status of the work;\n(d) An estimate of the number of jobs created and the number of jobs retained as a result of the Recovery Act funds;\n(e) Names and total compensation of each of the five most highly compensated officers for the calendar year in which the contract is awarded; and\n(f) Specific information on first-tier subcontractors.\n4.1501 Procedures.\n(a) In any contract action funded in whole or in part by the Recovery Act, the contracting officer shall indicate that the contract action is being made under the Recovery Act, and indicate which products or services are funded under the Recovery Act. This requirement applies whenever Recovery Act funds are used, regardless of the contract instrument.\n(b) To maximize transparency of Recovery Act funds that must be reported by the contractor, the contracting officer shall structure contract awards to allow for separately tracking Recovery Act funds. For example, the contracting officer may consider awarding dedicated separate contracts when using Recovery Act funds or establishing contract line item number (CLIN) structures to mitigate commingling of Recovery funds with other funds.\n(c) Contracting officers shall ensure that the contractor complies with the reporting requirements of 52.204-11 , American Recovery and Reinvestment Act  Reporting Requirements. If the contractor fails to comply with the reporting requirements, the contracting officer shall exercise appropriate contractual remedies.\n(d) The contracting officer shall make the contractor  s failure to comply with the reporting requirements a part of the contractor  s performance information under Subpart 42.15 .\n4.1502 Contract clause.\nInsert the clause at 52.204-11 , American Recovery and Reinvestment Act  Reporting Requirements in all solicitations and contracts funded in whole or in part with Recovery Act funds, except classified solicitations and contracts. This includes, but is not limited to, Governmentwide Acquisition Contracts (GWACs), multi-agency contracts (MACs), Federal Supply Schedule (FSS) contracts, or agency indefinite-delivery/indefinite-quantity (ID/IQ) contracts that will be funded with Recovery Act funds. Contracting officers shall include this clause in any existing contract or order that will be funded with Recovery Act funds. Contracting officers may not use Recovery Act funds on existing contracts and orders if the clause at 52.204-11 is not incorporated. This clause is not required for any existing contracts, or task and delivery orders issued under a contract, that contains the original clause FAR 52.204-11 (March 2009).\n*    *    *    *    *    *");
register_book(&s, "|4|16|", "Unique Procurement Instrument Identifie", "Subpart 4.16  Unique Procurement Instrument Identifiers\n4.1600 Scope of subpart.\nThis subpart prescribes policies and procedures for assigning unique Procurement Instrument Identifiers (PIID) for each solicitation, contract, agreement, or order and related procurement instrument.\n4.1601 Policy.\n(a) Procurement Instrument Identifier (PIID) . Agencies shall have in place a process that ensures that each PIID used to identify a solicitation or contract action is unique Governmentwide, and will remain so for at least 20 years from the date of contract award.\n(b) Agencies must submit their proposed identifier format to the General Services Administration  s Integrated Acquisition Environment Program Office, which maintains a registry of the agency-unique identifier schemes.\n(c) The PIID shall consist of alpha characters in the first positions to indicate the agency, followed by alpha-numeric characters according to agency procedures.\n(d) The PIID shall be used to identify all solicitation and contract actions. The PIID shall also be used to identify solicitation and contract actions in designated support and reporting systems ( e.g., Federal Procurement Data System, Past Performance Information Retrieval System), in accordance with regulations, applicable authorities, and agency policies and procedures.\n(e) Agencies shall not change the PIID, unless the conditions in paragraph (f) of this section exist.\n(f) If continued use of a PIID is not possible or is not in the Government  s best interest solely for administrative reasons ( e.g., for implementations of new agency contracting systems), the contracting officer may assign a new PIID by issuing a modification. The modification shall clearly identify both the original and the newly assigned PIID.\n4.1602 Identifying the PIID and supplementary PIID.\n(a) Identifying the PIID in solicitation and contract award documentation (including forms and electronic generated formats). Agencies shall include all PIIDs for all related procurement actions as identified in paragraphs (a)(1) through (a)(5) of this section.\n(1) Solicitation . Identify the PIID for all solicitations. For amendments to solicitations, identify a supplementary PIID, in conjunction with the PIID for the solicitation.\n(2) Contracts and purchase orders . Identify the PIID for contracts and purchase orders.\n(3) Delivery and task orders. For delivery and task orders placed by an agency under a contract ( e.g. , indefinite delivery indefinite quantity (IDIQ) contracts, multi-agency contracts (MAC), Governmentwide acquisition contracts (GWACs), or Multiple Award Schedule (MAS) contracts), identify the PIID for the delivery and task order and the PIID for the contract.\n(4) Blanket purchase agreements and basic ordering agreements. Identify the PIID for blanket purchase agreements issued in accordance with 13.303 , and for basic agreements and basic ordering agreements issued in accordance with subpart 16.7 . For blanket purchase agreements issued in accordance with subpart 8.4 under a MAS contract, identify the PIID for the blanket purchase agreement and the PIID for the MAS contract.\n(i) Orders . For orders against basic ordering agreements or blanket purchase agreements issued in accordance with 13.303 , identify the PIID for the order and the PIID for the blanket purchase agreement or basic ordering agreement.\n(ii) Orders under subpart 8.4 . For orders against a blanket purchase agreement established under a MAS contract, identify the PIID for the order, the PIID for the blanket purchase agreement, and the PIID for the MAS contract.\n(5) Modifications. For modifications to actions described in paragraphs (a)(2) through (a)(4) of this section, and in accordance with agency procedures, identify a supplementary PIID for the modification in conjunction with the PIID for the contract, order, or agreement being modified.\n(b) Placement of the PIID on forms. When the form (including electronic generated format) does not provide spaces or fields for the PIID or supplementary PIID required in paragraph (a) of this section, identify the PIID in accordance with agency procedures.\n(c) Additional agency specific identification information . If agency procedures require additional identification information in solicitations, contracts, or other related procurement instruments for administrative purposes, identify it in such a manner so as to separate it clearly from the PIID.");
register_book(&s, "|5|2|", "Synopses of Proposed Contract Actions", "Subpart 5.2  Synopses of Proposed Contract Actions\n5.201 General.\n(a) As required by the Small Business Act ( 15 U.S.C. 637(e) ) and the Office of Federal Procurement Policy Act ( 41 U.S.C. 416 ), agencies must make notices of proposed contract actions available as specified in paragraph (b) of this section.\n(b)(1) For acquisitions of supplies and services, other than those covered by the exceptions in 5.202 and the special situations in 5.205 , the contracting officer must transmit a notice to the GPE, for each proposed  \n(i) Contract action meeting the threshold in 5.101 (a)(1);\n(ii) Modification to an existing contract for additional supplies or services that meets the threshold in 5.101 (a)(1); or\n(iii) Contract action in any amount when advantageous to the Government.\n(2) When transmitting notices using electronic commerce, contracting officers must ensure the notice is forwarded to the GPE.\n(c) The primary purposes of the notice are to improve small business access to acquisition information and enhance competition by identifying contracting and subcontracting opportunities.\n(d) The GPE may be accessed via the Internet at http://www.fedbizopps.gov .\n5.202 Exceptions.\nThe contracting officer need not submit the notice required by 5.201 when  \n(a) The contracting officer determines that  \n(1) The synopsis cannot be worded to preclude disclosure of an agency  s needs and such disclosure would compromise the national security ( e.g., would result in disclosure of classified information). The fact that a proposed solicitation or contract action contains classified information, or that access to classified matter may be necessary to submit a proposal or perform the contract does not, in itself, justify use of this exception to synopsis;\n(2) The proposed contract action is made under the conditions described in 6.302-2 (or, for purchases conducted using simplified acquisition procedures, if unusual and compelling urgency precludes competition to the maximum extent practicable) and the Government would be seriously injured if the agency complies with the time periods specified in 5.203 ;\n(3) The proposed contract action is one for which either the written direction of a foreign government reimbursing the agency for the cost of the acquisition of the supplies or services for such government, or the terms of an international agreement or treaty between the United States and a foreign government, or international organizations, has the effect of requiring that the acquisition shall be from specified sources;\n(4) The proposed contract action is expressly authorized or required by a statute to be made through another Government agency, including acquisitions from the Small Business Administration (SBA) using the authority of section 8(a) of the Small Business Act (but see 5.205 (f)), or from a specific source such as a workshop for the blind under the rules of the Committee for the Purchase from the Blind and Other Severely Handicapped;\n(5) The proposed contract action is for utility services other than telecommunications services and only one source is available;\n(6) The proposed contract action is an order placed under subpart 16.5 . When the order contains brand-name specifications, see especially 16.505 (a)(4);\n(7) The proposed contract action results from acceptance of a proposal under the Small Business Innovation Development Act of 1982 (Pub. L. 97-219);\n(8) The proposed contract action results from the acceptance of an unsolicited research proposal that demonstrates a unique and innovative concept (see 2.101 ) and publication of any notice complying with 5.207 would improperly disclose the originality of thought or innovativeness of the proposed research, or would disclose proprietary information associated with the proposal. This exception does not apply if the proposed contract action results from an unsolicited research proposal and acceptance is based solely upon the unique capability of the source to perform the particular research services proposed (see 6.302-1 (a)(2)(i));\n(9) The proposed contract action is made for perishable subsistence supplies, and advance notice is not appropriate or reasonable;\n(10) The proposed contract action is made under conditions described in 6.302-3 , or 6.302-5 with regard to brand name commercial items for authorized resale, or 6.302-7 , and advance notice is not appropriate or reasonable;\n(11) The proposed contract action is made under the terms of an existing contract that was previously synopsized in sufficient detail to comply with the requirements of 5.207 with respect to the current proposed contract action;\n(12) The proposed contract action is by a Defense agency and the proposed contract action will be made and performed outside the United States and its outlying areas, and only local sources will be solicited. This exception does not apply to proposed contract actions covered by the World Trade Organization Government Procurement Agreement or a Free Trade Agreement (see Subpart 25.4 );\n(13) The proposed contract action  \n(i) Is for an amount not expected to exceed the simplified acquisition threshold;\n(ii) Will be made through a means that provides access to the notice of proposed contract action through the GPE; and\n(iii) Permits the public to respond to the solicitation electronically; or\n(14) The proposed contract action is made under conditions described in 6.302-3 with respect to the services of an expert to support the Federal Government in any current or anticipated litigation or dispute.\n(b) The head of the agency determines in writing, after consultation with the Administrator for Federal Procurement Policy and the Administrator of the Small Business Administration, that advance notice is not appropriate or reasonable.\n5.203 Publicizing and response time.\nWhenever agencies are required to publicize notice of proposed contract actions under 5.201 , they must proceed as follows:\n(a) An agency must transmit a notice of proposed contract action to the GPE (see 5.201 ). All publicizing and response times are calculated based on the date of publication. The publication date is the date the notice appears on the GPE. The notice must be published at least 15 days before issuance of a solicitation, or a proposed contract action the Government intends to solicit and negotiate with only one source under the authority of 6.302 , except that, for acquisitions of commercial items, the contracting officer may  \n(1) Establish a shorter period for issuance of the solicitation; or\n(2) Use the combined synopsis and solicitation procedure (see 12.603 ).\n(b) The contracting officer must establish a solicitation response time that will afford potential offerors a reasonable opportunity to respond to each proposed contract action, (including actions where the notice of proposed contract action and solicitation information is accessible through the GPE), in an amount estimated to be greater than $25,000, but not greater than the simplified acquisition threshold; or each contract action for the acquisition of commercial items in an amount estimated to be greater than $25,000. The contracting officer should consider the circumstances of the individual acquisition, such as the complexity, commerciality, availability, and urgency, when establishing the solicitation response time.\n(c) Except for the acquisition of commercial items (see 5.203 (b)), agencies shall allow at least a 30-day response time for receipt of bids or proposals from the date of issuance of a solicitation, if the proposed contract action is expected to exceed the simplified acquisition threshold.\n(d) Agencies shall allow at least a 30 day response time from the date of publication of a proper notice of intent to contract for architect-engineer services or before issuance of an order under a basic ordering agreement or similar arrangement if the proposed contract action is expected to exceed the simplified acquisition threshold.\n(e) Agencies must allow at least a 45-day response time for receipt of bids or proposals from the date of publication of the notice required in 5.201 for proposed contract actions categorized as research and development if the proposed contract action is expected to exceed the simplified acquisition threshold.\n(f) Nothing in this subpart prohibits officers or employees of agencies from responding to requests for information.\n(g) Contracting officers may, unless they have evidence to the contrary, presume the notice was published one day after transmission to the GPE. This presumption does not negate the mandatory waiting or response times specified in paragraphs (a) through (d) of this section. Upon learning that a particular notice has not in fact been published within the presumed timeframes, contracting officers should consider whether the date for receipt of offers can be extended or whether circumstances have become sufficiently compelling to justify proceeding with the proposed contract action under the authority of 5.202 (a)(2).\n(h) In addition to other requirements set forth in this section, for acquisitions covered by the World Trade Organization Government Procurement Agreement or a Free Trade Agreement (see Subpart 25.4 ), the period of time between publication of the synopsis notice and receipt of offers must be no less than 40 days. However, if the acquisition falls within a general category identified in an annual forecast, the availability of which is published, the contracting officer may reduce this time period to as few as 10 days.\n5.204 Presolicitation notices.\nContracting officers must provide access to presolicitation notices through the GPE (see 15.201 and 36.213-2 ). The contracting officer must synopsize a proposed contract action before issuing any resulting solicitation (see 5.201 and 5.203 ).\n5.205 Special situations.\n(a) Research and development (R&D) advance notices . Contracting officers may transmit to the GPE advance notices of their interest in potential R&D programs whenever market research does not produce a sufficient number of concerns to obtain adequate competition. Advance notices must not be used where security considerations prohibit such publication. Advance notices will enable potential sources to learn of R&D programs and provide these sources with an opportunity to submit information which will permit evaluation of their capabilities. Contracting officers must consider potential sources which respond to advance notices for a subsequent solicitation. Advanced notices must be entitled  Research and Development Sources Sought  and include the name and telephone number of the contracting officer or other contracting activity official from whom technical details of the project can be obtained. This will enable sources to submit information for evaluation of their R&D capabilities. Contracting officers must synopsize (see 5.201 ) all subsequent solicitations for R&D contracts, including those resulting from a previously synopsized advance notice, unless one of the exceptions in 5.202 applies.\n(b) Federally Funded Research and Development Centers . Before establishing a Federally Funded Research and Development Center (FFRDC) (see Part 35 ) or before changing its basic purpose and mission, the sponsor must transmit at least three notices over a 90-day period to the GPE and the Federal Register , indicating the agency  s intention to sponsor an FFRDC or change the basic purpose and mission of an FFRDC. The notice must indicate the scope and nature of the effort to be performed and request comments. Notice is not required where the action is required by law.\n(c) Special notices . Contracting officers may transmit to the GPE special notices of procurement matters such as business fairs, long-range procurement estimates, prebid or preproposal conferences, meetings, and the availability of draft solicitations or draft specifications for review.\n(d) Architect-engineering services . Contracting officers must publish notices of intent to contract for architect-engineering services as follows:\n(1) Except when exempted by 5.202 , contracting officers must transmit to the GPE a synopsis of each proposed contract action for which the total fee (including phases and options) is expected to exceed $25,000.\n(2) When the total fee is expected to exceed $15,000 but not exceed $25,000, the contracting officer must comply with 5.101 (a)(2). When the proposed contract action is not required to be synopsized under paragraph (d)(1) of this section, the contracting officer must display a notice of the solicitation or a copy of the solicitation in a public place at the contracting office. Other optional publicizing methods are authorized in accordance with 5.101 (b).\n(e) Public-private competitions under OMB Circular A-76.\n(1) The contracting officer shall make a formal public announcement for each streamlined or standard competition. The public announcement shall include, at a minimum, the agency, agency component, location, type of competition (streamlined or standard), activity being competed, incumbent service providers, number of Government personnel performing the activity, name of the Competitive Sourcing Official, name of the contracting officer, name of the Agency Tender Official, and projected end date of the competition.\n(2) The contracting officer shall announce the end of the streamlined or standard competition by making a formal public announcement of the performance decision. (See OMB Circular A-76.)\n(f) Section 8(a) competitive acquisition . When a national buy requirement is being considered for competitive acquisition limited to eligible 8(a) concerns under Subpart 19.8 , the contracting officer must transmit a synopsis of the proposed contract action to the GPE. The synopsis may be transmitted to the GPE concurrent with submission of the agency offering (see 19.804-2 ) to the Small Business Administration (SBA). The synopsis should also include information  \n(1) Advising that the acquisition is being offered for competition limited to eligible 8(a) concerns;\n(2) Specifying the North American Industry Classification System (NAICS) code;\n(3) Advising that eligibility to participate may be restricted to firms in either the developmental stage or the developmental and transitional stages; and\n(4) Encouraging interested 8(a) firms to request a copy of the solicitation as expeditiously as possible since the solicitation will be issued without further notice upon SBA acceptance of the requirement for the section 8(a) program.\n5.206 Notices of subcontracting opportunities.\n(a) The following entities may transmit a notice to the GPE to seek competition for subcontracts, to increase participation by qualified HUBZone small business, small, small disadvantaged, women-owned small business, veteran-owned small business and service-disabled veteran-owned small business concerns, and to meet established subcontracting plan goals:\n(1) A contractor awarded a contract exceeding $150,000 that is likely to result in the award of any subcontracts.\n(2) A subcontractor or supplier, at any tier, under a contract exceeding $150,000, that has a subcontracting opportunity exceeding $15,000.\n(b) The notices must describe  \n(1) The business opportunity;\n(2) Any prequalification requirements; and\n(3) Where to obtain technical data needed to respond to the requirement.\n5.207 Preparation and transmittal of synopses.\n(a) Content . Each synopsis transmitted to the GPE must address the following data elements, as applicable:\n(1) Action Code.\n(2) Date.\n(3) Year.\n(4) Contracting Office ZIP Code.\n(5) Classification Code.\n(6) Contracting Office Address.\n(7) Subject.\n(8) Proposed Solicitation Number.\n(9) Closing Response Date.\n(10) Contact Point or Contracting Officer.\n(11) Contract Award and Solicitation Number.\n(12) Contract Award Dollar Amount.\n(13) Contract Line Item Number.\n(14) Contract Award Date.\n(15) Contractor.\n(16) Description.\n(17) Place of Contract Performance.\n(18) Set-aside Status.\n(b) Transmittal . Transmissions to the GPE must be in accordance with the interface description available via the Internet at http://www.fedbizopps.gov .\n(c) General format for  Description .  Prepare a clear and concise description of the supplies or services that is not unnecessarily restrictive of competition and will allow a prospective offeror to make an informed business judgment as to whether a copy of the solicitation should be requested including the following, as appropriate:\n(1) National Stock Number (NSN) if assigned.\n(2) Specification and whether an offeror, its product, or service must meet a qualification requirement in order to be eligible for award, and identification of the office from which additional information about the qualification requirement may be obtained (see Subpart 9.2 ).\n(3) Manufacturer, including part number, drawing number, etc.\n(4) Size, dimensions, or other form, fit or functional description.\n(5) Predominant material of manufacture.\n(6) Quantity, including any options for additional quantities.\n(7) Unit of issue.\n(8) Destination information.\n(9) Delivery schedule.\n(10) Duration of the contract period.\n(11) Sustainable acquisition requirements (or a description of high-performance sustainable building practices required, if for design, construction, renovation, repair, or deconstruction) (see parts 23 or 36 ).\n(12) For a proposed contract action in an amount estimated to be greater than $25,000 but not greater than the simplified acquisition threshold, enter  \n(i) A description of the procedures to be used in awarding the contract ( e.g., request for oral or written quotation or solicitation); and\n(ii) The anticipated award date.\n(13) For Architect-Engineer projects and other projects for which the supply or service codes are insufficient, provide brief details with respect to: location, scope of services required, cost range and limitations, type of contract, estimated starting and completion dates, and any significant evaluation factors.\n(14)(i) If the solicitation will include the FAR clause at 52.225-3 , Buy American Act  Free Trade Agreements  Israeli Trade Act, or an equivalent agency clause, insert the following notice in the synopsis:  One or more of the items under this acquisition is subject to Free Trade Agreements.  \n(ii) If the solicitation will include the FAR clause at 52.225-5 , Trade Agreements, or an equivalent agency clause, insert the following notice in the synopsis:  One or more of the items under this acquisition is subject to the World Trade Organization Government Procurement Agreement and Free Trade Agreements.  \n(iii) If the solicitation will include the FAR clause at 52.225-11 , Buy American Act  Construction Materials Under Trade Agreements, 52.225-23 , Required Use of American Iron, Steel, and Manufactured Goods  Buy American Act  Construction Materials Under Trade Agreements, or an equivalent agency clause, insert the following notice in the synopsis:  One or more of the items under this acquisition is subject to the World Trade Organization Government Procurement Agreement and Free Trade Agreements.  \n(15) In the case of noncompetitive contract actions (including those that do not exceed the simplified acquisition threshold), identify the intended source and insert a statement of the reason justifying the lack of competition.\n(16)(i) Except when using the sole source authority at 6.302-1 , insert a statement that all responsible sources may submit a bid, proposal, or quotation which shall be considered by the agency.\n(ii) When using the sole source authority at 6.302-1 , insert a statement that all responsible sources may submit a capability statement, proposal, or quotation, which shall be considered by the agency.\n(17) If solicitations synopsized through the GPE will not be made available through the GPE, provide information on how to obtain the solicitation.\n(18) If the solicitation will be made available to interested parties through electronic data interchange, provide any information necessary to obtain and respond to the solicitation electronically.\n(19) If the technical data required to respond to the solicitation will not be furnished as part of such solicitation, identify the source in the Government, such as http://www.fedbizopps.gov/ , from which the technical data may be obtained.\n(d) Set-asides . When the proposed acquisition provides for a total or partial small business program set-aside, or when the proposed acquisition provides for a local area set-aside (see Subpart 26.2 ), the contracting officer shall identify the type of set-aside in the synopsis and in the solicitation.\n(e) Codes to be used in Synopses to identify services or supplies . Contracting officers must use one of the classification codes identified at http://www.fedbizopps.gov/ to identify services or supplies in synopses.\n(f) Notice of solicitation cancellation . Contracting officers may publish notices of solicitation cancellations (or indefinite suspensions) of proposed contract actions in the GPE.");
register_book(&s, "|5|3|", "Synopses of Contract Awards", "Subpart 5.3  Synopses of Contract Awards\n5.301 General.\n(a) Except for contract actions described in paragraph (b) of this section and as provided in 5.003 , contracting officers must synopsize through the GPE the following:\n(1) Contract awards exceeding $25,000 that are  \n(i) Covered by the World Trade Organization Government Procurement Agreement or a Free Trade Agreement (see subpart 25.4 ); or\n(ii) Likely to result in the award of any subcontracts. However, the dollar threshold is not a prohibition against publicizing an award of a smaller amount when publicizing would be advantageous to industry or to the Government.\n(2) Certain contract actions greater than the simplified acquisition threshold as follows  \n(i) Federal Supply Schedule (FSS) orders or Blanket Purchase Agreements supported by a limited-source justification (excluding brand name) in accordance with 8.405-6 ; or\n(ii) Task or delivery orders awarded without providing fair opportunity in accordance with 16.505 (b)(2).\n(3) A notice is not required under this section if the notice would disclose the executive agency  s needs and the disclosure of such needs would compromise the national security. \n(b) A notice is not required under paragraph (a)(1) of this section if  \n(1) The award results from acceptance of an unsolicited research proposal that demonstrates a unique and innovative research concept and publication of any notice would disclose the originality of thought or innovativeness of the proposed research or would disclose proprietary information associated with the proposal;\n(2) The award results from a proposal submitted under the Small Business Innovation Development Act of 1982 (Pub. L. 97-219);\n(3) The contract action is an order placed under subpart 16.5 or 8.4 , except see paragraph (a)(2) of this section; \n(4) The award is made for perishable subsistence supplies;\n(5) The award is for utility services, other than telecommunications services, and only one source is available;\n(6) The contract action  \n(i) Is for an amount not greater than the simplified acquisition threshold;\n(ii) Was made through a means where access to the notice of proposed contract action was provided through the GPE; and\n(iii) Permitted the public to respond to the solicitation electronically; or\n(7) The award is for the services of an expert to support the Federal Government in any current or anticipated litigation or dispute pursuant to the exception to full and open competition authorized at 6.302-3 .\n(c) With respect to acquisitions covered by the World Trade Organization Government Procurement Agreement or a Free Trade Agreement, contracting officers must submit synopses in sufficient time to permit their publication in the GPE not later than 60 days after award.\n(d) Posting is required of the justifications for  \n(1) Contracts awarded using other than full and open competition in accordance with 6.305 ;\n(2) FSS orders or Blanket Purchase Agreements with an estimated value greater than the simplified acquisition threshold and supported by a limited-sources justification (see 8.405-6 (a)); or\n(3) Task or delivery orders greater than the simplified acquisition threshold and awarded without providing for fair opportunity in accordance with 16.505 (b)(2)(ii)(B) and (D).\n5.302 Preparation and transmittal of synopses of awards.\nContracting officers shall transmit synopses of contract awards in the same manner as prescribed in 5.207 .\n5.303 Announcement of contract awards.\n(a) Public announcement . Contracting officers shall make information available on awards over $4 million (unless another dollar amount is specified in agency acquisition regulations) in sufficient time for the agency concerned to announce it by 5 p.m. Washington, DC, time on the day of award. Agencies shall not release information on awards before the public release time of 5 p.m. Washington, DC time. Contracts excluded from this reporting requirement include  \n(1) Those placed with the Small Business Administration under Section 8(a) of the Small Business Act;\n(2) Those placed with foreign firms when the place of delivery or performance is outside the United States and its outlying areas; and\n(3) Those for which synopsis was exempted under 5.202 (a)(1).\n(b) Local announcement . Agencies may also release information on contract awards to the local press or other media. When local announcements are made for contract awards in excess of the simplified acquisition threshold, they shall include  \n(1) For awards after sealed bidding, a statement that the contract was awarded after competition by sealed bidding, the number of offers solicited and received, and the basis for selection ( e.g., the lowest responsible bidder); or\n(2) For awards after negotiation, the information prescribed by 15.503 (b), and after competitive negotiation (either price or design competition), a statement to this effect, and in general terms the basis for selection.");
register_book(&s, "|5|4|", "Release of Information", "Subpart 5.4  Release of Information\n5.401 General.\n(a) A high level of business security must be maintained in order to preserve the integrity of the acquisition process. When it is necessary to obtain information from potential contractors and others outside the Government for use in preparing Government estimates, contracting officers shall ensure that the information is not publicized or discussed with potential contractors.\n(b) Contracting officers may make available maximum information to the public, except information  \n(1) On plans that would provide undue or discriminatory advantage to private or personal interests;\n(2) Received in confidence from an offeror;\n(3) Otherwise requiring protection under Freedom of Information Act (see Subpart 24.2 ) or Privacy Act (see Subpart 24.1 ); or\n(4) Pertaining to internal agency communications ( e.g., technical reviews, contracting authority or other reasons, or recommendations referring thereto).\n(c) This policy applies to all Government personnel who participate directly or indirectly in any stage of the acquisition cycle.\n5.402 General public.\nContracting officers shall process requests for specific information from the general public, including suppliers, in accordance with Subpart 24.1 or 24.2 , as appropriate.\n5.403 Requests from Members of Congress.\nContracting officers shall give Members of Congress, upon their request, detailed information regarding any particular contract. When responsiveness would result in disclosure of classified matter, business confidential information, or information prejudicial to competitive acquisition, the contracting officer shall refer the proposed reply, with full documentation, to the agency head and inform the legislative liaison office of the action.\n5.404 Release of long-range acquisition estimates.\nTo assist industry planning and to locate additional sources of supply, it may be desirable to publicize estimates of unclassified long-range acquisition requirements. Estimates may be publicized as far in advance as possible.\n5.404-1 Release procedures.\n(a) Application . The agency head, or a designee, may release long-range acquisition estimates if the information will  \n(1) Assist industry in its planning and facilitate meeting the acquisition requirements;\n(2) Not encourage undesirable practices ( e.g., attempts to corner the market or hoard industrial materials); and\n(3) Not indicate the existing or potential mobilization of the industry as a whole.\n(b) Conditions . The agency head shall ensure that  \n(1) Classified information is released through existing security channels in accordance with agency security regulations;\n(2) The information is publicized as widely as practicable to all parties simultaneously by any of the means described in this part;\n(3) Each release states that  \n(i) The estimate is based on the best information available,\n(ii) The information is subject to modification and is in no way binding on the Government, and\n(iii) More specific information relating to any individual item or class of items will not be furnished until the proposed action is synopsized through the GPE or the solicitation is issued;\n(4) Each release contains the name and address of the contracting officer that will process the acquisition;\n(5) Modifications to the original release are publicized as soon as possible, in the same manner as the original; and\n(6) Each release  \n(i) Is coordinated in advance with small business, public information, and public relations personnel, as appropriate;\n(ii) Contains, if applicable, a statement that small business set-asides may be involved, but that a determination can be made only when acquisition action is initiated; and\n(iii) Contains the name or description of the item, and the estimated quantity to be acquired by calendar quarter, fiscal year, or other period. It may also contain such additional information as the number of units last acquired, the unit price, and the name of the last supplier.\n5.404-2 Announcements of long-range acquisition estimates.\nFurther publicizing, consistent with the needs of the individual case, may be accomplished by announcing through the GPE that long-range acquisition estimates have been published and are obtainable, upon request, from the contracting officer.\n5.405 Exchange of acquisition information.\n(a) When the same item or class of items is being acquired by more than one agency, or by more than one contracting activity within an agency, the exchange and coordination of pertinent information, particularly cost and pricing data, between these agencies or contracting activities is necessary to promote uniformity of treatment of major issues and the resolution of particularly difficult or controversial issues. The exchange and coordination of information is particularly beneficial during the period of acquisition planning, presolicitation, evaluation, and pre-award survey.\n(b) When substantial acquisitions of major items are involved or when the contracting activity deems it desirable, the contracting activity shall request appropriate information (on both the end item and on major subcontracted components) from other agencies or contracting activities responsible for acquiring similar items. Each agency or contracting activity receiving such a request shall furnish the information requested. The contracting officer, early in a negotiation of a contract, or in connection with the review of a subcontract, shall request the contractor to furnish information as to the contractor  s or subcontractor  s previous Government contracts and subcontracts for the same or similar end items and major subcontractor components.\n5.406 Public disclosure of justification documents for certain contract actions.\n(a) Justifications and approvals for other than full and open competition must be posted in accordance with 6.305 .\n(b) Limited-source justifications (excluding brand name) for FSS orders or blanket purchase agreements with an estimated value greater than the simplified acquisition threshold must be posted in accordance with 8.405-6 (a)(2).\n(c) Justifications for task or delivery orders greater than the simplified acquisition threshold and awarded without providing for fair opportunity must be posted in accordance with 16.505 (b)(2)(ii)(D).");
register_book(&s, "|5|5|", "Paid Advertisements", "Subpart 5.5  Paid Advertisements\n5.501 Definitions.\nAs used in this subpart  \nAdvertisement  means any single message prepared for placement in communication media, regardless of the number of placements.\nPublication  means  \n(1) The placement of an advertisement in a newspaper, magazine, trade or professional journal, or any other printed medium; or\n(2) The broadcasting of an advertisement over radio or television.\n5.502 Authority.\n(a) Newspapers. Authority to approve the publication of paid advertisements in newspapers is vested in the head of each agency ( 44 U.S.C. 3702 ). This approval authority may be delegated ( 5 U.S.C. 302(b) ). Contracting officers shall obtain written authorization in accordance with policy procedures before advertising in newspapers.\n(b) Other media. Unless the agency head determines otherwise, advance written authorization is not required to place advertisements in media other than newspapers.\n5.503 Procedures.\n(a) General.\n(1) Orders for paid advertisements may be placed directly with the media or through an advertising agency. Contracting officers shall give small, small disadvantaged, women-owned, veteran-owned, HUBZone, and service-disabled veteran-owned small business concerns maximum opportunity to participate in these acquisitions.\n(2) The contracting officer shall use the SF 1449 for paper solicitations. The SF 1449 shall be used to make awards or place orders unless the award/order is made by using electronic commerce or by using the Governmentwide commercial purchase card for micropurchases.\n(b) Rates. Advertisements may be paid for at rates not over the commercial rates charged private individuals, with the usual discounts ( 44 U.S.C. 3703 ).\n(c) Proof of advertising. Every invoice for advertising shall be accompanied by a copy of the advertisement or an affidavit of publication furnished by the publisher, radio or television station, or advertising agency concerned ( 44 U.S.C. 3703 ). Paying offices shall retain the proof of advertising until the Government Accountability Office settles the paying office  s account.\n(d) Payment. Upon receipt of an invoice supported by proof of advertising, the contracting officer shall attach a copy of the written authority (see 5.502 (a)) and submit the invoice for payment under agency procedures.\n5.504 Use of advertising agencies.\n(a) General. Basic ordering agreements may be placed with advertising agencies for assistance in producing and placing advertisements when a significant number will be placed in several publications and in national media. Services of advertising agencies include, but are not limited to, counseling as to selection of the media for placement of the advertisement, contacting the media in the interest of the Government, placing orders, selecting and ordering typography, copywriting, and preparing rough layouts.\n(b) Use of commission-paying media. The services of advertising agencies in placing advertising with media often can be obtained at no cost to the Government, over and above the space cost, as many media give advertising agencies a commission or discount on the space cost that is not given to the Government.\n(c) Use of noncommission-paying media. Some media do not grant advertising agencies a commission or discount, meaning the Government can obtain the same rate as the advertising agency. If the advertising agency agrees to place advertisements in noncommission-paying media as a no-cost service, the basic ordering agreement shall so provide. If the advertising agency will not agree to place advertisements at no cost, the agreement shall  \n(1) Provide that the Government may place orders directly with the media; or\n(2) Specify an amount that the Government will pay if the agency places the orders.\n(d) Art work, supplies, and incidentals. The basic ordering agreement also may provide for the furnishing by the advertising agency of art work, supplies, and incidentals, including brochures and pamphlets, but not their printing.  Incidentals  may include telephone calls, telegrams, and postage incurred by the advertising agency on behalf of the Government.");
register_book(&s, "|5|6|", "Publicizing Multi-Agency Use Contracts", "Subpart 5.6  Publicizing Multi-Agency Use Contracts\n5.601 Governmentwide database of contracts.\n(a) A Governmentwide database of contracts and other procurement instruments intended for use by multiple agencies is available via the Internet at https://www.contractdirectory.gov/contractdirectory/ . This searchable database is a tool that may be used to identify existing contracts and other procurement instruments that may be used to fulfill Government needs.\n(b) The contracting activity shall  \n(1) Enter the information specified at https://www.contractdirectory.gov/contractdirectory/ , in accordance with the instructions on that web site, within ten days of award of a Governmentwide acquisition contract (GWAC), multi-agency contract, Federal Supply Schedule contract, or any other procurement instrument intended for use by multiple agencies, including blanket purchase agreements (BPAs) under Federal Supply Schedule contracts.\n(2) Enter the information specified at https://www.contractdirectory.gov/contractdirectory/ in accordance with the instructions on that web site by October 31, 2003, for all contracts and other procurement instruments intended for use by multiple agencies that were awarded before July 24, 2003.");
register_book(&s, "|5|7|", "Publicizing Requirements Under the Amer", "Subpart 5.7  Publicizing Requirements Under the American Recovery and Reinvestment Act of 2009 \n5.701 Scope.\nThis subpart prescribes posting requirements for presolicitation and award notices for actions funded in whole or in part by the American Recovery and Reinvestment Act of 2009 (Pub. L. 111-5) (Recovery Act). The requirements of this subpart enhance transparency to the public.\n5.702 Applicability.\nThis subpart applies to all actions expected to exceed $25,000 funded in whole or in part by the Recovery Act. Unlike subparts 5.2 and 5.3 , this subpart includes additional requirements for orders and for actions that are not both fixed-price and competitive.\n5.703 Definition.\nAs used in this subpart  \nTask or delivery order contract  means a  delivery order contract,  and a  task order contract,  as defined in 16.501-1 . For example, it includes Governmentwide Acquisition Contracts (GWACs), multi-agency contracts (MACs), and other indefinite-delivery/indefinite-quantity contracts, whether single award or multiple award. It also includes Federal Supply Schedule contracts (including Blanket Purchase Agreements under Subpart 8.4 ).\n5.704 Publicizing preaward.\n(a)(1) Follow the publication procedures at 5.201 .\n(2) In addition, notices of proposed contract actions are required for orders exceeding $25,000, funded in whole or in part by the Recovery Act, which are issued under task or delivery order contracts. This does not include modifications to existing orders, but these modifications are covered postaward, see 5.705 . These notices are for  informational purposes only,  therefore, 5.203 does not apply. Contracting officers should concurrently use their usual solicitation practice ( e.g. , e-Buy).\n(b) Contracting officers shall identify proposed contract actions, funded in whole or in part by the Recovery Act, by using the following instructions which are also available in the Recovery FAQs under  Buyers/Engineers  at the Governmentwide Point of Entry (GPE) ( https://www.fedbizopps.gov ):\n(1) If submitting notices electronically via ftp or email, enter the word  Recovery  as the first word in the title field. \n(2) If using the GPE directly, select the  yes  radio button for the  Is this a Recovery and Reinvestment Act action  field on the  Notice Details  form (Step 2) located below the  NAICS Code  field. In addition, enter the word  Recovery  as the first word in the title field.\n(c) In preparing the description required by 5.207 (a)(16), use clear and concise language to describe the planned procurement. Use descriptions of the goods and services (including construction), that can be understood by the general public. Avoid the use of acronyms or terminology that is not widely understood by the general public.\n5.705 Publicizing postaward.\nFollow usual publication procedures at 5.301 , except that the following supersede the exceptions at 5.301 (b)(2) through (7):\n(a)(1) Publicize the award notice for any action exceeding $500,000, funded in whole or in part by the Recovery Act, including  \n(i) Contracts; \n(ii) Modifications to existing contracts;\n(iii) Orders which are issued under task or delivery order contracts; and\n(iv) Modifications to orders under task or delivery order contracts.\n(2) Contracting officers shall identify contract actions, funded in whole or in part by the Recovery Act, by using the following instructions which are also available in the Recovery FAQS under  Buyers/Engineers  at the Governmentwide Point of Entry (GPE) ( https://www.fedbizopps.gov ):\n(i) If submitting notices electronically via ftp or email, enter the word  Recovery  as the first word in the title field.\n(ii) If using the GPE directly, select the  yes  radio button for the  Is this a Recovery and Reinvestment Act action  field on the  Notice Details  form (Step 2) located below the  NAICS Code  field. In addition, enter the word  Recovery  as the first word in the title field.\n(3) In preparing the description required by 5.207 (a)(16), use clear and concise language to describe the planned procurement. Use descriptions of the goods and services (including construction), that can be understood by the general public. Avoid the use of acronyms or terminology that is not widely understood by the general public.\n(b) Regardless of dollar value, if the contract action, including all modifications and orders under task or delivery order contracts, is not both fixed-price and competitively awarded, publicize the award notice and include in the description the rationale for using other than a fixed-priced and/or competitive approach. Include in the description a statement specifically noting if the contract action was not awarded competitively, or was not fixed-price, or was neither competitive nor fixed-price. These notices and the rationale will be available to the public at the GPE, so do not include any proprietary information or information that would compromise national security. The following table provides examples for when a rationale is required.\nPosting of Rationale - Examples\nDescription of Contract Action	\nRationale Required\n(1)	\nA contract is competitively awarded and is fixed-price.\nNot Required.\n(2)	\nA contract is awarded that is not fixed-price.\nRequired.\n(3)	\nA contract is awarded without competition.\nRequired.\n(4)	\nAn order is issued under a new or existing single award IDIQ contract.\nRequired if order is made under a contract described in (2) or (3).\n(5)	\nAn order is issued under a new or existing multiple award IDIQ contract.\nRequired if one or both of the following conditions exist:\n(i) The order is not fixed-price.\n(ii) The order is awarded pursuant to an exception to the competition requirements applicable to the underlying vehicle ( e.g. , award is made pursuant to an exception to the fair opportunity process).\n(6)	\nA modification is issued.\nRequired if modification is made  \n(i) To a contract  described in (2) or (3) above; or\n(ii) To an order requiring posting as described in (4) or (5) above.\n(7)	\nA contract or order is awarded pursuant to a small business contracting authority ( e.g. , SBA  s section 8(a) program).\nRequired if one or both of the following conditions exist:\n(i) the contract or order is not fixed-price;\n(ii) the contract or order was not awarded using competition ( e.g. , a non-competitive 8(a) award).\n(c) Contracting officers shall use the instructions available in the Recovery FAQs under  Buyers/Engineers  at the GPE ( https://www.fedbizopps.gov ) to identify actions funded in whole or in part by the Recovery Act.\n*    *    *    *    *    *");
register_book(&s, "|6|2|", "Full and Open Competition After Exclusi", "Subpart 6.2  Full and Open Competition After Exclusion of Sources\n6.200 Scope of subpart.\nThis subpart prescribes policy and procedures for providing for full and open competition after excluding one or more sources.\n6.201 Policy.\nAcquisitions made under this subpart require use of the competitive procedures prescribed in 6.102 .\n6.202 Establishing or maintaining alternative sources.\n(a) Agencies may exclude a particular source from a contract action in order to establish or maintain an alternative source or sources for the supplies or services being acquired if the agency head determines that to do so would  \n(1) Increase or maintain competition and likely result in reduced overall costs for the acquisition, or for any anticipated acquisition;\n(2) Be in the interest of national defense in having a facility (or a producer, manufacturer, or other supplier) available for furnishing the supplies or services in case of a national emergency or industrial mobilization;\n(3) Be in the interest of national defense in establishing or maintaining an essential engineering, research, or development capability to be provided by an educational or other nonprofit institution or a federally funded research and development center;\n(4) Ensure the continuous availability of a reliable source of supplies or services;\n(5) Satisfy projected needs based on a history of high demand; or\n(6) Satisfy a critical need for medical, safety, or emergency supplies.\n(b)(1) Every proposed contract action under the authority of paragraph (a) of this section shall be supported by a determination and findings (D&F) (see Subpart 1.7 ) signed by the head of the agency or designee. This D&F shall not be made on a class basis.\n(2) Technical and requirements personnel are responsible for providing all necessary data to support their recommendation to exclude a particular source.\n(3) When the authority in paragraph (a)(1) of this section is cited, the findings shall include a description of the estimated reduction in overall costs and how the estimate was derived.\n6.203 Set-asides for small business concerns.\n(a) To fulfill the statutory requirements relating to small business concerns, contracting officers may set aside solicitations to allow only such business concerns to compete. This includes contract actions conducted under the Small Business Innovation Research Program established under Pub. L. 97-219.\n(b) No separate justification or determination and findings is required under this part to set aside a contract action for small business concerns.\n(c) Subpart 19.5 prescribes policies and procedures that shall be followed with respect to set-asides.\n6.204 Section 8(a) competition.\n(a) To fulfill statutory requirements relating to section 8(a) of the Small Business Act, as amended by Pub. L. 100-656, contracting officers may limit competition to eligible 8(a) contractors (see Subpart 19.8 ).\n(b) No separate justification or determination and findings is required under this part to limit competition to eligible 8(a) contractors. (But see 6.302-5 and 6.303-1 for sole source 8(a) awards over $20 million.)\n6.205 Set-asides for HUBZone small business concerns.\n(a) To fulfill the statutory requirements relating to the HUBZone Act of 1997 ( 15 U.S.C. 631 note), contracting officers in participating agencies (see 19.1302 ) may set aside solicitations to allow only qualified HUBZone small business concerns to compete (see 19.1305 ).\n(b) No separate justification or determination and findings is required under this part to set aside a contract action for qualified HUBZone small business concerns.\n6.206 Set-asides for service-disabled veteran-owned small business concerns.\n(a) To fulfill the statutory requirements relating to the Veterans Benefits Act of 2003 ( 15 U.S.C. 657f ), contracting officers may set-aside solicitations to allow only service-disabled veteran-owned small business concerns to compete (see 19.1405 ).\n(b) No separate justification or determination and findings are required under this part to set aside a contract action for service-disabled veteran-owned small business concerns.\n6.207 Set-asides for economically disadvantaged women-owned small business (EDWOSB) concerns or women-owned small business (WOSB) concerns eligible under the WOSB Program.\n(a) To fulfill the statutory requirements relating to 15 U.S.C. 637 (m), contracting officers may set aside solicitations for only EDWOSB concerns or WOSB concerns eligible under the WOSB Program (see 19.1505 ).\n(b) No separate justification or determination and findings is required under this part to set aside a contract action for EDWOSB concerns or WOSB concerns eligible under the WOSB Program.\n6.208 Set-asides for local firms during a major disaster or emergency. \n(a) To fulfill the statutory requirements relating to 42 U.S.C. 5150 , contracting officers may set aside solicitations to allow only offerors residing or doing business primarily in the area affected by such major disaster or emergency to compete (see Subpart 26.2 ).\n(b) No separate justification or determination and findings is required under this part to set aside a contract action. The set-aside area specified by the contracting officer shall be a geographic area within the area identified in a Presidential declaration(s) of major disaster or emergency and any additional geographic areas identified by the Department of Homeland Security.");
register_book(&s, "|6|3|", "Other Than Full and Open Competition", "Subpart 6.3  Other Than Full and Open Competition\n6.300 Scope of subpart.\nThis subpart prescribes policies and procedures, and identifies the statutory authorities, for contracting without providing for full and open competition.\n6.301 Policy.\n(a) 41 U.S.C. 253(c) and 10 U.S.C. 2304(c) each authorize, under certain conditions, contracting without providing for full and open competition. The Department of Defense, Coast Guard, and National Aeronautics and Space Administration are subject to 10 U.S.C. 2304(c) . Other executive agencies are subject to 41 U.S.C. 253(c) . Contracting without providing for full and open competition or full and open competition after exclusion of sources is a violation of statute, unless permitted by one of the exceptions in 6.302 .\n(b) Each contract awarded without providing for full and open competition shall contain a reference to the specific authority under which it was so awarded. Contracting officers shall use the U.S. Code citation applicable to their agency (see 6.302 ).\n(c) Contracting without providing for full and open competition shall not be justified on the basis of  \n(1) A lack of advance planning by the requiring activity; or\n(2) Concerns related to the amount of funds available ( e.g., funds will expire) to the agency or activity for the acquisition of supplies or services.\n(d) When not providing for full and open competition, the contracting officer shall solicit offers from as many potential sources as is practicable under the circumstances.\n(e) For contracts under this subpart, the contracting officer shall use the contracting procedures prescribed in 6.102 (a) or (b), if appropriate, or any other procedures authorized by this regulation.\n6.302 Circumstances permitting other than full and open competition.\nThe following statutory authorities (including applications and limitations) permit contracting without providing for full and open competition. Requirements for justifications to support the use of these authorities are in 6.303 .\n6.302-1 Only one responsible source and no other supplies or services will satisfy agency requirements.\n(a) Authority.\n(1) Citations: 10 U.S.C. 2304(c)(1) or 41 U.S.C. 253(c)(1) .\n(2) When the supplies or services required by the agency are available from only one responsible source, or, for DoD, NASA, and the Coast Guard, from only one or a limited number of responsible sources, and no other type of supplies or services will satisfy agency requirements, full and open competition need not be provided for.\n(i) Supplies or services may be considered to be available from only one source if the source has submitted an unsolicited research proposal that  \n(A) Demonstrates a unique and innovative concept (see definition at 2.101 ), or, demonstrates a unique capability of the source to provide the particular research services proposed;\n(B) Offers a concept or services not otherwise available to the Government; and\n(C) Does not resemble the substance of a pending competitive acquisition. (See 10 U.S.C. 2304(d)(1)(A) and 41 U.S.C. 253(d)(1)(A) .)\n(ii) Supplies may be deemed to be available only from the original source in the case of a follow-on contract for the continued development or production of a major system or highly specialized equipment, including major components thereof, when it is likely that award to any other source would result in  \n(A) Substantial duplication of cost to the Government that is not expected to be recovered through competition; or\n(B) Unacceptable delays in fulfilling the agency  s requirements. (See 10 U.S.C. 2304(d)(1)(B) or 41 U.S.C. 253 (d)(1)(B) .)\n(iii) For DoD, NASA, and the Coast Guard, services may be deemed to be available only from the original source in the case of follow-on contracts for the continued provision of highly specialized services when it is likely that award to any other source would result in  \n(A) Substantial duplication of cost to the Government that is not expected to be recovered through competition; or\n(B) Unacceptable delays in fulfilling the agency  s requirements. (See 10 U.S.C. 2304(d)(1)(B) .)\n(b) Application . This authority shall be used, if appropriate, in preference to the authority in 6.302-7 ; it shall not be used when any of the other circumstances is applicable. Use of this authority may be appropriate in situations such as the following (these examples are not intended to be all inclusive and do not constitute authority in and of themselves):\n(1) When there is a reasonable basis to conclude that the agency  s minimum needs can only be satisfied by  \n(i) Unique supplies or services available from only one source or only one supplier with unique capabilities; or\n(ii) For DoD, NASA, and the Coast Guard, unique supplies or services available from only one or a limited number of sources or from only one or a limited number of suppliers with unique capabilities.\n(2) The existence of limited rights in data, patent rights, copyrights, or secret processes; the control of basic raw material; or similar circumstances, make the supplies and services available from only one source (however, the mere existence of such rights or circumstances does not in and of itself justify the use of these authorities) (see Part 27 ).\n(3) When acquiring utility services (see 41.101 ), circumstances may dictate that only one supplier can furnish the service (see 41.202 ); or when the contemplated contract is for construction of a part of a utility system and the utility company itself is the only source available to work on the system.\n(4) When the agency head has determined in accordance with the agency  s standardization program that only specified makes and models of technical equipment and parts will satisfy the agency  s needs for additional units or replacement items, and only one source is available.\n(c) Application for brand-name descriptions. \n(1) An acquisition or portion of an acquisition that uses a brand-name description or other purchase description to specify a particular brand-name, product, or feature of a product, peculiar to one manufacturer  \n(i) Does not provide for full and open competition, regardless of the number of sources solicited; and\n(ii) Shall be justified and approved in accordance with 6.303 and 6.304 .\n(A) If only a portion of the acquisition is for a brand-name product or item peculiar to one manufacturer, the justification and approval is to cover only the portion of the acquisition which is brand-name or peculiar to one manufacturer. The justification should state it is covering only the portion of the acquisition which is brand-name or peculiar to one manufacturer, and the approval level requirements will then only apply to that portion;\n(B) The justification should indicate that the use of such descriptions in the acquisition or portion of an acquisition is essential to the Government  s requirements, thereby precluding consideration of a product manufactured by another company; and\n(C) The justification shall be posted with the solicitation (see 5.102 (a)(6)).\n(2) Brand-name or equal descriptions, and other purchase descriptions that permit prospective contractors to offer products other than those specifically referenced by brand-name, provide for full and open competition and do not require justifications and approvals to support their use.\n(d) Limitations.\n(1) Contracts awarded using this authority shall be supported by the written justifications and approvals described in 6.303 and 6.304 .\n(2) For contracts awarded using this authority, the notices required by 5.201 shall have been published and any bids, proposals, quotations, or capability statements must have been considered.\n6.302-2 Unusual and compelling urgency.\n(a) Authority.\n(1) Citations: 10 U.S.C. 2304(c)(2) or 41 U.S.C. 253(c)(2) .\n(2) When the agency  s need for the supplies or services is of such an unusual and compelling urgency that the Government would be seriously injured unless the agency is permitted to limit the number of sources from which it solicits bids or proposals, full and open competition need not be provided for.\n(b) Application . This authority applies in those situations where  \n(1) An unusual and compelling urgency precludes full and open competition; and\n(2) Delay in award of a contract would result in serious injury, financial or other, to the Government.\n(c) Limitations.\n(1) Contracts awarded using this authority shall be supported by the written justifications and approvals described in 6.303 and 6.304 . These justifications may be made and approved after contract award when preparation and approval prior to award would unreasonably delay the acquisition.\n(2) This statutory authority requires that agencies shall request offers from as many potential sources as is practicable under the circumstances.\n(d) Period of Performance. \n(1) The total period of performance of a contract awarded using this authority  \n(i) May not exceed the time necessary  \n(A) To meet the unusual and compelling requirements of the work to be performed under the contract; and\n(B) For the agency to enter into another contract for the required goods and services through the use of competitive procedures; and\n(ii) May not exceed one year unless the head of the agency entering into the contract determines that exceptional circumstances apply.\n(2) The requirements in paragraph (d)(1) of this section shall apply to any contract in an amount greater than the simplified acquisition threshold.\n(3) The determination of exceptional circumstances is in addition to the approval of the justification in 6.304 .\n(4) The determination may be made after contract award when making the determination prior to award would unreasonably delay the acquisition.\n6.302-3 Industrial mobilization; engineering, developmental, or research capability; or expert services.\n(a) Authority.\n(1) Citations: 10 U.S.C. 2304(c)(3) or 41 U.S.C. 253(c)(3) .\n(2) Full and open competition need not be provided for when it is necessary to award the contract to a particular source or sources in order  \n(i) To maintain a facility, producer, manufacturer, or other supplier available for furnishing supplies or services in case of a national emergency or to achieve industrial mobilization;\n(ii) To establish or maintain an essential engineering, research, or development capability to be provided by an educational or other nonprofit institution or a federally funded research and development center; or\n(iii) To acquire the services of an expert or neutral person for any current or anticipated litigation or dispute.\n(b) Application.\n(1) Use of the authority in paragraph (a)(2)(i) of this subsection may be appropriate when it is necessary to  \n(i) Keep vital facilities or suppliers in business or make them available in the event of a national emergency;\n(ii) Train a selected supplier in the furnishing of critical supplies or services; prevent the loss of a supplier  s ability and employees  skills; or maintain active engineering, research, or development work;\n(iii) Maintain properly balanced sources of supply for meeting the requirements of acquisition programs in the interest of industrial mobilization (when the quantity required is substantially larger than the quantity that must be awarded in order to meet the objectives of this authority, that portion not required to meet such objectives will be acquired by providing for full and open competition, as appropriate, under this part);\n(iv) Create or maintain the required domestic capability for production of critical supplies by limiting competition to items manufactured in  \n(A) The United States or its outlying areas; or\n(B) The United States, its outlying areas, or Canada.\n(v) Continue in production, contractors that are manufacturing critical items, when there would otherwise be a break in production; or\n(vi) Divide current production requirements among two or more contractors to provide for an adequate industrial mobilization base.\n(2) Use of the authority in paragraph (a)(2)(ii) of this subsection may be appropriate when it is necessary to  \n(i) Establish or maintain an essential capability for theoretical analyses, exploratory studies, or experiments in any field of science or technology;\n(ii) Establish or maintain an essential capability for engineering or developmental work calling for the practical application of investigative findings and theories of a scientific or technical nature; or\n(iii) Contract for supplies or services as are necessary incident to paragraphs (b)(2)(i) or (ii) of this subsection.\n(3) Use of the authority in paragraph (a)(2)(iii) of this subsection may be appropriate when it is necessary to acquire the services of either  \n(i) An expert to use, in any litigation or dispute (including any reasonably foreseeable litigation or dispute) involving the Government in any trial, hearing, or proceeding before any court, administrative tribunal, or agency, whether or not the expert is expected to testify. Examples of such services include, but are not limited to:\n(A) Assisting the Government in the analysis, presentation, or defense of any claim or request for adjustment to contract terms and conditions, whether asserted by a contractor or the Government, which is in litigation or dispute, or is anticipated to result in dispute or litigation before any court, administrative tribunal, or agency; or\n(B) Participating in any part of an alternative dispute resolution process, including but not limited to evaluators, fact finders, or witnesses, regardless of whether the expert is expected to testify; or\n(ii) A neutral person, e.g., mediators or arbitrators, to facilitate the resolution of issues in an alternative dispute resolution process.\n(c) Limitations . Contracts awarded using this authority shall be supported by the written justifications and approvals described in 6.303 and 6.304 .\n6.302-4 International agreement.\n(a) Authority.\n(1) Citations: 10 U.S.C. 2304(c)(4) or 41 U.S.C. 253(c)(4) .\n(2) Full and open competition need not be provided for when precluded by the terms of an international agreement or a treaty between the United States and a foreign government or international organization, or the written directions of a foreign government reimbursing the agency for the cost of the acquisition of the supplies or services for such government.\n(b) Application . This authority may be used in circumstances such as  \n(1) When a contemplated acquisition is to be reimbursed by a foreign country that requires that the product be obtained from a particular firm as specified in official written direction such as a Letter of Offer and Acceptance; or\n(2) When a contemplated acquisition is for services to be performed, or supplies to be used, in the sovereign territory of another country and the terms of a treaty or agreement specify or limit the sources to be solicited.\n(c) Limitations . Except for DoD, NASA, and the Coast Guard, contracts awarded using this authority shall be supported by written justifications and approvals described in 6.303 and 6.304 .\n6.302-5 Authorized or required by statute.\n(a) Authority.\n(1) Citations: 10 U.S.C. 2304(c)(5) or 41 U.S.C. 253(c)(5) .\n(2) Full and open competition need not be provided for when  \n(i) A statute expressly authorizes or requires that the acquisition be made through another agency or from a specified source; or\n(ii) The agency  s need is for a brand name commercial item for authorized resale.\n(b) Application . This authority may be used when statutes, such as the following, expressly authorize or require that acquisition be made from a specified source or through another agency:\n(1) Federal Prison Industries (UNICOR)  18 U.S.C. 4124 (see Subpart 8.6 ).\n(2) Qualified Nonprofit Agencies for the Blind or other Severely Disabled  41 U.S.C. 46-48c (see Subpart 8.7 ).\n(3) Government Printing and Binding  44 U.S.C. 501-504 , 1121 (see Subpart 8.8 ).\n(4) Sole source awards under the 8(a) Program (15 U.S.C. 637), but see 6.303 for requirements for justification and approval of sole-source 8(a) awards over $20 million. (See subpart 19.8 ).\n(5) Sole source awards under the HUBZone Act of 1997  15 U.S.C. 657a (see 19.1306 ).\n(6) Sole source awards under the Veterans Benefits Act of 2003 ( 15 U.S.C. 657f ).\n(c) Limitations.\n(1) This authority shall not be used when a provision of law requires an agency to award a new contract to a specified non-Federal Government entity unless the provision of law specifically  \n(i) Identifies the entity involved;\n(ii) Refers to 10 U.S.C. 2304(j) for armed services acquisitions or section 303(h) of the Federal Property and Administrative Services Act of 1949 for civilian agency acquisitions; and\n(iii) States that award to that entity shall be made in contravention of the merit-based selection procedures in 10 U.S.C. 2304(j) or section 303(h) of the Federal Property and Administrative Services Act, as appropriate. However, this limitation does not apply  \n(A) When the work provided for in the contract is a continuation of the work performed by the specified entity under a preceding contract; or\n(B) To any contract requiring the National Academy of Sciences to investigate, examine, or experiment upon any subject of science or art of significance to an executive agency and to report on those matters to the Congress or any agency of the Federal Government.\n(2) Contracts awarded using this authority shall be supported by the written justifications and approvals described in 6.303 and 6.304 , except for  \n(i) Contracts awarded under (a)(2)(ii) or (b)(2) of this subsection;\n(ii) Contracts awarded under (a)(2)(i) of this subsection when the statute expressly requires that the procurement be made from a specified source. (Justification and approval requirements apply when the statute authorizes, but does not require, that the procurement be made from a specified source); or\n(iii) Contracts less than or equal to $20 million awarded under (b)(4) of this subsection.\n(3) The authority in (a)(2)(ii) of this subsection may be used only for purchases of brand-name commercial items for resale through commissaries or other similar facilities. Ordinarily, these purchases will involve articles desired or preferred by customers of the selling activities (but see 6.301 (d)).\n6.302-6 National security.\n(a) Authority.\n(1) Citations: 10 U.S.C. 2304(c)(6) or 41 U.S.C. 253(c)(6) .\n(2) Full and open competition need not be provided for when the disclosure of the agency  s needs would compromise the national security unless the agency is permitted to limit the number of sources from which it solicits bids or proposals.\n(b) Application . This authority may be used for any acquisition when disclosure of the Government  s needs would compromise the national security ( e.g., would violate security requirements); it shall not be used merely because the acquisition is classified, or merely because access to classified matter will be necessary to submit a proposal or to perform the contract.\n(c) Limitations.\n(1) Contracts awarded using this authority shall be supported by the written justifications and approvals described in 6.303 and 6.304 .\n(2) See 5.202 (a)(1) for synopsis requirements.\n(3) This statutory authority requires that agencies shall request offers from as many potential sources as is practicable under the circumstances.\n6.302-7 Public interest.\n(a) Authority.\n(1) Citations: 10 U.S.C. 2304(c)(7) or 41 U.S.C. 253(c)(7) .\n(2) Full and open competition need not be provided for when the agency head determines that it is not in the public interest in the particular acquisition concerned.\n(b) Application . This authority may be used when none of the other authorities in 6.302 apply.\n(c) Limitations.\n(1) A written determination to use this authority shall be made in accordance with Subpart 1.7 , by  \n(i) The Secretary of Defense, the Secretary of the Army, the Secretary of the Navy, the Secretary of the Air Force, the Secretary of Homeland Security for the Coast Guard, or the Administrator of the National Aeronautics and Space Administration; or\n(ii) The head of any other executive agency. This authority may not be delegated.\n(2) The Congress shall be notified in writing of such determination not less than 30 days before award of the contract.\n(3) If required by the head of the agency, the contracting officer shall prepare a justification to support the determination under paragraph (c)(1) of this subsection.\n(4) This Determination and Finding (D&F) shall not be made on a class basis.\n6.303 Justifications.\n6.303-1 Requirements.\n(a) A contracting officer shall not commence negotiations for a sole source contract, commence negotiations for a contract resulting from an unsolicited proposal, or award any other contract without providing for full and open competition unless the contracting officer  \n(1) Justifies, if required in 6.302 , the use of such actions in writing;\n(2) Certifies the accuracy and completeness of the justification; and\n(3) Obtains the approval required by 6.304 .\n(b) The contracting officer shall not award a sole-source contract under the 8(a) authority (15 U.S.C. 637(a)) for an amount exceeding $20 million unless -\n(1) The contracting officer justifies the use of a sole-source contract in writing in accordance with 6.303-2 ;\n(2) The justification is approved by the appropriate official designated at 6.304 ; and\n(3) The justification and related information are made public after award in accordance with 6.305 .\n(c) Technical and requirements personnel are responsible for providing and certifying as accurate and complete necessary data to support their recommendation for other than full and open competition.\n(d) Justifications required by paragraph (a) of this section may be made on an individual or class basis. Any justification for contracts awarded under the authority of 6.302-7 shall only be made on an individual basis. Whenever a justification is made and approved on a class basis, the contracting officer must ensure that each contract action taken pursuant to the authority of the class justification and approval is within the scope of the class justification and approval and shall document the contract file for each contract action accordingly.\n(e) The justifications for contracts awarded under the authority cited in 6.302-2 may be prepared and approved within a reasonable time after contract award when preparation and approval prior to award would unreasonably delay the acquisitions.\n6.303-2 Content.\n(a) Each justification shall contain sufficient facts and rationale to justify the use of the specific authority cited.\n(b) As a minimum, each justification, except those for sole-source 8(a) contracts over $20 million (see paragraph (d) of this section), shall include the following information:\n(1) Identification of the agency and the contracting activity, and specific identification of the document as a  Justification for other than full and open competition.  \n(2) Nature and/or description of the action being approved.\n(3) A description of the supplies or services required to meet the agency  s needs (including the estimated value).\n(4) An identification of the statutory authority permitting other than full and open competition.\n(5) A demonstration that the proposed contractor  s unique qualifications or the nature of the acquisition requires use of the authority cited.\n(6) A description of efforts made to ensure that offers are solicited from as many potential sources as is practicable, including whether a notice was or will be publicized as required by Subpart 5.2 and, if not, which exception under 5.202 applies.\n(7) A determination by the contracting officer that the anticipated cost to the Government will be fair and reasonable.\n(8) A description of the market research conducted (see Part 10 ) and the results or a statement of the reason market research was not conducted.\n(9) Any other facts supporting the use of other than full and open competition, such as:\n(i) Explanation of why technical data packages, specifications, engineering descriptions, statements of work, or purchase descriptions suitable for full and open competition have not been developed or are not available.\n(ii) When 6.302-1 is cited for follow-on acquisitions as described in 6.302-1 (a)(2)(ii), an estimate of the cost to the Government that would be duplicated and how the estimate was derived.\n(iii) When 6.302-2 is cited, data, estimated cost, or other rationale as to the extent and nature of the harm to the Government.\n(10) A listing of the sources, if any, that expressed, in writing, an interest in the acquisition.\n(11) A statement of the actions, if any, the agency may take to remove or overcome any barriers to competition before any subsequent acquisition for the supplies or services required.\n(12) Contracting officer certification that the justification is accurate and complete to the best of the contracting officer  s knowledge and belief.\n(c) Each justification shall include evidence that any supporting data that is the responsibility of technical or requirements personnel ( e.g., verifying the Government  s minimum needs or schedule requirements or other rationale for other than full and open competition) and which form a basis for the justification have been certified as complete and accurate by the technical or requirements personnel.\n(d) As a minimum, each justification for a sole-source 8(a) contract over $20 million shall include the following information:\n(1) A description of the needs of the agency concerned for the matters covered by the contract.\n(2) A specification of the statutory provision providing the exception from the requirement to use competitive procedures in entering into the contract (see 19.805-1 ).\n(3) A determination that the use of a sole-source contract is in the best interest of the agency concerned.\n(4) A determination that the anticipated cost of the contract will be fair and reasonable.\n(5) Such other matters as the head of the agency concerned shall specify for purposes of this section.\n6.304 Approval of the justification.\n(a) Except for paragraph (b) of this section, the justification for other than full and open competition shall be approved in writing  \n(1) For a proposed contract not exceeding $650,000, the contracting officer  s certification required by 6.303-2 (b)(12) will serve as approval unless a higher approving level is established in agency procedures.\n(2) For a proposed contract over $650,000 but not exceeding $12.5 million, by the competition advocate for the procuring activity designated pursuant to 6.501 or an official described in paragraph (a)(3) or (a)(4) of this section. This authority is not delegable.\n(3) For a proposed contract over $12.5 million, but not exceeding $62.5 million, or, for DoD, NASA, and the Coast Guard, not exceeding $85.5 million, by the head of the procuring activity, or a designee who  \n(i) If a member of the armed forces, is a general or flag officer; or\n(ii) If a civilian, is serving in a position in a grade above GS-15 under the General Schedule (or in a comparable or higher position under another schedule).\n(4) For a proposed contract over $62.5 million or, for DoD, NASA, and the Coast Guard, over $85.5 million, by the senior procurement executive of the agency designated pursuant to the OFPP Act ( 41 U.S.C. 414(3) ) in accordance with agency procedures.This authority is not delegable except in the case of the Under Secretary of Defense for Acquisition, Technology, and Logistics, acting as the senior procurement executive for the Department of Defense.\n(b) Any justification for a contract awarded under the authority of 6.302-7 , regardless of dollar amount, shall be considered approved when the determination required by 6.302-7 (c)(1) is made.\n(c) A class justification for other than full and open competition shall be approved in writing in accordance with agency procedures. The approval level shall be determined by the estimated total value of the class.\n(d) The estimated dollar value of all options shall be included in determining the approval level of a justification.\n6.305 Availability of the justification.\n(a) The agency shall make publicly available the justification required by 6.303-1 as required by 10 U.S.C. 2304(l) and 41 U.S.C. 253(j) . Except for the circumstances in paragraphs (b) and (c) of this section, the justification shall be made publicly available within 14 days after contract award.\n(b) In the case of a contract award permitted under 6.302-2 , the justification shall be posted within 30 days after contract award.\n(c) In the case of a brand name justification under 6.302-1 (c), the justification shall be posted with the solicitation (see 5.102 (a)(6)).\n(d) The justifications shall be made publicly available  \n(1) At the Government Point of Entry (GPE) www.fedbizopps.gov ; \n(2) On the website of the agency, which may provide access to the justifications by linking to the GPE; and\n(3) Must remain posted for a minimum of 30 days.\n(e) Contracting officers shall carefully screen all justifications for contractor proprietary data and remove all such data, and such references and citations as are necessary to protect the proprietary data, before making the justifications available for public inspection. Contracting officers shall also be guided by the exemptions to disclosure of information contained in the Freedom of Information Act ( 5 U.S.C. 552 ) and the prohibitions against disclosure in 24.202 in determining whether the justification, or portions of it, are exempt from posting. Although the submitter notice process set out in EO 12600, entitled  Predisclosure Notification Procedures for Confidential Commercial Information,  does not apply, if the justification appears to contain proprietary data, the contracting officer should provide the contractor that submitted the information an opportunity to review the justification for proprietary data, before making the justification available for public inspection, redacted as necessary. This process must not prevent or delay the posting of the justification in accordance with the timeframes required in paragraphs (a) through (c).\n(f) The requirements of paragraphs (a) through (d) do not apply if posting the justification would disclose the executive agency  s needs and disclosure of such needs would compromise national security or create other security risks.");
register_book(&s, "|6|4|", "Sealed Bidding and Competitive Proposal", "Subpart 6.4  Sealed Bidding and Competitive Proposals\n6.401 Sealed bidding and competitive proposals.\nSealed bidding and competitive proposals, as described in Parts 14 and 15 , are both acceptable procedures for use under Subparts 6.1 , 6.2 ; and, when appropriate, under Subpart 6.3 .\n(a) Sealed bids . (See Part 14 for procedures.) Contracting officers shall solicit sealed bids if  \n(1) Time permits the solicitation, submission, and evaluation of sealed bids;\n(2) The award will be made on the basis of price and other price-related factors;\n(3) It is not necessary to conduct discussions with the responding offerors about their bids; and\n(4) There is a reasonable expectation of receiving more than one sealed bid.\n(b) Competitive proposals. (See Part 15 for procedures.)\n(1) Contracting officers may request competitive proposals if sealed bids are not appropriate under paragraph (a) of this section.\n(2) Because of differences in areas such as law, regulations, and business practices, it is generally necessary to conduct discussions with offerors relative to proposed contracts to be made and performed outside the United States and its outlying areas. Competitive proposals will therefore be used for these contracts unless discussions are not required and the use of sealed bids is otherwise appropriate.");
register_book(&s, "|6|5|", "Competition Advocates", "Subpart 6.5  Competition Advocates\n6.501 Requirement.\nAs required by Section 20 of the Office of Federal Procurement Policy Act, the head of each executive agency shall designate a competition advocate for the agency and for each procuring activity of the agency. The competition advocates shall  \n(a) Be in positions other than that of the agency senior procurement executive;\n(b) Not be assigned any duties or responsibilities that are inconsistent with 6.502 ; and\n(c) Be provided with staff or assistance ( e.g., specialists in engineering, technical operations, contract administration, financial management, supply management, and utilization of small business concerns), as may be necessary to carry out the advocate  s duties and responsibilities.\n6.502 Duties and responsibilities.\n(a) Agency and procuring activity competition advocates are responsible for promoting the acquisition of commercial items, promoting full and open competition, challenging requirements that are not stated in terms of functions to be performed, performance required or essential physical characteristics, and challenging barriers to the acquisition of commercial items and full and open competition such as unnecessarily restrictive statements of work, unnecessarily detailed specifications, and unnecessarily burdensome contract clauses.\n(b) Agency competition advocates shall  \n(1) Review the contracting operations of the agency and identify and report to the agency senior procurement executive and the chief acquisition officer  \n(i) Opportunities and actions taken to acquire commercial items to meet the needs of the agency;\n(ii) Opportunities and actions taken to achieve full and open competition in the contracting operations of the agency;\n(iii) Actions taken to challenge requirements that are not stated in terms of functions to be performed, performance required or essential physical characteristics;\n(iv) Any condition or action that has the effect of unnecessarily restricting the acquisition of commercial items or competition in the contract actions of the agency;\n(2) Prepare and submit an annual report to the agency senior procurement executive and the chief acquisition officer in accordance with agency procedures, describing  \n(i) Such advocate  s activities under this subpart;\n(ii) New initiatives required to increase the acquisition of commercial items;\n(iii) New initiatives required to increase competition;\n(iv) New initiatives to ensure requirements are stated in terms of functions to be performed, performance required or essential physical characteristics;\n(v) Any barriers to the acquisition of commercial items or competition that remain; \n(vi) Other ways in which the agency has emphasized the acquisition of commercial items and competition in areas such as acquisition training and research; and\n(vii) Initiatives that ensure task and delivery orders over $1,000,000 issued under multiple award contracts are properly planned, issued, and comply with 8.405 and 16.505 .\n(3) Recommend goals and plans for increasing competition on a fiscal year basis to the agency senior procurement executive and the chief acquisition officer; and\n(4) Recommend to the agency senior procurement executive and the chief acquisition officer a system of personal and organizational accountability for competition, which may include the use of recognition and awards to motivate program managers, contracting officers, and others in authority to promote competition in acquisition.\n*    *    *    *    *    *");
register_book(&s, "|7|2|", "Planning for the Purchase of Supplies i", "Subpart 7.2  Planning for the Purchase of Supplies in Economic Quantities\n7.200 Scope of subpart.\nThis subpart prescribes policies and procedures for gathering information from offerors to assist the Government in planning the most advantageous quantities in which supplies should be purchased.\n7.201 [Reserved]\n7.202 Policy.\n(a) Agencies are required by 10 U.S.C. 2384(a) and 41 U.S.C. 253f to procure supplies in such quantity as  \n(1) Will result in the total cost and unit cost most advantageous to the Government, where practicable; and\n(2) Does not exceed the quantity reasonably expected to be required by the agency.\n(b) Each solicitation for a contract for supplies is required, if practicable, to include a provision inviting each offeror responding to the solicitation  \n(1) To state an opinion on whether the quantity of the supplies proposed to be acquired is economically advantageous to the Government; and\n(2) If applicable, to recommend a quantity or quantities which would be more economically advantageous to the Government. Each such recommendation is required to include a quotation of the total price and the unit price for supplies procured in each recommended quantity.\n7.203 Solicitation provision.\nContracting officers shall insert the provision at 52.207-4 , Economic Purchase Quantity  Supplies, in solicitations for supplies. The provision need not be inserted if the solicitation is for a contract under the General Services Administration  s multiple award schedule contract program, or if the contracting officer determines that  \n(a) The Government already has the data;\n(b) The data is otherwise readily available; or\n(c) It is impracticable for the Government to vary its future requirements.\n7.204 Responsibilities of contracting officers.\n(a) Contracting officers are responsible for transmitting offeror responses to the solicitation provision at 52.207-4 to appropriate inventory management/requirements development activities in accordance with agency procedures. The economic purchase quantity data so obtained are intended to assist inventory managers in establishing and evaluating economic order quantities for supplies under their cognizance.\n(b) In recognition of the fact that economic purchase quantity data furnished by offerors are only one of many data inputs required for determining the most economical order quantities, contracting officers should generally take no action to revise quantities to be acquired in connection with the instant procurement. However, if a significant price variation is evident from offeror responses, and the potential for significant savings is apparent, the contracting officer shall consult with the cognizant inventory manager or requirements development activity before proceeding with an award or negotiations. If this consultation discloses that the Government should be ordering an item of supply in different quantities and the inventory manager/requirements development activity concurs, the solicitation for the item should be amended or canceled and a new requisition should be obtained.");
register_book(&s, "|7|3|", "Contractor Versus Government Performanc", "Subpart 7.3  Contractor Versus Government Performance\n7.300 [Reserved]\n7.301 Definitions.\nDefinitions of  inherently governmental activity  and other terms applicable to this subpart are set forth at Attachment D of the Office of Management and Budget Circular No. A-76 (Revised), Performance of Commercial Activities, dated May 29, 2003 (the Circular).\n7.302 Policy.\n(a) The Circular provides that it is the policy of the Government to  \n(1) Perform inherently governmental activities with Government personnel; and\n(2) Subject commercial activities to the forces of competition.\n(b) As provided in the Circular, agencies shall  \n(1) Not use contractors to perform inherently governmental activities;\n(2) Conduct public-private competitions in accordance with the provisions of the Circular and, as applicable, these regulations;\n(3) Give appropriate consideration relative to cost when making performance decisions between agency and contractor performance in public-private competitions;\n(4) Consider the Agency Tender Official an interested party in accordance with 31 U.S.C. 3551 to 3553 for purposes of filing a protest at the Government Accountability Office; and\n(5) Hear contests in accordance with OMB Circular A-76, Attachment B, Paragraph F.\n(c) When using sealed bidding in public-private competitions under OMB Circular A-76, contracting officers shall not hold discussions to correct deficiencies.\n7.303 [Reserved]\n7.304 [Reserved]\n7.305 Solicitation provisions and contract clause.\n(a) The contracting officer shall, when soliciting offers and tenders, insert in solicitations issued for standard competitions the provision at 52.207-1 , Notice of Standard Competition.\n(b) The contracting officer shall, when soliciting offers, insert in solicitations issued for streamlined competitions the provision at 52.207-2 , Notice of Streamlined Competition.\n(c) The contracting officer shall insert the clause at 52.207-3 , Right of First Refusal of Employment, in all solicitations which may result in a conversion from in-house performance to contract performance of work currently being performed by the Government and in contracts that result from the solicitations, whether or not a public-private competition is conducted. The 10-day period in the clause may be varied by the contracting officer up to a period of 90 days.");
register_book(&s, "|7|4|", "Equipment Lease or Purchase", "Subpart 7.4  Equipment Lease or Purchase\n7.400 Scope of subpart.\nThis subpart provides guidance pertaining to the decision to acquire equipment by lease or purchase. It applies to both the initial acquisition of equipment and the renewal or extension of existing equipment leases.\n7.401 Acquisition considerations.\n(a) Agencies should consider whether to lease or purchase equipment based on a case-by-case evaluation of comparative costs and other factors. The following factors are the minimum that should be considered:\n(1) Estimated length of the period the equipment is to be used and the extent of use within that period.\n(2) Financial and operating advantages of alternative types and makes of equipment.\n(3) Cumulative rental payments for the estimated period of use.\n(4) Net purchase price.\n(5) Transportation and installation costs.\n(6) Maintenance and other service costs.\n(7) Potential obsolescence of the equipment because of imminent technological improvements.\n(b) The following additional factors should be considered, as appropriate, depending on the type, cost, complexity, and estimated period of use of the equipment:\n(1) Availability of purchase options.\n(2) Potential for use of the equipment by other agencies after its use by the acquiring agency is ended.\n(3) Trade-in or salvage value.\n(4) Imputed interest.\n(5) Availability of a servicing capability, especially for highly complex equipment; e.g., can the equipment be serviced by the Government or other sources if it is purchased?\n7.402 Acquisition methods.\n(a) Purchase method.\n(1) Generally, the purchase method is appropriate if the equipment will be used beyond the point in time when cumulative leasing costs exceed the purchase costs.\n(2) Agencies should not rule out the purchase method of equipment acquisition in favor of leasing merely because of the possibility that future technological advances might make the selected equipment less desirable.\n(b) Lease method.\n(1) The lease method is appropriate if it is to the Government  s advantage under the circumstances. The lease method may also serve as an interim measure when the circumstances  \n(i) Require immediate use of equipment to meet program or system goals; but\n(ii) Do not currently support acquisition by purchase.\n(2) If a lease is justified, a lease with option to purchase is preferable.\n(3) Generally, a long term lease should be avoided, but may be appropriate if an option to purchase or other favorable terms are included.\n(4) If a lease with option to purchase is used, the contract shall state the purchase price or provide a formula which shows how the purchase price will be established at the time of purchase.\n7.403 General Services Administration assistance.\n(a) When requested by an agency, the General Services Administration (GSA) will assist in lease or purchase decisions by providing information such as  \n(1) Pending price adjustments to Federal Supply Schedule contracts;\n(2) Recent or imminent technological developments;\n(3) New techniques; and\n(4) Industry or market trends.\n(b) Agencies may request information from the following GSA office: U.S. General Services Administration, Federal Acquisition Service, Office of Acquisition Management, 2200 Crystal Drive, Room 806, Arlington, VA. 22202. Email: fasam@gsa.gov .\n7.404 Contract clause.\nThe contracting officer shall insert a clause substantially the same as the clause in 52.207-5 , Option to Purchase Equipment, in solicitations and contracts involving a lease with option to purchase.");
register_book(&s, "|7|5|", "Inherently Governmental Functions", "Subpart 7.5  Inherently Governmental Functions\n7.500 Scope of subpart.\nThe purpose of this subpart is to prescribe policies and procedures to ensure that inherently governmental functions are not performed by contractors.\n7.501 [Reserved]\n7.502 Applicability.\nThe requirements of this subpart apply to all contracts for services. This subpart does not apply to services obtained through either personnel appointments, advisory committees, or personal services contracts issued under statutory authority.\n7.503 Policy.\n(a) Contracts shall not be used for the performance of inherently governmental functions.\n(b) Agency decisions which determine whether a function is or is not an inherently governmental function may be reviewed and modified by appropriate Office of Management and Budget officials.\n(c) The following is a list of examples of functions considered to be inherently governmental functions or which shall be treated as such. This list is not all inclusive:\n(1) The direct conduct of criminal investigations.\n(2) The control of prosecutions and performance of adjudicatory functions other than those relating to arbitration or other methods of alternative dispute resolution.\n(3) The command of military forces, especially the leadership of military personnel who are members of the combat, combat support, or combat service support role.\n(4) The conduct of foreign relations and the determination of foreign policy.\n(5) The determination of agency policy, such as determining the content and application of regulations, among other things.\n(6) The determination of Federal program priorities for budget requests.\n(7) The direction and control of Federal employees.\n(8) The direction and control of intelligence and counter-intelligence operations.\n(9) The selection or non-selection of individuals for Federal Government employment, including the interviewing of individuals for employment.\n(10) The approval of position descriptions and performance standards for Federal employees.\n(11) The determination of what Government property is to be disposed of and on what terms (although an agency may give contractors authority to dispose of property at prices within specified ranges and subject to other reasonable conditions deemed appropriate by the agency).\n(12) In Federal procurement activities with respect to prime contracts  \n(i) Determining what supplies or services are to be acquired by the Government (although an agency may give contractors authority to acquire supplies at prices within specified ranges and subject to other reasonable conditions deemed appropriate by the agency);\n(ii) Participating as a voting member on any source selection boards;\n(iii) Approving any contractual documents, to include documents defining requirements, incentive plans, and evaluation criteria;\n(iv) Awarding contracts;\n(v) Administering contracts (including ordering changes in contract performance or contract quantities, taking action based on evaluations of contractor performance, and accepting or rejecting contractor products or services);\n(vi) Terminating contracts;\n(vii) Determining whether contract costs are reasonable, allocable, and allowable; and\n(viii) Participating as a voting member on performance evaluation boards.\n(13) The approval of agency responses to Freedom of Information Act requests (other than routine responses that, because of statute, regulation, or agency policy, do not require the exercise of judgment in determining whether documents are to be released or withheld), and the approval of agency responses to the administrative appeals of denials of Freedom of Information Act requests.\n(14) The conduct of administrative hearings to determine the eligibility of any person for a security clearance, or involving actions that affect matters of personal reputation or eligibility to participate in Government programs.\n(15) The approval of Federal licensing actions and inspections.\n(16) The determination of budget policy, guidance, and strategy.\n(17) The collection, control, and disbursement of fees, royalties, duties, fines, taxes, and other public funds, unless authorized by statute, such as 31 U.S.C. 952 (relating to private collection contractors) and 31 U.S.C. 3718 (relating to private attorney collection services), but not including  \n(i) Collection of fees, fines, penalties, costs, or other charges from visitors to or patrons of mess halls, post or base exchange concessions, national parks, and similar entities or activities, or from other persons, where the amount to be collected is easily calculated or predetermined and the funds collected can be easily controlled using standard case management techniques; and\n(ii) Routine voucher and invoice examination.\n(18) The control of the treasury accounts.\n(19) The administration of public trusts.\n(20) The drafting of Congressional testimony, responses to Congressional correspondence, or agency responses to audit reports from the Inspector General, the Government Accountability Office, or other Federal audit entity.\n(d) The following is a list of examples of functions generally not considered to be inherently governmental functions. However, certain services and actions that are not considered to be inherently governmental functions may approach being in that category because of the nature of the function, the manner in which the contractor performs the contract, or the manner in which the Government administers contractor performance. This list is not all inclusive:\n(1) Services that involve or relate to budget preparation, including workload modeling, fact finding, efficiency studies, and should-cost analyses, etc.\n(2) Services that involve or relate to reorganization and planning activities.\n(3) Services that involve or relate to analyses, feasibility studies, and strategy options to be used by agency personnel in developing policy.\n(4) Services that involve or relate to the development of regulations.\n(5) Services that involve or relate to the evaluation of another contractor  s performance.\n(6) Services in support of acquisition planning.\n(7) Contractors providing assistance in contract management (such as where the contractor might influence official evaluations of other contractors).\n(8) Contractors providing technical evaluation of contract proposals.\n(9) Contractors providing assistance in the development of statements of work.\n(10) Contractors providing support in preparing responses to Freedom of Information Act requests.\n(11) Contractors working in any situation that permits or might permit them to gain access to confidential business information and/or any other sensitive information (other than situations covered by the National Industrial Security Program described in 4.402 (b)).\n(12) Contractors providing information regarding agency policies or regulations, such as attending conferences on behalf of an agency, conducting community relations campaigns, or conducting agency training courses.\n(13) Contractors participating in any situation where it might be assumed that they are agency employees or representatives.\n(14) Contractors participating as technical advisors to a source selection board or participating as voting or nonvoting members of a source evaluation board.\n(15) Contractors serving as arbitrators or providing alternative methods of dispute resolution.\n(16) Contractors constructing buildings or structures intended to be secure from electronic eavesdropping or other penetration by foreign governments.\n(17) Contractors providing inspection services.\n(18) Contractors providing legal advice and interpretations of regulations and statutes to Government officials.\n(19) Contractors providing special non-law enforcement, security activities that do not directly involve criminal investigations, such as prisoner detention or transport and non-military national security details.\n(e) Agency implementation shall include procedures requiring the agency head or designated requirements official to provide the contracting officer, concurrent with transmittal of the statement of work (or any modification thereof), a written determination that none of the functions to be performed are inherently governmental. This assessment should place emphasis on the degree to which conditions and facts restrict the discretionary authority, decision-making responsibility, or accountability of Government officials using contractor services or work products. Disagreements regarding the determination will be resolved in accordance with agency procedures before issuance of a solicitation.\n*    *    *    *    *    *");
register_book(&s, "|8|4|", "Federal Supply Schedules", "Subpart 8.4  Federal Supply Schedules\n8.401 Definitions.\nAs used in this subpart  \nOrdering activity  means an activity that is authorized to place orders, or establish blanket purchase agreements (BPA), against the General Services Administration  s (GSA) Multiple Award Schedule contracts. A list of eligible ordering activities is available at http://www.gsa.gov/schedules (click  For Customers Ordering from Schedules  and then  Eligibility to Use GSA Sources  ).\nMultiple Award Schedule (MAS)  means contracts awarded by GSA or the Department of Veterans Affairs (VA) for similar or comparable supplies, or services, established with more than one supplier, at varying prices. The primary statutory authorities for the MAS program are Title III of the Federal Property and Administrative Services Act of 1949 ( 41 U.S.C. 251 , et seq .) and Title 40 U.S.C. 501 , Services for Executive Agencies.\nRequiring agency  means the agency needing the supplies or services.\nSchedules e-Library  means the on-line source for GSA and VA Federal Supply Schedule contract award information. Schedules e-Library may be accessed at http://www.gsa.gov/elibrary .\nSpecial Item Number (SIN)  means a group of generically similar (but not identical) supplies or services that are intended to serve the same general purpose or function.\n8.402 General.\n(a) The Federal Supply Schedule program is also known as the GSA Schedules Program or the Multiple Award Schedule Program. The Federal Supply Schedule program is directed and managed by GSA and provides Federal agencies (see 8.002 ) with a simplified process for obtaining commercial supplies and services at prices associated with volume buying. Indefinite delivery contracts are awarded to provide supplies and services at stated prices for given periods of time. GSA may delegate certain responsibilities to other agencies ( e.g., GSA has delegated authority to the VA to procure medical supplies under the VA Federal Supply Schedules program). Orders issued under the VA Federal Supply Schedule program are covered by this subpart. Additionally, the Department of Defense (DoD) manages similar systems of schedule-type contracting for military items; however, DoD systems are not covered by this subpart.\n(b) GSA schedule contracts require all schedule contractors to publish an  Authorized Federal Supply Schedule Pricelist  (pricelist). The pricelist contains all supplies and services offered by a schedule contractor. In addition, each pricelist contains the pricing and the terms and conditions pertaining to each Special Item Number that is on schedule. The schedule contractor is required to provide one copy of its pricelist to any ordering activity upon request. Also, a copy of the pricelist may be obtained from the Federal Supply Service by submitting a written e-mail request to schedules.infocenter@gsa.gov or by telephone at 1-800-488-3111. This subpart, together with the pricelists, contain necessary information for placing delivery or task orders with schedule contractors. In addition, the GSA schedule contracting office issues Federal Supply Schedules publications that contain a general overview of the Federal Supply Schedule (FSS) program and address pertinent topics. Ordering activities may request copies of schedules publications by contacting the Centralized Mailing List Service through the Internet at http://www.gsa.gov/cmls , submitting written e-mail requests to CMLS@gsa.gov ; or by completing GSA Form 457, FSS Publications Mailing List Application, and mailing it to the GSA Centralized Mailing List Service (7SM), P.O. Box 6477, Fort Worth, TX 76115. Copies of GSA Form 457 may also be obtained from the above-referenced points of contact.\n(c)(1) GSA offers an on-line shopping service called  GSA Advantage!  through which ordering activities may place orders against Schedules. (Ordering activities may also use GSA Advantage! to place orders through GSA  s Global Supply System, a GSA wholesale supply source, formerly known as  GSA Stock  or the  Customer Supply Center.  FAR Subpart 8.4 is not applicable to orders placed through the GSA Global Supply System.) Ordering activities may access GSA Advantage! through the GSA Federal Supply Service Home Page ( http://www.gsa.gov/fas ) or the GSA Federal Supply Schedule Home Page at http://www.gsa.gov/schedules .\n(2) GSA Advantage! enables ordering activities to search specific information ( i.e., national stock number, part number, common name), review delivery options, place orders directly with Schedule contractors (except see 8.405-6 ) and pay for orders using the Governmentwide commercial purchase card.\n(d)(1) e-Buy , GSA  s electronic Request for Quotation (RFQ) system, is a part of a suite of on-line tools which complement GSA Advantage!. E-Buy allows ordering activities to post requirements, obtain quotes, and issue orders electronically. Posting an RFQ on e-Buy  \n(i) Is one medium for providing fair notice to all schedule contractors offering such supplies and services as required by 8.405-1 , 8.405-2 , and 8.405-3 ; and\n(ii) Is required when an order contains brand-name specifications (see 8.405-6 ).\n(2) Ordering activities may access e-Buy at http://www.ebuy.gsa.gov . For more information or assistance on either GSA Advantage! or e-Buy, contact GSA at Internet e-mail address gsa.advantage@gsa.gov .\n(e) For more information or assistance regarding the Federal Supply Schedule Program, review the following website: http://www.gsa.gov/schedules . Additionally, for on-line training courses regarding the Schedules Program, review the following website: http://www.gsa.gov/training .\n(f) For administrative convenience, an ordering activity contracting officer may add items not on the Federal Supply Schedule (also referred to as open market items) to a Federal Supply Schedule blanket purchase agreement (BPA) or an individual task or delivery order only if  \n(1) All applicable acquisition regulations pertaining to the purchase of the items not on the Federal Supply Schedule have been followed ( e.g., publicizing ( Part 5 ), competition requirements ( Part 6 ), acquisition of commercial items ( Part 12 ), contracting methods ( Parts 13 , 14 , and 15 ), and small business programs ( Part 19 ));\n(2) The ordering activity contracting officer has determined the price for the items not on the Federal Supply Schedule is fair and reasonable;\n(3) The items are clearly labeled on the order as items not on the Federal Supply Schedule; and\n(4) All clauses applicable to items not on the Federal Supply Schedule are included in the order.\n(g) When using the Governmentwide commercial purchase card as a method of payment, orders at or below the micro-purchase threshold are exempt from verification in the System for Award Management database as to whether the contractor has a delinquent debt subject to collection under the Treasury Offset Program (TOP).\n8.403 Applicability.\n(a) Procedures in this subpart apply to  \n(1) Individual orders for supplies or services placed against Federal Supply Schedules contracts; and\n(2) BPAs established against Federal Supply Schedule contracts.\n(b) GSA may establish special ordering procedures for a particular schedule. In this case, that schedule will specify those special ordering procedures. Unless otherwise noted, special ordering procedures established for a Federal Supply Schedule take precedence over the procedures in 8.405 .\n(c) In accordance with section 1427(b) of Public Law 108-136, for requirements that substantially or to a dominant extent specify performance of architect-engineer services (as defined in 2.101 ), agencies  \n(1) Shall use the procedures at Subpart 36.6 ; and\n(2) Shall not place orders for such requirements under a Federal Supply Schedule.\n8.404 Use of Federal Supply Schedules.\n(a) General . Parts 13 (except 13.303-2 (c)(3)), 14 , 15 , and 19 (except for the requirement at 19.202-1 (e)(1)(iii)) do not apply to BPAs or orders placed against Federal Supply Schedules contracts (but see 8.405-5 ). BPAs and orders placed against a MAS, using the procedures in this subpart, are considered to be issued using full and open competition (see 6.102 (d)(3)). Therefore, when establishing a BPA (as authorized by 13.303-2 (c)(3)), or placing orders under Federal Supply Schedule contracts using the procedures of 8.405 , ordering activities shall not seek competition outside of the Federal Supply Schedules or synopsize the requirement; but see paragraph (g) of this section.\n(b)(1) The contracting officer, when placing an order or establishing a BPA, is responsible for applying the regulatory and statutory requirements applicable to the agency for which the order is placed or the BPA is established. The requiring agency shall provide the information on the applicable regulatory and statutory requirements to the contracting officer responsible for placing the order.\n(2) For orders over $500,000, see subpart 17.5 for additional requirements for interagency acquisitions. For example, the requiring agency shall make a determination that use of the Federal Supply Schedule is the best procurement approach, in accordance with 17.502-1 (a).\n(c) Acquisition planning. Orders placed under a Federal Supply Schedule contract  \n(1) Are not exempt from the development of acquisition plans (see Subpart 7.1 ), and an information technology acquisition strategy (see Part 39 );\n(2) Must comply with all FAR requirements for a bundled contract when the order meets the definition of  bundled contract  (see 2.101 (b)); and\n(3) Must, whether placed by the requiring agency, or on behalf of the requiring agency, be consistent with the requiring agency  s statutory and regulatory requirements applicable to the acquisition of the supply or service.\n(d) Pricing . Supplies offered on the schedule are listed at fixed prices. Services offered on the schedule are priced either at hourly rates, or at a fixed price for performance of a specific task ( e.g., installation, maintenance, and repair). GSA has already determined the prices of supplies and fixed-price services, and rates for services offered at hourly rates, under schedule contracts to be fair and reasonable. Therefore, ordering activities are not required to make a separate determination of fair and reasonable pricing, except for a price evaluation as required by 8.405-2 (d). By placing an order against a schedule contract using the procedures in 8.405 , the ordering activity has concluded that the order represents the best value (as defined in FAR 2.101 ) and results in the lowest overall cost alternative (considering price, special features, administrative costs, etc.) to meet the Government  s needs. Although GSA has already negotiated fair and reasonable pricing, ordering activities may seek additional discounts before placing an order (see 8.405-4 ).\n(e) The procedures under subpart 33.1 are applicable to the issuance of an order or the establishment of a BPA against a schedule contract.\n(f) If the ordering activity issues an RFQ, the ordering activity shall provide the RFQ to any schedule contractor that requests a copy of it.\n(g)(1) Ordering activities shall publicize contract actions funded in whole or in part by the American Recovery and Reinvestment Act of 2009 (Pub. L. 111-5):\n(i) Notices of proposed MAS orders (including orders issued under BPAs) that are for  informational purposes only  exceeding $25,000 shall follow the procedures in 5.704 for posting orders.\n(ii) Award notices for MAS orders (including orders issued under BPAs) shall follow the procedures in 5.705 .\n(2) When an order is awarded or a Blanket Purchase Agreement is established with an estimated value greater than the simplified acquisition threshold and supported by a limited-source justification at 8.405-6 (a), the ordering activity contracting officer must  \n(i) Publicize the action (see 5.301 ); and\n(ii) Post the justification in accordance with 8.405-6 (a)(2).\n(h) Type-of-order preference for services. \n(1) The ordering activity shall specify the order type ( i.e. , firm-fixed price, time-and-materials, or labor-hour) for the services offered on the schedule priced at hourly rates.\n(2) Agencies shall use fixed-price orders for the acquisition of commercial services to the maximum extent practicable.\n(3)(i) A time-and-materials or labor-hour order may be used for the acquisition of commercial services only when it is not possible at the time of placing the order to estimate accurately the extent or duration of the work or to anticipate costs with any reasonable degree of confidence.\n(ii) Prior to the issuance of a time-and-materials or labor-hour order, the contracting officer shall  \n(A) Execute a determination and findings (D&F) for the order, in accordance with paragraph (h)(3)(iii) of this section that a fixed-price order is not suitable;\n(B) Include a ceiling price in the order that the contractor exceeds at its own risk; and\n(C) When the total performance period, including options, is more than three years, the D&F prepared in accordance with this paragraph shall be signed by the contracting officer and approved by the head of the contracting activity prior to the execution of the base period.\n(iii) The D&F required by paragraph (h)(3)(ii)(A) of this section shall contain sufficient facts and rationale to justify that a fixed-price order is not suitable. At a minimum, the D&F shall  \n(A) Include a description of the market research conducted (see 8.404 (c) and 10.002 (e));\n(B) Establish that it is not possible at the time of placing the order to accurately estimate the extent or duration of the work or anticipate costs with any reasonable degree of confidence;\n(C) Establish that the current requirement has been structured to maximize the use of fixed-price orders ( e.g. , by limiting the value or length of the time-and-materials/labor-hour order; or, establishing fixed prices for portions of the requirement) on future acquisitions for the same or similar requirements; and \n(D) Describe actions to maximize the use of fixed-price orders on future acquisitions for the same requirements.\n(iv) Prior to an increase in the ceiling price of a time-and-materials or labor-hour order, the ordering activity shall  \n(A) Conduct an analysis of pricing and other relevant factors to determine if the action is in the best interest of the Government and document the order file;\n(B) Follow the procedures at 8.405-6 for a change that modifies the general scope of the order; and\n(C) Comply with the requirements at 8.402 (f) when modifying an order to add open market items.\n8.405 Ordering procedures for Federal Supply Schedules.\nOrdering activities shall use the ordering procedures of this section when placing an order or establishing a BPA for supplies or services. The procedures in this section apply to all schedules. For establishing BPAs and for orders under BPAs see 8.405-3 .\n8.405-1 Ordering procedures for supplies, and services not requiring a statement of work.\n(a) Ordering activities shall use the procedures of this subsection when ordering supplies and services that are listed in the schedules contracts at a fixed price for the performance of a specific task, where a statement of work is not required ( e.g., installation, maintenance, and repair). For establishing BPAs and for orders under BPAs see 8.405-3 .\n(b) Orders at or below the micro-purchase threshold . Ordering activities may place orders at, or below, the micro-purchase threshold with any Federal Supply Schedule contractor that can meet the agency  s needs. Although not required to solicit from a specific number of schedule contractors, ordering activities should attempt to distribute orders among contractors.\n(c) Orders exceeding the micro-purchase threshold but not exceeding the simplified acquisition threshold . Ordering activities shall place orders with the schedule contractor that can provide the supply or service that represents the best value. Before placing an order, an ordering activity shall:\n(1) Consider reasonably available information about the supply or service offered under MAS contracts by surveying at least three schedule contractors through the GSA Advantage! on-line shopping service, by reviewing the catalogs or pricelists of at least three schedule contractors, or by requesting quotations from at least three schedule contractors (see 8.405-5 ); or\n(2) Document the circumstances for restricting consideration to fewer than three schedule contractors based on one of the reasons at 8.405-6 (a);\n(d) For proposed orders exceeding the simplified acquisition threshold. \n(1) Each order shall be placed on a competitive basis in accordance with (d)(2) and (3) of this section, unless this requirement is waived on the basis of a justification that is prepared and approved in accordance with 8.405-6 .\n(2) The ordering activity contracting officer shall provide an RFQ that includes a description of the supplies to be delivered or the services to be performed and the basis upon which the selection will be made (see 8.405-1 (f)).\n(3) The ordering activity contracting officer shall  \n(i) Post the RFQ on e-Buy to afford all schedule contractors offering the required supplies or services under the appropriate multiple award schedule(s) an opportunity to submit a quote; or\n(ii) Provide the RFQ to as many schedule contractors as practicable, consistent with market research appropriate to the circumstances, to reasonably ensure that quotes will be received from at least three contractors that can fulfill the requirements. When fewer than three quotes are received from schedule contractors that can fulfill the requirement, the contracting officer shall prepare a written determination explaining that no additional contractors capable of fulfilling the requirement could be identified despite reasonable efforts to do so. The determination must clearly explain efforts made to obtain quotes from at least three schedule contractors.\n(4) The ordering activity contracting officer shall ensure that all quotes received are fairly considered and award is made in accordance with the basis for selection in the RFQ.\n(e) When an order contains brand-name specifications, the contracting officer shall post the RFQ on e-Buy along with the justification or documentation, as required by 8.405-6 . An RFQ is required when a purchase description specifies a brand-name.\n(f) In addition to price (see 8.404 (d) and 8.405-4 ), when determining best value, the ordering activity may consider, among other factors, the following:\n(1) Past performance.\n(2) Special features of the supply or service required for effective program performance.\n(3) Trade-in considerations.\n(4) Probable life of the item selected as compared with that of a comparable item.\n(5) Warranty considerations.\n(6) Maintenance availability.\n(7) Environmental and energy efficiency considerations.\n(8) Delivery terms.\n(g) Minimum documentation . The ordering activity shall document  \n(1) The schedule contracts considered, noting the contractor from which the supply or service was purchased;\n(2) A description of the supply or service purchased;\n(3) The amount paid;\n(4) When an order exceeds the simplified acquisition threshold, evidence of compliance with the ordering procedures at 8.405-1 (d); and\n(5) The basis for the award decision.\n8.405-2 Ordering procedures for services requiring a statement of work.\n(a) General . Ordering activities shall use the procedures in this subsection when ordering services priced at hourly rates as established by the schedule contracts. The applicable services will be identified in the Federal Supply Schedule publications and the contractor  s pricelists. For establishing BPAs and for orders under BPAs see 8.405-3 .\n(b) Statements of Work (SOWs) . All Statements of Work shall include a description of work to be performed; location of work; period of performance; deliverable schedule; applicable performance standards; and any special requirements ( e.g., security clearances, travel, special knowledge). To the maximum extent practicable, agency requirements shall be performance-based statements (see Subpart 37.6 ).\n(c) Request for Quotation procedures . The ordering activity must provide the Request for Quotation (RFQ), which includes the statement of work and evaluation criteria ( e.g., experience and past performance), to schedule contractors that offer services that will meet the agency  s needs. The RFQ may be posted to GSA  s electronic RFQ system, e-Buy (see 8.402 (d)).\n(1) Orders at, or below, the micro-purchase threshold . Ordering activities may place orders at, or below, the micro-purchase threshold with any Federal Supply Schedule contractor that can meet the agency  s needs. The ordering activity should attempt to distribute orders among contractors.\n(2) For orders exceeding the micro-purchase threshold, but not exceeding the simplified acquisition threshold.\n(i) The ordering activity shall develop a statement of work, in accordance with 8.405-2 (b).\n(ii) The ordering activity shall provide the RFQ (including the statement of work and evaluation criteria) to at least three schedule contractors that offer services that will meet the agency  s needs or document the circumstances for restricting consideration to fewer than three schedule contractors based on one of the reasons at 8.405-6 (a).\n(iii) The ordering activity shall specify the type of order ( i.e. , firm-fixed-price, labor-hour) for the services identified in the statement of work. The contracting officer should establish firm-fixed-prices, as appropriate.\n(3) For proposed orders exceeding the simplified acquisition threshold. In addition to meeting the requirements of 8.405-2 (c)(2)(i) and (iii), the following procedures apply:\n(i) Each order shall be placed on a competitive basis in accordance with (c)(3)(ii) and (iii) of this section, unless this requirement is waived on the basis of a justification that is prepared and approved in accordance with 8.405-6 .\n(ii) The ordering activity contracting officer shall provide an RFQ that includes a statement of work and the evaluation criteria.\n(iii) The ordering activity contracting officer shall  \n(A) Post the RFQ on e-Buy to afford all schedule contractors offering the required services under the appropriate multiple-award schedule(s) an opportunity to submit a quote; or\n(B) Provide the RFQ to as many schedule contractors as practicable, consistent with market research appropriate to the circumstances, to reasonably ensure that quotes will be received from at least three contractors that can fulfill the requirements. When fewer than three quotes are received from schedule contractors that can fulfill the requirements, the contracting officer shall prepare a written determination to explain that no additional contractors capable of fulfilling the requirements could be identified despite reasonable efforts to do so. The determination must clearly explain efforts made to obtain quotes from at least three schedule contractors.\n(C) Ensure all quotes received are fairly considered and award is made in accordance with the evaluation criteria in the RFQ.\n(4) The ordering activity shall provide the RFQ (including the statement of work and the evaluation criteria) to any schedule contractor who requests a copy of it.\n(d) Evaluation . The ordering activity shall evaluate all responses received using the evaluation criteria provided to the schedule contractors. The ordering activity is responsible for considering the level of effort and the mix of labor proposed to perform a specific task being ordered, and for determining that the total price is reasonable. Place the order with the schedule contractor that represents the best value (see 8.404 (d) and 8.405-4 ). After award, ordering activities should provide timely notification to unsuccessful offerors. If an unsuccessful offeror requests information on an award that was based on factors other than price alone, a brief explanation of the basis for the award decision shall be provided.\n(e) Use of time-and-materials and labor-hour orders for services . When placing a time-and-materials or labor-hour order for services, see 8.404 (h).\n(f) Minimum documentation . The ordering activity shall document  \n(1) The schedule contracts considered, noting the contractor from which the service was purchased;\n(2) A description of the service purchased;\n(3) The amount paid;\n(4) The evaluation methodology used in selecting the contractor to receive the order;\n(5) The rationale for any tradeoffs in making the selection;\n(6) The price reasonableness determination required by paragraph (d) of this subsection;\n(7) The rationale for using other than  \n(i) A firm-fixed price order; or\n(ii) A performance-based order; and\n(8) When an order exceeds the simplified acquisition threshold, evidence of compliance with the ordering procedures at 8.405-2 (c).\n8.405-3 Blanket purchase agreements (BPAs).\n(a) Establishment .\n(1) Ordering activities may establish BPAs under any schedule contract to fill repetitive needs for supplies or services. Ordering activities shall establish the BPA with the schedule contractor(s) that can provide the supply or service that represents the best value.\n(2) In addition to price (see 8.404 (d) and 8.405-4 ), when determining best value, the ordering activity may consider, among other factors, the following:\n(i) Past performance.\n(ii) Special features of the supply or service required for effective program performance.\n(iii) Trade-in considerations.\n(iv) Probable life of the item selected as compared with that of a comparable item.\n(v) Warranty considerations.\n(vi) Maintenance availability.\n(vii) Environmental and energy efficiency considerations.\n(viii) Delivery terms.\n(3)(i) The ordering activity contracting officer shall, to the maximum extent practicable, give preference to establishing multiple-award BPAs, rather than establishing a single-award BPA.\n(ii) No single-award BPA with an estimated value exceeding $103 million (including any options), may be awarded unless the head of the agency determines in writing that  \n(A) The orders expected under the BPA are so integrally related that only a single source can reasonably perform the work;\n(B) The BPA provides only for firm-fixed priced orders for  \n(1) Products with unit prices established in the BPA; or\n(2) Services with prices established in the BPA for specific tasks to be performed;\n(C) Only one source is qualified and capable of performing the work at a reasonable price to the Government; or\n(D) It is necessary in the public interest to award the BPA to a single source for exceptional circumstances.\n(iii) The requirement for a determination for a single-award BPA greater than $103 million is in addition to any applicable requirement for a limited-source justification at 8.405-6 . However, the two documents may be combined into one document.\n(iv) In determining how many multiple-award BPAs to establish or that a single-award BPA is appropriate, the contracting officer should consider the following factors and document the decision in the acquisition plan or BPA file:\n(A) The scope and complexity of the requirement(s);\n(B) The benefits of on-going competition and the need to periodically compare multiple technical approaches or prices;\n(C) The administrative costs of BPAs; and\n(D) The technical qualifications of the schedule contractor(s).\n(4) BPAs shall address the frequency of ordering, invoicing, discounts, requirements ( e.g. , estimated quantities, work to be performed), delivery locations, and time.\n(5) When establishing multiple-award BPAs, the ordering activity shall specify the procedures for placing orders under the BPAs in accordance with 8.405-3 (c)(2).\n(6) Establishment of a multi-agency BPA against a Federal Supply Schedule contract is permitted if the multi-agency BPA identifies the participating agencies and their estimated requirements at the time the BPA is established.\n(7) Minimum documentation . The ordering activity contracting officer shall include in the BPA file documentation the  \n(i) Schedule contracts considered, noting the contractor to which the BPA was awarded;\n(ii) Description of the supply or service purchased;\n(iii) Price;\n(iv) Required justification for a limited-source BPA (see 8.405-6 ), if applicable;\n(v) Determination for a single-award BPA exceeding $103 million, if applicable (see (a)(3)(ii));\n(vi) Documentation supporting the decision to establish multiple-award BPAs or a single-award BPA (see (a)(3)(iv));\n(vii) Evidence of compliance with paragraph (b) of this section, for competitively awarded BPAs, if applicable; and\n(viii) Basis for the award decision . This should include the evaluation methodology used in selecting the contractor, the rationale for any tradeoffs in making the selection, and a price reasonableness determination for services requiring a statement of work.\n(b) Competitive procedures for establishing a BPA . This paragraph applies to the establishment of a BPA, in addition to applicable instructions in paragraph (a).\n(1) For supplies, and for services not requiring a statement of work . The procedures of this paragraph apply when establishing a BPA for supplies and services that are listed in the schedule contract at a fixed price for the performance of a specific task, where a statement of work is not required ( e.g. , installation, maintenance, and repair).\n(i) If the estimated value of the BPA does not exceed the simplified acquisition threshold. \n(A) The ordering activity shall:\n(1) Consider reasonably available information about the supply or service offered under MAS contracts by surveying at least three schedule contractors through the GSA Advantage! on-line shopping service, by reviewing the catalogs or pricelists of at least three schedule contractors, or by requesting quotations from at least three schedule contractors (see 8.405-5 ); or\n(2) Document the circumstances for restricting consideration to fewer than three schedule contractors based on one of the reasons at 8.405-6 (a).\n(B) The ordering activity shall establish the BPA with the schedule contractor(s) that can provide the best value.\n(ii) If the estimated value of the BPA exceeds the simplified acquisition threshold . The ordering activity contracting officer:\n(A) Shall provide an RFQ that includes a description of the supplies to be delivered or the services to be performed and the basis upon which the selection will be made.\n(B) ( 1) Shall post the RFQ on e-Buy to afford all schedule contractors offering the required supplies or services under the appropriate multiple award schedule(s) an opportunity to submit a quote; or\n( 2) Shall provide the RFQ to as many schedule contractors as practicable, consistent with market research appropriate to the circumstances, to reasonably ensure that quotes will be received from at least three contractors that can fulfill the requirements. When fewer than three quotes are received from schedule contractors that can fulfill the requirements, the contracting officer shall prepare a written determination explaining that no additional contractors capable of fulfilling the requirements could be identified despite reasonable efforts to do so. The determination must clearly explain efforts made to obtain quotes from at least three schedule contractors.\n(C) Shall ensure all quotes received are fairly considered and award is made in accordance with the basis for selection in the RFQ. After seeking price reductions (see 8.405-4 ), establish the BPA with the schedule contractor(s) that provides the best value.\n(D) The BPA must be established in accordance with paragraphs (b)(1)(ii)(B) and (C) of this section, unless the requirement is waived on the basis of a justification that is prepared and approved in accordance with 8.405-6 .\n(2) For services requiring a statement of work . This applies when establishing a BPA that requires services priced at hourly rates, as provided by the schedule contract. The applicable services will be identified in the Federal Supply Schedule publications and the contractor  s pricelists.\n(i) Statements of Work (SOWs) . The ordering activity shall develop a statement of work. All Statements of Work shall include a description of work to be performed; location of work; period of performance; deliverable schedule; applicable performance standards; and any special requirements ( e.g. , security clearances, travel, and special knowledge). To the maximum extent practicable, agency requirements shall be performance-based statements (see subpart 37.6 ).\n(ii) Type-of-order preference . The ordering activity shall specify the order type ( i.e. , firm-fixed price, time-and-materials, or labor-hour) for the services identified in the statement of work. The contracting officer should establish firm-fixed priced orders to the maximum extent practicable. For time-and-materials and labor-hour orders, the contracting officer shall follow the procedures at 8.404 (h).\n(iii) Request for Quotation procedures . The ordering activity must provide a RFQ, which includes the statement of work and evaluation criteria ( e.g. , experience and past performance), to schedule contractors that offer services that will meet the agency  s needs. The RFQ may be posted to GSA  s electronic RFQ system, e-Buy (see 8.402 (d)).\n(iv) If the estimated value of the BPA does not exceed the simplified acquisition threshold . The ordering activity shall provide the RFQ (including the statement of work and evaluation criteria) to at least three schedule contractors that offer services that will meet the agency  s needs.\n(v) If estimated value of the BPA exceeds the simplified acquisition threshold . The ordering activity contracting officer  \n(A) Shall post the RFQ on e-Buy to afford all schedule contractors offering the required supplies or services under the appropriate multiple-award schedule an opportunity to submit a quote; or\n(B) Shall provide the RFQ, which includes the statement of work and evaluation criteria, to as many schedule contractors as practicable, consistent with market research appropriate to the circumstances, to reasonably ensure that quotes will be received from at least three contractors that can fulfill the requirements. When fewer than three quotes are received from schedule contractors that can fulfill the requirements, the contracting officer shall document the file. The contracting officer shall prepare a written determination explaining that no additional contractors capable of fulfilling the requirements could be identified despite reasonable efforts to do so. The determination must clearly explain efforts made to obtain quotes from at least three schedule contractors.\n(vi) The ordering activity contracting officer shall ensure all quotes received are fairly considered and award is made in accordance with the basis for selection in the RFQ. The ordering activity is responsible for considering the level of effort and the mix of labor proposed to perform, and for determining that the proposed price is reasonable.\n(vii) The BPA must be established in accordance with paragraph (b)(2)(iv) or (v), and with paragraph (b)(2)(vi) of this section, unless the requirement is waived on the basis of a justification that is prepared and approved in accordance with 8.405-6 .\n(viii) The ordering activity contracting officer shall establish the BPA with the schedule contractor(s) that represents the best value (see 8.404 (d) and 8.405-4 ).\n(3) After award, ordering activities should provide timely notification to unsuccessful offerors. If an unsuccessful offeror requests information on an award that was based on factors other than price alone, a brief explanation of the basis for the award decision shall be provided.\n(c) Ordering from BPAs . The procedures in this paragraph (c) are not required for BPAs established on or before May 16, 2011. However, ordering activities are encouraged to use the procedures for such BPAs.\n(1) Single-award BPA . If the ordering activity establishes a single-award BPA, authorized users may place the order directly under the established BPA when the need for the supply or service arises.\n(2) Multiple-award BPAs .\n(i) Orders at or below the micro-purchase threshold. The ordering activity may place orders at or below the micro-purchase threshold with any BPA holder that can meet the agency needs. The ordering activity should attempt to distribute any such orders among the BPA holders.\n(ii) Orders exceeding the micro-purchase threshold but not exceeding the simplified acquisition threshold.\n(A) The ordering activity must provide each multiple-award BPA holder a fair opportunity to be considered for each order exceeding the micro-purchase threshold, but not exceeding the simplified acquisition threshold unless one of the exceptions at 8.405-6 (a)(1)(i) applies.\n(B) The ordering activity need not contact each of the multiple-award BPA holders before placing an order if information is available to ensure that each BPA holder is provided a fair opportunity to be considered for each order.\n(C) The ordering activity contracting officer shall document the circumstances when restricting consideration to less than all multiple-award BPA holders offering the required supplies and services.\n(iii) Orders exceeding the simplified acquisition threshold. \n(A) The ordering activity shall place an order in accordance with paragraphs (c)(2)(iii)(A)( 1), ( 2) and ( 3) of this paragraph, unless the requirement is waived on the basis of a justification that is prepared and approved in accordance with 8.405-6 . The ordering activity shall  \n(1) Provide an RFQ to all BPA holders offering the required supplies or services under the multiple-award BPAs, to include a description of the supplies to be delivered or the services to be performed and the basis upon which the selection will be made;\n(2) Afford all BPA holders responding to the RFQ an opportunity to submit a quote; and\n(3) Fairly consider all responses received and make award in accordance with the selection procedures.\n(B) The ordering activity shall document evidence of compliance with these procedures and the basis for the award decision.\n(3) BPAs for hourly-rate services . If the BPA is for hourly-rate services, the ordering activity shall develop a statement of work for each order covered by the BPA. Ordering activities should place these orders on a firm-fixed price basis to the maximum extent practicable. For time-and-materials and labor-hour orders, the contracting officer shall follow the procedures at 8.404 (h). All orders under the BPA shall specify a price for the performance of the tasks identified in the statement of work. The ordering activity is responsible for considering the level of effort and the mix of labor proposed to perform a specific task being ordered, and for determining that the total price is reasonable through appropriate analysis techniques, and documenting the file accordingly.\n(d) Duration of BPAs . \n(1) Multiple-award BPAs generally should not exceed five years in length, but may do so to meet program requirements.\n(2) A single-award BPA shall not exceed one year. It may have up to four one-year options. See paragraph (e) of this section for requirements associated with option exercise.\n(3) Contractors may be awarded BPAs that extend beyond the current term of their GSA Schedule contract, so long as there are option periods in their GSA Schedule contract that, if exercised, will cover the BPA  s period of performance.\n(e) Review of BPAs .\n(1) The ordering activity contracting officer shall review the BPA and determine in writing, at least once a year ( e.g. , at option exercise), whether  \n(i) The schedule contract, upon which the BPA was established, is still in effect;\n(ii) The BPA still represents the best value (see 8.404 (d)); and\n(iii) Estimated quantities/amounts have been exceeded and additional price reductions can be obtained.\n(2) The determination shall be included in the BPA file documentation.\n8.405-4 Price reductions.\nOrdering activities may request a price reduction at any time before placing an order, establishing a BPA, or in conjunction with the annual BPA review. However, the ordering activity shall seek a price reduction when the order or BPA exceeds the simplified acquisition threshold. Schedule contractors are not required to pass on to all schedule users a price reduction extended only to an individual ordering activity for a specific order or BPA.\n8.405-5 Small business.\n(a) Although the preference programs of part 19 are not mandatory in this subpart, in accordance with section 1331 of Public Law 111-240 ( 15 U.S.C. 644 (r))  \n(1) Ordering activity contracting officers may, at their discretion  \n(i) Set aside orders for any of the small business concerns identified in 19.000 (a)(3); and\n(ii) Set aside BPAs for any of the small business concerns identified in 19.000 (a)(3).\n(2) When setting aside orders and BPAs  \n(i) Follow the ordering procedures for Federal Supply Schedules at 8.405-1 , 8.405-2 , and 8.405-3 ; and\n(ii) The specific small business program eligibility requirements identified in part 19 apply.\n(b) Orders placed against schedule contracts may be credited toward the ordering activity  s small business goals. For purposes of reporting an order placed with a small business schedule contractor, an ordering agency may only take credit if the awardee meets a size standard that corresponds to the work performed. Ordering activities should rely on the small business representations made by schedule contractors at the contract level. \n(c) Ordering activities may consider socio-economic status when identifying contractor(s) for consideration or competition for award of an order or BPA. At a minimum, ordering activities should consider, if available, at least one small business, veteran-owned small business, service disabled veteran-owned small business, HUBZone small business, women-owned small business, or small disadvantaged business schedule contractor(s). GSA Advantage! and Schedules e-Library at http://www.gsa.gov/fas contain information on the small business representations of Schedule contractors.\n(d) For orders exceeding the micro-purchase threshold, ordering activities should give preference to the items of small business concerns when two or more items at the same delivered price will satisfy the requirement.\n8.405-6 Limiting sources.\nOrders placed or BPAs established under Federal Supply Schedules are exempt from the requirements in part 6 . However, an ordering activity must justify its action when restricting consideration in accordance with paragraphs (a) or (b) of this section  \n(a) Orders or BPAs exceeding the micro-purchase threshold based on a limited sources justification.\n(1) Circumstances justifying limiting the source.\n(i) For a proposed order or BPA with an estimated value exceeding the micro-purchase threshold not placed or established in accordance with the procedures in 8.405-1 , 8.405-2 , or 8.405-3 , the only circumstances that may justify the action are  \n(A) An urgent and compelling need exists, and following the procedures would result in unacceptable delays;\n(B) Only one source is capable of providing the supplies or services required at the level of quality required because the supplies or services are unique or highly specialized; or\n(C) In the interest of economy and efficiency, the new work is a logical follow-on to an original Federal Supply Schedule order provided that the original order was placed in accordance with the applicable Federal Supply Schedule ordering procedures. The original order or BPA must not have been previously issued under sole-source or limited-sources procedures.\n(ii) See 8.405-6 (c) for the content of the justification for an order or BPA exceeding the simplified acquisition threshold.\n(2) Posting.\n(i) Within 14 days after placing an order or establishing a BPA exceeding the simplified acquisition threshold that is supported by a limited-sources justification permitted under any of the circumstances under paragraph (a)(1) of this section, the ordering activity shall  \n(A) Publish a notice in accordance with 5.301 ; and\n(B) Post the justification  \n(1) At the GPE www.fedbizopps.gov ;\n(2) On the Web site of the ordering activity agency, which may provide access to the justification by linking to the GPE; and\n(3) For a minimum of 30 days.\n(ii) In the case of an order or BPA permitted under paragraph (a)(1)(i)(A) of this section, the justification shall be posted within 30 days after award.\n(iii) Contracting officers shall carefully screen all justifications for contractor proprietary data and remove all such data, and such references and citations as are necessary to protect the proprietary data, before making the justifications available for public inspection. Contracting officers shall also be guided by the exemptions to disclosure of information contained in the Freedom of Information Act ( 5 U.S.C. 552 ) and the prohibitions against disclosure in 24.202 in determining whether other data should be removed. Although the submitter notice process set out in Executive Order 12600  Predisclosure Notification Procedures for Confidential Commercial Information  does not apply, if the justification appears to contain proprietary data, the contracting officer should provide the contractor that submitted the information an opportunity to review the justification for proprietary data before making the justification available for public inspection, redacted as necessary. This process must not prevent or delay the posting of the justification in accordance with the timeframes required in paragraphs (a)(2)(i) and (ii) of this section.\n(iv) This posting requirement does not apply when disclosure would compromise the national security ( e.g. , would result in disclosure of classified information) or create other security risks.\n(b) Items peculiar to one manufacturer . An item peculiar to one manufacturer can be a particular brand name, product, or a feature of a product, peculiar to one manufacturer). A brand name item, whether available on one or more schedule contracts, is an item peculiar to one manufacturer.\n(1) Brand name specifications shall not be used unless the particular brand name, product, or feature is essential to the Government  s requirements, and market research indicates other companies  similar products, or products lacking the particular feature, do not meet, or cannot be modified to meet, the agency  s needs.\n(2) Documentation .\n(i) For proposed orders or BPAs with an estimated value exceeding the micro-purchase threshold, but not exceeding the simplified acquisition threshold, the ordering activity contracting officer shall document the basis for restricting consideration to an item peculiar to one manufacturer.\n(ii) For proposed orders or BPAs with an estimated value exceeding the simplified acquisition threshold, see paragraph (c) of this section.\n(iii) The documentation or justification must be completed and approved at the time the requirement for a brand-name item is determined. In addition, the justification for a brand-name item is required at the order level when a justification for the brand-name item was not completed for the BPA or does not adequately cover the requirements in the order.\n(3) Posting.\n(i) The ordering activity shall post the following information along with the Request for Quotation (RFQ) to e-Buy ( http://www.ebuy.gsa.gov ):\n(A) For proposed orders or BPAs with an estimated value exceeding $25,000, but not exceeding the simplified acquisition threshold, the documentation required by paragraph (b)(2)(i) of this section.\n(B) For proposed orders or BPAs with an estimated value exceeding the simplified acquisition threshold, the justification required by paragraph (c) of this section.\n(C) The documentation in paragraph (b)(2)(i) and the justification in paragraph (c) of this subsection is subject to the screening requirement in paragraph (a)(2)(iii) of this section.\n(ii) The posting requirement of paragraph (b)(3)(i) of this section does not apply when  \n(A) Disclosure would compromise the national security ( e.g. , would result in disclosure of classified information) or create other security risks. The fact that access to classified matter may be necessary to submit a proposal or perform the contract does not, in itself, justify use of this exception;\n(B) The nature of the file ( e.g. , size, format) does not make it cost-effective or practicable for contracting officers to provide access through e-Buy; or\n(C) The agency  s senior procurement executive makes a written determination that access through e-Buy is not in the Government  s interest.\n(4) When applicable, the documentation and posting requirements in paragraphs (b)(2) and (3) of this subsection apply only to the portion of the order or BPA that requires a brand-name item. If the justification and approval is to cover only the portion of the acquisition which is brand-name, then it should so state; the approval level requirements will then only apply to that portion.\n(c) An order or BPA with an estimated value exceeding the simplified acquisition threshold.\n(1) For a proposed order or BPA exceeding the simplified acquisition threshold, the requiring activity shall assist the ordering activity contracting officer in the preparation of the justification. The justification shall cite that the acquisition is conducted under the authority of the Multiple-Award Schedule Program (see 8.401 ).\n(2) At a minimum, each justification shall include the following information:\n(i) Identification of the agency and the contracting activity, and specific identification of the document as a  Limited-Sources Justification.  \n(ii) Nature and/or description of the action being approved.\n(iii) A description of the supplies or services required to meet the agency  s needs (including the estimated value).\n(iv) The authority and supporting rationale (see 8.405-6 (a)(1)(i) and (b)(1)) and, if applicable, a demonstration of the proposed contractor  s unique qualifications to provide the required supply or service.\n(v) A determination by the ordering activity contracting officer that the order represents the best value consistent with 8.404 (d).\n(vi) A description of the market research conducted among schedule holders and the results or a statement of the reason market research was not conducted.\n(vii) Any other facts supporting the justification.\n(viii) A statement of the actions, if any, the agency may take to remove or overcome any barriers that led to the restricted consideration before any subsequent acquisition for the supplies or services is made.\n(ix) The ordering activity contracting officer  s certification that the justification is accurate and complete to the best of the contracting officer  s knowledge and belief.\n(x) Evidence that any supporting data that is the responsibility of technical or requirements personnel ( e.g. , verifying the Government  s minimum needs or requirements or other rationale for limited sources) and which form a basis for the justification have been certified as complete and accurate by the technical or requirements personnel.\n(xi) For justifications under 8.405-6 (a)(1), a written determination by the approving official identifying the circumstance that applies.\n(d) Justification approvals .\n(1) For a proposed order or BPA with an estimated value exceeding the simplified acquisition threshold, but not exceeding $650,000, the ordering activity contracting officer  s certification that the justification is accurate and complete to the best of the ordering activity contracting officer  s knowledge and belief will serve as approval, unless a higher approval level is established in accordance with agency procedures.\n(2) For a proposed order or BPA with an estimated value exceeding $650,000, but not exceeding $12.5 million, the justification must be approved by the competition advocate of the activity placing the order, or by an official named in paragraph (d)(3) or (d)(4) of this section. This authority is not delegable.\n(3) For a proposed order or BPA with an estimated value exceeding $12.5 million, but not exceeding $62.5 million (or, for DoD, NASA, and the Coast Guard, not exceeding $85.5 million), the justification must be approved by  \n(i) The head of the procuring activity placing the order;\n(ii) A designee who  \n(A) If a member of the armed forces, is a general or flag officer;\n(B) If a civilian, is serving in a position in a grade above GS-15 under the General Schedule (or in a comparable or higher position under another schedule); or\n(iii) An official named in paragraph (d)(4) of this section.\n(4) For a proposed order or BPA with an estimated value exceeding $62.5 million (or, for DoD, NASA, and the Coast Guard, over $85.5 million), the justification must be approved by the senior procurement executive of the agency placing the order. This authority is not delegable, except in the case of the Under Secretary of Defense for Acquisition, Technology, and Logistics, acting as the senior procurement executive for the Department of Defense.\n8.405-7 Payment.\nAgencies may make payments for oral or written orders by any authorized means, including the Governmentwide commercial purchase card (but see 32.1108 (b)(2)).\n8.406 Ordering activity responsibilities.\n8.406-1 Order placement.\n(a) Ordering activities may place orders orally, except for  \n(1) Supplies and services not requiring a statement of work exceeding the simplified acquisition threshold;\n(2) Services requiring a statement of work (SOW); and\n(3) Orders containing brand-name specifications that exceed $25,000.\n(b) Ordering activities may use Optional Form 347 , an agency-prescribed form, or an established electronic communications format to order supplies or services from schedule contracts.\n(c) The ordering activity shall place an order directly with the contractor in accordance with the terms and conditions of the pricelists (see 8.402 (b)). Prior to placement of the order, the ordering activity shall ensure that the regulatory and statutory requirements of the requiring agency have been applied.\n(d) Orders shall include the following information in addition to any information required by the schedule contract:\n(1) Complete shipping and billing addresses.\n(2) Contract number and date.\n(3) Agency order number.\n(4) F.o.b. delivery point; i.e. , origin or destination.\n(5) Discount terms.\n(6) Delivery time or period of performance.\n(7) Special item number or national stock number.\n(8) A statement of work for services, when required, or a brief, complete description of each item (when ordering by model number, features and options such as color, finish, and electrical characteristics, if available, must be specified).\n(9) Quantity and any variation in quantity.\n(10) Number of units.\n(11) Unit price.\n(12) Total price of order.\n(13) Points of inspection and acceptance.\n(14) Other pertinent data; e.g. , delivery instructions or receiving hours and size-of-truck limitation.\n(15) Marking requirements.\n(16) Level of preservation, packaging, and packing.\n8.406-2 Inspection and acceptance.\n(a) Supplies.\n(1) Consignees shall inspect supplies at destination except when  \n(i) The schedule contract indicates that mandatory source inspection is required by the schedule contracting agency; or\n(ii) A schedule item is covered by a product description, and the ordering activity determines that the schedule contracting agency  s inspection assistance is needed (based on the ordering volume, the complexity of the supplies, or the past performance of the supplier).\n(2) When the schedule contracting agency performs the inspection, the ordering activity will provide two copies of the order specifying source inspection to the schedule contracting agency. The schedule contracting agency will notify the ordering activity of acceptance or rejection of the supplies.\n(3) Material inspected at source by the schedule contracting agency, and determined to conform with the product description of the schedule, shall not be reinspected for the same purpose. The consignee shall limit inspection to kind, count, and condition on receipt.\n(4) Unless otherwise provided in the schedule contract, acceptance is conclusive, except as regards latent defects, fraud, or such gross mistakes as amount to fraud.\n(b) Services . The ordering activity has the right to inspect all services in accordance with the contract requirements and as called for by the order. The ordering activity shall perform inspections and tests as specified in the order  s quality assurance surveillance plan in a manner that will not unduly delay the work.\n8.406-3 Remedies for nonconformance.\n(a) If a contractor delivers a supply or service, but it does not conform to the order requirements, the ordering activity shall take appropriate action in accordance with the inspection and acceptance clause of the contract, as supplemented by the order.\n(b) If the contractor fails to perform an order, or take appropriate corrective action, the ordering activity may terminate the order for cause or modify the order to establish a new delivery date (after obtaining consideration, as appropriate). Ordering activities shall follow the procedures at 8.406-4 when terminating an order for cause.\n8.406-4 Termination for cause.\n(a)(1) An ordering activity contracting officer may terminate individual orders for cause. Termination for cause shall comply with FAR 12.403 , and may include charging the contractor with excess costs resulting from repurchase.\n(2) The schedule contracting office shall be notified of all instances where an ordering activity contracting officer has terminated for cause an individual order to a Federal Supply Schedule contractor, or if fraud is suspected.\n(b) If the contractor asserts that the failure was excusable, the ordering activity contracting officer shall follow the procedures at 8.406-6 , as appropriate.\n(c) If the contractor is charged excess costs, the following apply:\n(1) Any repurchase shall be made at as low a price as reasonable, considering the quality required by the Government, delivery requirement, and administrative expenses. Copies of all repurchase orders, except the copy furnished to the contractor or any other commercial concern, shall include the notation:\nRepurchase against the account of __________ [ insert contractor  s name ] under Order __________ [ insert number ] under Contract __________ [ insert number ].\n(2) When excess costs are anticipated, the ordering activity may withhold funds due the contractor as offset security. Ordering activities shall minimize excess costs to be charged against the contractor and collect or set-off any excess costs owed.\n(3) If an ordering activity is unable to collect excess repurchase costs, it shall notify the schedule contracting office after final payment to the contractor.\n(i) The notice shall include the following information about the terminated order:\n(A) Name and address of the contractor.\n(B) Schedule, contract, and order number.\n(C) National stock or special item number(s), and a brief description of the item(s).\n(D) Cost of schedule items involved.\n(E) Excess costs to be collected.\n(F) Other pertinent data.\n(ii) The notice shall also include the following information about the purchase contract:\n(A) Name and address of the contractor.\n(B) Item repurchase cost.\n(C) Repurchase order number and date of payment.\n(D) Contract number, if any.\n(E) Other pertinent data.\n(d) Only the schedule contracting officer may modify the contract to terminate for cause any, or all, supplies or services covered by the schedule contract. If the schedule contracting officer has terminated any supplies or services covered by the schedule contract, no further orders may be placed for those items. Orders placed prior to termination for cause shall be fulfilled by the contractor, unless terminated for the convenience of the Government by the ordering activity contracting officer.\n(e) Reporting . An ordering activity contracting officer, in accordance with agency procedures, shall ensure that information related to termination for cause notices and any amendments are reported. In the event the termination for cause is subsequently converted to a termination for convenience, or is otherwise withdrawn, the contracting officer shall ensure that a notice of the conversion or withdrawal is reported. All reporting shall be in accordance with 42.1503 (h).\n8.406-5 Termination for the Government  s convenience.\n(a) An ordering activity contracting officer may terminate individual orders for the Government  s convenience. Terminations for the Government  s convenience shall comply with FAR 12.403 .\n(b) Before terminating orders for the Government  s convenience, the ordering activity contracting officer shall endeavor to enter into a  no cost  settlement agreement with the contractor.\n(c) Only the schedule contracting officer may modify the schedule contract to terminate any, or all, supplies or services covered by the schedule contract for the Government  s convenience.\n8.406-6 Disputes.\n(a) Disputes pertaining to the performance of orders under a schedule contract.\n(1) Under the Disputes clause of the schedule contract, the ordering activity contracting officer may  \n(i) Issue final decisions on disputes arising from performance of the order (but see paragraph (b) of this section); or\n(ii) Refer the dispute to the schedule contracting officer.\n(2) The ordering activity contracting officer shall notify the schedule contracting officer promptly of any final decision.\n(b) Disputes pertaining to the terms and conditions of schedule contracts . The ordering activity contracting officer shall refer all disputes that relate to the contract terms and conditions to the schedule contracting officer for resolution under the Disputes clause of the contract and notify the schedule contractor of the referral.\n(c) Appeals . Contractors may appeal final decisions to either the Board of Contract Appeals servicing the agency that issued the final decision or the U.S. Court of Federal Claims.\n(d) Alternative dispute resolution . The contracting officer should use the alternative dispute resolution (ADR) procedures, to the maximum extent practicable (see 33.204 and 33.214 ).\n8.406-7 Contractor Performance Evaluation.\nOrdering activities must prepare at least annually and at the time the work under the order is completed, an evaluation of contractor performance for each order that exceeds the simplified acquisition threshold in accordance with 42.1502 (c).");
register_book(&s, "|8|5|", "Acquisition of Helium", "Subpart 8.5  Acquisition of Helium\n8.500 Scope of subpart.\nThis subpart implements the requirements of the Helium Act ( 50 U.S.C. 167 , et seq .) concerning the acquisition of liquid or gaseous helium by Federal agencies or by Government contractors or subcontractors for use in the performance of a Government contract (also see 43 CFR Part 3195).\n8.501 Definitions.\nAs used in this subpart  \nBureau of Land Management  means the  \nDepartment of the Interior Bureau of Land Management Amarillo Field Office Helium Operations 801 South Fillmore Street Suite 500 Amarillo, TX 79101-3545.\nFederal helium supplier  means a private helium vendor that has an in-kind crude helium sales contract with the Bureau of Land Management (BLM) and that is on the BLM Amarillo Field Office  s Authorized List of Federal Helium Suppliers available via the Internet at http://blm.gov/8pjd .\nMajor helium requirement  means an estimated refined helium requirement greater than 200,000 standard cubic feet (scf) (measured at 14.7 pounds per square inch absolute pressure and 70 degrees Fahrenheit temperature) of gaseous helium or 7510 liters of liquid helium delivered to a helium use location per year.\n8.502 Policy.\nAgencies and their contractors and subcontractors must purchase major helium requirements from Federal helium suppliers, to the extent that supplies are available.\n8.503 Exception.\nThe requirements of this subpart do not apply to contracts or subcontracts in which the helium was acquired by the contractor prior to award of the contract or subcontract.\n8.504 Procedures.\nThe contracting officer must forward the following information to the Bureau of Land Management within 45 days of the close of each fiscal quarter:\n(a) The name of any company that supplied a major helium requirement.\n(b) The amount of helium purchased.\n(c) The delivery date(s).\n(d) The location where the helium was used.\n8.505 Contract clause.\nInsert the clause at 52.208-8 , Required Sources for Helium and Helium Usage Data, in solicitations and contracts if it is anticipated that performance of the contract involves a major helium requirement.");
register_book(&s, "|8|6|", "Acquisition from Federal Prison Industr", "Subpart 8.6  Acquisition from Federal Prison Industries, Inc.\n8.601 General.\n(a) Federal Prison Industries, Inc. (FPI), also referred to as UNICOR, is a self-supporting, wholly owned Government corporation of the District of Columbia.\n(b) FPI provides training and employment for prisoners confined in Federal penal and correctional institutions through the sale of its supplies and services to Government agencies ( 18 U.S.C. 4121-4128 ).\n(c) FPI diversifies its supplies and services to minimize adverse impact on private industry.\n(d) Supplies manufactured and services performed by FPI are listed in the FPI Schedule, which can be accessed at http://www.unicor.gov or by submitting a written request to Federal Prison Industries, Inc., Department of Justice, Washington, DC 20534.\n(e) Agencies are encouraged to purchase FPI supplies and services to the maximum extent practicable.\n8.602 Policy.\n(a) In accordance with 10 U.S.C. 2410n and Section 637 of Division H of the Consolidated Appropriations Act, 2005 (Pub. L. 108-447), and except as provided in paragraph (b) of this section, agencies shall  \n(1) Before purchasing an item of supply listed in the FPI Schedule, conduct market research to determine whether the FPI item is comparable to supplies available from the private sector that best meet the Government  s needs in terms of price, quality, and time of delivery. This is a unilateral determination made at the discretion of the contracting officer. The arbitration provisions of 18 U.S.C. 4124(b) do not apply.\n(2) Prepare a written determination that includes supporting rationale explaining the assessment of price, quality, and time of delivery, based on the results of market research comparing the FPI item to supplies available from the private sector.\n(3) If the FPI item is comparable, purchase the item from FPI following the ordering procedures at http://www.unicor.gov , unless a waiver is obtained in accordance with 8.604 .\n(4) If the FPI item is not comparable in one or more of the areas of price, quality, and time of delivery  \n(i) Acquire the item using  \n(A) Competitive procedures ( e.g., the procedures in 6.102 , the set-aside procedures in Subpart 19.5 , or competition conducted in accordance with Part 13 ); or\n(B) The fair opportunity procedures in 16.505 , if placing an order under a multiple award delivery-order contract;\n(ii) Include FPI in the solicitation process and consider a timely offer from FPI for award in accordance with the item description or specifications, and evaluation factors in the solicitation  \n(A) If the solicitation is available through the Governmentwide point of entry (FedBizOpps), it is not necessary to provide a separate copy of the solicitation to FPI;\n(B) If the solicitation is not available through FedBizOpps, provide a copy of the solicitation to FPI;\n(iii) When using a multiple award schedule issued under the procedures in Subpart 8.4 or when using the fair opportunity procedures in 16.505  \n(A) Establish and communicate to FPI the item description or specifications, and evaluation factors that will be used as the basis for selecting a source, so that an offer from FPI can be evaluated on the same basis as the contract or schedule holder; and\n(B) Consider a timely offer from FPI;\n(iv) Award to the source offering the item determined by the agency to provide the best value to the Government; and\n(v) When the FPI item is determined to provide the best value to the Government as a result of FPI  s response to a competitive solicitation, follow the ordering procedures at http://www.unicor.gov .\n(b) The procedures in paragraph (a) of this section do not apply if an exception in 8.605 (b) through (g) applies.\n(c) In some cases where FPI and an AbilityOne participating nonprofit agency produce identical items (see 8.603 ), FPI grants a waiver to permit the Government to purchase a portion of its requirement from the AbilityOne participating nonprofit agency. When this occurs, the portion of the requirement for which FPI has granted a waiver  \n(1) Shall be purchased from the AbilityOne participating nonprofit agency using the procedures in Subpart 8.7 ; and\n(2) Shall not be subject to the procedures in paragraph (a) of this section.\n(d) Disputes regarding price, quality, character, or suitability of supplies produced by FPI, except for determinations under paragraph (a)(1) of this section, are subject to arbitration as specified in 18 U.S.C. 4124 . The statute provides that the arbitration shall be conducted by a board consisting of the Comptroller General of the United States, the Administrator of General Services, and the President, or their representatives. The decisions of the board are final and binding on all parties.\n8.603 Purchase priorities.\nFPI and nonprofit agencies participating in the AbilityOne Program under the Javits-Wagner-O  Day Act (see Subpart 8.7 ) may produce identical supplies or services. When this occurs, ordering offices shall purchase supplies and services in the following priorities:\n(a) Supplies.\n(1) Federal Prison Industries, Inc. ( 41 U.S.C. 48 ).\n(2) AbilityOne participating nonprofit agencies.\n(3) Commercial sources.\n(b) Services.\n(1) AbilityOne participating nonprofit agencies.\n(2) Federal Prison Industries, Inc., or commercial sources.\n8.604 Waivers.\nFPI may grant a waiver for purchase of supplies in the FPI Schedule from another source. FPI waivers ordinarily are of the following types:\n(a) General or blanket waivers issued when classes of supplies are not available from FPI.\n(b) Formal waivers issued in response to requests from offices desiring to acquire, from other sources, supplies listed in the FPI Schedule and not covered by a general waiver. Agencies shall process waiver requests in accordance with the procedures at http://www.unicor.gov .\n8.605 Exceptions.\nPurchase from FPI is not mandatory and a waiver is not required if  \n(a)(1) The contracting officer makes a determination that the FPI item of supply is not comparable to supplies available from the private sector that best meet the Government  s needs in terms of price, quality, and time of delivery; and\n(2) The item is acquired in accordance with 8.602 (a)(4);\n(b) Public exigency requires immediate delivery or performance;\n(c) Suitable used or excess supplies are available;\n(d) The supplies are acquired and used outside the United States;\n(e) Acquiring listed items totaling $3,000 or less;\n(f) Acquiring items that FPI offers exclusively on a competitive (non-mandatory) basis, as identified in the FPI Schedule; or\n(g) Acquiring services.\n8.606 Evaluating FPI performance.\nAgencies shall evaluate FPI contract performance in accordance with Subpart 42.15 . Performance evaluations do not negate the requirements of 8.602 and 8.604 , but they may be used to support a waiver request in accordance with 8.604 .\n8.607 Performance as a subcontractor.\nAgencies shall not require a contractor, or subcontractor at any tier, to use FPI as a subcontractor for performance of a contract by any means, including means such as  \n(a) A solicitation provision requiring a potential contractor to offer to make use of FPI supplies or services;\n(b) A contract specification requiring the contractor to use specific supplies or services (or classes of supplies or services) offered by FPI; or\n(c) Any contract modification directing the use of FPI supplies or services.\n8.608 Protection of classified and sensitive information.\nAgencies shall not enter into any contract with FPI that allows an inmate worker access to any  \n(a) Classified data;\n(b) Geographic data regarding the location of  \n(1) Surface and subsurface infrastructure providing communications or water or electrical power distribution;\n(2) Pipelines for the distribution of natural gas, bulk petroleum products, or other commodities; or\n(3) Other utilities; or\n(c) Personal or financial information about any individual private citizen, including information relating to such person  s real property however described, without the prior consent of the individual.");
register_book(&s, "|8|7|", "Acquisition from Nonprofit Agencies Emp", "Subpart 8.7  Acquisition from Nonprofit Agencies Employing People Who Are Blind or Severely Disabled\n8.700 Scope of subpart.\nThis subpart prescribes the policies and procedures for implementing the Javits-Wagner-O  Day Act ( 41 U.S.C. 46-48c ) and the rules of the Committee for Purchase from People Who Are Blind or Severely Disabled (41 CFR Chapter 51) which implements the AbilityOne Program.\n8.701 Definitions.\nAs used in this subpart  \nAllocation  means an action taken by a central nonprofit agency to designate the AbilityOne participating nonprofit agencies that will furnish definite quantities of supplies or perform specific services upon receipt of orders from ordering offices.\nCentral nonprofit agency  means National Industries for the Blind (NIB), which has been designated to represent people who are blind; or NISH, which has been designated to represent AbilityOne participating nonprofit agencies serving people with severe disabilities other than blindness.\nCommittee  means the Committee for Purchase from People Who Are Blind or Severely Disabled.\nGovernment  or  entity of the Government  means any entity of the legislative or judicial branch, any executive agency, military department, Government corporation, or independent establishment, the U.S. Postal Service, or any nonappropriated-fund instrumentality of the Armed Forces.\nOrdering office  means any activity in an entity of the Government that places orders for the purchase of supplies or services under the AbilityOne Program.\nProcurement List  means a list of supplies (including military resale commodities) and services that the Committee has determined are suitable for purchase by the Government under the Javits-Wagner-O  Day Act.\nNonprofit agency serving people who are blind  or  nonprofit agency serving people with other severe disabilities  (referred to jointly as AbilityOne participating nonprofit agencies) means a qualified nonprofit agency employing people who are blind or have other severe disabilities approved by the Committee to furnish a commodity or a service to the Government under the Act.\n8.702 General.\nThe Committee is an independent Government activity with members appointed by the President of the United States. It is responsible for  \n(a) Determining those supplies and services to be purchased by all entities of the Government from AbilityOne participating nonprofit agencies;\n(b) Establishing prices for the supplies and services; and\n(c) Establishing rules and regulations to implement the Javits-Wagner-O  Day Act.\n8.703 Procurement List.\nThe Committee maintains a Procurement List of all supplies and services required to be purchased from AbilityOne participating nonprofit agencies. The Procurement List may be accessed at: http://www.abilityone.gov . Questions concerning whether a supply item or service is on the Procurement List may be submitted at Internet e-mail address info@abilityone.gov or referred to the Committee offices at the following address and telephone number: \nCommittee for Purchase From People Who Are Blind or Severely Disabled, 1401 S. Clark Street, Suite 10800, Arlington, VA 22202-3259, (703) 603-7740.\nMany items on the Procurement List are identified in the General Services Administration (GSA) Supply Catalog and GSA  s Customer Service Center Catalogs with a black square and the words  NIB/NISH Mandatory Source,  and in similar catalogs issued by the Defense Logistics Agency (DLA) and the Department of Veterans Affairs (VA). GSA, DLA, and VA are central supply agencies from which other Federal agencies are required to purchase certain supply items on the Procurement List.\n8.704 Purchase priorities.\n(a) The Javits-Wagner-O  Day Act requires the Government to purchase supplies or services on the Procurement List, at prices established by the Committee, from AbilityOne participating nonprofit agencies if they are available within the period required. When identical supplies or services are on the Procurement List and the Schedule of Products issued by Federal Prison Industries, Inc., ordering offices shall purchase supplies and services in the following priorities:\n(1) Supplies:\n(i) Federal Prison Industries, Inc. ( 41 U.S.C. 48 ).\n(ii) AbilityOne participating nonprofit agencies.\n(iii) Commercial sources.\n(2) Services:\n(i) AbilityOne participating nonprofit agencies.\n(ii) Federal Prison Industries, Inc., or commercial sources.\n(b) No other provision of the FAR shall be construed as permitting an exception to the mandatory purchase of items on the Procurement List.\n(c) The Procurement List identifies those supplies for which the ordering office must obtain a formal waiver ( 8.604 ) from Federal Prison Industries, Inc., before making any purchases from AbilityOne participating nonprofit agencies.\n8.705 Procedures.\n8.705-1 General.\n(a) Ordering offices shall obtain supplies and services on the Procurement List from the central nonprofit agency or its designated AbilityOne participating nonprofit agencies, except that supplies identified on the Procurement List as available from DLA, GSA, or VA supply distribution facilities shall be obtained through DLA, GSA, or VA procedures. If a distribution facility cannot provide the supplies, it shall inform the ordering office, which shall then order from the AbilityOne participating nonprofit agency designated by the Committee.\n(b) Supply distribution facilities in DLA and GSA shall obtain supplies on the Procurement List from the central nonprofit agency identified or its designated AbilityOne participating nonprofit agency.\n8.705-2 Direct-order process.\nCentral nonprofit agencies may authorize ordering offices to transmit orders for specific supplies or services directly to an AbilityOne participating nonprofit agency. The written authorization remains valid until it is revoked by the central nonprofit agency or the Committee. The central nonprofit agency shall specify the normal delivery or performance lead time required by the nonprofit agency. The ordering office shall reflect this lead time in its orders.\n8.705-3 Allocation process.\n(a) When the direct order process has not been authorized, the ordering office shall submit a letter request for allocation (requesting the designation of the AbilityOne participating nonprofit agency to produce the supplies or perform the service) to the central nonprofit agency designated in the Procurement List. Ordering offices shall request allocations in sufficient time for a reply, for orders to be placed, and for the nonprofit agency to produce the supplies or provide the service within the required delivery or performance schedule.\n(b) The ordering office  s request to the central nonprofit agency for allocation shall include the following information:\n(1) For supplies  Item name, stock number, latest specification, quantity, unit price, date delivery is required, and destination to which delivery is to be made.\n(2) For services  Type and location of service required, latest specification, work to be performed, estimated volume, and required date or dates for completion.\n(3) Other requirements; e.g., packing, marking, as necessary.\n(c) When an allocation is received, the ordering office shall promptly issue an order to the specified AbilityOne participating nonprofit agency or to the central nonprofit agency, as instructed by the allocation. If the issuance of an order is to be delayed for more than 15 days beyond receipt of the allocation, or canceled, the ordering office shall advise the central nonprofit agency immediately.\n(d) Ordering offices may issue orders without limitation as to dollar amount and shall record them upon issuance as obligations. Each order shall include, as a minimum, the information contained in the request for allocation. Ordering offices shall also include additional instructions necessary for performance under the order; e.g., on the handling of Government-furnished property, reports required, and notification of shipment.\n8.705-4 Compliance with orders.\n(a) The central nonprofit agency shall inform the ordering office of changes in lead time experienced by its AbilityOne participating nonprofit agencies to minimize requests for extension once the ordering office places an order.\n(b) The ordering office shall grant a request by a central nonprofit agency or AbilityOne participating nonprofit agency for revision in the delivery or completion schedule, if feasible. If extension of the delivery or completion date is not feasible, the ordering office shall notify the appropriate central nonprofit agency and request that it reallocate the order, or grant a purchase exception authorizing acquisition from commercial sources.\n(c) When an AbilityOne participating nonprofit agency fails to perform under the terms of an order, the ordering office shall make every effort to resolve the noncompliance with the nonprofit agency involved and to negotiate an adjustment before taking action to cancel the order. If the problem cannot be resolved with the nonprofit agency, the ordering office shall refer the matter for resolution first to the central nonprofit agency and then, if necessary, to the Committee.\n(d) When, after complying with 8.705-4 (c), the ordering office determines that it must cancel an order, it shall notify the central nonprofit agency and, if practical, request a reallocation of the order. When the central nonprofit agency cannot reallocate the order, it shall grant a purchase exception permitting use of commercial sources, subject to approval by the Committee when the value of the purchase exception is $25,000 or more.\n8.706 Purchase exceptions.\n(a) Ordering offices may acquire supplies or services on the Procurement List from commercial sources only if the acquisition is specifically authorized in a purchase exception granted by the designated central nonprofit agency.\n(b) The central nonprofit agency shall promptly grant purchase exceptions when  \n(1) The AbilityOne participating nonprofit agencies cannot provide the supplies or services within the time required, and commercial sources can provide them significantly sooner in the quantities required; or\n(2) The quantity required cannot be produced or provided economically by the AbilityOne participating nonprofit agencies.\n(c) The central nonprofit agency granting the exception shall specify the quantity and delivery or performance period covered by the exception.\n(d) When a purchase exception is granted, the contracting officer shall  \n(1) Initiate purchase action within 15 days following the date of the exception or any extension granted by the central nonprofit agency; and\n(2) Provide a copy of the solicitation to the central nonprofit agency when it is issued.\n(e) The Committee may also grant a purchase exception, under any circumstances it considers appropriate.\n8.707 Prices.\n(a) The prices of items on the Procurement List are fair market prices established by the Committee. All prices for supplies ordered under this subpart are f.o.b. origin.\n(b) Prices for supplies are normally adjusted semiannually. Prices for services are normally adjusted annually.\n(c) The Committee may request the agency responsible for acquiring the supplies or service to assist it in establishing or revising the fair market price. The Committee has the authority to establish prices without prior coordination with the responsible contracting office.\n(d) Price changes shall normally apply to all orders received by the AbilityOne participating nonprofit agency on or after the effective date of the change. In special cases, after considering the views of the ordering office, the Committee may make price changes applicable to orders received by the AbilityOne participating nonprofit agency prior to the effective date of the change.\n(e) If an ordering office desires packing, packaging, or marking of supplies other than the standard pack as provided on the Procurement List, any difference in costs shall be included as a separate item on the nonprofit agency  s invoice. The ordering office shall reimburse the nonprofit agency for these costs.\n(f) Ordering offices may make recommendations to the Committee at any time for price revisions for supplies and services on the Procurement List.\n8.708 Shipping.\n(a) Delivery is accomplished when a shipment is placed aboard the vehicle of the initial carrier. The time of delivery is the date shipment is released to and accepted by the initial carrier.\n(b) Shipment is normally under Government bills of lading. However, for small orders, ordering offices may specify other shipment methods.\n(c) When shipments are under Government bills of lading, the bills of lading may accompany orders or be otherwise furnished promptly. Failure of an ordering office to furnish bills of lading or to designate a method of transportation may result in an excusable delay in delivery.\n(d) AbilityOne participating nonprofit agencies shall include transportation costs for small shipments paid by the nonprofit agencies as an item on the invoice. The ordering office shall reimburse the nonprofit agencies for these costs.\n8.709 Payments.\nThe ordering office shall make payments for supplies or services on the Procurement List within 30 days after shipment or after receipt of a proper invoice or voucher.\n8.710 Quality of merchandise.\nSupplies and services provided by AbilityOne participating nonprofit agencies shall comply with the applicable Government specifications and standards cited in the order. When no specifications or standards exist  \n(a) Supplies shall be of the highest quality and equal to similar items available on the commercial market; and\n(b) Services shall conform to good commercial practices.\n8.711 Quality complaints.\n(a) When the quality of supplies or services received is unsatisfactory, the using activity shall take the following actions:\n(1) For supplies received from DLA supply centers, GSA supply distribution facilities, or Department of Veterans Affairs distribution division, notify the supplying agency.\n(2) For supplies or services received from AbilityOne participating nonprofit agencies, address complaints to the individual nonprofit agency involved, with a copy to the appropriate central nonprofit agency.\n(b) When quality problems cannot be resolved by the AbilityOne participating nonprofit agency and the ordering office, the ordering office shall first contact the central nonprofit agency and then, if necessary, the Committee for resolution.\n8.712 Specification changes.\n(a) The contracting activity shall notify the AbilityOne participating nonprofit agency and appropriate central nonprofit agency of any change in specifications or descriptions. In the absence of such written notification, the AbilityOne participating nonprofit agency shall furnish the supplies or services under the specification or description cited in the order.\n(b) The contracting activity shall provide 90-days advance notification to the Committee and the central nonprofit agency on actions that affect supplies on the Procurement List and shall permit them to comment before action is taken, particularly when it involves  \n(1) Changes that require new national stock numbers or item designations;\n(2) Deleting items from the supply system;\n(3) Standardization; or\n(4) Developing new items to replace items on the Procurement List.\n(c) For services, the contracting activity shall notify the AbilityOne participating nonprofit agency and central nonprofit agency concerned at least 90 days prior to the date that any changes in the scope of work or other conditions will be required.\n(d) When, in order to meet its emergency needs, a contracting activity is unable to give the 90-day notification required in paragraphs (b) and (c) of this section, the contracting activity shall, at the time it places the order or change notice, inform the AbilityOne participating nonprofit agency and the central nonprofit agency in writing of the reasons that it cannot meet the 90-day notification requirement.\n8.713 Optional acquisition of supplies and services.\n(a) Ordering offices may acquire supplies and services not included on the Procurement List from an AbilityOne participating nonprofit agency that is the low responsive, responsible offeror under a solicitation issued by other authorized acquisition methods.\n(b) Ordering offices should forward solicitations to AbilityOne participating nonprofit agencies that may be qualified to provide the supplies or services required.\n8.714 Communications with the central nonprofit agencies and the Committee.\n(a) The addresses of the central nonprofit agencies are:\n(1) National Industries for the Blind 1310 Braddock Place Alexandria, VA 22314-1691 (703) 310-0500; and\n(2) NISH 8401 Old Courthouse Road Vienna, VA 22182 (571) 226-4660.\n(b) Any matter requiring referral to the Committee shall be addressed to:\nExecutive Director of the Committee, 1401 S. Clark Street, Suite 10800, Arlington, VA 22202-3259.\n8.715 Replacement commodities.\nWhen a commodity on the Procurement List is replaced by another commodity which has not been previously acquired, and a qualified AbilityOne participating nonprofit agency can furnish the replacement commodity in accordance with the Government  s quality standards and delivery schedules and at a fair market price, the replacement commodity is automatically on the Procurement List and shall be acquired from the AbilityOne participating nonprofit agency designated by the Committee. The commodity being replaced shall continue to be included on the Procurement List until there is no longer a requirement for that commodity.\n8.716 Change-of-name and successor in interest procedures.\nWhen the Committee recognizes a name change or a successor in interest for an AbilityOne participating nonprofit agency providing supplies or services on the Procurement List  \n(a) The Committee will provide a notice of a change to the Procurement List to the cognizant contracting officers; and\n(b) Upon receipt of a notice of a change to the Procurement List from the Committee, the contracting officer must  \n(1) Prepare a Standard Form (SF) 30 , Amendment of Solicitation/Modification of Contract, incorporating a summary of the notice and attaching a list of contracts affected; and\n(2) Distribute the SF 30 , including a copy to the Committee.");
register_book(&s, "|8|8|", "Acquisition of Printing and Related Sup", "Subpart 8.8  Acquisition of Printing and Related Supplies\n8.800 Scope of subpart.\nThis subpart provides policy for the acquisition of Government printing and related supplies.\n8.801 Definitions.\nAs used in this subpart  \nGovernment printing  means printing, binding, and blankbook work for the use of an executive department, independent agency, or establishment of the Government.\nRelated supplies  means supplies that are used and equipment that is usable in printing and binding operations.\n8.802 Policy.\n(a) Government printing must be done by or through the Government Printing Office (GPO) ( 44 U.S.C. 501 ), unless  \n(1) The GPO cannot provide the printing service ( 44 U.S.C. 504 );\n(2) The printing is done in field printing plants operated by an executive agency ( 44 U.S.C. 501(2) );\n(3) The printing is acquired by an executive agency from allotments for contract field printing ( 44 U.S.C. 501(2) ); or\n(4) The printing is specifically authorized by statute to be done other than by the GPO.\n(b) The head of each agency shall designate a central printing authority; that central printing authority may serve as the liaison with the Congressional Joint Committee on Printing (JCP) and the Public Printer on matters related to printing. Contracting officers shall obtain approval from their designated central printing authority before contracting in any manner, whether directly or through contracts for supplies or services, for the items defined in 8.801 and for composition, platemaking, presswork, binding, and micrographics (when used as a substitute for printing).\n(c)(1) Further, 44 U.S.C. 1121 provides that the Public Printer may acquire and furnish paper and envelopes (excluding envelopes printed in the course of manufacture) in common use by two or more Government departments, establishments, or services within the District of Columbia, and provides for reimbursement of the Public Printer from available appropriations or funds. Paper and envelopes that are furnished by the Public Printer may not be acquired in any other manner.\n(2) Paper and envelopes for use by Executive agencies outside the District of Columbia and stocked by GSA shall be requisitioned from GSA in accordance with the procedures listed in Federal Property Management Regulations (FPMR) Subpart 101-26.3.");
register_book(&s, "|8|11|", "Leasing of Motor Vehicles", "Subpart 8.11  Leasing of Motor Vehicles\n8.1100 Scope of subpart.\nThis subpart covers the procedures for the leasing, from commercial concerns, of motor vehicles that comply with Federal Motor Vehicle Safety Standards and applicable State motor vehicle safety regulations. It does not apply to motor vehicles leased outside the United States and its outlying areas.\n8.1101 Definitions.\nAs used in this subpart  \nLeasing  means the acquisition of motor vehicles, other than by purchase from private or commercial sources, and includes the synonyms  hire  and  rent.  \nMotor vehicle  means an item of equipment, mounted on wheels and designed for highway and/or land use, that  \n(1) Derives power from a self-contained power unit; or\n(2) Is designed to be towed by and used in conjunction with self-propelled equipment.\n8.1102 Presolicitation requirements.\n(a) Except as specified in 8.1102 (b), before preparing solicitations for leasing of motor vehicles, contracting officers shall obtain from the requiring activity a written certification that  \n(1) The vehicles requested are of maximum fuel efficiency and minimum body size, engine size, and equipment (if any) necessary to fulfill operational needs, and meet prescribed fuel economy standards;\n(2) The head of the requiring agency, or a designee, has certified that the requested passenger automobiles (sedans and station wagons) larger than Type IA, IB, or II (small, subcompact, or compact) are essential to the agency  s mission;\n(3) Internal approvals have been received; and\n(4) The General Services Administration has advised that it cannot furnish the vehicles.\n(b) With respect to requirements for leasing motor vehicles for a period of less than 60 days, the contracting officer need not obtain the certification specified in 8.1102 (a)  \n(1) If the requirement is for type 1A, 1B, or II vehicles, which are by definition fuel efficient; or\n(2) If the requirement is for passenger vehicles larger than 1A, 1B, or II, and the agency has established procedures for advance approval, on a case-by-case basis, of such requirements.\n(c) Generally, solicitations shall not be limited to current year production models. However, with the prior approval of the head of the contracting office, solicitations may be limited to current models on the basis of overall economy.\n8.1103 Contract requirements.\nContracting officers shall include the following items in each contract for leasing motor vehicles:\n(a) Scope of contract.\n(b) Method of computing payments.\n(c) A listing of the number and type of vehicles required, and the equipment and accessories to be provided with each vehicle.\n(d) Responsibilities of the contractor or the Government for furnishing gasoline, motor oil, antifreeze, and similar items.\n(e) Unless it is determined that it will be more economical for the Government to perform the work, a statement that the contractor shall perform all maintenance on the vehicles.\n(f) A statement as to the applicability of pertinent State and local laws and regulations, and the responsibility of each party for compliance with them.\n(g) Responsibilities of the contractor or the Government for emergency repairs and services.\n8.1104 Contract clauses.\nInsert the following clauses in solicitations and contracts for leasing of motor vehicles, unless the motor vehicles are leased in foreign countries:\n(a) The clause at 52.208-4 , Vehicle Lease Payments.\n(b) The clause at 52.208-5 , Condition of Leased Vehicles.\n(c) The clause at 52.208-6 , Marking of Leased Vehicles.\n(d) A clause substantially the same as the clause at 52.208-7 , Tagging of Leased Vehicles, for vehicles leased over 60 days (see Subpart B of 41 CFR Part 102-34).\n(e) The provisions and clauses prescribed elsewhere in the FAR for solicitations and contracts for supplies when a fixed-price contract is contemplated, but excluding  \n(1) The clause at 52.211-16 , Variation in Quantity;\n(2) The clause at 52.232-1 , Payments;\n(3) The clause at 52.222-20 , Walsh-Healey Public Contracts Act; and\n(4) The clause at 52.246-16 , Responsibility for Supplies.\n*    *    *    *    *    *");
register_book(&s, "|9|2|", "Qualifications Requirements", "Subpart 9.2  Qualifications Requirements\n9.200 Scope of subpart.\nThis subpart implements 10 U.S.C. 2319 and 41 U.S.C.253c and prescribes policies and procedures regarding qualification requirements and the acquisitions that are subject to such requirements.\n9.201 Definitions.\nAs used in this subpart  \nQualified bidders list (QBL)  means a list of bidders who have had their products examined and tested and who have satisfied all applicable qualification requirements for that product or have otherwise satisfied all applicable qualification requirements.\nQualified manufacturers list (QML)  means a list of manufacturers who have had their products examined and tested and who have satisfied all applicable qualification requirements for that product.\n9.202 Policy.\n(a)(1) The head of the agency or designee shall, before establishing a qualification requirement, prepare a written justification  \n(i) Stating the necessity for establishing the qualification requirement and specifying why the qualification requirement must be demonstrated before contract award;\n(ii) Estimating the likely costs for testing and evaluation which will be incurred by the potential offeror to become qualified; and\n(iii) Specifying all requirements that a potential offeror (or its product) must satisfy in order to become qualified. Only those requirements which are the least restrictive to meet the purposes necessitating the establishment of the qualification requirements shall be specified.\n(2) Upon request to the contracting activity, potential offerors shall be provided  \n(i) All requirements that they or their products must satisfy to become qualified; and\n(ii) At their expense (but see 9.204 (a)(2) with regard to small businesses), a prompt opportunity to demonstrate their abilities to meet the standards specified for qualification using qualified personnel and facilities of the agency concerned, or of another agency obtained through interagency agreements or under contract, or other methods approved by the agency (including use of approved testing and evaluation services not provided under contract to the agency).\n(3) If the services in (a)(2)(ii) of this section are provided by contract, the contractors selected to provide testing and evaluation services shall be  \n(i) Those that are not expected to benefit from an absence of additional qualified sources; and\n(ii) Required by their contracts to adhere to any restriction on technical data asserted by the potential offeror seeking qualification.\n(4) A potential offeror seeking qualification shall be promptly informed as to whether qualification is attained and, in the event it is not, promptly furnished specific reasons why qualification was not attained.\n(b) When justified under the circumstances, the agency activity responsible for establishing a qualification requirement shall submit to the competition advocate for the procuring activity responsible for purchasing the item subject to the qualification requirement, a determination that it is unreasonable to specify the standards for qualification which a prospective offeror (or its product) must satisfy. After considering any comments of the competition advocate reviewing the determination, the head of the procuring activity may waive the requirements of 9.202 (a)(1)(ii) through (4) for up to 2 years with respect to the item subject to the qualification requirement. A copy of the waiver shall be furnished to the head of the agency or other official responsible for actions under 9.202 (a)(1). The waiver authority provided in this paragraph does not apply with respect to qualification requirements contained in a QPL, QML, or QBL.\n(c) If a potential offeror can demonstrate to the satisfaction of the contracting officer that the potential offeror (or its product) meets the standards established for qualification or can meet them before the date specified for award of the contract, a potential offeror may not be denied the opportunity to submit and have considered an offer for a contract solely because the potential offeror  \n(1) Is not on a QPL, QML, or QBL maintained by the Department of Defense (DoD) or the National Aeronautics and Space Administration (NASA); or\n(2) Has not been identified as meeting a qualification requirement established after October 19, 1984, by DoD or NASA; or\n(3) Has not been identified as meeting a qualification requirement established by a civilian agency (not including NASA).\n(d) The procedures in Subpart 19.6 for referring matters to the Small Business Administration are not mandatory on the contracting officer when the basis for a referral would involve a challenge by the offeror to either the validity of the qualification requirement or the offeror  s compliance with such requirement.\n(e) The contracting officer need not delay a proposed award in order to provide a potential offeror with an opportunity to demonstrate its ability to meet the standards specified for qualification. In addition, when approved by the head of an agency or designee, a procurement need not be delayed in order to comply with 9.202 (a).\n(f) Within 7 years following enforcement of a QPL, QML, or QBL by DoD or NASA, or within 7 years after any qualification requirement was originally established by a civilian agency other than NASA, the qualification requirement shall be examined and revalidated in accordance with the requirements of 9.202 (a). For DoD and NASA, qualification requirements other than QPL  s, QML  s and QBL  s shall be examined and revalidated within 7 years after establishment of the requirement under 9.202 (a). Any periods for which a waiver under 9.202 (b) is in effect shall be excluded in computing the 7 years within which review and revalidation must occur.\n9.203 QPL  s, QML  s, and QBL  s.\n(a) Qualification and listing in a QPL, QML, or QBL is the process by which products are obtained from manufacturers or distributors, examined and tested for compliance with specification requirements, or manufacturers or potential offerors, are provided an opportunity to demonstrate their abilities to meet the standards specified for qualification. The names of successful products, manufacturers, or potential offerors are included on lists evidencing their status. Generally, qualification is performed in advance and independently of any specific acquisition action. After qualification, the products, manufacturers, or potential offerors are included in a Federal or Military QPL, QML, or QBL. (See 9.202 (a)(2) with regard to any product, manufacturer, or potential offeror not yet included on an applicable list.)\n(b) Specifications requiring a qualified product are included in the following publications:\n(1) GSA Index of Federal Specifications, Standards and Commercial Item Descriptions, FPMR 101-29.1.\n(2) Department of Defense Acquisition Streamlining and Standardization Information System (ASSIST) at ( http://assist.daps.dla.mil ).\n(c) Instructions concerning qualification procedures are included in the following publications:\n(1) Federal Standardization Manual, FSPM-0001.\n(2) Defense Standardization Manual 4120.24-M, Appendix 2, as amended by Military Standards 961 and 962.\n(d) The publications listed in paragraphs (b) and (c) of this section are sold to the public. The publications in paragraphs (b)(1) and (c)(1) of this section may be obtained from the addressee in 11.201 (d)(1). The publications in paragraphs (b)(2) and (c)(2) of this section may be obtained from the addressee in 11.201 (d)(2).\n9.204 Responsibilities for establishment of a qualification requirement.\nThe responsibilities of agency activities that establish qualification requirements include the following:\n(a) Arranging publicity for the qualification requirements. If active competition on anticipated future qualification requirements is likely to be fewer than two manufacturers or the products of two manufacturers, the activity responsible for establishment of the qualification requirements must  \n(1) Periodically furnish through the Governmentwide point of entry (GPE) a notice seeking additional sources or products for qualification unless the contracting officer determines that such publication would compromise the national security.\n(2) Bear the cost of conducting the specified testing and evaluation (excluding the costs associated with producing the item or establishing the production, quality control, or other system to be tested and evaluated) for a small business concern or a product manufactured by a small business concern which has met the standards specified for qualification and which could reasonably be expected to compete for a contract for that requirement. However, such costs may be borne only if it is determined in accordance with agency procedures that such additional qualified sources or products are likely to result in cost savings from increased competition for future requirements sufficient to amortize the costs incurred by the agency within a reasonable period of time, considering the duration and dollar value of anticipated future requirements. A prospective contractor requesting the United States to bear testing and evaluation costs must certify as to its status as a small business concern under Section 3 of the Small Business Act in order to receive further consideration.\n(b) Qualifying products that meet specification requirements.\n(c) Listing manufacturers and suppliers whose products are qualified in accordance with agency procedures.\n(d) Furnishing QPL  s, QML  s, or QBL  s or the qualification requirements themselves to prospective offerors and the public upon request (see 9.202 (a)(2)(i)).\n(e) Clarifying, as necessary, qualification requirements.\n(f) In appropriate cases, when requested by the contracting officer, providing concurrence in a decision not to enforce a qualification requirement for a solicitation.\n(g) Withdrawing or omitting qualification of a listed product, manufacturer or offeror, as necessary.\n(h) Advising persons furnished any list of products, manufacturers or offerors meeting a qualification requirement and suppliers whose products are on any such list that  \n(1) The list does not constitute endorsement of the product, manufacturer, or other source by the Government;\n(2) The products or sources listed have been qualified under the latest applicable specification;\n(3) The list may be amended without notice;\n(4) The listing of a product or source does not release the supplier from compliance with the specification; and\n(5) Use of the list for advertising or publicity is permitted. However, it must not be stated or implied that a particular product or source is the only product or source of that type qualified, or that the Government in any way recommends or endorses the products or the sources listed.\n(i) Reexamining a qualified product or manufacturer when  \n(1) The manufacturer has modified its product, or changed the material or the processing sufficiently so that the validity of previous qualification is questionable;\n(2) The requirements in the specification have been amended or revised sufficiently to affect the character of the product; or\n(3) It is otherwise necessary to determine that the quality of the product is maintained in conformance with the specification.\n9.205 Opportunity for qualification before award.\n(a) If an agency determines that a qualification requirement is necessary, the agency activity responsible for establishing the requirement must urge manufacturers and other potential sources to demonstrate their ability to meet the standards specified for qualification and, when possible, give sufficient time to arrange for qualification before award. The responsible agency activity must, before establishing any qualification requirement, furnish notice through the GPE. The notice must include  \n(1) Intent to establish a qualification requirement;\n(2) The specification number and name of the product;\n(3) The name and address of the activity to which a request for the information and opportunity described in 9.202 (a)(2) should be submitted;\n(4) The anticipated date that the agency will begin awarding contracts subject to the qualification requirement;\n(5) A precautionary notice that when a product is submitted for qualification testing, the applicant must furnish any specific information that may be requested of the manufacturer before testing will begin; and\n(6) The approximate time period following submission of a product for qualification testing within which the applicant will be notified whether the product passed or failed the qualification testing (see 9.202 (a)(4)).\n(b) The activity responsible for establishing a qualification requirement must keep any list maintained of those already qualified open for inclusion of additional products, manufacturers, or other potential sources.\n9.206 Acquisitions subject to qualification requirements.\n9.206-1 General.\n(a) Agencies may not enforce any QPL, QML, or QBL without first complying with the requirements of 9.202 (a). However, qualification requirements themselves, whether or not previously embodied in a in a QPL, QML, or QBL, may be enforced without regard to 9.202 (a) if they are in either of the following categories:\n(1) Any qualification requirement established by statute prior to October 30, 1984, for civilian agencies (not including NASA); or\n(2) Any qualification requirement established by statute or administrative action prior to October 19, 1984, for DoD or NASA. Qualification requirements established after the above dates must comply with 9.202 (a) to be enforceable.\n(b) Except when the agency head or designee determines that an emergency exists, whenever an agency elects, whether before or after award, not to enforce a qualification requirement which it established, the requirement may not thereafter be enforced unless the agency complies with 9.202 (a).\n(c) If a qualification requirement applies, the contracting officer need consider only those offers identified as meeting the requirement or included on the applicable QPL, QML, or QBL, unless an offeror can satisfactorily demonstrate to the contracting officer that it or its product or its subcontractor or its product can meet the standards established for qualification before the date specified for award.\n(d) If a product subject to a qualification requirement is to be acquired as a component of an end item, the contracting officer must ensure that all such components and their qualification requirements are properly identified in the solicitation since the product or source must meet the standards specified for qualification before award.\n(e) In acquisitions subject to qualification requirements, the contracting officer shall take the following steps:\n(1) Use presolicitation notices in appropriate cases to advise potential suppliers before issuing solicitations involving qualification requirements. The notices shall identify the specification containing the qualification requirement and establish an allowable time period, consistent with delivery requirements, for prospective offerors to demonstrate their abilities to meet the standards specified for qualification. The notice shall be publicized in accordance with 5.204 . Whether or not a presolicitation notice is used, the general synopsizing requirements of Subpart 5.2 apply.\n(2) Distribute solicitations to prospective contractors whether or not they have been identified as meeting applicable qualification requirements.\n(3) When appropriate, request in accordance with agency procedures that a qualification requirement not be enforced in a particular acquisition and, if granted, so specify in the solicitation (see 9.206-1 (b)).\n(4) Forward requests from potential suppliers for information on a qualification requirement to the agency activity responsible for establishing the requirement.\n(5) Allow the maximum time, consistent with delivery requirements, between issuing the solicitation and the contract award. As a minimum, contracting officers shall comply with the time frames specified in 5.203 when applicable.\n9.206-2 Contract clause.\nThe contracting officer shall insert the clause at 52.209-1 , Qualification Requirements, in solicitations and contracts when the acquisition is subject to a qualification requirement.\n9.206-3 Competition.\n(a) Presolicitation . If a qualification requirement applies to an acquisition, the contracting officer shall review the applicable QPL, QML, or QBL or other identification of those sources which have met the requirement before issuing a solicitation to ascertain whether the number of sources is adequate for competition. (See 9.204 (a) for duties of the agency activity responsible for establishment of the qualification requirement.) If the number of sources is inadequate, the contracting officer shall request the agency activity which established the requirement to  \n(1) Indicate the anticipated date on which any sources presently undergoing evaluation will have demonstrated their abilities to meet the qualification requirement so that the solicitation could be rescheduled to allow as many additional sources as possible to qualify; or\n(2) Indicate whether a means other than the qualification requirement is feasible for testing or demonstrating quality assurance.\n(b) Post solicitation . The contracting officer shall submit to the agency activity which established the qualification requirement the names and addresses of concerns which expressed interest in the acquisition but are not included on the applicable QPL, QML, or QBL or identified as meeting the qualification requirement. The activity will then assist interested concerns in meeting the standards specified for qualification (see 9.202 (a)(2) and (4)).\n9.207 Changes in status regarding qualification requirements.\n(a) The contracting officer shall promptly report to the agency activity which established the qualification requirement any conditions which may merit removal or omission from a QPL, QML, or QBL or affect whether a source should continue to be otherwise identified as meeting the requirement. These conditions exist when  \n(1) Products or services are submitted for inspection or acceptance that do not meet the qualification requirement;\n(2) Products or services were previously rejected and the defects were not corrected when submitted for inspection or acceptance;\n(3) A supplier fails to request reevaluation following change of location or ownership of the plant where the product which met the qualification requirement was manufactured (see the clause at 52.209-1 , Qualification Requirements);\n(4) A manufacturer of a product which met the qualification requirement has discontinued manufacture of the product;\n(5) A source requests removal from a QPL, QML, or QBL;\n(6) A condition of meeting the qualification requirement was violated; e.g., advertising or publicity contrary to 9.204 (h)(5);\n(7) A revised specification imposes a new qualification requirement;\n(8) Manufacturing or design changes have been incorporated in the qualification requirement;\n(9) The source is listed in the System for Award Management Exclusions (see Subpart 9.4 ); or\n(10) Performance of a contract subject to a qualification requirement is otherwise unsatisfactory.\n(b) After considering any of the above or other conditions reasonably related to whether a product or source continues to meet the standards specified for qualification, an agency may take appropriate action without advance notification. The agency shall, however, promptly notify the affected parties if a product or source is removed from a QPL, QML, or QBL, or will no longer be identified as meeting the standards specified for qualification. This notice shall contain specific information why the product or source no longer meets the qualification requirement.");
register_book(&s, "|9|3|", "First Article Testing and Approval", "Subpart 9.3  First Article Testing and Approval\n9.301 Definition.\nApproval,  as used in this subpart, means the contracting officer  s written notification to the contractor accepting the test results of the first article.\n9.302 General.\nFirst article testing and approval (hereafter referred to as testing and approval) ensures that the contractor can furnish a product that conforms to all contract requirements for acceptance. Before requiring testing and approval, the contracting officer shall consider the  \n(a) Impact on cost or time of delivery;\n(b) Risk to the Government of foregoing such test; and\n(c) Availability of other, less costly, methods of ensuring the desired quality.\n9.303 Use.\nTesting and approval may be appropriate when  \n(a) The contractor has not previously furnished the product to the Government;\n(b) The contractor previously furnished the product to the Government, but  \n(1) There have been subsequent changes in processes or specifications;\n(2) Production has been discontinued for an extended period of time; or\n(3) The product acquired under a previous contract developed a problem during its life;\n(c) The product is described by a performance specification; or\n(d) It is essential to have an approved first article to serve as a manufacturing standard.\n9.304 Exceptions.\nNormally, testing and approval is not required in contracts for  \n(a) Research or development;\n(b) Products requiring qualification before award ( e.g., when an applicable qualified products list exists (see Subpart 9.2 ));\n(c) Products normally sold in the commercial market; or\n(d) Products covered by complete and detailed technical specifications, unless the requirements are so novel or exacting that it is questionable whether the products would meet the requirements without testing and approval.\n9.305 Risk.\nBefore first article approval, the acquisition of materials or components, or commencement of production, is normally at the sole risk of the contractor. To minimize this risk, the contracting officer shall provide sufficient time in the delivery schedule for acquisition of materials and components, and for production after receipt of first article approval. When Government requirements preclude this action, the contracting officer may, before approval of the first article, authorize the contractor to acquire specific materials or components or commence production to the extent essential to meet the delivery schedule (see Alternate II of the clause at 52.209-3 , First Article Approval  Contractor Testing, and Alternate II of the clause at 52.209-4 , First Article Approval  Government Testing). Costs incurred based on this authorization are allocable to the contract for  \n(1) Progress payments; and\n(2) Termination settlements if the contract is terminated for the convenience of the Government.\n9.306 Solicitation requirements.\nSolicitations containing a testing and approval requirement shall  \n(a) Provide, in the circumstance where the contractor is to be responsible for the first article approval testing  \n(1) The performance or other characteristics that the first article must meet for approval;\n(2) The detailed technical requirements for the tests that must be performed for approval; and\n(3) The necessary data that must be submitted to the Government in the first article approval test report;\n(b) Provide, in the circumstance where the Government is to be responsible for the first article approval testing  \n(1) The performance or other characteristics that the first article must meet for approval; and\n(2) The tests to which the first article will be subjected for approval;\n(c) Inform offerors that the requirement may be waived when supplies identical or similar to those called for have previously been delivered by the offeror and accepted by the Government (see 52.209-3 (h) and 52.209-4 (i));\n(d) Permit the submission of alternative offers, one including testing and approval and the other excluding testing and approval (if eligible under 9.306 (c));\n(e) State clearly the first article  s relationship to the contract quantity (see paragraph (e) of the clause at 52.209-3 , First Article Approval  Contractor Testing, or 52.209-4 , First Article Approval  Government Testing);\n(f) Contain a delivery schedule for the production quantity (see 12.104). The delivery schedule may  \n(1) Be the same whether or not testing and approval is waived; or\n(2) Provide for earlier delivery when testing and approval is waived and the Government desires earlier delivery. In the latter case, any resulting difference in delivery schedules shall not be a factor in evaluation for award. The clause at 52.209-4 , First Article Approval  Government Testing, shall contain the delivery schedule for the first article;\n(g) Provide for the submission of contract numbers, if any, to document the offeror  s eligibility under 9.306 (c);\n(h) State whether the approved first article will serve as a manufacturing standard; and\n(i) Include, when the Government is responsible for first article testing, the Government  s estimated testing costs as a factor for use in evaluating offers (when appropriate).\n(j) Inform offerors that the prices for first articles and first article tests in relation to production quantities shall not be materially unbalanced (see 15.404-1 (g)) if first article test items or tests are to be separately priced.\n9.307 Government administration procedures.\n(a) Before the contractor ships the first article, or the first article test report, to the Government laboratory or other activity responsible for approval at the address specified in the contract, the contract administration office shall provide that activity with as much advance notification as is feasible of the forthcoming shipment, and  \n(1) Advise that activity of the contractual requirements for testing and approval, or evaluation, as appropriate;\n(2) Call attention to the notice requirement in paragraph (b) of the clause at 52.209-3 , First Article Approval  Contractor Testing, or 52.209-4 , First Article Approval  Government Testing; and\n(3) Request that the activity inform the contract administration office of the date when testing or evaluation will be completed.\n(b) The Government laboratory or other activity responsible for first article testing or evaluation shall inform the contracting office whether to approve, conditionally approve, or disapprove the first article. The contracting officer shall then notify the contractor of the action taken and furnish a copy of the notice to the contract administration office. The notice shall include the first article shipment number, when available, and the applicable contract line item number. Any changes in the drawings, designs, or specifications determined by the contracting officer to be necessary shall be made under the Changes clause, and not by the notice of approval, conditional approval, or disapproval furnished the contractor.\n9.308 Contract clauses.\n9.308-1 Testing performed by the contractor.\n(a)(1) The contracting officer shall insert the clause at 52.209-3 , First Article Approval  Contractor Testing, in solicitations and contracts when a fixed-price contract is contemplated and it is intended that the contract require  \n(i) First article approval; and\n(ii) That the contractor be required to conduct the first article testing.\n(2) If it is intended that the contractor be required to produce the first article and the production quantity at the same facility, the contracting officer shall use the clause with its Alternate I.\n(3) If it is necessary to authorize the contractor to purchase material or to commence production before first article approval, the contracting officer shall use the clause with its Alternate II.\n(b)(1) The contracting officer shall insert a clause substantially the same as the clause at 52.209-3 , First Article Approval  Contractor Testing, in solicitations and contracts when a cost-reimbursement contract is contemplated and it is intended that the contract require  \n(i) First article approval; and\n(ii) That the contractor be required to conduct the first article test.\n(2) If it is intended that the contractor be required to produce the first article and the production quantity at the same facility, the contracting officer shall use a clause substantially the same as the clause at 52.209-3 , First Article Approval  Contractor Testing, with its Alternate I.\n(3) If it is necessary to authorize the contractor to purchase material or to commence production before first article approval, the contracting officer shall use a clause substantially the same as the clause at 52.209-3 , First Article Approval  Contractor Testing, with its Alternate II.\n9.308-2 Testing performed by the Government.\n(a)(1) The contracting officer shall insert the clause at 52.209-4 , First Article Approval  Government Testing, in solicitations and contracts when a fixed-price contract is contemplated and it is intended that the contract require first article approval and that the Government will be responsible for conducting the first article test.\n(2) If it is intended that the contractor be required to produce the first article and the production quantity at the same facility, the contracting officer shall use the basic clause with its Alternate I.\n(3) If it is necessary to authorize the contractor to purchase material or to commence production before first article approval, the contracting officer shall use the basic clause with its Alternate II.\n(b)(1) The contracting officer shall insert a clause substantially the same as the clause at 52.209-4 , First Article Approval  Government Testing, in solicitations and contracts when a cost-reimbursement contract is contemplated and it is intended that the contract require first article approval and that the Government be responsible for conducting the first article test.\n(2) If it is intended that the contractor be required to produce the first article and the production quantity at the same facility, the contracting officer shall use a clause substantially the same as the clause at 52.209-4 , First Article Approval  Government Testing, with its Alternate I.\n(3) If it is necessary to authorize the contractor to purchase material or to commence production before first article approval, the contracting officer shall use a clause substantially the same as the clause at 52.209-4 , First Article Approval  Government Testing, with its Alternate II.");
register_book(&s, "|9|4|", "Debarment, Suspension, and Ineligibilit", "Subpart 9.4  Debarment, Suspension, and Ineligibility\n9.400 Scope of subpart.\n(a) This subpart  \n(1) Prescribes policies and procedures governing the debarment and suspension of contractors by agencies for the causes given in 9.406-2 and 9.407-2 ;\n(2) Provides for the listing of contractors debarred, suspended, proposed for debarment, and declared ineligible (see the definition of  ineligible  in 2.101 ); and\n(3) Sets forth the consequences of this listing.\n(b) Although this subpart does cover the listing of ineligible contractors ( 9.404 ) and the effect of this listing ( 9.405 (b)), it does not prescribe policies and procedures governing declarations of ineligibility.\n9.401 Applicability.\nIn accordance with Public Law 103-355, Section 2455 ( 31 U.S.C. 6101 , note), and Executive Order 12689, any debarment, suspension or other Governmentwide exclusion initiated under the Nonprocurement Common Rule implementing Executive Order 12549 on or after August 25, 1995, shall be recognized by and effective for Executive Branch agencies as a debarment or suspension under this subpart. Similarly, any debarment, suspension, proposed debarment or other Governmentwide exclusion initiated on or after August 25, 1995, under this subpart shall also be recognized by and effective for those agencies and participants as an exclusion under the Nonprocurement Common Rule.\n9.402 Policy.\n(a) Agencies shall solicit offers from, award contracts to, and consent to subcontracts with responsible contractors only. Debarment and suspension are discretionary actions that, taken in accordance with this subpart, are appropriate means to effectuate this policy.\n(b) The serious nature of debarment and suspension requires that these sanctions be imposed only in the public interest for the Government  s protection and not for purposes of punishment. Agencies shall impose debarment or suspension to protect the Government  s interest and only for the causes and in accordance with the procedures set forth in this subpart.\n(c) Agencies are encouraged to establish methods and procedures for coordinating their debarment or suspension actions.\n(d) When more than one agency has an interest in the debarment or suspension of a contractor, the Interagency Committee on Debarment and Suspension, established under Executive Order 12549, and authorized by Section 873 of the National Defense Authorization Act for Fiscal Year 2009 (Pub. L. 110-417), shall resolve the lead agency issue and coordinate such resolution among all interested agencies prior to the initiation of any suspension, debarment, or related administrative action by any agency.\n(e) Agencies shall establish appropriate procedures to implement the policies and procedures of this subpart.\n9.403 Definitions.\nAs used in this subpart  \nAffiliates.  Business concerns, organizations, or individuals are affiliates of each other if, directly or indirectly, (1) either one controls or has the power to control the other, or (2) a third party controls or has the power to control both. Indicia of control include, but are not limited to, interlocking management or ownership, identity of interests among family members, shared facilities and equipment, common use of employees, or a business entity organized following the debarment, suspension, or proposed debarment of a contractor which has the same or similar management, ownership, or principal employees as the contractor that was debarred, suspended, or proposed for debarment.\nAgency  means any executive department, military department or defense agency, or other agency or independent establishment of the executive branch.\nCivil judgment  means a judgment or finding of a civil offense by any court of competent jurisdiction.\nContractor  means any individual or other legal entity that  \n(1) Directly or indirectly ( e.g., through an affiliate), submits offers for or is awarded, or reasonably may be expected to submit offers for or be awarded, a Government contract, including a contract for carriage under Government or commercial bills of lading, or a subcontract under a Government contract; or\n(2) Conducts business, or reasonably may be expected to conduct business, with the Government as an agent or representative of another contractor.\nDebarring official  means  \n(1) An agency head; or\n(2) A designee authorized by the agency head to impose debarment.\nIndictment  means indictment for a criminal offense. An information or other filing by competent authority charging a criminal offense is given the same effect as an indictment.\nLegal proceedings  means any civil judicial proceeding to which the Government is a party or any criminal proceeding. The term includes appeals from such proceedings.\nNonprocurement Common Rule  means the procedures used by Federal Executive Agencies to suspend, debar, or exclude individuals or entities from participation in nonprocurement transactions under Executive Order 12549. Examples of nonprocurement transactions are grants, cooperative agreements, scholarships, fellowships, contracts of assistance, loans, loan guarantees, subsidies, insurance, payments for specified use, and donation agreements.\nSuspending official  means  \n(1) An agency head; or\n(2) A designee authorized by the agency head to impose suspension.\nUnfair trade practices  means the commission of any or the following acts by a contractor:\n(1) A violation of Section 337 of the Tariff Act of 1930 ( 19 U.S.C. 1337 ) as determined by the International Trade Commission.\n(2) A violation, as determined by the Secretary of Commerce, of any agreement of the group known as the  Coordination Committee  for purposes of the Export Administration Act of 1979 ( 50 U.S.C. App. 2401 , et seq .) or any similar bilateral or multilateral export control agreement.\n(3) A knowingly false statement regarding a material element of a certification concerning the foreign content of an item of supply, as determined by the Secretary of the Department or the head of the agency to which such certificate was furnished.\n9.404 System for Award Management Exclusions.\n(a) The General Services Administration (GSA)  \n(1) Operates the web-based System for Award Management (SAM) Exclusions; and\n(2) Provides technical assistance to Federal agencies in the use of SAM.\n(b) The SAM Exclusions contains the  \n(1) Names and addresses of all contractors debarred, suspended, proposed for debarment, declared ineligible, or excluded or disqualified under the nonprocurement common rule, with cross-references when more than one name is involved in a single action; \n(2) Name of the agency or other authority taking the action;\n(3) Cause for the action (see 9.406-2 and 9.407-2 for causes authorized under this subpart) or other statutory or regulatory authority;\n(4) Effect of the action;\n(5) Termination date for each listing;\n(6) Data Universal Numbering System number;\n(7) Social Security Number (SSN), Employer Identification Number (EIN), or other Taxpayer Identification Number (TIN), if available; and\n(8) Name and telephone number of the agency point of contact for the action.\n(c) Each agency must  \n(1) Obtain password(s) from GSA to access SAM for data entry;\n(2) Notify GSA in the event a password needs to be rescinded ( e.g., when an agency employee leaves or changes function);\n(3) Enter the information required by paragraph (b) of this section within 3 working days after the action becomes effective;\n(4) Determine whether it is legally permitted to enter the SSN, EIN, or other TIN, under agency authority to suspend or debar;\n(5) Update SAM Exclusions, generally within 5 working days after modifying or rescinding an action;\n(6) In accordance with internal retention procedures, maintain records relating to each debarment, suspension, or proposed debarment taken by the agency;\n(7) Establish procedures to ensure that the agency does not solicit offers from, award contracts to, or consent to subcontracts with contractors whose names are in SAM Exclusions, except as otherwise provided in this subpart;\n(8) Direct inquiries concerning listed contractors to the agency or other authority that took the action; and \n(9) Contact GSA for technical assistance with SAM, via the support e-mail address or on the technical support phone line available at the SAM web site provided in paragraph (d) of this section.\n(d) SAM is available via https://www.acquisition.gov.\n9.405 Effect of listing.\n(a) Contractors debarred, suspended, or proposed for debarment are excluded from receiving contracts, and agencies shall not solicit offers from, award contracts to, or consent to subcontracts with these contractors, unless the agency head determines that there is a compelling reason for such action (see 9.405-1 (b), 9.405-2 , 9.406-1 (c), 9.407-1 (d), and 23.506 (e)). Contractors debarred, suspended, or proposed for debarment are also excluded from conducting business with the Government as agents or representatives of other contractors.\n(b) Contractors included in SAM Exclusions as having been declared ineligible on the basis of statutory or other regulatory procedures are excluded from receiving contracts, and if applicable, subcontracts, under the conditions and for the period set forth in the statute or regulation. Agencies shall not solicit offers from, award contracts to, or consent to subcontracts with these contractors under those conditions and for that period.\n(c) Contractors debarred, suspended, or proposed for debarment are excluded from acting as individual sureties (see Part 28 ).\n(d)(1) After the opening of bids or receipt of proposals, the contracting officer shall review SAM Exclusions.\n(2) Bids received from any listed contractor in response to an invitation for bids shall be entered on the abstract of bids, and rejected unless the agency head determines in writing that there is a compelling reason to consider the bid.\n(3) Proposals, quotations, or offers received from any listed contractor shall not be evaluated for award or included in the competitive range, nor shall discussions be conducted with a listed offeror during a period of ineligibility, unless the agency head determines, in writing, that there is a compelling reason to do so. If the period of ineligibility expires or is terminated prior to award, the contracting officer may, but is not required to, consider such proposals, quotations, or offers.\n(4) Immediately prior to award, the contracting officer shall again review SAM Exclusions to ensure that no award is made to a listed contractor.\n9.405-1 Continuation of current contracts.\n(a) Notwithstanding the debarment, suspension, or proposed debarment of a contractor, agencies may continue contracts or subcontracts in existence at the time the contractor was debarred, suspended, or proposed for debarment unless the agency head directs otherwise. A decision as to the type of termination action, if any, to be taken should be made only after review by agency contracting and technical personnel and by counsel to ensure the propriety of the proposed action.\n(b) For contractors debarred, suspended, or proposed for debarment, unless the agency head makes a written determination of the compelling reasons for doing so, ordering activities shall not  \n(1) Place orders exceeding the guaranteed minimum under indefinite quantity contracts;\n(2) Place orders under optional use Federal Supply Schedule contracts, blanket purchase agreements, or basic ordering agreements; or\n(3) Add new work, exercise options, or otherwise extend the duration of current contracts or orders.\n9.405-2 Restrictions on subcontracting.\n(a) When a contractor debarred, suspended, or proposed for debarment is proposed as a subcontractor for any subcontract subject to Government consent (see Subpart 44.2 ), contracting officers shall not consent to subcontracts with such contractors unless the agency head states in writing the compelling reasons for this approval action. (See 9.405 (b) concerning declarations of ineligibility affecting sub-contracting.)\n(b) The Government suspends or debars contractors to protect the Government  s interests. By operation of the clause at 52.209-6 , Protecting the Government  s Interests When Subcontracting with Contractors Debarred, Suspended or Proposed for Debarment, contractors shall not enter into any subcontract in excess of $30,000, other than a subcontract for a commercially available off-the-shelf item, with a contractor that has been debarred, suspended, or proposed for debarment unless there is a compelling reason to do so. If a contractor intends to enter into a subcontract in excess of $30,000, other than a subcontract for a commercially available off-the-shelf item, with a party that is debarred, suspended, or proposed for debarment as evidenced by the parties  listing in SAM Exclusions (see 9.404 ), a corporate officer or designee of the contractor is required by operation of the clause at 52.209-6 , Protecting the Government  s Interests when Subcontracting with Contractors Debarred, Suspended, or Proposed for Debarment, to notify the contracting officer, in writing, before entering into such subcontract. For contracts for the acquisition of commercial items, the notification requirement applies only for first-tier subcontracts. For all other contracts, the notification requirement applies to subcontracts at any tier. The notice must provide the following:\n(1) The name of the subcontractor;\n(2) The contractor  s knowledge of the reasons for the subcontractor being listed in SAM Exclusions;\n(3) The compelling reason(s) for doing business with the subcontractor notwithstanding its listed in SAM Exclusions; and\n(4) The systems and procedures the contractor has established to ensure that it is fully protecting the Government  s interests when dealing with such subcontractor in view of the specific basis for the party  s debarment, suspension, or proposed debarment.\n(c) The contractor  s compliance with the requirements of 52.209-6 will be reviewed during Contractor Purchasing System Reviews (see Subpart 44.3 ).\n9.406 Debarment.\n9.406-1 General.\n(a) It is the debarring official  s responsibility to determine whether debarment is in the Government  s interest. The debarring official may, in the public interest, debar a contractor for any of the causes in 9.406-2 , using the procedures in 9.406-3 . The existence of a cause for debarment, however, does not necessarily require that the contractor be debarred; the seriousness of the contractor  s acts or omissions and any remedial measures or mitigating factors should be considered in making any debarment decision. Before arriving at any debarment decision, the debarring official should consider factors such as the following:\n(1) Whether the contractor had effective standards of conduct and internal control systems in place at the time of the activity which constitutes cause for debarment or had adopted such procedures prior to any Government investigation of the activity cited as a cause for debarment.\n(2) Whether the contractor brought the activity cited as a cause for debarment to the attention of the appropriate Government agency in a timely manner.\n(3) Whether the contractor has fully investigated the circumstances surrounding the cause for debarment and, if so, made the result of the investigation available to the debarring official.\n(4) Whether the contractor cooperated fully with Government agencies during the investigation and any court or administrative action.\n(5) Whether the contractor has paid or has agreed to pay all criminal, civil, and administrative liability for the improper activity, including any investigative or administrative costs incurred by the Government, and has made or agreed to make full restitution.\n(6) Whether the contractor has taken appropriate disciplinary action against the individuals responsible for the activity which constitutes cause for debarment.\n(7) Whether the contractor has implemented or agreed to implement remedial measures, including any identified by the Government.\n(8) Whether the contractor has instituted or agreed to institute new or revised review and control procedures and ethics training programs.\n(9) Whether the contractor has had adequate time to eliminate the circumstances within the contractor  s organization that led to the cause for debarment.\n(10) Whether the contractor  s management recognizes and understands the seriousness of the misconduct giving rise to the cause for debarment and has implemented programs to prevent recurrence.\nThe existence or nonexistence of any mitigating factors or remedial measures such as set forth in this paragraph (a) is not necessarily determinative of a contractor  s present responsibility. Accordingly, if a cause for debarment exists, the contractor has the burden of demonstrating, to the satisfaction of the debarring official, its present responsibility and that debarment is not necessary.\n(b) Debarment constitutes debarment of all divisions or other organizational elements of the contractor, unless the debarment decision is limited by its terms to specific divisions, organizational elements, or commodities. The debarring official may extend the debarment decision to include any affiliates of the contractor if they are  \n(1) Specifically named; and\n(2) Given written notice of the proposed debarment and an opportunity to respond (see 9.406-3 (c)).\n(c) A contractor  s debarment, or proposed debarment, shall be effective throughout the executive branch of the Government, unless the agency head or a designee (except see 23.506 (e)) states in writing the compelling reasons justifying continued business dealings between that agency and the contractor.\n(d)(1) When the debarring official has authority to debar contractors from both acquisition contracts pursuant to this regulation and contracts for the purchase of Federal personal property pursuant to the Federal Property Management Regulations (FPMR) 101-45.6, that official shall consider simultaneously debarring the contractor from the award of acquisition contracts and from the purchase of Federal personal property.\n(2) When debarring a contractor from the award of acquisition contracts and from the purchase of Federal personal property, the debarment notice shall so indicate and the appropriate FAR and FPMR citations shall be included.\n9.406-2 Causes for debarment.\nThe debarring official may debar  \n(a) A contractor for a conviction of or civil judgment for  \n(1) Commission of fraud or a criminal offense in connection with  \n(i) Obtaining;\n(ii) Attempting to obtain; or\n(iii) Performing a public contract or subcontract.\n(2) Violation of Federal or State antitrust statutes relating to the submission of offers;\n(3) Commission of embezzlement, theft, forgery, bribery, falsification or destruction of records, making false statements, tax evasion, violating Federal criminal tax laws, or receiving stolen property;\n(4) Intentionally affixing a label bearing a  Made in America  inscription (or any inscription having the same meaning) to a product sold in or shipped to the United States or its outlying areas, when the product was not made in the United States or its outlying areas (see Section 202 of the Defense Production Act (Public Law 102-558)); or\n(5) Commission of any other offense indicating a lack of business integrity or business honesty that seriously and directly affects the present responsibility of a Government contractor or subcontractor.\n(b)(1) A contractor, based upon a preponderance of the evidence, for any of the following  \n(i) Violation of the terms of a Government contract or subcontract so serious as to justify debarment, such as  \n(A) Willful failure to perform in accordance with the terms of one or more contracts; or\n(B) A history of failure to perform, or of unsatisfactory performance of, one or more contracts.\n(ii) Violations of the Drug-Free Workplace Act of 1988 (Pub. L. 100-690), as indicated by  \n(A) Failure to comply with the requirements of the clause at 52.223-6 , Drug-Free Workplace; or\n(B) Such a number of contractor employees convicted of violations of criminal drug statutes occurring in the workplace as to indicate that the contractor has failed to make a good faith effort to provide a drug-free workplace (see 23.504 ).\n(iii) Intentionally affixing a label bearing a  Made in America  inscription (or any inscription having the same meaning) to a product sold in or shipped to the United States or its outlying areas, when the product was not made in the United States or its outlying areas (see Section 202 of the Defense Production Act (Public Law 102-558)).\n(iv) Commission of an unfair trade practice as defined in 9.403 (see Section 201 of the Defense Production Act (Pub. L. 102-558)).\n(v) Delinquent Federal taxes in an amount that exceeds $3,000. \n(A) Federal taxes are considered delinquent for purposes of this provision if both of the following criteria apply:\n(1) The tax liability is finally determined. The liability is finally determined if it has been assessed. A liability is not finally determined if there is a pending administrative or judicial challenge. In the case of a judicial challenge to the liability, the liability is not finally determined until all judicial appeal rights have been exhausted. \n(2) The taxpayer is delinquent in making payment. A taxpayer is delinquent if the taxpayer has failed to pay the tax liability when full payment was due and required. A taxpayer is not delinquent in cases where enforced collection action is precluded. \n(B) Examples. \n(1) The taxpayer has received a statutory notice of deficiency, under I.R.C.  6212, which entitles the taxpayer to seek Tax Court review of a proposed tax deficiency. This is not a delinquent tax because it is not a final tax liability. Should the taxpayer seek Tax Court review, this will not be a final tax liability until the taxpayer has exercised all judicial appeal rights. \n(2) The IRS has filed a notice of Federal tax lien with respect to an assessed tax liability, and the taxpayer has been issued a notice under I.R.C.  6320 entitling the taxpayer to request a hearing with the IRS Office of Appeals contesting the lien filing, and to further appeal to the Tax Court if the IRS determines to sustain the lien filing. In the course of the hearing, the taxpayer is entitled to contest the underlying tax liability because the taxpayer has had no prior opportunity to contest the liability. This is not a delinquent tax because it is not a final tax liability. Should the taxpayer seek tax court review, this will not be a final tax liability until the taxpayer has exercised all judicial appeal rights. \n(3) The taxpayer has entered into an installment agreement pursuant to I.R.C.  6159. The taxpayer is making timely payments and is in full compliance with the agreement terms. The taxpayer is not delinquent because the taxpayer is not currently required to make full payment. \n(4) The taxpayer has filed for bankruptcy protection. The taxpayer is not delinquent because enforced collection action is stayed under 11 U.S.C. 362 (the Bankruptcy Code).\n(vi) Knowing failure by a principal, until 3 years after final payment on any Government contract awarded to the contractor, to timely disclose to the Government, in connection with the award, performance, or closeout of the contract or a subcontract thereunder, credible evidence of  \n(A) Violation of Federal criminal law involving fraud, conflict of interest, bribery, or gratuity violations found in Title 18 of the United States Code;\n(B) Violation of the civil False Claims Act (31 U.S.C. 3729-3733); or\n(C) Significant overpayment(s) on the contract, other than overpayments resulting from contract financing payments as defined in 32.001 .\n(2) A contractor, based on a determination by the Secretary of Homeland Security or the Attorney General of the United States, that the contractor is not in compliance with Immigration and Nationality Act employment provisions (see Executive Order 12989, as amended by Executive Order 13286). Such determination is not reviewable in the debarment proceedings.\n(c) A contractor or subcontractor based on any other cause of so serious or compelling a nature that it affects the present responsibility of the contractor or subcontractor.\n9.406-3 Procedures.\n(a) Investigation and referral . Agencies shall establish procedures for the prompt reporting, investigation, and referral to the debarring official of matters appropriate for that official  s consideration.\n(b) Decisionmaking process.\n(1) Agencies shall establish procedures governing the debarment decisionmaking process that are as informal as is practicable, consistent with principles of fundamental fairness. These procedures shall afford the contractor (and any specifically named affiliates) an opportunity to submit, in person, in writing, or through a representative, information and argument in opposition to the proposed debarment.\n(2) In actions not based upon a conviction or civil judgment, if it is found that the contractor  s submission in opposition raises a genuine dispute over facts material to the proposed debarment, agencies shall also  \n(i) Afford the contractor an opportunity to appear with counsel, submit documentary evidence, present witnesses, and confront any person the agency presents; and\n(ii) Make a transcribed record of the proceedings and make it available at cost to the contractor upon request, unless the contractor and the agency, by mutual agreement, waive the requirement for a transcript.\n(c) Notice of proposal to debar . A notice of proposed debarment shall be issued by the debarring official advising the contractor and any specifically named affiliates, by certified mail, return receipt requested  \n(1) That debarment is being considered;\n(2) Of the reasons for the proposed debarment in terms sufficient to put the contractor on notice of the conduct or transaction(s) upon which it is based;\n(3) Of the cause(s) relied upon under 9.406-2 for proposing debarment;\n(4) That, within 30 days after receipt of the notice, the contractor may submit, in person, in writing, or through a representative, information and argument in opposition to the proposed debarment, including any additional specific information that raises a genuine dispute over the material facts;\n(5) Of the agency  s procedures governing debarment decisionmaking;\n(6) Of the effect of the issuance of the notice of proposed debarment; and\n(7) Of the potential effect of an actual debarment.\n(d) Debarring official  s decision.\n(1) In actions based upon a conviction or civil judgment, or in which there is no genuine dispute over material facts, the debarring official shall make a decision on the basis of all the information in the administrative record, including any submission made by the contractor. If no suspension is in effect, the decision shall be made within 30 working days after receipt of any information and argument submitted by the contractor, unless the debarring official extends this period for good cause.\n(2)(i) In actions in which additional proceedings are necessary as to disputed material facts, written findings of fact shall be prepared. The debarring official shall base the decision on the facts as found, together with any information and argument submitted by the contractor and any other information in the administrative record.\n(ii) The debarring official may refer matters involving disputed material facts to another official for findings of fact. The debarring official may reject any such findings, in whole or in part, only after specifically determining them to be arbitrary and capricious or clearly erroneous.\n(iii) The debarring official  s decision shall be made after the conclusion of the proceedings with respect to disputed facts.\n(3) In any action in which the proposed debarment is not based upon a conviction or civil judgment, the cause for debarment must be established by a preponderance of the evidence.\n(e) Notice of debarring official  s decision.\n(1) If the debarring official decides to impose debarment, the contractor and any affiliates involved shall be given prompt notice by certified mail, return receipt requested  \n(i) Referring to the notice of proposed debarment;\n(ii) Specifying the reasons for debarment;\n(iii) Stating the period of debarment, including effective dates; and\n(iv) Advising that the debarment is effective throughout the executive branch of the Government unless the head of an agency or a designee makes the statement called for by 9.406-1 (c).\n(2) If debarment is not imposed, the debarring official shall promptly notify the contractor and any affiliates involved, by certified mail, return receipt requested.\n(f)(1) If the contractor enters into an administrative agreement with the Government in order to resolve a debarment proceeding, the debarring official shall access the website (available at www.cpars.csd.disa.mil , then select FAPIIS) and enter the requested information.\n(2) The debarring official is responsible for the timely submission, within 3 working days, and accuracy of the documentation regarding the administrative agreement.\n(3) With regard to information that may be covered by a disclosure exemption under the Freedom of Information Act, the debarring official shall follow the procedures at 9.105-2 (b)(2)(iv).\n9.406-4 Period of debarment.\n(a)(1) Debarment shall be for a period commensurate with the seriousness of the cause(s). Generally, debarment should not exceed 3 years, except that  \n(i) Debarment for violation of the provisions of the Drug-Free Workplace Act of 1988 (see 23.506 ) may be for a period not to exceed 5 years; and\n(ii) Debarments under 9.406-2 (b)(2) shall be for one year unless extended pursuant to paragraph (b) of this subsection.\n(2) If suspension precedes a debarment, the suspension period shall be considered in determining the debarment period.\n(b) The debarring official may extend the debarment for an additional period, if that official determines that an extension is necessary to protect the Government  s interest. However, a debarment may not be extended solely on the basis of the facts and circumstances upon which the initial debarment action was based. Debarments under 9.406-2 (b)(2) may be extended for additional periods of one year if the Secretary of Homeland Security or the Attorney General determines that the contractor continues to be in violation of the employment provisions of the Immigration and Nationality Act. If debarment for an additional period is determined to be necessary, the procedures of 9.406-3 shall be followed to extend the debarment.\n(c) The debarring official may reduce the period or extent of debarment, upon the contractor  s request, supported by documentation, for reasons such as  \n(1) Newly discovered material evidence;\n(2) Reversal of the conviction or civil judgment upon which the debarment was based;\n(3) Bona fide change in ownership or management;\n(4) Elimination of other causes for which the debarment was imposed; or\n(5) Other reasons the debarring official deems appropriate.\n9.406-5 Scope of debarment.\n(a) The fraudulent, criminal, or other seriously improper conduct of any officer, director, shareholder, partner, employee, or other individual associated with a contractor may be imputed to the contractor when the conduct occurred in connection with the individual  s performance of duties for or on behalf of the contractor, or with the contractor  s knowledge, approval, or acquiescence. The contractor  s acceptance of the benefits derived from the conduct shall be evidence of such knowledge, approval, or acquiescence.\n(b) The fraudulent, criminal, or other seriously improper conduct of a contractor may be imputed to any officer, director, shareholder, partner, employee, or other individual associated with the contractor who participated in, knew of, or had reason to know of the contractor  s conduct.\n(c) The fraudulent, criminal, or other seriously improper conduct of one contractor participating in a joint venture or similar arrangement may be imputed to other participating contractors if the conduct occurred for or on behalf of the joint venture or similar arrangement, or with the knowledge, approval, or acquiescence of these contractors. Acceptance of the benefits derived from the conduct shall be evidence of such knowledge, approval, or acquiescence.\n9.407 Suspension.\n9.407-1 General.\n(a) The suspending official may, in the public interest, suspend a contractor for any of the causes in 9.407-2 , using the procedures in 9.407-3 .\n(b)(1) Suspension is a serious action to be imposed on the basis of adequate evidence, pending the completion of investigation or legal proceedings, when it has been determined that immediate action is necessary to protect the Government  s interest. In assessing the adequacy of the evidence, agencies should consider how much information is available, how credible it is given the circumstances, whether or not important allegations are corroborated, and what inferences can reasonably be drawn as a result. This assessment should include an examination of basic documents such as contracts, inspection reports, and correspondence.\n(2) The existence of a cause for suspension does not necessarily require that the contractor be suspended. The suspending official should consider the seriousness of the contractor  s acts or omissions and may, but is not required to, consider remedial measures or mitigating factors, such as those set forth in 9.406-1 (a). A contractor has the burden of promptly presenting to the suspending official evidence of remedial measures or mitigating factors when it has reason to know that a cause for suspension exists. The existence or nonexistence of any remedial measures or mitigating factors is not necessarily determinative of a contractor  s present responsibility.\n(c) Suspension constitutes suspension of all divisions or other organizational elements of the contractor, unless the suspension decision is limited by its terms to specific divisions, organizational elements, or commodities. The suspending official may extend the suspension decision to include any affiliates of the contractor if they are  \n(1) Specifically named; and\n(2) Given written notice of the suspension and an opportunity to respond (see 9.407-3 (c)).\n(d) A contractor  s suspension shall be effective throughout the executive branch of the Government, unless the agency head or a designee (except see 23.506 (e)) states in writing the compelling reasons justifying continued business dealings between that agency and the contractor.\n(e)(1) When the suspending official has authority to suspend contractors from both acquisition contracts pursuant to this regulation and contracts for the purchase of Federal personal property pursuant to FPMR 101-45.6, that official shall consider simultaneously suspending the contractor from the award of acquisition contracts and from the purchase of Federal personal property.\n(2) When suspending a contractor from the award of acquisition contracts and from the purchase of Federal personal property, the suspension notice shall so indicate and the appropriate FAR and FPMR citations shall be included.\n9.407-2 Causes for suspension.\n(a) The suspending official may suspend a contractor suspected, upon adequate evidence, of  \n(1) Commission of fraud or a criminal offense in connection with  \n(i) Obtaining;\n(ii) Attempting to obtain; or\n(iii) Performing a public contract or subcontract.\n(2) Violation of Federal or State antitrust statutes relating to the submission of offers;\n(3) Commission of embezzlement, theft, forgery, bribery, falsification or destruction of records, making false statements, tax evasion, violating Federal criminal tax laws, or receiving stolen property;\n(4) Violations of the Drug-Free Workplace Act of 1988 (Pub. L. 100-690), as indicated by  \n(i) Failure to comply with the requirements of the clause at 52.223-6 , Drug-Free Workplace; or\n(ii) Such a number of contractor employees convicted of violations of criminal drug statutes occurring in the workplace as to indicate that the contractor has failed to make a good faith effort to provide a drug-free workplace (see 23.504 );\n(5) Intentionally affixing a label bearing a  Made in America  inscription (or any inscription having the same meaning) to a product sold in or shipped to the United States or its outlying areas, when the product was not made in the United States or its outlying areas (see Section 202 of the Defense Production Act (Public Law 102-558));\n(6) Commission of an unfair trade practice as defined in 9.403 (see section 201 of the Defense Production Act (Pub. L. 102-558)); \n(7) Delinquent Federal taxes in an amount that exceeds $3,000. See the criteria at 9.406-2 (b)(1)(v) for determination of when taxes are delinquent; \n(8) Knowing failure by a principal, until 3 years after final payment on any Government contract awarded to the contractor, to timely disclose to the Government, in connection with the award, performance, or closeout of the contract or a subcontract thereunder, credible evidence of  \n(i) Violation of Federal criminal law involving fraud, conflict of interest, bribery, or gratuity violations found in Title 18 of the United States Code; \n(ii) Violation of the civil False Claims Act (31 U.S.C. 3729-3733); or \n(iii) Significant overpayment(s) on the contract, other than overpayments resulting from contract financing payments as defined in 32.001 ; or\n(9) Commission of any other offense indicating a lack of business integrity or business honesty that seriously and directly affects the present responsibility of a Government contractor or subcontractor.\n(b) Indictment for any of the causes in paragraph (a) of this section constitutes adequate evidence for suspension.\n(c) The suspending official may upon adequate evidence also suspend a contractor for any other cause of so serious or compelling a nature that it affects the present responsibility of a Government contractor or subcontractor.\n9.407-3 Procedures.\n(a) Investigation and referral . Agencies shall establish procedures for the prompt reporting, investigation, and referral to the suspending official of matters appropriate for that official  s consideration.\n(b) Decisionmaking process.\n(1) Agencies shall establish procedures governing the suspension decisionmaking process that are as informal as is practicable, consistent with principles of fundamental fairness. These procedures shall afford the contractor (and any specifically named affiliates) an opportunity, following the imposition of suspension, to submit, in person, in writing, or through a representative, information and argument in opposition to the suspension.\n(2) In actions not based on an indictment, if it is found that the contractor  s submission in opposition raises a genuine dispute over facts material to the suspension and if no determination has been made, on the basis of Department of Justice advice, that substantial interests of the Government in pending or contemplated legal proceedings based on the same facts as the suspension would be prejudiced, agencies shall also  \n(i) Afford the contractor an opportunity to appear with counsel, submit documentary evidence, present witnesses, and confront any person the agency presents; and\n(ii) Make a transcribed record of the proceedings and make it available at cost to the contractor upon request, unless the contractor and the agency, by mutual agreement, waive the requirement for a transcript.\n(c) Notice of suspension . When a contractor and any specifically named affiliates are suspended, they shall be immediately advised by certified mail, return receipt requested  \n(1) That they have been suspended and that the suspension is based on an indictment or other adequate evidence that the contractor has committed irregularities  \n(i) Of a serious nature in business dealings with the Government or\n(ii) Seriously reflecting on the propriety of further Government dealings with the contractor  any such irregularities shall be described in terms sufficient to place the contractor on notice without disclosing the Government  s evidence;\n(2) That the suspension is for a temporary period pending the completion of an investigation and such legal proceedings as may ensue;\n(3) Of the cause(s) relied upon under 9.407-2 for imposing suspension;\n(4) Of the effect of the suspension;\n(5) That, within 30 days after receipt of the notice, the contractor may submit, in person, in writing, or through a representative, information and argument in opposition to the suspension, including any additional specific information that raises a genuine dispute over the material facts; and\n(6) That additional proceedings to determine disputed material facts will be conducted unless  \n(i) The action is based on an indictment; or\n(ii) A determination is made, on the basis of Department of Justice advice, that the substantial interests of the Government in pending or contemplated legal proceedings based on the same facts as the suspension would be prejudiced.\n(d) Suspending official  s decision.\n(1) In actions  \n(i) Based on an indictment;\n(ii) In which the contractor  s submission does not raise a genuine dispute over material facts; or\n(iii) In which additional proceedings to determine disputed material facts have been denied on the basis of Department of Justice advice, the suspending official  s decision shall be based on all the information in the administrative record, including any submission made by the contractor.\n(2)(i) In actions in which additional proceedings are necessary as to disputed material facts, written findings of fact shall be prepared. The suspending official shall base the decision on the facts as found, together with any information and argument submitted by the contractor and any other information in the administrative record.\n(ii) The suspending official may refer matters involving disputed material facts to another official for findings of fact. The suspending official may reject any such findings, in whole or in part, only after specifically determining them to be arbitrary and capricious or clearly erroneous.\n(iii) The suspending official  s decision shall be made after the conclusion of the proceedings with respect to disputed facts.\n(3) The suspending official may modify or terminate the suspension or leave it in force (for example, see 9.406-4 (c) for the reasons for reducing the period or extent of debarment). However, a decision to modify or terminate the suspension shall be without prejudice to the subsequent imposition of  \n(i) Suspension by any other agency; or\n(ii) Debarment by any agency.\n(4) Prompt written notice of the suspending official  s decision shall be sent to the contractor and any affiliates involved, by certified mail, return receipt requested.\n(e)(1) If the contractor enters into an administrative agreement with the Government in order to resolve a suspension proceeding, the suspending official shall access the website (available at www.cpars.csd.disa.mil , then select FAPIIS) and enter the requested information.\n(2) The suspending official is responsible for the timely submission, within 3 working days, and accuracy of the documentation regarding the administrative agreement.\n(3) With regard to information that may be covered by a disclosure exemption under the Freedom of Information Act, the suspending official shall follow the procedures at 9.105-2 (b)(2)(iv).\n9.407-4 Period of suspension.\n(a) Suspension shall be for a temporary period pending the completion of investigation and any ensuing legal proceedings, unless sooner terminated by the suspending official or as provided in this subsection.\n(b) If legal proceedings are not initiated within 12 months after the date of the suspension notice, the suspension shall be terminated unless an Assistant Attorney General requests its extension, in which case it may be extended for an additional 6 months. In no event may a suspension extend beyond 18 months, unless legal proceedings have been initiated within that period.\n(c) The suspending official shall notify the Department of Justice of the proposed termination of the suspension, at least 30 days before the 12-month period expires, to give that Department an opportunity to request an extension.\n9.407-5 Scope of suspension.\nThe scope of suspension shall be the same as that for debarment (see 9.406-5 ), except that the procedures of 9.407-3 shall be used in imposing suspension.\n9.408 [Reserved]\n9.409 Contract clause.\nThe contracting officer shall insert the clause at 52.209-6 , Protecting the Government  s Interests when Subcontracting with Contractors Debarred, Suspended, or Proposed for Debarment, in solicitations and contracts where the contract value exceeds $30,000.");
register_book(&s, "|9|5|", "Organizational and Consultant Conflicts", "Subpart 9.5  Organizational and Consultant Conflicts of Interest\n9.500 Scope of subpart.\nThis subpart  \n(a) Prescribes responsibilities, general rules, and procedures for identifying, evaluating, and resolving organizational conflicts of interest;\n(b) Provides examples to assist contracting officers in applying these rules and procedures to individual contracting situations; and\n(c) Implements section 8141 of the 1989 Department of Defense Appropriation Act, Pub. L. 100-463, 102 Stat. 2270-47 (1988).\n9.501 Definition.\nMarketing consultant,  as used in this subpart, means any independent contractor who furnishes advice, information, direction, or assistance to an offeror or any other contractor in support of the preparation or submission of an offer for a Government contract by that offeror. An independent contractor is not a marketing consultant when rendering  \n(1) Services excluded in Subpart 37.2 ;\n(2) Routine engineering and technical services (such as installation, operation, or maintenance of systems, equipment, software, components, or facilities);\n(3) Routine legal, actuarial, auditing, and accounting services; and\n(4) Training services.\n9.502 Applicability.\n(a) This subpart applies to contracts with either profit or nonprofit organizations, including nonprofit organizations created largely or wholly with Government funds.\n(b) The applicability of this subpart is not limited to any particular kind of acquisition. However, organizational conflicts of interest are more likely to occur in contracts involving  \n(1) Management support services;\n(2) Consultant or other professional services;\n(3) Contractor performance of or assistance in technical evaluations; or\n(4) Systems engineering and technical direction work performed by a contractor that does not have overall contractual responsibility for development or production.\n(c) An organizational conflict of interest may result when factors create an actual or potential conflict of interest on an instant contract, or when the nature of the work to be performed on the instant contract creates an actual or potential conflict of interest on a future acquisition. In the latter case, some restrictions on future activities of the contractor may be required.\n(d) Acquisitions subject to unique agency organizational conflict of interest statutes are excluded from the requirements of this subpart.\n9.503 Waiver.\nThe agency head or a designee may waive any general rule or procedure of this subpart by determining that its application in a particular situation would not be in the Government  s interest. Any request for waiver must be in writing, shall set forth the extent of the conflict, and requires approval by the agency head or a designee. Agency heads shall not delegate waiver authority below the level of head of a contracting activity.\n9.504 Contracting officer responsibilities.\n(a) Using the general rules, procedures, and examples in this subpart, contracting officers shall analyze planned acquisitions in order to  \n(1) Identify and evaluate potential organizational conflicts of interest as early in the acquisition process as possible; and\n(2) Avoid, neutralize, or mitigate significant potential conflicts before contract award.\n(b) Contracting officers should obtain the advice of counsel and the assistance of appropriate technical specialists in evaluating potential conflicts and in developing any necessary solicitation provisions and contract clauses (see 9.506 ).\n(c) Before issuing a solicitation for a contract that may involve a significant potential conflict, the contracting officer shall recommend to the head of the contracting activity a course of action for resolving the conflict (see 9.506 ).\n(d) In fulfilling their responsibilities for identifying and resolving potential conflicts, contracting officers should avoid creating unnecessary delays, burdensome information requirements, and excessive documentation. The contracting officer  s judgment need be formally documented only when a substantive issue concerning potential organizational conflict of interest exists.\n(e) The contracting officer shall award the contract to the apparent successful offeror unless a conflict of interest is determined to exist that cannot be avoided or mitigated. Before determining to withhold award based on conflict of interest considerations, the contracting officer shall notify the contractor, provide the reasons therefor, and allow the contractor a reasonable opportunity to respond. If the contracting officer finds that it is in the best interest of the United States to award the contract notwithstanding a conflict of interest, a request for waiver shall be submitted in accordance with 9.503 . The waiver request and decision shall be included in the contract file.\n9.505 General rules.\nThe general rules in 9.505-1 through 9.505-4 prescribe limitations on contracting as the means of avoiding, neutralizing, or mitigating organizational conflicts of interest that might otherwise exist in the stated situations. Some illustrative examples are provided in 9.508 . Conflicts may arise in situations not expressly covered in this section 9.505 or in the examples in 9.508 . Each individual contracting situation should be examined on the basis of its particular facts and the nature of the proposed contract. The exercise of common sense, good judgment, and sound discretion is required in both the decision on whether a significant potential conflict exists and, if it does, the development of an appropriate means for resolving it. The two underlying principles are  \n(a) Preventing the existence of conflicting roles that might bias a contractor  s judgment; and\n(b) Preventing unfair competitive advantage. In addition to the other situations described in this subpart, an unfair competitive advantage exists where a contractor competing for award of any Federal contract possesses  \n(1) Proprietary information that was obtained from a Government official without proper authorization; or\n(2) Source selection information (as defined in 2.101 ) that is relevant to the contract but is not available to all competitors, and such information would assist that contractor in obtaining the contract.\n9.505-1 Providing systems engineering and technical direction.\n(a) A contractor that provides systems engineering and technical direction for a system but does not have overall contractual responsibility for its development, its integration, assembly, and checkout, or its production shall not  \n(1) Be awarded a contract to supply the system or any of its major components; or\n(2) Be a subcontractor or consultant to a supplier of the system or any of its major components.\n(b) Systems engineering includes a combination of substantially all of the following activities: determining specifications, identifying and resolving interface problems, developing test requirements, evaluating test data, and supervising design. Technical direction includes a combination of substantially all of the following activities: developing work statements, determining parameters, directing other contractors  operations, and resolving technical controversies. In performing these activities, a contractor occupies a highly influential and responsible position in determining a system  s basic concepts and supervising their execution by other contractors. Therefore this contractor should not be in a position to make decisions favoring its own products or capabilities.\n9.505-2 Preparing specifications or work statements.\n(a)(1) If a contractor prepares and furnishes complete specifications covering nondevelopmental items, to be used in a competitive acquisition, that contractor shall not be allowed to furnish these items, either as a prime contractor or as a subcontractor, for a reasonable period of time including, at least, the duration of the initial production contract. This rule shall not apply to  \n(i) Contractors that furnish at Government request specifications or data regarding a product they provide, even though the specifications or data may have been paid for separately or in the price of the product; or\n(ii) Situations in which contractors, acting as industry representatives, help Government agencies prepare, refine, or coordinate specifications, regardless of source, provided this assistance is supervised and controlled by Government representatives.\n(2) If a single contractor drafts complete specifications for nondevelopmental equipment, it should be eliminated for a reasonable time from competition for production based on the specifications. This should be done in order to avoid a situation in which the contractor could draft specifications favoring its own products or capabilities. In this way the Government can be assured of getting unbiased advice as to the content of the specifications and can avoid allegations of favoritism in the award of production contracts.\n(3) In development work, it is normal to select firms that have done the most advanced work in the field. These firms can be expected to design and develop around their own prior knowledge. Development contractors can frequently start production earlier and more knowledgeably than firms that did not participate in the development, and this can affect the time and quality of production, both of which are important to the Government. In many instances the Government may have financed the development. Thus, while the development contractor has a competitive advantage, it is an unavoidable one that is not considered unfair; hence no prohibition should be imposed.\n(b)(1) If a contractor prepares, or assists in preparing, a work statement to be used in competitively acquiring a system or services  or provides material leading directly, predictably, and without delay to such a work statement  that contractor may not supply the system, major components of the system, or the services unless  \n(i) It is the sole source;\n(ii) It has participated in the development and design work; or\n(iii) More than one contractor has been involved in preparing the work statement.\n(2) Agencies should normally prepare their own work statements. When contractor assistance is necessary, the contractor might often be in a position to favor its own products or capabilities. To overcome the possibility of bias, contractors are prohibited from supplying a system or services acquired on the basis of work statements growing out of their services, unless excepted in paragraph (b)(1) of this section.\n(3) For the reasons given in 9.505-2 (a)(3), no prohibitions are imposed on development and design contractors.\n9.505-3 Providing evaluation services.\nContracts for the evaluation of offers for products or services shall not be awarded to a contractor that will evaluate its own offers for products or services, or those of a competitor, without proper safeguards to ensure objectivity to protect the Government  s interests.\n9.505-4 Obtaining access to proprietary information.\n(a) When a contractor requires proprietary information from others to perform a Government contract and can use the leverage of the contract to obtain it, the contractor may gain an unfair competitive advantage unless restrictions are imposed. These restrictions protect the information and encourage companies to provide it when necessary for contract performance. They are not intended to protect information  \n(1) Furnished voluntarily without limitations on its use; or\n(2) Available to the Government or contractor from other sources without restriction.\n(b) A contractor that gains access to proprietary information of other companies in performing advisory and assistance services for the Government must agree with the other companies to protect their information from unauthorized use or disclosure for as long as it remains proprietary and refrain from using the information for any purpose other than that for which it was furnished. The contracting officer shall obtain copies of these agreements and ensure that they are properly executed.\n(c) Contractors also obtain proprietary and source selection information by acquiring the services of marketing consultants which, if used in connection with an acquisition, may give the contractor an unfair competitive advantage. Contractors should make inquiries of marketing consultants to ensure that the marketing consultant has provided no unfair competitive advantage.\n9.506 Procedures.\n(a) If information concerning prospective contractors is necessary to identify and evaluate potential organizational conflicts of interest or to develop recommended actions, contracting officers first should seek the information from within the Government or from other readily available sources. Government sources include the files and the knowledge of personnel within the contracting office, other contracting offices, the cognizant contract administration and audit activities and offices concerned with contract financing. Non-Government sources include publications and commercial services, such as credit rating services, trade and financial journals, and business directories and registers.\n(b) If the contracting officer decides that a particular acquisition involves a significant potential organizational conflict of interest, the contracting officer shall, before issuing the solicitation, submit for approval to the chief of the contracting office (unless a higher level official is designated by the agency)  \n(1) A written analysis, including a recommended course of action for avoiding, neutralizing, or mitigating the conflict, based on the general rules in 9.505 or on another basis not expressly stated in that section;\n(2) A draft solicitation provision (see 9.507-1 ); and\n(3) If appropriate, a proposed contract clause (see 9.507-2 ).\n(c) The approving official shall  \n(1) Review the contracting officer  s analysis and recommended course of action, including the draft provision and any proposed clause;\n(2) Consider the benefits and detriments to the Government and prospective contractors; and\n(3) Approve, modify, or reject the recommendations in writing.\n(d) The contracting officer shall  \n(1) Include the approved provision(s) and any approved clause(s) in the solicitation or the contract, or both;\n(2) Consider additional information provided by prospective contractors in response to the solicitation or during negotiations; and\n(3) Before awarding the contract, resolve the conflict or the potential conflict in a manner consistent with the approval or other direction by the head of the contracting activity.\n(e) If, during the effective period of any restriction (see 9.507 ), a contracting office transfers acquisition responsibility for the item or system involved, it shall notify the successor contracting office of the restriction, and send a copy of the contract under which the restriction was imposed.\n9.507 Solicitation provisions and contract clause.\n9.507-1 Solicitation provisions.\nAs indicated in the general rules in 9.505 , significant potential organizational conflicts of interest are normally resolved by imposing some restraint, appropriate to the nature of the conflict, upon the contractor  s eligibility for future contracts or subcontracts. Therefore, affected solicitations shall contain a provision that  \n(a) Invites offerors  attention to this subpart;\n(b) States the nature of the potential conflict as seen by the contracting officer;\n(c) States the nature of the proposed restraint upon future contractor activities; and\n(d) Depending on the nature of the acquisition, states whether or not the terms of any proposed clause and the application of this subpart to the contract are subject to negotiation.\n9.507-2 Contract clause.\n(a) If, as a condition of award, the contractor  s eligibility for future prime contract or subcontract awards will be restricted or the contractor must agree to some other restraint, the solicitation shall contain a proposed clause that specifies both the nature and duration of the proposed restraint. The contracting officer shall include the clause in the contract, first negotiating the clause  s final terms with the successful offeror, if it is appropriate to do so (see 9.506 (d) of this subsection).\n(b) The restraint imposed by a clause shall be limited to a fixed term of reasonable duration, sufficient to avoid the circumstance of unfair competitive advantage or potential bias. This period varies. It might end, for example, when the first production contract using the contractor  s specifications or work statement is awarded, or it might extend through the entire life of a system for which the contractor has performed systems engineering and technical direction. In every case, the restriction shall specify termination by a specific date or upon the occurrence of an identifiable event.\n9.508 Examples.\nThe examples in paragraphs (a) through (i) following illustrate situations in which questions concerning organizational conflicts of interest may arise. They are not all inclusive, but are intended to help the contracting officer apply the general rules in 9.505 to individual contract situations.\n(a) Company A agrees to provide systems engineering and technical direction for the Navy on the powerplant for a group of submarines ( i.e., turbines, drive shafts, propellers, etc.). Company A should not be allowed to supply any powerplant components. Company A can, however, supply components of the submarine unrelated to the powerplant ( e.g., fire control, navigation, etc.). In this example, the system is the powerplant, not the submarine, and the ban on supplying components is limited to those for the system only.\n(b) Company A is the systems engineering and technical direction contractor for system X. After some progress, but before completion, the system is canceled. Later, system Y is developed to achieve the same purposes as system X, but in a fundamentally different fashion. Company B is the systems engineering and technical direction contractor for system Y. Company A may supply system Y or its components.\n(c) Company A develops new electronic equipment and, as a result of this development, prepares specifications. Company A may supply the equipment.\n(d) XYZ Tool Company and PQR Machinery Company, representing the American Tool Institute, work under Government supervision and control to refine specifications or to clarify the requirements of a specific acquisition. These companies may supply the item.\n(e) Before an acquisition for information technology is conducted, Company A is awarded a contract to prepare data system specifications and equipment performance criteria to be used as the basis for the equipment competition. Since the specifications are the basis for selection of commercial hardware, a potential conflict of interest exists. Company A should be excluded from the initial follow-on information technology hardware acquisition.\n(f) Company A receives a contract to define the detailed performance characteristics an agency will require for purchasing rocket fuels. Company A has not developed the particular fuels. When the definition contract is awarded, it is clear to both parties that the agency will use the performance characteristics arrived at to choose competitively a contractor to develop or produce the fuels. Company A may not be awarded this follow-on contract.\n(g) Company A receives a contract to prepare a detailed plan for scientific and technical training of an agency  s personnel. It suggests a curriculum that the agency endorses and incorporates in its request for proposals to institutions to establish and conduct the training. Company A may not be awarded a contract to conduct the training.\n(h) Company A is selected to study the use of lasers in communications. The agency intends to ask that firms doing research in the field make proprietary information available to Company A. The contract must require Company A to  \n(1) Enter into agreements with these firms to protect any proprietary information they provide; and\n(2) Refrain from using the information in supplying lasers to the Government or for any purpose other than that for which it was intended.\n(i) An agency that regulates an industry wishes to develop a system for evaluating and processing license applications. Contractor X helps develop the system and process the applications. Contractor X should be prohibited from acting as a consultant to any of the applicants during its period of performance and for a reasonable period thereafter.");
register_book(&s, "|9|6|", "Contractor Team Arrangements", "Subpart 9.6  Contractor Team Arrangements\n9.601 Definition.\nContractor team arrangement,  as used in this subpart, means an arrangement in which  \n(1) Two or more companies form a partnership or joint venture to act as a potential prime contractor; or\n(2) A potential prime contractor agrees with one or more other companies to have them act as its subcontractors under a specified Government contract or acquisition program.\n9.602 General.\n(a) Contractor team arrangements may be desirable from both a Government and industry standpoint in order to enable the companies involved to  \n(1) Complement each other  s unique capabilities; and\n(2) Offer the Government the best combination of performance, cost, and delivery for the system or product being acquired.\n(b) Contractor team arrangements may be particularly appropriate in complex research and development acquisitions, but may be used in other appropriate acquisitions, including production.\n(c) The companies involved normally form a contractor team arrangement before submitting an offer. However, they may enter into an arrangement later in the acquisition process, including after contract award.\n9.603 Policy.\nThe Government will recognize the integrity and validity of contractor team arrangements; provided , the arrangements are identified and company relationships are fully disclosed in an offer or, for arrangements entered into after submission of an offer, before the arrangement becomes effective. The Government will not normally require or encourage the dissolution of contractor team arrangements.\n9.604 Limitations.\nNothing in this subpart authorizes contractor team arrangements in violation of antitrust statutes or limits the Government  s rights to  \n(a) Require consent to subcontracts (see Subpart 44.2 );\n(b) Determine, on the basis of the stated contractor team arrangement, the responsibility of the prime contractor (see Subpart 9.1 );\n(c) Provide to the prime contractor data rights owned or controlled by the Government;\n(d) Pursue its policies on competitive contracting, subcontracting, and component breakout after initial production or at any other time; and\n(e) Hold the prime contractor fully responsible for contract performance, regardless of any team arrangement between the prime contractor and its subcontractors.");
register_book(&s, "|9|7|", "Defense Production Pools and Research a", "Subpart 9.7  Defense Production Pools and Research and Development Pools\n9.701 Definition.\nPool,  as used in this subpart, means a group of concerns (see 19.001 ) that have  \n(1) Associated together in order to obtain and perform, jointly or in conjunction with each other, defense production or research and development contracts;\n(2) Entered into an agreement governing their organization, relationship, and procedures; and\n(3) Obtained approval of the agreement by either  \n(i) The Small Business Administration (SBA) under section 9 or 11 of the Small Business Act ( 15 U.S.C. 638 or 640) (see 13 CFR 125); or\n(ii) A designated official under Part V of Executive Order 10480, August 14, 1953 (18 FR 4939, August 20, 1953) and section 708 of the Defense Production Act of 1950 ( 50 U.S.C. App. 2158 ).\n9.702 Contracting with pools.\n(a) Except as specified in this subpart, a pool shall be treated the same as any other prospective or actual contractor.\n(b) The contracting officer shall not award a contract to a pool unless the offer leading to the contract is submitted by the pool in its own name or by an individual pool member expressly stating that the offer is on behalf of the pool.\n(c) Upon receipt of an offer submitted by a group representing that it is a pool, the contracting officer shall verify its approved status with the SBA District Office Director or other approving agency and document the contract file that the verification was made.\n(d) Pools approved by the SBA under the Small Business Act are entitled to the preferences and privileges accorded to small business concerns. Approval under the Defense Production Act does not confer these preferences and privileges.\n(e) Before awarding a contract to an unincorporated pool, the contracting officer shall require each pool member participating in the contract to furnish a certified copy of a power of attorney identifying the agent authorized to sign the offer or contract on that member  s behalf. The contracting officer shall attach a copy of each power of attorney to each signed copy of the contract retained by the Government.\n9.703 Contracting with individual pool members.\n(a) Pool members may submit individual offers, independent of the pool. However, the contracting officer shall not consider an independent offer by a pool member if that pool member participates in a competing offer submitted by the pool.\n(b) If a pool member submits an individual offer, independent of the pool, the contracting officer shall consider the pool agreement, along with other factors, in determining whether that pool member is a responsible prospective contractor under Subpart 9.1 .\n*    *    *    *    *    *");
register_book(&s, "|11|2|", "Using and Maintaining Requirements Docu", "Subpart 11.2  Using and Maintaining Requirements Documents\n11.201 Identification and availability of specifications.\n(a) Solicitations citing requirements documents listed in the General Services Administration (GSA) Index of Federal Specifications, Standards and Commercial Item Descriptions, the DoD Acquisition Streamlining and Standardization Information System (ASSIST), or other agency index shall identify each document  s approval date and the dates of any applicable amendments and revisions. Do not use general identification references, such as  the issue in effect on the date of the solicitation.  Contracting offices will not normally furnish these cited documents with the solicitation, except when  \n(1) The requirements document must be furnished with the solicitation to enable prospective contractors to make a competent evaluation of the solicitation;\n(2) In the judgment of the contracting officer, it would be impracticable for prospective contractors to obtain the documents in reasonable time to respond to the solicitation; or\n(3) A prospective contractor requests a copy of a Government promulgated requirements document.\n(b) Contracting offices shall clearly identify in the solicitation any pertinent documents not listed in the GSA Index of Federal Specifications, Standards and Commercial Item Descriptions or ASSIST. Such documents shall be furnished with the solicitation or specific instructions shall be furnished for obtaining or examining such documents.\n(c) When documents refer to other documents, such references shall  \n(1) Be restricted to documents, or appropriate portions of documents, that apply in the acquisition;\n(2) Cite the extent of their applicability;\n(3) Not conflict with other documents and provisions of the solicitation; and\n(4) Identify all applicable first tier references.\n(d)(1) The GSA Index of Federal Specifications, Standards and Commercial Item Descriptions, FPMR Part 101-29, may be purchased from the  \nGeneral Services Administration Federal Supply Service Specifications Section Suite 8100 470 East L  Enfant Plaza, SW Washington, DC 20407 Telephone (202) 619-8925.\n(2) Most unclassified Defense specifications and standards may be downloaded from the following ASSIST website:\n(i) ASSIST ( http://assist.daps.dla.mil ).\n(ii) Quick Search ( http://assist.daps.dla.mil/quicksearch ).\n(iii) ASSISTdocs.com ( http://assistdocs.com ).\n(3) Documents not available from ASSIST may be ordered from the Department of Defense Single Stock Point (DoDSSP) by  \n(i) Using the ASSIST Shopping Wizard ( http://assist.daps.dla.mil/wizard );\n(ii) Phoning the DoDSSP Customer Service Desk, (215) 697-2179, Mon-Fri, 0730 to 1600 EST; or\n(iii) Ordering from DoDSSP, Building 4, Section D, 700 Robbins Avenue, Philadelphia, PA 19111-5094, Telephone (215) 697-2667/2179, Facsimile (215) 697-1462.\n(4) The FIPS PUBS may be obtained from  \nhttp://www.itl.nist.gov/fipspubs/ , or purchased from the  \nSuperintendent of Documents, U.S. Government Printing Office, Washington, DC 20402, Telephone (202) 512-1800, Facsimile (202) 512-2250; or\nNational Technical Information Service (NTIS), 5285 Port Royal Road, Springfield, VA 22161, Telephone (703) 605-6000, Facsimile (703) 605-6900, Email: orders@ntis.gov .\n(e) Agencies may purchase some nongovernment standards, including voluntary consensus standards, from the National Technical Information Service  s Fedworld Information Network. Agencies may also obtain nongovernment standards from the standards developing organization responsible for the preparation, publication, or maintenance of the standard, or from an authorized document reseller. The National Institute of Standards and Technology can assist agencies in identifying sources for, and content of, nongovernment standards. DoD activities may obtain from the DoDSSP those nongovernment standards, including voluntary consensus standards, adopted for use by defense activities.\n11.202 Maintenance of standardization documents.\n(a) Recommendations for changes to standardization documents listed in the GSA Index of Federal Specifications, Standards and Commercial Item Descriptions should be submitted to the  \nGeneral Services Administration Federal Supply Service Office of Acquisition Washington, DC 20406.\nAgencies shall submit recommendations for changes to standardization documents listed in the DoDISS to the cognizant preparing activity.\n(b) When an agency cites an existing standardization document but modifies it to meet its needs, the agency shall follow the guidance in Federal Standardization Manual and, for Defense components, DoD 4120.24-M, Defense Standardization Program Policies and Procedures.\n11.203 Customer satisfaction.\nAcquisition organizations shall communicate with customers to determine how well the requirements document reflects the customer  s needs and to obtain suggestions for corrective actions. Whenever practicable, the agency may provide affected industry an opportunity to comment on the requirements documents.\n11.204 Solicitation provisions and contract clauses.\n(a) The contracting officer shall insert the provision at 52.211-1 , Availability of Specifications Listed in the GSA Index of Federal Specifications, Standards and Commercial Item Descriptions, FPMR Part 101-29, in solicitations that cite specifications listed in the Index that are not furnished with the solicitation.\n(b) The contracting officer shall insert the provision at 52.211-2 , Availability of Specifications, Standards, and Data Item Descriptions Listed in the Acquisition Streamlining and Standardization Information System (ASSIST), in solicitations that cite specifications listed in the ASSIST that are not furnished with the solicitation.\n(c) The contracting officer shall insert a provision substantially the same as the provision at 52.211-3 , Availability of Specifications Not Listed in the GSA Index of Federal Specifications, Standards and Commercial Item Descriptions, in solicitations that cite specifications that are not listed in the Index and are not furnished with the solicitation, but may be obtained from a designated source.\n(d) The contracting officer shall insert a provision substantially the same as the provision at 52.211-4 , Availability for Examination of Specifications Not Listed in the GSA Index of Federal Specifications, Standards and Commercial Item Descriptions, in solicitations that cite specifications that are not listed in the Index and are available for examination at a specified location.");
register_book(&s, "|11|3|", "Acceptable Material", "Subpart 11.3  Acceptable Material\n11.301 Definitions.\nAs used in this subpart  \nPostconsumer material  means a material or finished product that has served its intended use and has been discarded for disposal or recovery, having completed its life as a consumer item. Postconsumer material is a part of the broader category of  recovered material.  For paper and paper products, postconsumer material means  postconsumer fiber  defined by the U.S. Environmental Protection Agency (EPA) as  \n(1) Paper, paperboard, and fibrous materials from retail stores, office buildings, homes, and so forth, after they have passed through their end-usage as a consumer item, including: used corrugated boxes; old newspapers; old magazines; mixed waste paper; tabulating cards; and used cordage; or\n(2) All paper, paperboard, and fibrous materials that enter and are collected from municipal solid waste; but not\n(3) Fiber derived from printers  over-runs, converters  scrap, and over-issue publications.\nRecovered material  for paper and paper products, is defined by EPA in its Comprehensive Procurement Guideline as  recovered fiber  and means the following materials:\n(1) Postconsumer fiber.\n(2) Manufacturing wastes such as  \n(i) Dry paper and paperboard waste generated after completion of the papermaking process (that is, those manufacturing operations up to and including the cutting and trimming of the paper machine reel into smaller rolls or rough sheets) including: envelope cuttings, bindery trimmings, and other paper and paperboard waste resulting from printing, cutting, forming, and other converting operations; bag, box, and carton manufacturing wastes; and butt rolls, mill wrappers, and rejected unused stock; and\n(ii) Repulped finished paper and paperboard from obsolete inventories of paper and paperboard manufacturers, merchants, wholesalers, dealers, printers, converters, or others.\n11.302 Policy.\n(a) Agencies must not require virgin material or supplies composed of or manufactured using virgin material unless compelled by law or regulation or unless virgin material is vital for safety or meeting performance requirements of the contract.\n(b)(1) When acquiring other than commercial items, agencies must require offerors to identify used, reconditioned, or remanufactured supplies; or unused former Government surplus property proposed for use under the contract. These supplies or property may not be used in contract performance unless authorized by the contracting officer.\n(2) When acquiring commercial items, the contracting officer must consider the customary practices in the industry for the item being acquired. The contracting officer may require offerors to provide information on used, reconditioned, or remanufactured supplies, or unused former Government surplus property proposed for use under the contract. The request for the information must be included in the solicitation, and to the maximum extent practicable must be limited to information or standards consistent with normal commercial practices.\n(c)(1) When the contracting officer needs additional information to determine whether supplies meet minimum recovered material or biobased standards stated in the solicitation, the contracting officer may require offerors to submit additional information on the recycled or biobased content or related standards. The request for the information must be included in the solicitation. When acquiring commercial items, limit the information to the maximum extent practicable to that available under normal commercial practices.\n(2) For biobased products, agencies may not require, as a condition of purchase of such products, the vendor or manufacturer to provide more data than would typically be provided by other business entities offering products for sale to the agency, other than data confirming the biobased content of a product (see 7 CFR 3201.8).\n11.303 Special requirements for paper.\n(a) The following applies when agencies acquire paper in the United States (as defined in 23.001 ):\n(1) Section 2(d)(ii) of Executive Order 13423, Strengthening Federal Environmental, Energy, and Transportation Management, establishes a 30 percent postconsumer fiber content standards for agency paper use. Section 2(d)(ii) requires that an agency  s paper products must meet or exceed the minimum content standard.\n(2) Section 2(e)(iv) of Executive Order 13514 requires acquisition of uncoated printing and writing paper containing at least 30 percent postconsumer fiber.\n(b) Exceptions . If paper under paragraphs (a)(1) or (a)(2) of this section containing at least 30 percent postconsumer fiber is not reasonably available, does not meet reasonable performance requirements, or is only available at an unreasonable price, then the agency must purchase  \n(1) Printing and writing paper containing no less than 20 percent postconsumer fiber; or\n(2) Paper, other than printing and writing paper, with the maximum practicable percentage of postconsumer fiber that is reasonably available at a reasonable price and that meets reasonable performance requirements.\n11.304 Contract clause.\nInsert the clause at 52.211-5 , Material Requirements, in solicitations and contracts for supplies that are not commercial items.");
register_book(&s, "|11|4|", "Delivery or Performance Schedules", "Subpart 11.4  Delivery or Performance Schedules\n11.401 General.\n(a) The time of delivery or performance is an essential contract element and shall be clearly stated in solicitations. Contracting officers shall ensure that delivery or performance schedules are realistic and meet the requirements of the acquisition. Schedules that are unnecessarily short or difficult to attain  \n(1) Tend to restrict competition,\n(2) Are inconsistent with small business policies, and\n(3) May result in higher contract prices.\n(b) Solicitations shall, except when clearly unnecessary, inform bidders or offerors of the basis on which their bids or proposals will be evaluated with respect to time of delivery or performance.\n(c) If timely delivery or performance is unusually important to the Government, liquidated damages clauses may be used (see Subpart 11.5 ).\n11.402 Factors to consider in establishing schedules.\n(a) Supplies or services. When establishing a contract delivery or performance schedule, consideration shall be given to applicable factors such as the  \n(1) Urgency of need;\n(2) Industry practices;\n(3) Market conditions;\n(4) Transportation time;\n(5) Production time;\n(6) Capabilities of small business concerns;\n(7) Administrative time for obtaining and evaluating offers and for awarding contracts;\n(8) Time for contractors to comply with any conditions precedent to contract performance; and\n(9) Time for the Government to perform its obligations under the contract; e.g., furnishing Government property.\n(b) Construction . When scheduling the time for completion of a construction contract, the contracting officer shall consider applicable factors such as the  \n(1) Nature and complexity of the project;\n(2) Construction seasons involved;\n(3) Required completion date;\n(4) Availability of materials and equipment;\n(5) Capacity of the contractor to perform; and\n(6) Use of multiple completion dates. (In any given contract, separate completion dates may be established for separable items of work. When multiple completion dates are used, requests for extension of time must be evaluated with respect to each item, and the affected completion dates modified when appropriate.)\n11.403 Supplies or services.\n(a) The contracting officer may express contract delivery or performance schedules in terms of  \n(1) Specific calendar dates;\n(2) Specific periods from the date of the contract; i.e., from the date of award or acceptance by the Government, or from the date shown as the effective date of the contract;\n(3) Specific periods from the date of receipt by the contractor of the notice of award or acceptance by the Government (including notice by receipt of contract document executed by the Government); or\n(4) Specific time for delivery after receipt by the contractor of each individual order issued under the contract, as in indefinite delivery type contracts and GSA schedules.\n(b) The time specified for contract performance should not be curtailed to the prejudice of the contractor because of delay by the Government in giving notice of award.\n(c) If the delivery schedule is based on the date of the contract, the contracting officer shall mail or otherwise furnish to the contractor the contract, notice of award, acceptance of proposal, or other contract document not later than the date of the contract.\n(d) If the delivery schedule is based on the date the contractor receives the notice of award, or if the delivery schedule is expressed in terms of specific calendar dates on the assumption that the notice of award will be received by a specified date, the contracting officer shall send the contract, notice of award, acceptance of proposal, or other contract document by certified mail, return receipt requested, or by any other method that will provide evidence of the date of receipt.\n(e) In invitations for bids, if the delivery schedule is based on the date of the contract, and a bid offers delivery based on the date the contractor receives the contract or notice of award, the contracting officer shall evaluate the bid by adding 5 calendar days (as representing the normal time for arrival through ordinary mail). If the contract or notice of award will be transmitted electronically, (1) the solicitation shall so state; and (2) the contracting officer shall evaluate delivery schedule based on the date of contract receipt or notice of award, by adding one working day. (The term  working day  excludes weekends and U.S. Federal holidays.) If the offered delivery date computed with mailing or transmittal time is later than the delivery date required by the invitation for bids, the bid shall be considered nonresponsive and rejected. If award is made, the delivery date will be the number of days offered in the bid after the contractor actually receives the notice of award.\n11.404 Contract clauses.\n(a) Supplies or services.\n(1) The contracting officer may use a time of delivery clause to set forth a required delivery schedule and to allow an offeror to propose an alternative delivery schedule. The clauses and their alternates may be used in solicitations and contracts for other than construction and architect-engineering substantially as shown, or they may be changed or new clauses written.\n(2) The contracting officer may insert in solicitations and contracts other than those for construction and architect-engineering, a clause substantially the same as the clause at 52.211-8 , Time of Delivery, if the Government requires delivery by a particular time and the delivery schedule is to be based on the date of the contract. If the delivery schedule is expressed in terms of specific calendar dates or specific periods and is based on an assumed date of award, the contracting officer may use the clause with its Alternate I. If the delivery schedule is expressed in terms of specific calendar dates or specific periods and is based on an assumed date the contractor will receive notice of award, the contracting officer may use the clause with its Alternate II. If the delivery schedule is to be based on the actual date the contractor receives a written notice of award, the contracting officer may use the clause with its Alternate III.\n(3) The contracting officer may insert in solicitations and contracts other than those for construction and architect-engineering, a clause substantially the same as the clause at 52.211-9 , Desired and Required Time of Delivery, if the Government desires delivery by a certain time but requires delivery by a specified later time, and the delivery schedule is to be based on the date of the contract. If the delivery schedule is expressed in terms of specific calendar dates or specific periods and is based on an assumed date of award, the contracting officer may use the clause with its Alternate I. If the delivery schedule is expressed in terms of specific calendar dates or specific periods and is based on an assumed date the contractor will receive notice of award, the contracting officer may use the clause with its Alternate II. If the delivery schedule is to be based on the actual date the contractor receives a written notice of award, the contracting officer may use the clause with its Alternate III.\n(b) Construction . The contracting officer shall insert the clause at 52.211-10 , Commencement, Prosecution, and Completion of Work, in solicitations and contracts when a fixed-price construction contract is contemplated. The clause may be changed to accommodate the issuance of orders under indefinite-delivery contracts. If the completion date is expressed as a specific calendar date, computed on the basis of the contractor receiving the notice to proceed by a certain day, the contracting officer may use the clause with its Alternate I.");
register_book(&s, "|11|5|", "Liquidated Damages", "Subpart 11.5  Liquidated Damages\n11.500 Scope.\nThis subpart prescribes policies and procedures for using liquidated damages clauses in solicitations and contracts for supplies, services, research and development, and construction. This subpart does not apply to liquidated damages for subcontracting plans (see 19.705-7 ) or liquidated damages related to the Contract Work Hours and Safety Standards Act (see Subpart 22.3 ).\n11.501 Policy.\n(a) The contracting officer must consider the potential impact on pricing, competition, and contract administration before using a liquidated damages clause. Use liquidated damages clauses only when  \n(1) The time of delivery or timely performance is so important that the Government may reasonably expect to suffer damage if the delivery or performance is delinquent; and\n(2) The extent or amount of such damage would be difficult or impossible to estimate accurately or prove.\n(b) Liquidated damages are not punitive and are not negative performance incentives (see 16.402-2 ). Liquidated damages are used to compensate the Government for probable damages. Therefore, the liquidated damages rate must be a reasonable forecast of just compensation for the harm that is caused by late delivery or untimely performance of the particular contract. Use a maximum amount or a maximum period for assessing liquidated damages if these limits reflect the maximum probable damage to the Government. Also, the contracting officer may use more than one liquidated damages rate when the contracting officer expects the probable damage to the Government to change over the contract period of performance.\n(c) The contracting officer must take all reasonable steps to mitigate liquidated damages. If the contract contains a liquidated damages clause and the contracting officer is considering terminating the contract for default, the contracting officer should seek expeditiously to obtain performance by the contractor or terminate the contract and repurchase (see Subpart 49.4 ). Prompt contracting officer action will prevent excessive loss to defaulting contractors and protect the interests of the Government.\n(d) The head of the agency may reduce or waive the amount of liquidated damages assessed under a contract, if the Commissioner, Financial Management Service, or designee approves (see Treasury Order 145-10).\n11.502 Procedures.\n(a) Include the applicable liquidated damages clause and liquidated damages rates in solicitations when the contract will contain liquidated damages provisions.\n(b) Construction contracts with liquidated damages provisions must describe the rate(s) of liquidated damages assessed per day of delay. The rate(s) should include the estimated daily cost of Government inspection and superintendence. The rate(s) should also include an amount for other expected expenses associated with delayed completion such as  \n(1) Renting substitute property; or\n(2) Paying additional allowance for living quarters.\n11.503 Contract clauses.\n(a) Use the clause at 52.211-11 , Liquidated Damages  Supplies, Services, or Research and Development, in fixed-price solicitations and contracts for supplies, services, or research and development when the contracting officer determines that liquidated damages are appropriate (see 11.501 (a)).\n(b) Use the clause at 52.211-12 , Liquidated Damages  Construction, in solicitations and contracts for construction, other than cost-plus-fixed-fee, when the contracting officer determines that liquidated damages are appropriate (see 11.501 (a)). If the contract specifies more than one completion date for separate parts or stages of the work, revise paragraph (a) of the clause to state the amount of liquidated damages for delay of each separate part or stage of the work.\n(c) Use the clause at 52.211-13 , Time Extensions, in solicitations and contracts for construction that use the clause at 52.211-12 , Liquidated Damages  Construction, when that clause has been revised as provided in paragraph (b) of this section.");
register_book(&s, "|11|6|", "Priorities and Allocations", "Subpart 11.6  Priorities and Allocations\n11.600 Scope of subpart.\nThis subpart implements the Defense Priorities and Allocations System (DPAS), a Department of Commerce regulation in support of approved national defense, emergency preparedness, and energy programs (see 15 CFR part 700).\n11.601 Definitions.\nAs used in this subpart  \nApproved program  means a program determined as necessary or appropriate for priorities and allocations support to promote the national defense by the Secretary of Defense, the Secretary of Energy, or the Secretary of Homeland Security, under the authority of the Defense Production Act, the Stafford Act, and Executive Order 12919, or the Selective Service Act and related statutes and Executive Order 12742.\nDelegate Agency  means a Government agency authorized by delegation from the Department of Commerce to place priority ratings on contracts or orders needed to support approved programs.\nNational defense  means programs for military and energy production or construction, military assistance to any foreign nation, stockpiling, space, and any directly related activity. Such term includes emergency preparedness activities conducted pursuant to title VI of The Robert T. Stafford Disaster Relief and Emergency Assistance Act ( 42 U.S.C. 5195 et seq .) and critical infrastructure protection and restoration. ( 50 U.S.C. App.  2152 ).\nRated order  means a prime contract, a subcontract, or a purchase order in support of an approved program issued in accordance with the provisions of the DPAS regulation (15 CFR part 700).\n11.602 General.\n(a) Under Title I of the Defense Production Act of 1950 ( 50 U.S.C. App. 2061 , et seq .), the President is authorized to require preferential acceptance and performance of contracts and orders supporting certain approved national defense and energy programs and to allocate materials, services, and facilities in such a manner as to promote these approved programs.\n(b) The President delegated the priorities and allocations authorities of the Defense Production Act in Executive Order 12919. As part of that delegation, the President designated the Secretary of Commerce to administer the DPAS. For more information, check the DPAS website at: www.bis.doc.gov/dpas.\n11.603 Procedures.\n(a) There are two levels of priority for rated orders established by the DPAS, identified by the rating symbols  DO  and  DX  . All DO rated orders have equal priority with each other and take preference over unrated orders. All DX rated orders have equal priority with each other and take preference over DO rated and unrated orders (see 15 CFR 700.11). The DPAS regulation contains provisions concerning the elements of a rated order (see 15 CFR 700.12); acceptance and rejection of rated orders (see 15 CFR 700.13); preferential scheduling (see 15 CFR 700.14); extension of priority ratings (flowdown) (see 15 CFR 700.15); changes or cancellations of priority ratings and rated orders (see 15 CFR 700.16); use of rated orders (see 15 CFR 700.17); and limitations on placing rated orders (see 15 CFR 700.18).\n(b) The Delegate Agencies have been given authority by the Department of Commerce to place rated orders in support of approved programs (see Schedule I of the DPAS). Other U.S. Government agencies, Canada, and foreign nations may apply for priority rating authority.\n(c) Rated orders shall be placed in accordance with the provisions of the DPAS.\n(d) Agency heads shall ensure compliance with the DPAS by contracting activities within their agencies.\n(e) Agency heads shall provide contracting activities with specific guidance on the issuance of rated orders in support of approved agency programs, including the general limitations and jurisdictional limitations on placing rated orders (see 15 CFR 700.18 and Executive Order 12919).\n(f) Contracting officers shall follow agency procedural instructions concerning the use of rated orders in support of approved agency programs.\n(g) Contracting officers, contractors, or subcontractors at any tier, that experience difficulty placing rated orders, obtaining timely delivery under rated orders, locating a contractor or supplier to fill a rated order, ensuring that rated orders receive preferential treatment by contractors or suppliers, or require rating authority for items not automatically ratable under the DPAS, should promptly seek special priorities assistance in accordance with agency procedures (see 15 CFR 700.50-700.55 and 700.80).\n(h) The Department of Commerce may take specific official actions (Ratings Authorizations, Directives, Letters of Understanding, Administrative Subpoenas, Demands for Information, and Inspection Authorizations) to implement or enforce the provisions of the DPAS (see 15 CFR 700.60-700.71).\n(i) Contracting officers shall report promptly any violations of the DPAS in accordance with agency procedures to the Office of Strategic Industries and Economic Security, U.S. Department of Commerce, Room 3876, Washington, DC 20230, Ref: DPAS; telephone: (202) 482-3634 or fax: (202) 482-5650.\n11.604 Solicitation provision and contract clause.\n(a) Contracting officers shall insert the provision at 52.211-14 , Notice of Priority Rating for National Defense, Emergency Preparedness, and Energy Program Use, in solicitations when the contract to be awarded will be a rated order.\n(b) Contracting officers shall insert the clause at 52.211-15 , Defense Priority and Allocation Requirements, in contracts that are rated orders.");
register_book(&s, "|11|7|", "Variation in Quantity", "Subpart 11.7  Variation in Quantity\n11.701 Supply contracts.\n(a) A fixed-price supply contract may authorize Government acceptance of a variation in the quantity of items called for if the variation is caused by conditions of loading, shipping, or packing, or by allowances in manufacturing processes. Any permissible variation shall be stated as a percentage and it may be an increase, a decrease, or a combination of both; however, contracts for subsistence items may use other applicable terms of variation in quantity.\n(b) There should be no standard or usual variation percentage. The overrun or underrun permitted in each contract should be based upon the normal commercial practices of a particular industry for a particular item, and the permitted percentage should be no larger than is necessary to afford a contractor reasonable protection. The permissible variation shall not exceed plus or minus 10 percent unless a different limitation is established in agency regulations. Consideration shall be given to the quantity to which the percentage variation applies. For example, when delivery will be made to multiple destinations and it is desired that the quantity variation apply to the item quantity for each destination, this requirement must be stated in the contract.\n(c) Contractors are responsible for delivery of the specified quantity of items in a fixed-price contract, within allowable variations, if any. If a contractor delivers a quantity of items in excess of the contract requirements plus any allowable variation in quantity, particularly small dollar value overshipments, it results in unnecessary administrative costs to the Government in determining disposition of the excess quantity. Accordingly, the contract may include the clause at 52.211-17 , Delivery of Excess Quantities, to provide that  \n(1) Excess quantities of items totaling up to $250 in value may be retained without compensating the contractor; and\n(2) Excess quantities of items totaling over $250 in value may, at the Government  s option, be either returned at the contractor  s expense or retained and paid for at the contract unit price.\n11.702 Construction contracts.\nConstruction contracts may authorize a variation in estimated quantities of unit-priced items. When the variation between the estimated quantity and the actual quantity of a unit-priced item is more than plus or minus 15 percent, an equitable adjustment in the contract price shall be made upon the demand of either the Government or the contractor. The contractor may request an extension of time if the quantity variation is such as to cause an increase in the time necessary for completion. The contracting officer must receive the request in writing within 10 days from the beginning of the period of delay. However, the contracting officer may extend this time limit before the date of final settlement of the contract. The contracting officer shall ascertain the facts and make any adjustment for extending the completion date that the findings justify.\n11.703 Contract clauses.\n(a) The contracting officer shall insert the clause at 52.211-16 , Variation in Quantity, in solicitations and contracts, if authorizing a variation in quantity in fixed-price contracts for supplies or for services that involve the furnishing of supplies.\n(b) The contracting officer may insert the clause at 52.211-17 , Delivery of Excess Quantities, in solicitations and contracts when a fixed-price supply contract is contemplated.\n(c) The contracting officer shall insert the clause at 52.211-18 , Variation in Estimated Quantity, in solicitations and contracts when a fixed-price construction contract is contemplated that authorizes a variation in the estimated quantity of unit-priced items.");
register_book(&s, "|11|8|", "Testing", "Subpart 11.8  Testing\n11.801 Preaward in-use evaluation.\nSupplies may be evaluated under comparable in-use conditions without a further test plan, provided offerors are so advised in the solicitation. The results of such tests or demonstrations may be used to rate the proposal, to determine technical acceptability, or otherwise to evaluate the proposal (see 15.305 ).\n*    *    *    *    *    *");
register_book(&s, "|12|2|", "Special Requirements for the Acquisitio", "Subpart 12.2  Special Requirements for the Acquisition of Commercial Items\n12.201 General.\nPublic Law 103-355 establishes special requirements for the acquisition of commercial items intended to more closely resemble those customarily used in the commercial marketplace. This subpart identifies those special requirements as well as other considerations necessary for proper planning, solicitation, evaluation and award of contracts for commercial items.\n12.202 Market research and description of agency need.\n(a) Market research (see 10.001 ) is an essential element of building an effective strategy for the acquisition of commercial items and establishes the foundation for the agency description of need (see Part 11 ), the solicitation, and resulting contract.\n(b) The description of agency need must contain sufficient detail for potential offerors of commercial items to know which commercial products or services may be suitable. Generally, for acquisitions in excess of the simplified acquisition threshold, an agency  s statement of need for a commercial item will describe the type of product or service to be acquired and explain how the agency intends to use the product or service in terms of function to be performed, performance requirement or essential physical characteristics. Describing the agency  s needs in these terms allows offerors to propose methods that will best meet the needs of the Government.\n(c) Follow the procedures in Subpart 11.2 regarding the identification and availability of specifications, standards and commercial item descriptions.\n(d) Requirements documents for electronic and information technology must comply with the applicable accessibility standards issued by the Architectural and Transportation Barriers Compliance Board at 36 CFR Part 1194 (see Subpart 39.2 ).\n(e) When acquiring information technology using Internet Protocol, agencies must include the appropriate Internet Protocol compliance requirements in accordance with 11.002 (g).\n12.203 Procedures for solicitation, evaluation, and award.\nContracting officers shall use the policies unique to the acquisition of commercial items prescribed in this part in conjunction with the policies and procedures for solicitation, evaluation and award prescribed in Part 13 , Simplified Acquisition Procedures; Part 14 , Sealed Bidding; or Part 15 , Contracting by Negotiation, as appropriate for the particular acquisition. The contracting officer may use the streamlined procedure for soliciting offers for commercial items prescribed in 12.603 . For acquisitions of commercial items exceeding the simplified acquisition threshold but not exceeding $6.5 million ($12 million for acquisitions as described in 13.500 (e)), including options, contracting activities shall employ the simplified procedures authorized by Subpart 13.5 to the maximum extent practicable.\n12.204 Solicitation/contract form.\n(a) The contracting officer shall use the Standard Form 1449 , Solicitation/Contract/Order for Commercial Items, if (1) the acquisition is expected to exceed the simplified acquisition threshold; (2) a paper solicitation or contract is being issued; and (3) procedures at 12.603 are not being used. Use of the SF 1449 is nonmandatory but encouraged for commercial acquisitions not exceeding the simplified acquisition threshold.\n(b) Consistent with the requirements at 5.203 (a) and (h), the contracting officer may allow fewer than 15 days before issuance of the solicitation.\n12.205 Offers.\n(a) Where technical information is necessary for evaluation of offers, agencies should, as part of market research, review existing product literature generally available in the industry to determine its adequacy for purposes of evaluation. If adequate, contracting officers shall request existing product literature from offerors of commercial items in lieu of unique technical proposals.\n(b) Contracting officers should allow offerors to propose more than one product that will meet a Government need in response to solicitations for commercial items. The contracting officer shall evaluate each product as a separate offer.\n(c) Consistent with the requirements at 5.203 (b), the contracting officer may allow fewer than 30 days response time for receipt of offers for commercial items, unless the acquisition is covered by the World Trade Organization Government Procurement Agreement or a Free Trade Agreement (see 5.203 (h)).\n12.206 Use of past performance.\nPast performance should be an important element of every evaluation and contract award for commercial items. Contracting officers should consider past performance data from a wide variety of sources both inside and outside the Federal Government in accordance with the policies and procedures contained in Subpart 9.1 , 13.106 , or Subpart 15.3 , as applicable.\n12.207 Contract type.\n(a) Except as provided in paragraph (b) of this section, agencies shall use firm-fixed-price contracts or fixed-price contracts with economic price adjustment for the acquisition of commercial items.\n(b) \n(1) A time-and-materials contract or labor-hour contract (see Subpart 16.6 ) may be used for the acquisition of commercial services when  \n(i) The service is acquired under a contract awarded using  \n(A) Competitive procedures ( e.g. , the procedures in 6.102 , the set-aside procedures in Subpart 19.5 , or competition conducted in accordance with Part 13 );\n(B) The procedures for other than full and open competition in 6.3 provided the agency receives offers that satisfy the Government  s expressed requirement from two or more responsible offerors; or\n(C) The fair opportunity procedures in 16.505 (including discretionary small business set-asides under 16.505 (b)(2)(i)(F)), if placing an order under a multiple-award delivery-order contract; and\n(ii) The contracting officer  \n(A) Executes a determination and findings (D&F) for the contract, in accordance with paragraph (b)(2) of this section (but see paragraph (c) of this section for indefinite-delivery contracts), that no other contract type authorized by this subpart is suitable;\n(B) Includes a ceiling price in the contract or order that the contractor exceeds at its own risk; and\n(C) Prior to increasing the ceiling price of a time-and-materials or labor-hour contract or order, shall  \n(1) Conduct an analysis of pricing and other relevant factors to determine if the action is in the best interest of the Government;\n(2) Document the decision in the contract or order file; and\n(3) When making a change that modifies the general scope of  \n(i) A contract, follow the procedures at 6.303;\n(ii) An order issued under the Federal Supply Schedules, follow the procedures at 8.405-6; or \n(iii) An order issued under multiple award task and delivery order contracts, follow the procedures at 16.505 (b)(2).\n(2) Each D&F required by paragraph (b)(1)(ii)(A) of this section shall contain sufficient facts and rationale to justify that no other contract type authorized by this subpart is suitable. At a minimum, the D&F shall  \n(i) Include a description of the market research conducted (see 10.002 (e));\n(ii) Establish that it is not possible at the time of placing the contract or order to accurately estimate the extent or duration of the work or to anticipate costs with any reasonable degree of confidence;\n(iii) Establish that the requirement has been structured to maximize the use of firm-fixed-price or fixed-price with economic price adjustment contracts ( e.g. , by limiting the value or length of the time-and-material/labor-hour contract or order; establishing fixed prices for portions of the requirement) on future acquisitions for the same or similar requirements; and\n(iv) Describe actions planned to maximize the use of firm-fixed-price or fixed-price with economic price adjustment contracts on future acquisitions for the same requirements.\n(3) See 16.601 (d)(1) for additional approval required for contracts expected to extend beyond three years.\n(4) See 8.404 (h) for the requirement for determination and findings when using Federal Supply Schedules.\n(c)(1) Indefinite-delivery contracts (see Subpart 16.5 ) may be used when  \n(i) The prices are established based on a firm-fixed-price or fixed-price with economic price adjustment; or\n(ii) Rates are established for commercial services acquired on a time-and-materials or labor-hour basis.\n(2) When an indefinite-delivery contract is awarded with services priced on a time-and-materials or labor-hour basis, contracting officers shall, to the maximum extent practicable, also structure the contract to allow issuance of orders on a firm-fixed-price or fixed-price with economic price adjustment basis. For such contracts, the contracting officer shall execute the D&F required by paragraph (b)(2) of this section, for each order placed on a time-and-materials or labor-hour basis. Placement of orders shall be in accordance with Subpart 8.4 or 16.5, as applicable.\n(3) If an indefinite-delivery contract only allows for the issuance of orders on a time-and-materials or labor-hour basis, the D&F required by paragraph (b)(2) of this section shall be executed to support the basic contract and shall also explain why providing for an alternative firm-fixed-price or fixed-price with economic price adjustment pricing structure is not practicable. The D&F for this contract shall be approved one level above the contracting officer. Placement of orders shall be in accordance with Subpart 16.5 .\n(d) The contract types authorized by this subpart may be used in conjunction with an award fee and performance or delivery incentives when the award fee or incentive is based solely on factors other than cost (see 16.202-1 and 16.203-1 ).\n(e) Use of any contract type other than those authorized by this subpart to acquire commercial items is prohibited.\n12.208 Contract quality assurance.\nContracts for commercial items shall rely on contractors  existing quality assurance systems as a substitute for Government inspection and testing before tender for acceptance unless customary market practices for the commercial item being acquired include in-process inspection. Any in-process inspection by the Government shall be conducted in a manner consistent with commercial practice.\n12.209 Determination of price reasonableness.\nWhile the contracting officer must establish price reasonableness in accordance with 13.106-3 , 14.408-2 , or Subpart 15.4 , as applicable, the contracting officer should be aware of customary commercial terms and conditions when pricing commercial items. Commercial item prices are affected by factors that include, but are not limited to, speed of delivery, length and extent of warranty, limitations of seller  s liability, quantities ordered, length of the performance period, and specific performance requirements. The contracting officer must ensure that contract terms, conditions, and prices are commensurate with the Government  s need.\n12.210 Contract financing.\nCustomary market practice for some commercial items may include buyer contract financing. The contracting officer may offer Government financing in accordance with the policies and procedures in Part 32 .\n12.211 Technical data.\nExcept as provided by agency-specific statutes, the Government shall acquire only the technical data and the rights in that data customarily provided to the public with a commercial item or process. The contracting officer shall presume that data delivered under a contract for commercial items was developed exclusively at private expense. When a contract for commercial items requires the delivery of technical data, the contracting officer shall include appropriate provisions and clauses delineating the rights in the technical data in addenda to the solicitation and contract (see Part 27 or agency FAR supplements).\n12.212 Computer software.\n(a) Commercial computer software or commercial computer software documentation shall be acquired under licenses customarily provided to the public to the extent such licenses are consistent with Federal law and otherwise satisfy the Government  s needs. Generally, offerors and contractors shall not be required to  \n(1) Furnish technical information related to commercial computer software or commercial computer software documentation that is not customarily provided to the public; or\n(2) Relinquish to, or otherwise provide, the Government rights to use, modify, reproduce, release, perform, display, or disclose commercial computer software or commercial computer software documentation except as mutually agreed to by the parties.\n(b) With regard to commercial computer software and commercial computer software documentation, the Government shall have only those rights specified in the license contained in any addendum to the contract. For additional guidance regarding the use and negotiation of license agreements for commercial computer software, see 27.405-3 .\n12.213 Other commercial practices.\nIt is a common practice in the commercial marketplace for both the buyer and seller to propose terms and conditions written from their particular perspectives. The terms and conditions prescribed in this part seek to balance the interests of both the buyer and seller. These terms and conditions are generally appropriate for use in a wide range of acquisitions. However, market research may indicate other commercial practices that are appropriate for the acquisition of the particular item. These practices should be considered for incorporation into the solicitation and contract if the contracting officer determines them appropriate in concluding a business arrangement satisfactory to both parties and not otherwise precluded by law or Executive order.\n12.214 Cost Accounting Standards.\nCost Accounting Standards (CAS) do not apply to contracts and subcontracts for the acquisition of commercial items when these contracts and subcontracts are firm-fixed-price or fixed-price with economic price adjustment (provided that the price adjustment is not based on actual costs incurred). See 30.201-1 for CAS applicability to fixed-price with economic price adjustment contracts and subcontracts for commercial items when the price adjustment is based on actual costs incurred. When CAS applies, the contracting officer shall insert the appropriate provisions and clauses as prescribed in 30.201 .\n12.215 Notification of overpayment.\nIf the contractor notifies the contracting officer of a duplicate payment or that the Government has otherwise overpaid, the contracting officer shall follow the procedures at 32.604 .\n12.216 Unenforceability of unauthorized obligations.\nMany supplies or services are acquired subject to supplier license agreements. These are particularly common in information technology acquisitions, but they may apply to any supply or service. For example, computer software and services delivered through the internet (web services) are often subject to license agreements, referred to as End User License Agreements (EULA), Terms of Service (TOS), or other similar legal instruments or agreements. Many of these agreements contain indemnification clauses that are inconsistent with Federal law and unenforceable, but which could create a violation of the Anti-Deficiency Act (31 U.S.C. 1341) if agreed to by the Government. Paragraph (u) of the clause at 52.212-4 prevents any such violations.");
register_book(&s, "|12|3|", "Solicitation Provisions and Contract Cl", "Subpart 12.3  Solicitation Provisions and Contract Clauses for the Acquisition of Commercial Items\n12.300 Scope of subpart.\nThis subpart establishes provisions and clauses to be used when acquiring commercial items.\n12.301 Solicitation provisions and contract clauses for the acquisition of commercial items.\n(a) In accordance with Section 8002 of Public Law 103-355 ( 41 U.S.C. 264 , note), contracts for the acquisition of commercial items shall, to the maximum extent practicable, include only those clauses  \n(1) Required to implement provisions of law or executive orders applicable to the acquisition of commercial items; or\n(2) Determined to be consistent with customary commercial practice.\n(b) Insert the following provisions in solicitations for the acquisition of commercial items, and clauses in solicitations and contracts for the acquisition of commercial items:\n(1) The provision at 52.212-1 , Instructions to Offerors  Commercial Items. This provision provides a single, streamlined set of instructions to be used when soliciting offers for commercial items and is incorporated in the solicitation by reference (see Block 27a, SF 1449 ). The contracting officer may tailor these instructions or provide additional instructions tailored to the specific acquisition in accordance with 12.302 .\n(2) The provision at 52.212-3 , Offeror Representations and Certifications  Commercial Items. This provision provides a single, consolidated list of representations and certifications for the acquisition of commercial items and is attached to the solicitation for offerors to complete. This provision may not be tailored except in accordance with Subpart 1.4 . Use the provision with its Alternate I in solicitations issued by DoD, NASA, or the Coast Guard. Use the provision with its Alternate II in solicitations for acquisitions for which small disadvantaged business procurement mechanisms are authorized on a regional basis.\n(3) The clause at 52.212-4 , Contract Terms and Conditions  Commercial Items. This clause includes terms and conditions which are, to the maximum extent practicable, consistent with customary commercial practices and is incorporated in the solicitation and contract by reference (see Block 27, SF 1449 ). Use this clause with its Alternate I when a time-and-materials or labor-hour contract will be awarded. The contracting officer may tailor this clause in accordance with 12.302 .\n(4) The clause at 52.212-5 , Contract Terms and Conditions Required to Implement Statutes or Executive Orders  Commercial Items. This clause incorporates by reference only those clauses required to implement provisions of law or Executive orders applicable to the acquisition of commercial items . The contracting officer shall attach this clause to the solicitation and contract and, using the appropriate clause prescriptions, indicate which, if any, of the additional clauses cited in 52.212-5 (b) or (c) are applicable to the specific acquisition. Some of the clauses require fill-in; the fill-in language should be inserted as directed by 52.104 (d). When cost information is obtained pursuant to Part 15 to establish the reasonableness of prices for commercial items, the contracting officer shall insert the clauses prescribed for this purpose in an addendum to the solicitation and contract. This clause may not be tailored.\n(i) Use the clause with its Alternate I when the head of the agency has waived the examination of records by the Comptroller General in accordance with 25.1001 .\n(ii)(A) If the acquisition will use funds appropriated or otherwise made available by the American Recovery and Reinvestment Act of 2009 (Pub. L. 111-5), the contracting officer shall use the clause with its Alternate II.\n(B) \n(1) In the case of a bilateral contract modification that will use funds appropriated or otherwise made available by the American Recovery and Reinvestment Act of 2009, the contracting officer shall specify applicability of Alternate II to that modification.\n(2) In the case of a task- or delivery-order contract in which not all orders will use funds appropriated or otherwise made available by the American Recovery and Reinvestment Act of 2009, the contracting officer shall specify the task or delivery orders to which Alternate II applies.\n(C) The contracting officer may not use Alternate I when Alternate II applies.\n(c) When the use of evaluation factors is appropriate, the contracting officer may  \n(1) Insert the provision at 52.212-2 , Evaluation  Commercial Items, in solicitations for commercial items (see 12.602 ); or\n(2) Include a similar provision containing all evaluation factors required by 13.106 , Subpart 14.2 or Subpart 15.3 , as an addendum (see 12.302 (d)).\n(d) Other required provisions and clauses. \n(1) Notwithstanding prescriptions contained elsewhere in the FAR, when acquiring commercial items, contracting officers shall be required to use only those provisions and clauses prescribed in this part. The provisions and clauses prescribed in this part shall be revised, as necessary, to reflect the applicability of statutes and executive orders to the acquisition of commercial items.\n(2) Insert the clause at 52.225-19 , Contractor Personnel in a Designated Operational Area or Supporting a Diplomatic or Consular Mission outside the United States, as prescribed in 25.301-4 .\n(3) Insert the provision at 52.209-7 , Information Regarding Responsibility Matters, as prescribed in 9.104-7 (b).\n(4) Insert the clause at 52.232-40 , Providing Accelerated Payments to Small Business Subcontractors, as prescribed in 32.009-2 .\n(e) Discretionary use of FAR provisions and clauses. The contracting officer may include in solicitations and contracts by addendum other FAR provisions and clauses when their use is consistent with the limitations contained in 12.302 . For example:\n(1) The contracting officer may include appropriate clauses when an indefinite-delivery type of contract will be used. The clauses prescribed at 16.506 may be used for this purpose.\n(2) The contracting officer may include appropriate provisions and clauses when the use of options is in the Government  s interest. The provisions and clauses prescribed in 17.208 may be used for this purpose. If the provision at 52.212-2 is used, paragraph (b) provides for the evaluation of options.\n(3) The contracting officer may use the provisions and clauses contained in Part 23 regarding the use of products containing recovered materials and biobased products when appropriate for the item being acquired.\n(4) When setting aside under the Stafford Act ( Subpart 26.2 ), include the provision at 52.226-3 , Disaster or Emergency Area Representation, in the solicitation. The representation in this provision is not in the System for Award Management database.\n(f) Agencies may supplement the provisions and clauses prescribed in this part (to require use of additional provisions and clauses) only as necessary to reflect agency unique statutes applicable to the acquisition of commercial items or as may be approved by the agency senior procurement executive, or the individual responsible for representing the agency on the FAR Council, without power of delegation.\n12.302 Tailoring of provisions and clauses for the acquisition of commercial items.\n(a) General . The provisions and clauses established in this subpart are intended to address, to the maximum extent practicable, commercial market practices for a wide range of potential Government acquisitions of commercial items. However, because of the broad range of commercial items acquired by the Government, variations in commercial practices, and the relative volume of the Government  s acquisitions in the specific market, contracting officers may, within the limitations of this subpart, and after conducting appropriate market research, tailor the provision at 52.212-1 , Instructions to Offerors  Commercial Items, and the clause at 52.212-4 , Contract Terms and Conditions  Commercial Items, to adapt to the market conditions for each acquisition.\n(b) Tailoring 52.212-4 , Contract Terms and Conditions  Commercial Items . The following paragraphs of the clause at 52.212-4 , Contract Terms and Conditions  Commercial Items, implement statutory requirements and shall not be tailored  \n(1) Assignments;\n(2) Disputes;\n(3) Payment (except as provided in Subpart 32.11 );\n(4) Invoice;\n(5) Other compliances; \n(6) Compliance with laws unique to Government contracts; and \n(7) Unauthorized obligations.\n(c) Tailoring inconsistent with customary commercial practice . The contracting officer shall not tailor any clause or otherwise include any additional terms or conditions in a solicitation or contract for commercial items in a manner that is inconsistent with customary commercial practice for the item being acquired unless a waiver is approved in accordance with agency procedures. The request for waiver must describe the customary commercial practice found in the marketplace, support the need to include a term or condition that is inconsistent with that practice and include a determination that use of the customary commercial practice is inconsistent with the needs of the Government. A waiver may be requested for an individual or class of contracts for that specific item.\n(d) Tailoring shall be by addenda to the solicitation and contract. The contracting officer shall indicate in Block 27a of the SF 1449 if addenda are attached. These addenda may include, for example, a continuation of the schedule of supplies/services to be acquired from blocks 18 through 21 of the SF 1449 ; a continuation of the description of the supplies/services being acquired; further elaboration of any other item(s) on the SF 1449 ; any other terms or conditions necessary for the performance of the proposed contract (such as options, ordering procedures for indefinite-delivery type contracts, warranties, contract financing arrangements, etc.).\n12.303 Contract format.\nSolicitations and contracts for the acquisition of commercial items prepared using this Part 12 shall be assembled, to the maximum extent practicable, using the following format:\n(a) Standard Form (SF) 1449 ;\n(b) Continuation of any block from SF 1449 , such as  \n(1) Block 10 if a price evaluation adjustment for small disadvantaged business concerns is applicable (the contracting officer shall indicate the percentage(s) and applicable line item(s)), if an incentive subcontracting clause is used (the contracting officer shall indicate the applicable percentage);\n(2) Block 18B for remittance address;\n(3) Block 19 for contract line item numbers;\n(4) Block 20 for schedule of supplies/services; or\n(5) Block 25 for accounting data;\n(c) Contract clauses  \n(1) 52.212-4 , Contract Terms and Conditions  Commercial Items, by reference (see SF 1449 block 27a);\n(2) Any addendum to 52.212-4 ; and\n(3) 52.212-5 , Contract Terms and Conditions Required to Implement Statutes and Executive orders;\n(d) Any contract documents, exhibits or attachments; and\n(e) Solicitation provisions  \n(1) 52.212-1 , Instructions to Offerors  Commercial Items, by reference (see SF 1449 , Block 27a);\n(2) Any addendum to 52.212-1 ;\n(3) 52.212-2 , Evaluation  Commercial Items, or other description of evaluation factors for award, if used; and\n(4) 52.212-3 , Offeror Representations and Certifications  Commercial Items.");
register_book(&s, "|12|4|", "Unique Requirements Regarding Terms and", "Subpart 12.4  Unique Requirements Regarding Terms and Conditions for Commercial Items\n12.401 General.\nThis subpart provides  \n(a) Guidance regarding tailoring of the paragraphs in the clause at 52.212-4 , Contract Terms and Conditions  Commercial Items, when the paragraphs do not reflect the customary practice for a particular market; and\n(b) Guidance on the administration of contracts for commercial items in those areas where the terms and conditions in 52.212-4 differ substantially from those contained elsewhere in the FAR.\n12.402 Acceptance.\n(a) The acceptance paragraph in 52.212-4 is based upon the assumption that the Government will rely on the contractor  s assurances that the commercial item tendered for acceptance conforms to the contract requirements. The Government inspection of commercial items will not prejudice its other rights under the acceptance paragraph. Additionally, although the paragraph does not address the issue of rejection, the Government always has the right to refuse acceptance of nonconforming items. This paragraph is generally appropriate when the Government is acquiring noncomplex commercial items.\n(b) Other acceptance procedures may be more appropriate for the acquisition of complex commercial items or commercial items used in critical applications. In such cases, the contracting officer shall include alternative inspection procedure(s) in an addendum and ensure these procedures and the postaward remedies adequately protect the interests of the Government. The contracting officer must carefully examine the terms and conditions of any express warranty with regard to the effect it may have on the Government  s available postaward remedies (see 12.404 ).\n(c) The acquisition of commercial items under other circumstances such as on an  as is  basis may also require acceptance procedures different from those contained in 52.212-4 . The contracting officer should consider the effect the specific circumstances will have on the acceptance paragraph as well as other paragraphs of the clause.\n12.403 Termination.\n(a) General . The clause at 52.212-4 permits the Government to terminate a contract for commercial items either for the convenience of the Government or for cause. However, the paragraphs in 52.212-4 entitled  Termination for the Government  s Convenience  and  Termination for Cause  contain concepts which differ from those contained in the termination clauses prescribed in Part 49 . Consequently, the requirements of Part 49 do not apply when terminating contracts for commercial items and contracting officers shall follow the procedures in this section. Contracting officers may continue to use Part 49 as guidance to the extent that Part 49 does not conflict with this section and the language of the termination paragraphs in 52.212-4 .\n(b) Policy . The contracting officer should exercise the Government  s right to terminate a contract for commercial items either for convenience or for cause only when such a termination would be in the best interests of the Government. The contracting officer should consult with counsel prior to terminating for cause.\n(c) Termination for cause.\n(1) The paragraph in 52.212-4 entitled  Excusable Delay  requires contractors notify the contracting officer as soon as possible after commencement of any excusable delay. In most situations, this requirement should eliminate the need for a show cause notice prior to terminating a contract. The contracting officer shall send a cure notice prior to terminating a contract for a reason other than late delivery.\n(2) The Government  s rights after a termination for cause shall include all the remedies available to any buyer in the marketplace. The Government  s preferred remedy will be to acquire similar items from another contractor and to charge the defaulted contractor with any excess reprocurement costs together with any incidental or consequential damages incurred because of the termination.\n(3) When a termination for cause is appropriate, the contracting officer shall send the contractor a written notification regarding the termination. At a minimum, this notification shall  \n(i) Indicate the contract is terminated for cause;\n(ii) Specify the reasons for the termination;\n(iii) Indicate which remedies the Government intends to seek or provide a date by which the Government will inform the contractor of the remedy; and\n(iv) State that the notice constitutes a final decision of the contracting officer and that the contractor has the right to appeal under the Disputes clause (see 33.211 ).\n(4) The contracting officer, in accordance with agency procedures, shall ensure that information related to termination for cause notices and any amendments are reported. In the event the termination for cause is subsequently converted to a termination for convenience, or is otherwise withdrawn, the contracting officer shall ensure that a notice of the conversion or withdrawal is reported. All reporting shall be in accordance with 42.1503 (h).\n(d) Termination for the Government  s convenience.\n(1) When the contracting officer terminates a contract for commercial items for the Government  s convenience, the contractor shall be paid  \n(i) \n(A) The percentage of the contract price reflecting the percentage of the work performed prior to the notice of the termination for fixed-price or fixed-price with economic price adjustment contracts; or\n(B) An amount for direct labor hours (as defined in the Schedule of the contract) determined by multiplying the number of direct labor hours expended before the effective date of termination by the hourly rate(s) in the Schedule; and\n(ii) Any charges the contractor can demonstrate directly resulted from the termination. The contractor may demonstrate such charges using its standard record keeping system and is not required to comply with the cost accounting standards or the contract cost principles in Part 31 . The Government does not have any right to audit the contractor  s records solely because of the termination for convenience.\n(2) Generally, the parties should mutually agree upon the requirements of the termination proposal. The parties must balance the Government  s need to obtain sufficient documentation to support payment to the contractor against the goal of having a simple and expeditious settlement.\n12.404 Warranties.\n(a) Implied warranties . The Government  s post award rights contained in 52.212-4 are the implied warranty of merchantability, the implied warranty of fitness for particular purpose and the remedies contained in the acceptance paragraph.\n(1) The implied warranty of merchantability provides that an item is reasonably fit for the ordinary purposes for which such items are used. The items must be of at least average, fair or medium-grade quality and must be comparable in quality to those that will pass without objection in the trade or market for items of the same description.\n(2) The implied warranty of fitness for a particular purpose provides that an item is fit for use for the particular purpose for which the Government will use the items. The Government can rely upon an implied warranty of fitness for particular purpose when  \n(i) The seller knows the particular purpose for which the Government intends to use the item; and\n(ii) The Government relied upon the contractor  s skill and judgment that the item would be appropriate for that particular purpose.\n(3) Contracting officers should consult with legal counsel prior to asserting any claim for a breach of an implied warranty.\n(b) Express warranties . The Federal Acquisition Streamlining Act of 1994 ( 41 U.S.C. 264 note) requires contracting officers to take advantage of commercial warranties. To the maximum extent practicable, solicitations for commercial items shall require offerors to offer the Government at least the same warranty terms, including offers of extended warranties, offered to the general public in customary commercial practice. Solicitations may specify minimum warranty terms, such as minimum duration, appropriate for the Government  s intended use of the item.\n(1) Any express warranty the Government intends to rely upon must meet the needs of the Government. The contracting officer should analyze any commercial warranty to determine if  \n(i) The warranty is adequate to protect the needs of the Government, e.g., items covered by the warranty and length of warranty;\n(ii) The terms allow the Government effective postaward administration of the warranty to include the identification of warranted items, procedures for the return of warranted items to the contractor for repair or replacement, and collection of product performance information; and\n(iii) The warranty is cost-effective.\n(2) In some markets, it may be customary commercial practice for contractors to exclude or limit the implied warranties contained in 52.212-4 in the provisions of an express warranty. In such cases, the contracting officer shall ensure that the express warranty provides for the repair or replacement of defective items discovered within a reasonable period of time after acceptance.\n(3) Express warranties shall be included in the contract by addendum (see 12.302 ).");
register_book(&s, "|12|5|", "Applicability of Certain Laws to the Ac", "Subpart 12.5  Applicability of Certain Laws to the Acquisition of Commercial Items and Commercially Available Off-The-Shelf Items\n12.500 Scope of subpart.\n(a) As required by sections 34 and 35 of the Office of Federal Procurement Policy Act ( 41 U.S.C. 430 and 431 ), this subpart lists provisions of law that are not applicable to  \n(1) Contracts for the acquisition of commercial items;\n(2) Subcontracts, at any tier, for the acquisition of commercial items; and\n(3) Contracts and subcontracts, at any tier, for the acquisition of COTS items.\n(b) This subpart also lists provisions of law that have been amended to eliminate or modify their applicability to either contracts or subcontracts for the acquisition of commercial items.\n12.501 Applicability.\n(a) This subpart applies to any contract or subcontract at any tier for the acquisition of commercial items.\n(b) Nothing in this subpart shall be construed to authorize the waiver of any provision of law with respect to any subcontract if the prime contractor is reselling or distributing commercial items of another contractor without adding value. This limitation is intended to preclude establishment of unusual contractual arrangements solely for the purpose of Government sales.\n(c) For purposes of this subpart, contractors awarded subcontracts under Subpart 19.8 , Contracting with the Small Business Administration (the 8(a) Program), shall be considered prime contractors.\n12.502 Procedures.\n(a) The FAR prescription for the provision or clause for each of the laws listed in 12.503 has been revised in the appropriate part to reflect its proper application to prime contracts for the acquisition of commercial items.\n(b) For subcontracts for the acquisition of commercial items or commercial components, the clauses at 52.212-5 , Contract Terms and Conditions Required to Implement Statutes or Executive Orders  Commercial Items, and 52.244-6 , Subcontracts for Commercial Items and Commercial Components, reflect the applicability of the laws listed in 12.504 by identifying the only provisions and clauses that are required to be included in a subcontract at any tier for the acquisition of commercial items or commercial components.\n(c) The FAR prescription for the provision or clause for each of the laws listed in 12.505 has been revised in the appropriate part to reflect its proper application to contracts and subcontracts for the acquisition of COTS items.\n12.503 Applicability of certain laws to Executive agency contracts for the acquisition of commercial items.\n(a) The following laws are not applicable to Executive agency contracts for the acquisition of commercial items:\n(1) 41 U.S.C. 43 , Walsh-Healey Act (see Subpart 22.6 ).\n(2) 41 U.S.C. 254(a) and 10 U.S.C. 2306(b) , Contingent Fees (see 3.404 ).\n(3) 41 U.S.C. 416(a)(6) , Minimum Response Time for Offers under Office of Federal Procurement Policy Act (see 5.203 ).\n(4) 41 U.S.C. 701 , et seq. , Drug-Free Workplace Act of 1988 (see 23.501 ).\n(5) 31 U.S.C. 1354(a) , Limitation on use of appropriated funds for contracts with entities not meeting veterans  employment reporting requirements (see 22.1302 ).\n(6) [Reserved]\n(7) Section 806(a)(3) of Pub. L. 102-190, as amended by Sections 2091 and 8105 of Pub. L. 103-355, Payment Protections for Subcontractors and Suppliers (see 28.106-6 ).\n(8) 41 U.S.C. 254d(c)(1) and 10 U.S.C. 2313(c)(1) , GAO Access to Contractor Employees, Section 871 of Pub. L. 110-417 (see 52.214-26 and 52.215-2 ).\n(9) Pub. L. 110-417, section 841(a), Policy on Personal Conflicts of Interest by Employees of Federal Government Contractors 41 U.S.C. 2303 (see subpart 3.11 ).\n(b) Certain requirements of the following laws are not applicable to executive agency contracts for the acquisition of commercial items:\n(1) 40 U.S.C. 3701 et seq. , Requirement for a certificate and clause under the Contract Work Hours and Safety Standards Act (see 22.305 ).\n(2) 41 U.S.C. 57(a) and (b), and 58, Requirement for a clause and certain other requirements related to the Anti-Kickback Act of 1986 (see 3.502 ).\n(3) 49 U.S.C. 40118 , Requirement for a clause under the Fly American provisions (see 47.405 ).\n(c) The applicability of the following laws have been modified in regards to Executive agency contracts for the acquisition of commercial items:\n(1) 41 U.S.C. 253g and 10 U.S.C. 2402 , Prohibition on Limiting Subcontractor Direct Sales to the United States (see 3.503 ).\n(2) 41 U.S.C. 254(d) and 10 U.S.C. 2306a , Truth in Negotiations Act (see 15.403 ).\n(3) 41 U.S.C. 422 , Cost Accounting Standards (48 CFR Chapter 99) (see 12.214 ).\n12.504 Applicability of certain laws to subcontracts for the acquisition of commercial items.\n(a) The following laws are not applicable to subcontracts at any tier for the acquisition of commercial items or commercial components at any tier:\n(1) 10 U.S.C. 2631 , Transportation of Supplies by Sea (except for the types of subcontracts listed at 47.504 (d)).\n(2) 15 U.S.C. 644(d) , Requirements relative to labor surplus areas under the Small Business Act (see Subpart 19.2 ).\n(3) [Reserved]\n(4) 41 U.S.C. 43 , Walsh-Healey Act (see Subpart 22.6 ).\n(5) 41 U.S.C. 253d , Validation of Proprietary Data Restrictions (see Subpart 27.4 ).\n(6) 41 U.S.C. 254(a) and 10 U.S.C. 2306(b) , Contingent Fees (see Subpart 3.4 ).\n(7) 41 U.S.C. 254d(c) and 10 U.S.C. 2313(c) , Examination of Records of Contractor, when a subcontractor is not required to provide certified cost or pricing data (see 15.209 (b)), unless using funds appropriated or otherwise made available by the American Recovery and Reinvestment Act of 2009 (Pub. L. 111-5).\n(8) 41 U.S.C. 416(a)(6) , Minimum Response Time for Offers under Office of Federal Procurement Policy Act (see Subpart 5.2 ).\n(9) 41 U.S.C. 418a , Rights in Technical Data (see Subpart 27.4 ).\n(10) 41 U.S.C. 701 , et seq ., Drug-Free Workplace Act of 1988 (see Subpart 23.5 ).\n(11) 46 U.S.C. App. 1241(b) , Transportation in American Vessels of Government Personnel and Certain Cargo (see Subpart 47.5 ) (except for the types of subcontracts listed at 47.504 (d)).\n(12) 49 U.S.C. 40118 , Fly American provisions (see Subpart 47.4 ).\n(13) Section 806(a)(3) of Pub. L. 102-190, as amended by Sections 2091 and 8105 of Pub. L. 103-355, Payment Protections for Subcontractors and Suppliers (see 28.106-6 ).\n(b) The requirements for a certificate and clause under the Contract Work Hours and Safety Standards Act, 40 U.S.C. 3701 et seq ., (see Subpart 22.3 ) are not applicable to subcontracts at any tier for the acquisition of commercial items or commercial components.\n(c) The applicability of the following laws has been modified in regards to subcontracts at any tier for the acquisition of commercial items or commercial components:\n(1) 41 U.S.C. 253g and 10 U.S.C. 2402 , Prohibition on Limiting Subcontractor Direct Sales to the United States (see Subpart 3.5 ).\n(2) 41 U.S.C. 254(d) and 10 U.S.C. 2306a , Truth in Negotiations Act (see Subpart 15.4 ).\n(3) 41 U.S.C. 422 , Cost Accounting Standards (48 CFR Chapter 99) (see 12.214 ).\n12.505 Applicability of certain laws to contracts for the acquisition of COTS items.\nCOTS items are a subset of commercial items. Therefore, any laws listed in sections 12.503 and 12.504 are also inapplicable or modified in their applicability to contracts or subcontracts for the acquisition of COTS items. In addition, the following laws are not applicable to contracts for the acquisition of COTS items:\n(a)(1) 41 U.S.C. 10a , portion of first sentence that reads  substantially all from articles, materials, or supplies mined, produced, or manufactured, as the case may be, in the United States,  Buy American Act-Supplies, component test (see 52.225-1 and 52.225-3 ).\n(2) 41 U.S.C. 10b , portion of first sentence that reads  substantially all from articles, materials, or supplies mined, produced, or manufactured, as the case may be, in the United States,  Buy American Act-Construction Materials, component test (see 52.225-9 and 52.225-11 ).\n(b) 42 U.S.C. 6962(c)(3)(A) , Certification and Estimate of Percentage of Recovered Material.");
register_book(&s, "|12|6|", "Streamlined Procedures for Evaluation a", "Subpart 12.6  Streamlined Procedures for Evaluation and Solicitation for Commercial Items\n12.601 General.\nThis subpart provides optional procedures for (a) streamlined evaluation of offers for commercial items; and (b) streamlined solicitation of offers for commercial items for use where appropriate. These procedures are intended to simplify the process of preparing and issuing solicitations, and evaluating offers for commercial items consistent with customary commercial practices.\n12.602 Streamlined evaluation of offers.\n(a) When evaluation factors are used, the contracting officer may insert a provision substantially the same as the provision at 52.212-2 , Evaluation  Commercial Items, in solicitations for commercial items or comply with the procedures in 13.106 if the acquisition is being made using simplified acquisition procedures. When the provision at 52.212-2 is used, paragraph (a) of the provision shall be tailored to the specific acquisition to describe the evaluation factors and relative importance of those factors. However, when using the simplified acquisition procedures in Part 13 , contracting officers are not required to describe the relative importance of evaluation factors.\n(b) Offers shall be evaluated in accordance with the criteria contained in the solicitation. For many commercial items, the criteria need not be more detailed than technical (capability of the item offered to meet the agency need), price and past performance. Technical capability may be evaluated by how well the proposed products meet the Government requirement instead of predetermined subfactors. Solicitations for commercial items do not have to contain subfactors for technical capability when the solicitation adequately describes the item  s intended use. A technical evaluation would normally include examination of such things as product literature, product samples (if requested), technical features and warranty provisions. Past performance shall be evaluated in accordance with the procedures in 13.106 or Subpart 15.3 , as applicable. The contracting officer shall ensure the instructions provided in the provision at 52.212-1 , Instructions to Offerors  Commercial Items, and the evaluation criteria provided in the provision at 52.212-2 , Evaluation  Commercial Items, are in agreement.\n(c) Select the offer that is most advantageous to the Government based on the factors contained in the solicitation. Fully document the rationale for selection of the successful offeror including discussion of any trade-offs considered.\n12.603 Streamlined solicitation for commercial items.\n(a) When a written solicitation will be issued, the contracting officer may use the following procedure to reduce the time required to solicit and award contracts for the acquisition of commercial items. This procedure combines the synopsis required by 5.203 and the issuance of the solicitation into a single document.\n(b) When using the combined synopsis/solicitation procedure, the SF 1449 is not used for issuing the solicitation.\n(c) To use these procedures, the contracting officer shall  \n(1) Prepare the synopsis as described at 5.207 .\n(2) In the Description, include the following additional information:\n(i) The following statement:\nThis is a combined synopsis/solicitation for commercial items prepared in accordance with the format in Subpart 12.6 , as supplemented with additional information included in this notice. This announcement constitutes the only solicitation; proposals are being requested and a written solicitation will not be issued.\n(ii) The solicitation number and a statement that the solicitation is issued as an invitation to bid (IFB), request for quotation (RFQ) or request for proposal (RFP).\n(iii) A statement that the solicitation document and incorporated provisions and clauses are those in effect through Federal Acquisition Circular _____.\n(iv) A notice regarding any set-aside and the associated NAICS code and small business size standard. \n(v) A list of contract line item number(s) and items, quantities and units of measure, (including option(s), if applicable).\n(vi) Description of requirements for the items to be acquired.\n(vii) Date(s) and place(s) of delivery and acceptance and FOB point.\n(viii) A statement that the provision at 52.212-1 , Instructions to Offerors  Commercial, applies to this acquisition and a statement regarding any addenda to the provision.\n(ix) A statement regarding the applicability of the provision at 52.212-2 , Evaluation  Commercial Items, if used, and the specific evaluation criteria to be included in paragraph (a) of that provision. If this provision is not used, describe the evaluation procedures to be used.\n(x) A statement advising offerors to include a completed copy of the provision at 52.212-3 , Offeror Representations and Certifications  Commercial Items, with its offer.\n(xi) A statement that the clause at 52.212-4 , Contract Terms and Conditions  Commercial Items, applies to this acquisition and a statement regarding any addenda to the clause.\n(xii) A statement that the clause at 52.212-5 , Contract Terms and Conditions Required To Implement Statutes or Executive Orders  Commercial Items, applies to this acquisition and a statement regarding which, if any, of the additional FAR clauses cited in the clause are applicable to the acquisition.\n(xiii) A statement regarding any additional contract requirement(s) or terms and conditions (such as contract financing arrangements or warranty requirements) determined by the contracting officer to be necessary for this acquisition and consistent with customary commercial practices.\n(xiv) A statement regarding the Defense Priorities and Allocations System (DPAS) and assigned rating, if applicable.\n(xv) The date, time and place offers are due.\n(xvi) The name and telephone number of the individual to contact for information regarding the solicitation.\n(3) Allow response time for receipt of offers as follows:\n(i) Because the synopsis and solicitation are contained in a single document, it is not necessary to publicize a separate synopsis 15 days before the issuance of the solicitation.\n(ii) When using the combined synopsis and solicitation, contracting officers must establish a response time in accordance with 5.203 (b) (but see 5.203 (h)).\n(4) Publicize amendments to solicitations in the same manner as the initial synopsis and solicitation.\n*    *    *    *    *    *");
register_book(&s, "|13|2|", "Actions At or Below the Micro-Purchase", "Subpart 13.2  Actions At or Below the Micro-Purchase Threshold\n13.201 General.\n(a) Agency heads are encouraged to delegate micro-purchase authority (see 1.603-3 ).\n(b) The Governmentwide commercial purchase card shall be the preferred method to purchase and to pay for micro-purchases (see 2.101 ).\n(c) Purchases at or below the micro-purchase threshold may be conducted using any of the methods described in Subpart 13.3 , provided the purchaser is authorized and trained, pursuant to agency procedures, to use those methods.\n(d) Micro-purchases do not require provisions or clauses, except as provided at 13.202 and 32.1110 . This paragraph takes precedence over any other FAR requirement to the contrary, but does not prohibit the use of any clause.\n(e) The requirements in Part 8 apply to purchases at or below the micro-purchase threshold.\n(f) The procurement requirements in subparts 23.1 , 23.2 , 23.4 , and 23.7 apply to purchases at or below the micro-purchase threshold.\n(g)(1) For acquisitions of supplies or services that, as determined by the head of the agency, are to be used to support a contingency operation or to facilitate defense against or recovery from nuclear, biological, chemical, or radiological attack, the micro-purchase threshold is  \n(i) $15,000 in the case of any contract to be awarded and performed, or purchase to be made, inside the United States; and\n(ii) $30,000 in the case of any contract to be awarded and performed, or purchase to be made, outside the United States.\n(2) Purchases using this authority must have a clear and direct relationship to the support of a contingency operation or the defense against or recovery from nuclear, biological, chemical, or radiological attack.\n(h) When using the Governmentwide commercial purchase card as a method of payment, purchases at or below the micro-purchase threshold are exempt from verification in the System for Award Management database as to whether the contractor has a delinquent debt subject to collection under the Treasury Offset Program (TOP).\n13.202 Unenforceability of unauthorized obligations in micro-purchases.\nMany supplies or services are acquired subject to supplier license agreements. These are particularly common in information technology acquisitions, but they may apply to any supply or service. For example, computer software and services delivered through the internet (web services) are often subject to license agreements, referred to as End User License Agreements (EULA), Terms of Service (TOS), or other similar legal instruments or agreements. Many of these agreements contain indemnification clauses that are inconsistent with Federal law and unenforceable, but which could create a violation of the Anti-Deficiency Act (31 U.S.C. 1341) if agreed to by the Government. The clause at 52.232-39 , Unenforceability of Unauthorized Obligations, automatically applies to any micro-purchase, including those made with the Governmentwide purchase card. This clause prevents such violations of the Anti-Deficiency Act (31 U.S.C. 1341).\n13.203 Purchase guidelines.\n(a) Solicitation, evaluation of quotations, and award.\n(1) To the extent practicable, micro-purchases shall be distributed equitably among qualified suppliers.\n(2) Micro-purchases may be awarded without soliciting competitive quotations if the contracting officer or individual appointed in accordance with 1.603-3 (b) considers the price to be reasonable.\n(3) The administrative cost of verifying the reasonableness of the price for purchases may more than offset potential savings from detecting instances of overpricing. Therefore, action to verify price reasonableness need only be taken if  \n(i) The contracting officer or individual appointed in accordance with 1.603-3 (b) suspects or has information to indicate that the price may not be reasonable ( e.g., comparison to the previous price paid or personal knowledge of the supply or service); or\n(ii) Purchasing a supply or service for which no comparable pricing information is readily available ( e.g., a supply or service that is not the same as, or is not similar to, other supplies or services that have recently been purchased on a competitive basis).\n(b) Documentation. If competitive quotations were solicited and award was made to other than the low quoter, documentation to support the purchase may be limited to identification of the solicited concerns and an explanation for the award decision.");
register_book(&s, "|13|3|", "Simplified Acquisition Methods", "Subpart 13.3  Simplified Acquisition Methods\n13.301 Governmentwide commercial purchase card.\n(a) Except as provided in 32.1108 (b)(2), the Governmentwide commercial purchase card is authorized for use in making and/or paying for purchases of supplies, services, or construction. The Governmentwide commercial purchase card may be used by contracting officers and other individuals designated in accordance with 1.603-3 . The card may be used only for purchases that are otherwise authorized by law or regulation.\n(b) Agencies using the Governmentwide commercial purchase card shall establish procedures for use and control of the card that comply with the Treasury Financial Manual for Guidance of Departments and Agencies (TFM 4-4500) and that are consistent with the terms and conditions of the current GSA credit card contract. Agency procedures should not limit the use of the Governmentwide commercial purchase card to micro-purchases. Agency procedures should encourage use of the card in greater dollar amounts by contracting officers to place orders and to pay for purchases against contracts established under Part 8 procedures, when authorized; and to place orders and/or make payment under other contractual instruments, when agreed to by the contractor. See 32.1110 (d) for instructions for use of the appropriate clause when payment under a written contract will be made through use of the card.\n(c) The Governmentwide commercial purchase card may be used to  \n(1) Make micro-purchases;\n(2) Place a task or delivery order (if authorized in the basic contract, basic ordering agreement, or blanket purchase agreement); or\n(3) Make payments, when the contractor agrees to accept payment by the card (but see 32.1108 (b)(2)).\n13.302 Purchase orders.\n13.302-1 General.\n(a) Except as provided under the unpriced purchase order method (see 13.302-2 ), purchase orders generally are issued on a fixed-price basis. See 12.207 for acquisition of commercial items.\n(b) Purchase orders shall  \n(1) Specify the quantity of supplies or scope of services ordered;\n(2) Contain a determinable date by which delivery of the supplies or performance of the services is required;\n(3) Provide for inspection as prescribed in Part 46 . Generally, inspection and acceptance should be at destination. Source inspection should be specified only if required by Part 46 . When inspection and acceptance will be performed at destination, advance copies of the purchase order or equivalent notice shall be furnished to the consignee(s) for material receipt purposes. Receiving reports shall be accomplished immediately upon receipt and acceptance of supplies;\n(4) Specify f.o.b. destination for supplies to be delivered within the United States, except Alaska or Hawaii, unless there are valid reasons to the contrary; and\n(5) Include any trade and prompt payment discounts that are offered, consistent with the applicable principles at 14.408-3 .\n(c) The contracting officer  s signature on purchase orders shall be in accordance with 4.101 and the definitions at 2.101 . Facsimile and electronic signature may be used in the production of purchase orders by automated methods.\n(d) Limit the distribution of copies of purchase orders and related forms to the minimum deemed essential for administration and transmission of contractual information.\n(e) In accordance with 31 U.S.C. 3332 , electronic funds transfer (EFT) is required for payments except as provided in 32.1110 . See Subpart 32.11 for instructions for use of the appropriate clause in purchase orders. When obtaining oral quotes, the contracting officer shall inform the quoter of the EFT clause that will be in any resulting purchase order.\n13.302-2 Unpriced purchase orders.\n(a) An unpriced purchase order is an order for supplies or services, the price of which is not established at the time of issuance of the order.\n(b) An unpriced purchase order may be used only when  \n(1) It is impractical to obtain pricing in advance of issuance of the purchase order; and\n(2) The purchase is for  \n(i) Repairs to equipment requiring disassembly to determine the nature and extent of repairs;\n(ii) Material available from only one source and for which cost cannot readily be established; or\n(iii) Supplies or services for which prices are known to be competitive, but exact prices are not known ( e.g., miscellaneous repair parts, maintenance agreements).\n(c) Unpriced purchase orders may be issued on paper or electronically. A realistic monetary limitation, either for each line item or for the total order, shall be placed on each unpriced purchase order. The monetary limitation shall be an obligation subject to adjustment when the firm price is established. The contracting office shall follow up on each order to ensure timely pricing. The contracting officer or the contracting officer  s designated representative shall review the invoice price and, if reasonable (see 13.106-3 (a)), process the invoice for payment.\n13.302-3 Obtaining contractor acceptance and modifying purchase orders.\n(a) When it is desired to consummate a binding contract between the parties before the contractor undertakes performance, the contracting officer shall require written (see 2.101 ) acceptance of the purchase order by the contractor.\n(b) Each purchase order modification shall identify the order it modifies and shall contain an appropriate modification number.\n(c) A contractor  s written acceptance of a purchase order modification may be required only if  \n(1) Determined by the contracting officer to be necessary to ensure the contractor  s compliance with the purchase order as revised; or\n(2) Required by agency regulations.\n13.302-4 Termination or cancellation of purchase orders.\n(a) If a purchase order that has been accepted in writing by the contractor is to be terminated, the contracting officer shall process the termination in accordance with  \n(1) 12.403 and 52.212-4 (l) or (m) for commercial items; or\n(2) Part 49 or 52.213-4 for other than commercial items.\n(b) If a purchase order that has not been accepted in writing by the contractor is to be canceled, the contracting officer shall notify the contractor in writing that the purchase order has been canceled, request the contractor  s written acceptance of the cancellation, and proceed as follows:\n(1) If the contractor accepts the cancellation and does not claim that costs were incurred as a result of beginning performance under the purchase order, no further action is required ( i.e., the purchase order shall be considered canceled).\n(2) If the contractor does not accept the cancellation or claims that costs were incurred as a result of beginning performance under the purchase order, the contracting officer shall process the action as a termination prescribed in paragraph (a) of this subsection.\n13.302-5 Clauses.\n(a) Each purchase order (and each purchase order modification (see 13.302-3 )) shall incorporate all clauses prescribed for the particular acquisition.\n(b) The contracting officer shall insert the clause at 52.213-2 , Invoices, in purchase orders that authorize advance payments (see 31 U.S.C. 3324(d)(2) ) for subscriptions or other charges for newspapers, magazines, periodicals, or other publications ( i.e., any publication printed, microfilmed, photocopied, or magnetically or otherwise recorded for auditory or visual usage).\n(c) The contracting officer shall insert the clause at 52.213-3 , Notice to Supplier, in unpriced purchase orders.\n(d)(1) The contracting officer may use the clause at 52.213-4 , Terms and Conditions  Simplified Acquisitions (Other Than Commercial Items), in simplified acquisitions exceeding the micro-purchase threshold that are for other than commercial items (see 12.301 ).\n(2) The clause  \n(i) Is a compilation of the most commonly used clauses that apply to simplified acquisitions; and\n(ii) May be modified to fit the individual acquisition to add other needed clauses, or those clauses may be added separately. Modifications ( i.e., additions, deletions, or substitutions) must not create a void or internal contradiction in the clause. For example, do not add an inspection and acceptance or termination for convenience requirement unless the existing requirement is deleted. Also, do not delete a paragraph without providing for an appropriate substitute.\n(3)(i) When an acquisition for supplies for use within the United States cannot be set aside for small business concerns and trade agreements apply (see Subpart 25.4 ), substitute the clause at FAR 52.225-3 , Buy American Act  Free Trade Agreements  Israeli Trade Act, used with Alternate I or Alternate II, if appropriate, instead of the clause at FAR 52.225-1 , Buy American Act  Supplies.\n(ii) When acquiring supplies for use outside the United States, delete clause 52.225-1 from the clause list at 52.213-4 (b).\n13.303 Blanket purchase agreements (BPAs).\n13.303-1 General.\n(a) A blanket purchase agreement (BPA) is a simplified method of filling anticipated repetitive needs for supplies or services by establishing  charge accounts  with qualified sources of supply (see Subpart 16.7 for additional coverage of agreements).\n(b) BPAs should be established for use by an organization responsible for providing supplies for its own operations or for other offices, installations, projects, or functions. Such organizations, for example, may be organized supply points, separate independent or detached field parties, or one-person posts or activities.\n(c) The use of BPAs does not exempt an agency from the responsibility for keeping obligations and expenditures within available funds.\n13.303-2 Establishment of BPAs.\n(a) The following are circumstances under which contracting officers may establish BPAs:\n(1) There is a wide variety of items in a broad class of supplies or services that are generally purchased, but the exact items, quantities, and delivery requirements are not known in advance and may vary considerably.\n(2) There is a need to provide commercial sources of supply for one or more offices or projects in a given area that do not have or need authority to purchase otherwise.\n(3) The use of this procedure would avoid the writing of numerous purchase orders.\n(4) There is no existing requirements contract for the same supply or service that the contracting activity is required to use.\n(b) After determining a BPA would be advantageous, contracting officers shall  \n(1) Establish the parameters to limit purchases to individual items or commodity groups or classes, or permit the supplier to furnish unlimited supplies or services; and\n(2) Consider suppliers whose past performance has shown them to be dependable, who offer quality supplies or services at consistently lower prices, and who have provided numerous purchases at or below the simplified acquisition threshold.\n(c) BPAs may be established with  \n(1) More than one supplier for supplies or services of the same type to provide maximum practicable competition;\n(2) A single firm from which numerous individual purchases at or below the simplified acquisition threshold will likely be made in a given period; or\n(3) Federal Supply Schedule contractors, if not inconsistent with the terms of the applicable schedule contract.\n(d) BPAs should be prepared without a purchase requisition and only after contacting suppliers to make the necessary arrangements for  \n(1) Securing maximum discounts;\n(2) Documenting individual purchase transactions;\n(3) Periodic billings; and\n(4) Incorporating other necessary details.\n13.303-3 Preparation of BPAs.\nPrepare BPAs on the forms specified in 13.307 . Do not cite accounting and appropriation data (see 13.303-5 (e)(4)).\n(a) The following terms and conditions are mandatory:\n(1) Description of agreement. A statement that the supplier shall furnish supplies or services, described in general terms, if and when requested by the contracting officer (or the authorized representative of the contracting officer) during a specified period and within a stipulated aggregate amount, if any.\n(2) Extent of obligation. A statement that the Government is obligated only to the extent of authorized purchases actually made under the BPA.\n(3) Purchase limitation. A statement that specifies the dollar limitation for each individual purchase under the BPA (see 13.303-5 (b)).\n(4) Individuals authorized to purchase under the BPA. A statement that a list of individuals authorized to purchase under the BPA, identified either by title of position or by name of individual, organizational component, and the dollar limitation per purchase for each position title or individual shall be furnished to the supplier by the contracting officer.\n(5) Delivery tickets. A requirement that all shipments under the agreement, except those for newspapers, magazines, or other periodicals, shall be accompanied by delivery tickets or sales slips that shall contain the following minimum information:\n(i) Name of supplier.\n(ii) BPA number.\n(iii) Date of purchase.\n(iv) Purchase number.\n(v) Itemized list of supplies or services furnished.\n(vi) Quantity, unit price, and extension of each item, less applicable discounts (unit prices and extensions need not be shown when incompatible with the use of automated systems, provided that the invoice is itemized to show this information).\n(vii) Date of delivery or shipment.\n(6) Invoices. One of the following statements shall be included (except that the statement in paragraph (a)(6)(iii) of this subsection should not be used if the accumulation of the individual invoices by the Government materially increases the administrative costs of this purchase method):\n(i) A summary invoice shall be submitted at least monthly or upon expiration of this BPA, whichever occurs first, for all deliveries made during a billing period, identifying the delivery tickets covered therein, stating their total dollar value, and supported by receipt copies of the delivery tickets.\n(ii) An itemized invoice shall be submitted at least monthly or upon expiration of this BPA, whichever occurs first, for all deliveries made during a billing period and for which payment has not been received. These invoices need not be supported by copies of delivery tickets.\n(iii) When billing procedures provide for an individual invoice for each delivery, these invoices shall be accumulated, provided that  \n(A) A consolidated payment will be made for each specified period; and\n(B) The period of any discounts will commence on the final date of the billing period or on the date of receipt of invoices for all deliveries accepted during the billing period, whichever is later.\n(iv) An invoice for subscriptions or other charges for newspapers, magazines, or other periodicals shall show the starting and ending dates and shall state either that ordered subscriptions have been placed in effect or will be placed in effect upon receipt of payment.\n(b) If the fast payment procedure is used, include the requirements stated in 13.403 .\n13.303-4 Clauses.\n(a) The contracting officer shall insert in each BPA the clauses prescribed elsewhere in this part that are required for or applicable to the particular BPA.\n(b) Unless a clause prescription specifies otherwise ( e.g., see 22.305 (a), 22.605 (a)(5), or 22.1006 ), if the prescription includes a dollar threshold, the amount to be compared to that threshold is that of any particular order under the BPA.\n13.303-5 Purchases under BPAs.\n(a) Use a BPA only for purchases that are otherwise authorized by law or regulation.\n(b) Individual purchases shall not exceed the simplified acquisition threshold. However, agency regulations may establish a higher threshold consistent with the following:\n(1) The simplified acquisition threshold and the $6.5 million limitation for individual purchases ($12 million for purchases entered into under the authority of 12.102(f)(1)) do not apply to BPAs established in accordance with 13.303-2 (c)(3).\n(2) The limitation for individual purchases for commercial item acquisitions conducted under Subpart 13.5 is $6.5 million ($12 million for acquisitions as described in 13.500(e)).\n(c) The existence of a BPA does not justify purchasing from only one source or avoiding small business set-asides. The requirements of 13.003(b) and Subpart 19.5 also apply to each order.\n(d) If, for a particular purchase greater than the micro-purchase threshold, there is an insufficient number of BPAs to ensure maximum practicable competition, the contracting officer shall  \n(1) Solicit quotations from other sources (see 13.105 ) and make the purchase as appropriate; and\n(2) Establish additional BPAs to facilitate future purchases if  \n(i) Recurring requirements for the same or similar supplies or services seem likely;\n(ii) Qualified sources are willing to accept BPAs; and\n(iii) It is otherwise practical to do so.\n(e) Limit documentation of purchases to essential information and forms as follows:\n(1) Purchases generally should be made electronically, or orally when it is not considered economical or practical to use electronic methods.\n(2) A paper purchase document may be issued if necessary to ensure that the supplier and the purchaser agree concerning the transaction.\n(3) Unless a paper document is issued, record essential elements ( e.g., date, supplier, supplies or services, price, delivery date) on the purchase requisition, in an informal memorandum, or on a form developed locally for the purpose.\n(4) Cite the pertinent purchase requisitions and the accounting and appropriation data.\n(5) When delivery is made or the services are performed, the supplier  s sales document, delivery document, or invoice may (if it reflects the essential elements) be used for the purpose of recording receipt and acceptance of the supplies or services. However, if the purchase is assigned to another activity for administration, the authorized Government representative shall document receipt and acceptance of supplies or services by signing and dating the agency specified form after verification and after notation of any exceptions.\n13.303-6 Review procedures.\n(a) The contracting officer placing orders under a BPA, or the designated representative of the contracting officer, shall review a sufficient random sample of the BPA files at least annually to ensure that authorized procedures are being followed.\n(b) The contracting officer that entered into the BPA shall  \n(1) Ensure that each BPA is reviewed at least annually and, if necessary, updated at that time; and\n(2) Maintain awareness of changes in market conditions, sources of supply, and other pertinent factors that may warrant making new arrangements with different suppliers or modifying existing arrangements.\n(c) If an office other than the purchasing office that established a BPA is authorized to make purchases under that BPA, the agency that has jurisdiction over the office authorized to make the purchases shall ensure that the procedures in paragraph (a) of this subsection are being followed.\n13.303-7 Completion of BPAs.\nAn individual BPA is considered complete when the purchases under it equal its total dollar limitation, if any, or when its stated time period expires.\n13.303-8 Optional clause.\nThe clause at 52.213-4 , Terms and Conditions  Simplified Acquisitions (Other Than Commercial Items), may be used in BPAs established under this section.\n13.304 [Reserved]\n13.305 Imprest funds and third party drafts.\n13.305-1 General.\nImprest funds and third party drafts may be used to acquire and to pay for supplies or services. Policies and regulations concerning the establishment of and accounting for imprest funds and third party drafts, including the responsibilities of designated cashiers and alternates, are contained in Part IV of the Treasury Financial Manual for Guidance of Departments and Agencies, Title 7 of the GAO Policy and Procedures Manual for Guidance of Federal Agencies, and the agency implementing regulations. Agencies also shall be guided by the Manual of Procedures and Instructions for Cashiers, issued by the Financial Management Service, Department of the Treasury.\n13.305-2 Agency responsibilities.\nEach agency using imprest funds and third party drafts shall  \n(a) Periodically review and determine whether there is a continuing need for each fund or third party draft account established, and that amounts of those funds or accounts are not in excess of actual needs;\n(b) Take prompt action to have imprest funds or third party draft accounts adjusted to a level commensurate with demonstrated needs whenever circumstances warrant such action; and\n(c) Develop and issue appropriate implementing regulations. These regulations shall include (but are not limited to) procedures covering  \n(1) Designation of personnel authorized to make purchases using imprest funds or third party drafts; and\n(2) Documentation of purchases using imprest funds or third party drafts, including documentation of  \n(i) Receipt and acceptance of supplies and services by the Government;\n(ii) Receipt of cash or third party draft payments by the suppliers; and\n(iii) Cash advances and reimbursements.\n13.305-3 Conditions for use.\nImprest funds or third party drafts may be used for purchases when  \n(a) The imprest fund transaction does not exceed $500 or such other limits as have been approved by the agency head;\n(b) The third party draft transaction does not exceed $2,500, unless authorized at a higher level in accordance with Treasury restrictions;\n(c) The use of imprest funds or third party drafts is considered to be advantageous to the Government; and\n(d) The use of imprest funds or third party drafts for the transaction otherwise complies with any additional conditions established by agencies and with the policies and regulations referenced in 13.305-1 .\n13.305-4 Procedures.\n(a) Each purchase using imprest funds or third party drafts shall be based upon an authorized purchase requisition, contracting officer verification statement, or other agency approved method of ensuring that adequate funds are available for the purchase.\n(b) Normally, purchases should be placed orally and without soliciting competition if prices are considered reasonable.\n(c) Since there is, for all practical purposes, simultaneous placement of the order and delivery of the items, clauses are not required for purchases using imprest funds or third party drafts.\n(d) Forms prescribed at 13.307(e) may be used if a written order is considered necessary ( e.g., if required by the supplier for discount, tax exemption, or other reasons). If a purchase order is used, endorse it  Payment to be made from Imprest Fund  (or  Payment to be made from Third Party Draft,  as appropriate).\n(e) The individual authorized to make purchases using imprest funds or third party drafts shall  \n(1) Furnish to the imprest fund or third party draft cashier a copy of the document required under paragraph (a) of this subsection annotated to reflect  \n(i) That an imprest fund or third party draft purchase has been made;\n(ii) The unit prices and extensions; and\n(iii) The supplier  s name and address; and\n(2) Require the supplier to include with delivery of the supplies an invoice, packing slip, or other sales instrument giving  \n(i) The supplier  s name and address;\n(ii) List and quantity of items supplied;\n(iii) Unit prices and extensions; and\n(iv) Cash discount, if any.\n13.306 SF 44, Purchase Order  Invoice  Voucher.\nThe SF 44 , Purchase Order  Invoice  Voucher, is a multipurpose pocket-size purchase order form designed primarily for on-the-spot, over-the-counter purchases of supplies and nonpersonal services while away from the purchasing office or at isolated activities. It also can be used as a receiving report, invoice, and public voucher.\n(a) This form may be used if all of the following conditions are satisfied:\n(1) The amount of the purchase is at or below the micro-purchase threshold, except for purchases made under unusual and compelling urgency or in support of contingency operations. Agencies may establish higher dollar limitations for specific activities or items.\n(2) The supplies or services are immediately available.\n(3) One delivery and one payment will be made.\n(4) Its use is determined to be more economical and efficient than use of other simplified acquisition procedures.\n(b) General procedural instructions governing the form  s use are printed on the form and on the inside front cover of each book of forms.\n(c) Since there is, for all practical purposes, simultaneous placement of the order and delivery of the items, clauses are not required for purchases using this form.\n(d) Agencies shall provide adequate safeguards regarding the control of forms and accounting for purchases.\n13.307 Forms.\n(a) Commercial items. For use of the SF 1449 , Solicitation/Contract/Order for Commercial Items, see 12.204 .\n(b) Other than commercial items.\n(1) Except when quotations are solicited electronically or orally, the SF 1449 ; SF 18 , Request for Quotations; or an agency form/automated format may be used. Each agency request for quotations form/automated format should conform with the SF 18 or SF 1449 to the maximum extent practicable.\n(2) Both SF 1449 and OF 347 , Order for Supplies or Services, are multipurpose forms used for negotiated purchases of supplies or services, delivery or task orders, inspection and receiving reports, and invoices. An agency form/automated format also may be used.\n(c) Forms used for both commercial and other than commercial items.\n(1) OF 336 , Continuation Sheet, or an agency form/automated format may be used when additional space is needed.\n(2) OF 348 , Order for Supplies or Services Schedule  Continuation, or an agency form/automated format may be used for negotiated purchases when additional space is needed. Agencies may print on these forms the clauses considered to be generally suitable for purchases.\n(3) SF 30 , Amendment of Solicitation/Modification of Contract, or a purchase order form may be used to modify a purchase order, unless an agency form/automated format is prescribed in agency regulations.\n(d) SF 44 , Purchase Order  Invoice  Voucher, is a multipurpose pocket-size purchase order form that may be used as outlined in 13.306 .\n(e) SF 1165 , Receipt for Cash  Subvoucher, or an agency purchase order form may be used for purchases using imprest funds or third party drafts.");
register_book(&s, "|13|4|", "Fast Payment Procedure", "Subpart 13.4  Fast Payment Procedure\n13.401 General.\n(a) The fast payment procedure allows payment under limited conditions to a contractor prior to the Government  s verification that supplies have been received and accepted. The procedure provides for payment for supplies based on the contractor  s submission of an invoice that constitutes a certification that the contractor  \n(1) Has delivered the supplies to a post office, common carrier, or point of first receipt by the Government; and\n(2) Shall replace, repair, or correct supplies not received at destination, damaged in transit, or not conforming to purchase agreements.\n(b) The contracting officer shall be primarily responsible for determining the amount of debts resulting from failure of contractors to properly replace, repair, or correct supplies lost, damaged, or not conforming to purchase requirements (see 32.602 and 32.603 ).\n13.402 Conditions for use.\nIf the conditions in paragraphs (a) through (f) of this section are present, the fast payment procedure may be used, provided that use of the procedure is consistent with the other conditions of the purchase. The conditions for use of the fast payment procedure are as follows:\n(a) Individual purchasing instruments do not exceed $30,000, except that executive agencies may permit higher dollar limitations for specified activities or items on a case-by-case basis.\n(b) Deliveries of supplies are to occur at locations where there is both a geographical separation and a lack of adequate communications facilities between Government receiving and disbursing activities that will make it impractical to make timely payment based on evidence of Government acceptance.\n(c) Title to the supplies passes to the Government  \n(1) Upon delivery to a post office or common carrier for mailing or shipment to destination; or\n(2) Upon receipt by the Government if the shipment is by means other than Postal Service or common carrier.\n(d) The supplier agrees to replace, repair, or correct supplies not received at destination, damaged in transit, or not conforming to purchase requirements.\n(e) The purchasing instrument is a firm-fixed-price contract, a purchase order, or a delivery order for supplies.\n(f) A system is in place to ensure  \n(1) Documentation of evidence of contractor performance under fast payment purchases;\n(2) Timely feedback to the contracting officer in case of contractor deficiencies; and\n(3) Identification of suppliers that have a current history of abusing the fast payment procedure (also see Subpart 9.1 ).\n13.403 Preparation and execution of orders.\nPriced or unpriced contracts, purchase orders, or BPAs using the fast payment procedure shall include the following:\n(a) A requirement that the supplies be shipped transportation or postage prepaid.\n(b) A requirement that invoices be submitted directly to the finance or other office designated in the order, or in the case of unpriced purchase orders, to the contracting officer (see 13.302-2 (c)).\n(c) The following statement on the consignee  s copy:\nConsignee  s Notification to Purchasing Activity of Nonreceipt, Damage, or Nonconformance\nThe consignee shall notify the purchasing office promptly after the specified date of delivery of supplies not received, damaged in transit, or not conforming to specifications of the purchase order. Unless extenuating circumstances exist, the notification should be made not later than 60 days after the specified date of delivery.\n13.404 Contract clause.\nThe contracting officer shall insert the clause at 52.213-1 , Fast Payment Procedure, in solicitations and contracts when the conditions in 13.402 are applicable and it is intended that the fast payment procedure be used in the contract (in the case of BPAs, the contracting officer may elect to insert the clause either in the BPA or in orders under the BPA).");
register_book(&s, "|13|5|", "Test Program for Certain Commercial Ite", "Subpart 13.5  Test Program for Certain Commercial Items\n13.500 General.\n(a) This subpart authorizes, as a test program, use of simplified procedures for the acquisition of supplies and services in amounts greater than the simplified acquisition threshold but not exceeding $6.5 million ($12 million for acquisitions as described in 13.500(e)), including options, if the contracting officer reasonably expects, based on the nature of the supplies or services sought, and on market research, that offers will include only commercial items. Under this test program, contracting officers may use any simplified acquisition procedure in this part, subject to any specific dollar limitation applicable to the particular procedure. The purpose of this test program is to vest contracting officers with additional procedural discretion and flexibility, so that commercial item acquisitions in this dollar range may be solicited, offered, evaluated, and awarded in a simplified manner that maximizes efficiency and economy and minimizes burden and administrative costs for both the Government and industry ( 10 U.S.C. 2304(g) and 2305 and 41 U.S.C. 253(g) and 253a and 253b).\n(b) For the period of this test, contracting activities must employ the simplified procedures authorized by the test to the maximum extent practicable.\n(c) When acquiring commercial items using the procedures in this part, the requirements of Part 12 apply subject to the order of precedence provided at 12.102(c). This includes use of the provisions and clauses in Subpart 12.3 .\n(d) The authority to issue solicitations under this subpart expires on January 1, 2015. Contracting officers may award contracts after the expiration of this authority for solicitations issued before the expiration of the authority.\n(e) Under 41 U.S.C. 428a , the simplified acquisition procedures authorized by this test program may be used for acquisitions that do not exceed $12 million when  \n(1) The acquisition is for commercial items that, as determined by the head of the agency, are to be used in support of a contingency operation or to facilitate the defense against or recovery from nuclear, biological, chemical, or radiological attack; or\n(2) The acquisition will be treated as an acquisition of commercial items in accordance with 12.102(f)(1).\n13.501 Special documentation requirements.\n(a) Sole source (including brand name) acquisitions.\n(1) Acquisitions conducted under simplified acquisition procedures are exempt from the requirements in Part 6 . However, contracting officers must  \n(i) Conduct sole source acquisitions, as defined in 2.101 , (including brand name) under this subpart only if the need to do so is justified in writing and approved at the levels specified in paragraph (a)(2) of this section;\n(ii) Prepare sole source (including brand name) justifications using the format at 6.303-2 , modified to reflect an acquisition under the authority of the test program for commercial items (section 4202 of the Clinger-Cohen Act of 1996) or the authority of the Services Acquisition Reform Act of 2003 ( 41 U.S.C. 428a );\n(iii) Make publicly available the justifications (excluding brand name) required by 6.305 (a) within 14 days after contract award or in the case of unusual and compelling urgency within 30 days after contract award, in accordance with 6.305 procedures at paragraphs (b), (d), (e), and (f); and\n(iv) Make publicly available brand name justifications with the solicitation, in accordance with 5.102 (a)(6).\n(2) Justifications and approvals are required under this subpart for sole-source (including brand-name) acquisitions or portions of an acquisition requiring a brand-name. If the justification is to cover only the portion of the acquisition which is brand-name, then it should so state; the approval level requirements will then only apply to that portion.\n(i) For a proposed contract exceeding $150,000, but not exceeding $650,000, the contracting officer  s certification that the justification is accurate and complete to the best of the contracting officer  s knowledge and belief will serve as approval, unless a higher approval level is established in accordance with agency procedures.\n(ii) For a proposed contract exceeding $650,000, but not exceeding $12.5 million, the competition advocate for the procuring activity, designated pursuant to 6.501 ; or an official described in 6.304 (a)(3) or (a)(4) must approve the justification and approval. This authority is not delegable.\n(iii) For a proposed contract exceeding $12.5 million but not exceeding $62.5 million or, for DoD, NASA, and the Coast Guard, not exceeding $85.5 million, the head of the procuring activity or the official described in 6.304 (a)(3) or (a)(4) must approve the justification and approval. This authority is not delegable.\n(iv) For a proposed contract exceeding $62.5 million or, for DoD, NASA, and the Coast Guard, $85.5 million, the official described in 6.304 (a)(4) must approve the justification and approval. This authority is not delegable except as provided in 6.304 (a)(4).\n(b) Contract file documentation. The contract file must include  \n(1) A brief written description of the procedures used in awarding the contract, including the fact that the test procedures in FAR Subpart 13.5 were used;\n(2) The number of offers received;\n(3) An explanation, tailored to the size and complexity of the acquisition, of the basis for the contract award decision; and\n(4) Any justification approved under paragraph (a) of this section.\n*    *    *    *    *    *");
register_book(&s, "|14|2|", "Solicitation of Bids", "Subpart 14.2  Solicitation of Bids\n14.201 Preparation of invitations for bids.\n14.201-1 Uniform contract format.\n(a) Contracting officers shall prepare invitations for bids and contracts using the uniform contract format outlined in Table 14-1 to the maximum practicable extent. The use of the format facilitates preparation of the solicitation and contract as well as reference to, and use of, those documents by bidders and contractors. It need not be used for acquisition of the following:\n(1) Construction (see Part 36 ).\n(2) Shipbuilding (including design, construction, and conversion), ship overhaul, and ship repair.\n(3) Subsistence items.\n(4) Supplies or services requiring special contract forms prescribed elsewhere in this regulation that are inconsistent with the uniform contract format.\n(5) Firm-fixed-price or fixed-price with economic price adjustment acquisitions that use the simplified contract format (see 14.201-9 ).\n(b) Information suitable for inclusion in invitations for bids under the uniform contract format shall also be included in invitations for bids not subject to that format if applicable.\n(c) Solicitations to which the uniform contract format applies shall include Parts I, II, III, and IV. If any section of the uniform contract format does not apply, the contracting officer should so mark that section in the solicitation. Upon award, the contracting officer shall not physically include Part IV in the resulting contract, but shall retain it in the contract file. (See 14.201 (c).) Award by acceptance of a bid on the award portion of Standard Form 33 , Solicitation, Offer and Award ( SF 33 ), Standard Form 26 , Award/Contract ( SF 26 ), or Standard Form 1447 , Solicitation/Contract ( SF 1447 ), incorporates Section K, Representations, certifications, and other statements of bidders, in the resultant contract even though not physically attached.\nTable 14-1  Uniform Contract Format\nSection\nTitle\nPart I  The Schedule\nA\nSolicitation/contract form\nB\nSupplies or services and prices\nC\nDescription/specifications\nD\nPackaging and marking\nE\nInspection and acceptance\nF\nDeliveries or performance\nG\nContract administration data\nH\nSpecial contract requirements\nPart II  Contract Clauses\nI\nContract clauses\nPart III  List of Documents, Exhibits, and Other Attachments\nJ\nList of documents, exhibits, and other attachments\nPart IV  Representations and Instructions\nK\nRepresentations, certifications, and other statements of bidders\nL\nInstructions, conditions, and notices to bidders\nM\nEvaluation factors for award\n14.201-2 Part I  The Schedule.\nThe contracting officer shall prepare the Schedule as follows:\n(a) Section A, Solicitation/contract form.\n(1) Prepare the invitation for bids on SF 33 , unless otherwise permitted by this regulation. The SF 33 is the first page of the solicitation and includes Section A of the uniform contract format. When the SF 1447 is used as the solicitation document, the information in subdivisions (a)(2)(i) and (a)(2)(iv) of this subsection shall be inserted in block 9 of the SF 1447 .\n(2) When the SF 33 or SF 1447 is not used, include the following on the first page of the invitation for bids:\n(i) Name, address, and location of issuing activity, including room and building where bids must be submitted.\n(ii) Invitation for bids number.\n(iii) Date of issuance.\n(iv) Time specified for receipt of bids.\n(v) Number of pages.\n(vi) Requisition or other purchase authority.\n(vii) Requirement for bidder to provide its name and complete address, including street, city, county, state, and ZIP code.\n(viii) A statement that bidders should include in the bid the address to which payment should be mailed, if that address is different from that of the bidder.\n(b) Section B, Supplies or services and prices . Include a brief description of the supplies or services; e.g., item number, national stock number/part number if applicable, title or name identifying the supplies or services, and quantities (see Part 11 ). The SF 33 and the SF 1447 may be supplemented as necessary by the Optional Form 336 ( OF 336 ), Continuation Sheet (53.302-336).\n(c) Section C, Description/specifications . Include any description or specifications needed in addition to Section B to permit full and open competition (see Part 11 ).\n(d) Section D, Packaging and marking. Provide packaging, packing, preservation, and marking requirements, if any.\n(e) Section E, Inspection and acceptance . Include inspection, acceptance, quality assurance, and reliability requirements (see Part 46 , Quality Assurance).\n(f) Section F, Deliveries or performance . Specify the requirements for time, place, and method of delivery or performance (see Subpart 11.4 , Delivery or Performance Schedules).\n(g) Section G, Contract administration data . Include any required accounting and appropriation data and any required contract administration information or instructions other than those on the solicitation form.\n(h) Section H, Special contract requirements . Include a clear statement of any special contract requirements that are not included in Section I, Contract clauses, or in other sections of the uniform contract format.\n14.201-3 Part II  Contract clauses.\nSection I, Contract clauses . The contracting officer shall include in this section the clauses required by law or by this regulation and any additional clauses expected to apply to any resulting contract, if these clauses are not required to be included in any other section of the uniform contract format.\n14.201-4 Part III  Documents, exhibits, and other attachments.\nSection J, List of documents, exhibits, and other attachments. The contracting officer shall list the title, date, and number of pages for each attached document.\n14.201-5 Part IV  Representations and instructions.\nThe contracting officer shall prepare the representations and instructions as follows:\n(a) Section K, Representations, certifications, and other statements of bidders . Include in this section those solicitation provisions that require representations, certifications, or the submission of other information by bidders.\n(b) Section L, Instructions, conditions, and notices to bidders. Insert in this section solicitation provisions and other information and instructions not required elsewhere to guide bidders. Invitations shall include the time and place for bid openings, and shall advise bidders that bids will be evaluated without discussions (see 52.214-10 and, for construction contracts, 52.214-19 ).\n(c) Section M, Evaluation factors for award . Identify the price related factors other than the bid price that will be considered in evaluating bids and awarding the contract. See 14.202-8 .\n14.201-6 Solicitation provisions.\n(a) The provisions prescribed in this subsection apply to preparation and submission of bids in general. See other FAR parts for provisions and clauses related to specific acquisition requirements.\n(b) Insert in all invitations for bids the provisions at  \n(1) 52.214-3 , Amendments to Invitations For Bids; and\n(2) 52.214-4 , False Statements in Bids.\n(c) Insert the following provisions in invitations for bids:\n(1) 52.214-5 , Submission of Bids.\n(2) 52.214-6 , Explanation to Prospective Bidders.\n(3) 52.214-7 , Late Submissions, Modifications, and Withdrawals of Bids.\n(d) [Reserved]\n(e) Insert in all invitations for bids, except those for construction, the provisions at 52.214-10 , Contract Award  Sealed Bidding.\n(f) Insert in invitations for bids to which the uniform contract format applies, the provision at 52.214-12 , Preparation of Bids.\n(g)(1) Insert the provision at 52.214-13 , Telegraphic Bids, in invitations for bids if the contracting officer decides to authorize telegraphic bids.\n(2) Use the provision with its Alternate I in invitations for bids that are for perishable subsistence, and when the contracting officer considers that offerors will be unwilling to provide acceptance periods long enough to allow written confirmation.\n(h) Insert the provision at 52.214-14 , Place of Performance  Sealed Bidding, in invitations for bids except those in which the place of performance is specified by the government.\n(i) Insert the provision at 52.214-15 , Period for Acceptance of Bids, in invitations for bids (IFB  s) that are not issued on SF 33 or SF 1447 except IFB  s  \n(1) For construction work; or\n(2) In which the government specifies a minimum acceptance period.\n(j) Insert the provision at 52.214-16 , Minimum Bid Acceptance Period, in invitations for bids, except for construction, if the contracting officer determines that a minimum acceptance period must be specified.\n(k) [Reserved]\n(l) Insert the provision at 52.214-18 , Preparation of Bids  Construction, in invitations for bids for construction work.\n(m) Insert the provision at 52.214-19 , Contract Award  Sealed Bidding  Construction, in all invitations for bids for construction work.\n(n) [Reserved]\n(o)(1) Insert the provision at 52.214-20 , Bid Samples, in invitations for bids if bid samples are required.\n(2) If it appears that the conditions in 14.202-4 (e)(1) will apply and the contracting officer anticipates granting waivers and  \n(i) If the nature of the required product does not necessitate limiting the grant of a waiver to a product produced at the same plant in which the product previously acquired or tested was produced, use the provision with its Alternate I; or\n(ii) If the nature of the required product necessitates limiting the grant of a waiver to a product produced at the same plant in which the product previously acquired or tested was produced, use the provision with its Alternate II.\n(3) See 14.202-4 (e)(2) regarding waiving the requirement for all bidders.\n(p)(1) Insert the provision at 52.214-21 , Descriptive Literature, in invitations for bids if  \n(i) Descriptive literature is required to evaluate the technical acceptability of an offered product; and\n(ii) The required information will not be readily available unless it is submitted by bidders.\n(2) Use the basic clause with its Alternate I if the possibility exists that the contracting officer may waive the requirement for furnishing descriptive literature for a bidder offering a previously supplied product that meets specification requirements of the current solicitation.\n(3) See 14.202-5 (d)(2) regarding waiving the requirement for all bidders.\n(q) Insert the provision at 52.214-22 , Evaluation of Bids for Multiple Awards, in invitations for bids if the contracting officer determines that multiple awards might be made if doing so is economically advantageous to the government.\n(r) Insert the provision at 52.214-23 , Late Submissions, Modifications, Revisions, and Withdrawals of Technical Proposals Under Two-Step Sealed Bidding, in solicitations for technical proposals in step one of two-step sealed bidding.\n(s) Insert the provision at 52.214-24 , Multiple Technical Proposals, in solicitations for technical proposals in step one of two-step sealed bidding if the contracting officer permits the submission of multiple technical proposals.\n(t) Insert the provision at 52.214-25 , Step Two of Two-Step Sealed Bidding, in invitations for bids issued under step two of two-step sealed bidding.\n(u) [Reserved]\n(v) Insert the provision at 52.214-31 , Facsimile Bids, in solicitations if facsimile bids are authorized (see 14.202-7 ).\n(w) Insert the provision at 52.214-34 , Submission of Offers in the English Language, in solicitations that include any of the clauses prescribed in 25.1101 or 25.1102 . It may be included in other solicitations when the contracting officer decides that it is necessary.\n(x) Insert the provision at 52.214-35 , Submission of Offers in U.S. Currency, in solicitations that include any of the clauses prescribed in 25.1101 or 25.1102 , unless the contracting officer includes the clause at 52.225-17 , Evaluation of Foreign Currency Offers, as prescribed in 25.1103 (d). It may be included in other solicitations when the contracting officer decides that it is necessary.\n14.201-7 Contract clauses.\n(a) When contracting by sealed bidding, the contracting officer shall insert the clause at 52.214-26 , Audit and Records  Sealed Bidding, in solicitations and contracts as follows: \n(1) Use the basic clause if  \n(i) The acquisition will not use funds appropriated or otherwise made available by the American Recovery and Reinvestment Act of 2009 (Pub. L. 111-5); and\n(ii) The contract amount is expected to exceed the threshold at 15.403-4 (a)(1) for submission of certified cost or pricing data.\n(2)(i) If the acquisition will use funds appropriated or otherwise made available by the American Recovery and Reinvestment Act of 2009, use the clause with its Alternate I in all solicitations and contracts.\n(ii)(A) In the case of a bilateral contract modification that will use funds appropriated or otherwise made available by the American Recovery and Reinvestment Act of 2009, the contracting officer shall specify applicability of Alternate I to that modification.\n(B) In the case of a task- or delivery-order contract in which not all orders will use funds appropriated or otherwise made available by the American Recovery and Reinvestment Act of 2009, the contracting officer shall specify the task or delivery orders to which Alternate I applies.\n(b)(1) When contracting by sealed bidding, the contracting officer shall insert the clause at 52.214-27 , Price Reduction for Defective Certified Cost or Pricing Data  Modifications  Sealed Bidding, in solicitations and contracts if the contract amount is expected to exceed the threshold for submission of certified cost or pricing data at 15.403-4 (a)(1).\n(2) In exceptional cases, the head of the contracting activity may waive the requirement for inclusion of the clause in a contract with a foreign government or agency of that government. The authorizations for the waiver and the reasons for granting it shall be in writing.\n(c)(1) When contracting by sealed bidding, the contracting officer shall insert the clause at 52.214-28 , Subcontractor Certified Cost or Pricing Data  Modifications  Sealed Bidding, in solicitations and contracts if the contract amount is expected to exceed the threshold for submission of certified cost or pricing data at 15.403-4 (a)(1).\n(2) In exceptional cases, the head of the contracting activity may waive the requirement for inclusion of the clause in a contract with a foreign government or agency of that government. The authorizations for the waiver and the reasons for granting it shall be in writing.\n(d) When contracting by sealed bidding the contracting officer shall insert the clause at 52.214-29 , Order of Precedence  Sealed Bidding, in solicitations and contracts to which the uniform contract format applies.\n14.201-8 Price related factors.\nThe factors set forth in paragraphs (a) through (e) of this subsection may be applicable in evaluation of bids for award and shall be included in the solicitation when applicable. (See 14.201-5 (c).)\n(a) Foreseeable costs or delays to the Government resulting from such factors as differences in inspection, locations of supplies, and transportation. If bids are on an f.o.b. origin basis (see 47.303 and 47.305 ), transportation costs to the designated points shall be considered in determining the lowest cost to the Government.\n(b) Changes made, or requested by the bidder, in any of the provisions of the invitation for bids, if the change does not constitute a ground for rejection under 14.404 .\n(c) Advantages or disadvantages to the Government that might result from making more than one award (see 14.201-6 (q)). The contracting officer shall assume, for the purpose of making multiple awards, that $500 would be the administrative cost to the Government for issuing and administering each contract awarded under a solicitation. Individual awards shall be for the items or combinations of items that result in the lowest aggregate cost to the Government, including the assumed administrative costs.\n(d) Federal, state, and local taxes (see Part 29 ).\n(e) Origin of supplies, and, if foreign, the application of the Buy American Act or any other prohibition on foreign purchases (see Part 25 ).\n14.201-9 Simplified contract format.\nPolicy . For firm-fixed-price or fixed-price with economic price adjustment acquisitions of supplies and services, the contracting officer may use the simplified contract format in lieu of the uniform contract format (see 14.201-1 ). The contracting officer has flexibility in preparation and organization of the simplified contract format. However, the following format should be used to the maximum practical extent:\n(a) Solicitation/contract form . Standard Form (SF) 1447 , Solicitation/Contract, shall be used as the first page of the solicitation.\n(b) Contract schedule . Include the following for each contract line item:\n(1) Contract line item number.\n(2) Description of supplies or services, or data sufficient to identify the requirement.\n(3) Quantity and unit of issue.\n(4) Unit price and amount.\n(5) Packaging and marking requirements.\n(6) Inspection and acceptance, quality assurance, and reliability requirements.\n(7) Place of delivery, performance and delivery dates, period of performance, and f.o.b. point.\n(8) Other item-peculiar information as necessary ( e.g., individual fund citations).\n(c) Clauses . Include the clauses required by this regulation. Additional clauses shall be incorporated only when considered absolutely necessary to the particular acquisition.\n(d) List of documents and attachments . Include if necessary.\n(e) Representations and instructions  \n(1) Representations and certifications . Insert those solicitation provisions that require representations, certifications, or the submission of other information by offerors.\n(2) Instructions, conditions, and notices . Include the solicitation provisions required by 14.201-6 . Include any other information/instructions necessary to guide offerors.\n(3) Evaluation factors for award . Insert all evaluation factors and any significant subfactors for award.\n(4) Upon award, the contracting officer need not physically include the provisions in paragraphs (e)(1), (2), and (3) of this subsection in the resulting contract, but shall retain them in the contract file. Award by acceptance of a bid on the award portion of SF 1447 incorporates the representations, certifications, and other statements of bidders in the resultant contract even though not physically attached.\n14.202 General rules for solicitation of bids.\n14.202-1 Bidding time.\n(a) Policy . A reasonable time for prospective bidders to prepare and submit bids shall be allowed in all invitations, consistent with the needs of the Government. (For construction contracts, see 36.213-3 (a).) A bidding time ( i.e., the time between issuance of the solicitation and opening of bids) of at least 30 calendar days shall be provided, when synopsis is required by Subpart 5.2 .\n(b) Factors to be considered . Because of unduly limited bidding time, some potential sources may be precluded from bidding and others may be forced to include amounts for contingencies that, with additional time, could be eliminated. To avoid unduly restricting competition or paying higher-than-necessary prices, consideration shall be given to such factors as the following in establishing a reasonable bidding time:\n(1) Degree of urgency;\n(2) Complexity of requirement;\n(3) Anticipated extent of subcontracting;\n(4) Whether use was made of presolicitation notices;\n(5) Geographic distribution of bidders; and\n(6) Normal transmittal time for both invitations and bids.\n14.202-2 Telegraphic bids.\n(a) Telegraphic bids and mailgrams shall be authorized only when  \n(1) The date for the opening of bids will not allow bidders sufficient time to submit bids in the prescribed format; or\n(2) Prices are subject to frequent changes.\n(b) If telegraphic bids are to be authorized, see 14.201-6 (g). Unauthorized telegraphic bids shall not be considered (see 14.301 (b)).\n14.202-3 Bid envelopes.\n(a) Postage or envelopes bearing  Postage and Fees Paid  indicia shall not be distributed with the invitation for bids or otherwise supplied to prospective bidders.\n(b) To provide for ready identification and proper handling of bids, Optional Form 17 , Offer Label, may be furnished with each bid set. The form may be obtained from the General Services Administration (see 53.107 ).\n14.202-4 Bid samples.\n(a) Policy.\n(1) Bidders shall not be required to furnish bid samples unless there are characteristics of the product that cannot be described adequately in the specification or purchase description.\n(2) Bid samples will be used only to determine the responsiveness of the bid and will not be used to determine a bidder  s ability to produce the required items.\n(3) Bid samples may be examined for any required characteristic, whether or not such characteristic is adequately described in the specification, if listed in accordance with paragraph (d)(1)(ii) of this section.\n(4) Bids will be rejected as nonresponsive if the sample fails to conform to each of the characteristics listed in the invitation.\n(b) When to use . The use of bid samples would be appropriate for products that must be suitable from the standpoint of balance, facility of use, general  feel,  color, pattern, or other characteristics that cannot be described adequately in the specification. However, when more than a minor portion of the characteristics of the product cannot be adequately described in the specification, products should be acquired by two-step sealed bidding or negotiation, as appropriate.\n(c) Justification . The reasons why acceptable products cannot be acquired without the submission of bid samples shall be set forth in the contract file, except where the submission is required by the formal specifications (Federal, Military, or other) applicable to the acquisition.\n(d) Requirements for samples in invitations for bids.\n(1) Invitations for bids shall  \n(i) State the number and, if appropriate, the size of the samples to be submitted and otherwise fully describe the samples required; and\n(ii) List all the characteristics for which the samples will be examined.\n(2) If bid samples are required, see 14.201-6 (o).\n(e) Waiver of requirement for bid samples.\n(1) The requirement for furnishing bid samples may be waived when a bidder offers a product previously or currently being contracted for or tested by the Government and found to comply with specification requirements conforming in every material respect with those in the current invitation for bids. When the requirement may be waived, see 14.201-6 (o)(2).\n(2) Where samples required by a Federal, Military, or other formal specification are not considered necessary and a waiver of the sample requirements of the specification has been authorized, a statement shall be included in the invitation that notwithstanding the requirements of the specification, samples will not be required.\n(f) Unsolicited samples . Bid samples furnished with a bid that are not required by the invitation generally will not be considered as qualifying the bid and will be disregarded. However, the bid sample will not be disregarded if it is clear from the bid or accompanying papers that the bidder  s intention was to qualify the bid. (See 14.404-2 (d) if the qualification does not conform to the solicitation.)\n(g) Handling bid samples.\n(1) Samples that are not destroyed in testing shall be returned to bidders at their request and expense, unless otherwise specified in the invitation.\n(2) Disposition instructions shall be requested from bidders and samples disposed of accordingly.\n(3) Samples ordinarily will be returned collect to the address from which received if disposition instructions are not received within 30 days. Small items may be returned by mail, postage prepaid.\n(4) Samples that are to be retained for inspection purposes in connection with deliveries shall be transmitted to the inspecting activity concerned, with instructions to retain the sample until completion of the contract or until disposition instructions are furnished.\n(5) Where samples are consumed or their usefulness is impaired by tests, they will be disposed of as scrap unless the bidder requests their return.\n14.202-5 Descriptive literature.\n(a) Policy . Contracting officers must not require bidders to furnish descriptive literature unless it is needed before award to determine whether the products offered meet the specification and to establish exactly what the bidder proposes to furnish.\n(b) Justification . The contracting officer must document in the contract file the reasons why product acceptability cannot be determined without the submission of descriptive literature, except when the contract specifications require submission.\n(c) Requirements of invitation for bids.\n(1) The invitation must clearly state  \n(i) What descriptive literature the bidders must furnish;\n(ii) The purpose for requiring the literature;\n(iii) The extent of its consideration in the evaluation of bids; and\n(iv) The rules that will apply if a bidder fails to furnish the literature before bid opening or if the literature provided does not comply with the requirements of the invitation.\n(2) If bidders must furnish descriptive literature, see 14.201-6 (p).\n(d) Waiver of requirement for descriptive literature.\n(1) The contracting officer may waive the requirement for descriptive literature if  \n(i) The bidder states in the bid that the product being offered is the same as a product previously or currently being furnished to the contracting activity; and\n(ii) The contracting officer determines that the product offered by the bidder complies with the specification requirements of the current invitation for bids. When the contracting officer waives the requirement, see 14.201-6 (p)(2).\n(2) When descriptive literature is not necessary and a waiver of literature requirements of a specification has been authorized, the contracting officer must include a statement in the invitation that, despite the requirements of the specifications, descriptive literature will not be required.\n(3) If the solicitation provides for a waiver, a bidder may submit a bid on the basis of either the descriptive literature furnished with the bid or a previously furnished product. If the bid is submitted on one basis, the bidder may not have it considered on the other basis after bids are opened.\n(e) Unsolicited descriptive literature . If descriptive literature is furnished when it is not required by the invitation for bids, the procedures set forth in 14.202-4 (f) must be followed.\n14.202-6 Final review of invitations for bids.\nEach invitation for bids shall be thoroughly reviewed before issuance to detect and correct discrepancies or ambiguities that could limit competition or result in the receipt of nonresponsive bids. Contracting officers are responsible for the reviews.\n14.202-7 Facsimile bids.\n(a) Unless prohibited or otherwise restricted by agency procedures, contracting officers may authorize facsimile bids (see 14.201-6 (v)). In determining whether or not to authorize facsimile bids, the contracting officer shall consider factors such as  \n(1) Anticipated bid size and volume;\n(2) Urgency of the requirement;\n(3) Frequency of price changes;\n(4) Availability, reliability, speed, and capacity of the receiving facsimile equipment; and\n(5) Adequacy of administrative procedures and controls for receiving, identifying, recording, and safeguarding facsimile bids, and ensuring their timely delivery to the bids opening location.\n(b) If facsimile bids are authorized, contracting officers may, after the date set for bid opening, request the apparently successful offeror to provide the complete, original signed bid.\n14.202-8 Electronic bids.\nIn accordance with Subpart 4.5 , contracting officers may authorize use of electronic commerce for submission of bids. If electronic bids are authorized, the solicitation shall specify the electronic commerce method(s) that bidders may use.\n14.203 Methods of soliciting bids.\n14.203-1 Transmittal to prospective bidders.\nInvitations for bids or presolicitation notices must be provided in accordance with 5.102 . When a contracting office is located in the United States, any solicitation sent to a prospective bidder located outside the United States shall be sent by electronic data interchange or air mail if security classification permits.\n14.203-2 Dissemination of information concerning invitations for bids.\nProcedures concerning display of invitations for bids in a public place, information releases to newspapers and trade journals, paid advertisements, and synopsizing through the Governmentwide point of entry (GPE) are set forth in 5.101 and Subpart 5.2 .\n14.203-3 Master solicitation.\nThe master solicitation is provided to potential sources who are requested to retain it for continued and repetitive use. Individual solicitations must reference the date of the current master solicitation and identify any changes. The contracting officer must  \n(a) Make available copies of the master solicitation on request; and\n(b) Provide the cognizant contract administration activity a current copy of the master solicitation.\n14.204 Records of invitations for bids and records of bids.\n(a) Each contracting office shall retain a record of each invitation that it issues and each abstract or record of bids. Contracting officers shall review and utilize the information available in connection with subsequent acquisitions of the same or similar items.\n(b) The file for each invitation shall show the distribution that was made and the date the invitation was issued. The names and addresses of prospective bidders who requested the invitation and were not included on the original solicitation list shall be added to the list and made a part of the record.\n14.205 Presolicitation notices.\nIn lieu of initially forwarding complete bid sets, the contracting officer may send presolicitation notices to concerns. The notice shall  \n(a) Specify the final date for receipt of requests for a complete bid set;\n(b) Briefly describe the requirement and furnish other essential information to enable concerns to determine whether they have an interest in the invitation; and\n(c) Normally not include drawings, plans, and specifications. The return date of the notice must be sufficiently in advance of the mailing date of the invitation for bids to permit an accurate estimate of the number of bid sets required. Bid sets shall be sent to concerns that request them in response to the notice.\n14.206 [Reserved]\n14.207 Pre-bid conference.\nA pre-bid conference may be used, generally in a complex acquisition, as a means of briefing prospective bidders and explaining complicated specifications and requirements to them as early as possible after the invitation has been issued and before the bids are opened. It shall never be used as a substitute for amending a defective or ambiguous invitation. The conference shall be conducted in accordance with the procedure prescribed in 15.201 .\n14.208 Amendment of invitation for bids.\n(a) If it becomes necessary to make changes in quantity, specifications, delivery schedules, opening dates, etc., or to correct a defective or ambiguous invitation, such changes shall be accomplished by amendment of the invitation for bids using Standard Form 30 , Amendment of Solicitation/ Modification of Contract. The fact that a change was mentioned at a pre-bid conference does not relieve the necessity for issuing an amendment. Amendments shall be sent, before the time for bid opening, to everyone to whom invitations have been furnished and shall be displayed in the bid room.\n(b) Before amending an invitation for bids, the period of time remaining until bid opening and the need to extend this period shall be considered. When only a short time remains before the time set for bid opening, consideration should be given to notifying bidders of an extension of time by telegrams or telephone. Such extension must be confirmed in the amendment.\n(c) Any information given to a prospective bidder concerning an invitation for bids shall be furnished promptly to all other prospective bidders as an amendment to the invitation (1) if such information is necessary for bidders to submit bids or (2) if the lack of such information would be prejudicial to uninformed bidders. The information shall be furnished even though a pre-bid conference is held. No award shall be made on the invitation unless such amendment has been issued in sufficient time to permit all prospective bidders to consider such information in submitting or modifying their bids.\n14.209 Cancellation of invitations before opening.\n(a) The cancellation of an invitation for bids usually involves a loss of time, effort, and money spent by the Government and bidders. Invitations should not be cancelled unless cancellation is clearly in the public interest; e.g. ,\n(1) Where there is no longer a requirement for the supplies or services; or\n(2) Where amendments to the invitation would be of such magnitude that a new invitation is desirable.\n(b) When an invitation issued other than electronically is cancelled, bids that have been received shall be returned unopened to the bidders and notice of cancellation shall be sent to all prospective bidders to whom invitations were issued. When an invitation issued electronically is cancelled, a general notice of cancellation shall be posted electronically, the bids received shall not be viewed, and the bids shall be purged from primary and backup data storage systems.\n(c) The notice of cancellation shall  (1) identify the invitation for bids by number and short title or subject matter, (2) briefly explain the reason the invitation is being cancelled, and (3) where appropriate, assure prospective bidders that they will be given an opportunity to bid on any resolicitation of bids or any future requirements for the type of supplies or services involved. Cancellations shall be recorded in accordance with 14.403 (d).\n14.210 Qualified products.\n(See Subpart 9.2 .)\n14.211 Release of acquisition information.\n(a) Before solicitation . Information concerning proposed acquisitions shall not be released outside the Government before solicitation except for presolicitation notices in accordance with 14.205 or 36.213-2 , or long-range acquisition estimates in accordance with 5.404 , or synopses in accordance with 5.201 . Within the Government, such information shall be restricted to those having a legitimate interest. Releases of information shall be made (1) to all prospective bidders, and (2) as nearly as possible at the same time, so that one prospective bidder shall not be given unfair advantage over another. See 3.104 regarding requirements for proprietary and source selection information including access to and disclosure thereof.\n(b) After solicitation . Discussions with prospective bidders regarding a solicitation shall be conducted and technical or other information shall be transmitted only by the contracting officer or superiors having contractual authority or by others specifically authorized. Such personnel shall not furnish any information to a prospective bidder that alone or together with other information may afford an advantage over others. However, general information that would not be prejudicial to other prospective bidders may be furnished upon request; e.g., explanation of a particular contract clause or a particular condition of the schedule in the invitation for bids, and more specific information or clarifications may be furnished by amending the solicitation (see 14.208 ).\n14.212 Economic purchase quantities (supplies).\nContracting officers shall comply with the economic purchase quantity planning requirements for supplies in Subpart 7.2 . See 7.203 for instructions regarding use of the provision at 52.207-4 , Economic Purchase Quantity  Supplies, and 7.204 for guidance on handling responses to that provision.");
register_book(&s, "|14|3|", "Submission of Bids", "Subpart 14.3  Submission of Bids\n14.301 Responsiveness of bids.\n(a) To be considered for award, a bid must comply in all material respects with the invitation for bids. Such compliance enables bidders to stand on an equal footing and maintain the integrity of the sealed bidding system.\n(b) Telegraphic bids shall not be considered unless permitted by the invitation. The term  telegraphic bids  means bids submitted by telegram or by mailgram.\n(c) Facsimile bids shall not be considered unless permitted by the solicitation (see 14.202-7 ).\n(d) Bids should be filled out, executed, and submitted in accordance with the instructions in the invitation. If a bidder uses its own bid form or a letter to submit a bid, the bid may be considered only if  \n(1) The bidder accepts all the terms and conditions of the invitation; and\n(2) Award on the bid would result in a binding contract with terms and conditions that do not vary from the terms and conditions of the invitation.\n(e) Bids submitted by electronic commerce shall be considered only if the electronic commerce method was specifically stipulated or permitted by the solicitation.\n14.302 Bid submission.\n(a) Bids shall be submitted so that they will be received in the office designated in the invitation for bids (referred to in paragraphs (b) and (c) of this section as the  designated office  ) not later than the exact time set for opening of bids.\n(b) Except as specified in paragraph (c) of this section, if telegraphic bids are authorized, a telegraphic bid that is communicated by means of a telephone call to the designated office shall be considered if  \n(1) Agency regulations authorize such consideration;\n(2) The telephone call is made by the telegraph office that received the telegraphic bid;\n(3) The telephone call is received by the designated office not later than the time set for the bid opening;\n(4) The telegraph office that received the telegraphic bid sends the designated office the telegram that formed the basis for the telephone call;\n(5) The telegram indicates on its face that it was received in the telegraph office before the telephone call was received by the designated office; and\n(6) The bid in the telegram is identical in all essential respects to the bid received in the telephone call from the telegraph office.\n(c) If the conditions in paragraph (b) of this section apply and the bid received by telephone is the apparent low bid, award may not be made until the telegram is received by the designated office; however, if the telegram is not received by the designated office within 5 days after the bid opening date, the bid shall be rejected.\n14.303 Modification or withdrawal of bids.\n(a) Bids may be modified or withdrawn by any method authorized by the solicitation, if notice is received in the office designated in the solicitation not later than the exact time set for opening of bids. Unless proscribed by agency regulations, a telegraphic modification or withdrawal of a bid received in such office by telephone from the receiving telegraph office shall be considered. However, the message shall be confirmed by the telegraph company by sending a copy of the written telegram that formed the basis for the telephone call. If the solicitation authorizes facsimile bids, bids may be modified or withdrawn via facsimile received at any time before the exact time set for receipt of bids, subject to the conditions specified in the provision prescribed in 14.201-6 (v). Modifications received by telegram (including a record of those telephoned by the telegraph company) or facsimile shall be sealed in an envelope by a proper official. The official shall write on the envelope (1) the date and time of receipt and by whom, and (2) the number of the invitation for bids, and shall sign the envelope. No information contained in the envelope shall be disclosed before the time set for bid opening.\n(b) A bid may be withdrawn in person by a bidder or its authorized representative if, before the exact time set for opening of bids, the identity of the persons requesting withdrawal is established and that person signs a receipt for the bid.\n(c) Upon withdrawal of an electronically transmitted bid, the data received shall not be viewed and shall be purged from primary and backup data storage systems.\n14.304 Submission, modification, and withdrawal of bids.\n(a) Bidders are responsible for submitting bids, and any modifications or withdrawals, so as to reach the Government office designated in the invitation for bid (IFB) by the time specified in the IFB. They may use any transmission method authorized by the IFB ( i.e., regular mail, electronic commerce, or facsimile). If no time is specified in the IFB, the time for receipt is 4:30 p.m., local time, for the designated Government office on the date that bids are due.\n(b)(1) Any bid, modification, or withdrawal of a bid received at the Government office designated in the IFB after the exact time specified for receipt of bids is  late  and will not be considered unless it is received before award is made, the contracting officer determines that accepting the late bid would not unduly delay the acquisition; and  \n(i) If it was transmitted through an electronic commerce method authorized by the IFB, it was received at the initial point of entry to the Government infrastructure not later than 5:00 p.m. one working day prior to the date specified for receipt of bids; or\n(ii) There is acceptable evidence to establish that it was received at the Government installation designated for receipt of bids and was under the Government  s control prior to the time set for receipt of bids.\n(2) However, a late modification of an otherwise successful bid, that makes its terms more favorable to the Government, will be considered at any time it is received and may be accepted.\n(c) Acceptable evidence to establish the time of receipt at the Government installation includes the time/date stamp of that installation on the bid wrapper, other documentary evidence of receipt maintained by the installation, or oral testimony or statements of Government personnel.\n(d) If an emergency or unanticipated event interrupts normal Government processes so that bids cannot be received at the Government office designated for receipt of bids by the exact time specified in the IFB, and urgent Government requirements preclude amendment of the bid opening date, the time specified for receipt of bids will be deemed to be extended to the same time of day specified in the IFB on the first work day on which normal Government processes resume.\n(e) Bids may be withdrawn by written notice received at any time before the exact time set for receipt of bids. If the IFB authorizes facsimile bids, bids may be withdrawn via facsimile received at any time before the exact time set for receipt of bids, subject to the conditions specified in the provision at 52.214-31 , Facsimile Bids. A bid may be withdrawn in person by a bidder or its authorized representative if, before the exact time set for receipt of bids, the identity of the person requesting withdrawal is established and the person signs a receipt for the bid. Upon withdrawal of an electronically transmitted bid, the data received must not be viewed and, where practicable, must be purged from primary and backup data storage systems.\n(f) The contracting officer must promptly notify any bidder if its bid, modification, or withdrawal was received late, and must inform the bidder whether its bid will be considered, unless contract award is imminent and the notices prescribed in 14.409 would suffice.\n(g) Late bids and modifications that are not considered must be held unopened, unless opened for identification, until after award and then retained with other unsuccessful bids. However, any bid bond or guarantee must be returned.\n(h) If available, the following must be included in the contract files for each late bid, modification, or withdrawal:\n(1) The date and hour of receipt.\n(2) A statement, with supporting rationale, regarding whether the bid was considered for award.\n(3) The envelope, wrapper, or other evidence of the date of receipt.");
register_book(&s, "|14|4|", "Opening of Bids and Award of Contract", "Subpart 14.4  Opening of Bids and Award of Contract\n14.400 Scope of subpart.\nThis subpart contains procedures for the receipt, handling, opening, and disposition of bids including mistakes in bids, and subsequent award of contracts.\n14.401 Receipt and safeguarding of bids.\n(a) All bids (including modifications) received before the time set for the opening of bids shall be kept secure. Except as provided in paragraph (b) of this section, the bids shall not be opened or viewed, and shall remain in a locked bid box, a safe, or in a secured, restricted-access electronic bid box. If an invitation for bids is cancelled, bids shall be returned to the bidders. Necessary precautions shall be taken to ensure the security of the bid box or safe. Before bid opening, information concerning the identity and number of bids received shall be made available only to Government employees. Such disclosure shall be only on a  need to know  basis. When bid samples are submitted, they shall be handled with sufficient care to prevent disclosure of characteristics before bid opening.\n(b) Envelopes marked as bids but not identifying the bidder or the solicitation may be opened solely for the purpose of identification, and then only by an official designated for this purpose. If a sealed bid is opened by mistake ( e.g., because it is not marked as being a bid), the envelope shall be signed by the opener, whose position shall also be written thereon, and delivered to the designated official. This official shall immediately write on the envelope (1) an explanation of the opening, (2) the date and time opened, and (3) the invitation for bids number, and shall sign the envelope. The official shall then immediately reseal the envelope.\n14.402 Opening of bids.\n14.402-1 Unclassified bids.\n(a) The bid opening officer shall decide when the time set for opening bids has arrived and shall inform those present of that decision. The officer shall then (1) personally and publicly open all bids received before that time, (2) if practical, read the bids aloud to the persons present, and (3) have the bids recorded. The original of each bid shall be carefully safeguarded, particularly until the abstract of bids required by 14.403 has been made and its accuracy verified.\n(b) Performance of the procedure in paragraph (a) of this section may be delegated to an assistant, but the bid opening officer remains fully responsible for the actions of the assistant.\n(c) Examination of bids by interested persons shall be permitted if it does not interfere unduly with the conduct of Government business. Original bids shall not be allowed to pass out of the hands of a Government official unless a duplicate bid is not available for public inspection. The original bid may be examined by the public only under the immediate supervision of a Government official and under conditions that preclude possibility of a substitution, addition, deletion, or alteration in the bid.\n14.402-2 Classified bids.\nThe general public may not attend bid openings for classified acquisitions. A bidder or its representative may attend and record the results if the individual has the appropriate security clearance. The contracting officer also may make the bids available at a later time to properly cleared individuals who represent bidders. No public record shall be made of bids or bid prices received in response to classified invitations for bids.\n14.402-3 Postponement of openings.\n(a) A bid opening may be postponed even after the time scheduled for bid opening (but otherwise in accordance with 14.208 ) when  \n(1) The contracting officer has reason to believe that the bids of an important segment of bidders have been delayed in the mails, or in the communications system specified for transmission of bids, for causes beyond their control and without their fault or negligence ( e.g., flood, fire, accident, weather conditions, strikes, or Government equipment blackout or malfunction when bids are due); or\n(2) Emergency or unanticipated events interrupt normal governmental processes so that the conduct of bid opening as scheduled is impractical.\n(b) At the time of a determination to postpone a bid opening under paragraph (a)(1) of this section, an announcement of the determination shall be publicly posted. If practical before issuance of a formal amendment of the invitation, the determination shall be otherwise communicated to prospective bidders who are likely to attend the scheduled bid opening.\n(c) In the case of paragraph (a)(2) of this section, and when urgent Government requirements preclude amendment of the solicitation as prescribed in 14.208 , the time specified for opening of bids will be deemed to be extended to the same time of day specified in the solicitation on the first work day on which normal Government processes resume. In such cases, the time of actual bid opening shall be deemed to be the time set for bid opening for the purpose of determining  late bids  under 14.304 . A note should be made on the abstract of bids or otherwise added to the file explaining the circumstances of the postponement.\n14.403 Recording of bids.\n(a) Standard Form 1409 , Abstract of Offers, or Optional Form 1419 , Abstract of Offers  Construction (or automated equivalent), shall be completed and certified as to its accuracy by the bid opening officer as soon after bid opening as practicable. Where bid items are too numerous to warrant complete recording of all bids, abstract entries for individual bids may be limited to item numbers and bid prices. In preparing these forms, the extra columns and SF 1410 , Abstract of Offers  Continuation, and OF 1419A , Abstract of Offer  Construction, Continuation Sheet, may be used to label and record such information as the contracting activity deems necessary.\n(b) Abstracts of offers for unclassified acquisitions shall be available for public inspection. Such abstracts shall not contain information regarding failure to meet minimum standards of responsibility, apparent collusion of bidders, or other notations properly exempt from disclosure to the public in accordance with agency regulations implementing Subpart 24.2 .\n(c) The forms identified in paragraph (a) of this section need not be used by the Defense Energy Support Center for acquisitions of coal or petroleum products or by the Defense Supply Center Philadelphia for perishable subsistence items.\n(d) If an invitation for bids is cancelled before the time set for bid opening, this fact shall be recorded together with a statement of the number of bids invited and the number of bids received.\n14.404 Rejection of bids.\n14.404-1 Cancellation of invitations after opening.\n(a)(1) Preservation of the integrity of the competitive bid system dictates that, after bids have been opened, award must be made to that responsible bidder who submitted the lowest responsive bid, unless there is a compelling reason to reject all bids and cancel the invitation.\n(2) Every effort shall be made to anticipate changes in a requirement before the date of opening and to notify all prospective bidders of any resulting modification or cancellation. This will permit bidders to change their bids and prevent unnecessary exposure of bid prices.\n(3) As a general rule, after the opening of bids, an invitation should not be cancelled and resolicited due solely to increased requirements for the items being acquired. Award should be made on the initial invitation for bids and the additional quantity should be treated as a new acquisition.\n(b) When it is determined before award but after opening that the requirements of 11.201 (relating to the availability and identification of specifications) have not been met, the invitation shall be cancelled.\n(c) Invitations may be cancelled and all bids rejected before award but after opening when, consistent with subparagraph (a)(1) of this section, the agency head determines in writing that  \n(1) Inadequate or ambiguous specifications were cited in the invitation;\n(2) Specifications have been revised;\n(3) The supplies or services being contracted for are no longer required;\n(4) The invitation did not provide for consideration of all factors of cost to the Government, such as cost of transporting Government-furnished property to bidders  plants;\n(5) Bids received indicate that the needs of the Government can be satisfied by a less expensive article differing from that for which the bids were invited;\n(6) All otherwise acceptable bids received are at unreasonable prices, or only one bid is received and the contracting officer cannot determine the reasonableness of the bid price;\n(7) The bids were not independently arrived at in open competition, were collusive, or were submitted in bad faith (see Subpart 3.3 for reports to be made to the Department of Justice);\n(8) No responsive bid has been received from a responsible bidder;\n(9) A cost comparison as prescribed in OMB Circular A-76 and Subpart 7.3 shows that performance by the Government is more economical; or\n(10) For other reasons, cancellation is clearly in the public  s interest.\n(d) Should administrative difficulties be encountered after bid opening that may delay award beyond bidders  acceptance periods, the several lowest bidders whose bids have not expired (irrespective of the acceptance period specified in the bid) should be requested, before expiration of their bids, to extend in writing the bid acceptance period (with consent of sureties, if any) in order to avoid the need for resoliciting.\n(e) Under some circumstances, completion of the acquisition after cancellation of the invitation for bids may be appropriate.\n(1) If the invitation for bids has been cancelled for the reasons specified in subparagraphs (c)(6), (7), or (8) of this subsection, and the agency head has authorized, in the determination in paragraph (c) of this subsection, the completion of the acquisition through negotiation, the contracting officer shall proceed in accordance with paragraph (f) of this subsection.\n(2) If the invitation for bids has been cancelled for the reasons specified in subparagraphs (c)(1), (2), (4), (5), or (10) of this subsection, or for the reasons in subparagraphs (c)(6), (7), or (8) of this subsection and completion through negotiation is not authorized under subparagraph (e)(1) of this subsection, the contracting officer shall proceed with a new acquisition.\n(f) When the agency head has determined, in accordance with paragraph (e)(1) of this subsection, that an invitation for bids should be canceled and that use of negotiation is in the Government  s interest, the contracting officer may negotiate (in accordance with Part 15 , as appropriate) and make award without issuing a new solicitation provided  \n(1) Each responsible bidder in the sealed bid acquisition has been given notice that negotiations will be conducted and has been given an opportunity to participate in negotiations; and\n(2) The award is made to the responsible bidder offering the lowest negotiated price.\n14.404-2 Rejection of individual bids.\n(a) Any bid that fails to conform to the essential requirements of the invitation for bids shall be rejected.\n(b) Any bid that does not conform to the applicable specifications shall be rejected unless the invitation authorized the submission of alternate bids and the supplies offered as alternates meet the requirements specified in the invitation.\n(c) Any bid that fails to conform to the delivery schedule or permissible alternates stated in the invitation shall be rejected.\n(d) A bid shall be rejected when the bidder imposes conditions that would modify requirements of the invitation or limit the bidder  s liability to the Government, since to allow the bidder to impose such conditions would be prejudicial to other bidders. For example, bids shall be rejected in which the bidder  \n(1) Protects against future changes in conditions, such as increased costs, if total possible costs to the Government cannot be determined;\n(2) Fails to state a price and indicates that price shall be  price in effect at time of delivery;  \n(3) States a price but qualifies it as being subject to  price in effect at time of delivery;  \n(4) When not authorized by the invitation, conditions or qualifies a bid by stipulating that it is to be considered only if, before date of award, the bidder receives (or does not receive) award under a separate solicitation;\n(5) Requires that the Government is to determine that the bidder  s product meets applicable Government specifications; or\n(6) Limits rights of the Government under any contract clause.\n(e) A low bidder may be requested to delete objectionable conditions from a bid provided the conditions do not go to the substance, as distinguished from the form, of the bid, or work an injustice on other bidders. A condition goes to the substance of a bid where it affects price, quantity, quality, or delivery of the items offered.\n(f) Any bid may be rejected if the contracting officer determines in writing that it is unreasonable as to price. Unreasonableness of price includes not only the total price of the bid, but the prices for individual line items as well.\n(g) Any bid may be rejected if the prices for any line items or subline items are materially unbalanced (see 15.404-1 (g)).\n(h) Bids received from any person or concern that is suspended, debarred, proposed for debarment or declared ineligible as of the bid opening date shall be rejected unless a compelling reason determination is made (see Subpart 9.4 ).\n(i) Low bids received from concerns determined to be not responsible pursuant to subpart 9.1 shall be rejected (but if a bidder is a small business concern, see 19.6 with respect to certificates of competency).\n(j) When a bid guarantee is required and a bidder fails to furnish the guarantee in accordance with the requirements of the invitation for bids, the bid shall be rejected, except as otherwise provided in 28.101-4 .\n(k) The originals of all rejected bids, and any written findings with respect to such rejections, shall be preserved with the papers relating to the acquisition.\n(l) After submitting a bid, if all of a bidder  s assets or that part related to the bid are transferred during the period between the bid opening and the award, the transferee may not be able to take over the bid. Accordingly, the contracting officer shall reject the bid unless the transfer is effected by merger, operation of law, or other means not barred by 41 U.S.C. 15 or 31 U.S.C. 3727 .\n14.404-3 Notice to bidders of rejection of all bids.\nWhen it is determined necessary to reject all bids, the contracting officer shall notify each bidder that all bids have been rejected and shall state the reason for such action.\n14.404-4 Restrictions on disclosure of descriptive literature.\nWhen a bid is accompanied by descriptive literature (as defined in 2.101 ), and the bidder imposes a restriction that prevents the public disclosure of such literature, the restriction may render the bid nonresponsive. The restriction renders the bid nonresponsive if it prohibits the disclosure of sufficient information to permit competing bidders to know the essential nature and type of the products offered or those elements of the bid that relate to quantity, price, and delivery terms. The provisions of this paragraph do not apply to unsolicited descriptive literature submitted by a bidder if such literature does not qualify the bid (see 14.202-5 (e)).\n14.404-5 All or none qualifications.\nUnless the solicitation provides otherwise, a bid may be responsive notwithstanding that the bidder specifies that award will be accepted only on all, or a specified group, of the items. Bidders shall not be permitted to withdraw or modify  all or none  qualifications after bid opening since such qualifications are substantive and affect the rights of other bidders.\n14.405 Minor informalities or irregularities in bids.\nA minor informality or irregularity is one that is merely a matter of form and not of substance. It also pertains to some immaterial defect in a bid or variation of a bid from the exact requirements of the invitation that can be corrected or waived without being prejudicial to other bidders. The defect or variation is immaterial when the effect on price, quantity, quality, or delivery is negligible when contrasted with the total cost or scope of the supplies or services being acquired. The contracting officer either shall give the bidder an opportunity to cure any deficiency resulting from a minor informality or irregularity in a bid or waive the deficiency, whichever is to the advantage of the Government. Examples of minor informalities or irregularities include failure of a bidder to  \n(a) Return the number of copies of signed bids required by the invitation;\n(b) Furnish required information concerning the number of its employees;\n(c) Sign its bid, but only if  \n(1) The unsigned bid is accompanied by other material indicating the bidder  s intention to be bound by the unsigned bid (such as the submission of a bid guarantee or a letter signed by the bidder, with the bid, referring to and clearly identifying the bid itself); or\n(2) The firm submitting a bid has formally adopted or authorized, before the date set for opening of bids, the execution of documents by typewritten, printed, or stamped signature and submits evidence of such authorization and the bid carries such a signature;\n(d) Acknowledge receipt of an amendment to an invitation for bids, but only if  \n(1) The bid received clearly indicates that the bidder received the amendment, such as where the amendment added another item to the invitation and the bidder submitted a bid on the item; or\n(2) The amendment involves only a matter of form or has either no effect or merely a negligible effect on price, quantity, quality, or delivery of the item bid upon; and\n(e) Execute the representations with respect to Equal Opportunity and Affirmative Action Programs, as set forth in the clauses at 52.222-22 , Previous Contracts and Compliance Reports, and 52.222-25 , Affirmative Action Compliance.\n14.406 Receipt of an unreadable electronic bid.\nIf a bid received at the Government facility by electronic data interchange is unreadable to the degree that conformance to the essential requirements of the invitation for bids cannot be ascertained, the contracting officer immediately shall notify the bidder that the bid will be rejected unless the bidder provides clear and convincing evidence  \n(a) Of the content of the bid as originally submitted; and\n(b) That the unreadable condition of the bid was caused by Government software or hardware error, malfunction, or other Government mishandling.\n14.407 Mistakes in bids.\n14.407-1 General.\nAfter the opening of bids, contracting officers shall examine all bids for mistakes. In cases of apparent mistakes and in cases where the contracting officer has reason to believe that a mistake may have been made, the contracting officer shall request from the bidder a verification of the bid, calling attention to the suspected mistake. If the bidder alleges a mistake, the matter shall be processed in accordance with this section 14.407 . Such actions shall be taken before award.\n14.407-2 Apparent clerical mistakes.\n(a) Any clerical mistake, apparent on its face in the bid, may be corrected by the contracting officer before award. The contracting officer first shall obtain from the bidder a verification of the bid intended. Examples of apparent mistakes are  \n(1) Obvious misplacement of a decimal point;\n(2) Obviously incorrect discounts (for example, 1 percent 10 days, 2 percent 20 days, 5 percent 30 days);\n(3) Obvious reversal of the price f.o.b. destination and price f.o.b. origin; and\n(4) Obvious mistake in designation of unit.\n(b) Correction of the bid shall be effected by attaching the verification to the original bid and a copy of the verification to the duplicate bid. Correction shall not be made on the face of the bid; however, it shall be reflected in the award document.\n(c) Correction of bids submitted by electronic data interchange shall be effected by including in the electronic solicitation file the original bid, the verification request, and the bid verification.\n14.407-3 Other mistakes disclosed before award.\nIn order to minimize delays in contract awards, administrative determinations may be made as described in this 14.407-3 in connection with mistakes in bids alleged after opening of bids and before award. The authority to permit correction of bids is limited to bids that, as submitted, are responsive to the invitation and may not be used to permit correction of bids to make them responsive. This authority is in addition to that in 14.407-2 or that may be otherwise available.\n(a) If a bidder requests permission to correct a mistake and clear and convincing evidence establishes both the existence of the mistake and the bid actually intended, the agency head may make a determination permitting the bidder to correct the mistake; provided, that if this correction would result in displacing one or more lower bids, such a determination shall not be made unless the existence of the mistake and the bid actually intended are ascertainable substantially from the invitation and the bid itself.\n(b) If  \n(1) A bidder requests permission to withdraw a bid rather than correct it;\n(2) The evidence is clear and convincing both as to the existence of a mistake and as to the bid actually intended; and\n(3) The bid, both as uncorrected and as corrected, is the lowest received, the agency head may make a determination to correct the bid and not permit its withdrawal.\n(c) If, under paragraph (a) or (b) of this subsection, (1) the evidence of a mistake is clear and convincing only as to the mistake but not as to the intended bid, or (2) the evidence reasonably supports the existence of a mistake but is not clear and convincing, an official above the contracting officer, unless otherwise provided by agency procedures, may make a determination permitting the bidder to withdraw the bid.\n(d) If the evidence does not warrant a determination under paragraph (a), (b), or (c) of this section, the agency head may make a determination that the bid be neither withdrawn nor corrected.\n(e) Heads of agencies may delegate their authority to make the determinations under paragraphs (a), (b), (c), and (d) of this 14.407-3 to a central authority, or a limited number of authorities as necessary, in their agencies, without power of redelegation.\n(f) Each proposed determination shall have the concurrence of legal counsel within the agency concerned before issuance.\n(g) Suspected or alleged mistakes in bids shall be processed as follows. A mere statement by the administrative officials that they are satisfied that an error was made is insufficient.\n(1) The contracting officer shall immediately request the bidder to verify the bid. Action taken to verify bids must be sufficient to reasonably assure the contracting officer that the bid as confirmed is without error, or to elicit the allegation of a mistake by the bidder. To assure that the bidder will be put on notice of a mistake suspected by the contracting officer, the bidder should be advised as appropriate  \n(i) That its bid is so much lower than the other bids or the Government  s estimate as to indicate a possibility of error;\n(ii) Of important or unusual characteristics of the specifications;\n(iii) Of changes in requirements from previous purchases of a similar item; or\n(iv) Of any other information, proper for disclosure, that leads the contracting officer to believe that there is a mistake in bid.\n(2) If the bid is verified, the contracting officer shall consider the bid as originally submitted. If the time for acceptance of bids is likely to expire before a decision can be made, the contracting officer shall request all bidders whose bids may become eligible for award to extend the time for acceptance of their bids in accordance with 14.404-1 (d). If the bidder whose bid is believed erroneous does not (or cannot) grant an extension of time, the bid shall be considered as originally submitted (but see paragraph (g)(5) of this section). If the bidder alleges a mistake, the contracting officer shall advise the bidder to make a written request to withdraw or modify the bid. The request must be supported by statements (sworn statements, if possible) and shall include all pertinent evidence such as the bidder  s file copy of the bid, the original worksheets and other data used in preparing the bid, subcontractors  quotations, if any, published price lists, and any other evidence that establishes the existence of the error, the manner in which it occurred, and the bid actually intended.\n(3) When the bidder furnishes evidence supporting an alleged mistake, the contracting officer shall refer the case to the appropriate authority (see paragraph (e) of this section) together with the following data:\n(i) A signed copy of the bid involved.\n(ii) A copy of the invitation for bids and any specifications or drawings relevant to the alleged mistake.\n(iii) An abstract or record of the bids received.\n(iv) The written request by the bidder to withdraw or modify the bid, together with the bidder  s written statement and supporting evidence.\n(v) A written statement by the contracting officer setting forth  \n(A) A description of the supplies or services involved;\n(B) The expiration date of the bid in question and of the other bids submitted;\n(C) Specific information as to how and when the mistake was alleged;\n(D) A summary of the evidence submitted by the bidder;\n(E) In the event only one bid was received, a quotation of the most recent contract price for the supplies or services involved or, in the absence of a recent comparable contract, the contracting officer  s estimate of a fair price for the supplies or services;\n(F) Any additional pertinent evidence; and\n(G) A recommendation that either the bid be considered for award in the form submitted, or the bidder be authorized to withdraw or modify the bid.\n(4) When time is of the essence because of the expiration of bids or otherwise, the contracting officer may refer the case by telegraph or telephone to the appropriate authority. Ordinarily, the contracting officer will not refer mistake in bid cases by telegraph or telephone to the appropriate authority when the determination set forth in paragraphs (a) or (b) of this section is applicable, since actual examination is generally necessary to determine whether the evidence presented is clear and convincing.\n(5) Where the bidder fails or refuses to furnish evidence in support of a suspected or alleged mistake, the contracting officer shall consider the bid as submitted unless (i) the amount of the bid is so far out of line with the amounts of other bids received, or with the amount estimated by the agency or determined by the contracting officer to be reasonable, or (ii) there are other indications of error so clear, as to reasonably justify the conclusion that acceptance of the bid would be unfair to the bidder or to other bona fide bidders. Attempts made to obtain the information required and the action taken with respect to the bid shall be fully documented.\n(h) Each agency shall maintain records of all determinations made in accordance with this subsection 14.407-3 , the facts involved, and the action taken in each case. Copies of all such determinations shall be included in the file.\n(i) Nothing contained in this subsection 14.407-3 prevents an agency from submitting doubtful cases to the Comptroller General for advance decision.\n14.407-4 Mistakes after award.\nIf a contractor  s discovery and request for correction of a mistake in bid is not made until after the award, it shall be processed under the procedures of Subpart 33.2 and the following:\n(a) When a mistake in a contractor  s bid is not discovered until after award, the mistake may be corrected by contract modification if correcting the mistake would be favorable to the Government without changing the essential requirements of the specifications.\n(b) In addition to the cases contemplated in paragraph (a) of this section or as otherwise authorized by law, agencies are authorized to make a determination  \n(1) To rescind a contract;\n(2) To reform a contract  \n(i) To delete the items involved in the mistake; or\n(ii) To increase the price if the contract price, as corrected, does not exceed that of the next lowest acceptable bid under the original invitation for bids; or\n(3) That no change shall be made in the contract as awarded, if the evidence does not warrant a determination under subparagraph (b)(1) or (2) of this section.\n(c) Determinations under paragraph (b)(1) and (2) of this section may be made only on the basis of clear and convincing evidence that a mistake in bid was made. In addition, it must be clear that the mistake was  \n(1) Mutual; or\n(2) If unilaterally made by the contractor, so apparent as to have charged the contracting officer with notice of the probability of the mistake.\n(d) Each proposed determination shall be coordinated with legal counsel in accordance with agency procedures.\n(e) Mistakes alleged or disclosed after award shall be processed as follows:\n(1) The contracting officer shall request the contractor to support the alleged mistake by submission of written statements and pertinent evidence, such as  \n(i) The contractor  s file copy of the bid,\n(ii) The contractor  s original worksheets and other data used in preparing the bid,\n(iii) Subcontractors  and suppliers  quotations, if any,\n(iv) Published price lists, and\n(v) Any other evidence that will serve to establish the mistake, the manner in which the mistake occurred, and the bid actually intended.\n(2) The case file concerning an alleged mistake shall contain the following:\n(i) All evidence furnished by the contractor in support of the alleged mistake.\n(ii) A signed statement by the contracting officer  \n(A) Describing the supplies or services involved;\n(B) Specifying how and when the mistake was alleged or disclosed;\n(C) Summarizing the evidence submitted by the contractor and any additional evidence considered pertinent;\n(D) Quoting, in cases where only one bid was received, the most recent contract price for the supplies or services involved, or in the absence of a recent comparable contract, the contracting officer  s estimate of a fair price for the supplies or services and the basis for the estimate;\n(E) Setting forth the contracting officer  s opinion whether a bona fide mistake was made and whether the contracting officer was, or should have been, on constructive notice of the mistake before the award, together with the reasons for, or data in support of, such opinion;\n(F) Setting forth the course of action with respect to the alleged mistake that the contracting officer considers proper on the basis of the evidence, and if other than a change in contract price is recommended, the manner by which the supplies or services will otherwise be acquired; and\n(G) Disclosing the status of performance and payments under the contract, including contemplated performance and payments.\n(iii) A signed copy of the bid involved.\n(iv) A copy of the invitation for bids and any specifications or drawings relevant to the alleged mistake.\n(v) An abstract of written record of the bids received.\n(vi) A written request by the contractor to reform or rescind the contract, and copies of all other relevant correspondence between the contracting officer and the contractor concerning the alleged mistake.\n(vii) A copy of the contract and any related change orders or supplemental agreements.\n(f) Each agency shall include in the contract file a record of  \n(1) All determinations made in accordance with this 14.407-4 ;\n(2) The facts involved; and\n(3) The action taken in each case.\n14.408 Award.\n14.408-1 General.\n(a) The contracting officer shall make a contract award (1) by written or electronic notice, (2) within the time for acceptance specified in the bid or an extension (see 14.404-1 (d)), and (3) to that responsible bidder whose bid, conforming to the invitation, will be most advantageous to the Government, considering only price and the price-related factors (see 14.201-8 ) included in the invitation. Award shall not be made until all required approvals have been obtained and the award otherwise conforms with 14.103-2 .\n(b) If less than three bids have been received, the contracting officer shall examine the situation to ascertain the reasons for the small number of responses. Award shall be made notwithstanding the limited number of bids. However, the contracting officer shall initiate, if appropriate, corrective action to increase competition in future solicitations for the same or similar items, and include a notation of such action in the records of the invitation for bids (see 14.204 ).\n(c)(1) Award shall be made by mailing or otherwise furnishing a properly executed award document to the successful bidder.\n(2) When a notice of award is issued, it shall be followed as soon as possible by the formal award.\n(3) When more than one award results from any single invitation for bids, separate award documents shall be suitably numbered and executed.\n(4) When an award is made to a bidder for less than all of the items that may be awarded to that bidder and additional items are being withheld for subsequent award, the award shall state that the Government may make subsequent awards on those additional items within the bid acceptance period.\n(5) All provisions of the invitation for bids, including any acceptable additions or changes made by a bidder in the bid, shall be clearly and accurately set forth (either expressly or by reference) in the award document. The award is an acceptance of the bid, and the bid and the award constitute the contract.\n(d)(1) Award is generally made by using the Award portion of Standard Form (SF) 33 , Solicitation, Offer, and Award, or SF 1447 , Solicitation/Contract (see 53.214 ). If an offer from a SF 33 leads to further changes, the resulting contract shall be prepared as a bilateral document on SF 26 , Award/Contract.\n(2) Use of the Award portion of SF 33 , SF 26 , or SF 1447 , does not preclude the additional use of informal documents, including telegrams or electronic transmissions, as notices of awards.\n14.408-2 Responsible bidder  reasonableness of price.\n(a) The contracting officer shall determine that a prospective contractor is responsible (see Subpart 9.1 ) and that the prices offered are reasonable before awarding the contract. The price analysis techniques in 15.404-1 (b) may be used as guidelines. In each case the determination shall be made in the light of all prevailing circumstances. Particular care must be taken in cases where only a single bid is received.\n(b) The price analysis shall consider whether bids are materially unbalanced (see 15.404-1 (g)).\n14.408-3 Prompt payment discounts.\n(a) Prompt payment discounts shall not be considered in the evaluation of bids. However, any discount offered will form a part of the award, and will be taken by the payment center if payment is made within the discount period specified by the bidder. As an alternative to indicating a discount in conjunction with the offer, bidders may prefer to offer discounts on individual invoices.\n(b) See 32.111 (b)(1), which prescribes the contract clause at 52.232-8 , Discounts for Prompt Payment.\n14.408-4 Economic price adjustment.\n(a) Bidder proposes economic price adjustment.\n(1) When a solicitation does not contain an economic price adjustment clause but a bidder proposes one with a ceiling that the price will not exceed, the bid shall be evaluated on the basis of the maximum possible economic price adjustment of the quoted base price.\n(2) If the bid is eligible for award, the contracting officer shall request the bidder to agree to the inclusion in the award of an approved economic price adjustment clause (see 16.203 ) that is subject to the same ceiling. If the bidder will not agree to an approved clause, the award may be made on the basis of the bid as originally submitted.\n(3) Bids that contain economic price adjustments with no ceiling shall be rejected unless a clear basis for evaluation exists.\n(b) Government proposes economic price adjustment.\n(1) When an invitation contains an economic price adjustment clause and no bidder takes exception to the provisions, bids shall be evaluated on the basis of the quoted prices without the allowable economic price adjustment being added.\n(2) When a bidder increases the maximum percentage of economic price adjustment stipulated in the invitation or limits the downward economic price adjustment provisions of the invitation, the bid shall be rejected as nonresponsive.\n(3) When a bid indicates deletion of the economic price adjustment clause, the bid shall be rejected as nonresponsive since the downward economic price adjustment provisions are thereby limited.\n(4) When a bidder decreases the maximum percentage of economic price adjustment stipulated in the invitation, the bid shall be evaluated at the base price on an equal basis with bids that do not reduce the stipulated ceiling. However, after evaluation, if the bidder offering the lower ceiling is in a position to receive the award, the award shall reflect the lower ceiling.\n14.408-5 [Reserved]\n14.408-6 Equal low bids.\n(a) Contracts shall be awarded in the following order of priority when two or more low bids are equal in all respects:\n(1) Small business concerns that are also labor surplus area concerns.\n(2) Other small business concerns.\n(3) Other business concerns.\n(b) If two or more bidders still remain equally eligible after application of paragraph (a) of this section, award shall be made by a drawing by lot limited to those bidders. If time permits, the bidders involved shall be given an opportunity to attend the drawing. The drawing shall be witnessed by at least three persons, and the contract file shall contain the names and addresses of the witnesses and the person supervising the drawing.\n(c) When an award is to be made by using the priorities under this 14.408-6 , the contracting officer shall include a written agreement in the contract that the contractor will perform, or cause to be performed, the contract in accordance with the circumstances justifying the priority used to break the tie or select bids for a drawing by lot.\n14.408-7 Documentation of award.\n(a) The contracting officer shall document compliance with 14.103-2 in the contract file.\n(b) The documentation shall either state that the accepted bid was the lowest bid received, or list all lower bids with reasons for their rejection in sufficient detail to justify the award.\n(c) When an award is made after receipt of equal low bids, the documentation shall describe how the tie was broken.\n14.408-8 Protests against award.\n(See Subpart 33.1 , Protests.)\n14.409 Information to bidders.\n14.409-1 Award of unclassified contracts.\n(a)(1) The contracting officer shall as a minimum (subject to any restrictions in Subpart 9.4 )  \n(i) Notify each unsuccessful bidder in writing or electronically within three days after contract award, that its bid was not accepted.  Day,  for purposes of the notification process, means calendar day, except that the period will run until a day which is not a Saturday, Sunday, or legal holiday;\n(ii) Extend appreciation for the interest the unsuccessful bidder has shown in submitting a bid; and\n(iii) When award is made to other than a low bidder, state the reason for rejection in the notice to each of the unsuccessful low bidders.\n(2) For acquisitions covered by the World Trade Organization Government Procurement Agreement or a Free Trade Agreement (see 25.408 (a)(5)), agencies must include in notices given unsuccessful bidders from World Trade Organization Government Procurement Agreement or Free Trade Agreement countries  \n(i) The dollar amount of the successful bid; and\n(ii) The name and address of the successful bidder.\n(b) Information included in paragraph (a)(2) of this subsection shall be provided to any unsuccessful bidder upon request except when multiple awards have been made and furnishing information on the successful bids would require so much work as to interfere with normal operations of the contracting office. In such circumstances, only information concerning location of the abstract of offers need be given.\n(c) When a request is received concerning an unclassified invitation from an inquirer who is neither a bidder nor a representative of a bidder, the contracting officer should make every effort to furnish the names of successful bidders and, if requested, the prices at which awards were made. However, when such requests require so much work as to interfere with the normal operations of the contracting office, the inquirer will be advised where a copy of the abstract of offers may be seen.\n(d) Requests for records shall be governed by agency regulations implementing Subpart 24.2 .\n14.409-2 Award of classified contracts.\nIn addition to 14.409-1 , if classified information was furnished or created in connection with the solicitation, the contracting officer shall advise the unsuccessful bidders, including any who did not bid, to take disposition action in accordance with agency procedures. The name of the successful bidder and the contract price will be furnished to unsuccessful bidders only upon request. Information regarding a classified award shall not be furnished by telephone.");
register_book(&s, "|14|5|", "Two-Step Sealed Bidding", "Subpart 14.5  Two-Step Sealed Bidding\n14.501 General.\nTwo-step sealed bidding is a combination of competitive procedures designed to obtain the benefits of sealed bidding when adequate specifications are not available. An objective is to permit the development of a sufficiently descriptive and not unduly restrictive statement of the Government  s requirements, including an adequate technical data package, so that subsequent acquisitions may be made by conventional sealed bidding. This method is especially useful in acquisitions requiring technical proposals, particularly those for complex items. It is conducted in two steps:\n(a) Step one consists of the request for, submission, evaluation, and (if necessary) discussion of a technical proposal. No pricing is involved. The objective is to determine the acceptability of the supplies or services offered. As used in this context, the word  technical  has a broad connotation and includes, among other things, the engineering approach, special manufacturing processes, and special testing techniques. It is the proper step for clarification of questions relating to technical requirements. Conformity to the technical requirements is resolved in this step, but not responsibility as defined in 9.1.\n(b) Step two involves the submission of sealed priced bids by those who submitted acceptable technical proposals in step one. Bids submitted in step two are evaluated and the awards made in accordance with Subparts 14.3 and 14.4 .\n14.502 Conditions for use.\n(a) Unless other factors require the use of sealed bidding, two-step sealed bidding may be used in preference to negotiation when all of the following conditions are present:\n(1) Available specifications or purchase descriptions are not definite or complete or may be too restrictive without technical evaluation, and any necessary discussion, of the technical aspects of the requirement to ensure mutual understanding between each source and the Government.\n(2) Definite criteria exist for evaluating technical proposals.\n(3) More than one technically qualified source is expected to be available.\n(4) Sufficient time will be available for use of the two-step method.\n(5) A firm-fixed-price contract or a fixed-price contract with economic price adjustment will be used.\n(b) None of the following precludes the use of two-step sealed bidding:\n(1) Multi-year contracting.\n(2) Government property to be made available to the successful bidder.\n(3) A total small business set-aside (see 19.502-2 ).\n(4) The use of the price evaluation adjustment for small disadvantaged business concerns (see Subpart 19.11 ).\n(5) The use of a set-aside or price evaluation preference for HUBZone small business concerns (see Subpart 19.13 ).\n(6) The use of a set-aside for service-disabled veteran-owned small business concerns (see Subpart 19.14 ).\n(7) The use of a set-aside for economically disadvantaged woman-owned small business concerns and women-owned small business concerns eligible under the Woman-Owned Small Business Program (see subpart 19.15 ).\n(8) A first or subsequent production quantity is being acquired under a performance specification.\n14.503 Procedures.\n14.503-1 Step one.\n(a) Requests for technical proposals shall be synopsized in accordance with Part 5 . The request must include, as a minimum, the following:\n(1) A description of the supplies or services required.\n(2) A statement of intent to use the two-step method.\n(3) The requirements of the technical proposal.\n(4) The evaluation criteria, to include all factors and any significant subfactors.\n(5) A statement that the technical proposals shall not include prices or pricing information.\n(6) The date, or date and hour, by which the proposal must be received (see 14.201-6 (r)).\n(7) A statement that  \n(i) In the second step, only bids based upon technical proposals determined to be acceptable, either initially or as a result of discussions, will be considered for awards, and\n(ii) Each bid in the second step must be based on the bidder  s own technical proposals.\n(8) A statement that  \n(i) Offerors should submit proposals that are acceptable without additional explanation or information,\n(ii) The Government may make a final determination regarding a proposal  s acceptability solely on the basis of the proposal as submitted; and\n(iii) The Government may proceed with the second step without requesting further information from any offeror; however, the Government may request additional information from offerors of proposals that it considers reasonably susceptible of being made acceptable, and may discuss proposals with their offerors.\n(9) A statement that a notice of unacceptability will be forwarded to the offeror upon completion of the proposal evaluation and final determination of unacceptability.\n(10) A statement either that only one technical proposal may be submitted by each offeror or that multiple technical proposals may be submitted. When specifications permit different technical approaches, it is generally in the Government  s interest to authorize multiple proposals. If multiple proposals are authorized, see 14.201-6 (s).\n(b) Information on delivery or performance requirements may be of assistance to bidders in determining whether or not to submit a proposal and may be included in the request. The request shall also indicate that the information is not binding on the Government and that the actual delivery or performance requirements will be contained in the invitation issued under step two.\n(c) Upon receipt, the contracting officer shall  \n(1) Safeguard proposals against disclosure to unauthorized persons;\n(2) Accept and handle data marked in accordance with 15.609 as provided in that section; and\n(3) Remove any reference to price or cost.\n(d) The contracting officer shall establish a time period for evaluating technical proposals. The period may vary with the complexity and number of proposals involved. However, the evaluation should be completed quickly.\n(e)(1) Evaluations shall be based on the criteria in the request for proposals but not consideration of responsibility as defined in 9.1, Proposals, shall be categorized as  \n(i) Acceptable;\n(ii) Reasonably susceptible of being made acceptable; or\n(iii) Unacceptable.\n(2) Any proposal which modifies, or fails to conform to the essential requirements or specifications of, the request for technical proposals shall be considered nonresponsive and categorized as unacceptable.\n(f)(1) The contracting officer may proceed directly with step two if there are sufficient acceptable proposals to ensure adequate price competition under step two, and if further time, effort and delay to make additional proposals acceptable and thereby increase competition would not be in the Government  s interest. If this is not the case, the contracting officer shall request bidders whose proposals may be made acceptable to submit additional clarifying or supplementing information. The contracting office shall identify the nature of the deficiencies in the proposal or the nature of the additional information required. The contracting officer may also arrange discussions for this purpose. No proposal shall be discussed with any offeror other than the submitter.\n(2) In initiating requests for additional information, the contracting officer shall fix an appropriate time for bidders to conclude discussions, if any, submit all additional information, and incorporate such additional information as part of their proposals submitted. Such time may be extended in the discretion of the contracting officer. If the additional information incorporated as part of a proposal within the final time fixed by the contracting officer establishes that the proposal is acceptable, it shall be so categorized. Otherwise, it shall be categorized as unacceptable.\n(g) When a technical proposal is found unacceptable (either initially or after clarification), the contracting officer shall promptly notify the offeror of the basis of the determination and that a revision of the proposal will not be considered. Upon written request, the contracting officer shall debrief unsuccessful offerors (see 15.505 and 15.506 ).\n(h) Late technical proposals are governed by 15.208 (b), (c), and (f).\n(i) If it is necessary to discontinue two-step sealed bidding, the contracting officer shall include a statement of the facts and circumstances in the contract file. Each offeror shall be notified in writing. When step one results in no acceptable technical proposal or only one acceptable technical proposal, the acquisition may be continued by negotiation.\n14.503-2 Step two.\n(a) Sealed bidding procedures shall be followed except that invitations for bids shall  \n(1) Be issued only to those offerors submitting acceptable technical proposals in step one;\n(2) Include the provision prescribed in 14.201-6 (t);\n(3) Prominently state that the bidder shall comply with the specifications and the bidder  s technical proposal; and\n(4) Not be synopsized through the Governmentwide point of entry (GPE) as an acquisition opportunity nor publicly posted (see 5.101 (a)).\n(b) The names of firms that submitted acceptable proposals in step one will be listed through the GPE for the benefit of prospective subcontractors (see 5.207 ).\n*    *    *    *    *    *");
register_book(&s, "|15|2|", "Solicitation and Receipt of Proposals a", "Subpart 15.2  Solicitation and Receipt of Proposals and Information\n15.200 Scope of subpart.\nThis subpart prescribes policies and procedures for  \n(a) Exchanging information with industry prior to receipt of proposals;\n(b) Preparing and issuing requests for proposals (RFPs) and requests for information (RFIs); and\n(c) Receiving proposals and information.\n15.201 Exchanges with industry before receipt of proposals.\n(a) Exchanges of information among all interested parties, from the earliest identification of a requirement through receipt of proposals, are encouraged. Any exchange of information must be consistent with procurement integrity requirements (see 3.104 ). Interested parties include potential offerors, end users, Government acquisition and supporting personnel, and others involved in the conduct or outcome of the acquisition.\n(b) The purpose of exchanging information is to improve the understanding of Government requirements and industry capabilities, thereby allowing potential offerors to judge whether or how they can satisfy the Government  s requirements, and enhancing the Government  s ability to obtain quality supplies and services, including construction, at reasonable prices, and increase efficiency in proposal preparation, proposal evaluation, negotiation, and contract award.\n(c) Agencies are encouraged to promote early exchanges of information about future acquisitions. An early exchange of information among industry and the program manager, contracting officer, and other participants in the acquisition process can identify and resolve concerns regarding the acquisition strategy, including proposed contract type, terms and conditions, and acquisition planning schedules; the feasibility of the requirement, including performance requirements, statements of work, and data requirements; the suitability of the proposal instructions and evaluation criteria, including the approach for assessing past performance information; the availability of reference documents; and any other industry concerns or questions. Some techniques to promote early exchanges of information are  \n(1) Industry or small business conferences;\n(2) Public hearings;\n(3) Market research, as described in Part 10 ;\n(4) One-on-one meetings with potential offerors (any that are substantially involved with potential contract terms and conditions should include the contracting officer; also see paragraph (f) of this section regarding restrictions on disclosure of information);\n(5) Presolicitation notices;\n(6) Draft RFPs;\n(7) RFIs;\n(8) Presolicitation or preproposal conferences; and\n(9) Site visits.\n(d) The special notices of procurement matters at 5.205 (c), or electronic notices, may be used to publicize the Government  s requirement or solicit information from industry.\n(e) RFIs may be used when the Government does not presently intend to award a contract, but wants to obtain price, delivery, other market information, or capabilities for planning purposes. Responses to these notices are not offers and cannot be accepted by the Government to form a binding contract. There is no required format for RFIs.\n(f) General information about agency mission needs and future requirements may be disclosed at any time. After release of the solicitation, the contracting officer must be the focal point of any exchange with potential offerors. When specific information about a proposed acquisition that would be necessary for the preparation of proposals is disclosed to one or more potential offerors, that information must be made available to the public as soon as practicable, but no later than the next general release of information, in order to avoid creating an unfair competitive advantage. Information provided to a potential offeror in response to its request must not be disclosed if doing so would reveal the potential offeror  s confidential business strategy, and is protected under 3.104 or Subpart 24.2 . When conducting a presolicitation or preproposal conference, materials distributed at the conference should be made available to all potential offerors, upon request.\n15.202 Advisory multi-step process.\n(a) The agency may publish a presolicitation notice (see 5.204 ) that provides a general description of the scope or purpose of the acquisition and invites potential offerors to submit information that allows the Government to advise the offerors about their potential to be viable competitors. The presolicitation notice should identify the information that must be submitted and the criteria that will be used in making the initial evaluation. Information sought may be limited to a statement of qualifications and other appropriate information ( e.g., proposed technical concept, past performance, and limited pricing information). At a minimum, the notice shall contain sufficient information to permit a potential offeror to make an informed decision about whether to participate in the acquisition. This process should not be used for multi-step acquisitions where it would result in offerors being required to submit identical information in response to the notice and in response to the initial step of the acquisition.\n(b) The agency shall evaluate all responses in accordance with the criteria stated in the notice, and shall advise each respondent in writing either that it will be invited to participate in the resultant acquisition or, based on the information submitted, that it is unlikely to be a viable competitor. The agency shall advise respondents considered not to be viable competitors of the general basis for that opinion. The agency shall inform all respondents that, notwithstanding the advice provided by the Government in response to their submissions, they may participate in the resultant acquisition.\n15.203 Requests for proposals.\n(a) Requests for proposals (RFPs) are used in negotiated acquisitions to communicate Government requirements to prospective contractors and to solicit proposals. RFPs for competitive acquisitions shall, at a minimum, describe the  \n(1) Government  s requirement;\n(2) Anticipated terms and conditions that will apply to the contract:\n(i) The solicitation may authorize offerors to propose alternative terms and conditions, including the contract line item number (CLIN) structure; and\n(ii) When alternative CLIN structures are permitted, the evaluation approach should consider the potential impact on other terms and conditions or the requirement ( e.g., place of performance or payment and funding requirements) (see 15.206 );\n(3) Information required to be in the offeror  s proposal; and\n(4) Factors and significant subfactors that will be used to evaluate the proposal and their relative importance.\n(b) An RFP may be issued for OMB Circular A-76 studies. See Subpart 7.3 for additional information regarding cost comparisons between Government and contractor performance.\n(c) Electronic commerce may be used to issue RFPs and to receive proposals, modifications, and revisions. In this case, the RFP shall specify the electronic commerce method(s) that offerors may use (see Subpart 4.5 ).\n(d) Contracting officers may issue RFPs and/or authorize receipt of proposals, modifications, or revisions by facsimile.\n(1) In deciding whether or not to use facsimiles, the contracting officer should consider factors such as  \n(i) Anticipated proposal size and volume;\n(ii) Urgency of the requirement;\n(iii) Availability and suitability of electronic commerce methods; and\n(iv) Adequacy of administrative procedures and controls for receiving, identifying, recording, and safeguarding facsimile proposals, and ensuring their timely delivery to the designated proposal delivery location.\n(2) If facsimile proposals are authorized, contracting officers may request offeror(s) to provide the complete, original signed proposal at a later date.\n(e) Letter RFPs may be used in sole source acquisitions and other appropriate circumstances. Use of a letter RFP does not relieve the contracting officer from complying with other FAR requirements. Letter RFPs should be as complete as possible and, at a minimum, should contain the following:\n(1) RFP number and date;\n(2) Name, address (including electronic address and facsimile address, if appropriate), and telephone number of the contracting officer;\n(3) Type of contract contemplated;\n(4) Quantity, description, and required delivery dates for the item;\n(5) Applicable certifications and representations;\n(6) Anticipated contract terms and conditions;\n(7) Instructions to offerors and evaluation criteria for other than sole source actions;\n(8) Proposal due date and time; and\n(9) Other relevant information; e.g., incentives, variations in delivery schedule, cost proposal support, and data requirements.\n(f) Oral RFPs are authorized when processing a written solicitation would delay the acquisition of supplies or services to the detriment of the Government and a notice is not required under 5.202 ( e.g., perishable items and support of contingency operations or other emergency situations). Use of an oral RFP does not relieve the contracting officer from complying with other FAR requirements.\n(1) The contract files supporting oral solicitations should include  \n(i) A description of the requirement;\n(ii) Rationale for use of an oral solicitation;\n(iii) Sources solicited, including the date, time, name of individuals contacted, and prices offered; and\n(iv) The solicitation number provided to the prospective offerors.\n(2) The information furnished to potential offerors under oral solicitations should include appropriate items from paragraph (e) of this section.\n15.204 Contract format.\nThe use of a uniform contract format facilitates preparation of the solicitation and contract as well as reference to, and use of, those documents by offerors, contractors, and contract administrators. The uniform contract format need not be used for the following:\n(a) Construction and architect-engineer contracts (see Part 36 ).\n(b) Subsistence contracts.\n(c) Supplies or services contracts requiring special contract formats prescribed elsewhere in this regulation that are inconsistent with the uniform format.\n(d) Letter requests for proposals (see 15.203 (e)).\n(e) Contracts exempted by the agency head or designee.\n15.204-1 Uniform contract format.\n(a) Contracting officers shall prepare solicitations and resulting contracts using the uniform contract format outlined in Table 15-1 of this subsection.\n(b) Solicitations using the uniform contract format shall include Parts I, II, III, and IV (see 15.204-2 through 15.204-5 ). Upon award, contracting officers shall not physically include Part IV in the resulting contract, but shall retain it in the contract file. (See 4.1201 (c).) Section K shall be incorporated by reference in the contract.\nTable 15-1  Uniform Contract Format\nSection\nTitle\nPart I  The Schedule\nA\nSolicitation/contract form\nB\nSupplies or services and prices/costs\nC\nDescription/specifications/statement of work\nD\nPackaging and marking\nE\nInspection and acceptance\nF\nDeliveries or performance\nG\nContract administration data\nH\nSpecial contract requirements\nPart II  Contract Clauses\nI\nContract clauses\nPart III  List of Documents, Exhibits, and Other Attachments\nJ\nList of attachments\nPart IV  Representations and Instructions\nK\nRepresentations, certifications, and other statements of offerors or respondents\nL\nInstructions, conditions, and notices to offerors or respondents\nM\nEvaluation factors for award\n15.204-2 Part I  The Schedule.\nThe contracting officer shall prepare the contract Schedule as follows:\n(a) Section A, Solicitation/contract form.\n(1) Optional Form (OF) 308 , Solicitation and Offer  Negotiated Acquisition, or Standard Form (SF) 33 , Solicitation, Offer and Award, may be used to prepare RFPs.\n(2) When other than OF 308 or SF 33 is used, include the following information on the first page of the solicitation:\n(i) Name, address, and location of issuing activity, including room and building where proposals or information must be submitted.\n(ii) Solicitation number.\n(iii) Date of issuance.\n(iv) Closing date and time.\n(v) Number of pages.\n(vi) Requisition or other purchase authority.\n(vii) Brief description of item or service.\n(viii) Requirement for the offeror to provide its name and complete address, including street, city, county, state, and ZIP code, and electronic address (including facsimile address), if appropriate.\n(ix) Offer expiration date.\n(b) Section B, Supplies or services and prices/costs . Include a brief description of the supplies or services; e.g., item number, national stock number/part number if applicable, nouns, nomenclature, and quantities. (This includes incidental deliverables such as manuals and reports.)\n(c) Section C, Description/specifications/statement of work . Include any description or specifications needed in addition to Section B (see Part 11 , Describing Agency Needs).\n(d) Section D, Packaging and marking . Provide packaging, packing, preservation, and marking requirements, if any.\n(e) Section E, Inspection and acceptance . Include inspection, acceptance, quality assurance, and reliability requirements (see Part 46 , Quality Assurance).\n(f) Section F, Deliveries or performance . Specify the requirements for time, place, and method of delivery or performance (see Subpart 11.4 , Delivery or Performance Schedules, and 47.301-1 ).\n(g) Section G, Contract administration data . Include any required accounting and appropriation data and any required contract administration information or instructions other than those on the solicitation form. Include a statement that the offeror should include the payment address in the proposal, if it is different from that shown for the offeror.\n(h) Section H, Special contract requirements . Include a clear statement of any special contract requirements that are not included in Section I, Contract clauses, or in other sections of the uniform contract format.\n15.204-3 Part II  Contract Clauses.\nSection I, Contract clauses. The contracting officer shall include in this section the clauses required by law or by this regulation and any additional clauses expected to be included in any resulting contract, if these clauses are not required in any other section of the uniform contract format. An index may be inserted if this section  s format is particularly complex.\n15.204-4 Part III  List of Documents, Exhibits, and Other Attachments.\nSection J, List of attachments . The contracting officer shall list the title, date, and number of pages for each attached document, exhibit, and other attachment. Cross-references to material in other sections may be inserted, as appropriate.\n15.204-5 Part IV  Representations and Instructions.\nThe contracting officer shall prepare the representations and instructions as follows:\n(a) Section K, Representations, certifications, and other statements of offerors. Include in this section those solicitation provisions that require representations, certifications, or the submission of other information by offerors.\n(b) Section L, Instructions, conditions, and notices to offerors or respondents. Insert in this section solicitation provisions and other information and instructions not required elsewhere to guide offerors or respondents in preparing proposals or responses to requests for information. Prospective offerors or respondents may be instructed to submit proposals or information in a specific format or severable parts to facilitate evaluation. The instructions may specify further organization of proposal or response parts, such as  \n(1) Administrative;\n(2) Management;\n(3) Technical;\n(4) Past performance; and\n(5) Certified cost or pricing data (see Table 15-2 of 15.408 ) or data other than certified cost or pricing data.\n(c) Section M, Evaluation factors for award . Identify all significant factors and any significant subfactors that will be considered in awarding the contract and their relative importance (see 15.304 (d)). The contracting officer shall insert one of the phrases in 15.304 (e).\n15.205 Issuing solicitations.\n(a) The contracting officer shall issue solicitations to potential sources in accordance with the policies and procedures in 5.102 , 19.202-4 , and Part 6 .\n(b) A master solicitation, as described in 14.203-3 , may also be used for negotiated acquisitions.\n15.206 Amending the solicitation.\n(a) When, either before or after receipt of proposals, the Government changes its requirements or terms and conditions, the contracting officer shall amend the solicitation.\n(b) Amendments issued before the established time and date for receipt of proposals shall be issued to all parties receiving the solicitation.\n(c) Amendments issued after the established time and date for receipt of proposals shall be issued to all offerors that have not been eliminated from the competition.\n(d) If a proposal of interest to the Government involves a departure from the stated requirements, the contracting officer shall amend the solicitation, provided this can be done without revealing to the other offerors the alternate solution proposed or any other information that is entitled to protection (see 15.207 (b) and 15.306 (e)).\n(e) If, in the judgment of the contracting officer, based on market research or otherwise, an amendment proposed for issuance after offers have been received is so substantial as to exceed what prospective offerors reasonably could have anticipated, so that additional sources likely would have submitted offers had the substance of the amendment been known to them, the contracting officer shall cancel the original solicitation and issue a new one, regardless of the stage of the acquisition.\n(f) Oral notices may be used when time is of the essence. The contracting officer shall document the contract file and formalize the notice with an amendment (see Subpart 4.5 , Electronic Commerce in Contracting).\n(g) At a minimum, the following information should be included in each amendment:\n(1) Name and address of issuing activity.\n(2) Solicitation number and date.\n(3) Amendment number and date.\n(4) Number of pages.\n(5) Description of the change being made.\n(6) Government point of contact and phone number (and electronic or facsimile address, if appropriate).\n(7) Revision to solicitation closing date, if applicable.\n15.207 Handling proposals and information.\n(a) Upon receipt at the location specified in the solicitation, proposals and information received in response to a request for information (RFI) shall be marked with the date and time of receipt and shall be transmitted to the designated officials.\n(b) Proposals shall be safeguarded from unauthorized disclosure throughout the source selection process. (See 3.104 regarding the disclosure of source selection information ( 41 U.S.C. 423 )). Information received in response to an RFI shall be safeguarded adequately from unauthorized disclosure.\n(c) If any portion of a proposal received by the contracting officer electronically or by facsimile is unreadable, the contracting officer immediately shall notify the offeror and permit the offeror to resubmit the unreadable portion of the proposal. The method and time for resubmission shall be prescribed by the contracting officer after consultation with the offeror, and documented in the file. The resubmission shall be considered as if it were received at the date and time of the original unreadable submission for the purpose of determining timeliness under 15.208 (a), provided the offeror complies with the time and format requirements for resubmission prescribed by the contracting officer.\n15.208 Submission, modification, revision, and withdrawal of proposals.\n(a) Offerors are responsible for submitting proposals, and any revisions, and modifications, so as to reach the Government office designated in the solicitation by the time specified in the solicitation. Offerors may use any transmission method authorized by the solicitation ( i.e., regular mail, electronic commerce, or facsimile). If no time is specified in the solicitation, the time for receipt is 4:30 p.m., local time, for the designated Government office on the date that proposals are due.\n(b)(1) Any proposal, modification, or revision, that is received at the designated Government office after the exact time specified for receipt of proposals is  late  and will not be considered unless it is received before award is made, the contracting officer determines that accepting the late proposal would not unduly delay the acquisition; and  \n(i) If it was transmitted through an electronic commerce method authorized by the solicitation, it was received at the initial point of entry to the Government infrastructure not later than 5:00 p.m. one working day prior to the date specified for receipt of proposals; or\n(ii) There is acceptable evidence to establish that it was received at the Government installation designated for receipt of proposals and was under the Government  s control prior to the time set for receipt of proposals; or\n(iii) It was the only proposal received.\n(2) However, a late modification of an otherwise successful proposal, that makes its terms more favorable to the Government, will be considered at any time it is received and may be accepted.\n(c) Acceptable evidence to establish the time of receipt at the Government installation includes the time/date stamp of that installation on the proposal wrapper, other documentary evidence of receipt maintained by the installation, or oral testimony or statements of Government personnel.\n(d) If an emergency or unanticipated event interrupts normal Government processes so that proposals cannot be received at the Government office designated for receipt of proposals by the exact time specified in the solicitation, and urgent Government requirements preclude amendment of the solicitation closing date, the time specified for receipt of proposals will be deemed to be extended to the same time of day specified in the solicitation on the first work day on which normal Government processes resume.\n(e) Proposals may be withdrawn by written notice at any time before award. Oral proposals in response to oral solicitations may be withdrawn orally. The contracting officer must document the contract file when oral withdrawals are made. One copy of withdrawn proposals should be retained in the contract file (see 4.803 (a)(10)). Extra copies of the withdrawn proposals may be destroyed or returned to the offeror at the offeror  s request. Where practicable, electronically transmitted proposals that are withdrawn must be purged from primary and backup data storage systems after a copy is made for the file. Extremely bulky proposals must only be returned at the offeror  s request and expense.\n(f) The contracting officer must promptly notify any offeror if its proposal, modification, or revision was received late, and must inform the offeror whether its proposal will be considered, unless contract award is imminent and the notice prescribed in 15.503 (b) would suffice.\n(g) Late proposals and modifications that are not considered must be held unopened, unless opened for identification, until after award and then retained with other unsuccessful proposals.\n(h) If available, the following must be included in the contracting office files for each late proposal, modification, revision, or withdrawal:\n(1) The date and hour of receipt.\n(2) A statement regarding whether the proposal was considered for award, with supporting rationale.\n(3) The envelope, wrapper, or other evidence of date of receipt.\n15.209 Solicitation provisions and contract clauses.\nWhen contracting by negotiation  \n(a) The contracting officer shall insert the provision at 52.215-1 , Instructions to Offerors  Competitive Acquisition, in all competitive solicitations where the Government intends to award a contract without discussions.\n(1) If the Government intends to make award after discussions with offerors within the competitive range, the contracting officer shall use the basic provision with its Alternate I.\n(2) If the Government would be willing to accept alternate proposals, the contracting officer shall alter the basic clause to add a new paragraph (c)(9) substantially the same as Alternate II.\n(b)(1) Except as provided in paragraph (b)(2) of this section, the contracting officer shall insert the clause at 52.215-2 , Audit and Records  Negotiation ( 10 U.S.C. 2313 , 41 U.S.C. 254d , and OMB Circular No. A-133), in solicitations and contracts except those for  \n(i) Acquisitions not exceeding the simplified acquisition threshold;\n(ii) The acquisition of utility services at rates not exceeding those established to apply uniformly to the general public, plus any applicable reasonable connection charge; or\n(iii) The acquisition of commercial items exempted under 15.403-1 .\n(2)(i) When using funds appropriated or otherwise made available by the American Recovery and Reinvestment Act of 2009 (Pub. L. 111-5)  \n(A) The exceptions in paragraphs (b)(1)(i) through (b)(1)(iii) are not applicable; and\n(B) Use the clause with its Alternate I.\n(ii)(A) In the case of a bilateral contract modification that will use funds appropriated or otherwise made available by the American Recovery and Reinvestment Act of 2009, the contracting officer shall specify applicability of Alternate I to that modification.\n(B) In the case of a task- or delivery-order contract in which not all orders will use funds appropriated or otherwise made available by the American Recovery and Reinvestment Act of 2009, the contracting officer shall specify the task or delivery orders to which Alternate I applies.\n(3) For cost-reimbursement contracts with State and local Governments, educational institutions, and other nonprofit organizations, the contracting officer shall use the clause with its Alternate II.\n(4) When the head of the agency has waived the examination of records by the Comptroller General in accordance with 25.1001 , use the clause with its Alternate III.\n(c) When issuing a solicitation for information or planning purposes, the contracting officer shall insert the provision at 52.215-3 , Request for Information or Solicitation for Planning Purposes, and clearly mark on the face of the solicitation that it is for information or planning purposes.\n(d) [Reserved]\n(e) The contracting officer shall insert the provision at 52.215-5 , Facsimile Proposals, in solicitations if facsimile proposals are authorized (see 15.203 (d)).\n(f) The contracting officer shall insert the provision at 52.215-6 , Place of Performance, in solicitations unless the place of performance is specified by the Government.\n(g) [Reserved]\n(h) The contracting officer shall insert the clause at 52.215-8 , Order of Precedence  Uniform Contract Format, in solicitations and contracts using the format at 15.204 .\n15.210 Forms.\nPrescribed forms are not required to prepare solicitations described in this part. The following forms may be used at the discretion of the contracting officer:\n(a) Standard Form 33 , Solicitation, Offer and Award, and Optional Form 308 , Solicitation and Offer  Negotiated Acquisition, may be used to issue RFPs and RFIs.\n(b) Standard Form 30 , Amendment of Solicitation/ Modification of Contract, and Optional Form 309 , Amendment of Solicitation, may be used to amend solicitations of negotiated contracts.\n(c) Optional Form 17 , Offer Label, may be furnished with each request for proposal.");
register_book(&s, "|15|3|", "Source Selection", "Subpart 15.3  Source Selection\n15.300 Scope of subpart.\nThis subpart prescribes policies and procedures for selection of a source or sources in competitive negotiated acquisitions.\n15.301 [Reserved]\n15.302 Source selection objective.\nThe objective of source selection is to select the proposal that represents the best value.\n15.303 Responsibilities.\n(a) Agency heads are responsible for source selection. The contracting officer is designated as the source selection authority, unless the agency head appoints another individual for a particular acquisition or group of acquisitions.\n(b) The source selection authority shall  \n(1) Establish an evaluation team, tailored for the particular acquisition, that includes appropriate contracting, legal, logistics, technical, and other expertise to ensure a comprehensive evaluation of offers;\n(2) Approve the source selection strategy or acquisition plan, if applicable, before solicitation release;\n(3) Ensure consistency among the solicitation requirements, notices to offerors, proposal preparation instructions, evaluation factors and subfactors, solicitation provisions or contract clauses, and data requirements;\n(4) Ensure that proposals are evaluated based solely on the factors and subfactors contained in the solicitation ( 10 U.S.C. 2305(b)(1) and 41 U.S.C. 253b(d)(3) );\n(5) Consider the recommendations of advisory boards or panels (if any); and\n(6) Select the source or sources whose proposal is the best value to the Government ( 10 U.S.C. 2305(b)(4)(B) and 41 U.S.C. 253b(d)(3) ).\n(c) The contracting officer shall  \n(1) After release of a solicitation, serve as the focal point for inquiries from actual or prospective offerors;\n(2) After receipt of proposals, control exchanges with offerors in accordance with 15.306 ; and\n(3) Award the contract(s).\n15.304 Evaluation factors and significant subfactors.\n(a) The award decision is based on evaluation factors and significant subfactors that are tailored to the acquisition.\n(b) Evaluation factors and significant subfactors must  \n(1) Represent the key areas of importance and emphasis to be considered in the source selection decision; and\n(2) Support meaningful comparison and discrimination between and among competing proposals.\n(c) The evaluation factors and significant subfactors that apply to an acquisition and their relative importance, are within the broad discretion of agency acquisition officials, subject to the following requirements:\n(1) Price or cost to the Government shall be evaluated in every source selection ( 10 U.S.C. 2305(a)(3)(A)(ii) and 41 U.S.C. 253a(c)(1)(B) ) (also see Part 36 for architect-engineer contracts);\n(2) The quality of the product or service shall be addressed in every source selection through consideration of one or more non-cost evaluation factors such as past performance, compliance with solicitation requirements, technical excellence, management capability, personnel qualifications, and prior experience ( 10 U.S.C. 2305(a)(3)(A)(i) and 41 U.S.C. 253a(c)(1)(A) ); and\n(3)(i) Except as set forth in paragraph (c)(3)(iii) of this section, past performance shall be evaluated in all source selections for negotiated competitive acquisitions expected to exceed the simplified acquisition threshold.\n(ii) For solicitations involving bundling that offer a significant opportunity for subcontracting, the contracting officer must include a factor to evaluate past performance indicating the extent to which the offeror attained applicable goals for small business participation under contracts that required subcontracting plans ( 15 U.S.C. 637(d)(4)(G)(ii) ).\n(iii) Past performance need not be evaluated if the contracting officer documents the reason past performance is not an appropriate evaluation factor for the acquisition.\n(4) The extent of participation of small disadvantaged business concerns in performance of the contract shall be evaluated in unrestricted acquisitions expected to exceed $650,000 ($1.5 million for construction) subject to certain limitations (see 19.201 and 19.1202 ).\n(5) For solicitations involving bundling that offer a significant opportunity for subcontracting, the contracting officer must include proposed small business subcontracting participation in the subcontracting plan as an evaluation factor ( 15 U.S.C. 637(d)(4)(G)(i) ).\n(6) If telecommuting is not prohibited, agencies shall not unfavorably evaluate an offer that includes telecommuting unless the contracting officer executes a written determination in accordance with FAR 7.108 (b).\n(d) All factors and significant subfactors that will affect contract award and their relative importance shall be stated clearly in the solicitation ( 10 U.S.C. 2305(a)(2)(A)(i) and 41 U.S.C. 253a(b)(1)(A) ) (see 15.204-5 (c)). The rating method need not be disclosed in the solicitation. The general approach for evaluating past performance information shall be described.\n(e) The solicitation shall also state, at a minimum, whether all evaluation factors other than cost or price, when combined, are  \n(1) Significantly more important than cost or price;\n(2) Approximately equal to cost or price; or\n(3) Significantly less important than cost or price ( 10 U.S.C. 2305(a)(3)(A)(iii) and 41 U.S.C. 253a(c)(1)(C) ).\n15.305 Proposal evaluation.\n(a) Proposal evaluation is an assessment of the proposal and the offeror  s ability to perform the prospective contract successfully. An agency shall evaluate competitive proposals and then assess their relative qualities solely on the factors and subfactors specified in the solicitation. Evaluations may be conducted using any rating method or combination of methods, including color or adjectival ratings, numerical weights, and ordinal rankings. The relative strengths, deficiencies, significant weaknesses, and risks supporting proposal evaluation shall be documented in the contract file.\n(1) Cost or price evaluation . Normally, competition establishes price reasonableness. Therefore, when contracting on a firm-fixed-price or fixed-price with economic price adjustment basis, comparison of the proposed prices will usually satisfy the requirement to perform a price analysis, and a cost analysis need not be performed. In limited situations, a cost analysis (see 15.403-1 (c)(1)(i)(B)) may be appropriate to establish reasonableness of the otherwise successful offeror  s price. When contracting on a cost-reimbursement basis, evaluations shall include a cost realism analysis to determine what the Government should realistically expect to pay for the proposed effort, the offeror  s understanding of the work, and the offeror  s ability to perform the contract. (See 37.115 for uncompensated overtime evaluation.) The contracting officer shall document the cost or price evaluation.\n(2) Past performance evaluation.\n(i) Past performance information is one indicator of an offeror  s ability to perform the contract successfully. The currency and relevance of the information, source of the information, context of the data, and general trends in contractor  s performance shall be considered. This comparative assessment of past performance information is separate from the responsibility determination required under Subpart 9.1 .\n(ii) The solicitation shall describe the approach for evaluating past performance, including evaluating offerors with no relevant performance history, and shall provide offerors an opportunity to identify past or current contracts (including Federal, State, and local government and private) for efforts similar to the Government requirement. The solicitation shall also authorize offerors to provide information on problems encountered on the identified contracts and the offeror  s corrective actions. The Government shall consider this information, as well as information obtained from any other sources, when evaluating the offeror  s past performance. The source selection authority shall determine the relevance of similar past performance information.\n(iii) The evaluation should take into account past performance information regarding predecessor companies, key personnel who have relevant experience, or subcontractors that will perform major or critical aspects of the requirement when such information is relevant to the instant acquisition.\n(iv) In the case of an offeror without a record of relevant past performance or for whom information on past performance is not available, the offeror may not be evaluated favorably or unfavorably on past performance.\n(v) The evaluation should include the past performance of offerors in complying with subcontracting plan goals for small disadvantaged business (SDB) concerns (see Subpart 19.7 ), monetary targets for SDB participation (see 19.1202 ), and notifications submitted under 19.1202-4 (b).\n(3) Technical evaluation . When tradeoffs are performed (see 15.101-1 ), the source selection records shall include  \n(i) An assessment of each offeror  s ability to accomplish the technical requirements; and\n(ii) A summary, matrix, or quantitative ranking, along with appropriate supporting narrative, of each technical proposal using the evaluation factors.\n(4) Cost information. Cost information may be provided to members of the technical evaluation team in accordance with agency procedures.\n(5) S mall business subcontracting evaluation. Solicitations must be structured to give offers from small business concerns the highest rating for the evaluation factors in 15.304 (c)(3)(ii) and (c)(5).\n(b) The source selection authority may reject all proposals received in response to a solicitation, if doing so is in the best interest of the Government.\n(c) For restrictions on the use of support contractor personnel in proposal evaluation, see 37.203 (d).\n15.306 Exchanges with offerors after receipt of proposals.\n(a) Clarifications and award without discussions.\n(1) Clarifications are limited exchanges, between the Government and offerors, that may occur when award without discussions is contemplated.\n(2) If award will be made without conducting discussions, offerors may be given the opportunity to clarify certain aspects of proposals ( e.g., the relevance of an offeror  s past performance information and adverse past performance information to which the offeror has not previously had an opportunity to respond) or to resolve minor or clerical errors.\n(3) Award may be made without discussions if the solicitation states that the Government intends to evaluate propos-\nals and make award without discussions. If the solicitation contains such a notice and the Government determines it is necessary to conduct discussions, the rationale for doing so shall be documented in the contract file (see the provision at 52.215-1 ) ( 10 U.S.C. 2305(b)(4)(A)(ii) and 41 U.S.C. 253b(d)(1)(B) ).\n(b) Communications with offerors before establishment of the competitive range . Communications are exchanges, between the Government and offerors, after receipt of proposals, leading to establishment of the competitive range. If a competitive range is to be established, these communications  \n(1) Shall be limited to the offerors described in paragraphs (b)(1)(i) and (b)(1)(ii) of this section and  \n(i) Shall be held with offerors whose past performance information is the determining factor preventing them from being placed within the competitive range. Such communications shall address adverse past performance information to which an offeror has not had a prior opportunity to respond; and\n(ii) May only be held with those offerors (other than offerors under paragraph (b)(1)(i) of this section) whose exclusion from, or inclusion in, the competitive range is uncertain;\n(2) May be conducted to enhance Government understanding of proposals; allow reasonable interpretation of the proposal; or facilitate the Government  s evaluation process. Such communications shall not be used to cure proposal deficiencies or material omissions, materially alter the technical or cost elements of the proposal, and/or otherwise revise the proposal. Such communications may be considered in rating proposals for the purpose of establishing the competitive range;\n(3) Are for the purpose of addressing issues that must be explored to determine whether a proposal should be placed in the competitive range. Such communications shall not provide an opportunity for the offeror to revise its proposal, but may address  \n(i) Ambiguities in the proposal or other concerns ( e.g., perceived deficiencies, weaknesses, errors, omissions, or mistakes (see 14.407 )); and\n(ii) Information relating to relevant past performance; and\n(4) Shall address adverse past performance information to which the offeror has not previously had an opportunity to comment.\n(c) Competitive range.\n(1) Agencies shall evaluate all proposals in accordance with 15.305 (a), and, if discussions are to be conducted, establish the competitive range. Based on the ratings of each proposal against all evaluation criteria, the contracting officer shall establish a competitive range comprised of all of the most highly rated proposals, unless the range is further reduced for purposes of efficiency pursuant to paragraph (c)(2) of this section.\n(2) After evaluating all proposals in accordance with 15.305 (a) and paragraph (c)(1) of this section, the contracting officer may determine that the number of most highly rated proposals that might otherwise be included in the competitive range exceeds the number at which an efficient competition can be conducted. Provided the solicitation notifies offerors that the competitive range can be limited for purposes of efficiency (see 52.215-1 (f)(4)), the contracting officer may limit the number of proposals in the competitive range to the greatest number that will permit an efficient competition among the most highly rated proposals ( 10 U.S.C. 2305(b)(4) and 41 U.S.C. 253b(d) ).\n(3) If the contracting officer, after complying with paragraph (d)(3) of this section, decides that an offeror  s proposal should no longer be included in the competitive range, the proposal shall be eliminated from consideration for award. Written notice of this decision shall be provided to unsuccessful offerors in accordance with 15.503 .\n(4) Offerors excluded or otherwise eliminated from the competitive range may request a debriefing (see 15.505 and 15.506 ).\n(d) Exchanges with offerors after establishment of the competitive range . Negotiations are exchanges, in either a competitive or sole source environment, between the Government and offerors, that are undertaken with the intent of allowing the offeror to revise its proposal. These negotiations may include bargaining. Bargaining includes persuasion, alteration of assumptions and positions, give-and-take, and may apply to price, schedule, technical requirements, type of contract, or other terms of a proposed contract. When negotiations are conducted in a competitive acquisition, they take place after establishment of the competitive range and are called discussions.\n(1) Discussions are tailored to each offeror  s proposal, and must be conducted by the contracting officer with each offeror within the competitive range.\n(2) The primary objective of discussions is to maximize the Government  s ability to obtain best value, based on the requirement and the evaluation factors set forth in the solicitation.\n(3) At a minimum, the contracting officer must, subject to paragraphs (d)(5) and (e) of this section and 15.307 (a), indicate to, or discuss with, each offeror still being considered for award, deficiencies, significant weaknesses, and adverse past performance information to which the offeror has not yet had an opportunity to respond. The contracting officer also is encouraged to discuss other aspects of the offeror  s proposal that could, in the opinion of the contracting officer, be altered or explained to enhance materially the proposal  s potential for award. However, the contracting officer is not required to discuss every area where the proposal could be improved. The scope and extent of discussions are a matter of contracting officer judgment.\n(4) In discussing other aspects of the proposal, the Government may, in situations where the solicitation stated that evaluation credit would be given for technical solutions exceeding any mandatory minimums, negotiate with offerors for increased performance beyond any mandatory minimums, and the Government may suggest to offerors that have exceeded any mandatory minimums (in ways that are not integral to the design), that their proposals would be more competitive if the excesses were removed and the offered price decreased.\n(5) If, after discussions have begun, an offeror originally in the competitive range is no longer considered to be among the most highly rated offerors being considered for award, that offeror may be eliminated from the competitive range whether or not all material aspects of the proposal have been discussed, or whether or not the offeror has been afforded an opportunity to submit a proposal revision (see 15.307 (a) and 15.503 (a)(1)).\n(e) Limits on exchanges . Government personnel involved in the acquisition shall not engage in conduct that  \n(1) Favors one offeror over another;\n(2) Reveals an offeror  s technical solution, including unique technology, innovative and unique uses of commercial items, or any information that would compromise an offeror  s intellectual property to another offeror;\n(3) Reveals an offeror  s price without that offeror  s permission. However, the contracting officer may inform an offeror that its price is considered by the Government to be too high, or too low, and reveal the results of the analysis supporting that conclusion. It is also permissible, at the Government  s discretion, to indicate to all offerors the cost or price that the Government  s price analysis, market research, and other reviews have identified as reasonable ( 41 U.S.C. 423(h)(1)(2) );\n(4) Reveals the names of individuals providing reference information about an offeror  s past performance; or\n(5) Knowingly furnishes source selection information in violation of 3.104 and 41 U.S.C. 423(h)(1)(2) .\n15.307 Proposal revisions.\n(a) If an offeror  s proposal is eliminated or otherwise removed from the competitive range, no further revisions to that offeror  s proposal shall be accepted or considered.\n(b) The contracting officer may request or allow proposal revisions to clarify and document understandings reached during negotiations. At the conclusion of discussions, each offeror still in the competitive range shall be given an opportunity to submit a final proposal revision. The contracting officer is required to establish a common cut-off date only for receipt of final proposal revisions. Requests for final proposal revisions shall advise offerors that the final proposal revisions shall be in writing and that the Government intends to make award without obtaining further revisions.\n15.308 Source selection decision.\nThe source selection authority  s (SSA) decision shall be based on a comparative assessment of proposals against all source selection criteria in the solicitation. While the SSA may use reports and analyses prepared by others, the source selection decision shall represent the SSA  s independent judgment. The source selection decision shall be documented, and the documentation shall include the rationale for any business judgments and tradeoffs made or relied on by the SSA, including benefits associated with additional costs. Although the rationale for the selection decision must be documented, that documentation need not quantify the tradeoffs that led to the decision.");
register_book(&s, "|15|4|", "Contract Pricing", "Subpart 15.4  Contract Pricing\n15.400 Scope of subpart.\nThis subpart prescribes the cost and price negotiation policies and procedures for pricing negotiated prime contracts (including subcontracts) and contract modifications, including modifications to contracts awarded by sealed bidding.\n15.401 Definitions.\nAs used in this subpart  \nPrice  means cost plus any fee or profit applicable to the contract type.\nSubcontract  (except as used in 15.407-2 ) also includes a transfer of commercial items between divisions, subsidiaries, or affiliates of a contractor or a subcontractor ( 10 U.S.C. 2306a(h)(2) and 41 U.S.C. 254b(h)(2) ).\n15.402 Pricing policy.\nContracting officers shall  \n(a) Purchase supplies and services from responsible sources at fair and reasonable prices. In establishing the reasonableness of the offered prices, the contracting officer  \n(1) Shall obtain certified cost or pricing data when required by 15.403-4 , along with data other than certified cost or pricing data as necessary to establish a fair and reasonable price; or\n(2) When certified cost or pricing data are not required by 15.403-4 , shall obtain data other than certified cost or pricing data as necessary to establish a fair and reasonable price, generally using the following order of preference in determining the type of data required:\n(i) No additional data from the offeror, if the price is based on adequate price competition, except as provided by 15.403-3 (b).\n(ii) Data other than certified cost or pricing data such as  \n(A) Data related to prices ( e.g. , established catalog or market prices, sales to non-governmental and governmental entities), relying first on data available within the Government; second, on data obtained from sources other than the offeror; and, if necessary, on data obtained from the offeror. When obtaining data from the offeror is necessary, unless an exception under 15.403-1 (b)(1) or (2) applies, such data submitted by the offeror shall include, at a minimum, appropriate data on the prices at which the same or similar items have been sold previously, adequate for evaluating the reasonableness of the price.\n(B) Cost data to the extent necessary for the contracting officer to determine a fair and reasonable price.\n(3) Obtain the type and quantity of data necessary to establish a fair and reasonable price, but not more data than is necessary. Requesting unnecessary data can lead to increased proposal preparation costs, generally extend acquisition lead time, and consume additional contractor and Government resources. Use techniques such as, but not limited to, price analysis, cost analysis, and/or cost realism analysis to establish a fair and reasonable price. If a fair and reasonable price cannot be established by the contracting officer from the analyses of the data obtained or submitted to date, the contracting officer shall require the submission of additional data sufficient for the contracting officer to support the determination of the fair and reasonable price.\n(b) Price each contract separately and independently and not  \n(1) Use proposed price reductions under other contracts as an evaluation factor; or\n(2) Consider losses or profits realized or anticipated under other contracts.\n(c) Not include in a contract price any amount for a specified contingency to the extent that the contract provides for a price adjustment based upon the occurrence of that contingency.\n15.403 Obtaining certified cost or pricing data.\n15.403-1 Prohibition on obtaining certified cost or pricing data ( 10 U.S.C. 2306a and 41 U.S.C. 254b ).\n(a) Certified cost or pricing data shall not be obtained for acquisitions at or below the simplified acquisition threshold.\n(b) Exceptions to certified cost or pricing data requirements . The contracting officer shall not require certified cost or pricing data to support any action (contracts, subcontracts, or modifications) (but may require data other than certified cost or pricing data as defined in FAR 2.101 to support a determination of a fair and reasonable price or cost realism)  \n(1) When the contracting officer determines that prices agreed upon are based on adequate price competition (see standards in paragraph (c)(1) of this subsection);\n(2) When the contracting officer determines that prices agreed upon are based on prices set by law or regulation (see standards in paragraph (c)(2) of this subsection);\n(3) When a commercial item is being acquired (see standards in paragraph (c)(3) of this subsection);\n(4) When a waiver has been granted (see standards in paragraph (c)(4) of this subsection); or\n(5) When modifying a contract or subcontract for commercial items (see standards in paragraph (c)(3) of this sub section).\n(c) Standards for exceptions from certified cost or pricing data requirements  \n(1) Adequate price competition. A price is based on adequate price competition if  \n(i) Two or more responsible offerors, competing independently, submit priced offers that satisfy the Government  s expressed requirement and if  \n(A) Award will be made to the offeror whose proposal represents the best value (see 2.101 ) where price is a substantial factor in source selection; and\n(B) There is no finding that the price of the otherwise successful offeror is unreasonable. Any finding that the price is unreasonable must be supported by a statement of the facts and approved at a level above the contracting officer;\n(ii) There was a reasonable expectation, based on market research or other assessment, that two or more responsible offerors, competing independently, would submit priced offers in response to the solicitation  s expressed requirement, even though only one offer is received from a responsible offeror and if  \n(A) Based on the offer received, the contracting officer can reasonably conclude that the offer was submitted with the expectation of competition, e.g., circumstances indicate that  \n(1) The offeror believed that at least one other offeror was capable of submitting a meaningful offer; and\n(2) The offeror had no reason to believe that other potential offerors did not intend to submit an offer; and\n(B) The determination that the proposed price is based on adequate price competition and is reasonable has been approved at a level above the contracting officer; or\n(iii) Price analysis clearly demonstrates that the proposed price is reasonable in comparison with current or recent prices for the same or similar items, adjusted to reflect changes in market conditions, economic conditions, quantities, or terms and conditions under contracts that resulted from adequate price competition.\n(2) Prices set by law or regulation . Pronouncements in the form of periodic rulings, reviews, or similar actions of a governmental body, or embodied in the laws, are sufficient to set a price.\n(3) Commercial items.\n(i) Any acquisition of an item that the contracting officer determines meets the commercial item definition in 2.101 , or any modification, as defined in paragraph (3)(i) of that definition, that does not change the item from a commercial item to a noncommercial item, is exempt from the requirement for certified cost or pricing data. If the contracting officer determines that an item claimed to be commercial is, in fact, not commercial and that no other exception or waiver applies, ( e.g. the acquisition is not based on adequate price competition; the acquisition is not based on prices set by law or regulation; and the acquisition exceeds the threshold for the submission of certified cost or pricing data at 15.403-4 (a)(1)) the contracting officer shall require submission of certified cost or pricing data.\n(ii) In accordance with section 868 of Pub. L. 110-417:\n(A) When purchasing services that are not offered and sold competitively in substantial quantities in the commercial marketplace, but are of a type offered and sold competitively in substantial quantities in the commercial marketplace, they may be considered commercial items (thus meeting the purpose of 41 U.S.C. 254b and 10 U.S.C. 2306a for truth in negotiations) only if the contracting officer determines in writing that the offeror has submitted sufficient information to evaluate, through price analysis, the reasonableness of the price of such services.\n(B) In order to make this determination, the contracting officer may request the offeror to submit prices paid for the same or similar commercial items under comparable terms and conditions by both Government and commercial customers; and\n(C) If the contracting officer determines that the information described in paragraph (c)(3)(ii)(B) of this section is not sufficient to determine the reasonableness of price, other relevant information regarding the basis for price or cost, including information on labor costs, material costs and overhead rates may be requested.\n(iii) The following requirements apply to minor modifications defined in paragraph (3)(ii) of the definition of a commercial item at 2.101 that do not change the item from a commercial item to a noncommercial item:\n(A) For acquisitions funded by any agency other than DoD, NASA, or Coast Guard, such modifications of a commercial item are exempt from the requirement for submission of certified cost or pricing data.\n(B) For acquisitions funded by DoD, NASA, or Coast Guard, such modifications of a commercial item are exempt from the requirement for submission of certified cost or pricing data provided the total price of all such modifications under a particular contract action does not exceed the greater of the threshold for obtaining certified cost or pricing data in 15.403-4 or 5 percent of the total price of the contract at the time of contract award.\n(C) For acquisitions funded by DoD, NASA, or Coast Guard such modifications of a commercial item are not exempt from the requirement for submission of certified cost or pricing data on the basis of the exemption provided for at 15.403-1 (c)(3) if the total price of all such modifications under a particular contract action exceeds the greater of the threshold for obtaining certified cost or pricing data in 15.403-4 or 5 percent of the total price of the contract at the time of contract award.\n(iv) Any acquisition for noncommercial supplies or services treated as commercial items at 12.102 (f)(1), except sole source contracts greater than $17.5 million, is exempt from the requirements for certified cost or pricing data ( 41 U.S.C. 428a ).\n(4) Waivers . The head of the contracting activity (HCA) may, without power of delegation, waive the requirement for submission of certified cost or pricing data in exceptional cases. The authorization for the waiver and the supporting rationale shall be in writing. The HCA may consider waiving the requirement if the price can be determined to be fair and reasonable without submission of certified cost or pricing data. For example, if certified cost or pricing data were furnished on previous production buys and the contracting officer determines such data are sufficient, when combined with updated data, a waiver may be granted. If the HCA has waived the requirement for submission of certified cost or pricing data, the contractor or higher-tier subcontractor to whom the waiver relates shall be considered as having been required to provide certified cost or pricing data. Consequently, award of any lower-tier subcontract expected to exceed the certified cost or pricing data threshold requires the submission of certified cost or pricing data unless  \n(i) An exception otherwise applies to the subcontract; or\n(ii) The waiver specifically includes the subcontract and the rationale supporting the waiver for that subcontract.\n15.403-2 Other circumstances where certified cost or pricing data are not required.\n(a) The exercise of an option at the price established at contract award or initial negotiation does not require submission of certified cost or pricing data.\n(b) Certified cost or pricing data are not required for proposals used solely for overrun funding or interim billing price adjustments.\n15.403-3 Requiring data other than certified cost or pricing data.\n(a) \n(1) In those acquisitions that do not require certified cost or pricing data, the contracting officer shall  \n(i) Obtain whatever data are available from Government or other secondary sources and use that data in determining a fair and reasonable price;\n(ii) Require submission of data other than certified cost or pricing data, as defined in 2.101 , from the offeror to the extent necessary to determine a fair and reasonable price ( 10 U.S.C. 2306a(d)(1) and 41 U.S.C. 254b(d)(1) ) if the contracting officer determines that adequate data from sources other than the offeror are not available. This includes requiring data from an offeror to support a cost realism analysis;\n(iii) Consider whether cost data are necessary to determine a fair and reasonable price when there is not adequate price competition;\n(iv) Require that the data submitted by the offeror include, at a minimum, appropriate data on the prices at which the same item or similar items have previously been sold, adequate for determining the reasonableness of the price unless an exception under 15.403-1 (b)(1) or (2) applies; and\n(v) Consider the guidance in section 3.3, chapter 3, volume I, of the Contract Pricing Reference Guide cited at 15.404-1 (a)(7) to determine the data an offeror shall be required to submit.\n(2) The contractor  s format for submitting the data should be used (see 15.403-5 (b)(2)).\n(3) The contracting officer shall ensure that data used to support price negotiations are sufficiently current to permit negotiation of a fair and reasonable price. Requests for updated offeror data should be limited to data that affect the adequacy of the proposal for negotiations, such as changes in price lists.\n(4) As specified in section 808 of the Strom Thurmond National Defense Authorization Act for Fiscal Year 1999 (Pub. L. 105-261), an offeror who does not comply with a requirement to submit data for a contract or subcontract in accordance with paragraph (a)(1) of this subsection is ineligible for award unless the HCA determines that it is in the best interest of the Government to make the award to that offeror, based on consideration of the following:\n(i) The effort made to obtain the data.\n(ii) The need for the item or service.\n(iii) Increased cost or significant harm to the Government if award is not made.\n(b) Adequate price competition. When adequate price competition exists (see 15.403-1 (c)(1)), generally no additional data are necessary to determine the reasonableness of price. However, if there are unusual circumstances where it is concluded that additional data are necessary to determine the reasonableness of price, the contracting officer shall, to the maximum extent practicable, obtain the additional data from sources other than the offeror. In addition, the contracting officer should request data to determine the cost realism of competing offers or to evaluate competing approaches.\n(c) Commercial items. \n(1) At a minimum, the contracting officer must use price analysis to determine whether the price is fair and reasonable whenever the contracting officer acquires a commercial item (see 15.404-1 (b)). The fact that a price is included in a catalog does not, in and of itself, make it fair and reasonable. If the contracting officer cannot determine whether an offered price is fair and reasonable, even after obtaining additional data from sources other than the offeror, then the contracting officer shall require the offeror to submit data other than certified cost or pricing data to support further analysis (see 15.404-1 ). This data may include history of sales to non-governmental and governmental entities, cost data, or any other information the contracting officer requires to determine the price is fair and reasonable. Unless an exception under 15.403-1 (b)(1) or (2) applies, the contracting officer shall require that the data submitted by the offeror include, at a minimum, appropriate data on the prices at which the same item or similar items have previously been sold, adequate for determining the reasonableness of the price.\n(2) Limitations relating to commercial items ( 10 U.S.C. 2306a(d)(2) and 41 U.S.C. 254b(d)(2) ). \n(i) The contracting officer shall limit requests for sales data relating to commercial items to data for the same or similar items during a relevant time period.\n(ii) The contracting officer shall, to the maximum extent practicable, limit the scope of the request for data relating to commercial items to include only data that are in the form regularly maintained by the offeror as part of its commercial operations.\n(iii) The Government shall not disclose outside the Government data obtained relating to commercial items that is exempt from disclosure under 24.202 (a) or the Freedom of Information Act ( 5 U.S.C. 552(b) ).\n(3) For services that are not offered and sold competitively in substantial quantities in the commercial marketplace, but are of a type offered and sold competitively in substantial quantities in the commercial marketplace, see 15.403-1 (c)(3)(ii).\n15.403-4 Requiring certified cost or pricing data (10 U.S.C. 2306a and 41 U.S.C. 254b).\n(a)(1) The contracting officer shall obtain certified cost or pricing data only if the contracting officer concludes that none of the exceptions in 15.403-1 (b) applies. However, if the contracting officer has reason to believe exceptional circumstances exist and has sufficient data available to determine a fair and reasonable price, then the contracting officer should consider requesting a waiver under the exception at 15.403-1 (b)(4). The threshold for obtaining certified cost or pricing data is $700,000. Unless an exception applies, certified cost or pricing data are required before accomplishing any of the following actions expected to exceed the current threshold or, in the case of existing contracts, the threshold specified in the contract:\n(i) The award of any negotiated contract (except for undefinitized actions such as letter contracts).\n(ii) The award of a subcontract at any tier, if the contractor and each higher-tier subcontractor were required to furnish certified cost or pricing data (but see waivers at 15.403-1 (c)(4)).\n(iii) The modification of any sealed bid or negotiated contract (whether or not certified cost or pricing data were initially required) or any subcontract covered by paragraph (a)(1)(ii) of this subsection. Price adjustment amounts must consider both increases and decreases ( e.g. , a $200,000 modification resulting from a reduction of $500,000 and an increase of $300,000 is a pricing adjustment exceeding $700,000). This requirement does not apply when unrelated and separately priced changes for which certified cost or pricing data would not otherwise be required are included for administrative convenience in the same modification. Negotiated final pricing actions (such as termination settlements and total final price agreements for fixed-price incentive and redeterminable contracts) are contract modifications requiring certified cost or pricing data if  \n(A) The total final price agreement for such settlements or agreements exceeds the pertinent threshold set forth at paragraph (a)(1) of this subsection; or\n(B) The partial termination settlement plus the estimate to complete the continued portion of the contract exceeds the pertinent threshold set forth at paragraph (a)(1) of this subsection (see 49.105 (c)(15)).\n(2) Unless prohibited because an exception at 15.403-1 (b) applies, the head of the contracting activity, without power of delegation, may authorize the contracting officer to obtain certified cost or pricing data for pricing actions below the pertinent threshold in paragraph (a)(1) of this subsection, provided the action exceeds the simplified acquisition threshold. The head of the contracting activity shall justify the requirement for certified cost or pricing data. The documentation shall include a written finding that certified cost or pricing data are necessary to determine whether the price is fair and reasonable and the facts supporting that finding.\n(b) When certified cost or pricing data are required, the contracting officer shall require the contractor or prospective contractor to submit to the contracting officer (and to have any subcontractor or prospective subcontractor submit to the prime contractor or appropriate subcontractor tier) the following in support of any proposal:\n(1) The certified cost or pricing data and data other than certified cost or pricing data required by the contracting officer to determine that the price is fair and reasonable.\n(2) A Certificate of Current Cost or Pricing Data, in the format specified in 15.406-2 , certifying that to the best of its knowledge and belief, the cost or pricing data were accurate, complete, and current as of the date of agreement on price or, if applicable, an earlier date agreed upon between the parties that is as close as practicable to the date of agreement on price.\n(c) If certified cost or pricing data are requested and submitted by an offeror, but an exception is later found to apply, the data must not be considered certified cost or pricing data as defined in 2.101 and must not be certified in accordance with 15.406-2\n(d) The requirements of this subsection also apply to contracts entered into by an agency on behalf of a foreign government.\n15.403-5 Instructions for submission of certified cost or pricing data and data other than certified cost or pricing data.\n(a) Taking into consideration the policy at 15.402 , the contracting officer shall specify in the solicitation (see 15.408 (l) and (m))  \n(1) Whether certified cost or pricing data are required;\n(2) That, in lieu of submitting certified cost or pricing data, the offeror may submit a request for exception from the requirement to submit certified cost or pricing data;\n(3) Any requirement for data other than certified cost or pricing data; and\n(4) The requirement for necessary preaward or postaward access to offeror  s records.\n(b)(1) Format for submission of certified cost or pricing data . When certification is required, the contracting officer may require submission of certified cost or pricing data in the format indicated in Table 15-2 of 15.408 , specify an alternative format, or permit submission in the contractor  s format (See 15.408 (l)(1)), unless the data are required to be submitted on one of the termination forms specified in Subpart 49.6 .\n(2) Format for submission of data other than certified cost or pricing data . When required by the contracting officer, data other than certified cost or pricing data may be submitted in the offeror  s own format unless the contracting officer decides that use of a specific format is essential for evaluating and determining that the price is fair and reasonable and the format has been described in the solicitation.\n(3) Format for submission of data supporting forward pricing rate agreements . Data supporting forward pricing rate agreements or final indirect cost proposals shall be submitted in a form acceptable to the contracting officer.\n15.404 Proposal analysis.\n15.404-1 Proposal analysis techniques.\n(a) General. The objective of proposal analysis is to ensure that the final agreed-to price is fair and reasonable.\n(1) The contracting officer is responsible for evaluating the reasonableness of the offered prices. The analytical techniques and procedures described in this subsection may be used, singly or in combination with others, to ensure that the final price is fair and reasonable. The complexity and circumstances of each acquisition should determine the level of detail of the analysis required.\n(2) Price analysis shall be used when certified cost or pricing data are not required (see paragraph (b) of this subsection and 15.404-3 ).\n(3) Cost analysis shall be used to evaluate the reasonableness of individual cost elements when certified cost or pricing data are required. Price analysis should be used to verify that the overall price offered is fair and reasonable.\n(4) Cost analysis may also be used to evaluate data other than certified cost or pricing data to determine cost reasonableness or cost realism when a fair and reasonable price cannot be determined through price analysis alone for commercial or non-commercial items.\n(5) The contracting officer may request the advice and assistance of other experts to ensure that an appropriate analysis is performed.\n(6) Recommendations or conclusions regarding the Government  s review or analysis of an offeror  s or contractor  s proposal shall not be disclosed to the offeror or contractor without the concurrence of the contracting officer. Any discrepancy or mistake of fact (such as duplications, omissions, and errors in computation) contained in the certified cost or pricing data or data other than certified cost or pricing data submitted in support of a proposal shall be brought to the contracting officer  s attention for appropriate action.\n(7) The Air Force Institute of Technology (AFIT) and the Federal Acquisition Institute (FAI) jointly prepared a five-volume set of Contract Pricing Reference Guides to guide pricing and negotiation personnel. The five guides are: I Price Analysis, II Quantitative Techniques for Contract Pricing, III Cost Analysis, IV Advanced Issues in Contract Pricing, and V Federal Contract Negotiation Techniques. These references provide detailed discussion and examples applying pricing policies to pricing problems. They are to be used for instruction and professional guidance. However, they are not directive and should be considered informational only. They are available via the internet at http://www.acq.osd.mil/dpap/cpic/cp/contract_pricing_reference_guides.html .\n(b) Price analysis for commercial and non-commercial items.\n(1) Price analysis is the process of examining and evaluating a proposed price without evaluating its separate cost elements and proposed profit. Unless an exception from the requirement to obtain certified cost or pricing data applies under 15.403-1 (b)(1) or (b)(2), at a minimum, the contracting officer shall obtain appropriate data, without certification, on the prices at which the same or similar items have previously been sold and determine if the data is adequate for evaluating the reasonableness of the price. Price analysis may include evaluating data other than certified cost or pricing data obtained from the offeror or contractor when there is no other means for determining a fair and reasonable price. Contracting officers shall obtain data other than certified cost or pricing data from the offeror or contractor for all acquisitions (including commercial item acquisitions), if that is the contracting officer  s only means to determine the price to be fair and reasonable.\n(2) The Government may use various price analysis techniques and procedures to ensure a fair and reasonable price. Examples of such techniques include, but are not limited to, the following:\n(i) Comparison of proposed prices received in response to the solicitation. Normally, adequate price competition establishes a fair and reasonable price (see 15.403-1 (c)(1)(i)).\n(ii) Comparison of the proposed prices to historical prices paid, whether by the Government or other than the Government, for the same or similar items. This method may be used for commercial items including those  of a type  or requiring minor modifications.\n(A) The prior price must be a valid basis for comparison. If there has been a significant time lapse between the last acquisition and the present one, if the terms and conditions of the acquisition are significantly different, or if the reasonableness of the prior price is uncertain, then the prior price may not be a valid basis for comparison.\n(B) The prior price must be adjusted to account for materially differing terms and conditions, quantities and market and economic factors. For similar items, the contracting officer must also adjust the prior price to account for material differences between the similar item and the item being procured.\n(C) Expert technical advice should be obtained when analyzing similar items, or commercial items that are  of a type  or requiring minor modifications, to ascertain the magnitude of changes required and to assist in pricing the required changes\n(iii) Use of parametric estimating methods/application of rough yardsticks (such as dollars per pound or per horsepower, or other units) to highlight significant inconsistencies that warrant additional pricing inquiry.\n(iv) Comparison with competitive published price lists, published market prices of commodities, similar indexes, and discount or rebate arrangements.\n(v) Comparison of proposed prices with independent Government cost estimates.\n(vi) Comparison of proposed prices with prices obtained through market research for the same or similar items.\n(vii) Analysis of data other than certified cost or pricing data (as defined at 2.101 ) provided by the offeror.\n(3) The first two techniques at 15.404-1 (b)(2) are the preferred techniques. However, if the contracting officer determines that information on competitive proposed prices or previous contract prices is not available or is insufficient to determine that the price is fair and reasonable, the contracting officer may use any of the remaining techniques as appropriate to the circumstances applicable to the acquisition.\n(4) Value analysis can give insight into the relative worth of a product and the Government may use it in conjunction with the price analysis techniques listed in paragraph (b)(2) of this section.\n(c) Cost analysis.\n(1) Cost analysis is the review and evaluation of any separate cost elements and profit or fee in an offeror  s or contractor  s proposal, as needed to determine a fair and reasonable price or to determine cost realism, and the application of judgment to determine how well the proposed costs represent what the cost of the contract should be, assuming reasonable economy and efficiency.\n(2) The Government may use various cost analysis techniques and procedures to ensure a fair and reasonable price, given the circumstances of the acquisition. Such techniques and procedures include the following:\n(i) Verification of cost data or pricing data and evaluation of cost elements, including  \n(A) The necessity for, and reasonableness of, proposed costs, including allowances for contingencies;\n(B) Projection of the offeror  s cost trends, on the basis of current and historical cost or pricing data;\n(C) Reasonableness of estimates generated by appropriately calibrated and validated parametric models or cost-estimating relationships; and\n(D) The application of audited or negotiated indirect cost rates, labor rates, and cost of money or other factors.\n(ii) Evaluating the effect of the offeror  s current practices on future costs. In conducting this evaluation, the contracting officer shall ensure that the effects of inefficient or uneconomical past practices are not projected into the future. In pricing production of recently developed complex equipment, the contracting officer should perform a trend analysis of basic labor and materials, even in periods of relative price stability.\n(iii) Comparison of costs proposed by the offeror for individual cost elements with  \n(A) Actual costs previously incurred by the same offeror;\n(B) Previous cost estimates from the offeror or from other offerors for the same or similar items;\n(C) Other cost estimates received in response to the Government  s request;\n(D) Independent Government cost estimates by technical personnel; and\n(E) Forecasts of planned expenditures.\n(iv) Verification that the offeror  s cost submissions are in accordance with the contract cost principles and procedures in Part 31 and, when applicable, the requirements and procedures in 48 CFR Chapter 99 ( Appendix to the FAR looseleaf edition), Cost Accounting Standards.\n(v) Review to determine whether any cost data or pricing data, necessary to make the offeror  s proposal suitable for negotiation, have not been either submitted or identified in writing by the offeror. If there are such data, the contracting officer shall attempt to obtain and use them in the negotiations or make satisfactory allowance for the incomplete data.\n(vi) Analysis of the results of any make-or-buy program reviews, in evaluating subcontract costs (see 15.407-2 ).\n(d) Cost realism analysis.\n(1) Cost realism analysis is the process of independently reviewing and evaluating specific elements of each offeror  s proposed cost estimate to determine whether the estimated proposed cost elements are realistic for the work to be performed; reflect a clear understanding of the requirements; and are consistent with the unique methods of performance and materials described in the offeror  s technical proposal.\n(2) Cost realism analyses shall be performed on cost-reimbursement contracts to determine the probable cost of performance for each offeror.\n(i) The probable cost may differ from the proposed cost and should reflect the Government  s best estimate of the cost of any contract that is most likely to result from the offeror  s proposal. The probable cost shall be used for purposes of evaluation to determine the best value.\n(ii) The probable cost is determined by adjusting each offeror  s proposed cost, and fee when appropriate, to reflect any additions or reductions in cost elements to realistic levels based on the results of the cost realism analysis.\n(3) Cost realism analyses may also be used on competitive fixed-price incentive contracts or, in exceptional cases, on other competitive fixed-price-type contracts when new requirements may not be fully understood by competing offerors, there are quality concerns, or past experience indicates that contractors  proposed costs have resulted in quality or service shortfalls. Results of the analysis may be used in performance risk assessments and responsibility determinations. However, proposals shall be evaluated using the criteria in the solicitation, and the offered prices shall not be adjusted as a result of the analysis.\n(e) Technical analysis.\n(1) The contracting officer should request that personnel having specialized knowledge, skills, experience, or capability in engineering, science, or management perform a technical analysis of the proposed types and quantities of materials, labor, processes, special tooling, equipment or real property, the reasonableness of scrap and spoilage, and other associated factors set forth in the proposal(s) in order to determine the need for and reasonableness of the proposed resources, assuming reasonable economy and efficiency.\n(2) At a minimum, the technical analysis should examine the types and quantities of material proposed and the need for the types and quantities of labor hours and the labor mix. Any other data that may be pertinent to an assessment of the offeror  s ability to accomplish the technical requirements or to the cost or price analysis of the service or product being proposed should also be included in the analysis.\n(3) The contracting officer should request technical assistance in evaluating pricing related to items that are  similar to  items being purchased, or commercial items that are  of a type  or requiring minor modifications, to ascertain the magnitude of changes required and to assist in pricing the required changes.\n(f) Unit prices.\n(1) Except when pricing an item on the basis of adequate price competition or catalog or market price, unit prices shall reflect the intrinsic value of an item or service and shall be in proportion to an item  s base cost ( e.g., manufacturing or acquisition costs). Any method of distributing costs to line items that distorts the unit prices shall not be used. For example, distributing costs equally among line items is not acceptable except when there is little or no variation in base cost.\n(2) Except for the acquisition of commercial items, contracting officers shall require that offerors identify in their proposals those items of supply that they will not manufacture or to which they will not contribute significant value, unless adequate price competition is expected ( 10 U.S.C. 2304 and 41 U.S.C. 254(d)(5)(A)(i) ). Such information shall be used to determine whether the intrinsic value of an item has been distorted through application of overhead and whether such items should be considered for breakout. The contracting officer should require such information in all other negotiated contracts when appropriate.\n(g) Unbalanced pricing.\n(1) Unbalanced pricing may increase performance risk and could result in payment of unreasonably high prices. Unbalanced pricing exists when, despite an acceptable total evaluated price, the price of one or more contract line items is significantly over or understated as indicated by the application of cost or price analysis techniques. The greatest risks associated with unbalanced pricing occur when  \n(i) Startup work, mobilization, first articles, or first article testing are separate line items;\n(ii) Base quantities and option quantities are separate line items; or\n(iii) The evaluated price is the aggregate of estimated quantities to be ordered under separate line items of an indefinite-delivery contract.\n(2) All offers with separately priced line items or subline items shall be analyzed to determine if the prices are unbalanced. If cost or price analysis techniques indicate that an offer is unbalanced, the contracting officer shall  \n(i) Consider the risks to the Government associated with the unbalanced pricing in determining the competitive range and in making the source selection decision; and\n(ii) Consider whether award of the contract will result in paying unreasonably high prices for contract performance.\n(3) An offer may be rejected if the contracting officer determines that the lack of balance poses an unacceptable risk to the Government.\n15.404-2 Data to support proposal analysis.\n(a) Field pricing assistance.\n(1) The contracting officer should request field pricing assistance when the information available at the buying activity is inadequate to determine a fair and reasonable price. The contracting officer shall tailor requests to reflect the minimum essential supplementary information needed to conduct a technical or cost or pricing analysis.\n(2) The contracting officer shall tailor the type of information and level of detail requested in accordance with the specialized resources available at the buying activity and the magnitude and complexity of the required analysis. Field pricing assistance is generally available to provide  \n(i) Technical, audit, and special reports associated with the cost elements of a proposal, including subcontracts;\n(ii) Information on related pricing practices and history;\n(iii) Information to help contracting officers determine commerciality and a fair and reasonable price, including  \n(A) Verifying sales history to source documents;\n(B) Identifying special terms and conditions;\n(C) Identifying customarily granted or offered discounts for the item;\n(D) Verifying the item to an existing catalog or price list;\n(E) Verifying historical data for an item previously not determined commercial that the offeror is now trying to qualify as a commercial item; and\n(F) Identifying general market conditions affecting determinations of commerciality and a fair and reasonable price.\n(iv) Information relative to the business, technical, production, or other capabilities and practices of an offeror.\n(3) When field pricing assistance is requested, contracting officers are encouraged to team with appropriate field experts throughout the acquisition process, including negotiations. Early communication with these experts will assist in determining the extent of assistance required, the specific areas for which assistance is needed, a realistic review schedule, and the information necessary to perform the review.\n(4) When requesting field pricing assistance on a contractor  s request for equitable adjustment, the contracting officer shall provide the information listed in 43.204 (b)(5).\n(5) Field pricing information and other reports may include proprietary or source selection information (see 2.101 ). This information must be appropriately identified and protected accordingly.\n(b) Reporting field pricing information.\n(1) Depending upon the extent and complexity of the field pricing review, results, including supporting rationale, may be reported directly to the contracting officer orally, in writing, or by any other method acceptable to the contracting officer.\n(i) Whenever circumstances permit, the contracting officer and field pricing experts are encouraged to use telephonic and/or electronic means to request and transmit pricing information.\n(ii) When it is necessary to have written technical and audit reports, the contracting officer shall request that the audit agency concurrently forward the audit report to the requesting contracting officer and the administrative contracting officer (ACO). The completed field pricing assistance results may reference audit information, but need not reconcile the audit recommendations and technical recommendations. A copy of the information submitted to the contracting officer by field pricing personnel shall be provided to the audit agency.\n(2) Audit and field pricing information, whether written or reported telephonically or electronically, shall be made a part of the official contract file (see 4.807(f)).\n(c) Audit assistance for prime contracts or subcontracts.\n(1) The contracting officer should contact the cognizant audit office directly, particularly when an audit is the only field pricing support required. The audit office shall send the audit report, or otherwise transmit the audit recommendations, directly to the contracting officer.\n(i) The auditor shall not reveal the audit conclusions or recommendations to the offeror/contractor without obtaining the concurrence of the contracting officer. However, the auditor may discuss statements of facts with the contractor.\n(ii) The contracting officer should be notified immediately of any information disclosed to the auditor after submission of a report that may significantly affect the audit findings and, if necessary, a supplemental audit report shall be issued.\n(2) The contracting officer shall not request a separate preaward audit of indirect costs unless the information already available from an existing audit, completed within the preceding 12 months, is considered inadequate for determining the reasonableness of the proposed indirect costs ( 41 U.S.C. 254d and 10 U.S.C. 2313 ).\n(3) The auditor is responsible for the scope and depth of the audit. Copies of updated information that will significantly affect the audit should be provided to the auditor by the contracting officer.\n(4) General access to the offeror  s books and financial records is limited to the auditor. This limitation does not preclude the contracting officer or the ACO, or their representatives, from requesting that the offeror provide or make available any data or records necessary to analyze the offeror  s proposal.\n(d) Deficient proposals . The ACO or the auditor, as appropriate, shall notify the contracting officer immediately if the data provided for review is so deficient as to preclude review or audit, or if the contractor or offeror has denied access to any records considered essential to conduct a satisfactory review or audit. Oral notifications shall be confirmed promptly in writing, including a description of deficient or denied data or records. The contracting officer immediately shall take appropriate action to obtain the required data. Should the offeror/contractor again refuse to provide adequate data, or provide access to necessary data, the contracting officer shall withhold the award or price adjustment and refer the contract action to a higher authority, providing details of the attempts made to resolve the matter and a statement of the practicability of obtaining the supplies or services from another source.\n15.404-3 Subcontract pricing considerations.\n(a) The contracting officer is responsible for the determination of a fair and reasonable price for the prime contract, including subcontracting costs. The contracting officer should consider whether a contractor or subcontractor has an approved purchasing system, has performed cost or price analysis of proposed subcontractor prices, or has negotiated the subcontract prices before negotiation of the prime contract, in determining the reasonableness of the prime contract price. This does not relieve the contracting officer from the responsibility to analyze the contractor  s submission, including subcontractor  s certified cost or pricing data.\n(b) The prime contractor or subcontractor shall  \n(1) Conduct appropriate cost or price analyses to establish the reasonableness of proposed subcontract prices;\n(2) Include the results of these analyses in the price proposal; and\n(3) When required by paragraph (c) of this subsection, submit subcontractor certified cost or pricing data to the Government as part of its own certified cost or pricing data.\n(c) Any contractor or subcontractor that is required to submit certified cost or pricing data also shall obtain and analyze certified cost or pricing data before awarding any subcontract, purchase order, or modification expected to exceed the certified cost or pricing data threshold, unless an exception in 15.403-1 (b) applies to that action.\n(1) The contractor shall submit, or cause to be submitted by the subcontractor(s), certified cost or pricing data to the Government for subcontracts that are the lower of either  \n(i) $12.5 million or more; or\n(ii) Both more than the pertinent certified cost or pricing data threshold and more than 10 percent of the prime contractor  s proposed price, unless the contracting officer believes such submission is unnecessary.\n(2) The contracting officer should require the contractor or subcontractor to submit to the Government (or cause submission of) subcontractor certified cost or pricing data below the thresholds in paragraph (c)(1) of this subsection and data other than certified cost or pricing data that the contracting officer considers necessary for adequately pricing the prime contract.\n(3) Subcontractor certified cost or pricing data shall be submitted in the format provided in Table 15-2 of 15.408 or the alternate format specified in the solicitation.\n(4) Subcontractor certified cost or pricing data shall be current, accurate, and complete as of the date of price agreement, or, if applicable, an earlier date agreed upon by the parties and specified on the contractor  s Certificate of Current Cost or Pricing Data. The contractor shall update subcontractor  s data, as appropriate, during source selection and negotiations.\n(5) If there is more than one prospective subcontractor for any given work, the contractor need only submit to the Government certified cost or pricing data for the prospective subcontractor most likely to receive the award.\n15.404-4 Profit.\n(a) General . This subsection prescribes policies for establishing the profit or fee portion of the Government prenegotiation objective in price negotiations based on cost analysis.\n(1) Profit or fee prenegotiation objectives do not necessarily represent net income to contractors. Rather, they represent that element of the potential total remuneration that contractors may receive for contract performance over and above allowable costs. This potential remuneration element and the Government  s estimate of allowable costs to be incurred in contract performance together equal the Government  s total prenegotiation objective. Just as actual costs may vary from estimated costs, the contractor  s actual realized profit or fee may vary from negotiated profit or fee, because of such factors as efficiency of performance, incurrence of costs the Government does not recognize as allowable, and the contract type.\n(2) It is in the Government  s interest to offer contractors opportunities for financial rewards sufficient to stimulate efficient contract performance, attract the best capabilities of qualified large and small business concerns to Government contracts, and maintain a viable industrial base.\n(3) Both the Government and contractors should be concerned with profit as a motivator of efficient and effective contract performance. Negotiations aimed merely at reducing prices by reducing profit, without proper recognition of the function of profit, are not in the Government  s interest. Negotiation of extremely low profits, use of historical averages, or automatic application of predetermined percentages to total estimated costs do not provide proper motivation for optimum contract performance.\n(b) Policy.\n(1) Structured approaches (see paragraph (d) of this subsection) for determining profit or fee prenegotiation objectives provide a discipline for ensuring that all relevant factors are considered. Subject to the authorities in 1.301 (c), agencies making noncompetitive contract awards over $100,000 totaling $50 million or more a year  \n(i) Shall use a structured approach for determining the profit or fee objective in those acquisitions that require cost analysis; and\n(ii) May prescribe specific exemptions for situations in which mandatory use of a structured approach would be clearly inappropriate.\n(2) Agencies may use another agency  s structured approach.\n(c) Contracting officer responsibilities.\n(1) When the price negotiation is not based on cost analysis, contracting officers are not required to analyze profit.\n(2) When the price negotiation is based on cost analysis, contracting officers in agencies that have a structured approach shall use it to analyze profit. When not using a structured approach, contracting officers shall comply with paragraph (d)(1) of this subsection in developing profit or fee prenegotiation objectives.\n(3) Contracting officers shall use the Government prenegotiation cost objective amounts as the basis for calculating the profit or fee prenegotiation objective. Before applying profit or fee factors, the contracting officer shall exclude from the pre-negotiation cost objective amounts the purchase cost of contractor-acquired property that is categorized as equipment, as defined in FAR 45.101 , and where such equipment is to be charged directly to the contract. Before applying profit or fee factors, the contracting officer shall exclude any facilities capital cost of money included in the cost objective amounts. If the prospective contractor fails to identify or propose facilities capital cost of money in a proposal for a contract that will be subject to the cost principles for contracts with commercial organizations (see Subpart 31.2 ), facilities capital cost of money will not be an allowable cost in any resulting contract (see 15.408 (i)).\n(4)(i) The contracting officer shall not negotiate a price or fee that exceeds the following statutory limitations, imposed by 10 U.S.C. 2306(d) and 41 U.S.C. 254(b) :\n(A) For experimental, developmental, or research work performed under a cost-plus-fixed-fee contract, the fee shall not exceed 15 percent of the contract  s estimated cost, excluding fee.\n(B) For architect-engineer services for public works or utilities, the contract price or the estimated cost and fee for production and delivery of designs, plans, drawings, and specifications shall not exceed 6 percent of the estimated cost of construction of the public work or utility, excluding fees.\n(C) For other cost-plus-fixed-fee contracts, the fee shall not exceed 10 percent of the contract  s estimated cost, excluding fee.\n(ii) The contracting officer  s signature on the price negotiation memorandum or other documentation supporting determination of fair and reasonable price documents the contracting officer  s determination that the statutory price or fee limitations have not been exceeded.\n(5) The contracting officer shall not require any prospective contractor to submit breakouts or supporting rationale for its profit or fee objective but may consider it, if it is submitted voluntarily.\n(6) If a change or modification calls for essentially the same type and mix of work as the basic contract and is of relatively small dollar value compared to the total contract value, the contracting officer may use the basic contract  s profit or fee rate as the prenegotiation objective for that change or modification.\n(d) Profit-analysis factors  \n(1) Common factors . Unless it is clearly inappropriate or not applicable, each factor outlined in paragraphs (d)(1)(i) through (vi) of this subsection shall be considered by agencies in developing their structured approaches and by contracting officers in analyzing profit, whether or not using a structured approach.\n(i) Contractor effort . This factor measures the complexity of the work and the resources required of the prospective contractor for contract performance. Greater profit opportunity should be provided under contracts requiring a high degree of professional and managerial skill and to prospective contractors whose skills, facilities, and technical assets can be expected to lead to efficient and economical contract performance. The subfactors in paragraphs (d)(1)(i)(A) through (D) of this subsection shall be considered in determining contractor effort, but they may be modified in specific situations to accommodate differences in the categories used by prospective contractors for listing costs  \n(A) Material acquisition . This subfactor measures the managerial and technical effort needed to obtain the required purchased parts and material, subcontracted items, and special tooling. Considerations include the complexity of the items required, the number of purchase orders and subcontracts to be awarded and administered, whether established sources are available or new or second sources must be developed, and whether material will be obtained through routine purchase orders or through complex subcontracts requiring detailed specifications. Profit consideration should correspond to the managerial and technical effort involved.\n(B) Conversion direct labor . This subfactor measures the contribution of direct engineering, manufacturing, and other labor to converting the raw materials, data, and subcontracted items into the contract items. Considerations include the diversity of engineering, scientific, and manufacturing labor skills required and the amount and quality of supervision and coordination needed to perform the contract task.\n(C) Conversion-related indirect costs . This subfactor measures how much the indirect costs contribute to contract performance. The labor elements in the allocable indirect costs should be given the profit consideration they would receive if treated as direct labor. The other elements of indirect costs should be evaluated to determine whether they merit only limited profit consideration because of their routine nature, or are elements that contribute significantly to the proposed contract.\n(D) General management . This subfactor measures the prospective contractor  s other indirect costs and general and administrative (G&A) expense, their composition, and how much they contribute to contract performance. Considerations include how labor in the overhead pools would be treated if it were direct labor, whether elements within the pools are routine expenses or instead are elements that contribute significantly to the proposed contract, and whether the elements require routine as opposed to unusual managerial effort and attention.\n(ii) Contract cost risk.\n(A) This factor measures the degree of cost responsibility and associated risk that the prospective contractor will assume as a result of the contract type contemplated and considering the reliability of the cost estimate in relation to the complexity and duration of the contract task. Determination of contract type should be closely related to the risks involved in timely, cost-effective, and efficient performance. This factor should compensate contractors proportionately for assuming greater cost risks.\n(B) The contractor assumes the greatest cost risk in a closely priced firm-fixed-price contract under which it agrees to perform a complex undertaking on time and at a predetermined price. Some firm-fixed-price contracts may entail substantially less cost risk than others because, for example, the contract task is less complex or many of the contractor  s costs are known at the time of price agreement, in which case the risk factor should be reduced accordingly. The contractor assumes the least cost risk in a cost-plus-fixed-fee level-of-effort contract, under which it is reimbursed those costs determined to be allocable and allowable, plus the fixed fee.\n(C) In evaluating assumption of cost risk, contracting officers shall, except in unusual circumstances, treat time-and-materials, labor-hour, and firm-fixed-price, level-of-effort term contracts as cost-plus-fixed-fee contracts.\n(iii) Federal socioeconomic programs . This factor measures the degree of support given by the prospective contractor to Federal socioeconomic programs, such as those involving small business concerns, small business concerns owned and controlled by socially and economically disadvantaged individuals, women-owned small business concerns, veteran-owned, HUBZone, service-disabled veteran-owned small business concerns, handicapped sheltered workshops, and energy conservation. Greater profit opportunity should be provided contractors that have displayed unusual initiative in these programs.\n(iv) Capital investments . This factor takes into account the contribution of contractor investments to efficient and economical contract performance.\n(v) Cost-control and other past accomplishments . This factor allows additional profit opportunities to a prospective contractor that has previously demonstrated its ability to perform similar tasks effectively and economically. In addition, consideration should be given to measures taken by the prospective contractor that result in productivity improvements, and other cost-reduction accomplishments that will benefit the Government in follow-on contracts.\n(vi) Independent development . Under this factor, the contractor may be provided additional profit opportunities in recognition of independent development efforts relevant to the contract end item without Government assistance. The contracting officer should consider whether the development cost was recovered directly or indirectly from Government sources.\n(2) Additional factors . In order to foster achievement of program objectives, each agency may include additional factors in its structured approach or take them into account in the profit analysis of individual contract actions.\n15.405 Price negotiation.\n(a) The purpose of performing cost or price analysis is to develop a negotiation position that permits the contracting officer and the offeror an opportunity to reach agreement on a fair and reasonable price. A fair and reasonable price does not require that agreement be reached on every element of cost, nor is it mandatory that the agreed price be within the contracting officer  s initial negotiation position. Taking into consideration the advisory recommendations, reports of contributing specialists, and the current status of the contractor  s purchasing system, the contracting officer is responsible for exercising the requisite judgment needed to reach a negotiated settlement with the offeror and is solely responsible for the final price agreement. However, when significant audit or other specialist recommendations are not adopted, the contracting officer should provide rationale that supports the negotiation result in the price negotiation documentation.\n(b) The contracting officer  s primary concern is the overall price the Government will actually pay. The contracting officer  s objective is to negotiate a contract of a type and with a price providing the contractor the greatest incentive for efficient and economical performance. The negotiation of a contract type and a price are related and should be considered together with the issues of risk and uncertainty to the contractor and the Government. Therefore, the contracting officer should not become preoccupied with any single element and should balance the contract type, cost, and profit or fee negotiated to achieve a total result  a price that is fair and reasonable to both the Government and the contractor.\n(c) The Government  s cost objective and proposed pricing arrangement directly affect the profit or fee objective. Because profit or fee is only one of several interrelated variables, the contracting officer shall not agree on profit or fee without concurrent agreement on cost and type of contract.\n(d) If, however, the contractor insists on a price or demands a profit or fee that the contracting officer considers unreasonable, and the contracting officer has taken all authorized actions (including determining the feasibility of developing an alternative source) without success, the contracting officer shall refer the contract action to a level above the contracting officer. Disposition of the action should be documented.\n15.406 Documentation.\n15.406-1 Prenegotiation objectives.\n(a) The prenegotiation objectives establish the Government  s initial negotiation position. They assist in the contracting officer  s determination of fair and reasonable price. They should be based on the results of the contracting officer  s analysis of the offeror  s proposal, taking into consideration all pertinent information including field pricing assistance, audit reports and technical analysis, fact-finding results, independent Government cost estimates and price histories.\n(b) The contracting officer shall establish prenegotiation objectives before the negotiation of any pricing action. The scope and depth of the analysis supporting the objectives should be directly related to the dollar value, importance, and complexity of the pricing action. When cost analysis is required, the contracting officer shall document the pertinent issues to be negotiated, the cost objectives, and a profit or fee objective.\n15.406-2 Certificate of Current Cost or Pricing Data.\n(a) When certified cost or pricing data are required, the contracting officer shall require the contractor to execute a Certificate of Current Cost or Pricing Data, using the format in this paragraph, and must include the executed certificate in the contract file.\nCertificate of Current Cost or Pricing Data\nThis is to certify that, to the best of my knowledge and belief, the cost or pricing data (as defined in section 2.101 of the Federal Acquisition Regulation (FAR) and required under FAR subsection 15.403-4 ) submitted, either actually or by specific identification in writing, to the Contracting Officer or to the Contracting Officer's representative in support of ________* are accurate, complete, and current as of ________**. This certification includes the cost or pricing data supporting any advance agreements and forward pricing rate agreements between the offeror and the Government that are part of the proposal.\nFirm _____________________________________________\nSignature _________________________________________\nName ____________________________________________\nTitle _____________________________________________\nDate of execution***________________________________\n* Identify the proposal, request for price adjustment, or other submission involved, giving the appropriate identifying number ( e.g., RFP No.).\n** Insert the day, month, and year when price negotiations were concluded and price agreement was reached or, if applicable, an earlier date agreed upon between the parties that is as close as practicable to the date of agreement on price.\n*** Insert the day, month, and year of signing, which should be as close as practicable to the date when the price negotiations were concluded and the contract price was agreed to.\n(End of certificate)\n(b) The certificate does not constitute a representation as to the accuracy of the contractor  s judgment on the estimate of future costs or projections. It applies to the data upon which the judgment or estimate was based. This distinction between fact and judgment should be clearly understood. If the contractor had information reasonably available at the time of agreement showing that the negotiated price was not based on accurate, complete, and current data, the contractor  s responsibility is not limited by any lack of personal knowledge of the information on the part of its negotiators.\n(c) The contracting officer and contractor are encouraged to reach a prior agreement on criteria for establishing closing or cutoff dates when appropriate in order to minimize delays associated with proposal updates. Closing or cutoff dates should be included as part of the data submitted with the proposal and, before agreement on price, data should be updated by the contractor to the latest closing or cutoff dates for which the data are available. Use of cutoff dates coinciding with reports is acceptable, as certain data may not be reasonably available before normal periodic closing dates ( e.g., actual indirect costs). Data within the contractor  s or a subcontractor  s organization on matters significant to contractor management and to the Government will be treated as reasonably available. What is significant depends upon the circumstances of each acquisition.\n(d) Possession of a Certificate of Current Cost or Pricing Data is not a substitute for examining and analyzing the contractor  s proposal.\n(e) If certified cost or pricing data are requested by the Government and submitted by an offeror, but an exception is later found to apply, the data shall not be considered certified cost or pricing data and shall not be certified in accordance with this subsection.\n15.406-3 Documenting the negotiation.\n(a) The contracting officer shall document in the contract file the principal elements of the negotiated agreement. The documentation ( e.g., price negotiation memorandum (PNM)) shall include the following:\n(1) The purpose of the negotiation.\n(2) A description of the acquisition, including appropriate identifying numbers ( e.g., RFP No.).\n(3) The name, position, and organization of each person representing the contractor and the Government in the negotiation.\n(4) The current status of any contractor systems ( e.g., purchasing, estimating, accounting, and compensation) to the extent they affected and were considered in the negotiation.\n(5) If certified cost or pricing data were not required in the case of any price negotiation exceeding the certified cost or pricing data threshold, the exception used and the basis for it.\n(6) If certified cost or pricing data were required, the extent to which the contracting officer  \n(i) Relied on the certified cost or pricing data submitted and used them in negotiating the price;\n(ii) Recognized as inaccurate, incomplete, or noncurrent any certified cost or pricing data submitted; the action taken by the contracting officer and the contractor as a result; and the effect of the defective data on the price negotiated; or\n(iii) Determined that an exception applied after the data were submitted and, therefore, considered not to be certified cost or pricing data.\n(7) A summary of the contractor  s proposal, any field pricing assistance recommendations, including the reasons for any pertinent variances from them, the Government  s negotiation objective, and the negotiated position. Where the determination of a fair and reasonable price is based on cost analysis, the summary shall address each major cost element. When determination of a fair and reasonable price is based on price analysis, the summary shall include the source and type of data used to support the determination.\n(8) The most significant facts or considerations controlling the establishment of the prenegotiation objectives and the negotiated agreement including an explanation of any significant differences between the two positions.\n(9) To the extent such direction has a significant effect on the action, a discussion and quantification of the impact of direction given by Congress, other agencies, and higher-level officials ( i.e., officials who would not normally exercise authority during the award and review process for the instant contract action).\n(10) The basis for the profit or fee prenegotiation objective and the profit or fee negotiated.\n(11) Documentation of fair and reasonable pricing.\n(b) Whenever field pricing assistance has been obtained, the contracting officer shall forward a copy of the negotiation documentation to the office(s) providing assistance. When appropriate, information on how advisory field support can be made more effective should be provided separately.\n15.407 Special cost or pricing areas.\n15.407-1 Defective certified cost or pricing data.\n(a) If, before agreement on price, the contracting officer learns that any certified cost or pricing data submitted are inaccurate, incomplete, or noncurrent, the contracting officer shall immediately bring the matter to the attention of the prospective contractor, whether the defective data increase or decrease the contract price. The contracting officer shall consider any new data submitted to correct the deficiency, or consider the inaccuracy, incompleteness, or noncurrency of the data when negotiating the contract price. The price negotiation memorandum shall reflect the adjustments made to the data or the corrected data used to negotiate the contract price.\n(b)(1) If, after award, certified cost or pricing data are found to be inaccurate, incomplete, or noncurrent as of the date of final agreement on price or an earlier date agreed upon by the parties given on the contractor's or subcontractor's Certificate of Current Cost or Pricing Data, the Government is entitled to a price adjustment, including profit or fee, of any significant amount by which the price was increased because of the defective data. This entitlement is ensured by including in the contract one of the clauses prescribed in 15.408 (b) and (c) and is set forth in the clauses at 52.215-10 , Price Reduction for Defective Certified Cost or Pricing Data, and 52.215-11 , Price Reduction for Defective Certified Cost or Pricing Data-Modifications. The clauses give the Government the right to a price adjustment for defects in certified cost or pricing data submitted by the contractor, a prospective subcontractor, or an actual subcontractor.\n(2) In arriving at a price adjustment, the contracting officer shall consider the time by which the certified cost or pricing data became reasonably available to the contractor, and the extent to which the Government relied upon the defective data.\n(3) The clauses referred to in paragraph (b)(1) of this subsection recognize that the Government  s right to a price adjustment is not affected by any of the following circumstances:\n(i) The contractor or subcontractor was a sole source supplier or otherwise was in a superior bargaining position;\n(ii) The contracting officer should have known that the certified cost or pricing data in issue were defective even though the contractor or subcontractor took no affirmative action to bring the character of the data to the attention of the contracting officer;\n(iii) The contract was based on an agreement about the total cost of the contract and there was no agreement about the cost of each item procured under such contract; or\n(iv) Certified cost or pricing data were required; however, the contractor or subcontractor did not submit a Certificate of Current Cost or Pricing Data relating to the contract.\n(4) Subject to paragraphs (b)(5) and (6) of this subsection, the contracting officer shall allow an offset for any understated certified cost or pricing data submitted in support of price negotiations, up to the amount of the Government  s claim for overstated pricing data arising out of the same pricing action ( e.g., the initial pricing of the same contract or the pricing of the same change order).\n(5) An offset shall be allowed only in an amount supported by the facts and if the contractor  \n(i) Certifies to the contracting officer that, to the best of the contractor  s knowledge and belief, the contractor is entitled to the offset in the amount requested; and\n(ii) Proves that the certified cost or pricing data were available before the  as of  date specified on the Certificate of Current Cost or Pricing Data but were not submitted. Such offsets need not be in the same cost groupings ( e.g., material, direct labor, or indirect costs).\n(6) An offset shall not be allowed if  \n(i) The understated data were known by the contractor to be understated before the  as of  date specified on the Certificate of Current Cost or Pricing Data; or\n(ii) The Government proves that the facts demonstrate that the price would not have increased in the amount to be offset even if the available data had been submitted before the  as of  date specified on the Certificate of Current Cost or Pricing Data.\n(7)(i) In addition to the price adjustment, the Government is entitled to recovery of any overpayment plus interest on the overpayments. The Government is also entitled to penalty amounts on certain of these overpayments. Overpayment occurs only when payment is made for supplies or services accepted by the Government. Overpayments do not result from amounts paid for contract financing, as defined in 32.001 .\n(ii) In calculating the interest amount due, the contracting officer shall  \n(A) Determine the defective pricing amounts that have been overpaid to the contractor;\n(B) Consider the date of each overpayment (the date of overpayment for this interest calculation shall be the date payment was made for the related completed and accepted contract items; or for subcontract defective pricing, the date payment was made to the prime contractor, based on prime contract progress billings or deliveries, which included payments for a completed and accepted subcontract item); and\n(C) Apply the underpayment interest rate(s) in effect for each quarter from the time of overpayment to the time of repayment, utilizing rate(s) prescribed by the Secretary of the Treasury under 26 U.S.C. 6621(a)(2) .\n(iii) In arriving at the amount due for penalties on contracts where the submission of defective certified cost or pricing data was a knowing submission, the contracting officer shall obtain an amount equal to the amount of overpayment made. Before taking any contractual actions concerning penalties, the contracting officer shall obtain the advice of counsel.\n(iv) In the demand letter, the contracting officer shall separately include  \n(A) The repayment amount;\n(B) The penalty amount (if any);\n(C) The interest amount through a specified date; and\n(D) A statement that interest will continue to accrue until repayment is made.\n(c) If, after award, the contracting officer learns or suspects that the data furnished were not accurate, complete, and current, or were not adequately verified by the contractor as of the time of negotiation, the contracting officer shall request an audit to evaluate the accuracy, completeness, and currency of the data. The Government may evaluate the profit-cost relationships only if the audit reveals that the data certified by the contractor were defective. The contracting officer shall not reprice the contract solely because the profit was greater than forecast or because a contingency specified in the submission failed to materialize.\n(d) For each advisory audit received based on a postaward review that indicates defective pricing, the contracting officer shall make a determination as to whether or not the data submitted were defective and relied upon. Before making such a determination, the contracting officer should give the contractor an opportunity to support the accuracy, completeness, and currency of the data in question. The contracting officer shall prepare a memorandum documenting both the determination and any corrective action taken as a result. The contracting officer shall send one copy of this memorandum to the auditor and, if the contract has been assigned for administration, one copy to the administrative contracting officer (ACO). A copy of the memorandum or other notice of the contracting officer  s determination shall be provided to the contractor. When the contracting officer determines that the contractor submitted defective cost or pricing data, the contracting officer, in accordance with agency procedures, shall ensure that information relating to the contracting officer  s final determination is reported in accordance with 42.1503 (h). Agencies shall ensure updated information that changes a contracting officer  s prior final determination is reported into the FAPIIS module of PPIRS in the event of a  \n(1) Contracting officer  s decision in accordance with the Contract Disputes Act;\n(2) Board of Contract Appeals decision; or\n(3) Court decision.\n(e) If both the contractor and subcontractor submitted, and the contractor certified, or should have certified, cost or pricing data, the Government has the right, under the clauses at 52.215-10 , Price Reduction for Defective Certified Cost or Pricing Data, and 52.215-11 , Price Reduction for Defective Certified Cost or Pricing Data  Modifications, to reduce the prime contract price if it was significantly increased because a subcontractor submitted defective data. This right applies whether these data supported subcontract cost estimates or supported firm agreements between subcontractor and contractor.\n(f) If Government audit discloses defective subcontractor certified cost or pricing data, the information necessary to support a reduction in prime contract and subcontract prices may be available only from the Government. To the extent necessary to secure a prime contract price reduction, the contracting officer should make this information available to the prime contractor or appropriate subcontractors, upon request. If release of the information would compromise Government security or disclose trade secrets or confidential business information, the contracting officer shall release it only under conditions that will protect it from improper disclosure. Information made available under this paragraph shall be limited to that used as the basis for the prime contract price reduction. In order to afford an opportunity for corrective action, the contracting officer should give the prime contractor reasonable advance notice before determining to reduce the prime contract price.\n(1) When a prime contractor includes defective subcontract data in arriving at the price but later awards the subcontract to a lower priced subcontractor (or does not subcontract for the work), any adjustment in the prime contract price due to defective subcontract data is limited to the difference (plus applicable indirect cost and profit markups) between the subcontract price used for pricing the prime contract, and either the actual subcontract price or the actual cost to the contractor, if not subcontracted, provided the data on which the actual subcontract price is based are not themselves defective.\n(2) Under cost-reimbursement contracts and under all fixed-price contracts except firm-fixed-price contracts and fixed-price contracts with economic price adjustment, payments to subcontractors that are higher than they would be had there been no defective subcontractor certified cost or pricing data shall be the basis for disallowance or nonrecognition of costs under the clauses prescribed in 15.408 (b) and (c). The Government has a continuing and direct financial interest in such payments that is unaffected by the initial agreement on prime contract price.\n15.407-2 Make-or-buy programs.\n(a) General . The prime contractor is responsible for managing contract performance, including planning, placing, and administering subcontracts as necessary to ensure the lowest overall cost and technical risk to the Government. When make-or-buy programs are required, the Government may reserve the right to review and agree on the contractor  s make-or-buy program when necessary to ensure negotiation of reasonable contract prices, satisfactory performance, or implementation of socioeconomic policies. Consent to subcontracts and review of contractors  purchasing systems are separate actions covered in Part 44 .\n(b) Definition.   Make item,  as used in this subsection, means an item or work effort to be produced or performed by the prime contractor or its affiliates, subsidiaries, or divisions.\n(c) Acquisitions requiring make-or-buy programs.\n(1) Contracting officers may require prospective contractors to submit make-or-buy program plans for negotiated acquisitions requiring certified cost or pricing data whose estimated value is $12.5 million or more, except when the proposed contract is for research or development and, if prototypes or hardware are involved, no significant follow-on production is anticipated.\n(2) Contracting officers may require prospective contractors to submit make-or-buy programs for negotiated acquisitions whose estimated value is under $12.5 million only if the contracting officer  \n(i) Determines that the information is necessary; and\n(ii) Documents the reasons in the contract file.\n(d) Solicitation requirements . When prospective contractors are required to submit proposed make-or-buy programs, the solicitation shall include  \n(1) A statement that the program and required supporting information must accompany the offer; and\n(2) A description of factors to be used in evaluating the proposed program, such as capability, capacity, availability of small, small disadvantaged, women-owned, veteran-owned, HUBZone, and service-disabled veteran-owned small business concerns for subcontracting, establishment of new facilities in or near labor surplus areas, delivery or performance schedules, control of technical and schedule interfaces, proprietary processes, technical superiority or exclusiveness, and technical risks involved.\n(e) Program requirements . To support a make-or-buy program, the following information shall be supplied by the contractor in its proposal:\n(1) Items and work included . The information required from a contractor in a make-or-buy program shall be confined to those major items or work efforts that normally would require company management review of the make-or-buy decision because they are complex, costly, needed in large quantities, or require additional equipment or real property to produce. Raw materials, commercial items (see 2.101 ), and off-the-shelf items (see 46.101 ) shall not be included, unless their potential impact on contract cost or schedule is critical. Normally, make-or-buy programs should not include items or work efforts estimated to cost less than 1 percent of the total estimated contract price or any minimum dollar amount set by the agency.\n(2) The offeror  s program should include or be supported by the following information:\n(i) A description of each major item or work effort.\n(ii) Categorization of each major item or work effort as  must make,    must buy,  or  can either make or buy.  \n(iii) For each item or work effort categorized as  can either make or buy,  a proposal either to  make  or to  buy.  \n(iv) Reasons for categorizing items and work efforts as  must make  or  must buy,  and proposing to  make  or to  buy  those categorized as  can either make or buy.  The reasons must include the consideration given to the evaluation factors described in the solicitation and must be in sufficient detail to permit the contracting officer to evaluate the categorization or proposal.\n(v) Designation of the plant or division proposed to make each item or perform each work effort, and a statement as to whether the existing or proposed new facility is in or near a labor surplus area.\n(vi) Identification of proposed subcontractors, if known, and their location and size status (also see Subpart 19.7 for subcontracting plan requirements).\n(vii) Any recommendations to defer make-or-buy decisions when categorization of some items or work efforts is impracticable at the time of submission.\n(viii) Any other information the contracting officer requires in order to evaluate the program.\n(f) Evaluation, negotiation, and agreement. Contracting officers shall evaluate and negotiate proposed make-or-buy programs as soon as practicable after their receipt and before contract award.\n(1) When the program is to be incorporated in the contract and the design status of the product being acquired does not permit accurate precontract identification of major items or work efforts, the contracting officer shall notify the prospective contractor in writing that these items or efforts, when identifiable, shall be added under the clause at 52.215-9 , Changes or Additions to Make-or-Buy Program.\n(2) Contracting officers normally shall not agree to proposed  make items  when the products or services are not regularly manufactured or provided by the contractor and are available  quality, quantity, delivery, and other essential factors considered  from another firm at equal or lower prices, or when they are regularly manufactured or provided by the contractor, but are available  quality, quantity, delivery, and other essential factors considered  from another firm at lower prices. However, the contracting officer may agree to these as  make items  if an overall lower Governmentwide cost would result or it is otherwise in the best interest of the Government. If this situation occurs in any fixed-price incentive or cost-plus-incentive-fee contract, the contracting officer shall specify these items in the contract and state that they are subject to paragraph (d) of the clause at 52.215-9 , Changes or Additions to Make-or-Buy Program (see 15.408 (a)). If the contractor proposes to reverse the categorization of such items during contract performance, the contract price shall be subject to equitable reduction.\n(g) Incorporating make-or-buy programs in contracts . The contracting officer may incorporate the make-or-buy program in negotiated contracts for  \n(1) Major systems (see Part 34 ) or their subsystems or components, regardless of contract type; or\n(2) Other supplies and services if  \n(i) The contract is a cost-reimbursable contract, or a cost-sharing contract in which the contractor  s share of the cost is less than 25 percent; and\n(ii) The contracting officer determines that technical or cost risks justify Government review and approval of changes or additions to the make-or-buy program.\n15.407-3 Forward pricing rate agreements.\n(a) When certified cost or pricing data are required, offerors are required to describe any forward pricing rate agreements (FPRAs) in each specific pricing proposal to which the rates apply and to identify the latest cost or pricing data already submitted in accordance with the FPRA. All data submitted in connection with the FPRA, updated as necessary, form a part of the total data that the offeror certifies to be accurate, complete, and current at the time of agreement on price for an initial contract or for a contract modification. (See the Certificate of Current Cost or Pricing Data at 15.406-2 .)\n(b) Contracting officers will use FPRA rates as bases for pricing all contracts, modifications, and other contractual actions to be performed during the period covered by the agreement. Conditions that may affect the agreement  s validity shall be reported promptly to the ACO. If the ACO determines that a changed condition invalidates the agreement, the ACO shall notify all interested parties of the extent of its effect and status of efforts to establish a revised FPRA.\n(c) Contracting officers shall not require certification at the time of agreement for data supplied in support of FPRA  s or other advance agreements. When a forward pricing rate agreement or other advance agreement is used to price a contract action that requires a certificate, the certificate supporting that contract action shall cover the data supplied to support the FPRA or other advance agreement, and all other data supporting the action.\n15.407-4 Should-cost review.\n(a) General.\n(1) Should-cost reviews are a specialized form of cost analysis. Should-cost reviews differ from traditional evaluation methods because they do not assume that a contractor  s historical costs reflect efficient and economical operation. Instead, these reviews evaluate the economy and efficiency of the contractor  s existing work force, methods, materials, equipment, real property, operating systems, and management. These reviews are accomplished by a multi-functional team of Government contracting, contract administration, pricing, audit, and engineering representatives. The objective of should-cost reviews is to promote both short and long-range improvements in the contractor  s economy and efficiency in order to reduce the cost of performance of Government contracts. In addition, by providing rationale for any recommendations and quantifying their impact on cost, the Government will be better able to develop realistic objectives for negotiation.\n(2) There are two types of should-cost reviews  program should-cost review (see paragraph (b) of this subsection) and overhead should-cost review (see paragraph (c) of this subsection). These should-cost reviews may be performed together or independently. The scope of a should-cost review can range from a large-scale review examining the contractor  s entire operation (including plant-wide overhead and selected major subcontractors) to a small-scale tailored review examining specific portions of a contractor  s operation.\n(b) Program should-cost review.\n(1) A program should-cost review is used to evaluate significant elements of direct costs, such as material and labor, and associated indirect costs, usually associated with the production of major systems. When a program should-cost review is conducted relative to a contractor proposal, a separate audit report on the proposal is required.\n(2) A program should-cost review should be considered, particularly in the case of a major system acquisition (see Part 34 ), when  \n(i) Some initial production has already taken place;\n(ii) The contract will be awarded on a sole source basis;\n(iii) There are future year production requirements for substantial quantities of like items;\n(iv) The items being acquired have a history of increasing costs;\n(v) The work is sufficiently defined to permit an effective analysis and major changes are unlikely;\n(vi) Sufficient time is available to plan and adequately conduct the should-cost review; and\n(vii) Personnel with the required skills are available or can be assigned for the duration of the should-cost review.\n(3) The contracting officer should decide which elements of the contractor  s operation have the greatest potential for cost savings and assign the available personnel resources accordingly. The expertise of on-site Government personnel should be used, when appropriate. While the particular elements to be analyzed are a function of the contract work task, elements such as manufacturing, pricing and accounting, management and organization, and subcontract and vendor management are normally reviewed in a should-cost review.\n(4) In acquisitions for which a program should-cost review is conducted, a separate program should-cost review team report, prepared in accordance with agency procedures, is required. The contracting officer shall consider the findings and recommendations contained in the program should-cost review team report when negotiating the contract price. After completing the negotiation, the contracting officer shall provide the ACO a report of any identified uneconomical or inefficient practices, together with a report of correction or disposition agreements reached with the contractor. The contracting officer shall establish a follow-up plan to monitor the correction of the uneconomical or inefficient practices.\n(5) When a program should-cost review is planned, the contracting officer should state this fact in the acquisition plan or acquisition plan updates (see Subpart 7.1 ) and in the solicitation.\n(c) Overhead should-cost review.\n(1) An overhead should- cost review is used to evaluate indirect costs, such as fringe benefits, shipping and receiving, real property, and equipment, depreciation, plant maintenance and security, taxes, and general and administrative activities. It is normally used to evaluate and negotiate an FPRA with the contractor. When an overhead should-cost review is conducted, a separate audit report is required.\n(2) The following factors should be considered when selecting contractor sites for overhead should-cost reviews:\n(i) Dollar amount of Government business.\n(ii) Level of Government participation.\n(iii) Level of noncompetitive Government contracts.\n(iv) Volume of proposal activity.\n(v) Major system or program.\n(vi) Corporate reorganizations, mergers, acquisitions, or takeovers.\n(vii) Other conditions ( e.g., changes in accounting systems, management, or business activity).\n(3) The objective of the overhead should-cost review is to evaluate significant indirect cost elements in-depth, and identify and recommend corrective actions regarding inefficient and uneconomical practices. If it is conducted in conjunction with a program should-cost review, a separate overhead should-cost review report is not required. However, the findings and recommendations of the overhead should-cost team, or any separate overhead should-cost review report, shall be provided to the ACO. The ACO should use this information to form the basis for the Government position in negotiating an FPRA with the contractor. The ACO shall establish a follow-up plan to monitor the correction of the uneconomical or inefficient practices.\n15.407-5 Estimating systems.\n(a) Using an acceptable estimating system for proposal preparation benefits both the Government and the contractor by increasing the accuracy and reliability of individual proposals. Cognizant audit activities, when it is appropriate to do so, shall establish and manage regular programs for reviewing selected contractors  estimating systems or methods, in order to reduce the scope of reviews to be performed on individual proposals, expedite the negotiation process, and increase the reliability of proposals. The results of estimating system reviews shall be documented in survey reports.\n(b) The auditor shall send a copy of the estimating system survey report and a copy of the official notice of corrective action required to each contracting office and contract administration office having substantial business with that contractor. Significant deficiencies not corrected by the contractor shall be a consideration in subsequent proposal analyses and negotiations. \n15.408 Solicitation provisions and contract clauses.\n(a) Changes or Additions to Make-or-Buy Program . The contracting officer shall insert the clause at 52.215-9 , Changes or Additions to Make-or-Buy Program, in solicitations and contracts when it is contemplated that a make-or-buy program will be incorporated in the contract. If a less economical  make  or  buy  categorization is selected for one or more items of significant value, the contracting officer shall use the clause with  \n(1) Its Alternate I, if a fixed-price incentive contract is contemplated; or\n(2) Its Alternate II, if a cost-plus-incentive-fee contract is contemplated.\n(b) Price Reduction for Defective Certified Cost or Pricing Data . The contracting officer shall, when contracting by negotiation, insert the clause at 52.215-10 , Price Reduction for Defective Certified Cost or Pricing Data, in solicitations and contracts when it is contemplated that certified cost or pricing data will be required from the contractor or any subcontractor (see 15.403-4 ).\n(c) Price Reduction for Defective Certified Cost or Pricing Data  Modifications . The contracting officer shall, when contracting by negotiation, insert the clause at 52.215-11 , Price Reduction for Defective Certified Cost or Pricing Data  Modifications, in solicitations and contracts when it is contemplated that certified cost or pricing data will be required from the contractor or any subcontractor (see 15.403-4 ) for the pricing of contract modifications, and the clause prescribed in paragraph (b) of this section has not been included. \n(d) Subcontractor Certified Cost or Pricing Data . The contracting officer shall insert the clause at 52.215-12 , Subcontractor Certified Cost or Pricing Data, in solicitations and contracts when the clause prescribed in paragraph (b) of this section is included.\n(e) Subcontractor Certified Cost or Pricing Data  Modifications . The contracting officer shall insert the clause at 52.215-13 , Subcontractor Certified Cost or Pricing Data  Modifications, in solicitations and contracts when the clause prescribed in paragraph (c) of this section is included.\n(f) Integrity of Unit Prices.\n(1) The contracting officer shall insert the clause at 52.215-14 , Integrity of Unit Prices, in solicitations and contracts except for-\n(i) Acquisitions at or below the simplified acquisition threshold;\n(ii) Construction or architect-engineer services under Part 36 ;\n(iii) Utility services under Part 41 ;\n(iv) Service contracts where supplies are not required;\n(v) Acquisitions of commercial items; and\n(vi) Contracts for petroleum products.\n(2) The contracting officer shall insert the clause with its Alternate I when contracting without adequate price competition or when prescribed by agency regulations. 52.215-15 Part 31\n(g) Pension Adjustments and Asset Reversions . The contracting officer shall insert the clause at 52.215-15 , Pension Adjustments and Asset Reversions, in solicitations and contracts for which it is anticipated that certified cost or pricing data will be required or for which any preaward or postaward cost determinations will be subject to part 31.\n(h) Facilities Capital Cost of Money . The contracting officer shall insert the provision at 52.215-16 , Facilities Capital Cost of Money, in solicitations expected to result in contracts that are subject to the cost principles for contracts with commercial organizations (see Subpart 31.2 ).\n(i) Waiver of Facilities Capital Cost of Money. If the prospective contractor does not propose facilities capital cost of money in its offer, the contracting officer shall insert the clause at 52.215-17 , Waiver of Facilities Capital Cost of Money, in the resulting contract.\n(j) Reversion or Adjustment of Plans for Postretirement Benefits (PRB) Other Than Pensions . The contracting officer shall insert the clause at 52.215-18 , Reversion or Adjustment of Plans for Postretirement Benefits (PRB) Other Than Pensions, in solicitations and contracts for which it is anticipated that certified cost or pricing data will be required or for which any preaward or postaward cost determinations will be subject to Part 31 .\n(k) Notification of Ownership Changes . The contracting officer shall insert the clause at 52.215-19 , Notification of Ownership Changes, in solicitations and contracts for which it is contemplated that certified cost or pricing data will be required or for which any preaward or postaward cost determination will be subject to Subpart 31.2 .\n(l) Requirements for Certified Cost or Pricing Data and Data Other Than Certified Cost or Pricing Data . Considering the hierarchy at 15.402 , the contracting officer shall insert the provision at 52.215-20 , Requirements for Certified Cost or Pricing Data and Data Other Than Certified Cost or Pricing Data, in solicitations if it is reasonably certain that certified cost or pricing data or data other than certified cost or pricing data will be required. This provision also provides instructions to offerors on how to request an exception from the requirement to submit certified cost or pricing data. The contracting officer shall  \n(1) Use the provision with its Alternate I to specify a format for certified cost or pricing data other than the format required by Table 15-2 of this section;\n(2) Use the provision with its Alternate II if copies of the proposal are to be sent to the ACO and contract auditor;\n(3) Use the provision with its Alternate III if submission via electronic media is required; and\n(4) Replace the basic provision with its Alternate IV if certified cost or pricing data are not expected to be required because an exception may apply, but data other than certified cost or pricing data will be required as described in 15.403-3 .\n(m) Requirements for Certified Cost or Pricing Data and Data Other Than Certified Cost or Pricing Data  Modifications . Considering the hierarchy at 15.402 , the contracting officer shall insert the clause at 52.215-21 , Requirements for Certified Cost or Pricing Data and Data Other Than Certified Cost or Pricing Data  Modifications, in solicitations and contracts if it is reasonably certain that certified cost or pricing data or data other than certified cost or pricing data will be required for modifications. This clause also provides instructions to contractors on how to request an exception from the requirement to submit certified cost or pricing data. The contracting officer shall  \n(1) Use the clause with its Alternate I to specify a format for certified cost or pricing data other than the format required by Table 15-2 of this section;\n(2) Use the clause with its Alternate II if copies of the proposal are to be sent to the ACO and contract auditor;\n(3) Use the clause with its Alternate III if submission via electronic media is required; and\n(4) Replace the basic clause with its Alternate IV if certified cost or pricing data are not expected to be required because an exception may apply, but data other than certified cost or pricing data will be required as described in 15.403-3 .\n(n) Limitations on Pass-Through Charges. \n(1) The contracting officer shall insert the provision at 52.215-22 , Limitations on Pass-Through Charges-Identification of Subcontract Effort, in solicitations containing the clause at 52.215-23 .\n(2)(i) Except as provided in paragraph (n)(2)(ii), the contracting officer shall insert the clause 52.215-23 , Limitations on Pass-Through Charges, in solicitations and contracts including task or delivery orders as follows:\n(A) For civilian agencies, insert the clause when  \n(1) The total estimated contract or order value exceeds the simplified acquisition threshold as defined in section 2.101 and\n(2) The contemplated contract type is expected to be a cost-reimbursement type contract as defined in Subpart 16.3 ; or\n(B) For DoD, insert the clause when  \n(1) The total estimated contract or order value exceeds the threshold for obtaining cost or pricing data in 15.403-4 ; and \n(2) The contemplated contract type is expected to be any contract type except  \n(i) A firm-fixed-price contract awarded on the basis of adequate price competition;\n(ii) A fixed-price contract with economic price adjustment awarded on the basis of adequate price competition;\n(iii) A firm-fixed-price contract for the acquisition of a commercial item;\n(iv) A fixed-price contract with economic price adjustment, for the acquisition of a commercial item;\n(v) A fixed-price incentive contract awarded on the basis of adequate price competition; or\n(vi) A fixed-price incentive contract for the acquisition of a commercial item.\n(ii) The clause may be used when the total estimated contract or order value is below the thresholds identified in 15.408 (n)(2)(i) and for any contract type, when the contracting officer determines that inclusion of the clause is appropriate.\n(iii) Use the clause 52.215-23 with its Alternate I when the contracting officer determines that the prospective contractor has demonstrated that its functions provide added value to the contracting effort and there are no excessive pass-through charges.\nTable 15-2  Instructions for Submitting Cost/Price Proposals When Certified Cost or Pricing Data Are Required\nThis document provides instructions for preparing a contract pricing proposal when certified cost or pricing data are required.\nNote 1. There is a clear distinction between submitting certified cost or pricing data and merely making available books, records, and other documents without identification. The requirement for submission of certified cost or pricing data is met when all accurate certified cost or pricing data reasonably available to the offeror have been submitted, either actually or by specific identification, to the Contracting Officer or an authorized representative. As later data come into your possession, it should be submitted promptly to the Contracting Officer in a manner that clearly shows how the data relate to the offeror's price proposal. The requirement for submission of certified cost or pricing data continues up to the time of agreement on price, or an earlier date agreed upon between the parties if applicable.\nNote 2. By submitting your proposal, you grant the Contracting Officer or an authorized representative the right to examine records that formed the basis for the pricing proposal. That examination can take place at any time before award. It may include those books, records, documents, and other types of factual data (regardless of form or whether the data are specifically referenced or included in the proposal as the basis for pricing) that will permit an adequate evaluation of the proposed price.\nI. General Instructions\nA. You must provide the following information on the first page of your pricing proposal:\n(1) Solicitation, contract, and/or modification number;\n(2) Name and address of offeror;\n(3) Name and telephone number of point of contact;\n(4) Name of contract administration office (if available);\n(5) Type of contract action (that is, new contract, change order, price revision/redetermination, letter contract, unpressed order, or other);\n(6) Proposed cost; profit or fee; and total;\n(7) Whether you will require the use of Government property in the performance of the contract, and, if so, what property;\n(8) Whether your organization is subject to cost accounting standards; whether your organization has submitted a CASB Disclosure Statement, and if it has been determined adequate; whether you have been notified that you are or may be in noncompliance with your Disclosure Statement or CAS (other than a noncompliance that the cognizant Federal agency official has determined to have an immaterial cost impact), and, if yes, an explanation; whether any aspect of this proposal is inconsistent with your disclosed practices or applicable CAS, and, if so, an explanation; and whether the proposal is consistent with your established estimating and accounting principles and procedures and FAR Part 31 , Cost Principles, and, if not, an explanation;\n(9) The following statement: This proposal reflects our estimates and/or actual costs as of this date and conforms with the instructions in FAR 15.403-5 (b)(1) and Table 15-2 . By submitting this proposal, we grant the Contracting Officer and authorized representative(s) the right to examine, at any time before award, those records, which include books, documents, accounting procedures and practices, and other data, regardless of type and form or whether such supporting information is specifically referenced or included in the proposal as the basis for pricing, that will permit an adequate evaluation of the proposed price.\n(10) Date of submission; and\n(11) Name, title, and signature of authorized representative.\nB. In submitting your proposal, you must include an index, appropriately referenced, of all the certified cost or pricing data and information accompanying or identified in the proposal. In addition, you must annotate any future additions and/or revisions, up to the date of agreement on price, or an earlier date agreed upon by the parties, on a supplemental index.\nC. As part of the specific information required, you must submit, with your proposal  \n(1) Certified cost or pricing data (as defined at FAR 2.101 ). You must clearly identify on your cover sheet that certified cost or pricing data are included as part of the proposal.\n(2) Information reasonably required to explain your estimating process, including  \n(i) The judgmental factors applied and the mathematical or other methods used in the estimate, including those used in projecting from known data; and\n(ii) The nature and amount of any contingencies included in the proposed price.\nD. You must show the relationship between contract line item prices and the total contract price. You must attach cost-element breakdowns for each proposed line item, using the appropriate format prescribed in the  Formats for Submission of Line Item Summaries  section of this table. You must furnish supporting breakdowns for each cost element, consistent with your cost accounting system.\nE. When more than one contract line item is proposed, you must also provide summary total amounts covering all line items for each element of cost.\nF. Whenever you have incurred costs for work performed before submission of a proposal, you must identify those costs in your cost/price proposal.\nG. If you have reached an agreement with Government representatives on use of forward pricing rates/factors, identify the agreement, include a copy, and describe its nature.\nH. As soon as practicable after final agreement on price or an earlier date agreed to by the parties, but before the award resulting from the proposal, you must, under the conditions stated in FAR 15.406-2 , submit a Certificate of Current Cost or Pricing Data.\nII. Cost Elements\nDepending on your system, you must provide breakdowns for the following basic cost elements, as applicable: \nA. Materials and services . Provide a consolidated priced summary of individual material quantities included in the various tasks, orders, or contract line items being proposed and the basis for pricing (vendor quotes, invoice prices, etc.). Include raw materials, parts, components, assemblies, and services to be produced or performed by others. For all items proposed, identify the item and show the source, quantity, and price. Conduct price analyses of all subcontractor proposals. Conduct cost analyses for all subcontracts when certified cost or pricing data are submitted by the subcontractor. Include these analyses as part of your own certified cost or pricing data submissions for subcontracts expected to exceed the appropriate threshold in FAR 15.403-4 . Submit the subcontractor certified cost or pricing data and data other than certified cost or pricing data as part of your own certified cost or pricing data as required in paragraph IIA(2) of this table. These requirements also apply to all subcontractors if required to submit certified cost or pricing data.\n(1) Adequate Price Competition. Provide data showing the degree of competition and the basis for establishing the source and reasonableness of price for those acquisitions (such as subcontracts, purchase orders, material order, etc.) exceeding, or expected to exceed, the appropriate threshold set forth at FAR 15.403-4 priced on the basis of adequate price competition. For interorganizational transfers priced at other than the cost of comparable competitive commercial work of the division, subsidiary, or affiliate of the contractor, explain the pricing method (see FAR 31.205-26 (e)).\n(2) All Other . Obtain certified cost or pricing data from prospective sources for those acquisitions (such as subcontracts, purchase orders, material order, etc.) exceeding the threshold set forth in FAR 15.403-4 and not otherwise exempt, in accordance with FAR 15.403-1 (b) ( i.e. , adequate price competition, commercial items, prices set by law or regulation or waiver). Also provide data showing the basis for establishing source and reasonableness of price. In addition, provide a summary of your cost analysis and a copy of certified cost or pricing data submitted by the prospective source in support of each subcontract, or purchase order that is the lower of either $12.5 million or more, or both more than the pertinent certified cost or pricing data threshold and more than 10 percent of the prime contractor's proposed price. Also submit any information reasonably required to explain your estimating process (including the judgmental factors applied and the mathematical or other methods used in the estimate, including those used in projecting from known data, and the nature and amount of any contingencies included in the price). The Contracting Officer may require you to submit cost or pricing data in support of proposals in lower amounts. Subcontractor certified cost or pricing data must be accurate, complete and current as of the date of final price agreement, or an earlier date agreed upon by the parties, given on the prime contractor  s Certificate of Current Cost or Pricing Data. The prime contractor is responsible for updating a prospective subcontractor  s data. For standard commercial items fabricated by the offeror that are generally stocked in inventory, provide a separate cost breakdown, if priced based on cost. For interorganizational transfers priced at cost, provide a separate breakdown of cost elements. Analyze the certified cost or pricing data and submit the results of your analysis of the prospective source  s proposal.When submission of a prospective source  s certified cost or pricing data is required as described in this paragraph, it must be included as part of your own certified cost or pricing data. You must also submit any data other than certified cost or pricing data obtained from a subcontractor, either actually or by specific identification, along with the results of any analysis performed on that data.\nB. Direct Labor . Provide a time-phased ( e.g., monthly, quarterly, etc.) breakdown of labor hours, rates, and cost by appropriate category, and furnish bases for estimates.\nC. Indirect Costs . Indicate how you have computed and applied your indirect costs, including cost breakdowns. Show trends and budgetary data to provide a basis for evaluating the reasonableness of proposed rates. Indicate the rates used and provide an appropriate explanation.\nD. Other Costs . List all other costs not otherwise included in the categories described above ( e.g. , special tooling, travel, computer and consultant services, preservation, packaging and packing, spoilage and rework, and Federal excise tax on finished articles) and provide bases for pricing.\nE. Royalties . If royalties exceed $1,500, you must provide the following information on a separate page for each separate royalty or license fee:\n(1) Name and address of licensor.\n(2) Date of license agreement.\n(3) Patent numbers.\n(4) Patent application serial numbers, or other basis on which the royalty is payable.\n(5) Brief description (including any part or model numbers of each contract item or component on which the royalty is payable)\n(6) Percentage or dollar rate of royalty per unit.\n(7) Unit price of contract item.\n(8) Number of units.\n(9) Total dollar amount of royalties.\n(10) If specifically requested by the Contracting Officer, a copy of the current license agreement and identification of applicable claims of specific patents (see FAR 27.202 and 31.205-37 ).\nF. Facilities Capital Cost of Money . When you elect to claim facilities capital cost of money as an allowable cost, you must submit Form CASB-CMF and show the calculation of the proposed amount (see FAR 31.205-10 ).\nIII. Formats for Submission of Line Item Summaries\nA. New Contracts (including letter contracts) .\nCost Elements\nProposed Contract Estimate  Total Cost\nProposed Contract Estimate  Unit Cost\nReference\n(1)\n(2)\n(3)\n(4)\nColumn\nInstruction\n(1)\nEnter appropriate cost elements.\n(2)\nEnter those necessary and reasonable costs that, in your judgment, will properly be incurred in efficient contract performance. When any of the costs in this column have already been incurred ( e.g., under a letter contract), describe them on an attached supporting page. When preproduction or startup costs are significant, or when specifically requested to do so by the Contracting Officer, provide a full identification and explanation of them.\n(3)\nOptional, unless required by the Contracting Officer.\n(4)\nIdentify the attachment in which the information supporting the specific cost element may be found.\n(Attach separate pages as necessary.)\nB. Change Orders, Modifications, and Claims.\nCost Elements\nEstimated Cost of All Work Deleted\nCost of Deleted Work Already Performed\nNet Cost To Be Deleted\nCost of Work Added\nNet Cost of Change\nReference\n(1)\n(2)\n(3)\n(4)\n(5)\n(6)\n(7)\nColumn\nInstruction\n(1)\nEnter appropriate cost elements.\n(2)\nInclude the current estimates of what the cost would have been to complete the deleted work not yet performed (not the original proposal estimates), and the cost of deleted work already performed.\n(3)\nInclude the incurred cost of deleted work already performed, using actuals incurred if possible, or, if actuals are not available, estimates from your accounting records. Attach a detailed inventory of work, materials, parts, components, and hardware already purchased, manufactured, or performed and deleted by the change, indicating the cost and proposed disposition of each line item. Also, if you desire to retain these items or any portion of them, indicate the amount offered for them.\n(4)\nEnter the net cost to be deleted, which is the estimated cost of all deleted work less the cost of deleted work already performed. Column (2) minus Column (3) equals Column (4).\n(5)\nEnter your estimate for cost of work added by the change. When nonrecurring costs are significant, or when specifically requested to do so by the Contracting Officer, provide a full identification and explanation of them. When any of the costs in this column have already been incurred, describe them on an attached supporting schedule.\n(6)\nEnter the net cost of change, which is the cost of work added, less the net cost to be deleted. Column (5) minus Column (4) equals Column (6). When this result is negative, place the amount in parentheses.\n(7)\nIdentify the attachment in which the information supporting the specific cost element may be found.\n(Attach separate pages as necessary.)\nC. Price Revision/Redetermination.\nCutoff Date\nNumber of Units Completed\nNumber of Units To Be Completed\nContract Amount\nRedertermination Proposal Amount\nDifference\n(1)\n(2)\n(3)\n(4)\n(5)\n(6)\nCost Elements\nIncurred Cost  Preproduction\nIncurred Cost  Completed Units\nIncurred Cost  Work in Progress\nTotal Incurred Cost\nEstimated Cost to Complete\nEstimated Total Cost\nReference\n(7)\n(8)\n(9)\n(10)\n(11)\n(12)\n(13)\n(14)\n(Use as applicable)\nColumn\nInstruction\n(1)\nEnter the cutoff date required by the contract, if applicable.\n(2)\nEnter the number of units completed during the period for which experienced costs of production are being submitted.\n(3)\nEnter the number of units remaining to be completed under the contract.\n(4)\nEnter the cumulative contract amount.\n(5)\nEnter your redetermination proposal amount.\n(6)\nEnter the difference between the contract amount and the redetermination proposal amount. When this result is negative, place the amount in parentheses. Column (4) minus Column (5) equals Column (6).\n(7)\nEnter appropriate cost elements. When residual inventory exists, the final costs established under fixed-price-incentive and fixed-price-redeterminable arrangements should be net of the fair market value of such inventory. In support of subcontract costs, submit a listing of all subcontracts subject to repricing action, annotated as to their status.\n(8)\nEnter all costs incurred under the contract before starting production and other nonrecurring costs (usually referred to as startup costs) from your books and records as of the cutoff date. These include such costs as preproduction engineering, special plant rearrangement, training program, and any identifiable nonrecurring costs such as initial rework, spoilage, pilot runs, etc. In the event the amounts are not segregated in or otherwise available from your records, enter in this column your best estimates. Explain the basis for each estimate and how the costs are charged on your accounting records ( e.g., included in production costs as direct engineering labor, charged to manufacturing overhead). Also show how the costs would be allocated to the units at their various stages of contract completion.\n(9)\nEnter in Column (9) the production costs from your books and records (exclusive of preproduction costs reported in Column (8)) of the units completed as of the cutoff date.\n(10)\nEnter in Column (10) the costs of work in process as determined from your records or inventories at the cutoff date. When the amounts for work in process are not available in your records but reliable estimates for them can be made, enter the estimated amounts in Column (10) and enter in column (9) the differences between the total incurred costs (exclusive of preproduction costs) as of the cutoff date and these estimates. Explain the basis for the estimates, including identification of any provision for experienced or anticipated allowances, such as shrinkage, rework, design changes, etc. Furnish experienced unit or lot costs (or labor hours) from inception of contract to the cutoff date, improvement curves, and any other available production cost history pertaining to the item(s) to which your proposal relates.\n(11)\nEnter total incurred costs (Total of Columns (8), (9), and (10)).\n(12)\nEnter those necessary and reasonable costs that in your judgment will properly be incurred in completing the remaining work to be performed under the contract with respect to the item(s) to which your proposal relates.\n(13)\nEnter total estimated cost (Total of Columns (11) and (12)).\n(14)\nIdentify the attachment in which the information supporting the specific cost element may be found.\n(Attach separate pages as necessary.)");
register_book(&s, "|15|5|", "Preaward, Award, and Postaward Notifica", "Subpart 15.5  Preaward, Award, and Postaward Notifications, Protests, and Mistakes\n15.501 Definition.\nDay,  as used in this subpart, has the meaning set forth at 33.101 .\n15.502 Applicability.\nThis subpart applies to competitive proposals, as described in 6.102 (b), and a combination of competitive procedures, as described in 6.102 (c). The procedures in 15.504 , 15.506 , 15.507 , 15.508 , and 15.509 , with reasonable modification, should be followed for sole source acquisitions and acquisitions described in 6.102 (d)(1) and (2).\n15.503 Notifications to unsuccessful offerors.\n(a) Preaward notices  \n(1) Preaward notices of exclusion from competitive range . The contracting officer shall notify offerors promptly in writing when their proposals are excluded from the competitive range or otherwise eliminated from the competition. The notice shall state the basis for the determination and that a proposal revision will not be considered.\n(2) Preaward notices for small business programs.\n(i) In addition to the notice in paragraph (a)(1) of this section, the contracting officer shall notify each offeror in writing prior to award, upon completion of negotiations, determinations of responsibility, and, if necessary, the process in 19.304 (d)  \n(A) When using a small business set-aside (see Subpart 19.5 );\n(B) When a small disadvantaged business concern receives a benefit based on its disadvantaged status (see Subpart 19.11 and 19.1202 ) and is the apparently successful offeror;\n(C) When using the HUBZone procedures in 19.1305 or 19.1307 ; \n(D) When using the service-disabled veteran-owned small business procedures in 19.1405 ; or\n(E) When using the Woman-Owned Small Business Program procedures in 19.1505 .\n(ii) The notice shall state  \n(A) The name and address of the apparently successful offeror;\n(B) That the Government will not consider subsequent revisions of the offeror  s proposal; and\n(C) That no response is required unless a basis exists to challenge the size status or small business status of the apparently successful offeror ( e.g. , small business concern, small disadvantaged business concern, HUBZone small business concern, service-disabled veteran-owned small business concern, economically disadvantaged women-owned small business concern, or women-owned small business concern eligible under the Women-Owned Small Business Program).\n(iii) The notice is not required when the contracting officer determines in writing that the urgency of the requirement necessitates award without delay or when the contract is entered into under the 8(a) program (see 19.805-2 ).\n(b) Postaward notices.\n(1) Within 3 days after the date of contract award, the contracting officer shall provide written notification to each offeror whose proposal was in the competitive range but was not selected for award ( 10 U.S.C. 2305(b)(5) and 41 U.S.C. 253b(c) ) or had not been previously notified under paragraph (a) of this section. The notice shall include  \n(i) The number of offerors solicited;\n(ii) The number of proposals received;\n(iii) The name and address of each offeror receiving an award;\n(iv) The items, quantities, and any stated unit prices of each award. If the number of items or other factors makes listing any stated unit prices impracticable at that time, only the total contract price need be furnished in the notice. However, the items, quantities, and any stated unit prices of each award shall be made publicly available, upon request; and\n(v) In general terms, the reason(s) the offeror  s proposal was not accepted, unless the price information in paragraph (b)(1)(iv) of this section readily reveals the reason. In no event shall an offeror  s cost breakdown, profit, overhead rates, trade secrets, manufacturing processes and techniques, or other confidential business information be disclosed to any other offeror.\n(2) Upon request, the contracting officer shall furnish the information described in paragraph (b)(1) of this section to unsuccessful offerors in solicitations using simplified acquisition procedures in Part 13 .\n(3) Upon request, the contracting officer shall provide the information in paragraph (b)(1) of this section to unsuccessful offerors that received a preaward notice of exclusion from the competitive range.\n15.504 Award to successful offeror.\nThe contracting officer shall award a contract to the successful offeror by furnishing the executed contract or other notice of the award to that offeror.\n(a) If the award document includes information that is different than the latest signed proposal, as amended by the offeror  s written correspondence, both the offeror and the contracting officer shall sign the contract award.\n(b) When an award is made to an offeror for less than all of the items that may be awarded and additional items are being withheld for subsequent award, each notice shall state that the Government may make subsequent awards on those additional items within the proposal acceptance period.\n(c) If the Optional Form (OF) 307 , Contract Award, Standard Form (SF) 26 , Award/Contract, or SF 33 , Solicitation, Offer and Award, is not used to award the contract, the first page of the award document shall contain the Government  s acceptance statement from Block 15 of that form, exclusive of the Item 3 reference language, and shall contain the contracting officer  s name, signature, and date. In addition, if the award document includes information that is different than the signed proposal, as amended by the offeror  s written correspondence, the first page shall include the contractor  s agreement statement from Block 14 of the OF 307 and the signature of the contractor  s authorized representative.\n15.505 Preaward debriefing of offerors.\nOfferors excluded from the competitive range or otherwise excluded from the competition before award may request a debriefing before award ( 10 U.S.C. 2305(b)(6)(A) and 41 U.S.C. 253b(f) - (h)).\n(a)(1) The offeror may request a preaward debriefing by submitting a written request for debriefing to the contracting officer within 3 days after receipt of the notice of exclusion from the competition.\n(2) At the offeror  s request, this debriefing may be delayed until after award. If the debriefing is delayed until after award, it shall include all information normally provided in a postaward debriefing (see 15.506 (d)). Debriefings delayed pursuant to this paragraph could affect the timeliness of any protest filed subsequent to the debriefing.\n(3) If the offeror does not submit a timely request, the offeror need not be given either a preaward or a postaward debriefing. Offerors are entitled to no more than one debriefing for each proposal.\n(b) The contracting officer shall make every effort to debrief the unsuccessful offeror as soon as practicable, but may refuse the request for a debriefing if, for compelling reasons, it is not in the best interests of the Government to conduct a debriefing at that time. The rationale for delaying the debriefing shall be documented in the contract file. If the contracting officer delays the debriefing, it shall be provided no later than the time postaward debriefings are provided under 15.506 . In that event, the contracting officer shall include the information at 15.506 (d) in the debriefing.\n(c) Debriefings may be done orally, in writing, or by any other method acceptable to the contracting officer.\n(d) The contracting officer should normally chair any debriefing session held. Individuals who conducted the evaluations shall provide support.\n(e) At a minimum, preaward debriefings shall include  \n(1) The agency  s evaluation of significant elements in the offeror  s proposal;\n(2) A summary of the rationale for eliminating the offeror from the competition; and\n(3) Reasonable responses to relevant questions about whether source selection procedures contained in the solicitation, applicable regulations, and other applicable authorities were followed in the process of eliminating the offeror from the competition.\n(f) Preaward debriefings shall not disclose  \n(1) The number of offerors;\n(2) The identity of other offerors;\n(3) The content of other offerors  proposals;\n(4) The ranking of other offerors;\n(5) The evaluation of other offerors; or\n(6) Any of the information prohibited in 15.506 (e).\n(g) An official summary of the debriefing shall be included in the contract file.\n15.506 Postaward debriefing of offerors.\n(a)(1) An offeror, upon its written request received by the agency within 3 days after the date on which that offeror has received notification of contract award in accordance with 15.503 (b), shall be debriefed and furnished the basis for the selection decision and contract award.\n(2) To the maximum extent practicable, the debriefing should occur within 5 days after receipt of the written request. Offerors that requested a postaward debriefing in lieu of a preaward debriefing, or whose debriefing was delayed for compelling reasons beyond contract award, also should be debriefed within this time period.\n(3) An offeror that was notified of exclusion from the competition (see 15.505 (a)), but failed to submit a timely request, is not entitled to a debriefing.\n(4)(i) Untimely debriefing requests may be accommodated.\n(ii) Government accommodation of a request for delayed debriefing pursuant to 15.505 (a)(2), or any untimely debriefing request, does not automatically extend the deadlines for filing protests. Debriefings delayed pursuant to 15.505 (a)(2) could affect the timeliness of any protest filed subsequent to the debriefing.\n(b) Debriefings of successful and unsuccessful offerors may be done orally, in writing, or by any other method acceptable to the contracting officer.\n(c) The contracting officer should normally chair any debriefing session held. Individuals who conducted the evaluations shall provide support.\n(d) At a minimum, the debriefing information shall include  \n(1) The Government  s evaluation of the significant weaknesses or deficiencies in the offeror  s proposal, if applicable;\n(2) The overall evaluated cost or price (including unit prices) and technical rating, if applicable, of the successful offeror and the debriefed offeror, and past performance information on the debriefed offeror;\n(3) The overall ranking of all offerors, when any ranking was developed by the agency during the source selection;\n(4) A summary of the rationale for award;\n(5) For acquisitions of commercial items, the make and model of the item to be delivered by the successful offeror; and\n(6) Reasonable responses to relevant questions about whether source selection procedures contained in the solicitation, applicable regulations, and other applicable authorities were followed.\n(e) The debriefing shall not include point-by-point comparisons of the debriefed offeror  s proposal with those of other offerors. Moreover, the debriefing shall not reveal any information prohibited from disclosure by 24.202 or exempt from release under the Freedom of Information Act ( 5 U.S.C. 552 ) including  \n(1) Trade secrets;\n(2) Privileged or confidential manufacturing processes and techniques;\n(3) Commercial and financial information that is privileged or confidential, including cost breakdowns, profit, indirect cost rates, and similar information; and\n(4) The names of individuals providing reference information about an offeror  s past performance.\n(f) An official summary of the debriefing shall be included in the contract file.\n15.507 Protests against award.\n(a) Protests against award in negotiated acquisitions shall be handled in accordance with Part 33 . Use of agency protest procedures that incorporate the alternative dispute resolution provisions of Executive Order 12979 is encouraged for both preaward and postaward protests.\n(b) If a protest causes the agency, within 1 year of contract award, to  \n(1) Issue a new solicitation on the protested contract award, the contracting officer shall provide the information in paragraph (c) of this section to all prospective offerors for the new solicitation; or\n(2) Issue a new request for revised proposals on the protested contract award, the contracting officer shall provide the information in paragraph (c) of this section to offerors that were in the competitive range and are requested to submit revised proposals.\n(c) The following information will be provided to appropriate parties:\n(1) Information provided to unsuccessful offerors in any debriefings conducted on the original award regarding the successful offeror  s proposal; and\n(2) Other nonproprietary information that would have been provided to the original offerors.\n15.508 Discovery of mistakes.\nMistakes in a contractor  s proposal that are disclosed after award shall be processed substantially in accordance with the procedures for mistakes in bids at 14.407-4 .\n15.509 Forms.\nOptional Form 307 , Contract Award, Standard Form (SF) 26 , Award/Contract, or SF 33 , Solicitation, Offer and Award, may be used to award negotiated contracts in which the signature of both parties on a single document is appropriate. Note however, if using the SF 26 for a negotiated procurement, block 18 is not to be used. If these forms are not used, the award document shall incorporate the agreement and award language from the OF 307 .");
register_book(&s, "|15|6|", "Unsolicited Proposals", "Subpart 15.6  Unsolicited Proposals\n15.600 Scope of subpart.\nThis subpart sets forth policies and procedures concerning the submission, receipt, evaluation, and acceptance or rejection of unsolicited proposals.\n15.601 Definitions.\nAs used in this subpart  \nAdvertising material  means material designed to acquaint the Government with a prospective contractor  s present products, services, or potential capabilities, or designed to stimulate the Government  s interest in buying such products or services.\nCommercial item offer  means an offer of a commercial item that the vendor wishes to see introduced in the Government  s supply system as an alternate or a replacement for an existing supply item. This term does not include innovative or unique configurations or uses of commercial items that are being offered for further development and that may be submitted as an unsolicited proposal.\nContribution  means a concept, suggestion, or idea presented to the Government for its use with no indication that the source intends to devote any further effort to it on the Government  s behalf.\n15.602 Policy.\nIt is the policy of the Government to encourage the submission of new and innovative ideas in response to Broad Agency Announcements, Small Business Innovation Research topics, Small Business Technology Transfer Research topics, Program Research and Development Announcements, or any other Government-initiated solicitation or program. When the new and innovative ideas do not fall under topic areas publicized under those programs or techniques, the ideas may be submitted as unsolicited proposals.\n15.603 General.\n(a) Unsolicited proposals allow unique and innovative ideas or approaches that have been developed outside the Government to be made available to Government agencies for use in accomplishment of their missions. Unsolicited proposals are offered with the intent that the Government will enter into a contract with the offeror for research and development or other efforts supporting the Government mission, and often represent a substantial investment of time and effort by the offeror.\n(b) Advertising material, commercial item offers, or contributions, as defined in 15.601 , or routine correspondence on technical issues, are not unsolicited proposals.\n(c) A valid unsolicited proposal must  \n(1) Be innovative and unique;\n(2) Be independently originated and developed by the offeror;\n(3) Be prepared without Government supervision, endorsement, direction, or direct Government involvement;\n(4) Include sufficient detail to permit a determination that Government support could be worthwhile and the proposed work could benefit the agency  s research and development or other mission responsibilities;\n(5) Not be an advance proposal for a known agency requirement that can be acquired by competitive methods; and\n(6) Not address a previously published agency requirement.\n(d) Unsolicited proposals in response to a publicized general statement of agency needs are considered to be independently originated.\n(e) Agencies must evaluate unsolicited proposals for energy-savings performance contracts in accordance with the procedures in 10 CFR 436.33(b).\n15.604 Agency points of contact.\n(a) Preliminary contact with agency technical or other appropriate personnel before preparing a detailed unsolicited proposal or submitting proprietary information to the Government may save considerable time and effort for both parties (see 15.201 ). Agencies must make available to potential offerors of unsolicited proposals at least the following information:\n(1) Definition (see 2.101 ) and content (see 15.605 ) of an unsolicited proposal acceptable for formal evaluation.\n(2) Requirements concerning responsible prospective contractors (see Subpart 9.1 ), and organizational conflicts of interest (see Subpart 9.5 ).\n(3) Guidance on preferred methods for submitting ideas/concepts to the Government, such as any agency: upcoming solicitations; Broad Agency Announcements; Small Business Innovation Research programs; Small Business Technology Transfer Research programs; Program Research and Development Announcements; or grant programs.\n(4) Agency points of contact for information regarding advertising, contributions, and other types of transactions similar to unsolicited proposals.\n(5) Information sources on agency objectives and areas of potential interest.\n(6) Procedures for submission and evaluation of unsolicited proposals.\n(7) Instructions for identifying and marking proprietary information so that it is protected and restrictive legends conform to 15.609 .\n(b) Only the cognizant contracting officer has the authority to bind the Government regarding unsolicited proposals.\n15.605 Content of unsolicited proposals.\nUnsolicited proposals should contain the following information to permit consideration in an objective and timely manner:\n(a) Basic information including  \n(1) Offeror  s name and address and type of organization; e.g., profit, nonprofit, educational, small business;\n(2) Names and telephone numbers of technical and business personnel to be contacted for evaluation or negotiation purposes;\n(3) Identification of proprietary data to be used only for evaluation purposes;\n(4) Names of other Federal, State, or local agencies or parties receiving the proposal or funding the proposed effort;\n(5) Date of submission; and\n(6) Signature of a person authorized to represent and contractually obligate the offeror.\n(b) Technical information including  \n(1) Concise title and abstract (approximately 200 words) of the proposed effort;\n(2) A reasonably complete discussion stating the objectives of the effort or activity, the method of approach and extent of effort to be employed, the nature and extent of the anticipated results, and the manner in which the work will help to support accomplishment of the agency  s mission;\n(3) Names and biographical information on the offeror  s key personnel who would be involved, including alternates; and\n(4) Type of support needed from the agency; e.g., Government property or personnel resources.\n(c) Supporting information including  \n(1) Proposed price or total estimated cost for the effort in sufficient detail for meaningful evaluation;\n(2) Period of time for which the proposal is valid (a 6-month minimum is suggested);\n(3) Type of contract preferred;\n(4) Proposed duration of effort;\n(5) Brief description of the organization, previous experience, relevant past performance, and facilities to be used;\n(6) Other statements, if applicable, about organizational conflicts of interest, security clearances, and environmental impacts; and\n(7) The names and telephone numbers of agency technical or other agency points of contact already contacted regarding the proposal.\n15.606 Agency procedures.\n(a) Agencies shall establish procedures for controlling the receipt, evaluation, and timely disposition of unsolicited proposals consistent with the requirements of this subpart. The procedures shall include controls on the reproduction and disposition of proposal material, particularly data identified by the offeror as subject to duplication, use, or disclosure restrictions.\n(b) Agencies shall establish agency points of contact (see 15.604 ) to coordinate the receipt and handling of unsolicited proposals.\n15.606-1 Receipt and initial review.\n(a) Before initiating a comprehensive evaluation, the agency contact point shall determine if the proposal  \n(1) Is a valid unsolicited proposal, meeting the requirements of 15.603 (c);\n(2) Is suitable for submission in response to an existing agency requirement (see 15.602 );\n(3) Is related to the agency mission;\n(4) Contains sufficient technical information and cost-related or price-related information for evaluation;\n(5) Has overall scientific, technical, or socioeconomic merit;\n(6) Has been approved by a responsible official or other representative authorized to obligate the offeror contractually; and\n(7) Complies with the marking requirements of 15.609 .\n(b) If the proposal meets these requirements, the contact point shall promptly acknowledge receipt and process the proposal.\n(c) If a proposal is rejected because the proposal does not meet the requirements of paragraph (a) of this subsection, the agency contact point shall promptly inform the offeror of the reasons for rejection in writing and of the proposed disposition of the unsolicited proposal.\n15.606-2 Evaluation.\n(a) Comprehensive evaluations shall be coordinated by the agency contact point, who shall attach or imprint on each unsolicited proposal, circulated for evaluation, the legend required by 15.609 (d). When performing a comprehensive evaluation of an unsolicited proposal, evaluators shall consider the following factors, in addition to any others appropriate for the particular proposal:\n(1) Unique, innovative, and meritorious methods, approaches, or concepts demonstrated by the proposal;\n(2) Overall scientific, technical, or socioeconomic merits of the proposal;\n(3) Potential contribution of the effort to the agency  s specific mission;\n(4) The offeror  s capabilities, related experience, facilities, techniques, or unique combinations of these that are integral factors for achieving the proposal objectives;\n(5) The qualifications, capabilities, and experience of the proposed principal investigator, team leader, or key personnel critical to achieving the proposal objectives; and\n(6) The realism of the proposed cost.\n(b) The evaluators shall notify the agency point of contact of their recommendations when the evaluation is completed.\n15.607 Criteria for acceptance and negotiation of an unsolicited proposal.\n(a) A favorable comprehensive evaluation of an unsolicited proposal does not, in itself, justify awarding a contract without providing for full and open competition. The agency point of contact shall return an unsolicited proposal to the offeror, citing reasons, when its substance  \n(1) Is available to the Government without restriction from another source;\n(2) Closely resembles a pending competitive acquisition requirement;\n(3) Does not relate to the activity  s mission; or\n(4) Does not demonstrate an innovative and unique method, approach, or concept, or is otherwise not deemed a meritorious proposal.\n(b) The contracting officer may commence negotiations on a sole source basis only when  \n(1) An unsolicited proposal has received a favorable comprehensive evaluation;\n(2) A justification and approval has been obtained (see 6.302-1 (a)(2)(i) for research proposals or other appropriate provisions of Subpart 6.3 , and 6.303-2 (c));\n(3) The agency technical office sponsoring the contract furnishes the necessary funds; and\n(4) The contracting officer has complied with the synopsis requirements of Subpart 5.2 .\n15.608 Prohibitions.\n(a) Government personnel shall not use any data, concept, idea, or other part of an unsolicited proposal as the basis, or part of the basis, for a solicitation or in negotiations with any other firm unless the offeror is notified of and agrees to the intended use. However, this prohibition does not preclude using any data, concept, or idea in the proposal that also is available from another source without restriction.\n(b) Government personnel shall not disclose restrictively marked information (see 3.104 and 15.609 ) included in an unsolicited proposal. The disclosure of such information concerning trade secrets, processes, operations, style of work, apparatus, and other matters, except as authorized by law, may result in criminal penalties under 18 U.S.C. 1905 .\n15.609 Limited use of data.\n(a) An unsolicited proposal may include data that the offeror does not want disclosed to the public for any purpose or used by the Government except for evaluation purposes. If the offeror wishes to restrict the data, the title page must be marked with the following legend:\nUse and Disclosure of Data\nThis proposal includes data that shall not be disclosed outside the Government and shall not be duplicated, used, or disclosed  in whole or in part  for any purpose other than to evaluate this proposal. However, if a contract is awarded to this offeror as a result of  or in connection with  the submission of these data, the Government shall have the right to duplicate, use, or disclose the data to the extent provided in the resulting contract. This restriction does not limit the Government's right to use information contained in these data if they are obtained from another source without restriction. The data subject to this restriction are contained in Sheets [ insert numbers or other identification of sheets ].\n(b) The offeror shall also mark each sheet of data it wishes to restrict with the following legend: Use or disclosure of data contained on this sheet is subject to the restriction on the title page of this proposal.\n(c) The agency point of contact shall return to the offeror any unsolicited proposal marked with a legend different from that provided in paragraph (a) of this section. The return letter will state that the proposal cannot be considered because it is impracticable for the Government to comply with the legend and that the agency will consider the proposal if it is resubmitted with the proper legend.\n(d) The agency point of contact shall place a cover sheet on the proposal or clearly mark it as follows, unless the offeror clearly states in writing that no restrictions are imposed on the disclosure or use of the data contained in the proposal:\nUnsolicited Proposal  Use of Data Limited\nAll Government personnel must exercise extreme care to ensure that the information in this proposal is not disclosed to an individual who has not been authorized access to such data in accordance with FAR 3.104 , and is not duplicated, used, or disclosed in whole or in part for any purpose other than evaluation of the proposal, without the written permission of the offeror. If a contract is awarded on the basis of this proposal, the terms of the contract shall control disclosure and use. This notice does not limit the Government's right to use information contained in the proposal if it is obtainable from another source without restriction. This is a Government notice, and shall not by itself be construed to impose any liability upon the Government or Government personnel for disclosure or use of data contained in this proposal.\n(e) Use the notice in paragraph (d) of this section solely as a manner of handling unsolicited proposals that will be compatible with this subpart. However, do not use this notice to justify withholding of a record, or to improperly deny the public access to a record, where an obligation is imposed by the Freedom of Information Act ( 5 U.S.C. 552 ). An offeror should identify trade secrets, commercial or financial information, and privileged or confidential information to the Government (see paragraph (a) of this section).\n(f) When an agency receives an unsolicited proposal without any restrictive legend from an educational or nonprofit organization or institution, and an evaluation outside the Government is necessary, the agency point of contact shall  \n(1) Attach a cover sheet clearly marked with the legend in paragraph (d) of this section;\n(2) Change the beginning of this legend to read  All Government and non-Government personnel . . . .  ; and\n(3) Require any non-Government evaluator to agree in writing that data in the proposal will not be disclosed to others outside the Government.\n(g) If the proposal is received with the restrictive legend (see paragraph (a) of this section), the modified cover sheet shall also be used and permission shall be obtained from the offeror before release of the proposal for evaluation by non-Government personnel.\n(h) When an agency receives an unsolicited proposal with or without a restrictive legend from other than an educational or nonprofit organization or institution, and evaluation by Government personnel outside the agency or by experts outside of the Government is necessary, written permission must be obtained from the offeror before release of the proposal for evaluation. The agency point of contact shall  \n(1) Clearly mark the cover sheet with the legend in paragraph (d) or as modified in paragraph (f) of this section; and\n(2) Obtain a written agreement from any non-Government evaluator stating that data in the proposal will not be disclosed to persons outside the Government.\n*    *    *    *    *    *");
register_book(&s, "|16|2|", "Fixed-Price Contracts", "Subpart 16.2  Fixed-Price Contracts\n16.201 General.\n(a) Fixed-price types of contracts provide for a firm price or, in appropriate cases, an adjustable price. Fixed-price contracts providing for an adjustable price may include a ceiling price, a target price (including target cost), or both. Unless otherwise specified in the contract, the ceiling price or target price is subject to adjustment only by operation of contract clauses providing for equitable adjustment or other revision of the contract price under stated circumstances. The contracting officer shall use firm-fixed-price or fixed-price with economic price adjustment contracts when acquiring commercial items, except as provided in 12.207 (b).\n(b) Time-and-materials contracts and labor-hour contracts are not fixed-price contracts.\n16.202 Firm-fixed-price contracts.\n16.202-1 Description.\nA firm-fixed-price contract provides for a price that is not subject to any adjustment on the basis of the contractor  s cost experience in performing the contract. This contract type places upon the contractor maximum risk and full responsibility for all costs and resulting profit or loss. It provides maximum incentive for the contractor to control costs and perform effectively and imposes a minimum administrative burden upon the contracting parties. The contracting officer may use a firm-fixed-price contract in conjunction with an award-fee incentive (see 16.404 ) and performance or delivery incentives (see 16.402-2 and 16.402-3 ) when the award fee or incentive is based solely on factors other than cost. The contract type remains firm-fixed-price when used with these incentives.\n16.202-2 Application.\nA firm-fixed-price contract is suitable for acquiring commercial items (see Parts 2 and 12 ) or for acquiring other supplies or services on the basis of reasonably definite functional or detailed specifications (see Part 11 ) when the contracting officer can establish fair and reasonable prices at the outset, such as when  \n(a) There is adequate price competition;\n(b) There are reasonable price comparisons with prior purchases of the same or similar supplies or services made on a competitive basis or supported by valid certified cost or pricing data;\n(c) Available cost or pricing information permits realistic estimates of the probable costs of performance; or\n(d) Performance uncertainties can be identified and reasonable estimates of their cost impact can be made, and the contractor is willing to accept a firm fixed price representing assumption of the risks involved.\n16.203 Fixed-price contracts with economic price adjustment.\n16.203-1 Description.\n(a) A fixed-price contract with economic price adjustment provides for upward and downward revision of the stated contract price upon the occurrence of specified contingencies. Economic price adjustments are of three general types:\n(1) Adjustments based on established prices. These price adjustments are based on increases or decreases from an agreed-upon level in published or otherwise established prices of specific items or the contract end items.\n(2) Adjustments based on actual costs of labor or material . These price adjustments are based on increases or decreases in specified costs of labor or material that the contractor actually experiences during contract performance.\n(3) Adjustments based on cost indexes of labor or material . These price adjustments are based on increases or decreases in labor or material cost standards or indexes that are specifically identified in the contract.\n(b) The contracting officer may use a fixed-price contract with economic price adjustment in conjunction with an award-fee incentive (see 16.404 ) and performance or delivery incentives (see 16.402-2 and 16.402-3 ) when the award fee or incentive is based solely on factors other than cost. The contract type remains fixed-price with economic price adjustment when used with these incentives.\n16.203-2 Application.\nA fixed-price contract with economic price adjustment may be used when (i) there is serious doubt concerning the stability of market or labor conditions that will exist during an extended period of contract performance, and (ii) contingencies that would otherwise be included in the contract price can be identified and covered separately in the contract. Price adjustments based on established prices should normally be restricted to industry-wide contingencies. Price adjustments based on labor and material costs should be limited to contingencies beyond the contractor  s control. For use of economic price adjustment in sealed bid contracts, see 14.408-4 .\n(a) In establishing the base level from which adjustment will be made, the contracting officer shall ensure that contingency allowances are not duplicated by inclusion in both the base price and the adjustment requested by the contractor under economic price adjustment clause.\n(b) In contracts that do not require submission of certified cost or pricing data, the contracting officer shall obtain adequate data to establish the base level from which adjustment will be made and may require verification of data submitted.\n16.203-3 Limitations.\nA fixed-price contract with economic price adjustment shall not be used unless the contracting officer determines that it is necessary either to protect the contractor and the Government against significant fluctuations in labor or material costs or to provide for contract price adjustment in the event of changes in the contractor  s established prices.\n16.203-4 Contract clauses.\n(a) Adjustment based on established prices  standard supplies.\n(1) The contracting officer shall, when contracting by negotiation, insert the clause at 52.216-2 , Economic Price Adjustment  Standard Supplies, or an agency-prescribed clause as authorized in paragraph (a)(2) of this subsection, in solicitations and contracts when all of the following conditions apply:\n(i) A fixed-price contract is contemplated.\n(ii) The requirement is for standard supplies that have an established catalog or market price.\n(iii) The contracting officer has made the determination specified in 16.203-3 .\n(2) If all the conditions in paragraph (a)(1) of this subsection apply and the contracting officer determines that the use of the clause at 52.216-2 is inappropriate, the contracting officer may use an agency-prescribed clause instead of the clause at 52.216-2 .\n(3) If the negotiated unit price reflects a net price after applying a trade discount from a catalog or list price, the contracting officer shall document in the contract file both the catalog or list price and the discount. (This does not apply to prompt payment or cash discounts.)\n(b) Adjustment based on established prices  semistandard supplies.\n(1) The contracting officer shall, when contracting by negotiation, insert the clause at 52.216-3 , Economic Price Adjustment  Semistandard Supplies, or an agency-prescribed clause as authorized in paragraph (b)(2) of this section, in solicitations and contracts when all of the following conditions apply:\n(i) A fixed-price contract is contemplated.\n(ii) The requirement is for semistandard supplies for which the prices can be reasonably related to the prices of nearly equivalent standard supplies that have an established catalog or market price.\n(iii) The contracting officer has made the determination specified in 16.203-3 .\n(2) If all conditions in paragraph (b)(1) of this subsection apply and the contracting officer determines that the use of the clause at 52.216-3 is inappropriate, the contracting officer may use an agency-prescribed clause instead of the clause at 52.216-3 .\n(3) If the negotiated unit price reflects a net price after applying a trade discount from a catalog or list price, the contracting officer shall document in the contract file both the catalog or list price and the discount. (This does not apply to prompt payment or cash discounts.)\n(4) Before entering into the contract, the contracting officer and contractor must agree in writing on the identity of the standard supplies and the corresponding contract line items to which the clause applies.\n(5) If the supplies are standard, except for preservation, packaging, and packing requirements, the clause prescribed in 16.203-4 (a) shall be used rather than this clause.\n(c) Adjustments based on actual cost of labor or material.\n(1) The contracting officer shall, when contracting by negotiation, insert a clause that is substantially the same as the clause at 52.216-4 , Economic Price Adjustment  Labor and Material, or an agency-prescribed clause as authorized in subparagraph (c)(2) of this section, in solicitations and contracts when all of the following conditions apply:\n(i) A fixed-price contract is contemplated.\n(ii) There is no major element of design engineering or development work involved.\n(iii) One or more identifiable labor or material cost factors are subject to change.\n(iv) The contracting officer has made the determination specified in 16.203-3 .\n(2) If all conditions in paragraph (c)(1) of this section apply and the contracting officer determines that the use of the clause at 52.216-4 is inappropriate, the contracting officer may use an agency-prescribed clause instead of the clause at 52.216-4 .\n(3) The contracting officer shall describe in detail in the contract Schedule  \n(i) The types of labor and materials subject to adjustment under the clause;\n(ii) The labor rates, including fringe benefits (if any) and unit prices of materials that may be increased or decreased; and\n(iii) The quantities of the specified labor and materials allocable to each unit to be delivered under the contract.\n(4) In negotiating adjustments under the clause, the contracting officer shall  \n(i) Consider work in process and materials on hand at the time of changes in labor rates, including fringe benefits (if any) or material prices;\n(ii) Not include in adjustments any indirect cost (except fringe benefits as defined in 31.205-6 (m)) or profit; and\n(iii) Consider only those fringe benefits specified in the contract Schedule.\n(d) Adjustments based on cost indexes of labor or material . The contracting officer should consider using an economic price adjustment clause based on cost indexes of labor or material under the circumstances and subject to approval as described in paragraphs (d)(1) and (d)(2) of this section.\n(1) A clause providing adjustment based on cost indexes of labor or materials may be appropriate when  \n(i) The contract involves an extended period of performance with significant costs to be incurred beyond 1 year after performance begins;\n(ii) The contract amount subject to adjustment is substantial; and\n(iii) The economic variables for labor and materials are too unstable to permit a reasonable division of risk between the Government and the contractor, without this type of clause.\n(2) Any clause using this method shall be prepared and approved under agency procedures. Because of the variations in circumstances and clause wording that may arise, no standard clause is prescribed.\n16.204 Fixed-price incentive contracts.\nA fixed-price incentive contract is a fixed-price contract that provides for adjusting profit and establishing the final contract price by a formula based on the relationship of final negotiated total cost to total target cost. Fixed-price incentive contracts are covered in Subpart 16.4 , Incentive Contracts. See 16.403 for more complete descriptions, application, and limitations for these contracts. Prescribed clauses are found at 16.406 .\n16.205 Fixed-price contracts with prospective price redetermination.\n16.205-1 Description.\nA fixed-price contract with prospective price redetermination provides for  \n(a) A firm fixed price for an initial period of contract deliveries or performance; and\n(b) Prospective redetermination, at a stated time or times during performance, of the price for subsequent periods of performance.\n16.205-2 Application.\nA fixed-price contract with prospective price redetermination may be used in acquisitions of quantity production or services for which it is possible to negotiate a fair and reasonable firm fixed price for an initial period, but not for subsequent periods of contract performance.\n(a) The initial period should be the longest period for which it is possible to negotiate a fair and reasonable firm fixed price. Each subsequent pricing period should be at least 12 months.\n(b) The contract may provide for a ceiling price based on evaluation of the uncertainties involved in performance and their possible cost impact. This ceiling price should provide for assumption of a reasonable proportion of the risk by the contractor and, once established, may be adjusted only by operation of contract clauses providing for equitable adjustment or other revision of the contract price under stated circumstances.\n16.205-3 Limitations.\nThis contract type shall not be used unless  \n(a) Negotiations have established that  \n(1) The conditions for use of a firm-fixed-price contract are not present (see 16.202-2 ); and\n(2) A fixed-price incentive contract would not be more appropriate;\n(b) The contractor  s accounting system is adequate for price redetermination;\n(c) The prospective pricing periods can be made to conform with operation of the contractor  s accounting system; and\n(d) There is reasonable assurance that price redetermination actions will take place promptly at the specified times.\n16.205-4 Contract clause.\nThe contracting officer shall, when contracting by negotiation, insert the clause at 52.216-5 , Price Redetermination  Prospective, in solicitations and contracts when a fixed-price contract is contemplated and the conditions specified in 16.205-2 and 16.205-3 (a) through (d) apply.\n16.206 Fixed-ceiling-price contracts with retroactive price redetermination.\n16.206-1 Description.\nA fixed-ceiling-price contract with retroactive price redetermination provides for  \n(a) A fixed ceiling price; and\n(b) Retroactive price redetermination within the ceiling after completion of the contract.\n16.206-2 Application.\nA fixed-ceiling-price contract with retroactive price redetermination is appropriate for research and development contracts estimated at $150,000 or less when it is established at the outset that a fair and reasonable firm fixed price cannot be negotiated and that the amount involved and short performance period make the use of any other fixed-price contract type impracticable.\n(a) A ceiling price shall be negotiated for the contract at a level that reflects a reasonable sharing of risk by the contractor. The established ceiling price may be adjusted only if required by the operation of contract clauses providing for equitable adjustment or other revision of the contract price under stated circumstances.\n(b) The contract should be awarded only after negotiation of a billing price that is as fair and reasonable as the circumstances permit.\n(c) Since this contract type provides the contractor no cost control incentive except the ceiling price, the contracting officer should make clear to the contractor during discussion before award that the contractor  s management effectiveness and ingenuity will be considered in retroactively redetermining the price.\n16.206-3 Limitations.\nThis contract type shall not be used unless  \n(a) The contract is for research and development and the estimated cost is $150,000 or less;\n(b) The contractor  s accounting system is adequate for price redetermination;\n(c) There is reasonable assurance that the price redetermination will take place promptly at the specified time; and\n(d) The head of the contracting activity (or a higher-level official, if required by agency procedures) approves its use in writing.\n16.206-4 Contract clause.\nThe contracting officer shall, when contracting by negotiation, insert the clause at 52.216-6 , Price Redetermination  Retroactive, in solicitations and contracts when a fixed-price contract is contemplated and the conditions in 16.206-2 and 16.206-3 (a) through (d) apply.\n16.207 Firm-fixed-price, level-of-effort term contracts.\n16.207-1 Description.\nA firm-fixed-price, level-of-effort term contract requires  \n(a) The contractor to provide a specified level of effort, over a stated period of time, on work that can be stated only in general terms; and\n(b) The Government to pay the contractor a fixed dollar amount.\n16.207-2 Application.\nA firm-fixed-price, level-of-effort term contract is suitable for investigation or study in a specific research and development area. The product of the contract is usually a report showing the results achieved through application of the required level of effort. However, payment is based on the effort expended rather than on the results achieved.\n16.207-3 Limitations.\nThis contract type may be used only when  \n(a) The work required cannot otherwise be clearly defined;\n(b) The required level of effort is identified and agreed upon in advance;\n(c) There is reasonable assurance that the intended result cannot be achieved by expending less than the stipulated effort; and\n(d) The contract price is $150,000 or less, unless approved by the chief of the contracting office.");
register_book(&s, "|16|3|", "Cost-Reimbursement Contracts", "Subpart 16.3  Cost-Reimbursement Contracts\n16.301 General.\n16.301-1 Description.\nCost-reimbursement types of contracts provide for payment of allowable incurred costs, to the extent prescribed in the contract. These contracts establish an estimate of total cost for the purpose of obligating funds and establishing a ceiling that the contractor may not exceed (except at its own risk) without the approval of the contracting officer.\n16.301-2 Application.\n(a) The contracting officer shall use cost-reimbursement contracts only when  \n(1) Circumstances do not allow the agency to define its requirements sufficiently to allow for a fixed-price type contract (see 7.105 ); or\n(2) Uncertainties involved in contract performance do not permit costs to be estimated with sufficient accuracy to use any type of fixed-price contract.\n(b) The contracting officer shall document the rationale for selecting the contract type in the written acquisition plan and ensure that the plan is approved and signed at least one level above the contracting officer (see 7.103 (j) and 7.105 ). \n16.301-3 Limitations.\n(a) A cost-reimbursement contract may be used only when -\n(1) The factors in 16.104 have been considered;\n(2) A written acquisition plan has been approved and signed at least one level above the contracting officer;\n(3) The contractor  s accounting system is adequate for determining costs applicable to the contract or order; and\n(4) Prior to award of the contract or order, adequate Government resources are available to award and manage a contract other than firm-fixed-priced (see 7.104 (e)). This includes appropriate Government surveillance during performance in accordance with 1.602-2 , to provide reasonable assurance that efficient methods and effective cost controls are used.\n(i) Designation of at least one contracting officer  s representative (COR) qualified in accordance with 1.602-2 has been made prior to award of the contract or order; and\n(ii) Appropriate Government surveillance during performance to provide reasonable assurance that efficient methods and effective cost controls are used.\n(b) The use of cost-reimbursement contracts is prohibited for the acquisition of commercial items (see Parts 2 and 12 ).\n16.302 Cost contracts.\n(a) Description. A cost contract is a cost-reimbursement contract in which the contractor receives no fee.\n(b) Application . A cost contract may be appropriate for research and development work, particularly with nonprofit educational institutions or other nonprofit organizations.\n(c) Limitations . See 16.301-3 .\n16.303 Cost-sharing contracts.\n(a) Description. A cost-sharing contract is a cost-reimbursement contract in which the contractor receives no fee and is reimbursed only for an agreed-upon portion of its allowable costs.\n(b) Application . A cost-sharing contract may be used when the contractor agrees to absorb a portion of the costs, in the expectation of substantial compensating benefits.\n(c) Limitations . See 16.301-3 .\n16.304 Cost-plus-incentive-fee contracts.\nA cost-plus-incentive-fee contract is a cost-reimbursement contract that provides for an initially negotiated fee to be adjusted later by a formula based on the relationship of total allowable costs to total target costs. Cost-plus-incentive-fee contracts are covered in Subpart 16.4 , Incentive Contracts. See 16.405-1 for a more complete description and discussion of application of these contracts. See 16.301-3 for limitations.\n16.305 Cost-plus-award-fee contracts.\nA cost-plus-award-fee contract is a cost-reimbursement contract that provides for a fee consisting of (a) a base amount (which may be zero) fixed at inception of the contract and (b) an award amount, based upon a judgmental evaluation by the Government, sufficient to provide motivation for excellence in contract performance. Cost-plus-award-fee contracts are covered in Subpart 16.4 , Incentive Contracts. See 16.401 (e) for a more complete description and discussion of the application of these contracts. See 16.301-3 and 16.401 (e)(5) for limitations.\n16.306 Cost-plus-fixed-fee contracts.\n(a) Description. A cost-plus-fixed-fee contract is a cost-reimbursement contract that provides for payment to the contractor of a negotiated fee that is fixed at the inception of the contract. The fixed fee does not vary with actual cost, but may be adjusted as a result of changes in the work to be performed under the contract. This contract type permits contracting for efforts that might otherwise present too great a risk to contractors, but it provides the contractor only a minimum incentive to control costs.\n(b) Application.\n(1) A cost-plus-fixed-fee contract is suitable for use when the conditions of 16.301-2 are present and, for example  \n(i) The contract is for the performance of research or preliminary exploration or study, and the level of effort required is unknown; or\n(ii) The contract is for development and test, and using a cost-plus-incentive-fee contract is not practical.\n(2) A cost-plus-fixed-fee contract normally should not be used in development of major systems (see Part 34 ) once preliminary exploration, studies, and risk reduction have indicated a high degree of probability that the development is achievable and the Government has established reasonably firm performance objectives and schedules.\n(c) Limitations . No cost-plus-fixed-fee contract shall be awarded unless the contracting officer complies with all limitations in 15.404-4 (c)(4)(i) and 16.301-3 .\n(d) Completion and term forms . A cost-plus-fixed-fee contract may take one of two basic forms  completion or term.\n(1) The completion form describes the scope of work by stating a definite goal or target and specifying an end product. This form of contract normally requires the contractor to complete and deliver the specified end product ( e.g., a final report of research accomplishing the goal or target) within the estimated cost, if possible, as a condition for payment of the entire fixed fee. However, in the event the work cannot be completed within the estimated cost, the Government may require more effort without increase in fee, provided the Government increases the estimated cost.\n(2) The term form describes the scope of work in general terms and obligates the contractor to devote a specified level of effort for a stated time period. Under this form, if the performance is considered satisfactory by the Government, the fixed fee is payable at the expiration of the agreed-upon period, upon contractor statement that the level of effort specified in the contract has been expended in performing the contract work. Renewal for further periods of performance is a new acquisition that involves new cost and fee arrangements.\n(3) Because of the differences in obligation assumed by the contractor, the completion form is preferred over the term form whenever the work, or specific milestones for the work, can be defined well enough to permit development of estimates within which the contractor can be expected to complete the work.\n(4) The term form shall not be used unless the contractor is obligated by the contract to provide a specific level of effort within a definite time period.\n16.307 Contract clauses.\n(a)(1) The contracting officer shall insert the clause at 52.216-7 , Allowable Cost and Payment, in solicitations and contracts when a cost-reimbursement contract or a time-and-materials contract (other than a contract for a commercial item) is contemplated. If the contract is a time-and-materials contract , the clause at 52.216-7 applies in conjunction with the clause at 52.232-7 ), but only to the portion of the contract that provides for reimbursement of materials (as defined in the clause at 52.232-7 ) at actual cost. Further, the clause at 52.216-7 does not apply to labor-hour contracts.\n(2) If the contract is a construction contract and contains the clause at 52.232-27 , Prompt Payment for Construction Contracts, the contracting officer shall use the clause at 52.216-7 with its Alternate I.\n(3) If the contract is with an educational institution, the contracting officer shall use the clause at 52.216-7 with its Alternate II.\n(4) If the contract is with a State or local government, the contracting officer shall use the clause at 52.216-7 with its Alternate III.\n(5) If the contract is with a nonprofit organization other than an educational institution, a State or local government, or a nonprofit organization exempted under OMB Circular No. A-122, the contracting officer shall use the clause at 52.216-7 with its Alternate IV.\n(b) The contracting officer shall insert the clause at 52.216-8 , Fixed Fee, in solicitations and contracts when a cost-plus-fixed-fee contract (other than a construction contract) is contemplated.\n(c) The contracting officer shall insert the clause at 52.216-9 , Fixed-Fee  Construction, in solicitations and contracts when a cost-plus-fixed-fee construction contract is contemplated.\n(d) The contracting officer shall insert the clause at 52.216-10 , Incentive Fee, in solicitations and contracts when a cost-plus-incentive-fee contract is contemplated.\n(e)(1) The contracting officer shall insert the clause at 52.216-11 , Cost Contract  No Fee, in solicitations and contracts when a cost-reimbursement contract is contemplated that provides no fee and is not a cost-sharing contract.\n(2) If a cost-reimbursement research and development contract with an educational institution or a nonprofit organization that provides no fee or other payment above cost and is not a cost-sharing contract is contemplated, and if the contracting officer determines that withholding of a portion of allowable costs is not required, the contracting officer shall use the clause with its Alternate I.\n(f)(1) The contracting officer shall insert the clause at 52.216-12 , Cost-Sharing Contract  No Fee, in solicitations and contracts when a cost-sharing contract is contemplated.\n(2) If a cost-sharing research and development contract with an educational institution or a nonprofit organization is contemplated, and if the contracting officer determines that withholding of a portion of allowable costs is not required, the contracting officer shall use the clause with its Alternate I.\n(g) The contracting officer shall insert the clause at 52.216-15 , Predetermined Indirect Cost Rates, in solicitations and contracts when a cost-reimbursement research and development contract with an educational institution (see 42.705-3 (b)) is contemplated and predetermined indirect cost rates are to be used.");
register_book(&s, "|16|4|", "Incentive Contracts", "Subpart 16.4  Incentive Contracts\n16.401 General.\n(a) Incentive contracts as described in this subpart are appropriate when a firm-fixed-price contract is not appropriate and the required supplies or services can be acquired at lower costs and, in certain instances, with improved delivery or technical performance, by relating the amount of profit or fee payable under the contract to the contractor  s performance. Incentive contracts are designed to obtain specific acquisition objectives by  \n(1) Establishing reasonable and attainable targets that are clearly communicated to the contractor; and\n(2) Including appropriate incentive arrangements designed to  \n(i) motivate contractor efforts that might not otherwise be emphasized; and\n(ii) discourage contractor inefficiency and waste.\n(b) When predetermined, formula-type incentives on technical performance or delivery are included, increases in profit or fee are provided only for achievement that sur-passes the targets, and decreases are provided for to the extent that such targets are not met. The incentive increases or decreases are applied to performance targets rather than minimum performance requirements.\n(c) The two basic categories of incentive contracts are fixed-price incentive contracts (see 16.403 and 16.404 ) and cost-reimbursement incentive contracts (see 16.405 ). Since it is usually to the Government  s advantage for the contractor to assume substantial cost responsibility and an appropriate share of the cost risk, fixed-price incentive contracts are preferred when contract costs and performance requirements are reasonably certain. Cost-reimbursement incentive contracts are subject to the overall limitations in 16.301 that apply to all cost-reimbursement contracts.\n(d) A determination and finding, signed by the head of the contracting activity, shall be completed for all incentive- and award-fee contracts justifying that the use of this type of contract is in the best interest of the Government. This determination shall be documented in the contract file and, for award-fee contracts, shall address all of the suitability items in 16.401 (e)(1).\n(e) Award-fee contracts are a type of incentive contract.\n(1) Application . An award-fee contract is suitable for use when  \n(i) The work to be performed is such that it is neither feasible nor effective to devise predetermined objective incentive targets applicable to cost, schedule, and technical performance;\n(ii) The likelihood of meeting acquisition objectives will be enhanced by using a contract that effectively motivates the contractor toward exceptional performance and provides the Government with the flexibility to evaluate both actual performance and the conditions under which it was achieved; and\n(iii) Any additional administrative effort and cost required to monitor and evaluate performance are justified by the expected benefits as documented by a risk and cost benefit analysis to be included in the Determination and Findings referenced in 16.401 (e)(5)(iii).\n(2) Award-fee amount . The amount of award fee earned shall be commensurate with the contractor  s overall cost, schedule, and technical performance as measured against contract requirements in accordance with the criteria stated in the award-fee plan. Award fee shall not be earned if the contractor  s overall cost, schedule, and technical performance in the aggregate is below satisfactory. The basis for all award-fee determinations shall be documented in the contract file to include, at a minimum, a determination that overall cost, schedule and technical performance in the aggregate is or is not at a satisfactory level. This determination and the methodology for determining the award fee are unilateral decisions made solely at the discretion of the Government.\n(3) Award-fee plan . All contracts providing for award fees shall be supported by an award-fee plan that establishes the procedures for evaluating award fee and an Award-Fee Board for conducting the award-fee evaluation. Award-fee plans shall  \n(i) Be approved by the FDO unless otherwise authorized by agency procedures;\n(ii) Identify the award-fee evaluation criteria and how they are linked to acquisition objectives which shall be defined in terms of contract cost, schedule, and technical performance. Criteria should motivate the contractor to enhance performance in the areas rated, but not at the expense of at least minimum acceptable performance in all other areas;\n(iii) Describe how the contractor  s performance will be measured against the award-fee evaluation criteria;\n(iv) Utilize the adjectival rating and associated description as well as the award-fee pool earned percentages shown below in Table 16-1. Contracting officers may supplement the adjectival rating description. The method used to determine the adjectival rating must be documented in the award-fee plan;\nAward-Fee Adjectival Rating\nAward-Fee Pool Available To Be Earned\nDescription\nExcellent\n91%-100%\nContractor has exceeded almost all of the significant award-fee criteria and has met overall cost, schedule, and technical performance requirements of the contract in the aggregate as defined and measured against the criteria in the award-fee plan for the award-fee evaluation period.\nVery Good		\n76%-90%\nContractor has exceeded many of the significant award-fee criteria and has met overall cost, schedule, and technical performance requirements of the contract in the aggregate as defined and measured against the criteria in the award-fee plan for the award-fee evaluation period.\nGood		\n51%-75%\nContractor has exceeded some of the significant award-fee criteria and has met overall cost, schedule, and technical performance requirements of the contract in the aggregate as defined and measured against the criteria in the award-fee plan for the award-fee evaluation period.\nSatisfactory	\nNo Greater Than 50%\nContractor has met overall cost, schedule, and technical performance requirements of the contract in the aggregate as defined and measured against the criteria in the award-fee plan for the award-fee evaluation period.\nUnsatisfactory\n0%\nContractor has failed to meet overall cost, schedule, and technical performance requirements of the contract in the aggregate as defined and measured against the criteria in the award-fee plan for the award-fee evaluation period.\nTable 16-1\n(v) Prohibit earning any award fee when a contractor  s overall cost, schedule, and technical performance in the aggregate is below satisfactory;\n(vi) Provide for evaluation period(s) to be conducted at stated intervals during the contract period of performance so that the contractor will periodically be informed of the quality of its performance and the areas in which improvement is expected ( e.g. six months, nine months, twelve months, or at specific milestones); and\n(vii) Define the total award-fee pool amount and how this amount is allocated across each evaluation period.\n(4) Rollover of unearned award fee . The use of rollover of unearned award fee is prohibited.\n(5) Limitations . No award-fee contract shall be awarded unless  \n(i) All of the limitations in 16.301-3 , that are applicable to cost-reimbursement contracts only, are complied with;\n(ii) An award-fee plan is completed in accordance with the requirements in 16.401 (e)(3); and\n(iii) A determination and finding is completed in accordance with 16.401 (d) addressing all of the suitability items in 16.401 (e)(1).\n(f) Incentive- and Award-Fee Data Collection and Analysis . Each agency shall collect relevant data on award fee and incentive fees paid to contractors and include performance measures to evaluate such data on a regular basis to determine effectiveness of award and incentive fees as a tool for improving contractor performance and achieving desired program outcomes. This information should be considered as part of the acquisition planning process (see 7.105 ) in determining the appropriate type of contract to be utilized for future acquisitions.\n(g) Incentive- and Award-Fee Best Practices . Each agency head shall provide mechanisms for sharing proven incentive strategies for the acquisition of different types of products and services among contracting and program management officials.\n16.402 Application of predetermined, formula-type incentives.\n16.402-1 Cost incentives.\n(a) Most incentive contracts include only cost incentives, which take the form of a profit or fee adjustment formula and are intended to motivate the contractor to effectively manage costs. No incentive contract may provide for other incentives without also providing a cost incentive (or constraint).\n(b) Except for award-fee contracts (see 16.404 and 16.401 (e)), incentive contracts include a target cost, a target profit or fee, and a profit or fee adjustment formula that (within the constraints of a price ceiling or minimum and maximum fee) provides that  \n(1) Actual cost that meets the target will result in the target profit or fee;\n(2) Actual cost that exceeds the target will result in downward adjustment of target profit or fee; and\n(3) Actual cost that is below the target will result in upward adjustment of target profit or fee.\n16.402-2 Performance incentives.\n(a) Performance incentives may be considered in connection with specific product characteristics ( e.g., a missile range, an aircraft speed, an engine thrust, or a vehicle maneuverability) or other specific elements of the contractor  s performance. These incentives should be designed to relate profit or fee to results achieved by the contractor, compared with specified targets.\n(b) To the maximum extent practicable, positive and negative performance incentives shall be considered in connection with service contracts for performance of objectively measurable tasks when quality of performance is critical and incentives are likely to motivate the contractor.\n(c) Technical performance incentives may be particularly appropriate in major systems contracts, both in development (when performance objectives are known and the fabrication of prototypes for test and evaluation is required) and in production (if improved performance is attainable and highly desirable to the Government).\n(d) Technical performance incentives may involve a variety of specific characteristics that contribute to the overall performance of the end item. Accordingly, the incentives on individual technical characteristics must be balanced so that no one of them is exaggerated to the detriment of the overall performance of the end item.\n(e) Performance tests and/or assessments of work performance are generally essential in order to determine the degree of attainment of performance targets. Therefore, the contract must be as specific as possible in establishing test criteria (such as testing conditions, instrumentation precision, and data interpretation) and performance standards (such as the quality levels of services to be provided).\n(f) Because performance incentives present complex problems in contract administration, the contracting officer should negotiate them in full coordination with Government engineering and pricing specialists.\n(g) It is essential that the Government and contractor agree explicitly on the effect that contract changes ( e.g., pursuant to the Changes clause) will have on performance incentives.\n(h) The contracting officer must exercise care, in establishing performance criteria, to recognize that the contractor should not be rewarded or penalized for attainments of Government-furnished components.\n16.402-3 Delivery incentives.\n(a) Delivery incentives should be considered when improvement from a required delivery schedule is a significant Government objective. It is important to determine the Government  s primary objectives in a given contract ( e.g., earliest possible delivery or earliest quantity production).\n(b) Incentive arrangements on delivery should specify the application of the reward-penalty structure in the event of Government-caused delays or other delays beyond the control, and without the fault or negligence, of the contractor or subcontractor.\n16.402-4 Structuring multiple-incentive contracts.\nA properly structured multiple-incentive arrangement should  \n(a) Motivate the contractor to strive for outstanding results in all incentive areas; and\n(b) Compel trade-off decisions among the incentive areas, consistent with the Government  s overall objectives for the acquisition. Because of the interdependency of the Government  s cost, the technical performance, and the delivery goals, a contract that emphasizes only one of the goals may jeopardize control over the others. Because outstanding results may not be attainable for each of the incentive areas, all multiple-incentive contracts must include a cost incentive (or constraint) that operates to preclude rewarding a contractor for superior technical performance or delivery results when the cost of those results outweighs their value to the Government.\n16.403 Fixed-price incentive contracts.\n(a) Description . A fixed-price incentive contract is a fixed-price contract that provides for adjusting profit and establishing the final contract price by application of a formula based on the relationship of total final negotiated cost to total target cost. The final price is subject to a price ceiling, negotiated at the outset. The two forms of fixed-price incentive contracts, firm target and successive targets, are further described in 16.403-1 and 16.403-2 below.\n(b) Application . A fixed-price incentive contract is appropriate when  \n(1) A firm-fixed-price contract is not suitable;\n(2) The nature of the supplies or services being acquired and other circumstances of the acquisition are such that the contractor  s assumption of a degree of cost responsibility will provide a positive profit incentive for effective cost control and performance; and\n(3) If the contract also includes incentives on technical performance and/or delivery, the performance requirements provide a reasonable opportunity for the incentives to have a meaningful impact on the contractor  s management of the work.\n(c) Billing prices . In fixed-price incentive contracts, billing prices are established as an interim basis for payment. These billing prices may be adjusted, within the ceiling limits, upon request of either party to the contract, when it becomes apparent that final negotiated cost will be substantially different from the target cost.\n16.403-1 Fixed-price incentive (firm target) contracts.\n(a) Description . A fixed-price incentive (firm target) contract specifies a target cost, a target profit, a price ceiling (but not a profit ceiling or floor), and a profit adjustment formula. These elements are all negotiated at the outset. The price ceiling is the maximum that may be paid to the contractor, except for any adjustment under other contract clauses. When the contractor completes performance, the parties negotiate the final cost, and the final price is established by applying the formula. When the final cost is less than the target cost, application of the formula results in a final profit greater than the target profit; conversely, when final cost is more than target cost, application of the formula results in a final profit less than the target profit, or even a net loss. If the final negotiated cost exceeds the price ceiling, the contractor absorbs the difference as a loss. Because the profit varies inversely with the cost, this contract type provides a positive, calculable profit incentive for the contractor to control costs.\n(b) Application . A fixed-price incentive (firm target) contract is appropriate when the parties can negotiate at the outset a firm target cost, target profit, and profit adjustment formula that will provide a fair and reasonable incentive and a ceiling that provides for the contractor to assume an appropriate share of the risk. When the contractor assumes a considerable or major share of the cost responsibility under the adjustment formula, the target profit should reflect this responsibility.\n(c) Limitations . This contract type may be used only when  \n(1) The contractor  s accounting system is adequate for providing data to support negotiation of final cost and incentive price revision; and\n(2) Adequate cost or pricing information for establishing reasonable firm targets is available at the time of initial contract negotiation.\n(d) Contract schedule . The contracting officer shall specify in the contract schedule the target cost, target profit, and target price for each item subject to incentive price revision.\n16.403-2 Fixed-price incentive (successive targets) contracts.\n(a) Description.\n(1) A fixed-price incentive (successive targets) contract specifies the following elements, all of which are negotiated at the outset:\n(i) An initial target cost.\n(ii) An initial target profit.\n(iii) An initial profit adjustment formula to be used for establishing the firm target profit, including a ceiling and floor for the firm target profit. (This formula normally provides for a lesser degree of contractor cost responsibility than would a formula for establishing final profit and price.)\n(iv) The production point at which the firm target cost and firm target profit will be negotiated (usually before delivery or shop completion of the first item).\n(v) A ceiling price that is the maximum that may be paid to the contractor, except for any adjustment under other contract clauses providing for equitable adjustment or other revision of the contract price under stated circumstances.\n(2) When the production point specified in the contract is reached, the parties negotiate the firm target cost, giving consideration to cost experience under the contract and other pertinent factors. The firm target profit is established by the formula. At this point, the parties have two alternatives, as follows:\n(i) They may negotiate a firm fixed price, using the firm target cost plus the firm target profit as a guide.\n(ii) If negotiation of a firm fixed price is inappropriate, they may negotiate a formula for establishing the final price using the firm target cost and firm target profit. The final cost is then negotiated at completion, and the final profit is established by formula, as under the fixed-price incentive (firm target) contract (see 16.403-1 above).\n(b) Application . A fixed-price incentive (successive targets) contract is appropriate when  \n(1) Available cost or pricing information is not sufficient to permit the negotiation of a realistic firm target cost and profit before award;\n(2) Sufficient information is available to permit negotiation of initial targets; and\n(3) There is reasonable assurance that additional reliable information will be available at an early point in the contract performance so as to permit negotiation of either (i) a firm fixed price or (ii) firm targets and a formula for establishing final profit and price that will provide a fair and reasonable incentive. This additional information is not limited to experience under the contract, itself, but may be drawn from other contracts for the same or similar items.\n(c) Limitations . This contract type may be used only when  \n(1) The contractor  s accounting system is adequate for providing data for negotiating firm targets and a realistic profit adjustment formula, as well as later negotiation of final costs; and\n(2) Cost or pricing information adequate for establishing a reasonable firm target cost is reasonably expected to be available at an early point in contract performance.\n(d) Contract schedule . The contracting officer shall specify in the contract schedule the initial target cost, initial target profit, and initial target price for each item subject to incentive price revision.\n16.404 Fixed-price contracts with award fees.\nAward-fee provisions may be used in fixed-price contracts when the Government wishes to motivate a contractor and other incentives cannot be used because contractor performance cannot be measured objectively. Such contracts shall establish a fixed price (including normal profit) for the effort. This price will be paid for satisfactory contract performance. Award fee earned (if any) will be paid in addition to that fixed price. See 16.401 (e) for the requirements relative to utilizing this contract type.\n16.405 Cost-reimbursement incentive contracts.\nSee 16.301 for requirements applicable to all cost-reimbursement contracts, for use in conjunction with the following subsections.\n16.405-1 Cost-plus-incentive-fee contracts.\n(a) Description . The cost-plus-incentive-fee contract is a cost-reimbursement contract that provides for the initially negotiated fee to be adjusted later by a formula based on the relationship of total allowable costs to total target costs. This contract type specifies a target cost, a target fee, minimum and maximum fees, and a fee adjustment formula. After contract performance, the fee payable to the contractor is determined in accordance with the formula. The formula provides, within limits, for increases in fee above target fee when total allowable costs are less than target costs, and decreases in fee below target fee when total allowable costs exceed target costs. This increase or decrease is intended to provide an incentive for the contractor to manage the contract effectively. When total allowable cost is greater than or less than the range of costs within which the fee-adjustment formula operates, the contractor is paid total allowable costs, plus the minimum or maximum fee.\n(b) Application.\n(1) A cost-plus-incentive-fee contract is appropriate for services or development and test programs when  \n(i) A cost-reimbursement contract is necessary (see 16.301-2 ); and\n(ii) A target cost and a fee adjustment formula can be negotiated that are likely to motivate the contractor to manage effectively.\n(2) The contract may include technical performance incentives when it is highly probable that the required development of a major system is feasible and the Government has established its performance objectives, at least in general terms. This approach also may apply to other acquisitions, if the use of both cost and technical performance incentives is desirable and administratively practical.\n(3) The fee adjustment formula should provide an incentive that will be effective over the full range of reasonably foreseeable variations from target cost. If a high maximum fee is negotiated, the contract shall also provide for a low minimum fee that may be a zero fee or, in rare cases, a negative fee.\n(c) Limitations . No cost-plus-incentive-fee contract shall be awarded unless all limitations in 16.301-3 are complied with.\n16.405-2 Cost-plus-award-fee contracts.\nA cost-plus-award-fee contract is a cost-reimbursement contract that provides for a fee consisting of (1) a base amount fixed at inception of the contract, if applicable and at the discretion of the contracting officer, and (2) an award amount that the contractor may earn in whole or in part during performance and that is sufficient to provide motivation for excellence in the areas of cost, schedule, and technical performance. See 16.401 (e) for the requirements relative to utilizing this contract type.\n16.406 Contract clauses.\n(a) Insert the clause at 52.216-16 , Incentive Price Revision  Firm Target, in solicitations and contracts when a fixed-price incentive (firm target) contract is contemplated. If the contract calls for supplies or services to be ordered under a provisioning document or Government option and the prices are to be subject to the incentive price revision under the clause, the contracting officer shall use the clause with its Alternate I.\n(b) Insert the clause at 52.216-17 , Incentive Price Revision  Successive Targets, in solicitations and contracts when a fixed-price incentive (successive targets) contract is contemplated. If the contract calls for supplies or services to be ordered under a provisioning document or Government option and the prices are to be subject to incentive price revision under the clause, the contracting officer shall use the clause with its Alternate I.\n(c) The clause at 52.216-7 , Allowable Cost and Payment, is prescribed in 16.307 (a) for insertion in solicitations and contracts when a cost-plus-incentive-fee contract or a cost-plus-award-fee contract is contemplated.\n(d) The clause at 52.216-10 , Incentive Fee, is prescribed in 16.307(d) for insertion in solicitations and contracts when a cost-plus-incentive-fee contract is contemplated.\n(e) Insert an appropriate award-fee clause in solicitations and contracts when an award-fee contract is contemplated, provided that the clause  \n(1) Is prescribed by or approved under agency acquisition regulations;\n(2) Is compatible with the clause at 52.216-7 , Allowable Cost and Payment; and\n(3) Expressly provides that the award amount and the award-fee determination methodology are unilateral decisions made solely at the discretion of the Government.");
register_book(&s, "|16|5|", "Indefinite-Delivery Contracts", "Subpart 16.5  Indefinite-Delivery Contracts\n16.500 Scope of subpart.\n(a) This subpart prescribes policies and procedures for making awards of indefinite-delivery contracts and establishes a preference for making multiple awards of indefinite-quantity contracts.\n(b) This subpart does not limit the use of other than competitive procedures authorized by Part 6 .\n(c) Nothing in this subpart restricts the authority of the General Services Administration (GSA) to enter into schedule, multiple award, or task or delivery order contracts under any other provision of law. Therefore, GSA regulations and the coverage for the Federal Supply Schedule program in Subpart 8.4 and Part 38 take precedence over this subpart.\n(d) The statutory multiple award preference implemented by this subpart does not apply to architect-engineer contracts subject to the procedures in Subpart 36.6 . However, agencies are not precluded from making multiple awards for architect-engineer services using the procedures in this subpart, provided the selection of contractors and placement of orders are consistent with Subpart 36.6 .\n16.501-1 Definitions.\nAs used in this subpart  \nDelivery-order contract  means a contract for supplies that does not procure or specify a firm quantity of supplies (other than a minimum or maximum quantity) and that provides for the issuance of orders for the delivery of supplies during the period of the contract.\nTask-order contract  means a contract for services that does not procure or specify a firm quantity of services (other than a minimum or maximum quantity) and that provides for the issuance of orders for the performance of tasks during the period of the contract.\n16.501-2 General.\n(a) There are three types of indefinite-delivery contracts: definite-quantity contracts, requirements contracts, and indefinite-quantity contracts. The appropriate type of indefinite-delivery contract may be used to acquire supplies and/or services when the exact times and/or exact quantities of future deliveries are not known at the time of contract award. Pursuant to 10 U.S.C. 2304d and section 303K of the Federal Property and Administrative Services Act of 1949, requirements contracts and indefinite-quantity contracts are also known as delivery-order contracts or task-order contracts.\n(b) The various types of indefinite-delivery contracts offer the following advantages:\n(1) All three types permit  \n(i) Government stocks to be maintained at minimum levels; and\n(ii) Direct shipment to users.\n(2) Indefinite-quantity contracts and requirements contracts also permit  \n(i) Flexibility in both quantities and delivery scheduling; and\n(ii) Ordering of supplies or services after requirements materialize.\n(3) Indefinite-quantity contracts limit the Government  s obligation to the minimum quantity specified in the contract.\n(4) Requirements contracts may permit faster deliveries when production lead time is involved, because contractors are usually willing to maintain limited stocks when the Government will obtain all of its actual purchase requirements from the contractor.\n(c) Indefinite-delivery contracts may provide for any appropriate cost or pricing arrangement under Part 16 . Cost or pricing arrangements that provide for an estimated quantity of supplies or services ( e.g., estimated number of labor hours) must comply with the appropriate procedures of this subpart.\n16.502 Definite-quantity contracts.\n(a) Description . A definite-quantity contract provides for delivery of a definite quantity of specific supplies or services for a fixed period, with deliveries or performance to be scheduled at designated locations upon order.\n(b) Application . A definite-quantity contract may be used when it can be determined in advance that  \n(1) A definite quantity of supplies or services will be required during the contract period; and\n(2) The supplies or services are regularly available or will be available after a short lead time.\n16.503 Requirements contracts.\n(a) Description . A requirements contract provides for filling all actual purchase requirements of designated Government activities for supplies or services during a specified contract period (from one contractor), with deliveries or performance to be scheduled by placing orders with the contractor.\n(1) For the information of offerors and contractors, the contracting officer shall state a realistic estimated total quantity in the solicitation and resulting contract. This estimate is not a representation to an offeror or contractor that the estimated quantity will be required or ordered, or that conditions affecting requirements will be stable or normal. The contracting officer may obtain the estimate from records of previous requirements and consumption, or by other means, and should base the estimate on the most current information available.\n(2) The contract shall state, if feasible, the maximum limit of the contractor  s obligation to deliver and the Government  s obligation to order. The contract may also specify maximum or minimum quantities that the Government may order under each individual order and the maximum that it may order during a specified period of time.\n(b) Application . \n(1) A requirements contract may be appropriate for acquiring any supplies or services when the Government anticipates recurring requirements but cannot predetermine the precise quantities of supplies or services that designated Government activities will need during a definite period.\n(2) No requirements contract in an amount estimated to exceed $103 million (including all options) may be awarded to a single source unless a determination is executed in accordance with 16.504 (c)(1)(ii)(D).\n(c) Government property furnished for repair . When a requirements contract is used to acquire work ( e.g., repair, modification, or overhaul) on existing items of Government property, the contracting officer shall specify in the Schedule that failure of the Government to furnish such items in the amounts or quantities described in the Schedule as  estimated  or  maximum  will not entitle the contractor to any equitable adjustment in price under the Government Property clause of the contract.\n(d) Limitations on use of requirements contracts for advisory and assistance services.\n(1) Except as provided in paragraph (d)(2) of this section, no solicitation for a requirements contract for advisory and assistance services in excess of three years and $12.5 million (including all options) may be issued unless the contracting officer or other official designated by the head of the agency determines in writing that the services required are so unique or highly specialized that it is not practicable to make multiple awards using the procedures in 16.504 .\n(2) The limitation in paragraph (d)(1) of this section is not applicable to an acquisition of supplies or services that includes the acquisition of advisory and assistance services, if the contracting officer or other official designated by the head of the agency determines that the advisory and assistance services are necessarily incident to, and not a significant component of, the contract.\n16.504 Indefinite-quantity contracts.\n(a) Description . An indefinite-quantity contract provides for an indefinite quantity, within stated limits, of supplies or services during a fixed period. The Government places orders for individual requirements. Quantity limits may be stated as number of units or as dollar values.\n(1) The contract must require the Government to order and the contractor to furnish at least a stated minimum quantity of supplies or services. In addition, if ordered, the contractor must furnish any additional quantities, not to exceed the stated maximum. The contracting officer should establish a reasonable maximum quantity based on market research, trends on recent contracts for similar supplies or services, survey of potential users, or any other rational basis.\n(2) To ensure that the contract is binding, the minimum quantity must be more than a nominal quantity, but it should not exceed the amount that the Government is fairly certain to order.\n(3) The contract may also specify maximum or minimum quantities that the Government may order under each task or delivery order and the maximum that it may order during a specific period of time.\n(4) A solicitation and contract for an indefinite quantity must  \n(i) Specify the period of the contract, including the number of options and the period for which the Government may extend the contract under each option;\n(ii) Specify the total minimum and maximum quantity of supplies or services the Government will acquire under the contract;\n(iii) Include a statement of work, specifications, or other description, that reasonably describes the general scope, nature, complexity, and purpose of the supplies or services the Government will acquire under the contract in a manner that will enable a prospective offeror to decide whether to submit an offer;\n(iv) State the procedures that the Government will use in issuing orders, including the ordering media, and, if multiple awards may be made, state the procedures and selection criteria that the Government will use to provide awardees a fair opportunity to be considered for each order (see 16.505 (b)(1));\n(v) Include the name, address, telephone number, facsimile number, and e-mail address of the agency task and delivery order ombudsman (see 16.505 (b)(8)) if multiple awards may be made;\n(vi) Include a description of the activities authorized to issue orders; and\n(vii) Include authorization for placing oral orders, if appropriate, provided that the Government has established procedures for obligating funds and that oral orders are confirmed in writing.\n(b) Application . Contracting officers may use an indefinite-quantity contract when the Government cannot predetermine, above a specified minimum, the precise quantities of supplies or services that the Government will require during the contract period, and it is inadvisable for the Government to commit itself for more than a minimum quantity. The contracting officer should use an indefinite-quantity contract only when a recurring need is anticipated.\n(c) Multiple award preference  \n(1) Planning the acquisition.\n(i) Except for indefinite-quantity contracts for advisory and assistance services as provided in paragraph (c)(2) of this section, the contracting officer must, to the maximum extent practicable, give preference to making multiple awards of indefinite-quantity contracts under a single solicitation for the same or similar supplies or services to two or more sources.\n(ii)(A) The contracting officer must determine whether multiple awards are appropriate as part of acquisition planning. The contracting officer must avoid situations in which awardees specialize exclusively in one or a few areas within the statement of work, thus creating the likelihood that orders in those areas will be awarded on a sole-source basis; however, each awardee need not be capable of performing every requirement as well as any other awardee under the contracts. The contracting officer should consider the following when determining the number of contracts to be awarded:\n(1) The scope and complexity of the contract requirement.\n(2) The expected duration and frequency of task or delivery orders.\n(3) The mix of resources a contractor must have to perform expected task or delivery order requirements.\n(4) The ability to maintain competition among the awardees throughout the contracts  period of performance.\n(B) The contracting officer must not use the multiple award approach if  \n(1) Only one contractor is capable of providing performance at the level of quality required because the supplies or services are unique or highly specialized;\n(2) Based on the contracting officer  s knowledge of the market, more favorable terms and conditions, including pricing, will be provided if a single award is made;\n(3) The expected cost of administration of multiple contracts outweighs the expected benefits of making multiple awards;\n(4) The projected task orders are so integrally related that only a single contractor can reasonably perform the work;\n(5) The total estimated value of the contract is less than the simplified acquisition threshold; or\n(6) Multiple awards would not be in the best interests of the Government.\n(C) The contracting officer must document the decision whether or not to use multiple awards in the acquisition plan or contract file. The contracting officer may determine that a class of acquisitions is not appropriate for multiple awards (see Subpart 1.7 ).\n(D) \n(1) No task or delivery order contract in an amount estimated to exceed $103 million (including all options) may be awarded to a single source unless the head of the agency determines in writing that  \n(i) The task or delivery orders expected under the contract are so integrally related that only a single source can reasonably perform the work;\n(ii) The contract provides only for firm-fixed price (see 16.202 ) task or delivery orders for  \n( A) Products for which unit prices are established in the contract; or\n( B) Services for which prices are established in the contract for the specific tasks to be performed;\n(iii) Only one source is qualified and capable of performing the work at a reasonable price to the Government; or\n(iv) It is necessary in the public interest to award the contract to a single source due to exceptional circumstances.\n(2) The head of the agency must notify Congress within 30 days after any determination under paragraph (c)(1)(ii)(D)( 1)( iv ) of this section.\n(3) The requirement for a determination for a single-award contract greater than $103 million:\n(i) Is in addition to any applicable requirements of Subpart 6.3 .\n(ii) Is not applicable for architect-engineer services awarded pursuant to Subpart 36.6 .\n(2) Contracts for advisory and assistance services.\n(i) Except as provided in paragraph (c)(2)(ii) of this section, if an indefinite-quantity contract for advisory and assistance services exceeds 3 years and $12.5 million, including all options, the contracting officer must make multiple awards unless  \n(A) The contracting officer or other official designated by the head of the agency determines in writing, as part of acquisition planning, that multiple awards are not practicable. The contracting officer or other official must determine that only one contractor can reasonably perform the work because either the scope of work is unique or highly specialized or the tasks so integrally related;\n(B) The contracting officer or other official designated by the head of the agency determines in writing, after the evaluation of offers, that only one offeror is capable of providing the services required at the level of quality required; or\n(C) Only one offer is received.\n(ii) The requirements of paragraph (c)(2)(i) of this section do not apply if the contracting officer or other official designated by the head of the agency determines that the advisory and assistance services are incidental and not a significant component of the contract.\n16.505 Ordering.\n(a) General.\n(1) In general, the contracting officer does not synopsize orders under indefinite-delivery contracts; except see 16.505 (a)(4) and (11), and 16.505 (b)(2)(ii)(D).\n(2) Individual orders shall clearly describe all services to be performed or supplies to be delivered so the full cost or price for the performance of the work can be established when the order is placed. Orders shall be within the scope, issued within the period of performance, and be within the maximum value of the contract.\n(3) Performance-based acquisition methods must be used to the maximum extent practicable, if the contract or order is for services (see 37.102 (a) and Subpart 37.6 ).\n(4) The following requirements apply when procuring items peculiar to one manufacturer:\n(i) The contracting officer must justify restricting consideration to an item peculiar to one manufacturer ( e.g. , a particular brand-name, product, or a feature of a product that is peculiar to one manufacturer). A brand-name item, even if available on more than one contract, is an item peculiar to one manufacturer. Brand-name specifications shall not be used unless the particular brand-name, product, or feature is essential to the Government  s requirements and market research indicates other companies  similar products, or products lacking the particular feature, do not meet, or cannot be modified to meet, the agency  s needs.\n(ii) Requirements for use of items peculiar to one manufacturer shall be justified and approved using the format(s) and requirements from paragraphs (b)(2)(ii)(A), (B), and (C) of this section, modified to show the brand-name justification. A justification is required unless a justification covering the requirements in the order was previously approved for the contract in accordance with 6.302-1 (c) or unless the base contract is a single-award contract awarded under full and open competition. Justifications for the use of brand-name specifications must be completed and approved at the time the requirement for a brand-name is determined.\n(iii)(A) For an order in excess of $25,000, the contracting officer shall  \n(1) Post the justification and supporting documentation on the agency website used (if any) to solicit offers for orders under the contract; or\n(2) Provide the justification and supporting documentation along with the solicitation to all contract awardees.\n(B) The justifications for brand-name acquisitions may apply to the portion of the acquisition requiring the brand-name item. If the justification is to cover only the portion of the acquisition which is brand-name, then it should so state; the approval level requirements will then only apply to that portion.\n(C) The requirements in paragraph (a)(4)(iii)(A) of this section do not apply when disclosure would compromise the national security ( e.g. , would result in disclosure of classified information) or create other security risks.\n(D) The justification is subject to the screening requirement in paragraph (b)(2)(ii)(D)( 4) of this section.\n(5) When acquiring information technology and related services, consider the use of modular contracting to reduce program risk (see 39.103 (a)).\n(6) Orders may be placed by using any medium specified in the contract.\n(7) Orders placed under indefinite-delivery contracts must contain the following information:\n(i) Date of order.\n(ii) Contract number and order number.\n(iii) For supplies and services, contract item number and description, quantity, and unit price or estimated cost or fee.\n(iv) Delivery or performance schedule.\n(v) Place of delivery or performance (including consignee).\n(vi) Any packaging, packing, and shipping instructions.\n(vii) Accounting and appropriation data.\n(viii) Method of payment and payment office, if not specified in the contract (see 32.1110 (e)).\n(8) Orders placed under a task-order contract or delivery-order contract awarded by another agency ( i.e., a Governmentwide acquisition contract, or multi-agency contract)  \n(i) Are not exempt from the development of acquisition plans (see Subpart 7.1 ), and an information technology acquisition strategy (see Part 39 );\n(ii) May not be used to circumvent conditions and limitations imposed on the use of funds ( e.g., 31 U.S.C. 1501(a)(1) ); and\n(iii) Must comply with all FAR requirements for a bundled contract when the order meets the definition of  bundled contract  (see 2.101 (b)).\n(9) In accordance with section 1427(b) of Public Law 108-136, orders placed under multi-agency contracts for services that substantially or to a dominant extent specify performance of architect-engineer services, as defined in 2.101 , shall  \n(i) Be awarded using the procedures at Subpart 36.6 ; and\n(ii) Require the direct supervision of a professional architect or engineer licensed, registered or certified in the State, Federal District, or outlying area, in which the services are to be performed.\n(10) \n(i) No protest under Subpart 33.1 is authorized in connection with the issuance or proposed issuance of an order under a task-order contract or delivery-order contract, except for  \n(A) A protest on the grounds that the order increases the scope, period, or maximum value of the contract; or\n(B) A protest of an order valued in excess of $10 million . Protests of orders in excess of $10 million may only be filed with the Government Accountability Office, in accordance with the procedures at 33.104 .\n(ii) The authority to protest the placement of an order under (a)(10)(i)(B) of this section expires on September 30, 2016, for agencies other than DoD, NASA, and the Coast Guard (41 U.S.C. 4103(d) and 41 U.S.C. 4106(f) ). The authority to protest the placement of an order under (a)(10)(i)(B) of this section does not expire for DoD, NASA, and the Coast Guard.\n(11) Publicize orders funded in whole or in part by the American Recovery and Reinvestment Act of 2009 (Pub. L. 111-5) as follows:\n(i) Notices of proposed orders shall follow the procedures in 5.704 for posting orders.\n(ii) Award notices for orders shall follow the procedures in 5.705 .\n(12) When using the Governmentwide commercial purchase card as a method of payment, orders at or below the micro-purchase threshold are exempt from verification in the System for Award Management database as to whether the contractor has a delinquent debt subject to collection under the Treasury Offset Program (TOP).\n(b) Orders under multiple-award contracts  \n(1) Fair opportunity.\n(i) The contracting officer must provide each awardee a fair opportunity to be considered for each order exceeding $3,000 issued under multiple delivery-order contracts or multiple task-order contracts, except as provided for in paragraph (b)(2) of this section.\n(ii) The contracting officer may exercise broad discretion in developing appropriate order placement procedures. The contracting officer should keep submission requirements to a minimum. Contracting officers may use streamlined procedures, including oral presentations. If the order does not exceed the simplified acquisition threshold, the contracting officer need not contact each of the multiple awardees under the contract before selecting an order awardee if the contracting officer has information available to ensure that each awardee is provided a fair opportunity to be considered for each order. The competition requirements in Part 6 and the policies in Subpart 15.3 do not apply to the ordering process. However, the contracting officer must  \n(A) Develop placement procedures that will provide each awardee a fair opportunity to be considered for each order and that reflect the requirement and other aspects of the contracting environment;\n(B) Not use any method (such as allocation or designation of any preferred awardee) that would not result in fair consideration being given to all awardees prior to placing each order;\n(C) Tailor the procedures to each acquisition;\n(D) Include the procedures in the solicitation and the contract; and\n(E) Consider price or cost under each order as one of the factors in the selection decision.\n(iii) Orders exceeding the simplified acquisition threshold. \n(A) Each order exceeding the simplified acquisition threshold shall be placed on a competitive basis in accordance with paragraph (b)(1)(iii)(B) of this section, unless supported by a written determination that one of the circumstances described at 16.505 (b)(2)(i) applies to the order and the requirement is waived on the basis of a justification that is prepared in accordance with 16.505 (b)(2)(ii)(B);\n(B) The contracting officer shall  \n(1) Provide a fair notice of the intent to make a purchase, including a clear description of the supplies to be delivered or the services to be performed and the basis upon which the selection will be made to all contractors offering the required supplies or services under the multiple-award contract; and\n(2) Afford all contractors responding to the notice a fair opportunity to submit an offer and have that offer fairly considered.\n(iv) Orders exceeding $5 million . For task or delivery orders in excess of $5 million, the requirement to provide all awardees a fair opportunity to be considered for each order shall include, at a minimum  \n(A) A notice of the task or delivery order that includes a clear statement of the agency  s requirements;\n(B) A reasonable response period;\n(C) Disclosure of the significant factors and subfactors, including cost or price, that the agency expects to consider in evaluating proposals, and their relative importance;\n(D) Where award is made on a best value basis, a written statement documenting the basis for award and the relative importance of quality and price or cost factors; and\n(E) An opportunity for a postaward debriefing in accordance with paragraph (b)(6) of this section.\n(v) The contracting officer should consider the following when developing the procedures:\n(A) \n(1) Past performance on earlier orders under the contract, including quality, timeliness and cost control.\n(2) Potential impact on other orders placed with the contractor.\n(3) Minimum order requirements.\n(4) The amount of time contractors need to make informed business decisions on whether to respond to potential orders.\n(5) Whether contractors could be encouraged to respond to potential orders by outreach efforts to promote exchanges of information, such as  \n(i) Seeking comments from two or more contractors on draft statements of work;\n(ii) Using a multiphased approach when effort required to respond to a potential order may be resource intensive ( e.g., requirements are complex or need continued development), where all contractors are initially considered on price considerations ( e.g., rough estimates), and other considerations as appropriate ( e.g., proposed conceptual approach, past performance). The contractors most likely to submit the highest value solutions are then selected for one-on-one sessions with the Government to increase their understanding of the requirements, provide suggestions for refining requirements, and discuss risk reduction measures.\n(B) Formal evaluation plans or scoring of quotes or offers are not required.\n(2) Exceptions to the fair opportunity process.\n(i) The contracting officer shall give every awardee a fair opportunity to be considered for a delivery-order or task-order exceeding $3,000 unless one of the following statutory exceptions applies:\n(A) The agency need for the supplies or services is so urgent that providing a fair opportunity would result in unacceptable delays.\n(B) Only one awardee is capable of providing the supplies or services required at the level of quality required because the supplies or services ordered are unique or highly specialized.\n(C) The order must be issued on a sole-source basis in the interest of economy and efficiency because it is a logical follow-on to an order already issued under the contract, provided that all awardees were given a fair opportunity to be considered for the original order.\n(D) It is necessary to place an order to satisfy a minimum guarantee.\n(E) For orders exceeding the simplified acquisition threshold, a statute expressly authorizes or requires that the purchase be made from a specified source.\n(F) In accordance with section 1331 of Public Law 111-240 ( 15 U.S.C. 644 (r)), contracting officers may, at their discretion, set aside orders for any of the small business concerns identified in 19.000 (a)(3). When setting aside orders for small business concerns, the specific small business program eligibility requirements identified in part 19 apply.\n(ii) The justification for an exception to fair opportunity shall be in writing as specified in paragraphs (b)(2)(ii)(A) or (B) of this section. No justification is needed for the exception described in paragraph (b)(2)(i)(F) of this section.\n(A) Orders exceeding $3,000, but not exceeding the simplified acquisition threshold . The contracting officer shall document the basis for using an exception to the fair opportunity process. If the contracting officer uses the logical follow-on exception, the rationale shall describe why the relationship between the initial order and the follow-on is logical ( e.g. , in terms of scope, period of performance, or value).\n(B) Orders exceeding the simplified acquisition threshold. As a minimum, each justification shall include the following information and be approved in accordance with paragraph (b)(2)(ii)(C) of this section:\n(1) Identification of the agency and the contracting activity, and specific identification of the document as a  Justification for an Exception to Fair Opportunity.  \n(2) Nature and/or description of the action being approved.\n(3) A description of the supplies or services required to meet the agency  s needs (including the estimated value).\n(4) Identification of the exception to fair opportunity (see 16.505 (b)(2)) and the supporting rationale, including a demonstration that the proposed contractor  s unique qualifications or the nature of the acquisition requires use of the exception cited. If the contracting officer uses the logical follow-on exception, the rationale shall describe why the relationship between the initial order and the follow-on is logical ( e.g. , in terms of scope, period of performance, or value).\n(5) A determination by the contracting officer that the anticipated cost to the Government will be fair and reasonable.\n(6) Any other facts supporting the justification.\n(7) A statement of the actions, if any, the agency may take to remove or overcome any barriers that led to the exception to fair opportunity before any subsequent acquisition for the supplies or services is made.\n(8) The contracting officer  s certification that the justification is accurate and complete to the best of the contracting officer  s knowledge and belief.\n(9) Evidence that any supporting data that is the responsibility of technical or requirements personnel ( e.g. , verifying the Government  s minimum needs or requirements or other rationale for an exception to fair opportunity) and which form a basis for the justification have been certified as complete and accurate by the technical or requirements personnel.\n(10) A written determination by the approving official that one of the circumstances in (b)(2)(i)(A) through (E) of this section applies to the order.\n(C) Approval.\n(1) For proposed orders exceeding the simplified acquisition threshold, but not exceeding $650,000, the ordering activity contracting officer  s certification that the justification is accurate and complete to the best of the ordering activity contracting officer  s knowledge and belief will serve as approval, unless a higher approval level is established in accordance with agency procedures.\n(2) For a proposed order exceeding $650,000, but not exceeding $12.5 million, the justification must be approved by the competition advocate of the activity placing the order, or by an official named in paragraph (b)(2)(ii)(C) (3) or (4) of this section. This authority is not delegable.\n(3) For a proposed order exceeding $12.5 million, but not exceeding $62.5 million (or, for DoD, NASA, and the Coast Guard, not exceeding $85.5 million), the justification must be approved by  \n(i) The head of the procuring activity placing the order;\n(ii) A designee who  \n(A) If a member of the armed forces, is a general or flag officer;\n(B) If a civilian, is serving in a position in a grade above GS-15 under the General Schedule (or in a comparable or higher position under another schedule); or\n(iii) An official named in paragraph (b)(2)(ii)(C) (4) of this section.\n(4) For a proposed order exceeding $62.5 million (or, for DoD, NASA, and the Coast Guard, over $85.5 million), the justification must be approved by the senior procurement executive of the agency placing the order. This authority is not delegable, except in the case of the Under Secretary of Defense for Acquisition, Technology, and Logistics, acting as the senior procurement executive for the Department of Defense.\n(D) Posting.\n(1) Except as provided in paragraph (b)(2)(ii)(D) (5) of this section, within 14 days after placing an order exceeding the simplified acquisition threshold that does not provide for fair opportunity in accordance with 16.505 (b), the contract officer shall  \n(i) Publish a notice in accordance with 5.301 ; and\n(ii) Make publicly available the justification required at (b)(2)(ii)(B) of this section.\n(2) The justification shall be made publicly available  \n(i) At the GPE www.fedbizopps.gov ;\n(ii) On the Web site of the agency, which may provide access to the justifications by linking to the GPE; and\n(iii) Must remain posted for a minimum of 30 days.\n(3) In the case of an order permitted under paragraph (b)(2)(i)(A) of this subsection, the justification shall be posted within 30 days after award of the order.\n(4) Contracting officers shall carefully screen all justifications for contractor proprietary data and remove all such data, and such references and citations as are necessary to protect the proprietary data, before making the justifications available for public inspection. Contracting officers shall also be guided by the exemptions to disclosure of information contained in the Freedom of Information Act ( 5 U.S.C. 552 ) and the prohibitions against disclosure in 24.202 in determining whether other data should be removed. Although the submitter notice process set out in Executive Order 12600  Predisclosure Notification Procedures for Confidential Commercial Information  does not apply, if the justification appears to contain proprietary data, the contracting officer should provide the contractor that submitted the information an opportunity to review the justification for proprietary data before making the justification available for public inspection, redacted as necessary. This process must not prevent or delay the posting of the justification in accordance with the timeframes required in paragraphs (1) and (3).\n(5) The posting requirement of this section does not apply  \n(i) When disclosure would compromise the national security ( e.g. , would result in disclosure of classified information) or create other security risks; or\n(ii) To a small business set-aside under paragraph (b)(2)(i)(F).\n(3) Pricing orders . If the contract did not establish the price for the supply or service, the contracting officer must establish prices for each order using the policies and methods in Subpart 15.4.\n(4) For additional requirements for cost reimbursement orders see 16.301-3 .\n(5) For additional requirements for time-and-materials or labor-hour orders, see 16.601 (e).\n(6) Postaward Notices and Debriefing of Awardees for Orders Exceeding $5 million . The contracting officer shall notify unsuccessful awardees when the total price of a task or delivery order exceeds $5 million.\n(i) The procedures at 15.503 (b)(1) shall be followed when providing postaward notification to unsuccessful awardees.\n(ii) The procedures at 15.506 shall be followed when providing postaward debriefing to unsuccessful awardees. \n(iii) A summary of the debriefing shall be included in the task or delivery order file.\n(7) Decision documentation for orders. \n(i) The contracting officer shall document in the contract file the rationale for placement and price of each order, including the basis for award and the rationale for any tradeoffs among cost or price and non-cost considerations in making the award decision. This documentation need not quantify the tradeoffs that led to the decision.\n(ii) The contract file shall also identify the basis for using an exception to the fair opportunity process (see paragraph (b)(2))\n(8) Task-order and delivery-order ombudsman . The head of the agency shall designate a task-order and delivery-order ombudsman. The ombudsman must review complaints from contractors and ensure they are afforded a fair opportunity to be considered, consistent with the procedures in the contract. The ombudsman must be a senior agency official who is independent of the contracting officer and may be the agency  s competition advocate.\n(c) Limitation on ordering period for task-order contracts for advisory and assistance services.\n(1) Except as provided for in paragraphs (c)(2) and (c)(3), the ordering period of a task-order contract for advisory and assistance services, including all options or modifications, normally may not exceed 5 years.\n(2) The 5-year limitation does not apply when  \n(i) A longer ordering period is specifically authorized by a statute; or\n(ii) The contract is for an acquisition of supplies or services that includes the acquisition of advisory and assistance services and the contracting officer, or other official designated by the head of the agency, determines that the advisory and assistance services are incidental and not a significant component of the contract.\n(3) The contracting officer may extend the contract on a sole-source basis only once for a period not to exceed 6 months if the contracting officer, or other official designated by the head of the agency, determines that  \n(i) The award of a follow-on contract is delayed by circumstances that were not reasonably foreseeable at the time the initial contract was entered into; and\n(ii) The extension is necessary to ensure continuity of services, pending the award of the follow-on contract.\n16.506 Solicitation provisions and contract clauses.\n(a) Insert the clause at 52.216-18 , Ordering, in solicitations and contracts when a definite-quantity contract, a requirements contract, or an indefinite-quantity contract is contemplated.\n(b) Insert a clause substantially the same as the clause at 52.216-19 , Order Limitations, in solicitations and contracts when a definite-quantity contract, a requirements contract, or an indefinite-quantity contract is contemplated.\n(c) Insert the clause at 52.216-20 , Definite Quantity, in solicitations and contracts when a definite-quantity contract is contemplated.\n(d)(1) Insert the clause at 52.216-21 , Requirements, in solicitations and contracts when a requirements contract is contemplated.\n(2) If the contract is for nonpersonal services and related supplies and covers estimated requirements that exceed a specific Government activity  s internal capability to produce or perform, use the clause with its Alternate I.\n(3) If the contract includes subsistence for both Government use and resale in the same Schedule, and similar products may be acquired on a brand-name basis, use the clause with its Alternate II (but see paragraph (d)(5) of this section).\n(4) If the contract involves a partial small business set-aside, use the clause with its Alternate III (but see paragraph (d)(5) of this section).\n(5) If the contract  \n(i) Includes subsistence for Government use and resale in the same schedule and similar products may be acquired on a brand-name basis; and\n(ii) Involves a partial small business set-aside, use the clause with its Alternate IV.\n(e) Insert the clause at 52.216-22 , Indefinite Quantity, in solicitations and contracts when an indefinite-quantity contract is contemplated.\n(f) Insert the provision at 52.216-27 , Single or Multiple Awards, in solicitations for indefinite-quantity contracts that may result in multiple contract awards. Modify the provision to specify the estimated number of awards. Do not use this provision for advisory and assistance services contracts that exceed 3 years and $12.5 million (including all options).\n(g) Insert the provision at 52.216-28 , Multiple Awards for Advisory and Assistance Services, in solicitations for task-order contracts for advisory and assistance services that exceed 3 years and $12.5 million (including all options), unless a determination has been made under 16.504 (c)(2)(i)(A). Modify the provision to specify the estimated number of awards.\n(h) See 10.001 (d) for insertion of the clause at 52.210-1 , Market Research, when the contract is over $5 million for the procurement of items other than commercial items.");
register_book(&s, "|16|6|", "Time-and-Materials, Labor-Hour, and Let", "Subpart 16.6  Time-and-Materials, Labor-Hour, and Letter Contracts\n16.600 Scope.\nTime-and-materials contracts and labor-hour contracts are not fixed-price contracts.\n16.601 Time-and-materials contracts.\n(a) Definitions for the purposes of Time-and-Materials Contracts.\nDirect materials  means those materials that enter directly into the end product, or that are used or consumed directly in connection with the furnishing of the end product or service.\nHourly rate  means the rate(s) prescribed in the contract for payment for labor that meets the labor category qualifications of a labor category specified in the contract that are  \n(1) Performed by the contractor;\n(2) Performed by the subcontractors; or\n(3) Transferred between divisions, subsidiaries, or affiliates of the contractor under a common control.\nMaterials  means  \n(1) Direct materials, including supplies transferred between divisions, subsidiaries, or affiliates of the contractor under a common control;\n(2) Subcontracts for supplies and incidental services for which there is not a labor category specified in the contract;\n(3) Other direct costs ( e.g. , incidental services for which there is not a labor category specified in the contract, travel, computer usage charges, etc.); and\n(4) Applicable indirect costs.\n(b) Description . A time-and-materials contract provides for acquiring supplies or services on the basis of  \n(1) Direct labor hours at specified fixed hourly rates that include wages, overhead, general and administrative expenses, and profit; and\n(2) Actual cost for materials (except as provided for in 31.205-26 (e) and (f)).\n(c) Application . A time-and-materials contract may be used only when it is not possible at the time of placing the contract to estimate accurately the extent or duration of the work or to anticipate costs with any reasonable degree of confidence. See 12.207 (b) for the use of time-and-material contracts for certain commercial services.\n(1) Government surveillance . A time-and-materials contract provides no positive profit incentive to the contractor for cost control or labor efficiency. Therefore, appropriate Government surveillance of contractor performance is required to give reasonable assurance that efficient methods and effective cost controls are being used.\n(2) Fixed hourly rates .\n(i) The contract shall specify separate fixed hourly rates that include wages, overhead, general and administrative expenses, and profit for each category of labor (see 16.601 (f)(1)).\n(ii) For acquisitions of noncommercial items awarded without adequate price competition (see 15.403-1 (c)(1)), the contract shall specify separate fixed hourly rates that include wages, overhead, general and administrative expenses, and profit for each category of labor to be performed by  \n(A) The contractor;\n(B) Each subcontractor; and\n(C) Each division, subsidiary, or affiliate of the contractor under a common control.\n(iii) For contract actions that are not awarded using competitive procedures, unless exempt under paragraph (c)(2)(iv) of this section, the fixed hourly rates for services transferred between divisions, subsidiaries, or affiliates of the contractor under a common control  \n(A) Shall not include profit for the transferring organization; but\n(B) May include profit for the prime contractor.\n(iv) For contract actions that are not awarded using competitive procedures, the fixed hourly rates for services that meet the definition of commercial item at 2.101 that are transferred between divisions, subsidiaries, or affiliates of the contractor under a common control may be the established catalog or market rate when  \n(A) It is the established practice of the transferring organization to price interorganizational transfers at other than cost for commercial work of the contractor or any division, subsidiary or affiliate of the contractor under a common control; and\n(B) The contracting officer has not determined the price to be unreasonable.\n(3) Material handling costs . When included as part of material costs, material handling costs shall include only costs clearly excluded from the labor-hour rate. Material handling costs may include all appropriate indirect costs allocated to direct materials in accordance with the contractor's usual accounting procedures consistent with Part 31 .\n(d) Limitations . A time-and-materials contract or order may be used only if  \n(1) The contracting officer prepares a determination and findings that no other contract type is suitable. The determination and finding shall be  \n(i) Signed by the contracting officer prior to the execution of the base period or any option periods of the contracts; and\n(ii) Approved by the head of the contracting activity prior to the execution of the base period when the base period plus any option periods exceeds three years; and\n(2) The contract or order includes a ceiling price that the contractor exceeds at its own risk. Also see 12.207 (b) for further limitations on use of time-and-materials or labor-hour contracts for acquisition of commercial items.\n(e) Post award requirements. Prior to an increase in the ceiling price of a time-and-materials or labor-hour contract or order, the contracting officer shall  \n(1) Conduct an analysis of pricing and other relevant factors to determine if the action is in the best interest of the Government;\n(2) Document the decision in the contract or order file; and\n(3) When making a change that modifies the general scope of  \n(i) A contract, follow the procedures at 6.303 ;\n(ii) An order issued under the Federal Supply Schedules, follow the procedures at 8.405-6 ; or\n(iii) An order issued under multiple award task and delivery order contracts, follow the procedures at 16.505 (b)(2).\n(f) Solicitation provisions .\n(1) The contracting officer shall insert the provision at 52.216-29 , Time-and-Materials/Labor-Hour Proposal Requirements  Non-Commercial Item Acquisitions With Adequate Price Competition, in solicitations contemplating use of a Time-and-Materials or Labor-Hour type of contract for noncommercial items, if the price is expected to be based on adequate price competition. If authorized by agency procedures, the contracting officer may amend the provision to make mandatory one of the three approaches in paragraph (c) of the provision, and/or to require the identification of all subcontractors, divisions, subsidiaries, or affiliates included in a blended labor rate.\n(2) The contracting officer shall insert the provision at 52.216-30 , Time-and-Materials/Labor-Hour Proposal Requirements  Non-Commercial Item Acquisitions without Adequate Price Competition, in solicitations for noncommercial items contemplating use of a Time-and-Materials or Labor-Hour type of contract if the price is not expected to be based on adequate price competition.\n(3) The contracting officer shall insert the provision at 52.216-31 , Time-and-Materials/Labor-Hour Proposal Requirements  Commercial Item Acquisitions, in solicitations contemplating use of a Commercial Time-and-Materials or Labor-Hour contract.\n16.602 Labor-hour contracts.\nDescription. A labor-hour contract is a variation of the time-and-materials contract, differing only in that materials are not supplied by the contractor. See 12.207 (b), 16.601 (c), and 16.601 (d) for application and limitations, for time-and-materials contracts that also apply to labor-hour contracts. See 12.207 (b) for the use of labor-hour contracts for certain commercial services.\n16.603 Letter contracts.\n16.603-1 Description.\nA letter contract is a written preliminary contractual instrument that authorizes the contractor to begin immediately manufacturing supplies or performing services.\n16.603-2 Application.\n(a) A letter contract may be used when (1) the Government  s interests demand that the contractor be given a binding commitment so that work can start immediately and (2) negotiating a definitive contract is not possible in sufficient time to meet the requirement. However, a letter contract should be as complete and definite as feasible under the circumstances.\n(b) When a letter contract award is based on price competition, the contracting officer shall include an overall price ceiling in the letter contract.\n(c) Each letter contract shall, as required by the clause at 52.216-25 , Contract Definitization, contain a negotiated definitization schedule including (1) dates for submission of the contractor's price proposal, required certified cost or pricing data and data other than certified cost or pricing data; and, if required, make-or-buy and subcontracting plans, (2) a date for the start of negotiations, and (3) a target date for definitization, which shall be the earliest practicable date for definitization. The schedule will provide for definitization of the contract within 180 days after the date of the letter contract or before completion of 40 percent of the work to be performed, whichever occurs first. However, the contracting officer may, in extreme cases and according to agency procedures, authorize an additional period. If, after exhausting all reasonable efforts, the contracting officer and the contractor cannot negotiate a definitive contract because of failure to reach agreement as to price or fee, the clause at 52.216-25 requires the contractor to proceed with the work and provides that the contracting officer may, with the approval of the head of the contracting activity, determine a reasonable price or fee in accordance with Subpart 15.4 and Part 31 , subject to appeal as provided in the Disputes clause.\n(d) The maximum liability of the Government inserted in the clause at 52.216-24 , Limitation of Government Liability, shall be the estimated amount necessary to cover the contractor  s requirements for funds before definitization. However, it shall not exceed 50 percent of the estimated cost of the definitive contract unless approved in advance by the official that authorized the letter contract.\n(e) The contracting officer shall assign a priority rating to the letter contract if it is appropriate under 11.604 .\n16.603-3 Limitations.\nA letter contract may be used only after the head of the contracting activity or a designee determines in writing that no other contract is suitable. Letter contracts shall not  \n(a) Commit the Government to a definitive contract in excess of the funds available at the time the letter contract is executed;\n(b) Be entered into without competition when competition is required by Part 6 ; or\n(c) Be amended to satisfy a new requirement unless that requirement is inseparable from the existing letter contract. Any such amendment is subject to the same requirements and limitations as a new letter contract.\n16.603-4 Contract clauses.\n(a) The contracting officer shall include in each letter contract the clauses required by this regulation for the type of definitive contract contemplated and any additional clauses known to be appropriate for it.\n(b) In addition, the contracting officer shall insert the following clauses in solicitations and contracts when a letter contract is contemplated:\n(1) The clause at 52.216-23 , Execution and Commencement of Work, except that this clause may be omitted from letter contracts awarded on SF 26 ;\n(2) The clause at 52.216-24 , Limitation of Government Liability, with dollar amounts completed in a manner consistent with 16.603-2 (d); and\n(3) The clause at 52.216-25 , Contract Definitization, with its paragraph (b) completed in a manner consistent with 16.603-2 (c). If at the time of entering into the letter contract, the contracting officer knows that the definitive contract will be based on adequate price competition or will otherwise meet the criteria of 15.403-1 for not requiring submission of certified cost or pricing data, the words  and certified cost or pricing data in accordance with FAR 15.408, Table 15-2 supporting its proposal  may be deleted from paragraph (a) of the clause. If the letter contract is being awarded on the basis of price competition, the contracting officer shall use the clause with its Alternate I.\n(c) The contracting officer shall also insert the clause at 52.216-26 , Payments of Allowable Costs Before Definitization, in solicitations and contracts if a cost-reimbursement definitive contract is contemplated, unless the acquisition involves conversion, alteration, or repair of ships.");
register_book(&s, "|16|7|", "Agreements", "Subpart 16.7  Agreements\n16.701 Scope.\nThis subpart prescribes policies and procedures for establishing and using basic agreements and basic ordering agreements. (See 13.303 for blanket purchase agreements (BPA  s) and see 35.015 (b) for additional coverage of basic agreements with educational institutions and nonprofit organizations.)\n16.702 Basic agreements.\n(a) Description . A basic agreement is a written instrument of understanding, negotiated between an agency or contracting activity and a contractor, that (1) contains contract clauses applying to future contracts between the parties during its term and (2) contemplates separate future contracts that will incorporate by reference or attachment the required and applicable clauses agreed upon in the basic agreement. A basic agreement is not a contract.\n(b) Application . A basic agreement should be used when a substantial number of separate contracts may be awarded to a contractor during a particular period and significant recurring negotiating problems have been experienced with the contractor. Basic agreements may be used with negotiated fixed-price or cost-reimbursement contracts.\n(1) Basic agreements shall contain  \n(i) Clauses required for negotiated contracts by statute, executive order, and this regulation; and\n(ii) Other clauses prescribed in this regulation or agency acquisition regulations that the parties agree to include in each contract as applicable.\n(2) Each basic agreement shall provide for discontinuing its future applicability upon 30 days  written notice by either party.\n(3) Each basic agreement shall be reviewed annually before the anniversary of its effective date and revised as necessary to conform to the requirements of this regulation. Basic agreements may need to be revised before the annual review due to mandatory statutory requirements. A basic agreement may be changed only by modifying the agree-ment itself and not by a contract incorporating the agreement.\n(4) Discontinuing or modifying a basic agreement shall not affect any prior contract incorporating the basic agreement.\n(5) Contracting officers of one agency should obtain and use existing basic agreements of another agency to the maximum practical extent.\n(c) Limitations . A basic agreement shall not  \n(1) Cite appropriations or obligate funds;\n(2) State or imply any agreement by the Government to place future contracts or orders with the contractor; or\n(3) Be used in any manner to restrict competition.\n(d) Contracts incorporating basic agreements.\n(1) Each contract incorporating a basic agreement shall include a scope of work and price, delivery, and other appropriate terms that apply to the particular contract. The basic agreement shall be incorporated into the contract by specific reference (including reference to each amendment) or by attachment.\n(2) The contracting officer shall include clauses pertaining to subjects not covered by the basic agreement, but applicable to the contract being negotiated, in the same manner as if there were no basic agreement.\n(3) If an existing contract is modified to effect new acquisition, the modification shall incorporate the most recent basic agreement, which shall apply only to work added by the modification, except that this action is not mandatory if the contract or modification includes all clauses required by statute, executive order, and this regulation as of the date of the modification. However, if it is in the Government  s interest and the contractor agrees, the modification may incorporate the most recent basic agreement for application to the entire contract as of the date of the modification.\n16.703 Basic ordering agreements.\n(a) Description . A basic ordering agreement is a written instrument of understanding, negotiated between an agency, contracting activity, or contracting office and a contractor, that contains (1) terms and clauses applying to future contracts (orders) between the parties during its term, (2) a description, as specific as practicable, of supplies or services to be provided, and (3) methods for pricing, issuing, and delivering future orders under the basic ordering agreement. A basic ordering agreement is not a contract.\n(b) Application . A basic ordering agreement may be used to expedite contracting for uncertain requirements for supplies or services when specific items, quantities, and prices are not known at the time the agreement is executed, but a substantial number of requirements for the type of supplies or services covered by the agreement are anticipated to be purchased from the contractor. Under proper circumstances, the use of these procedures can result in economies in ordering parts for equipment support by reducing administrative lead-time, inventory investment, and inventory obsolescence due to design changes.\n(c) Limitations . A basic ordering agreement shall not state or imply any agreement by the Government to place future contracts or orders with the contractor or be used in any manner to restrict competition.\n(1) Each basic ordering agreement shall  \n(i) Describe the method for determining prices to be paid to the contractor for the supplies or services;\n(ii) Include delivery terms and conditions or specify how they will be determined;\n(iii) List one or more Government activities authorized to issue orders under the agreement;\n(iv) Specify the point at which each order becomes a binding contract ( e.g., issuance of the order, acceptance of the order in a specified manner, or failure to reject the order within a specified number of days);\n(v) Provide that failure to reach agreement on price for any order issued before its price is established (see paragraph (d)(3) of this section) is a dispute under the Disputes clause included in the basic ordering agreement; and\n(vi) If fast payment procedures will apply to orders, include the special data required by 13.403 .\n(2) Each basic ordering agreement shall be reviewed annually before the anniversary of its effective date and revised as necessary to conform to the requirements of this regulation. Basic ordering agreements may need to be revised before the annual review due to mandatory statutory requirements. A basic ordering agreement shall be changed only by modifying the agreement itself and not by individual orders issued under it. Modifying a basic ordering agreement shall not retroactively affect orders previously issued under it.\n(d) Orders . A contracting officer representing any Government activity listed in a basic ordering agreement may issue orders for required supplies or services covered by that agreement.\n(1) Before issuing an order under a basic ordering agreement, the contracting officer shall  \n(i) Obtain competition in accordance with Part 6 ;\n(ii) If the order is being placed after competition, ensure that use of the basic ordering agreement is not prejudicial to other offerors; and\n(iii) Sign or obtain any applicable justifications and approvals, and any determination and findings, and comply with other requirements in accordance with 1.602-1 (b), as if the order were a contract awarded independently of a basic ordering agreement.\n(2) Contracting officers shall  \n(i) Issue orders under basic ordering agreements on Optional Form (OF) 347 , Order for Supplies or Services, or on any other appropriate contractual instrument;\n(ii) Incorporate by reference the provisions of the basic ordering agreement;\n(iii) If applicable, cite the authority under 6.302 in each order; and\n(iv) Comply with 5.203 when synopsis is required by 5.201 .\n(3) The contracting officer shall neither make any final commitment nor authorize the contractor to begin work on an order under a basic ordering agreement until prices have been established, unless the order establishes a ceiling price limiting the Government  s obligation and either  \n(i) The basic ordering agreement provides adequate procedures for timely pricing of the order early in its performance period; or\n(ii) The need for the supplies or services is compelling and unusually urgent ( i.e., when the Government would be seriously injured, financially or otherwise, if the requirement is not met sooner than would be possible if prices were established before the work began). The contracting officer shall proceed with pricing as soon as practical. In no event shall an entire order be priced retroactively.\n*    *    *    *    *    *");
register_book(&s, "|17|2|", "Options", "Subpart 17.2  Options\n17.200 Scope of subpart.\nThis subpart prescribes policies and procedures for the use of option solicitation provisions and contract clauses. Except as provided in agency regulations, this subpart does not apply to contracts for (a) services involving the construction, alteration, or repair (including dredging, excavating, and painting) of buildings, bridges, roads, or other kinds of real property; (b) architect-engineer services; and (c) research and development services. However, it does not preclude the use of options in those contracts.\n17.201 [Reserved]\n17.202 Use of options.\n(a) Subject to the limitations of paragraphs (b) and (c) of this section, for both sealed bidding and contracting by negotiation, the contracting officer may include options in contracts when it is in the Government  s interest. When using sealed bidding, the contracting officer shall make a written determination that there is a reasonable likelihood that the options will be exercised before including the provision at 52.217-5 , Evaluation of Options, in the solicitation. (See 17.207 (f) with regard to the exercise of options.)\n(b) Inclusion of an option is normally not in the Government  s interest when, in the judgment of the contracting officer  \n(1) The foreseeable requirements involve  \n(i) Minimum economic quantities ( i.e., quantities large enough to permit the recovery of startup costs and the production of the required supplies at a reasonable price); and\n(ii) Delivery requirements far enough into the future to permit competitive acquisition, production, and delivery.\n(2) An indefinite quantity or requirements contract would be more appropriate than a contract with options. However, this does not preclude the use of an indefinite quantity contract or requirements contract with options.\n(c) The contracting officer shall not employ options if  \n(1) The contractor will incur undue risks; e.g., the price or availability of necessary materials or labor is not reasonably foreseeable;\n(2) Market prices for the supplies or services involved are likely to change substantially; or\n(3) The option represents known firm requirements for which funds are available unless  \n(i) The basic quantity is a learning or testing quantity; and\n(ii) Competition for the option is impracticable once the initial contract is awarded.\n(d) In recognition of  \n(1) The Government  s need in certain service contracts for continuity of operations; and\n(2) The potential cost of disrupted support, options may be included in service contracts if there is an anticipated need for a similar service beyond the first contract period.\n17.203 Solicitations.\n(a) Solicitations shall include appropriate option provisions and clauses when resulting contracts will provide for the exercise of options (see 17.208 ).\n(b) Solicitations containing option provisions shall state the basis of evaluation, either exclusive or inclusive of the option and, when appropriate, shall inform offerors that it is anticipated that the Government may exercise the option at time of award.\n(c) Solicitations normally should allow option quantities to be offered without limitation as to price, and there shall be no limitation as to price if the option quantity is to be considered in the evaluation for award (see 17.206 ).\n(d) Solicitations that allow the offer of options at unit prices which differ from the unit prices for the basic requirement shall state that offerors may offer varying prices for options, depending on the quantities actually ordered and the dates when ordered.\n(e) If it is anticipated that the Government may exercise an option at the time of award and if the condition specified in paragraph (d) of this section applies, solicitations shall specify the price at which the Government will evaluate the option (highest option price offered or option price for specified requirements).\n(f) Solicitations may, in unusual circumstances, require that options be offered at prices no higher than those for the initial requirement; e.g., when  \n(1) The option cannot be evaluated under 17.206 ; or;\n(2) Future competition for the option is impracticable.\n(g) Solicitations that require the offering of an option at prices no higher than those for the initial requirement shall  \n(1) Specify that the Government will accept an offer containing an option price higher than the base price only if the acceptance does not prejudice any other offeror; and\n(2) Limit option quantities for additional supplies to not more than 50 percent of the initial quantity of the same contract line item. In unusual circumstances, an authorized person at a level above the contracting officer may approve a greater percentage of quantity.\n(h) Include the value of options in determining if the acquisition will exceed the World Trade Organization Government Procurement Agreement or Free Trade Agreement thresholds.\n17.204 Contracts.\n(a) The contract shall specify limits on the purchase of additional supplies or services, or the overall duration of the term of the contract, including any extension.\n(b) The contract shall state the period within which the option may be exercised.\n(c) The period shall be set so as to provide the contractor adequate lead time to ensure continuous production.\n(d) The period may extend beyond the contract completion date for service contracts. This is necessary for situations when exercise of the option would result in the obligation of funds that are not available in the fiscal year in which the contract would otherwise be completed.\n(e) Unless otherwise approved in accordance with agency procedures, the total of the basic and option periods shall not exceed 5 years in the case of services, and the total of the basic and option quantities shall not exceed the requirement for 5 years in the case of supplies. These limitations do not apply to information technology contracts. However, statutes applicable to various classes of contracts, for example, the Service Contract Act (see 22.1002-1 ), may place additional restrictions on the length of contracts.\n(f) Contracts may express options for increased quantities of supplies or services in terms of  \n(1) Percentage of specific line items,\n(2) Increase in specific line items; or\n(3) Additional numbered line items identified as the option.\n(g) Contracts may express extensions of the term of the contract as an amended completion date or as additional time for performance; e.g., days, weeks, or months.\n17.205 Documentation.\n(a) The contracting officer shall justify in writing the quantities or the term under option, the notification period for exercising the option, and any limitation on option price under 17.203 (g); and shall include the justification document in the contract file.\n(b) Any justifications and approvals and any determination and findings required by Part 6 shall specify both the basic requirement and the increase permitted by the option.\n17.206 Evaluation.\n(a) In awarding the basic contract, the contracting officer shall, except as provided in paragraph (b) of this section, evaluate offers for any option quantities or periods contained in a solicitation when it has been determined prior to soliciting offers that the Government is likely to exercise the options. (See 17.208 .)\n(b) The contracting officer need not evaluate offers for any option quantities when it is determined that evaluation would not be in the best interests of the Government and this determination is approved at a level above the contracting officer. An example of a circumstance that may support a determination not to evaluate offers for option quantities is when there is a reasonable certainty that funds will be unavailable to permit exercise of the option.\n17.207 Exercise of options.\n(a) When exercising an option, the contracting officer shall provide written notice to the contractor within the time period specified in the contract.\n(b) When the contract provides for economic price adjustment and the contractor requests a revision of the price, the contracting officer shall determine the effect of the adjustment on prices under the option before the option is exercised.\n(c) The contracting officer may exercise options only after determining that  \n(1) Funds are available;\n(2) The requirement covered by the option fulfills an existing Government need;\n(3) The exercise of the option is the most advantageous method of fulfilling the Government  s need, price and other factors (see paragraphs (d) and (e) of this section) considered; \n(4) The option was synopsized in accordance with Part 5 unless exempted by 5.202 (a)(11) or other appropriate exemptions in 5.202 ; \n(5) The contractor is not listed in the System for Award Management Exclusions (see FAR 9.405-1 );\n(6) The contractor  s past performance evaluations on other contract actions have been considered; and\n(7) The contractor  s performance on this contract has been acceptable, e.g. , received satisfactory ratings.\n(d) The contracting officer, after considering price and other factors, shall make the determination on the basis of one of the following:\n(1) A new solicitation fails to produce a better price or a more advantageous offer than that offered by the option. If it is anticipated that the best price available is the option price or that this is the more advantageous offer, the contracting officer should not use this method of testing the market.\n(2) An informal analysis of prices or an examination of the market indicates that the option price is better than prices available in the market or that the option is the more advantageous offer.\n(3) The time between the award of the contract containing the option and the exercise of the option is so short that it indicates the option price is the lowest price obtainable or the more advantageous offer. The contracting officer shall take into consideration such factors as market stability and comparison of the time since award with the usual duration of contracts for such supplies or services.\n(e) The determination of other factors under paragraph (c)(3) of this section  \n(1) Should take into account the Government  s need for continuity of operations and potential costs of disrupting operations; and\n(2) May consider the effect on small business.\n(f) Before exercising an option, the contracting officer shall make a written determination for the contract file that exercise is in accordance with the terms of the option, the requirements of this section, and Part 6 . To satisfy requirements of Part 6 regarding full and open competition, the option must have been evaluated as part of the initial competition and be exercisable at an amount specified in or reasonably determinable from the terms of the basic contract, e.g.  \n(1) A specific dollar amount;\n(2) An amount to be determined by applying provisions (or a formula) provided in the basic contract, but not including renegotiation of the price for work in a fixed-price type contract;\n(3) In the case of a cost-type contract, if  \n(i) The option contains a fixed or maximum fee; or\n(ii) The fixed or maximum fee amount is determinable by applying a formula contained in the basic contract (but see 16.102 (c));\n(4) A specific price that is subject to an economic price adjustment provision; or\n(5) A specific price that is subject to change as the result of changes to prevailing labor rates provided by the Secretary of Labor.\n(g) The contract modification or other written document which notifies the contractor of the exercise of the option shall cite the option clause as authority.\n17.208 Solicitation provisions and contract clauses.\n(a) Insert a provision substantially the same as the provision at 52.217-3 , Evaluation Exclusive of Options, in solicitations when the solicitation includes an option clause and does not include one of the provisions prescribed in paragraph (b) or (c) of this section.\n(b) Insert a provision substantially the same as the provision at 52.217-4 , Evaluation of Options Exercised at Time of Contract Award, in solicitations when the solicitation includes an option clause, the contracting officer has determined that there is a reasonable likelihood that the option will be exercised, and the option may be exercised at the time of contract award.\n(c) Insert a provision substantially the same as the provision at 52.217-5 , Evaluation of Options, in solicitations when  \n(1) The solicitation contains an option clause;\n(2) An option is not to be exercised at the time of contract award;\n(3) A firm-fixed-price contract, a fixed-price contract with economic price adjustment, or other type of contract approved under agency procedures is contemplated; and\n(4) The contracting officer has determined that there is a reasonable likelihood that the option will be exercised. For sealed bids, the determination shall be in writing.\n(d) Insert a clause substantially the same as the clause at 52.217-6 , Option for Increased Quantity, in solicitations and contracts, other than those for services, when the inclusion of an option is appropriate (see 17.200 and 17.202 ) and the option quantity is expressed as a percentage of the basic contract quantity or as an additional quantity of a specific line item.\n(e) Insert a clause substantially the same as the clause at 52.217-7 , Option for Increased Quantity  Separately Priced Line Item, in solicitations and contracts, other than those for services, when the inclusion of an option is appropriate (see 17.200 and 17.202 ) and the option quantity is identified as a separately priced line item having the same nomenclature as a corresponding basic contract line item.\n(f) Insert a clause substantially the same as the clause at 52.217-8 , Option to Extend Services, in solicitations and contracts for services when the inclusion of an option is appropriate. (See 17.200 , 17.202 , and 37.111 .)\n(g) Insert a clause substantially the same as the clause at 52.217-9 , Option to Extend the Term of the Contract, in solicitations and contracts when the inclusion of an option is appropriate (see 17.200 and 17.202 ) and it is necessary to include in the contract any or all of the following:\n(1) A requirement that the Government must give the contractor a preliminary written notice of its intent to extend the contract.\n(2) A statement that an extension of the contract includes an extension of the option.\n(3) A specified limitation on the total duration of the contract.");
register_book(&s, "|17|4|", "Leader Company Contracting", "Subpart 17.4  Leader Company Contracting\n17.401 General.\nLeader company contracting is an extraordinary acquisition technique that is limited to special circumstances and utilized only when its use is in accordance with agency procedures. A developer or sole producer of a product or system is designated under this acquisition technique to be the leader company, and to furnish assistance and know-how under an approved contract to one or more designated follower companies, so they can become a source of supply. The objectives of this technique are one or more of the following:\n(a) Reduce delivery time.\n(b) Achieve geographic dispersion of suppliers.\n(c) Maximize the use of scarce tooling or special equipment.\n(d) Achieve economies in production.\n(e) Ensure uniformity and reliability in equipment, compatibility or standardization of components, and interchangeability of parts.\n(f) Eliminate problems in the use of proprietary data that cannot be resolved by more satisfactory solutions.\n(g) Facilitate the transition from development to production and to subsequent competitive acquisition of end items or major components.\n17.402 Limitations.\n(a) Leader company contracting is to be used only when  \n(1) The leader company has the necessary production know-how and is able to furnish required assistance to the follower(s);\n(2) No other source can meet the Government  s requirements without the assistance of a leader company;\n(3) The assistance required of the leader company is limited to that which is essential to enable the follower(s) to produce the items; and\n(4) Its use is authorized in accordance with agency procedures.\n(b) When leader company contracting is used, the Government shall reserve the right to approve subcontracts between the leader company and the follower(s).\n17.403 Procedures.\n(a) The contracting officer may award a prime contract to a  \n(1) Leader company, obligating it to subcontract a designated portion of the required end items to a specified follower company and to assist it to produce the required end items;\n(2) Leader company, for the required assistance to a follower company, and a prime contract to the follower for production of the items; or\n(3) Follower company, obligating it to subcontract with a designated leader company for the required assistance.\n(b) The contracting officer shall ensure that any contract awarded under this arrangement contains a firm agreement regarding disclosure, if any, of contractor trade secrets, technical designs or concepts, and specific data, or software, of a proprietary nature.");
register_book(&s, "|17|5|", "Interagency Acquisitions", "Subpart 17.5  Interagency Acquisitions \n17.500 Scope of subpart.\n(a) This subpart prescribes policies and procedures applicable to all interagency acquisitions under any authority, except as provided for in paragraph (c) of this section. In addition to complying with the interagency acquisition policy and procedures in this subpart, nondefense agencies acquiring supplies and services on behalf of the Department of Defense shall also comply with the policy and procedures at Subpart 17.7 . \n(b) This subpart applies to interagency acquisitions, see 2.101 for definition, when  \n(1) An agency needing supplies or services obtains them using another agency  s contract; or\n(2) An agency uses another agency to provide acquisition assistance, such as awarding and administering a contract, a task order, or delivery order.\n(c) This subpart does not apply to  \n(1) Interagency reimbursable work performed by Federal employees (other than acquisition assistance), or interagency activities where contracting is incidental to the purpose of the transaction; or\n(2) Orders of $500,000 or less issued against Federal Supply Schedules.\n17.501 General.\n(a) Interagency acquisitions are commonly conducted through indefinite-delivery contracts, such as task- and delivery-order contracts. The indefinite-delivery contracts used most frequently to support interagency acquisitions are Federal Supply Schedules (FSS), Governmentwide acquisition contracts (GWACs), and multi-agency contracts (MACs).\n(b) An agency shall not use an interagency acquisition to circumvent conditions and limitations imposed on the use of funds.\n(c) An interagency acquisition is not exempt from the requirements of subpart 7.3 , Contractor Versus Government Performance.\n(d) An agency shall not use an interagency acquisition to make acquisitions conflicting with any other agency  s authority or responsibility (for example, that of the Administrator of General Services under title 40, United States Code ,  Public Buildings, Property and Works  and title III of the Federal Property and Administrative Services Act of 1949.)\n17.502 Procedures.\n17.502-1 General.\n(a) Determination of best procurement approach. \n(1) Assisted acquisitions . Prior to requesting that another agency conduct an acquisition on its behalf, the requesting agency shall make a determination that the use of an interagency acquisition represents the best procurement approach. As part of the best procurement approach determination, the requesting agency shall obtain the concurrence of the requesting agency  s responsible contracting office in accordance with internal agency procedures. At a minimum, the determination shall include an analysis of procurement approaches, including an evaluation by the requesting agency that using the acquisition services of another agency  \n(i) Satisfies the requesting agency  s schedule, performance, and delivery requirements (taking into account factors such as the servicing agency  s authority, experience, and expertise as well as customer satisfaction with the servicing agency  s past performance);\n(ii) Is cost effective (taking into account the reasonableness of the servicing agency  s fees); and\n(iii) Will result in the use of funds in accordance with appropriation limitations and compliance with the requesting agency  s laws and policies.\n(2) Direct acquisitions . Prior to placing an order against another agency  s indefinite-delivery vehicle, the requesting agency shall make a determination that use of another agency  s contract vehicle is the best procurement approach and shall obtain the concurrence of the requesting agency  s responsible contracting office. At a minimum, the determination shall include an analysis, including factors such as:\n(i) The suitability of the contract vehicle;\n(ii) The value of using the contract vehicle, including  \n(A) The administrative cost savings from using an existing contract;\n(B) Lower prices, greater number of vendors, and reasonable vehicle access fees; and\n(iii) The expertise of the requesting agency to place orders and administer them against the selected contract vehicle throughout the acquisition lifecycle.\n(b) Written agreement on responsibility for management and administration. \n(1) Assisted acquisitions. \n(i) Prior to the issuance of a solicitation, the servicing agency and the requesting agency shall both sign a written interagency agreement that establishes the general terms and conditions governing the relationship between the parties, including roles and responsibilities for acquisition planning, contract execution, and administration and management of the contract(s) or order(s). The requesting agency shall provide to the servicing agency any unique terms, conditions, and applicable agency-specific statutes, regulations, directives, and other applicable requirements for incorporation into the order or contract. In the event there are no agency unique requirements beyond the FAR, the requesting agency shall so inform the servicing agency contracting officer in writing. For acquisitions on behalf of the Department of Defense, also see Subpart 17.7 . for patent rights, see 27.304-2 . In preparing interagency agreements to support assisted acquisitions, agencies should review the Office of Federal Procurement Policy guidance, Interagency Acquisitions, available at http://www.whitehouse.gov/omb/assets/procurement/iac_revised.pdf .\n(ii) Each agency  s file shall include the interagency agreement between the requesting and servicing agency, and shall include sufficient documentation to ensure an adequate audit consistent with 4.801 (b).\n(2) Direct acquisitions . The requesting agency administers the order; therefore, no written agreement with the servicing agency is required.\n(c) Business-case analysis requirements for multi-agency contracts and governmentwide acquisition contracts . In order to establish a multi-agency or governmentwide acquisition contract, a business-case analysis must be prepared by the servicing agency and approved in accordance with the Office of Federal Procurement Policy (OFPP) business case guidance, available at http://www.whitehouse.gov/sites/default/files/omb/procurement/memo/development-review-and-approval-of-business-cases-for-certain-interagency-and-agency-specific-acquisitions-memo.pdf . The business-case analysis shall  \n(1) Consider strategies for the effective participation of small businesses during acquisition planning (see 7.103(u));\n(2) Detail the administration of such contract, including an analysis of all direct and indirect costs to the Government of awarding and administering such contract;\n(3) Describe the impact such contract will have on the ability of the Government to leverage its purchasing power, e.g. , will it have a negative effect because it dilutes other existing contracts;\n(4) Include an analysis concluding that there is a need for establishing the multi-agency contract; and\n(5) Document roles and responsibilities in the administration of the contract.\n17.502-2 The Economy Act.\n(a) The Economy Act ( 31 U.S.C. 1535 ) authorizes agencies to enter into agreements to obtain supplies or services from another agency. The FAR applies when one agency uses another agency  s contract to obtain supplies or services. If the interagency business transaction does not result in a contract or an order, then the FAR does not apply. The Economy Act also provides authority for placement of orders between major organizational units within an agency; procedures for such intra-agency transactions are addressed in agency regulations.\n(b) The Economy Act applies when more specific statutory authority does not exist. Examples of more specific authority are 40 U.S.C. 501 for the Federal Supply Schedules (subpart 8.4 ), and 40 U.S.C. 11302 (e) for Governmentwide acquisition contracts (GWACs).\n(c) Requirements for determinations and findings. \n(1) Each Economy Act order to obtain supplies or services by interagency acquisition shall be supported by a determination and findings (D&F). The D&F shall  \n(i) State that use of an interagency acquisition is in the best interest of the Government; \n(ii) State that the supplies or services cannot be obtained as conveniently or economically by contracting directly with a private source; and\n(iii) Include a statement that at least one of the following circumstances applies:\n(A) The acquisition will appropriately be made under an existing contract of the servicing agency, entered into before placement of the order, to meet the requirements of the servicing agency for the same or similar supplies or services.\n(B) The servicing agency has the capability or expertise to enter into a contract for such supplies or services that is not available within the requesting agency.\n(C) The servicing agency is specifically authorized by law or regulation to purchase such supplies or services on behalf of other agencies.\n(2) The D&F shall be approved by a contracting officer of the requesting agency with authority to contract for the supplies or services to be ordered, or by another official designated by the agency head, except that, if the servicing agency is not covered by the FAR, approval of the D&F may not be delegated below the senior procurement executive of the requesting agency.\n(3) The requesting agency shall furnish a copy of the D&F to the servicing agency with the request for order.\n(d) Payment.\n(1) The servicing agency may ask the requesting agency, in writing, for advance payment for all or part of the estimated cost of furnishing the supplies or services. Adjustment on the basis of actual costs shall be made as agreed to by the agencies.\n(2) If approved by the servicing agency, payment for actual costs may be made by the requesting agency after the supplies or services have been furnished.\n(3) Bills rendered or requests for advance payment shall not be subject to audit or certification in advance of payment.\n(4) In no event shall the servicing agency require, or the requesting agency pay, any fee or charge in excess of the actual cost (or estimated cost if the actual cost is not known) of entering into and administering the contract or other agreement under which the order is filled.\n17.503 Ordering procedures.\n(a) Before placing an order for supplies or services with another Government agency, the requesting agency shall follow the procedures in 17.502-1 and, if under the Economy Act, also 17.502-2 .\n(b) The order may be placed on any form or document that is acceptable to both agencies. The order should include  \n(1) A description of the supplies or services required;\n(2) Delivery requirements;\n(3) A funds citation;\n(4) A payment provision (see 17.502-2 (d) for Economy Act orders); and\n(5) Acquisition authority as may be appropriate (see 17.503 (d)).\n(c) The requesting and servicing agencies should agree to procedures for the resolution of disagreements that may arise under interagency acquisitions, including, in appropriate circumstances, the use of a third-party forum. If a third party is proposed, consent of the third party should be obtained in writing.\n(d) When an interagency acquisition requires the servicing agency to award a contract, the following procedures also apply:\n(1) If a justification and approval or a D&F (other than the requesting agency  s D&F required in 17.502-2 (c)) is required by law or regulation, the servicing agency shall execute and issue the justification and approval or D&F. The requesting agency shall furnish the servicing agency any information needed to make the justification and approval or D&F.\n(2) The requesting agency shall also be responsible for furnishing other assistance that may be necessary, such as providing information or special contract terms needed to comply with any condition or limitation applicable to the funds of the requesting agency.\n(3) The servicing agency is responsible for compliance with all other legal or regulatory requirements applicable to the contract, including  \n(i) Having adequate statutory authority for the contractual action; and\n(ii) Complying fully with the competition requirements of part 6 (see 6.002 ). However, if the servicing agency is not subject to the Federal Acquisition Regulation, the requesting agency shall verify that contracts utilized to meet its requirements contain provisions protecting the Government from inappropriate charges (for example, provisions mandated for FAR agencies by part 31 ), and that adequate contract administration will be provided.\n(e) Nonsponsoring Federal agencies may use a Federally Funded Research and Development Center (FFRDC) only if the terms of the FFRDC  s sponsoring agreement permit work from other than a sponsoring agency. Work placed with the FFRDC is subject to the acceptance by the sponsor and must fall within the purpose, mission, general scope of effort, or special competency of the FFRDC. (See 35.017 ; see also 6.302 for procedures to follow where using other than full and open competition.) The nonsponsoring agency shall provide to the sponsoring agency necessary documentation that the requested work would not place the FFRDC in direct competition with domestic private industry.\n17.504 Reporting requirements.\nThe senior procurement executive for each executive agency shall submit to the Director of OMB an annual report on interagency acquisitions, as directed by OMB.");
register_book(&s, "|17|6|", "Management and Operating Contracts", "Subpart 17.6  Management and Operating Contracts\n17.600 Scope of subpart.\nThis subpart prescribes policies and procedures for management and operating contracts for the Department of Energy and any other agency having requisite statutory authority.\n17.601 Definition.\nManagement and operating contract  means an agreement under which the Government contracts for the operation, maintenance, or support, on its behalf, of a Government-owned or -controlled research, development, special production, or testing establishment wholly or principally devoted to one or more major programs of the contracting Federal agency.\n17.602 Policy.\n(a) Heads of agencies, with requisite statutory authority, may determine in writing to authorize contracting officers to enter into or renew any management and operating contract in accordance with the agency  s statutory authority, or the Competition in Contracting Act of 1984, and the agency  s regulations governing such contracts. This authority shall not be delegated. Every contract so authorized shall show its authorization upon its face.\n(b) Agencies may authorize management and operating contracts only in a manner consistent with the guidance of this subpart and only if they are consistent with the situations described in 17.604 .\n(c) Within 2 years of the effective date of this regulation, agencies shall review their current contractual arrangements in the light of the guidance of this subpart, in order to  \n(1) Identify, modify as necessary, and authorize management and operating contracts; and\n(2) Modify as necessary or terminate contracts not so identified and authorized, except that any contract with less than 4 years remaining as of the effective date of this regulation need not be terminated, nor need it be identified, modified, or authorized unless it is renewed or its terms are substantially renegotiated.\n17.603 Limitations.\n(a) Management and operating contracts shall not be authorized for  \n(1) Functions involving the direction, supervision, or control of Government personnel, except for supervision incidental to training;\n(2) Functions involving the exercise of police or regulatory powers in the name of the Government, other than guard or plant protection services;\n(3) Functions of determining basic Government policies;\n(4) Day-to-day staff or management functions of the agency or of any of its elements; or\n(5) Functions that can more properly be accomplished in accordance with Subpart 45.3 , Authorizing the Use and Rental of Government Property.\n(b) Since issuance of an authorization under 17.602 (a) is deemed sufficient proof of compliance with paragraph (a) immediately above, nothing in paragraph (a) immediately above shall affect the validity or legality of such an authorization.\n(c) For use of project labor agreements, see subpart 22.5 .\n17.604 Identifying management and operating contracts.\nA management and operating contract is characterized both by its purpose (see 17.601 ) and by the special relationship it creates between Government and contractor. The following criteria can generally be applied in identifying management and operating contracts:\n(a) Government-owned or -controlled facilities must be utilized; for instance  \n(1) In the interest of national defense or mobilization readiness;\n(2) To perform the agency  s mission adequately; or\n(3) Because private enterprise is unable or unwilling to use its own facilities for the work.\n(b) Because of the nature of the work, or because it is to be performed in Government facilities, the Government must maintain a special, close relationship with the contractor and the contractor  s personnel in various important areas ( e.g., safety, security, cost control, site conditions).\n(c) The conduct of the work is wholly or at least substantially separate from the contractor  s other business, if any.\n(d) The work is closely related to the agency  s mission and is of a long-term or continuing nature, and there is a need  \n(1) To ensure its continuity; and\n(2) For special protection covering the orderly transition of personnel and work in the event of a change in contractors.\n17.605 Award, renewal, and extension.\n(a) Effective work performance under management and operating contracts usually involves high levels of expertise and continuity of operations and personnel. Because of program requirements and the unusual (sometimes unique) nature of the work performed under management and operating contracts, the Government is often limited in its ability to effect competition or to replace a contractor. Therefore contracting officers should take extraordinary steps before award to assure themselves that the prospective contractor  s technical and managerial capacity are sufficient, that organizational conflicts of interest are adequately covered, and that the contract will grant the Government broad and continuing rights to involve itself, if necessary, in technical and managerial decisionmaking concerning performance.\n(b) The contracting officer shall review each management and operating contract, following agency procedures, at appropriate intervals and at least once every 5 years. The review should determine whether meaningful improvement in performance or cost might reasonably be achieved. Any extension or renewal of an operating and management contract must be authorized at a level within the agency no lower than the level at which the original contract was authorized in accordance with 17.602 (a).\n(c) Replacement of an incumbent contractor is usually based largely upon expectation of meaningful improvement in performance or cost. Therefore, when reviewing contractor performance, contracting officers should consider  \n(1) The incumbent contractor  s overall performance, including, specifically, technical, administrative, and cost performance;\n(2) The potential impact of a change in contractors on program needs, including safety, national defense, and mobilization considerations; and\n(3) Whether it is likely that qualified offerors will compete for the contract.\n*    *    *    *    *    *");
register_book(&s, "|17|7|", "Interagency Acquisitions: Acquisitions", "Subpart 17.7  Interagency Acquisitions: Acquisitions by Nondefense Agencies on Behalf of the Department of Defense\n17.700 Scope of subpart.\n(a) Compliance with this subpart is in addition to the policies and procedures for interagency acquisitions set forth in Subpart 17.5 . This subpart prescribes policies and procedures specific to acquisitions of supplies and services by nondefense agencies on behalf of the Department of Defense (DoD).\n(b) This subpart implements Pub. L. 110-181, section 801, as amended (10 USC 2304 Note).\n17.701 Definitions.\nAs used in this subpart  \nDepartment of Defense (DoD) acquisition official  means  \n(1) A DoD contracting officer; or\n(2) Any other DoD official authorized to approve a   	direct acquisition or an assisted acquisition on behalf of DoD.\nNondefense agency  means any department or agency of 	the Federal Government other than the Department of 	Defense. \nNondefense agency that is an element of the intelligence community  means the agencies identified in 50 U.S.C. 401a(4) which include the  \n(1) Office of the Director of National Intelligence; \n(2) Central Intelligence Agency;\n(3) Intelligence elements of the Federal Bureau of Investigation, Department of Energy, and Drug Enforcement Agency;\n(4) Bureau of Intelligence and Research of the Department of State; \n(5) Office of Intelligence and Analysis of the Department of the Treasury;\n(6) The Office of Intelligence and Analysis of the Department of Homeland Security and the Office of Intelligence of the Coast Guard; and\n(7) Such other elements of any department or agency as have been designated by the President, or designated jointly by the Director of National Intelligence and the head of the department or agency concerned, as an element of the intelligence community.\n17.702 Applicability.\nThis subpart applies to all acquisitions made by nondefense agencies on behalf of DoD. It does not apply to contracts entered into by a nondefense agency that is an element of the intelligence community for the performance of a joint program conducted to meet the needs of DoD and the nondefense agency.\n17.703 Policy. \n(a) A DoD acquisition official may request a nondefense agency to conduct an acquisition on behalf of DoD in excess of the simplified acquisition threshold only if the head of the nondefense agency conducting the acquisition on DoD's behalf has certified that the agency will comply with applicable procurement requirements for that fiscal year except when waived in accordance with paragraph (e) of this section. \n(b) A nondefense agency is compliant with applicable procurement requirements if the procurement policies, procedures, and internal controls of the nondefense agency applicable to the procurement of supplies and services on behalf of DoD, and the manner in which they are administered, are adequate to ensure the compliance of the nondefense department or agency with  \n(1) The Federal Acquisition Regulation and other laws and regulations that apply to procurements of supplies and services by Federal agencies; and\n(2) Laws and regulations that apply to procurements of supplies and services made by DoD through other Federal agencies, including DoD financial management regulations, the Defense Federal Acquisition Regulation Supplement (DFARS), DoD class deviations, and the DFARS Procedures, Guidance, and Information (PGI). (The DFARS, DoD class deviations, and PGI are accessible at: http://www.acq.osd.mil/dpap/dars ).\n(c) Within 30 days of the beginning of each fiscal year, submit nondefense agency certifications of compliance to the Director, Defense Procurement and Acquisition Policy, Department of Defense, 3060 Defense Pentagon, Washington D.C. 20301-3060.\n(d) The DoD acquisition official, as defined at 17.701, shall provide to the servicing nondefense agency contracting officer any DoD-unique terms, conditions, other related statutes, regulations, directives, and other applicable requirements for incorporation into the order or contract. In the event there are no DoD-unique requirements beyond the FAR, the DoD acquisition official shall so inform the servicing nondefense agency contracting officer in writing. Nondefense agency contracting officers are responsible for ensuring support provided in response to DoD  s request complies with paragraph (b) of this section.\n(e)  Waiver  . The limitation in paragraph (a) of this section shall not apply to the acquisition of supplies and services on behalf of DoD by a nondefense agency during any fiscal year for which the Under Secretary of Defense for Acquisition, Technology, and Logistics has determined in writing that it is necessary in the interest of DoD to acquire supplies and services through the nondefense agency during the fiscal year. The written determination shall identify the acquisition categories to which the waiver applies.\n(f) Nondefense agency certifications, waivers, and additional information are available at http://www.acq.osd.mil/dpap/cpic/cp/interagency_acquisition.html .");
register_book(&s, "|18|2|", "Emergency Acquisition Flexibilities", "Subpart 18.2  Emergency Acquisition Flexibilities\n18.201 Contingency operation.\n(a) Contingency operation is defined in 2.101 .\n(b) Micro-purchase threshold . The threshold increases when the head of the agency determines the supplies or services are to be used to support a contingency operation. (See 2.101 and 13.201 (g).)\n(c) Simplified acquisition threshold . The threshold increases when the head of the agency determines the supplies or services are to be used to support a contingency operation. (See 2.101 .)\n(d) SF 44 , Purchase Order-Invoice-Voucher . The normal threshold for the use of the SF 44 is at or below the micro-purchase threshold. Agencies may, however, establish higher dollar limitations for purchases made to support a contingency operation. (See 13.306 .)\n(e) Test program for certain commercial items . The threshold limits authorized for use of the test program may be increased for acquisitions to support a contingency operation. (See 13.500 (e).)\n18.202 Defense or recovery from certain attacks.\n(a) Micro-purchase threshold . The threshold increases when the head of the agency determines the supplies or services are to be used to facilitate defense against or recovery from nuclear, biological, chemical, or radiological attack. (See 2.101 .)\n(b) Simplified acquisition threshold . The threshold increases when the head of the agency determines the supplies or services are to be used to facilitate defense against or recovery from nuclear, biological, chemical, or radiological attack. (See 2.101 .)\n(c) Commercial items to facilitate defense and recovery . Contracting officers may treat any acquisition of supplies or services as an acquisition of commercial items if the head of the agency determines the acquisition is to be used to facilitate the defense against or recovery from nuclear, biological, chemical, or radiological attack. (See 12.102 (f)(1) and 13.500 (e).)\n(d) Test program for certain commercial items . The threshold limits authorized for use of the test program may be increased when it is determined the acquisition is to facilitate defense against or recovery from nuclear, biological, chemical, or radiological attack. (See 13.500 (e).)\n18.203 Emergency declaration or major disaster declaration.\n(a) Disaster or emergency assistance activities . Preference will be given to local organizations, firms, and individuals when contracting for major disaster or emergency assistance activities when the President has made a declaration under the Robert T. Stafford Disaster Relief and Emergency Assistance Act. Preference may take the form of local area set-asides or an evaluation preference. (See 6.208 and Subpart 26.2 .)\n(b) Ocean transportation by U.S. flag vessels . The provisions of the Cargo Preference Act of 1954 may be waived in emergency situations. (See 47.502 (c).)\n18.204 Resources.\n(a) National Response Framework . The National Response Framework (NRF) is a guide to how the Nation conducts all-hazards response. This key document establishes a comprehensive, national, all-hazards approach to domestic incident response. The Framework identifies the key response principles, roles and structures that organize national response. It describes how communities, States, the Federal Government, the private-sector, and nongovernmental partners apply these principles for a coordinated, effective national response. It also describes special circumstances where the Federal Government exercises a larger role, including incidents where Federal interests are involved and catastrophic incidents where a State would require significant support. The NRF is available at http://www.fema.gov/emergency/nrf/ .\n(b) OFPP Guidelines . The Office of Federal Procurement Policy (OFPP)  Emergency Acquisitions Guide  is available at http://www.whitehouse.gov/sites/default/files/omb/assets/procurement_guides/emergency_acquisitions_guide.pd f\n*    *    *    *    *    *");
register_book(&s, "|19|2|", "Policies", "Subpart 19.2  Policies\n19.201 General policy.\n(a) It is the policy of the Government to provide maximum practicable opportunities in its acquisitions to small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business, and women-owned small business concerns. Such concerns must also have the maximum practicable opportunity to participate as subcontractors in the contracts awarded by any executive agency, consistent with efficient contract performance. The Small Business Administration (SBA) counsels and assists small business concerns and assists contracting personnel to ensure that a fair proportion of contracts for supplies and services is placed with small business.\n(b) The Department of Commerce will determine on an annual basis, by North American Industry Classification System (NAICS) Industry Subsector, and region, if any, the authorized small disadvantaged business (SDB) procurement mechanisms and applicable factors (percentages). The Department of Commerce determination shall only affect solicitations that are issued on or after the effective date of the determination. The effective date of the Department of Commerce determination shall be no less than 60 days after its publication date. The Department of Commerce determination shall not affect ongoing acquisitions. The SDB procurement mechanisms are a price evaluation adjustment for SDB concerns (see Subpart 19.11 ), an evaluation factor or subfactor for participation of SDB concerns (see 19.1202 ), and monetary subcontracting incentive clauses for SDB concerns (see 19.1203 ). The Department of Commerce determination shall also include the applicable factors, by NAICS Industry Subsector, to be used in the price evaluation adjustment for SDB concerns (see 19.1104 ). The General Services Administration shall post the Department of Commerce determination at https://www.acquisition.gov/References/sdbadjustments.htm . The authorized procurement mechanisms shall be applied consistently with the policies and procedures in this subpart. The agencies shall apply the procurement mechanisms determined by the Department of Commerce. The Department of Commerce, in making its determination, is not limited to the SDB procurement mechanisms identified in this section where the Department of Commerce has found substantial and persuasive evidence of  \n(1) A persistent and significant underutilization of minority firms in a particular industry, attributable to past or present discrimination; and\n(2) A demonstrated incapacity to alleviate the problem by using those mechanisms.\n(c) Heads of contracting activities are responsible for effectively implementing the small business programs within their activities, including achieving program goals. They are to ensure that contracting and technical personnel maintain knowledge of small business program requirements and take all reasonable action to increase participation in their activities  contracting processes by these businesses.\n(d) The Small Business Act requires each agency with contracting authority to establish an Office of Small and Disadvantaged Business Utilization (see section (k) of the Small Business Act). For the Department of Defense, in accordance with the National Defense Authorization Act for Fiscal Year 2006 (Public Law 109-163), the Office of Small and Disadvantaged Business Utilization has been redesignated as the Office of Small Business Programs. Management of the office shall be the responsibility of an officer or employee of the agency who shall, in carrying out the purposes of the Act  \n(1) Be known as the Director of Small and Disadvantaged Business Utilization, or for the Department of Defense, the Director of Small Business Programs;\n(2) Be appointed by the agency head;\n(3) Be responsible to and report directly to the agency head or the deputy to the agency head;\n(4) Be responsible for the agency carrying out the functions and duties in sections 8, 15, and 31 of the Small Business Act.\n(5) Work with the SBA procurement center representative (or, if a procurement center representative is not assigned, see 19.402 (a)) to  \n(i) Identify proposed solicitations that involve bundling;\n(ii) Facilitate small business participation as contractors including small business contract teams, where appropriate; and\n(iii) Facilitate small business participation as subcontractors and suppliers where participation by small business concerns as contractors is unlikely;\n(6) Assist small business concerns in obtaining payments under their contracts, late payment, interest penalties, or information on contractual payment provisions;\n(7) Have supervisory authority over agency personnel to the extent that their functions and duties relate to sections 8, 15, and 31 of the Small Business Act.\n(8) Assign a small business technical advisor to each contracting activity within the agency to which the SBA has assigned a representative (see 19.402 )  \n(i) Who shall be a full-time employee of the contracting activity, well qualified, technically trained, and familiar with the supplies or services contracted for by the activity; and\n(ii) Whose principal duty is to assist the SBA  s assigned representative in performing functions and duties relating to sections 8, 15, and 31 of the Small Business Act;\n(9) Cooperate and consult on a regular basis with the SBA in carrying out the agency  s functions and duties in sections 8, 15, and 31 of the Small Business Act;\n(10) Make recommendations in accordance with agency procedures as to whether a particular acquisition should be awarded under subpart 19.5 as a small business set-aside, under subpart 19.8 as a Section 8(a) award, under subpart 19.13 as a HUBZone set-aside, under subpart 19.14 as a service-disabled veteran-owned small business set-aside, or under subpart 19.15 as a set-aside for economically disadvantaged women-owned small business (EDWOSB) concerns or women-owned small business (WOSB) concerns eligible under the WOSB Program.\n(11) Conduct annual reviews to assess the  \n(i) Extent to which small businesses are receiving a fair share of Federal procurements, including contract opportunities under the programs administered under the Small Business Act;\n(ii) Adequacy of contract bundling documentation and justifications; and\n(iii) Actions taken to mitigate the effects of necessary and justified contract bundling on small businesses.\n(12) Provide a copy of the assessment made under paragraph (d)(11) of this section to the Agency Head and SBA Administrator.\n(e) Small Business Specialists must be appointed and act in accordance with agency regulations.\n(f)(1) Each agency shall designate, at levels it determines appropriate, personnel responsible for determining whether, in order to achieve the contracting agency  s goal for SDB concerns, the use of the SDB mechanism in Subpart 19.11 has resulted in an undue burden on non-SDB firms in one of the Industry Subsectors and regions identified by Department of Commerce following paragraph (b) of this section, or is otherwise inappropriate. Determinations under this subpart are for the purpose of determining future acquisitions and shall not affect ongoing acquisitions. Requests for a determination, including supporting rationale, may be submitted to the agency designee. If the agency designee makes an affirmative determination that the SDB mechanism has an undue burden or is otherwise inappropriate, the determination shall be forwarded through agency channels to the OFPP, which shall review the determination in consultation with the Department of Commerce and the Small Business Administration. At a minimum, the following information should be included in any submittal:\n(i) A determination of undue burden or other inappropriate effect, including proposed corrective action.\n(ii) The Industry Subsector affected.\n(iii) Supporting information to justify the determination, including, but not limited to, dollars and percentages of contracts awarded by the contracting activity under the affected Industry Subsector for the previous two fiscal years and current fiscal year to date for  \n(A) Total awards;\n(B) Total awards to SDB concerns;\n(C) Awards to SDB concerns awarded contracts under the SDB price evaluation adjustment where the SDB concerns would not otherwise have been the successful offeror;\n(D) Number of successful and unsuccessful SDB offerors; and\n(E) Number of successful and unsuccessful non-SDB offerors.\n(iv) A discussion of the pertinent findings, including any peculiarities related to the industry, regions or demographics.\n(v) A discussion of other efforts the agency has undertaken to ensure equal opportunity for SDBs in contracting with the agency.\n(2) After consultation with OFPP, or if the agency does not receive a response from OFPP within 90 days after notice is provided to OFPP, the contracting agency may limit the use of the SDB mechanism in Subpart 19.11 until the Department of Commerce determines the updated price evaluation adjustment, as required by this section. This limitation shall not apply to solicitations that already have been synopsized.\n19.202 Specific policies.\nIn order to further the policy in 19.201 (a), contracting officers shall comply with the specific policies listed in this section and shall consider recommendations of the agency Director of Small and Disadvantaged Business Utilization, or the Director  s designee, as to whether a particular acquisition should be awarded under subpart 19.5 , 19.8 , 19.13 , 19.14 , or 19.15 . Agencies shall establish procedures including dollar thresholds for review of acquisitions by the Director or the Director  s designee for the purpose of making these recommendations. The contracting officer shall document the contract file whenever the Director  s recommendations are not accepted.\n19.202-1 Encouraging small business participation in acquisitions.\nSmall business concerns shall be afforded an equitable opportunity to compete for all contracts that they can perform to the extent consistent with the Government  s interest. When applicable, the contracting officer shall take the following actions:\n(a) Divide proposed acquisitions of supplies and services (except construction) into reasonably small lots (not less than economic production runs) to permit offers on quantities less than the total requirement.\n(b) Plan acquisitions such that, if practicable, more than one small business concern may perform the work, if the work exceeds the amount for which a surety may be guaranteed by SBA against loss under 15 U.S.C. 694b .\n(c) Ensure that delivery schedules are established on a realistic basis that will encourage small business participation to the extent consistent with the actual requirements of the Government.\n(d) Encourage prime contractors to subcontract with small business concerns (see Subpart 19.7 ).\n(e)(1) Provide a copy of the proposed acquisition package to the SBA procurement center representative (or, if a procurement center representative is not assigned, see 19.402 (a)) at least 30 days prior to the issuance of the solicitation if  \n(i) The proposed acquisition is for supplies or services currently being provided by a small business and the proposed acquisition is of a quantity or estimated dollar value, the magnitude of which makes it unlikely that small businesses can compete for the prime contract;\n(ii) The proposed acquisition is for construction and seeks to package or consolidate discrete construction projects and the magnitude of this consolidation makes it unlikely that small businesses can compete for the prime contract; or\n(iii) The proposed acquisition is for a bundled requirement. (See 10.001 (c)(2)(i) for mandatory 30-day notice requirement to incumbent small business concerns.) The contracting officer shall provide all information relative to the justification of contract bundling, including the acquisition plan or strategy, and if the acquisition involves substantial bundling, the information identified in 7.107 (e). When the acquisition involves substantial bundling, the contracting officer shall also provide the same information to the agency Office of Small and Disadvantaged Business Utilization.\n(2) The contracting officer also must provide a statement explaining why the  \n(i) Proposed acquisition cannot be divided into reasonably small lots (not less than economic production runs) to permit offers on quantities less than the total requirement;\n(ii) Delivery schedules cannot be established on a realistic basis that will encourage small business participation to the extent consistent with the actual requirements of the Government;\n(iii) Proposed acquisition cannot be structured so as to make it likely that small businesses can compete for the prime contract;\n(iv) Consolidated construction project cannot be acquired as separate discrete projects; or\n(v) Bundling is necessary and justified.\n(3) The 30-day notification process shall occur concurrently with other processing steps required prior to the issuance of the solicitation.\n(4) If the contracting officer rejects the SBA representative  s recommendation made in accordance with 19.402 (c)(2), the contracting officer shall document the basis for the rejection and notify the SBA representative in accordance with 19.505 .\n19.202-2 Locating small business sources.\nThe contracting officer must, to the extent practicable, encourage maximum participation by small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business, and women-owned small business concerns in acquisitions by taking the following actions:\n(a) Before issuing solicitations, make every reasonable effort to find additional small business concerns, unless lists are already excessively long and only some of the concerns on the list will be solicited. This effort should include contacting the SBA procurement center representative (or, if a procurement center representative is not assigned, see 19.402 (a)).\n(b) Publicize solicitations and contract awards through the Governmentwide point of entry (see Subparts 5.2 and 5.3 ).\n19.202-3 Equal low bids.\nIn the event of equal low bids (see 14.408-6 ), awards shall be made first to small business concerns which are also labor surplus area concerns, and second to small business concerns which are not also labor surplus area concerns.\n19.202-4 Solicitation.\nThe contracting officer must encourage maximum response to solicitations by small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business, and women-owned small business concerns by taking the following actions:\n(a) Allow the maximum amount of time practicable for the submission of offers.\n(b) Furnish specifications, plans, and drawings with solicitations, or furnish information as to where they may be obtained or examined.\n(c) Provide to any small business concern, upon its request, a copy of bid sets and specifications with respect to any contract to be let, the name and telephone number of an agency contact to answer questions related to such prospective contract and adequate citations to each major Federal law or agency rule with which such business concern must comply in performing such contract other than laws or agency rules with which the small business must comply when doing business with other than the Government.\n19.202-5 Data collection and reporting requirements.\nAgencies must measure the extent of small business participation in their acquisition programs by taking the following actions:\n(a) Require each prospective contractor to represent whether it is a small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business, women-owned small business, EDWOSB concern, or WOSB concern eligible under the WOSB Program (see the provision at 52.219-1 , Small Business Program Representations).\n(b) Accurately measure the extent of participation by small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business, and women-owned small business concerns in Government acquisitions in terms of the total value of contracts placed during each fiscal year, and report data to the SBA at the end of each fiscal year (see Subpart 4.6 ).\n(c) When the contract includes the clause at 52.219-28 , Post Award Small Business Program Rerepresentation, and the conditions in the clause for rerepresenting are met  \n(1) Require a contractor that represented itself as a small business concern prior to award of the contract to rerepresent its size status; and\n(2) Permit a contractor that represented itself as other than a small business concern prior to award to rerepresent its size status.\n19.202-6 Determination of fair market price.\n(a) The fair market price shall be the price achieved in accordance with the reasonable price guidelines in 15.404-1 (b) for  \n(1) Total and partial small business set-asides (see Subpart 19.5 );\n(2) HUBZone set-asides (see Subpart 19.13 );\n(3) Contracts utilizing the price evaluation adjustment for small disadvantaged business concerns (see Subpart 19.11 );\n(4) Contracts utilizing the price evaluation preference for HUBZone small business concerns (see Subpart 19.13 ); \n(5) Service-disabled veteran-owned small business set-asides (see subpart 19.14 );\n(6) Set-asides for EDWOSB concerns and WOSB concerns eligible under the WOSB Program (see subpart 19.15 ).\n(b) For 8(a) contracts, both with respect to meeting the requirement at 19.806 (b) and in order to accurately estimate the current fair market price, contracting officers shall follow the procedures at 19.807 .\n19.203 Relationship among small business programs.\n(a) There is no order of precedence among the 8(a) Program (subpart 19.8 ), HUBZone Program (subpart 19.13 ), Service-Disabled Veteran-Owned Small Business (SDVOSB) Procurement Program (subpart 19.14 ), or the Women-Owned Small Business (WOSB) Program (subpart 19.15 ). \n(b) At or below the simplified acquisition threshold . For acquisitions of supplies or services that have an anticipated dollar value exceeding $3,000 ($15,000 for acquisitions as described in 13.201 (g)(1)), but not exceeding $150,000 ($300,000 for acquisitions described in paragraph (1) of the simplified acquisition threshold definition at 2.101 ), the requirement at 19.502-2 (a) to exclusively reserve acquisitions for small business concerns does not preclude the contracting officer from awarding a contract to a small business under the 8(a) Program, HUBZone Program, SDVOSB Program, or WOSB Program.\n(c) Above the simplified acquisition threshold . For acquisitions of supplies or services that have an anticipated dollar value exceeding the simplified acquisition threshold definition at 2.101 , the contracting officer shall first consider an acquisition for the small business socioeconomic contracting programs ( i.e. , 8(a), HUBZone, SDVOSB, or WOSB programs) before considering a small business set-aside (see 19.502-2 (b)). However, if a requirement has been accepted by the SBA under the 8(a) Program, it must remain in the 8(a) Program unless the SBA agrees to its release in accordance with 13 CFR parts 124, 125, and 126.\n(d) In determining which socioeconomic program to use for an acquisition, the contracting officer should consider, at a minimum  \n(1) Results of market research that was done to determine if there are socioeconomic firms capable of satisfying the agency  s requirement; and\n(2) Agency progress in fulfilling its small business goals.\n(e) Small business set-asides have priority over acquisitions using full and open competition. See requirements for establishing a small business set-aside at subpart 19.5 .");
register_book(&s, "|19|3|", "Determination of Small Business Status", "Subpart 19.3  Determination of Small Business Status for Small Business Programs\n19.301 Representations and rerepresentations.\n19.301-1 Representation by the offeror.\n(a) To be eligible for award as a small business, an offeror must represent in good faith that it is a small business at the time of its written representation. An offeror may represent that it is a small business concern in connection with a specific solicitation if it meets the definition of a small business concern applicable to the solicitation and has not been determined by the Small Business Administration (SBA) to be other than a small business.\n(b) The contracting officer shall accept an offeror  s representation in a specific bid or proposal that it is a small business unless (1) another offeror or interested party challenges the concern  s small business representation or (2) the contracting officer has a reason to question the representation. Challenges of and questions concerning a specific representation shall be referred to the SBA in accordance with 19.302 .\n(c) An offeror  s representation that it is a small business is not binding on the SBA. If an offeror  s small business status is challenged, the SBA will evaluate the status of the concern and make a determination, which will be binding on the contracting officer, as to whether the offeror is a small business. A concern cannot become eligible for a specific award by taking action to meet the definition of a small business concern after the SBA has determined that it is not a small business.\n(d) If the SBA determines that the status of a concern as a small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business, or women-owned small business has been misrepresented in order to obtain a set-aside contract, an 8(a) subcontract, a subcontract that is to be included as part or all of a goal contained in a subcontracting plan, or a prime or subcontract to be awarded as a result, or in furtherance of any other provision of Federal law that specifically references Section 8(d) of the Small Business Act for a definition of program eligibility, the SBA may take action as specified in Sections 16(a) or 16(d) of the Act. If the SBA declines to take action, the agency may initiate the process. The SBA  s regulations on penalties for misrepresentations and false statements are contained in 13 CFR 121.108 for small business, 13 CFR 124.501 for 8(a) small business, 13 CFR 124.1004 for small disadvantaged business, 13 CFR 125.29 for veteran or service-disabled veteran-owned small business, 13 CFR 126.900 for HUBZone small business, and 13 CFR 127.700 for economically disadvantaged women-owned small business concerns and women-owned small business (WOSB) concerns eligible under the WOSB Program.\n19.301-2 Rerepresentation by a contractor that represented itself as a small business concern.\n(a) Definition . As used in this subsection  \nLong-term contract means a contract of more than five years in duration, including options. However, the term does not include contracts that exceed five years in duration because the period of performance has been extended for a cumulative period not to exceed six months under the clause at 52.217-8 , Option to Extend Services, or other appropriate authority.\n(b) A contractor that represented itself as a small business concern before contract award must rerepresent its size status for the North American Industry Classification System (NAICS) code in the contract upon the occurrence of any of the following:\n(1) Within 30 days after execution of a novation agreement or within 30 days after modification of the contract to include the clause at 52.219-28 , Post-Award Small Business Program Rerepresentation, if the novation agreement was executed prior to inclusion of this clause in the contract.\n(2) Within 30 days after a merger or acquisition of the contractor that does not require novation or within 30 days after modification of the contract to include the clause at 52.219-28 , Post-Award Small Business Program Rerepresentation, if the merger or acquisition occurred prior to inclusion of this clause in the contract.\n(3) For long-term contracts  \n(i) Within 60 to 120 days prior to the end of the fifth year of the contract; and\n(ii) Within 60 to 120 days prior to the date specified in the contract for exercising any option thereafter.\n(c) A contractor must rerepresent its size status in accordance with the size standard in effect at the time of its rerepresentation that corresponds to the NAICS code that was initially assigned to the contract.\n(d) After a contractor rerepresents it is other than small in accordance with 52.219-28 , the agency may no longer include the value of options exercised, modifications issued, orders issued, or purchases made under blanket purchase agreements on that contract in its small business prime contracting goal achievements. Agencies should issue a modification to the contract capturing the rerepresentation and report it to FPDS within 30 days after notification of the rerepresentation.\n(e) A change in size status does not change the terms and conditions of the contract.\n19.301-3 Rerepresentation by a contractor that represented itself as other than a small business concern.\nA contractor that represented itself as other than small before contract award may, but is not required to, rerepresent its size status when  \n(a) The conditions in 19.301-2 (b) apply; and\n(b) The contractor qualifies as a small business concern under the applicable size standard in effect at the time of its rerepresentation.\n19.302 Protesting a small business representation or rerepresentation.\n(a) An offeror, the SBA, or another interested party may protest the small business representation of an offeror in a specific offer. However, for competitive 8(a) contracts, the filing of a protest is limited to an offeror, the contracting officer, or the SBA.\n(b) Any time after offers are opened, the contracting officer may question the small business representation of any offeror in a specific offer by filing a contracting officer  s protest (see paragraph (c) of this section).\n(c)(1) Any contracting officer who receives a protest, whether timely or not, or who, as the contracting officer, wishes to protest the small business representation of an offeror, or rerepresentation of a contractor, shall promptly forward the protest to the SBA Government Contracting Area Office for the geographical area where the principal office of the concern in question is located.\n(2) The protest, or confirmation if the protest was initiated orally, shall be in writing and shall contain the basis for the protest with specific, detailed evidence to support the allegation that the offeror is not small. The SBA will dismiss any protest that does not contain specific grounds for the protest.\n(d) In order to affect a specific solicitation, a protest must be timely. SBA  s regulations on timeliness are contained in 13 CFR 121.1004. SBA  s regulations on timeliness related to protests of disadvantaged status are contained in 13 CFR 124, Subpart B.\n(1) To be timely, a protest by any concern or other interested party must be received by the contracting officer (see paragraphs (d)(1)(i) and (ii) of this section) by the close of business of the 5th business day after bid opening (in sealed bid acquisitions) or receipt of the special notification from the contracting officer that identifies the apparently successful offeror (in negotiated acquisitions) (see 15.503 (a)(2)).\n(i) A protest may be made orally if it is confirmed in writing either within the 5-day period or by letter postmarked no later than 1 business day after the oral protest.\n(ii) A protest may be made in writing if it is delivered to the contracting officer by hand, telegram, or letter postmarked within the 5-day period.\n(2) A contracting officer  s protest is always considered timely whether filed before or after award.\n(3) A protest under a Multiple Award Schedule will be timely if received by SBA at any time prior to the expiration of the contract period, including renewals.\n(e) Upon receipt of a protest from or forwarded by the Contracting Office, the SBA will  \n(1) Notify the contracting officer and the protester of the date it was received, and that the size of the concern being challenged is under consideration by the SBA; and\n(2) Furnish to the concern whose representation is being protested a copy of the protest and a blank SBA Form 355, Application for Small Business Determination, by certified mail, return receipt requested.\n(f) Within 3 business days after receiving a copy of the protest and the form, the challenged concern must file with the SBA a completed SBA Form 355 and a statement answering the allegations in the protest, and furnish evidence to support its position. If the concern does not submit the required material within the 3 business days or another period of time granted by the SBA, the SBA may assume that the disclosure would be contrary to the concern  s interests.\n(g)(1) Within 10 business days after receiving a protest, the challenged concern  s response, and other pertinent information, the SBA will determine the size status of the challenged concern and notify the contracting officer, the protester, and the challenged concern of its decision by certified mail, return receipt requested.\n(2) The SBA Government Contracting Area Director, or designee, will determine the small business status of the questioned concern and notify the contracting officer and the concern of the determination. Award may be made on the basis of that determination. This determination is final unless it is appealed in accordance with paragraph (i) of this section, and the contracting officer is notified of the appeal before award. If an award was made before the time the contracting officer received notice of the appeal, the contract shall be presumed to be valid.\n(h)(1) After receiving a protest involving an offeror being considered for award, the contracting officer shall not award the contract until (i) the SBA has made a size determination or (ii) 10 business days have expired since SBA  s receipt of a protest, whichever occurs first; however, award shall not be withheld when the contracting officer determines in writing that an award must be made to protect the public interest.\n(2) After the 10-day period has expired, the contracting officer may, when practical, continue to withhold award until the SBA  s determination is received, unless further delay would be disadvantageous to the Government.\n(3) Whenever an award is made before the receipt of SBA  s size determination, the contracting officer shall notify SBA that the award has been made.\n(4) If a protest is received that challenges the small business status of an offeror not being considered for award, the contracting officer is not required to suspend contract action. The contracting officer shall forward the protest to the SBA (see paragraph (c)(1) of this section) with a notation that the concern is not being considered for award, and shall notify the protester of this action.\n(i) An appeal from an SBA size determination may be filed by any concern or other interested party whose protest of the small business representation of another concern has been denied by an SBA Government Contracting Area Director, any concern or other interested party that has been adversely affected by a Government Contracting Area Director  s decision, or the SBA Associate Administrator for the SBA program involved. The appeal must be filed with the  \nOffice of Hearings and Appeals Small Business Administration Suite 5900, 409 3rd Street, SW Washington, DC 20416\nwithin the time limits and in strict accordance with the procedures contained in Subpart C of 13 CFR 134. It is within the discretion of the SBA Judge whether to accept an appeal from a size determination. If the Judge decides not to consider such an appeal, the Judge will issue an order denying review and specifying the reasons for the decision. The SBA will inform the contracting officer of its ruling on the appeal. The SBA decision, if received before award, will apply to the pending acquisition. SBA rulings received after award shall not apply to that acquisition.\n(j) A protest that is not timely, even though received before award, shall be forwarded to the SBA Government Contracting Area Office (see paragraph (c)(1) of this section), with a notation on it that the protest is not timely. The protester shall be notified that the protest cannot be considered on the instant acquisition but has been referred to SBA for its consideration in any future actions. A protest received by a contracting officer after award of a contract shall be forwarded to the SBA Government Contracting Area Office with a notation that award has been made. The protester shall be notified that the award has been made and that the protest has been forwarded to SBA for its consideration in future actions.\n(k) When a concern is found to be other than small under a protest concerning a size status rerepresentation made in accordance with the clause at 52.219-28 , Post-Award Small Business Program Rerepresentation, a contracting officer may permit contract performance to continue, issue orders, or exercise option(s), because the contract remains a valid contract.\n19.303 Determining North American Industry Classification System (NAICS) codes and size standards.\n(a) The contracting officer shall determine the appropriate NAICS code and related small business size standard and include them in solicitations above the micro-purchase threshold. For information on size standards matched to industry NAICS codes, including the use of new NAICS codes, see also 19.102(a).\n(b) If different products or services are required in the same solicitation, the solicitation shall identify the appropriate small business size standard for each product or service.\n(c) The contracting officer  s determination is final unless appealed as follows:\n(1) An appeal from a contracting officer  s NAICS code designation and the applicable size standard must be served and filed within 10 calendar days after the issuance of the initial solicitation. SBA  s Office of Hearings and Appeals (OHA) will dismiss summarily an untimely NAICS code appeal.\n(2)(i) The appeal petition must be in writing and must be addressed to the  \nOffice of Hearings and Appeals Small Business Administration Suite 5900, 409 3rd Street, SW Washington, DC 20416\n(ii) There is no required format for the appeal; however, the appeal must include  \n(A) The solicitation or contract number and the name, address, and telephone number of the contracting officer;\n(B) A full and specific statement as to why the size determination or NAICS code designation is allegedly erroneous and argument supporting the allegation; and\n(C) The name, address, telephone number, and signature of the appellant or its attorney.\n(3) The appellant must serve the appeal petition upon  \n(i) The SBA official who issued the size determination;\n(ii) The contracting officer who assigned the NAICS code to the acquisition;\n(iii) The business concern whose size status is at issue;\n(iv) All persons who filed protests; and\n(v) SBA  s Office of General Counsel.\n(4) Upon receipt of a NAICS code appeal, OHA will notify the contracting officer by a notice and order of the date OHA received the appeal, the docket number, and Judge assigned to the case. The contracting officer  s response to the appeal, if any, must include argument and evidence (see 13 CFR Part 134), and must be received by OHA within 10 calendar days from the date of the docketing notice and order, unless otherwise specified by the Administrative Judge. Upon receipt of OHA  s docketing notice and order, the contracting officer must immediately send to OHA a copy of the solicitation relating to the NAICS code appeal.\n(5) After close of record, OHA will issue a decision and inform the contracting officer. If OHA  s decision is received by the contracting officer before the date the offers are due, the decision shall be final and the solicitation must be amended to reflect the decision, if appropriate. OHA  s decision received after the due date of the initial offers shall not apply to the pending solicitation but shall apply to future solicitations of the same products or services.\n19.304 Disadvantaged business status.\n(a) To be eligible to receive a benefit as a prime contractor based on its disadvantaged status, a concern, at the time of its offer, must either be certified as a small disadvantaged business (SDB) concern or have a completed SDB application pending at the SBA or a Private Certifier (see 19.001 ).\n(b) The contracting officer may accept an offeror  s representation that it is an SDB concern for general statistical purposes. The provision at 52.219-1 , Small Business Program Representations, or 52.212-3 (c)(4), Offeror Representations and Certifications-Commercial Items, is used to collect SDB data for general statistical purposes.\n(c) The provision at 52.219-22 , Small Disadvantaged Business Status, or 52.212-3 (c)(8), Offeror Representations and Certifications-Commercial Items, is used to obtain SDB status when the prime contractor may receive a benefit based on its disadvantaged status. The mechanisms that may provide benefits on the basis of disadvantaged status as a prime contractor are a price evaluation adjustment for SDB concerns (see Subpart 19.11 ), and an evaluation factor or subfactor for SDB participation (see 19.1202 ).\n(1) If the apparently successful offeror has represented that it is currently certified as an SDB, the contracting officer may confirm that the concern is identified as a small disadvantaged business concern by accessing SBA  s database (PRO-Net) or by contacting the SBA  s Office of Small Disadvantaged Business Certification and Eligibility.\n(2) If the apparently successful offeror has represented that its SDB application is pending at the SBA or a Private Certifier, and its position as the apparently successful offeror is due to the application of the price evaluation adjustment, the contracting officer shall follow the procedure in paragraph (d) of this section.\n(d) Notifications to SBA of potential awards to offerors with pending SDB applications.\n(1) The contracting officer shall notify the  \nSmall Business Administration Assistant Administrator for SDBCE 409 Third Street, SW Washington, DC 20416.\nThe notification shall contain the name of the apparently successful offeror, and the names of any other offerors that have represented that their applications for SDB status are pending at the SBA or a Private Certifier and that could receive the award due to the application of a price evaluation adjustment if the apparently successful offeror is determined not to be an SDB by the SBA.\n(2) The SBA will, within 15 calendar days after receipt of the notification, determine the disadvantaged status of the apparently successful offeror and, as appropriate, any other offerors referred by the contracting officer and will notify the contracting officer.\n(3) If the contracting officer does not receive an SBA determination within 15 calendar days after the SBA  s receipt of the notification, the contracting officer shall presume that the apparently successful offeror, and any other offerors referred by the contracting officer, are not disadvantaged, and shall make award accordingly, unless the contracting officer grants an extension to the 15-day response period. No written determination is required for the contracting officer to make award at any point following the expiration of the 15-day response period.\n(4) When the contracting officer makes a written determination that award must be made to protect the public interest, the contracting officer may proceed to contract award without notifying SBA or before receiving a determination of SDB status from SBA during the 15-day response period. In both cases, the contracting officer shall presume that the apparently successful offeror, or any other offeror referred to the SBA whose SDB application is pending, is not an SDB and shall make award accordingly.\n19.305 Protesting a representation of disadvantaged business status.\n(a) This section applies to protests of a small business concern  s disadvantaged status as a prime contractor. Protests of a small business concern  s disadvantaged status as a subcontractor are processed under 19.703 (a)(2). Protests of a concern  s size as a prime contractor are processed under 19.302 . Protests of a concern  s size as a subcontractor are processed under 19.703 (b). An offeror, the contracting officer, or the SBA may protest the apparently successful offeror  s representation of disadvantaged status if the concern is eligible to receive a benefit based on its disadvantaged status (see Subpart 19.11 and 19.1202 .)\n(b) An offeror, excluding an offeror determined by the contracting officer to be non-responsive or outside the competitive range, or an offeror that SBA has previously found to be ineligible for the requirement at issue, may protest the apparently successful offeror  s representation of disadvantaged status by filing a protest in writing with the contracting officer. SBA regulations concerning protests are contained in 13 CFR 124, Subpart B. The protest  \n(1) Must be filed within the times specified in 19.302 (d)(1); and\n(2) Must contain specific facts or allegations supporting the basis of protest.\n(c) The contracting officer or the SBA may protest in writing a concern  s representation of disadvantaged status at any time following bid opening or notification of intended award.\n(1) If a contracting officer  s protest is based on information provided by a party ineligible to protest directly or ineligible to protest under the timeliness standard, the contracting officer must be persuaded by the evidence presented before adopting the grounds for protest as his or her own.\n(2) The SBA may protest a concern  s representation of disadvantaged status by filing directly with its Assistant Administrator for Small Disadvantaged Business Certification and Eligibility and notifying the contracting officer.\n(d) The contracting officer shall return premature protests to the protestor. A protest is considered to be premature if it is submitted before bid opening or notification of intended award. SBA normally will not consider a postaward protest. SBA may consider a postaward protest in its discretion where it determines that an SDB determination after award is meaningful ( e. g ., where the contracting officer agrees to terminate the contract if the protest is sustained).\n(e) Upon receipt of a protest that is not premature, the contracting officer shall withhold award and forward the protest to  \nSmall Business Administration Assistant Administrator for SDBCE 409 Third Street, SW Washington, DC 20416.\nThe contracting officer shall send to SBA  \n(1) The written protest and any accompanying materials;\n(2) The date the protest was received;\n(3) A copy of the protested concern  s representation as a small disadvantaged business, and the date of such representation; and\n(4) The date of bid opening or date on which notification of the apparently successful offeror was sent to unsuccessful offerors.\n(f) When the contracting officer makes a written determination that award must be made to protect the public interest, award may be made notwithstanding the protest.\n(g) The SBA Assistant Administrator for Small Disadvantaged Business Certification and Eligibility will notify the protestor and the contracting officer of the date the protest was received and whether it will be processed or dismissed for lack of timeliness or specificity. For protests that are not dismissed, the SBA will, within 15 working days after receipt of the protest, determine the disadvantaged status of the challenged offeror and will notify the contracting officer, the challenged offeror, and the protestor. Award may be made on the basis of that determination. The determination is final for purposes of the instant acquisition, unless it is appealed and  \n(1) The contracting officer receives the SBA  s decision on the appeal before award; or\n(2) The contracting officer has agreed to terminate the contract, as appropriate, based on the outcome of the appeal (see 13 CFR 124, Subpart B).\n(h) If the contracting officer does not receive an SBA determination within 15 working days after the SBA  s receipt of the protest, the contracting officer shall presume that the challenged offeror is disadvantaged and may award the contract, unless the SBA requests and the contracting officer grants an extension to the 15-day response period.\n(i) An SBA determination may be appealed by  \n(1) The party whose protest has been denied;\n(2) The concern whose status was protested; or\n(3) The contracting officer.\n(j) The appeal must be filed with the SBA  s Administrator or designee within five working days after receipt of the determination. If the contracting officer receives the SBA  s decision on the appeal before award, the decision shall apply to the instant acquisition. If the decision is received after award, it will not apply to the instant acquisition (but see paragraph (g)(2) of this section).\n19.306 Protesting a firm  s status as a HUBZone small business concern.\n(a) Definition . As used in this section  \nInterested party  has the meaning given in 13 CFR 126.103.\n(b)  HUBZone Small Business Status  .\n(1) For sole source acquisitions, the SBA or the contracting officer may protest the apparently successful offeror  s HUBZone small business concern status.\n(2) For all other acquisitions, an offeror that is an interested party, the contracting officer, or the SBA may protest the apparently successful offeror  s qualified HUBZone small business concern status.\n(c) Protests relating to whether a qualified HUBZone small business concern is a small business for purposes of any Federal program are subject to the procedures of Subpart 19.3 . Protests relating to small business size status for the acquisition and the HUBZone qualifying requirements will be processed concurrently by SBA.\n(d) All protests must be in writing and must state all specific grounds for the protest. Assertions that a protested concern is not a qualified HUBZone small business concern, without setting forth specific facts or allegations, are insufficient. An offeror must submit its protest to the contracting officer. The contracting officer and the SBA must submit protests to SBA  s Associate Administrator for the HUBZone Program (Director/HUB).\n(e)(1) The protest of an offeror that is an interested party must be submitted by  \n(i) For sealed bids:\n(A) The close of business on the fifth business day after bid opening; or\n(B) The close of business on the fifth business day from the date of identification of the apparent successful offeror, if the price evaluation preference was not applied at the time of bid opening.\n(ii) For negotiated acquisitions, the close of business on the fifth business day after notification by the contracting officer of the apparently successful offeror.\n(2) Any protest submitted after these time limits is untimely, unless it is submitted by the SBA or the contracting officer. Any protest received prior to bid opening or notification of intended award, whichever applies, is premature and shall be returned to the protester.\n(f) Except for premature protests, the contracting officer shall forward all protests received, notwithstanding whether the contracting officer believes that the protest is not sufficiently specific, timely, or submitted by an interested party. The contracting officer shall also forward a referral letter with the information required by 13 CFR 126.801(e).\n(g)(1) Protests may be submitted in person or by facsimile, express delivery service, or U.S. mail (postmarked within the applicable time period) to the Director/HUB, U.S. Small Business Administration, 409 3rd Street, SW., Washington, DC 20416, Fax (202) 205-7167.\n(2) The Director/HUB will notify the protester and the contracting officer that the protest was received and indicate whether the protest will be processed or dismissed for lack of timeliness or specificity. A protest will be dismissed if SBA determines the protester is not an interested party.\n(h) SBA will determine the HUBZone status of the protested HUBZone small business concern within 15 business days after receipt of a protest. If SBA does not contact the contracting officer within 15 business days, the contracting officer may award the contract to the apparently successful offeror, unless the contracting officer has granted SBA an extension. The contracting officer may award the contract after receipt of a protest if the contracting officer determines in writing that an award must be made to protect the public interest.\n(i) SBA will notify the contracting officer, the protester, and the protested concern of its determination. The determination is effective immediately and is final unless overturned on appeal by SBA  s Associate Deputy Administrator for Government Contracting and Administrator for Government Contracting and 8(a) Business Development(AA/GC&BD).\n(j) The protested HUBZone small business concern, the protester, or the contracting officer may file appeals of protest determinations with SBA  s AA/GC&BD. The AA/GC&BD must receive the appeal no later than 5 business days after the date of receipt of the protest determination. SBA will dismiss any appeal received after the 5-day period.\n(k) The appeal must be in writing. The appeal must identify the protest determination being appealed and must set forth a full and specific statement as to why the decision is erroneous or what significant fact the Director/HUB failed to consider.\n(l) The party appealing the decision must provide notice of the appeal to the contracting officer and either the protested HUBZone small business concern or the original protester, as appropriate. SBA will not consider additional information or changed circumstances that were not disclosed at the time of the Director/HUB  s decision or that are based on disagreement with the findings and conclusions contained in the determination.\n(m) The AA/GC&BD will make its decision within 5 business days of the receipt of the appeal, if practicable, and will base its decision only on the information and documentation in the protest record as supplemented by the appeal. SBA will provide a copy of the decision to the contracting officer, the protester, and the protested HUBZone small business concern. The SBA decision, if received before award, will apply to the pending acquisition. SBA rulings received after award will not apply to that acquisition. The AA/GC&BD  s decision is the final decision.\n19.307 Protesting a firm   s status as a service-disabled veteran-owned small business concern.\n(a) For sole source acquisitions, the SBA or the contracting officer may protest the apparently successful offeror  s service-disabled veteran-owned small business status. For service-disabled veteran-owned small business set-asides, any interested party may protest the apparently successful offeror  s service-disabled veteran-owned small business concern status.\n(b) Protests relating to whether a service-disabled veteran-owned small business concern is a small business for purposes of any Federal program are subject to the procedures of Subpart 19.3 . Protests relating to small business size status for the acquisition and the service-disabled veteran-owned small business status requirements will be processed concurrently by SBA.\n(c) All protests must be in writing and must state all specific grounds for the protest. Assertions that a protested concern is not a service-disabled veteran-owned small business concern, without setting forth specific facts or allegations, are insufficient. An offeror must submit its protest to the contracting officer. The contracting officer and the SBA must submit protests to SBA  s Associate Administrator for Government Contracting. The SBA regulations are found at 13 CFR 125.24 through 125.28.\n(d) An offeror  s protest must be received by close of business on the fifth business day after bid opening (in sealed bid acquisitions) or by close of business on the fifth business day after notification by the contracting officer of the apparently successful offeror (in negotiated acquisitions). Any protest received after these time limits is untimely. Any protest received prior to bid opening or notification of intended award, whichever applies, is premature and shall be returned to the protester.\n(e) Except for premature protests, the contracting officer must forward to SBA by mail or facsimile transmission (202-205-6390) any protest received, notwithstanding whether the contracting officer believes that the protest is insufficiently specific or untimely. The protest must be accompanied by a referral letter, with the notation on the envelope or facsimile cover sheet:  Attn: Service-Disabled Veteran Status Protest,  and be sent to Associate Administrator for Government Contracting AA/GC, U.S. Small Business Administration, 409 3rd Street, SW, Washington, DC 20416.\n(f) The referral letter must include information pertaining to the solicitation that may be necessary for SBA to determine timeliness and standing, including the solicitation number; the name, address, telephone number and facsimile number of the contracting officer; whether the contract was sole-source or set-aside; whether the protestor submitted an offer; whether the protested concern was the apparent successful offeror; when the protested concern submitted its offer ( i.e ., made the self-representation that it was a service-disabled veteran-owned small business concern); whether the procurement was conducted using sealed bid or negotiated procedures; the bid opening date, if applicable; when the protest was submitted; when the protester received notification about the apparent successful offeror, if applicable; and whether a contract has been awarded.\n(g) The Associate Administrator for Government Contracting will notify the protester and the contracting officer of the date the protest was received and whether the protest will be processed or dismissed for lack of timeliness or specificity.\n(h) All questions about service-disabled veteran-owned small business size or status must be referred to the SBA for resolution. When making its determinations of veteran, service-disabled veteran, or service-disabled veteran with a permanent and severe disability status, the SBA will rely upon determinations made by the Department of Veteran  s Affairs, Department of Defense determinations, or such determinations identified by documents provided by the U.S. National Archives and Records Administration. SBA will determine the service-disabled veteran-owned small business status of the protested concern within 15 business days after receipt of a protest. If SBA does not contact the contracting officer within 15 business days, the contracting officer may award the contract to the apparently successful offeror, unless the contracting officer has granted SBA an extension. The contracting officer may award the contract after receipt of a protest if the contracting officer determines in writing that an award must be made to protect the public interest.\n(i) SBA will notify the contracting officer, the protester, and the protested concern of its determination. The determination is effective immediately and is final unless overturned on appeal by SBA  s Office of Hearings and Appeals (OHA) pursuant to 13 CFR part 134.\n19.308 Protesting a firm  s status as an economically disadvantaged women-owned small business (EDWOSB) concern or women-owned small business (WOSB) concern eligible under the WOSB Program.\n(a) An offeror, the contracting officer, or the SBA may protest the apparent successful offeror  s status as an EDWOSB concern or WOSB concern eligible under the WOSB Program.\n(b) Protests relating to small business size status are subject to the procedures of subpart 19.3 . An interested party (see 19.308 (a)) seeking to protest both the size and status of an apparent successful offeror shall file two separate protests.\n(c) All protests shall be in writing and must state all specific grounds for the protest.\n(1) SBA will consider protests challenging the status of a concern if  \n(i) The protest presents evidence that the concern is not at least 51 percent owned and controlled by one or more women who are United States citizens; or\n(ii) The protest presents evidence that the concern is not at least 51 percent owned and controlled by one or more economically disadvantaged women, when it is in connection with an EDWOSB contract.\n(2) SBA shall consider protests by a contracting officer when the apparent successful offeror has failed to provide all of the required documents, as set forth in FAR 19.1503 (c).\n(d) Protest by an offeror.\n(1) An offeror shall submit its protest to the contracting officer  \n(i) To be received by the close of business by the  fifth business day after bid opening (in sealed bid acquisitions); or\n(ii) To be received by the close of business by the fifth business day after notification by the contracting officer of the apparent successful offeror (in negotiated acquisitions).\n(2) Any protest received after the designated time limit is untimely, unless it is from the contracting officer or SBA.\n(e)(1) The contracting officer shall forward all protests to SBA. The protests are to be submitted to SBA  s Director for Government Contracting, U.S. Small Business Administration, 409 Third Street, SW, Washington, DC 20416 or by fax to (202) 205-6390, Attn: Women-owned Small Business Status Protest. SBA  s protest regulations are found in subpart F  Protests  at 13 CFR 127.600 through 127.605.\n(2) The protest shall include a referral letter written by the contracting officer with information pertaining to the solicitation. The referral letter must include the following information to allow SBA to determine timeliness and standing of the protest:\n(i) The solicitation number; the name, address, telephone number and facsimile number of the contracting officer, the successful offeror and the protester.\n(ii) Whether the protestor submitted an offer.\n(iii) Whether the protested concern was the apparent successful offeror.\n(iv) When the protested concern submitted its offer.\n(v) Whether the acquisition was conducted using sealed bid or negotiated procedures.\n(vi) The bid opening date, if applicable.\n(vii) The date the contracting officer received the protest.\n(viii) The date the protestor received notification about the apparent successful offeror, if applicable; and\n(ix) Whether a contract has been awarded.\n(f) SBA will notify the protester and the contracting officer of the date the protest was received.\n(g) Before SBA decision . The contracting officer may award the contract after receipt of the protest but before SBA issues its decision if the contracting officer determines in writing that an award must be made to prevent significant harm to the public interest.\n(1) SBA will determine the merits of the status protest within 15 business days after receipt of a protest, or within any extension of that time that the contracting officer may grant SBA.\n(2) If SBA does not issue its determination within 15 business days, the contracting officer shall contact SBA to obtain the status of its decision.\n(3) After contacting SBA, if the contracting officer determines in writing that there is an immediate need and it is in the public  interest to proceed with award, the contracting officer may award the contract. This determination shall be provided to the SBA Director for Government Contracting and a copy shall be included in the contract file.\n(h) After SBA decision . SBA will notify the contracting officer, the protester, and the protested concern of its determination. The determination is effective immediately and is final unless overturned on appeal by SBA  s Office of Hearings and Appeals (OHA) pursuant to 13 CFR part 134.\n(1) If SBA has denied or dismissed the protest, the contracting officer may award the contract to the protested concern. If OHA subsequently overturns the SBA Director for Government Contracting  s determination or dismissal, the contracting officer may apply the OHA decision to the procurement in question.\n(2) If SBA has sustained the protest and determined that the concern is not eligible under the WOSB Program, and no OHA appeal has been filed, then  \n(i) The concern must remove its designation in the System for Award Management (SAM) as an EDWOSB or WOSB concern eligible under the WOSB Program, and shall not submit an offer as an EDWOSB concern or WOSB concern eligible under the WOSB Program, until SBA issues a decision that the ineligibility is resolved.\n(ii) The contracting officer shall not award the contract to the protested concern.\n(iii) The contracting officer shall terminate the award, shall not exercise any options or award further task or delivery orders, if the contracting officer receives the determination after contract award.\n(iv) The contracting officer may allow contract performance to continue when a written determination is made in accordance with 19.308 (g) and (h), but shall not exercise any options or award further task or delivery orders.\n(v) The contracting officer shall update the FPDS to reflect the final SBA decision.\n(3) If SBA has sustained the protest and determined that the concern is not eligible under the WOSB Program, and a timely OHA appeal has been filed, then  \n(i) The contracting officer must consider whether performance can be suspended until an OHA decision is rendered.\n(ii) The contracting officer shall either terminate the contract, not exercise the next option, or not award further task or delivery orders, if OHA affirms the SBA Director for Government Contracting  s determination finding the protested concern is ineligible. The contracting officer may allow contract performance to continue when a written determination is made in accordance with 19.308 (g) and (h), but shall not exercise any options or award further task or delivery orders; and\n(iii) The contracting officer shall update the FPDS to reflect OHA  s decision.\n(iv) The concern must remove its designation in SAM as an EDWOSB or WOSB concern eligible under the WOSB Program, and shall not submit an offer as an EDWOSB concern or WOSB concern eligible under the WOSB Program, until SBA issues a decision that the ineligibility is resolved or OHA finds the concern is eligible on appeal.\n19.309 Solicitation provisions and contract clauses.\n(a)(1) Insert the provision at 52.219-1 , Small Business Program Representations, in solicitations exceeding the micro-purchase threshold when the contract will be performed in the United States or its outlying areas.\n(2) Use the provision with its Alternate I in solicitations issued by DoD, NASA, or the Coast Guard.\n(b) Insert the provision at 52.219-22 , Small Disadvantaged Business Status, in solicitations that include the clause at 52.219-23 , Notice of Price Evaluation Adjustment for Small Disadvantaged Business Concerns, or 52.219-25 , Small Disadvantaged Business Participation Program  Disadvantaged Status and Reporting. Use the provision with its Alternate I in solicitations for acquisitions for which a price evaluation adjustment for small disadvantaged business concerns is authorized on a regional basis.\n(c) When contracting by sealed bidding, insert the provision at 52.219-2 , Equal Low Bids, in solicitations when the contract will be performed in the United States or its outlying areas.\n(d) Insert the clause at 52.219-28 , Post-Award Small Business Program Rerepresentation, in solicitations and contracts exceeding the micro-purchase threshold when the contract will be performed in the United States or its outlying areas.");
register_book(&s, "|19|4|", "Cooperation with the Small Business Adm", "Subpart 19.4  Cooperation with the Small Business Administration\n19.401 General.\n(a) The Small Business Act is the authority under which the Small Business Administration (SBA) and agencies consult and cooperate with each other in formulating policies to ensure that small business interests will be recognized and protected.\n(b) The Director of Small and Disadvantaged Business Utilization serves as the agency focal point for interfacing with SBA.\n19.402 Small Business Administration procurement center representatives.\n(a)(1) The SBA may assign one or more procurement center representatives to any contracting activity or contract administration office to carry out SBA policies and programs. Assigned SBA procurement center representatives are required to comply with the contracting agency  s directives governing the conduct of contracting personnel and the release of contract information. The SBA must obtain for its procurement center representatives security clearances required by the contracting agency.\n(2) If a SBA procurement center representative is not assigned to the procuring activity or contract administration office, contact the SBA Office of Government Contracting Area Office serving the area in which the procuring activity is located for assistance in carrying out SBA policies and programs. See http://www.sba.gov/content/procurement-center-representatives for the location of the SBA office servicing the activity.\n(b) Upon their request and subject to applicable acquisition and security regulations, contracting officers shall give SBA procurement center representatives (or, if a procurement center representative is not assigned, see paragraph (a) of this section) access to all reasonably obtainable contract information that is directly pertinent to their official duties.\n(c) The duties assigned by SBA to its procurement center representatives include the following:\n(1) Reviewing proposed acquisitions to recommend  \n(i) The setting aside of selected acquisitions not unilaterally set aside by the contracting officer;\n(ii) New qualified small business sources, including veteran-owned small, service-disabled veteran-owned small, HUBZone small, small disadvantaged, economically disadvantaged women-owned small, and women-owned small eligible under the Woman-Owned Small Business Program; and\n(iii) Breakout of components for competitive acquisitions.\n(2) Reviewing proposed acquisition packages provided in accordance with 19.202-1 (e). If the SBA procurement center representative (or, if a procurement center representative is not assigned, see paragraph (a) of this section) believes that the acquisition, as proposed, makes it unlikely that small businesses can compete for the prime contract, the representative shall recommend any alternate contracting method that the representative reasonably believes will increase small business prime contracting opportunities. The recommendation shall be made to the contracting officer within 15 days after receipt of the package.\n(3) Recommending concerns for inclusion on a list of concerns to be solicited in a specific acquisition.\n(4) Appealing to the chief of the contracting office any contracting officer  s determination not to solicit a concern recommended by the SBA for a particular acquisition, when not doing so results in no small business being solicited.\n(5) Conducting periodic reviews of the contracting activity to which assigned to ascertain whether it is complying with the small business policies in this regulation.\n(6) Sponsoring and participating in conferences and training designed to increase small business participation in the contracting activities of the office.\n19.403 Small Business Administration breakout procurement center representative.\n(a) The SBA is required by section 403 of Pub. L. 98-577 to assign a breakout procurement center representative to each major procurement center. A major procurement center means a procurement center that, in the opinion of the administrator, purchases substantial dollar amounts of other than commercial items, and which has the potential to incur significant savings as a result of the placement of a breakout procurement representative. The SBA breakout procurement center representative is an advocate for (1) the appropriate use of full and open competition, and (2) the breakout of items, when appropriate and while maintaining the integrity of the system in which such items are used. The SBA breakout procurement center representative is in addition to the SBA procurement center representative (see 19.402 ). When an SBA breakout procurement center representative is assigned, the SBA is required to assign at least two collocated small business technical advisors. Assigned SBA breakout procurement center representatives and technical advisors are required to comply with the contracting agency  s directives governing the conduct of contracting personnel and the release of contract information. The SBA must obtain for its breakout procurement center representatives and technical advisors security clearances required by the contracting agency.\n(b) Contracting officers shall comply with 19.402 (b) in their relationships with SBA breakout procurement center representatives and SBA small business technical advisors.\n(c) The SBA breakout procurement center representative is authorized to  \n(1) Attend any provisioning conference or similar evaluation session during which determinations are made as to whether requirements are to be acquired using other than full and open competition and make recommendations with respect to such requirements to the members of such conference or session;\n(2) Review, at any time, restrictions on competition previously imposed on items through acquisition method coding or similar procedures and recommend to personnel of the appropriate activity the prompt reevaluation of such limitations;\n(3) Review restrictions on competition arising out of restrictions on the rights of the United States in technical data and, when appropriate, recommend that personnel of the appropriate activity initiate a review of the validity of such an asserted restriction;\n(4) Obtain from any governmental source, and make available to personnel of the appropriate center, technical data necessary for the preparation of a competitive solicitation package for any item of supply or service previously acquired noncompetitively due to the unavailability of such technical data;\n(5) Have access to procurement records and other data of the procurement center commensurate with the level of such representative  s approved security clearance classification;\n(6) Receive unsolicited engineering proposals and, when appropriate  \n(i) Conduct a value analysis of such proposal to determine whether it, if adopted, will result in lower costs to the United States without substantially impeding legitimate acquisition objectives and forward to personnel of the appropriate center recommendations with respect to such proposal; or\n(ii) Forward such proposals without analysis to personnel of the center responsible for reviewing them who shall furnish the breakout procurement center representative with information regarding the proposal  s disposition;\n(7) Review the systems that account for the acquisition and management of technical data within the procurement center to ensure that such systems provide the maximum availability and access to data needed for the preparation of offers to sell to the United States those supplies to which such data pertain which potential offerors are entitled to receive;\n(8) Appeal the failure by the procurement center to act favorably on any recommendation made pursuant to paragraphs (c)(1) through (7) of this section. Such appeal must be in writing and shall be filed and processed in accordance with the appeal procedures set out at 19.505 ;\n(9) Conduct familiarization sessions for contracting officers and other appropriate personnel of the procurement center to which assigned. Such sessions shall acquaint the participants with the duties and objectives of the representative and shall instruct them in the methods designed to further the breakout of items for procurement through full and open competition; and\n(10) Prepare and personally deliver an annual briefing and report to the head of the procurement center to which assigned. Such briefing and report shall detail the past and planned activities of the representative and shall contain recommendations for improvement in the operation of the center as may be appropriate. The head of such center shall personally receive the briefing and report and shall, within 60 calendar days after receipt, respond, in writing, to each recommendation made by the representative.\n(d) The duties of the SBA small business technical advisors are to assist the SBA breakout procurement center representative in carrying out the activities described in paragraphs (c)(1) through (7) of this section to assist the SBA procurement center representatives (see FAR 19.402 ).");
register_book(&s, "|19|5|", "Set-Asides for Small Business", "Subpart 19.5  Set-Asides for Small Business\n19.501 General.\n(a) The purpose of small business set-asides is to award certain acquisitions exclusively to small business concerns. A  set-aside for small business  is the reserving of an acquisition exclusively for participation by small business concerns. A small business set-aside may be open to all small businesses. A small business set-aside of a single acquisition or a class of acquisitions may be total or partial.\n(b) The determination to make a small business set-aside may be unilateral or joint. A unilateral determination is one that is made by the contracting officer. A joint determination is one that is recommended by the Small Business Administration (SBA) procurement center representative (or, if a procurement center representative is not assigned, see 19.402 (a)) and concurred in by the contracting officer.\n(c) The contracting officer shall review acquisitions to determine if they can be set aside for small business, giving consideration to the recommendations of agency personnel having cognizance of the agency  s small business programs. The contracting officer shall perform market research and document why a small business set-aside is inappropriate when an acquisition is not set aside for small business, unless an award is anticipated to a small business under the 8(a), HUBZone, SDVOSB, or WOSB Programs. If the acquisition is set aside for small business based on this review, it is a unilateral set-aside by the contracting officer. Agencies may establish threshold levels for this review depending upon their needs.\n(d) At the request of an SBA procurement center representative, (or, if a procurement center representative is not assigned, see 19.402 (a)) the contracting officer shall make available for review at the contracting office (to the extent of the SBA representative  s security clearance) all proposed acquisitions in excess of the micro-purchase threshold that have not been unilaterally set aside for small business.\n(e) To the extent practicable, unilateral determinations initiated by a contracting officer shall be used as the basis for small business set-asides rather than joint determinations by an SBA procurement center representative and a contracting officer.\n(f) All solicitations involving set-asides must specify the applicable small business size standard and NAICS code (see 19.303 ).\n(g) Except as authorized by law, a contract may not be awarded as a result of a small business set-aside if the cost to the awarding agency exceeds the fair market price.\n19.502 Setting aside acquisitions.\n19.502-1 Requirements for setting aside acquisitions.\n(a) The contracting officer shall set aside an individual acquisition or class of acquisitions for competition among small businesses when  \n(1) It is determined to be in the interest of maintaining or mobilizing the Nation  s full productive capacity, war or national defense programs; or\n(2) Assuring that a fair proportion of Government contracts in each industry category is placed with small business concerns; and the circumstances described in 19.502-2 or 19.502-3 (a) exist.\n(b) This requirement does not apply to purchases of $3,000 or less ($15,000 or less for acquisitions as described in 13.201 (g)(1)), or purchases from required sources of supply under Part 8 ( e.g., Committee for Purchase From People Who are Blind or Severely Disabled, and Federal Supply Schedule contracts).\n19.502-2 Total small business set-asides.\n(a) Before setting aside an acquisition under this paragraph, refer to 19.203 (b). Each acquisition of supplies or services that has an anticipated dollar value exceeding $3,000 ($15,000 for acquisitions as described in 13.201 (g)(1)), but not over $150,000 ($300,000 for acquisitions described in paragraph (1) of the Simplified Acquisition Threshold definition at 2.101 ), is automatically reserved exclusively for small business concerns and shall be set aside for small business unless the contracting officer determines there is not a reasonable expectation of obtaining offers from two or more responsible small business concerns that are competitive in terms of market prices, quality, and delivery. If the contracting officer does not proceed with the small business set-aside and purchases on an unrestricted basis, the contracting officer shall include in the contract file the reason for this unrestricted purchase. If the contracting officer receives only one acceptable offer from a responsible small business concern in response to a set-aside, the contracting officer should make an award to that firm. If the contracting officer receives no acceptable offers from responsible small business concerns, the set-aside shall be withdrawn and the requirement, if still valid, shall be resolicited on an unrestricted basis. The small business reservation does not preclude the award of a contract as described in 19.203 .\n(b) Before setting aside an acquisition under this paragraph, refer to 19.203 (c). The contracting officer shall set aside any acquisition over $150,000 for small business participation when there is a reasonable expectation that:\n(1) Offers will be obtained from at least two responsible small business concerns offering the products of different small business concerns (see paragraph (c) of this section); and\n(2) Award will be made at fair market prices. Total small business set-asides shall not be made unless such a reasonable expectation exists (see 19.502-3 as to partial set-asides). Although past acquisition history of an item or similar items is always important, it is not the only factor to be considered in determining whether a reasonable expectation exists. In making R&D small business set-asides, there must also be a reasonable expectation of obtaining from small businesses the best scientific and technological sources consistent with the demands of the proposed acquisition for the best mix of cost, performances, and schedules.\n(c) For small business set-asides other than for construction or services, any concern proposing to furnish a product that it did not itself manufacture must furnish the product of a small business manufacturer unless the SBA has granted either a waiver or exception to the nonmanufacturer rule (see 19.102 (f)). In industries where the SBA finds that there are no small business manufacturers, it may issue a waiver to the nonmanufacturer rule (see 19.102 (f)(4) and (5)). In addition, SBA has excepted procurements processed under simplified acquisition procedures (see Part 13 ), where the anticipated cost of the procurement will not exceed $25,000, from the nonmanufacturer rule. Waivers permit small businesses to provide any firm  s product. The exception permits small businesses to provide any domestic firm  s product. In both of these cases, the contracting officer  s determination in paragraph (b)(1) of this subsection or the decision not to set aside a procurement reserved for small business under paragraph (a) of this subsection will be based on the expectation of receiving offers from at least two responsible small businesses, including nonmanufacturers, offering the products of different concerns.\n19.502-3 Partial set-asides.\n(a) The contracting officer shall set aside a portion of an acquisition, except for construction, for exclusive small business participation when  \n(1) A total set-aside is not appropriate (see 19.502-2 );\n(2) The requirement is severable into two or more economic production runs or reasonable lots;\n(3) One or more small business concerns are expected to have the technical competence and productive capacity to satisfy the set-aside portion of the requirement at a fair market price;\n(4) The acquisition is not subject to simplified acquisition procedures; and\n(5) A partial set-aside shall not be made if there is a reasonable expectation that only two concerns (one large and one small) with capability will respond with offers unless authorized by the head of a contracting activity on a case-by-case basis. Similarly, a class of acquisitions, not including construction, may be partially set aside. Under certain specified conditions, partial set-asides may be used in conjunction with multiyear contracting procedures.\n(b) When the contracting officer determines that a portion of an acquisition is to be set aside, the requirement shall be divided into a set-aside portion and a non-set-aside portion, each of which shall (1) be an economic production run or reasonable lot and (2) have terms and a delivery schedule comparable to the other. When practicable, the set-aside portion should make maximum use of small business capacity.\n(c)(1) The contracting officer shall award the non-set-aside portion using normal contracting procedures.\n(2)(i) After all awards have been made on the non-set-aside portion, the contracting officer shall negotiate with eligible concerns on the set-aside portion, as provided in the solicitation, and make award. Negotiations shall be conducted only with those offerors who have submitted responsive offers on the non-set-aside portion. Negotiations shall be conducted with small business concerns in the order of priority as indicated in the solicitation (but see paragraph (c)(2)(ii) of this section). The set-aside portion shall be awarded as provided in the solicitation. An offeror entitled to receive the award for quantities of an item under the non-set-aside portion and who accepts the award of additional quantities under the set-aside portion shall not be requested to accept a lower price because of the increased quantities of the award, nor shall negotiation be conducted with a view to obtaining such a lower price based solely upon receipt of award of both portions of the acquisition. This does not prevent acceptance by the contracting officer of voluntary reductions in the price from the low eligible offeror before award, acceptance of voluntary refunds, or the change of prices after award by negotiation of a contract modification.\n(ii) If equal low offers are received on the non-set-aside portion from concerns eligible for the set-aside portion, the concern that is awarded the non-set-aside part of the acquisition shall have first priority with respect to negotiations for the set-aside.\n19.502-4 Multiple-award contracts and small business set-asides.\nIn accordance with section 1331 of Public Law 111-240 ( 15 U.S.C. 644(r) ) contracting officers may, at their discretion  \n(a) When conducting multiple-award procurements using full and open competition, reserve one or more contract awards for any of the small business concerns identified in 19.000 (a)(3). The specific program eligibility requirements identified in this part apply;\n(b) Set aside part or parts of a multiple-award contract for any of the small business concerns identified in 19.000 (a)(3). The specific program eligibility requirements identified in this part apply; or\n(c) Set aside orders placed under multiple-award contracts for any of the small business concerns identified in 19.000 (a)(3). For orders placed under the Federal Supply Schedules Program see 8.405-5 . For all other multiple-award contracts see 16.505 .\n19.502-5 Methods of conducting set-asides.\n(a) Total small business set-asides may be conducted by using simplified acquisition procedures (see Part 13 ), sealed bids (see Part 14 ), or competitive proposals (see Part 15 ). Partial small business set-asides may be conducted using sealed bids (see Part 14 ), or competitive proposals (see Part 15 ).\n(b) Except for offers on the non-set-aside portion of partial set-asides, offers received from concerns that do not qualify as small business concerns shall be considered nonresponsive and shall be rejected. However, before rejecting an offer otherwise eligible for award because of questions concerning the size representation, an SBA determination must be obtained (see Subpart 19.3 ).\n19.502-6 Insufficient causes for not setting aside an acquisition.\nNone of the following is, in itself, sufficient cause for not setting aside an acquisition:\n(a) A large percentage of previous contracts for the required item(s) has been placed with small business concerns.\n(b) The item is on an established planning list under the Industrial Readiness Planning Program. However, a total small business set-aside shall not be made when the list contains a large business Planned Emergency Producer of the item(s) who has conveyed a desire to supply some or all of the required items.\n(c) The item is on a Qualified Products List. However, a total small business set-aside shall not be made if the list contains the products of large businesses unless none of the large businesses desire to participate in the acquisition.\n(d) A period of less than 30 days is available for receipt of offers.\n(e) The acquisition is classified.\n(f) Small business concerns are already receiving a fair proportion of the agency  s contracts for supplies and services.\n(g) A class small business set-aside of the item or service has been made by another contracting activity.\n(h) A  brand name or equal  product description will be used in the solicitation.\n19.503 Setting aside a class of acquisitions for small business.\n(a) A class of acquisitions of selected products or services, or a portion of the acquisitions, may be set aside for exclusive participation by small business concerns if individual acquisitions in the class will meet the criteria in 19.502-1 , 19.502-2 , or 19.502-3 (a). The determination to make a class small business set-aside shall not depend on the existence of a current acquisition if future acquisitions can be clearly foreseen.\n(b) The determination to set aside a class of acquisitions for small business may be either unilateral or joint.\n(c) Each class small business set-aside determination shall be in writing and must  \n(1) Specifically identify the product(s) and service(s) it covers;\n(2) Provide that the set-aside does not apply to any acquisition automatically reserved for small business concerns under 19.502-2 (a).\n(3) Provide that the set-aside applies only to the (named) contracting office(s) making the determination; and\n(4) Provide that the set-aside does not apply to any individual acquisition if the requirement is not severable into two or more economic production runs or reasonable lots, in the case of a partial class set-aside.\n(d) The contracting officer shall review each individual acquisition arising under a class small business set-aside to identify any changes in the magnitude of requirements, specifications, delivery requirements, or competitive market conditions that have occurred since the initial approval of the class set-aside. If there are any changes of such a material nature as to result in probable payment of more than a fair market price by the Government or in a change in the capability of small business concerns to satisfy the requirements, the contracting officer may withdraw or modify (see 19.506 (a)) the unilateral or joint set-aside by giving written notice to the SBA procurement center representative (or, if a procurement center representative is not assigned, see 19.402 (a)) stating the reasons.\n19.504 Inclusion of Federal Prison Industries, Inc.\nWhen using competitive procedures in accordance with 8.602 (a)(4), agencies shall include Federal Prison Industries, Inc. (FPI), in the solicitation process and consider a timely offer from FPI.\n19.505 Rejecting Small Business Administration recommendations.\n(a) If the contracting officer rejects a recommendation of the SBA procurement center representative (or, if a procurement center representative is not assigned, see 19.402 (a)) or breakout procurement center representative, written notice shall be furnished to the appropriate SBA representative within 5 working days of the contracting officer  s receipt of the recommendation.\n(b) The SBA procurement center representative (or, if a procurement center representative is not assigned, see 19.402 (a)) may appeal the contracting officer  s rejection to the head of the contracting activity (or designee) within 2 working days after receiving the notice. The head of the contracting activity (or designee) shall render a decision in writing, and provide it to the SBA representative within 7 working days. Pending issuance of a decision to the SBA representative, the contracting officer shall suspend action on the acquisition.\n(c) If the head of the contracting activity agrees that the contracting officer  s rejection was appropriate  \n(1) Within 2 working days, the SBA procurement center representative (or, if a procurement center representative is not assigned, see 19.402 (a)) may request the contracting officer to suspend action on the acquisition until the SBA Administrator appeals to the agency head (see paragraph (f) of this section); and\n(2) The SBA must be allowed 15 working days after making such a written request, within which the Administrator of SBA  \n(i) May appeal to the Secretary of the Department concerned; and\n(ii) Must notify the contracting officer whether the further appeal has, in fact, been taken. If notification is not received by the contracting officer within the 15-day period, it is deemed that the SBA request to suspend the contract action has been withdrawn and that an appeal to the Secretary was not taken.\n(d) When the contracting officer has been notified within the 15-day period that the SBA has appealed to the agency head, the head of the contracting activity (or designee) shall forward justification for its decision to the agency head. The contracting officer shall suspend contract action until notification is received that the SBA appeal has been settled.\n(e) The agency head shall reply to the SBA within 30 working days after receiving the appeal. The decision of the agency head shall be final.\n(f) A request to suspend action on an acquisition need not be honored if the contracting officer determines that proceeding to contract award and performance is in the public interest. The contracting officer shall include in the contract file a statement of the facts justifying the determination, and shall promptly notify the SBA representative of the determination and provide a copy of the justification.\n19.506 Withdrawing or modifying small business set-asides.\n(a) If, before award of a contract involving a small business set-aside, the contracting officer considers that award would be detrimental to the public interest ( e.g., payment of more than a fair market price), the contracting officer may withdraw the small business set-aside determination whether it was unilateral or joint. The contracting officer shall initiate a withdrawal of an individual small business set-aside by giving written notice to the agency small business specialist and the SBA procurement center representative (or, if a procurement center representative is not assigned, see 19.402 (a)) stating the reasons. In a similar manner, the contracting officer may modify a unilateral or joint class small business set-aside to withdraw one or more individual acquisitions.\n(b) If the agency small business specialist does not agree to a withdrawal or modification, the case shall be promptly referred to the SBA representative (or, if a procurement center representative is not assigned, see 19.402 (a)) for review.\n(c) The contracting officer shall prepare a written statement supporting any withdrawal or modification of a small business set-aside and include it in the contract file.\n19.507 Automatic dissolution of a small business set-aside.\n(a) If a small business set-aside acquisition or portion of an acquisition is not awarded, the unilateral or joint determination to set the acquisition aside is automatically dissolved for the unawarded portion of the set-aside. The required supplies and/or services for which no award was made may be acquired by sealed bidding or negotiation, as appropriate.\n(b) Before issuing a solicitation for the items called for in a small business set-aside that was dissolved, the contracting officer shall ensure that the delivery schedule is realistic in the light of all relevant factors, including the capabilities of small business concerns.\n19.508 Solicitation provisions and contract clauses.\n(a) [Reserved]\n(b) [Reserved]\n(c) The contracting officer shall insert the clause at 52.219-6 , Notice of Total Small Business Set-Aside, in solicitations and contracts involving total small business set-asides or reserves. This includes multiple-award contracts when orders may be set aside for any of the small business concerns identified in 19.000 (a)(3), as described in 8.405-5 and 16.505 (b)(2)(i)(F). The clause at 52.219-6 with its Alternate I will be used when the acquisition is for a product in a class for which the Small Business Administration has waived the nonmanufacturer rule (see 19.102 (f)(4) and (5)). Use the clause at 52.219-6 with its Alternate II when including FPI in the competition in accordance with 19.504 .\n(d) The contracting officer shall insert the clause at 52.219-7 , Notice of Partial Small Business Set-Aside, in solicitations and contracts involving partial small business set-asides. This includes part or parts of multiple-award contracts, including those described in 38.101 . The clause at 52.219-7 with its Alternate I will be used when the acquisition is for a product in a class for which the Small Business Administration has waived the nonmanufacturer rule (see 19.102 (f)(4) and (5)). Use the clause at 52.219-7 with its Alternate II when including FPI in the competition in accordance with 19.504 .\n(e) The contracting officer shall insert the clause at 52.219-14 , Limitations on Subcontracting, in solicitations and contracts for supplies, services, and construction, if any portion of the requirement is to be set aside or reserved for small business and the contract amount is expected to exceed $150,000. This includes multiple-award contracts when orders may be set aside for small business concerns, as described in 8.405-5 and 16.505 (b)(2)(i)(F).\n(f) The contracting officer shall insert the clause at 52.219-13 , Notice of Set-Aside of Orders, in solicitations and contracts to notify offerors if an order or orders are to be set aside for any of the small business concerns identified in 19.000 (a)(3).");
register_book(&s, "|19|6|", "Certificates of Competency and Determin", "Subpart 19.6  Certificates of Competency and Determinations of Responsibility\n19.601 General.\n(a) A Certificate of Competency (COC) is the certificate issued by the Small Business Administration (SBA) stating that the holder is responsible (with respect to all elements of responsibility, including, but not limited to, capability, competency, capacity, credit, integrity, perseverance, tenacity, and limitations on subcontracting) for the purpose of receiving and performing a specific Government contract.\n(b) The COC program empowers the Small Business Administration (SBA) to certify to Government contracting officers as to all elements of responsibility of any small business concern to receive and perform a specific Government contract. The COC program does not extend to questions concerning regulatory requirements imposed and enforced by other Federal agencies.\n(c) The COC program is applicable to all Government acquisitions. A contracting officer shall, upon determining an apparent successful small business offeror to be nonresponsible, refer that small business to the SBA for a possible COC, even if the next acceptable offer is also from a small business.\n(d) When a solicitation requires a small business to adhere to the limitations on subcontracting, a contracting officer  s finding that a small business cannot comply with the limitation shall be treated as an element of responsibility and shall be subject to the COC process. When a solicitation requires a small business to adhere to the definition of a nonmanufacturer, a contracting officer  s determination that the small business does not comply shall be processed in accordance with Subpart 19.3 .\n(e) Contracting officers, including those located overseas, are required to comply with this subpart for U.S. small business concerns.\n19.602 Procedures.\n19.602-1 Referral.\n(a) Upon determining and documenting that an apparent successful small business offeror lacks certain elements of responsibility (including, but not limited to, capability, competency, capacity, credit, integrity, perseverance, tenacity, and limitations on subcontracting, but for sureties see 28.101-3 (f) and 28.203 (c)), the contracting officer shall  \n(1) Withhold contract award (see 19.602-3 ); and\n(2) Refer the matter to the cognizant SBA Government Contracting Area Office (Area Office) serving the area in which the headquarters of the offeror is located, in accordance with agency procedures, except that referral is not necessary if the small business concern  \n(i) Is determined to be unqualified and ineligible because it does not meet the standard in 9.104-1 (g), provided, that the determination is approved by the chief of the contracting office; or\n(ii) Is suspended or debarred under Executive Order 11246 or Subpart 9.4 .\n(b) If a partial set-aside is involved, the contracting officer shall refer to the SBA the entire quantity to which the concern may be entitled, if responsible.\n(c) The referral shall include  \n(1) A notice that a small business concern has been determined to be nonresponsible, specifying the elements of responsibility the contracting officer found lacking; and\n(2) If applicable, a copy of the following:\n(i) Solicitation.\n(ii) Final offer submitted by the concern whose responsibility is at issue for the procurement.\n(iii) Abstract of bids or the contracting officer  s price negotiation memorandum.\n(iv) Preaward survey.\n(v) Technical data package (including drawings, specifications and statement of work).\n(vi) Any other justification and documentation used to arrive at the nonresponsibility determination.\n(d) For any single acquisition, the contracting officer shall make only one referral at a time regarding a determination of nonresponsibility.\n(e) Contract award shall be withheld by the contracting officer for a period of 15 business days (or longer if agreed to by the SBA and the contracting officer) following receipt by the appropriate SBA Area Office of a referral that includes all required documentation.\n19.602-2 Issuing or denying a Certificate of Competency (COC).\nWithin 15 business days (or a longer period agreed to by the SBA and the contracting agency) after receiving a notice that a small business concern lacks certain elements of responsibility, the SBA Area Office will take the following actions:\n(a) Inform the small business concern of the contracting officer  s determination and offer it an opportunity to apply to the SBA for a COC. (A concern wishing to apply for a COC should notify the SBA Area Office serving the geographical area in which the headquarters of the offeror is located.)\n(b) Upon timely receipt of a complete and acceptable application, elect to visit the applicant  s facility to review its responsibility.\n(1) The COC review process is not limited to the areas of nonresponsibility cited by the contracting officer.\n(2) The SBA may, at its discretion, independently evaluate the COC applicant for all elements of responsibility, but may presume responsibility exists as to elements other than those cited as deficient.\n(c) Consider denying a COC for reasons of nonresponsibility not originally cited by the contracting officer.\n(d) When the Area Director determines that a COC is warranted (for contracts valued at $25,000,000 or less), notify the contracting officer and provide the following options:\n(1) Accept the Area Director  s decision to issue a COC and award the contract to the concern. The COC issuance letter will then be sent, including as an attachment a detailed rationale for the decision; or\n(2) Ask the Area Director to suspend the case for one or more of the following purposes:\n(i) To permit the SBA to forward a detailed rationale for the decision to the contracting officer for review within a specified period of time.\n(ii) To afford the contracting officer the opportunity to meet with the Area Office to review all documentation contained in the case file and to attempt to resolve any issues.\n(iii) To submit any information to the SBA Area Office that the contracting officer believes the SBA did not consider (at which time, the SBA Area Office will establish a new suspense date mutually agreeable to the contracting officer and the SBA).\n(iv) To permit resolution of an appeal by the contracting agency to SBA Headquarters under 19.602-3 . However, there is no contracting officer  s appeal when the Area Office proposes to issue a COC valued at $100,000 or less.\n(e) At the completion of the process, notify the concern and the contracting officer that the COC is denied or is being issued.\n(f) Refer recommendations for issuing a COC on contracts greater than $25,000,000 to SBA Headquarters.\n19.602-3 Resolving differences between the agency and the Small Business Administration.\n(a) COCs valued between $100,000 and $25,000,000.\n(1) When disagreements arise about a concern  s ability to perform, the contracting officer and the SBA shall make every effort to reach a resolution before the SBA takes final action on a COC. This shall be done through the complete exchange of information and in accordance with agency procedures. If agreement cannot be reached between the contracting officer and the SBA Area Office, the contracting officer shall request that the Area Office suspend action and refer the matter to SBA Headquarters for review. The SBA Area Office shall honor the request for a review if the contracting officer agrees to withhold award until the review process is concluded. Without an agreement to withhold award, the SBA Area Office will issue the COC in accordance with applicable SBA regulations.\n(2) SBA Headquarters will furnish written notice to the procuring agency  s Director, Office of Small and Disadvantaged Business Utilization (OSDBU) or other designated official (with a copy to the contracting officer) that the case file has been received and that an appeal decision may be requested by an authorized official.\n(3) If the contracting agency decides to file an appeal, it must notify SBA Headquarters through its procuring agency  s Director, OSDBU, or other designated official, within 10 business days (or a time period agreed upon by both agencies) that it intends to appeal the issuance of the COC.\n(4) The appeal and any supporting documentation shall be filed by the procuring agency  s Director, OSDBU, or other designated official, within 10 business days (or a period agreed upon by both agencies) after SBA Headquarters receives the agency  s notification in accordance with paragraph (a)(3) of this subsection.\n(5) The SBA Associate Administrator for Government Contracting will make a final determination, in writing, to issue or to deny the COC.\n(b) SBA Headquarters  decisions on COCs valued over $25,000,000.\n(1) Prior to taking final action, SBA Headquarters will contact the contracting agency and offer it the following options:\n(i) To request that the SBA suspend case processing to allow the agency to meet with SBA Headquarters personnel and review all documentation contained in the case file; or\n(ii) To submit to SBA Headquarters for evaluation any information that the contracting agency believes has not been considered.\n(2) After reviewing all available information, the SBA will make a final decision to either issue or deny the COC.\n(c) Reconsideration of a COC after issuance.\n(1) The SBA reserves the right to reconsider its issuance of a COC, prior to contract award, if  \n(i) The COC applicant submitted false information or omitted materially adverse information; or\n(ii) The COC has been issued for more than 60 days (in which case the SBA may investigate the firm  s current circumstances).\n(2) When the SBA reconsiders and reaffirms the COC, the procedures in subsection 19.602-2 do not apply.\n(3) Denial of a COC by the SBA does not preclude a contracting officer from awarding a contract to the referred concern, nor does it prevent the concern from making an offer on any other procurement.\n19.602-4 Awarding the contract.\n(a) If new information causes the contracting officer to determine that the concern referred to the SBA is actually responsible to perform the contract, and award has not already been made under paragraph (c) of this subsection, the contracting officer shall reverse the determination of nonresponsibility, notify the SBA of this action, withdraw the referral, and proceed to award the contract.\n(b) The contracting officer shall award the contract to the concern in question if the SBA issues a COC after receiving the referral. An SBA-certified concern shall not be required to meet any other requirements of responsibility. SBA COC  s are conclusive with respect to all elements of responsibility of prospective small business contractors.\n(c) The contracting officer shall proceed with the acquisition and award the contract to another appropriately selected and responsible offeror if the SBA has not issued a COC within 15 business days (or a longer period of time agreed to with the SBA) after receiving the referral.");
register_book(&s, "|19|7|", "The Small Business Subcontracting Progr", "Subpart 19.7  The Small Business Subcontracting Program\n19.701 Definitions.\nAs used in this subpart  \nAlaska Native Corporation (ANC)  means any Regional Corporation, Village Corporation, Urban Corporation, or Group Corporation organized under the laws of the State of Alaska in accordance with the Alaska Native Claims Settlement Act, as amended ( 43 U.S.C. 1601 , et seq .) and which is considered a minority and economically disadvantaged concern under the criteria at 43 U.S.C. 1626(e)(1) . This definition also includes ANC direct and indirect subsidiary corporations, joint ventures, and partnerships that meet the requirements of 43 U.S.C. 1626(e)(2) .\nCommercial plan  means a subcontracting plan (including goals) that covers the offeror  s fiscal year and that applies to the entire production of commercial items sold by either the entire company or a portion thereof ( e.g., division, plant, or product line).\nElectronic Subcontracting Reporting System (eSRS)  means the Governmentwide, electronic, web-based system for small business subcontracting program reporting.\nFailure to make a good faith effort to comply with the subcontracting plan  means willful or intentional failure to perform in accordance with the requirements of the subcontracting plan, or willful or intentional action to frustrate the plan.\nIndian tribe  means any Indian tribe, band, group, pueblo, or community, including native villages and native groups (including corporations organized by Kenai, Juneau, Sitka, and Kodiak) as defined in the Alaska Native Claims Settlement Act ( 43 U.S.C.A. 1601 et seq .), that is recognized by the Federal Government as eligible for services from the Bureau of Indian Affairs in accordance with 25 U.S.C. 1452(c) . This definition also includes Indian-owned economic enterprises that meet the requirements of 25 U.S.C. 1452(e) .\nIndividual contract plan  means a subcontracting plan that covers the entire contract period (including option periods), applies to a specific contract, and has goals that are based on the offeror  s planned subcontracting in support of the specific contract, except that indirect costs incurred for common or joint purposes may be allocated on a prorated basis to the contract.\nMaster plan  means a subcontracting plan that contains all the required elements of an individual contract plan, except goals, and may be incorporated into individual contract plans, provided the master plan has been approved.\nSubcontract  means any agreement (other than one involving an employer-employee relationship) entered into by a Government prime contractor or subcontractor calling for supplies and/or services required for performance of the contract, contract modification, or subcontract.\n19.702 Statutory requirements.\nAny contractor receiving a contract for more than the simplified acquisition threshold must agree in the contract that small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business, and women-owned small business concerns will have the maximum practicable opportunity to participate in contract performance consistent with its efficient performance. It is further the policy of the United States that its prime contractors establish procedures to ensure the timely payment of amounts due pursuant to the terms of their subcontracts with small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business, and women-owned small business concerns.\n(a) Except as stated in paragraph (b) of this section, Section 8(d) of the Small Business Act ( 15 U.S.C. 637(d) ) imposes the following requirements regarding subcontracting with small businesses and small business subcontracting plans:\n(1) In negotiated acquisitions, each solicitation of offers to perform a contract or contract modification, that individually is expected to exceed $650,000 ($1.5 million for construction) and that has subcontracting possibilities, shall require the apparently successful offeror to submit an acceptable subcontracting plan. If the apparently successful offeror fails to negotiate a subcontracting plan acceptable to the contracting officer within the time limit prescribed by the contracting officer, the offeror will be ineligible for award.\n(2) In sealed bidding acquisitions, each invitation for bids to perform a contract or contract modification, that individually is expected to exceed $650,000 ($1.5 million for construction) and that has subcontracting possibilities, shall require the bidder selected for award to submit a subcontracting plan. If the selected bidder fails to submit a plan within the time limit prescribed by the contracting officer, the bidder will be ineligible for award.\n(b) Subcontracting plans (see paragraphs (a)(1) and (2) of this section) are not required  \n(1) From small business concerns;\n(2) For personal services contracts;\n(3) For contracts or contract modifications that will be performed entirely outside of the United States and its outlying areas; or\n(4) For modifications to contracts within the general scope of the contract that do not contain the clause at 52.219-8 , Utilization of Small Business Concerns (or equivalent prior clauses; e.g., contracts awarded before the enactment of Public Law 95-507).\n(c) As stated in 15 U.S.C. 637(d)(8) , any contractor or subcontractor failing to comply in good faith with the requirements of the subcontracting plan is in material breach of its contract. Further, 15 U.S.C. 637(d)(4)(F) directs that a contractor  s failure to make a good faith effort to comply with the requirements of the subcontracting plan shall result in the imposition of liquidated damages.\n(d) As authorized by 15 U.S.C. 637(d)(11) , certain costs incurred by a mentor firm in providing developmental assistance to a prot g  firm under the Department of Defense Pilot Mentor-Prot g  Program, may be credited as if they were subcontract awards to a prot g  firm for the purpose of determining whether the mentor firm attains the applicable goals under any subcontracting plan entered into with any executive agency. However, the mentor-prot g  agreement must have been approved by the Director, Small Business Programs of the cognizant DoD military department or defense agency, before developmental assistance costs may be credited against subcontract goals. A list of approved agreements may be obtained at http://www.acq.osd.mil/osbp/mentor_protege/ .\n19.703 Eligibility requirements for participating in the program.\n(a) Except as provided in paragraph (c) of this section to be eligible as a subcontractor under the program, a concern must represent itself as a small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business, or woman-owned small business concern.\n(1) To represent itself as a small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business, or woman-owned small business concern, a concern must meet the appropriate definition (see 2.101 and 19.001 ).\n(2) In connection with a subcontract, or a requirement for which the apparently successful offeror received an evaluation credit for proposing one or more SDB subcontractors, the contracting officer or the SBA may protest the disadvantaged status of a proposed subcontractor. Such protests will be processed in accordance with 13 CFR 124.1007 through 124.1014. Other interested parties may submit information to the contracting officer or the SBA in an effort to persuade the contracting officer or the SBA to initiate a protest. Such protests, in order to be considered timely, must be submitted to the SBA prior to completion of performance by the intended subcontractor.\n(b) A contractor acting in good faith may rely on the written representation of its subcontractor regarding the subcontractor  s status as a small business, small disadvantaged business, veteran-owned small business, service-disabled veteran-owned small business, or a woman-owned small business concern. The contractor, the contracting officer, or any other interested party can challenge a subcontractor  s size status representation by filing a protest, in accordance with 13 CFR 121.1001 through 121.1008. Protests challenging a subcontractor  s small disadvantaged business representation must be filed in accordance with 13 CFR 124.1007 through 124.1014.\n(c)(1) In accordance with 43 U.S.C. 1626 , the following procedures apply:\n(i) Subcontracts awarded to an ANC or Indian tribe shall be counted towards the subcontracting goals for small business and small disadvantaged business (SDB) concerns, regardless of the size or Small Business Administration certification status of the ANC or Indian tribe.\n(ii) Where one or more subcontractors are in the subcontract tier between the prime contractor and the ANC or Indian tribe, the ANC or Indian tribe shall designate the appropriate contractor(s) to count the subcontract towards its small business and small disadvantaged business subcontracting goals.\n(A) In most cases, the appropriate contractor is the contractor that awarded the subcontract to the ANC or Indian tribe.\n(B) If the ANC or Indian tribe designates more than one contractor to count the subcontract toward its goals, the ANC or Indian tribe shall designate only a portion of the total subcontract award to each contractor. The sum of the amounts designated to various contractors cannot exceed the total value of the subcontract.\n(C) The ANC or Indian tribe shall give a copy of the written designation to the contracting officer, the prime contractor, and the subcontractors in between the prime contractor and the ANC or Indian tribe within 30 days of the date of the subcontract award.\n(D) If the contracting officer does not receive a copy of the ANC's or the Indian tribe  s written designation within 30 days of the subcontract award, the contractor that awarded the subcontract to the ANC or Indian tribe will be considered the designated contractor.\n(2) A contractor acting in good faith may rely on the written representation of an ANC or an Indian tribe as to the status of the ANC or Indian tribe unless an interested party challenges its status or the contracting officer has independent reason to question its status. In the event of a challenge of a representation of an ANC or Indian tribe, the interested parties shall follow the procedures at 26.103 (b) through (e).\n(d)(1) The contractor shall confirm that a subcontractor representing itself as a HUBZone small business concern is certified by SBA as a HUBZone small business concern by accessing the System for Award Management database or by contacting the SBA. Options for contacting the SBA include  \n(i) HUBZone small business database search application web page at http://dsbs.sba.gov/dsbs/dsp_searchhubzone.cfm or www.sba.gov/hubzone ;\n(ii) In writing to the  \nDirector/HUB, U.S. Small Business Administration, 409 3rd Street, SW., Washington DC 20416; or\n(iii) E-mail at hubzone@sba.gov .\n(2) Protests challenging HUBZone small business concern size status must be filed in accordance with 13 CFR 121.411.\n19.704 Subcontracting plan requirements.\n(a) Each subcontracting plan required under 19.702 (a)(1) and (2) must include  \n(1) Separate percentage goals for using small business (including ANCs and Indian tribes), veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business (including ANCs and Indian tribes) and women-owned small business concerns as subcontractors;\n(2) A statement of the total dollars planned to be subcontracted and a statement of the total dollars planned to be subcontracted to small business (including ANCs and Indian tribes), veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business (including ANCs and Indian tribes) and women-owned small business concerns;\n(3) A description of the principal types of supplies and services to be subcontracted and an identification of types planned for subcontracting to small business (including ANCs and Indian tribes), veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business (including ANCs and Indian tribes), and women-owned small business concerns;\n(4) A description of the method used to develop the subcontracting goals;\n(5) A description of the method used to identify potential sources for solicitation purposes;\n(6) A statement as to whether or not the offeror included indirect costs in establishing subcontracting goals, and a description of the method used to determine the proportionate share of indirect costs to be incurred with small business (including ANCs and Indian tribes), veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business (including ANCs and Indian tribes), and women-owned small business concerns;\n(7) The name of an individual employed by the offeror who will administer the offeror  s subcontracting program, and a description of the duties of the individual;\n(8) A description of the efforts the offeror will make to ensure that small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business, and women-owned small business concerns have an equitable opportunity to compete for subcontracts;\n(9) Assurances that the offeror will include the clause at 52.219-8 , Utilization of Small Business Concerns (see 19.708 (a)), in all subcontracts that offer further subcon- tracting opportunities, and that the offeror will require all subcontractors (except small business concerns) that receive subcontracts in excess of $650,000 ($1.5 million for construction) to adopt a plan that complies with the requirements of the clause at 52.219-9 , Small Business Subcontracting Plan (see 19.708 (b));\n(10) Assurances that the offeror will  \n(i) Cooperate in any studies or surveys as may be required;\n(ii) Submit periodic reports so that the Government can determine the extent of compliance by the offeror with the subcontracting plan;\n(iii) Submit the Individual Subcontract Report (ISR), and the Summary Subcontract Report (SSR) using the Electronic Subcontracting Reporting System (eSRS) ( http://www.esrs.gov ), following the instructions in the eSRS;\n(A) The ISR shall be submitted semi-annually during contract performance for the periods ending March 31 and September 30. A report is also required for each contract within 30 days of contract completion. Reports are due 30 days after the close of each reporting period, unless otherwise directed by the contracting officer. Reports are required when due, regardless of whether there has been any subcontracting activity since the inception of the contract or the previous reporting period.\n(B) The SSR shall be submitted as follows: For DoD and NASA, the report shall be submitted semi-annually for the six months ending March 31 and the twelve months ending September 30. For civilian agencies, except NASA, it shall be submitted annually for the twelve-month period ending September 30. Reports are due 30 days after the close of each reporting period.\n(iv) Ensure that its subcontractors with subcontracting plans agree to submit the ISR and/or the SSR using the eSRS;\n(v) Provide its prime contract number, its DUNS number, and the e-mail address of the offeror  s official responsible for acknowledging receipt of or rejecting the ISRs to all first-tier subcontractors with subcontracting plans so they can enter this information into the eSRS when submitting their ISRs; and\n(vi) Require that each subcontractor with a subcontracting plan provide the prime contract number, its own DUNS number, and the e-mail address of the subcontractor  s official responsible for acknowledging receipt of or rejecting the ISRs, to its subcontractors with subcontracting plans.\n(11) A description of the types of records that will be maintained concerning procedures adopted to comply with the requirements and goals in the plan, including establishing source lists; and a description of the offeror  s efforts to locate small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business, and women-owned small business concerns and to award subcontracts to them.\n(b) Contractors may establish, on a plant or division-wide basis, a master plan (see 19.701 ) that contains all the elements required by the clause at 52.219-9 , Small Business Subcontracting Plan, except goals. Master plans shall be effective for a 3-year period after approval by the contracting officer; however, it is incumbent upon contractors to maintain and update master plans. Changes required to update master plans are not effective until approved by the contracting officer. A master plan, when incorporated in an individual plan, shall apply to that contract throughout the life of the contract.\n(c) For multiyear contracts or contracts containing options, the cumulative value of the basic contract and all options is considered in determining whether a subcontracting plan is necessary (see 19.705-2 (a)). If a plan is necessary and the offeror is submitting an individual contract plan, the plan shall contain all the elements required by paragraph (a) of this section and shall contain separate statements and goals for the basic contract and for each option.\n(d) A commercial plan (as defined in 19.701 ) is the preferred type of subcontracting plan for contractors furnishing commercial items. Once a contractor  s commercial plan has been approved, the Government shall not require another subcontracting plan from the same contractor while the plan remains in effect, as long as the product or service being provided by the contractor continues to meet the definition of a commercial item. The contractor shall  \n(1) Submit the commercial plan to either the first contracting officer awarding a contract subject to the plan during the contractor  s fiscal year, or, if the contractor has ongoing contracts with commercial plans, to the contracting officer responsible for the contract with the latest completion date. The contracting officer shall negotiate the commercial plan for the Government. The approved commercial plan shall remain in effect during the contractor  s fiscal year for all Government contracts in effect during that period; \n(2) Submit a new commercial plan, 30 working days before the end of the Contractor  s fiscal year, to the contracting officer responsible for the uncompleted Government contract with the latest completion date. The contractor must provide to each contracting officer responsible for an ongoing contract subject to the plan, the identity of the contracting officer that will be negotiating the new plan;\n(3) When the new commercial plan is approved, provide a copy of the approved plan to each contracting officer responsible for an ongoing contract that is subject to the plan; and\n(4) Comply with the reporting requirements stated in paragraph (a)(10) of this section by submitting one SSR in eSRS, for all contracts covered by its commercial plan. This report will be acknowledged or rejected in eSRS by the contracting officer who approved the plan. The report shall be submitted within 30 days after the end of the Government  s fiscal year.\n19.705 Responsibilities of the contracting officer under the subcontracting assistance program.\n19.705-1 General support of the program.\nThe contracting officer may encourage the development of increased subcontracting opportunities in negotiated acquisition by providing monetary incentives such as payments based on actual subcontracting achievement or award-fee contracting (see the clause at 52.219-10 , Incentive Subcontracting Program, and 19.708 (c)). This subsection does not apply to SDB subcontracting (see 19.1203 ). When using any contractual incentive provision based upon rewarding the contractor monetarily for exceeding goals in the subcontracting plan, the contracting officer must ensure that (a) the goals are realistic and (b) any rewards for exceeding the goals are commensurate with the efforts the contractor would not have otherwise expended. Incentive provisions should normally be negotiated after reaching final agreement with the contractor on the subcontracting plan.\n19.705-2 Determining the need for a subcontracting plan.\nThe contracting officer must take the following actions to determine whether a proposed contractual action requires a subcontracting plan:\n(a) Determine whether the proposed contractual action will meet the dollar threshold in 19.702 (a)(1) or (2). If the action includes options or similar provisions, include their value in determining whether the threshold is met.\n(b) Determine whether subcontracting possibilities exist by considering relevant factors such as  \n(1) Whether firms engaged in the business of furnishing the types of items to be acquired customarily contract for performance of part of the work or maintain sufficient in-house capability to perform the work; and\n(2) Whether there are likely to be product prequalification requirements.\n(c) If it is determined that there are no subcontracting possibilities, the determination must be approved at a level above the contracting officer and placed in the contract file.\n(d) In solicitations for negotiated acquisitions, the contracting officer may require the submission of subcontracting plans with initial offers, or at any other time prior to award. In determining when subcontracting plans should be required, as well as when and with whom plans should be negotiated, the contracting officer must consider the integrity of the competitive process, the goal of affording maximum practicable opportunity for small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business, and women-owned small business concerns to participate, and the burden placed on offerors.\n(e) A contract may have no more than one plan. When a modification meets the criteria in 19.702 for a plan, or an option is exercised, the goals associated with the modification or option shall be added to those in the existing subcontract plan.\n19.705-3 Preparing the solicitation.\nThe contracting officer shall provide the Small Business Administration's (SBA  s) procurement center representative (or, if a procurement center representative is not assigned, see 19.402 (a)) a reasonable period of time to review any solicitation requiring submission of a subcontracting plan and to submit advisory findings before the solicitation is issued.\n19.705-4 Reviewing the subcontracting plan.\nThe contracting officer shall review the subcontracting plan for adequacy, ensuring that the required information, goals, and assurances are included (see 19.704 ).\n(a) No detailed standards apply to every subcontracting plan. Instead, the contracting officer shall consider each plan in terms of the circumstances of the particular acquisition, including  \n(1) Previous involvement of small business concerns as prime contractors or subcontractors in similar acquisitions;\n(2) Proven methods of involving small business concerns as subcontractors in similar acquisitions; and\n(3) The relative success of methods the contractor intends to use to meet the goals and requirements of the plan, as evidenced by records maintained by contractors.\n(b) If, under a sealed bid solicitation, a bidder submits a plan that does not cover each of the 11 required elements (see 19.704 ), the contracting officer shall advise the bidder of the deficiency and request submission of a revised plan by a specific date. If the bidder does not submit a plan that incorporates the required elements within the time allotted, the bidder shall be ineligible for award. If the plan, although responsive, evidences the bidder  s intention not to comply with its obligations under the clause at 52.219-8 , Utilization of Small Business Concerns, the contracting officer may find the bidder nonresponsible.\n(c) In negotiated acquisitions, the contracting officer shall determine whether the plan is acceptable based on the negotiation of each of the 11 elements of the plan (see 19.704 ). Subcontracting goals should be set at a level that the parties reasonably expect can result from the offeror expending good faith efforts to use small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business, and women-owned small business subcontractors to the maximum practicable extent. The contracting officer shall take particular care to ensure that the offeror has not submitted unreasonably low goals to minimize exposure to liquidated damages and to avoid the administrative burden of substantiating good faith efforts. Additionally, particular attention should be paid to the identification of steps that, if taken, would be considered a good faith effort. No goal should be negotiated upward if it is apparent that a higher goal will significantly increase the Government  s cost or seriously impede the attainment of acquisition objectives. An incentive subcontracting clause (see 52.219-10 , Incentive Subcontracting Program), may be used when additional and unique contract effort, such as providing technical assistance, could significantly increase subcontract awards to small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, or women-owned small business concerns.\n(d) In determining the acceptability of a proposed subcontracting plan, the contracting officer should take the following actions:\n(1) Obtain information available from the cognizant contract administration office, as provided for in 19.706 (a), and evaluate the offeror  s past performance in awarding subcontracts for the same or similar products or services to small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business, and women-owned small business concerns. If information is not available on a specific type of product or service, evaluate the offeror  s overall past performance and consider the performance of other contractors on similar efforts.\n(2) In accordance with 15 U.S.C. 637(d)(4)(F)(iii) , ensure that the goals offered are attainable in relation to  \n(i) The subcontracting opportunities available to the contractor, commensurate with the efficient and economical performance of the contract;\n(ii) The pool of eligible subcontractors available to fulfill the subcontracting opportunities; and\n(iii) The actual performance of such contractor in fulfilling the subcontracting goals specified in prior plans.\n(3) Ensure that the subcontracting goals are consistent with the offeror  s certified cost or pricing data or data other than certified cost or pricing data.\n(4) Evaluate the offeror  s make-or-buy policy or program to ensure that it does not conflict with the offeror  s proposed subcontracting plan and is in the Government  s interest. If the contract involves products or services that are particularly specialized or not generally available in the commercial market, consider the offeror  s current capacity to perform the work and the possibility of reduced subcontracting opportunities.\n(5) Evaluate subcontracting potential, considering the offeror  s make-or-buy policies or programs, the nature of the supplies or services to be subcontracted, the known availability of small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business, and women-owned small business concerns in the geographical area where the work will be performed, and the potential contractor  s long-standing contractual relationship with its suppliers.\n(6) Advise the offeror of available sources of information on potential small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business, and women-owned small business subcontractors, as well as any specific concerns known to be potential subcontractors. If the offeror  s proposed goals are questionable, the contracting officer must emphasize that the information should be used to develop realistic and acceptable goals.\n(7) Obtain advice and recommendations from the SBA procurement center representative (or, if a procurement center representative is not assigned, see 19.402 (a)) and the agency small business specialist.\n19.705-5 Awards involving subcontracting plans.\n(a) In making an award that requires a subcontracting plan, the contracting officer shall be responsible for the following:\n(1) Consider the contractor  s compliance with the subcontracting plans submitted on previous contracts as a factor in determining contractor responsibility.\n(2) Assure that a subcontracting plan was submitted when required.\n(3) Notify the SBA procurement center representative (or, if a procurement center representative is not assigned, see 19.402 (a)) of the opportunity to review the proposed contract (including the plan and supporting documentation). The notice shall be issued in sufficient time to provide the representative a reasonable time to review the material and submit advisory recommendations to the contracting officer. Failure of the representative to respond in a reasonable period of time shall not delay contract award.\n(4) Determine any fee that may be payable if an incentive is used in conjunction with the subcontracting plan.\n(5) Ensure that an acceptable plan is incorporated into and made a material part of the contract.\n(b) Letter contracts and similar undefinitized instruments, which would otherwise meet the requirements of 19.702 (a)(1) and (2), shall contain at least a preliminary basic plan addressing the requirements of 19.704 and in such cases require the negotiation of the final plan within 90 days after award or before definitization, whichever occurs first.\n19.705-6 Postaward responsibilities of the contracting officer.\nAfter a contract or contract modification containing a subcontracting plan is awarded, the contracting officer who approved the plan is responsible for the following:\n(a) Notifying the SBA of the award by sending a copy of the award document to the Area Director, Office of Government Contracting, in the SBA area office where the contract will be performed.\n(b) Forwarding a copy of each commercial plan and any associated approvals to the Area Director, Office of Government Contracting, in the SBA area office where the contractor  s headquarters is located.\n(c) Giving to the SBA procurement center representative (or, if a procurement center representative is not assigned, see 19.402 (a)) a copy of  \n(1) Any subcontracting plan submitted in response to a sealed bid solicitation; and\n(2) The final negotiated subcontracting plan that was incorporated into a negotiated contract or contract modification.\n(d) Notifying the SBA procurement center representative (or, if a procurement center representative is not assigned, see 19.402 (a)) of the opportunity to review subcontracting plans in connection with contract modifications.\n(e) Forwarding a copy of each plan, or a determination that there is no requirement for a subcontracting plan, to the cognizant contract administration office.\n(f) Initiating action to assess liquidated damages in accordance with 19.705-7 upon a recommendation by the administrative contracting officer or receipt of other reliable evidence to indicate that such action is warranted.\n(g) Taking action to enforce the terms of the contract upon receipt of a notice under 19.706 (f).\n(h) Acknowledging receipt of or rejecting the ISR and the SSR in the eSRS. Acknowledging receipt does not mean acceptance or approval of the report. The report shall be rejected if it is not adequately completed, for instance, if there are errors, omissions, or incomplete data. Failure to meet the goals of the subcontracting plan is not a valid reason for rejecting the report.\n19.705-7 Liquidated damages.\n(a) Maximum practicable utilization of small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business, and women-owned small business concerns as subcontractors in Government contracts is a matter of national interest with both social and economic benefits. When a contractor fails to make a good faith effort to comply with a subcontracting plan, these objectives are not achieved, and 15 U.S.C. 637(d)(4)(F) directs that liquidated damages shall be paid by the contractor.\n(b) The amount of damages attributable to the contractor  s failure to comply shall be an amount equal to the actual dollar amount by which the contractor failed to achieve each subcontracting goal.\n(c) If, at completion of the basic contract or any option, or in the case of a commercial plan, at the close of the fiscal year for which the plan is applicable, a contractor has failed to meet its subcontracting goals, the contracting officer shall review all available information for an indication that the contractor has not made a good faith effort to comply with the plan. If no such indication is found, the contracting officer shall document the file accordingly. If the contracting officer decides in accordance with paragraph (d) of this subsection that the contractor failed to make a good faith effort to comply with its subcontracting plan, the contracting officer shall give the contractor written notice specifying the failure, advising the contractor of the possibility that the contractor may have to pay to the Government liquidated damages, and providing a period of 15 working days (or longer period as necessary) within which to respond. The notice shall give the contractor an opportunity to demonstrate what good faith efforts have been made before the contracting officer issues the final decision, and shall further state that failure of the contractor to respond may be taken as an admission that no valid explanation exists.\n(d) In determining whether a contractor failed to make a good faith effort to comply with its subcontracting plan, a contracting officer must look to the totality of the contractor  s actions, consistent with the information and assurances provided in its plan. The fact that the contractor failed to meet its subcontracting goals does not, in and of itself, constitute a failure to make a good faith effort. For example, notwithstanding a contractor  s diligent effort to identify and solicit offers from small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business, and women-owned small business concerns, factors such as unavailability of anticipated sources or unreasonable prices may frustrate achievement of the contractor  s goals. However, when considered in the context of the contractor  s total effort in accordance with its plan, the following, though not all inclusive, may be considered as indicators of a failure to make a good faith effort: a failure to attempt to identify, contact, solicit, or consider for contract award small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business, or women-owned small business concerns; a failure to designate and maintain a company official to administer the subcontracting program and monitor and enforce compliance with the plan; a failure to submit the ISR, or the SSR, using the eSRS, or as provided in agency regulations; a failure to maintain records or otherwise demonstrate procedures adopted to comply with the plan; or the adoption of company policies or procedures that have as their objectives the frustration of the objectives of the plan.\n(e) If, after consideration of all the pertinent data, the contracting officer finds that the contractor failed to make a good faith effort to comply with its subcontracting plan, the contracting officer shall issue a final decision to the contractor to that effect and require the payment of liquidated damages in an amount stated. The contracting officer  s final decision shall state that the contractor has the right to appeal under the clause in the contract entitled Disputes.\n(f) With respect to commercial plans approved under the clause at 52.219-9 , Small Business Subcontracting Plan, the contracting officer that approved the plan shall  \n(1) Perform the functions of the contracting officer under this subsection on behalf of all agencies with contracts covered by the commercial plan;\n(2) Determine whether or not the goals in the commercial plan were achieved and, if they were not achieved, review all available information for an indication that the contractor has not made a good faith effort to comply with the plan, and document the results of the review;\n(3) If a determination is made to assess liquidated damages, in order to calculate and assess the amount of damages, the contracting officer shall ask the contractor to provide  \n(i) Contract numbers for the Government contracts subject to the plan;\n(ii) The total Government sales during the contractor  s fiscal year; and\n(iii) The amount of payments made under the Government contracts subject to that plan that contributed to the contractor  s total sales during the contractor  s fiscal year; and\n(4) When appropriate, assess liquidated damages on the Government  s behalf, based on the pro rata share of subcontracting attributable to the Government contracts. For example: The contractor  s total actual sales were $50 million and its actual subcontracting was $20 million. The Government  s total payments under contracts subject to the plan contributing to the contractor  s total sales were $5 million, which accounted for 10 percent of the contractor  s total sales. Therefore, the pro rata share of subcontracting attributable to the Government contracts would be 10 percent of $20 million, or $2 million. To continue the example, if the contractor failed to achieve its small business goal by 1 percent, the liquidated damages would be calculated as 1 percent of $2 million, or $20,000. The contracting officer shall make similar calculations for each category of small business where the contractor failed to achieve its goal and the sum of the dollars for all of the categories equals the amount of the liquidated damages to be assessed. A copy of the contracting officer  s final decision assessing liquidated damages shall be provided to other contracting officers with contracts subject to the commercial plan.\n(g) Liquidated damages shall be in addition to any other remedies that Government may have.\n(h) Every contracting officer with a contract that is subject to a commercial plan shall include in the contract file a copy of the approved plan and a copy of the final decision assessing liquidating damages, if applicable.\n19.706 Responsibilities of the cognizant administrative contracting officer.\nThe administrative contracting officer is responsible for assisting in evaluating subcontracting plans, and for monitoring, evaluating, and documenting contractor performance under the clause prescribed in 19.708 (b) and any subcontracting plan included in the contract. The contract administration office shall provide the necessary information and advice to support the contracting officer, as appropriate, by furnishing  \n(a) Documentation on the contractor  s performance and compliance with subcontracting plans under previous contracts;\n(b) Information on the extent to which the contractor is meeting the plan  s goals for subcontracting with eligible small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business, and women-owned small business concerns;\n(c) Information on whether the contractor  s efforts to ensure the participation of small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, small disadvantaged business, and women-owned small business concerns are in accordance with its subcontracting plan;\n(d) Information on whether the contractor is requiring its subcontractors to adopt similar subcontracting plans;\n(e) Immediate notice if, during performance, the contractor is failing to meet its commitments under the clause prescribed in 19.708 (b) or the subcontracting plan;\n(f) Immediate notice and rationale if, during performance, the contractor is failing to comply in good faith with the subcontracting plan; and\n(g) Immediate notice that performance under a contract is complete, that the goals were or were not met, and, if not met, whether there is any indication of a lack of a good faith effort to comply with the subcontracting plan.\n19.707 The Small Business Administration  s role in carrying out the program.\n(a) Under the program, the SBA may  \n(1) Assist both Government agencies and contractors in carrying out their responsibilities with regard to subcontracting plans;\n(2) Review (within 5 working days) any solicitation that meets the dollar threshold in 19.702 (a)(1) or (2) before the solicitation is issued;\n(3) Review (within 5 working days) before execution any negotiated contractual document requiring a subcontracting plan, including the plan itself, and submit recommendations to the contracting officer, which shall be advisory in nature; and\n(4) Evaluate compliance with subcontracting plans, either on a contract-by-contract basis, or, in the case of contractors having multiple contracts, on an aggregate basis.\n(b) The SBA is not authorized to  \n(1) Prescribe the extent to which any contractor or subcontractor shall subcontract,\n(2) Specify concerns to which subcontracts will be awarded, or\n(3) Exercise any authority regarding the administration of individual prime contracts or subcontracts.\n19.708 Contract clauses.\n(a) Insert the clause at 52.219-8 , Utilization of Small Business Concerns, in solicitations and contracts when the contract amount is expected to exceed the simplified acquisition threshold unless  \n(1) A personal services contract is contemplated (see 37.104 ); or\n(2) The contract, together with all of its subcontracts, will be performed entirely outside of the United States and its outlying areas.\n(b)(1) Insert the clause at 52.219-9 , Small Business Subcontracting Plan, in solicitations and contracts that offer subcontracting possibilities, are expected to exceed $650,000 ($1.5 million for construction of any public facility), and are required to include the clause at 52.219-8 , Utilization of Small Business Concerns, unless the acquisition is set aside or is to be accomplished under the 8(a) program. When  \n(i) Contracting by sealed bidding rather than by negotiation, the contracting officer shall use the clause with its Alternate I.\n(ii) Contracting by negotiation, and subcontracting plans are required with initial proposals as provided for in 19.705-2 (d), the contracting officer shall use the clause with its Alternate II.\n(iii) The contract action will not be reported in the Federal Procurement Data System pursuant to 4.606 (c)(5), or (c)(6), the contracting officer shall use the clause with its Alternate III.\n(2) Insert the clause at 52.219-16 , Liquidated Damages  Subcontracting Plan, in all solicitations and contracts containing the clause at 52.219-9 , Small Business Subcontracting Plan, or the clause with its Alternate I, II, or III.\n(c)(1) The contracting officer may, when contracting by negotiation, insert in solicitations and contracts a clause substantially the same as the clause at 52.219-10 , Incentive Subcontracting Program, when a subcontracting plan is required (see 19.702 ), and inclusion of a monetary incentive is, in the judgment of the contracting officer, necessary to increase subcontracting opportunities for small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, and women-owned small business concerns, and is commensurate with the efficient and economical performance of the contract; unless the conditions in paragraph (c)(3) of this section are applicable. The contracting officer may vary the terms of the clause as specified in paragraph (c)(2) of this section.\n(2) Various approaches may be used in the development of small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, and women-owned small business concerns  subcontracting incentives. They can take many forms, from a fully quantified schedule of payments based on actual subcontract achievement to an award-fee approach employing subjective evaluation criteria (see paragraph (c)(3) of this section). The incentive should not reward the contractor for results other than those that are attributable to the contractor  s efforts under the incentive subcontracting program.\n(3) As specified in paragraph (c)(2) of this section, the contracting officer may include small business, veteran-owned small business, service-disabled veteran-owned small business, HUBZone small business, and women-owned small business subcontracting as one of the factors to be considered in determining the award fee in a cost-plus-award-fee contract; in such cases, however, the contracting officer shall not use the clause at 52.219-10 , Incentive Subcontracting Program.");
register_book(&s, "|19|8|", "Contracting with the Small Business Adm", "Subpart 19.8  Contracting with the Small Business Administration (The 8(a) Program)\n19.800 General.\n(a) Section 8(a) of the Small Business Act ( 15 U.S.C. 637(a) ) established a program that authorizes the Small Business Administration (SBA) to enter into all types of contracts with other agencies and let subcontracts for performing those contracts to firms eligible for program participation. The SBA  s subcontractors are referred to as  8(a) contractors.  \n(b) Contracts may be awarded to the SBA for performance by eligible 8(a) firms on either a sole source or competitive basis.\n(c) When, acting under the authority of the program, the SBA certifies to an agency that the SBA is competent and responsible to perform a specific contract, the contracting officer is authorized, in the contracting officer  s discretion, to award the contract to the SBA based upon mutually agreeable terms and conditions.\n(d) The SBA refers to this program as the 8(a) Business Development (BD) Program.\n(e) The contracting officer shall comply with 19.203 before deciding to offer an acquisition to a small business concern under the 8(a) Program. For acquisitions above the simplified acquisition threshold, the contracting officer shall consider 8(a) set-asides or sole source awards before considering small business set-asides.\n(f) When SBA has delegated its 8(a) Program contract execution authority to an agency, the contracting officer must refer to its agency supplement or other policy directives for appropriate guidance.\n19.801 [Reserved]\n19.802 Selecting concerns for the 8(a) Program.\nSelecting concerns for the 8(a) Program is the responsibility of the SBA and is based on the criteria established in 13 CFR 124.101-112.\n19.803 Selecting acquisitions for the 8(a) Program.\nThrough their cooperative efforts, the SBA and an agency match the agency  s requirements with the capabilities of 8(a) concerns to establish a basis for the agency to contract with the SBA under the program. Selection is initiated in one of three ways  \n(a) The SBA advises an agency contracting activity through a search letter of an 8(a) firm  s capabilities and asks the agency to identify acquisitions to support the firm  s business plans. In these instances, the SBA will provide at least the following information in order to enable the agency to match an acquisition to the firm  s capabilities:\n(1) Identification of the concern and its owners.\n(2) Background information on the concern, including any and all information pertaining to the concern  s technical ability and capacity to perform.\n(3) The firm  s present production capacity and related facilities.\n(4) The extent to which contracting assistance is needed in the present and the future, described in terms that will enable the agency to relate the concern  s plans to present and future agency requirements.\n(5) If construction is involved, the request shall also include the following:\n(i) The concern  s capabilities in and qualifications for accomplishing various categories of maintenance, repair, alteration, and construction work in specific categories such as mechanical, electrical, heating and air conditioning, demolition, building, painting, paving, earth work, waterfront work, and general construction work.\n(ii) The concern  s capacity in each construction category in terms of estimated dollar value ( e.g., electrical, up to $100,000).\n(b) The SBA identifies a specific requirement for a particular 8(a) firm or firms and asks the agency contracting activity to offer the acquisition to the 8(a) Program for the firm(s). In these instances, in addition to the information in paragraph (a) of this section, the SBA will provide  \n(1) A clear identification of the acquisition sought; e.g., project name or number;\n(2) A statement as to how any additional needed equipment and real property will be provided in order to ensure that the firm will be fully capable of satisfying the agency  s requirements;\n(3) If construction, information as to the bonding capability of the firm(s); and\n(4) Either  \n(i) If sole source request  \n(A) The reasons why the firm is considered suitable for this particular acquisition; e.g., previous contracts for the same or similar supply or service; and\n(B) A statement that the firm is eligible in terms of NAICS code, business support levels, and business activity targets; or\n(ii) If competitive, a statement that at least two 8(a) firms are considered capable of satisfying the agency  s requirements and a statement that the firms are also eligible in terms of the NAICS code, business support levels, and business activity targets. If requested by the contracting activity, SBA will identify at least two such firms and provide information concerning the firms  capabilities.\n(c) Agencies may also review other proposed acquisitions for the purpose of identifying requirements which may be offered to the SBA. Where agencies independently, or through the self marketing efforts of an 8(a) firm, identify a requirement for the 8(a) Program, they may offer on behalf of a specific 8(a) firm, for the 8(a) Program in general, or for 8(a) competition.\n19.804 Evaluation, offering, and acceptance.\n19.804-1 Agency evaluation.\nIn determining the extent to which a requirement should be offered in support of the 8(a) Program, the agency should evaluate  \n(a) Its current and future plans to acquire the specific items or work that 8(a) contractors are seeking to provide, identified in terms of  \n(1) Quantities required or the number of construction projects planned; and\n(2) Performance or delivery requirements, including required monthly production rates, when applicable;\n(b) Its current and future plans to acquire items or work similar in nature and complexity to that specified in the business plan;\n(c) Problems encountered in previous acquisitions of the items or work from the 8(a) contractors and/or other contractors;\n(d) The impact of any delay in delivery;\n(e) Whether the items or work have previously been acquired using small business set-asides; and\n(f) Any other pertinent information about known 8(a) contractors, the items, or the work. This includes any information concerning the firms  capabilities. When necessary, the contracting agency shall make an independent review of the factors in 19.803 (a) and other aspects of the firms  capabilities which would ensure the satisfactory performance of the requirement being considered for commitment to the 8(a) Program.\n19.804-2 Agency offering.\n(a) After completing its evaluation, the agency must notify the SBA of the extent of its plans to place 8(a) contracts with the SBA for specific quantities of items or work. The notification must identify the time frames within which prime contract and subcontract actions must be completed in order for the agency to meet its responsibilities. The notification must also contain the following information applicable to each prospective contract:\n(1) A description of the work to be performed or items to be delivered, and a copy of the statement of work, if available.\n(2) The estimated period of performance.\n(3) The NAICS code that applies to the principal nature of the acquisition.\n(4) The anticipated dollar value of the requirement, including options, if any.\n(5) Any special restrictions or geographical limitations on the requirement (for construction, include the location of the work to be performed).\n(6) Any special capabilities or disciplines needed for contract performance.\n(7) The type of contract anticipated.\n(8) The acquisition history, if any, of the requirement, including the names and addresses of any small business contractors that have performed this requirement during the previous 24 months.\n(9) A statement that prior to the offering no solicitation for the specific acquisition has been issued as a small business, HUBZone, service-disabled veteran-owned small business set-aside, or a set-aside under the Women-Owned Small Business (WOSB) Program, and that no other public communication (such as a notice through the Governmentwide point of entry (GPE)) has been made showing the contracting agency  s clear intention to set-aside the acquisition for small business, HUBZone small business, service-disabled veteran-owned small business concerns, or a set-aside under the WOSB Program.\n(10) Identification of any particular 8(a) concern designated for consideration, including a brief justification, such as  \n(i) The 8(a) concern, through its own efforts, marketed the requirement and caused it to be reserved for the 8(a) Program; or\n(ii) The acquisition is a follow-on or renewal contract and the nominated concern is the incumbent.\n(11) Bonding requirements, if applicable.\n(12) Identification of all SBA field offices that have asked for the acquisition for the 8(a) Program.\n(13) A request, if appropriate, that a requirement with an estimated contract value under the applicable competitive threshold be awarded as an 8(a) competitive contract (see 19.805-1 (d)).\n(14) A request, if appropriate, that a requirement with a contract value over the applicable competitive threshold be awarded as a sole source contract (see 19.805-1 (b)).\n(15) Any other pertinent and reasonably available data.\n(b)(1) An agency offering a construction requirement for which no specific offeror is nominated should submit it to the SBA District Office for the geographical area where the work is to be performed.\n(2) An agency offering a construction requirement on behalf of a specific offeror should submit it to the SBA District Office servicing that concern.\n(3) Sole source requirements, other than construction, should be forwarded directly to the district office that services the nominated firm. If the contracting officer is not nominating a specific firm, the offering letter should be forwarded to the district office servicing the geographical area in which the contracting office is located.\n(c) All requirements for 8(a) competition, other than construction, should be forwarded to the district office servicing the geographical area in which the contracting office is located. All requirements for 8(a) construction competition should be forwarded to the district office servicing the geographical area in which all or the major portion of the construction is to be performed. All requirements, including construction, must be synopsized through the GPE. For construction, the synopsis must include the geographical area of the competition set forth in the SBA  s acceptance letter.\n19.804-3 SBA acceptance.\n(a) Upon receipt of the contracting agency  s offer, the SBA will determine whether to accept the requirement for the 8(a) Program. The SBA  s decision whether to accept the requirement will be transmitted to the contracting agency in writing within 10 working days of receipt of the offer if the contract is likely to exceed the simplified acquisition threshold and within 2 days of receipt if the contract is at or below the simplified acquisition threshold. The contracting agency may grant an extension of these time periods. If SBA does not respond to an offering letter within 10 days, the contracting activity may seek SBA  s acceptance through the Associate Administrator.\n(b) If the acquisition is accepted as a sole source, the SBA will advise the contracting activity of the 8(a) firm selected for negotiation. Generally, the SBA will accept a contracting activity  s recommended source.\n(c) For acquisitions not exceeding the simplified acquisition threshold, when the contracting activity makes an offer to the 8(a) Program on behalf of a specific 8(a) firm and does not receive a reply to its offer within 2 days, the contracting activity may assume the offer is accepted and proceed with award of an 8(a) contract.\n(d) As part of the acceptance process, SBA will review the appropriateness of the NAICS code designation assigned to the requirement by the contracting activity.\n(1) SBA will not challenge the NAICS code assigned to the requirement by the contracting activity if it is reasonable, even though other NAICS codes may also be reasonable.\n(2) If SBA and the contracting activity are unable to agree on a NAICS code designation for the requirement, SBA may refuse to accept the requirement for the 8(a) Program, appeal the contracting officer  s determination to the head of the agency pursuant to 19.810 , or appeal the NAICS code designation to the SBA Office of Hearings and Appeals under Subpart C of 13 CFR Part 134.\n19.804-4 Repetitive acquisitions.\nIn order for repetitive acquisitions to be awarded through the 8(a) Program, there must be separate offers and acceptances. This allows the SBA to determine  \n(a) Whether the requirement should be a competitive 8(a) award;\n(b) A nominated firm  s eligibility, whether or not it is the same firm that performed the previous contract;\n(c) The effect that contract award would have on the equitable distribution of 8(a) contracts; and\n(d) Whether the requirement should continue under the 8(a) Program.\n19.804-5 Basic ordering agreements.\n(a) The contracting activity must offer, and SBA must accept, each order under a basic ordering agreement (BOA) in addition to offering and accepting the BOA itself.\n(b) SBA will not accept for award on a sole-source basis any order that would cause the total dollar amount of orders issued under a specific BOA to exceed the competitive threshold amount in 19.805-1 .\n(c) Once an 8(a) concern  s program term expires, the concern otherwise exits the 8(a) Program, or becomes other than small for the NAICS code assigned under the BOA, SBA will not accept new orders for the concern.\n19.804-6 Indefinite delivery contracts.\n(a) Separate offers and acceptances must not be made for individual orders under multiple award, Federal Supply Schedule (FSS), multi-agency contracts or Governmentwide acquisition contracts. SBA  s acceptance of the original contract is valid for the term of the contract.\n(b) The requirements of 19.805-1 of this part do not apply to individual orders that exceed the competitive threshold as long as the original contract was competed.\n(c) An 8(a) concern may continue to accept new orders under a multiple award, Federal Supply Schedule (FSS), multi-agency contract or Governmentwide acquisition contract even after a concern  s program term expires, the concern otherwise exits the 8(a) Program, or the concern becomes other than small for the NAICS code assigned under the contract.\n19.805 Competitive 8(a).\n19.805-1 General.\n(a) Except as provided in paragraph (b) of this subsection, an acquisition offered to the SBA under the 8(a) Program shall be awarded on the basis of competition limited to eligible 8(a) firms if  \n(1) There is a reasonable expectation that at least two eligible and responsible 8(a) firms will submit offers and that award can be made at a fair market price; and\n(2) The anticipated total value of the contract, including options, will exceed $6.5 million for acquisitions assigned manufacturing North American Industry Classification System (NAICS) codes and $4 million for all other acquisitions.\n(b) Where an acquisition exceeds the competitive threshold, the SBA may accept the requirement for a sole source 8(a) award if  \n(1) There is not a reasonable expectation that at least two eligible and responsible 8(a) firms will submit offers at a fair market price; or\n(2) SBA accepts the requirement on behalf of a concern owned by an Indian tribe or an Alaska Native Corporation.\n(c) A proposed 8(a) requirement with an estimated value exceeding the applicable competitive threshold amount shall not be divided into several requirements for lesser amounts in order to use 8(a) sole source procedures for award to a single firm.\n(d) The SBA Associate Administrator for 8(a) Business Development (AA/BD) may approve an agency request for a competitive 8(a) award below the competitive thresholds. Such requests will be approved only on a limited basis and will be primarily granted where technical competitions are appropriate or where a large number of responsible 8(a) firms are available for competition. In determining whether a request to compete below the threshold will be approved, the AA/BD will, in part, consider the extent to which the requesting agency is supporting the 8(a) Program on a noncompetitive basis. The agency may include recommendations for competition below the threshold in the offering letter or by separate correspondence to the AA/BD.\n19.805-2 Procedures.\n(a) Offers shall be solicited from those sources identified in accordance with 19.804-3 .\n(b) The SBA will determine the eligibility of the firms for award of the contract. Eligibility will be determined by the SBA as of the time of submission of initial offers which include price. Eligibility is based on Section 8(a) Program criteria.\n(1) In sealed bid acquisitions, upon receipt of offers, the contracting officer will provide the SBA a copy of the solicitation, the estimated fair market price, and a list of offerors ranked in the order of their standing for award ( i.e., first low, second low, etc.) with the total evaluated price for each offer, differentiating between basic requirements and any options. The SBA will consider the eligibility of the first low offeror. If the first low offeror is not determined to be eligible, the SBA will consider the eligibility of the next low offeror until an eligible offeror is identified. The SBA will determine the eligibility of the firms and advise the contracting officer within 5 working days after its receipt of the list of bidders. Once eligibility has been established by the SBA, the successful offeror will be determined by the contracting activity in accordance with normal contracting procedures.\n(2) In negotiated acquisition, the SBA will determine eligibility when the successful offeror has been established by the agency and the contract transmitted for signature unless a referral has been made under 19.809 , in which case the SBA will determine eligibility at that point.\n(c) In any case in which a firm is determined to be ineligible, the SBA will notify the firm of that determination.\n(d) The eligibility of an 8(a) firm for a competitive 8(a) award may not be challenged or protested by another 8(a) firm or any other party as part of a solicitation or proposed contract award. Any party with information concerning the eligibility of an 8(a) firm to continue participation in the 8(a) Program may submit such information to the SBA in accordance with 13 CFR 124.517.\n19.806 Pricing the 8(a) contract.\n(a) The contracting officer shall price the 8(a) contract in accordance with Subpart 15.4 . If required by Subpart 15.4 , the SBA shall obtain certified cost or pricing data from the 8(a) contractor. If the SBA requests audit assistance to determine the proposed price to be fair and reasonable in a sole source acquisition, the contracting activity shall furnish it to the extent it is available.\n(b) An 8(a) contract, sole source or competitive, may not be awarded if the price of the contract results in a cost to the contracting agency which exceeds a fair market price.\n(c) If requested by the SBA, the contracting officer shall make available the data used to estimate the fair market price within 10 working days.\n(d) The negotiated contract price and the estimated fair market price are subject to the concurrence of the SBA. In the event of a disagreement between the contracting officer and the SBA, the SBA may appeal in accordance with 19.810 .\n19.807 Estimating fair market price.\n(a) The contracting officer shall estimate the fair market price of the work to be performed by the 8(a) contractor.\n(b) In estimating the fair market price for an acquisition other than those covered in paragraph (c) of this section, the contracting officer shall use cost or price analysis and consider commercial prices for similar products and services, available in-house cost estimates, data (including certified cost or pricing data) submitted by the SBA or the 8(a) contractor, and data obtained from any other Government agency.\n(c) In estimating a fair market price for a repeat purchase, the contracting officer shall consider recent award prices for the same items or work if there is comparability in quantities, conditions, terms, and performance times. The estimated price should be adjusted to reflect differences in specifications, plans, transportation costs, packaging and packing costs, and other circumstances. Price indices may be used as guides to determine the changes in labor and material costs. Comparison of commercial prices for similar items may also be used.\n19.808 Contract negotiation.\n19.808-1 Sole source.\n(a) The SBA may not accept for negotiation a sole-source 8(a) contract that exceeds $20 million unless the requesting agency has completed a justification in accordance with the requirements of 6.303 .\n(b) The SBA is responsible for initiating negotiations with the agency within the time established by the agency. If the SBA does not initiate negotiations within the agreed time and the agency cannot allow additional time, the agency may, after notifying the SBA, proceed with the acquisition from other sources.\n(c) The SBA should participate, whenever practicable, in negotiating the contracting terms. When mutually agreeable, the SBA may authorize the contracting activity to negotiate directly with the 8(a) contractor. Whether or not direct negotiations take place, the SBA is responsible for approving the resulting contract before award.\n19.808-2 Competitive.\nIn competitive 8(a) acquisitions subject to Part 15 , the contracting officer conducts negotiations directly with the competing 8(a) firms. Conducting competitive negotiations among 8(a) firms prior to SBA  s formal acceptance of the acquisition for the 8(a) Program may be grounds for SBA  s not accepting the acquisition for the 8(a) Program.\n19.809 Preaward considerations.\nThe contracting officer should request a preaward survey of the 8(a) contractor whenever considered useful. If the results of the preaward survey or other information available to the contracting officer raise substantial doubt as to the firm  s ability to perform, the contracting officer must refer the matter to SBA for Certificate of Competency consideration under Subpart 19.6 .\n19.810 SBA appeals.\n(a) The SBA Administrator may submit the following matters for determination to the agency head if the SBA and the contracting officer fail to agree on them:\n(1) The decision not to make a particular acquisition available for award under the 8(a) Program.\n(2) A contracting officer  s decision to reject a specific 8(a) firm for award of an 8(a) contract after SBA  s acceptance of the requirement for the 8(a) Program.\n(3) The terms and conditions of a proposed 8(a) contract, including the contracting activity  s NAICS code designation and estimate of the fair market price.\n(b) Notification of a proposed appeal to the agency head by the SBA must be received by the contracting officer within 5 working days after the SBA is formally notified of the contracting officer  s decision. The SBA will provide the agency Director for Small and Disadvantaged Business Utilization a copy of this notification of the intent to appeal. The SBA must send the written appeal to the head of the contracting activity within 15 working days of SBA  s notification of intent to appeal or the contracting activity may consider the appeal withdrawn. Pending issuance of a decision by the agency head, the contracting officer must suspend action on the acquisition. The contracting officer need not suspend action on the acquisition if the contracting officer makes a written determination that urgent and compelling circumstances that significantly affect the interests of the United States will not permit waiting for a decision.\n(c) If the SBA appeal is denied, the decision of the agency head shall specify the reasons for the denial, including the reasons why the selected firm was determined incapable of performance, if appropriate. The decision shall be made a part of the contract file.\n19.811 Preparing the contracts.\n19.811-1 Sole source.\n(a) The contract to be awarded by the agency to the SBA shall be prepared in accordance with agency procedures and in the same detail as would be required in a contract with a business concern. The contracting officer shall use the Standard Form 26 as the award form, except for construction contracts, in which case the Standard Form 1442 shall be used as required in 36.701 (a).\n(b) The agency shall prepare the contract that the SBA will award to the 8(a) contractor in accordance with agency procedures, as if the agency were awarding the contract directly to the 8(a) contractor, except for the following:\n(1) The award form shall cite 41 U.S.C. 253(c)(5) or 10 U.S.C. 2304(c)(5) (as appropriate) as the authority for use of other than full and open competition.\n(2) Appropriate clauses shall be included, as necessary, to reflect that the contract is between the SBA and the 8(a) contractor.\n(3) The following items shall be inserted by the SBA:\n(i) The SBA contract number.\n(ii) The effective date.\n(iii) The typed name of the SBA  s contracting officer.\n(iv) The signature of the SBA  s contracting officer.\n(v) The date signed.\n(4) The SBA will obtain the signature of the 8(a) contractor prior to signing and returning the prime contract to the contracting officer for signature. The SBA will make every effort to obtain signatures and return the contract, and any subsequent bilateral modification, to the contracting officer within a maximum of 10 working days.\n(c) Except in procurements where the SBA will make advance payments to its 8(a) contractor, the agency contracting officer may, as an alternative to the procedures in paragraphs (a) and (b) of this subsection, use a single contract document for both the prime contract between the agency and the SBA and its 8(a) contractor. The single contract document shall contain the information in paragraphs (b) (1), (2), and (3) of this subsection. Appropriate blocks on the Standard Form (SF) 26 or 1442 will be asterisked and a continuation sheet appended as a tripartite agreement which includes the following:\n(1) Agency acquisition office, prime contract number, name of agency contracting officer and lines for signature, date signed, and effective date.\n(2) The SBA office, the SBA contract number, name of the SBA contracting officer, and lines for signature and date signed.\n(3) Name and lines for the 8(a) subcontractor  s signature and date signed.\n(d) For acquisitions not exceeding the simplified acquisition threshold, the contracting officer may use the alternative procedures in paragraph (c) of this subsection with the appropriate simplified acquisition forms.\n19.811-2 Competitive.\n(a) The contract will be prepared in accordance with 14.408-1 (d), except that appropriate blocks on the Standard Form 26 or 1442 will be asterisked and a continuation sheet appended as a tripartite agreement which includes the following:\n(1) The agency contracting activity, prime contract number, name of agency contracting officer, and lines for signature, date signed, and effective date.\n(2) The SBA office, the SBA subcontract number, name of the SBA contracting officer and lines for signature and date signed.\n(b) The process for obtaining signatures shall be as specified in 19.811-1 (b)(4).\n19.811-3 Contract clauses.\n(a) The contracting officer shall insert the clause at 52.219-11 , Special 8(a) Contract Conditions, in contracts between the SBA and the agency when the acquisition is accomplished using the procedures of 19.811-1 (a) and (b).\n(b) The contracting officer shall insert the clause at 52.219-12 , Special 8(a) Subcontract Conditions, in contracts between the SBA and its 8(a) contractor when the acquisition is accomplished using the procedures of 19.811-1 (a) and (b).\n(c) The contracting officer shall insert the clause at 52.219-17 , Section 8(a) Award, in competitive solicitations and contracts when the acquisition is accomplished using the procedures of 19.805 and in sole source awards which utilize the alternative procedure in 19.811-1 (c).\n(d) The contracting officer shall insert the clause at 52.219-18 , Notification of Competition Limited to Eligible 8(a) Concerns, in competitive solicitations and contracts when the acquisition is accomplished using the procedures of 19.805 .\n(1) The clause at 52.219-18 with its Alternate I will be used when competition is to be limited to 8(a) concerns within one or more specific SBA districts pursuant to 19.804-2 .\n(2) The clause at 52.219-18 with its Alternate II will be used when the acquisition is for a product in a class for which the Small Business Administration has waived the nonmanufacturer rule (see 19.102 (f)(4) and (5)).\n(e) The contracting officer shall insert the clause at 52.219-14 , Limitations on Subcontracting, in any solicitation and contract resulting from this subpart. This includes multiple-award contracts when orders may be set aside for 8(a) concerns as described in 8.405-5 and 16.505 (b)(2)(i)(F).\n19.812 Contract administration.\n(a) The contracting officer shall assign contract administration functions, as required, based on the location of the 8(a) contractor (see Federal Directory of Contract Administration Services Components (available via the Internet at https://pubapp.dcma.mil/CASD/main.jsp )).\n(b) The agency shall distribute copies of the contract(s) in accordance with Part 4 . All contracts and modifications, if any, shall be distributed to both the SBA and the firm in accordance with the timeframes set forth in 4.201 .\n(c) To the extent consistent with the contracting activity  s capability and resources, 8(a) contractors furnishing requirements shall be afforded production and technical assistance, including, when appropriate, identification of causes of deficiencies in their products and suggested corrective action to make such products acceptable.\n(d) An 8(a) contract, whether in the base or an option year, must be terminated for convenience if the 8(a) concern to which it was awarded transfers ownership or control of the firm or if the contract is transferred or novated for any reason to another firm, unless the Administrator of the SBA waives the requirement for contract termination (13 CFR 124.515). The Administrator may waive the termination requirement only if certain conditions exist. Moreover, a waiver of the requirement for termination is permitted only if the 8(a) firm  s request for waiver is made to the SBA prior to the actual relinquishment of ownership or control, except in the case of death or incapacity where the waiver must be submitted within 60 days after such an occurrence. The clauses in the contract entitled  Special 8(a) Contract Conditions  and  Special 8(a) Subcontract Conditions  require the SBA and the 8(a) subcontractor to notify the contracting officer when ownership of the firm is being transferred. When the contracting officer receives information that an 8(a) contractor is planning to transfer ownership or control to another firm, the contracting officer must take action immediately to preserve the option of waiving the termination requirement. The contracting officer should determine the timing of the proposed transfer and its effect on contract performance and mission support. If the contracting officer determines that the SBA does not intend to waive the termination requirement, and termination of the contract would severely impair attainment of the agency  s program objectives or mission, the contracting officer should immediately notify the SBA in writing that the agency is requesting a waiver. Within 15 business days thereafter, or such longer period as agreed to by the agency and the SBA, the agency head must either confirm or withdraw the request for waiver. Unless a waiver is approved by the SBA, the contracting officer must terminate the contract for convenience upon receipt of a written request by the SBA. This requirement for a convenience termination does not affect the Government  s right to terminate for default if the cause for termination of an 8(a) contract is other than the transfer of ownership or control.");
register_book(&s, "|19|11|", "Price Evaluation Adjustment for Small D", "Subpart 19.11  Price Evaluation Adjustment for Small Disadvantaged Business Concerns\n19.1101 General.\nA price evaluation adjustment for small disadvantaged business concerns shall be applied as determined by the Department of Commerce (see 19.201 (b)). Joint ventures may qualify provided the requirements set forth in 13 CFR 124.1002(f) are met.\n19.1102 Applicability.\n(a) This subpart applies to the Department of Defense, National Aeronautics and Space Administration, and the U.S. Coast Guard. Civilian agencies do not have the statutory authority (originally authorized in the Federal Acquisition Streamlining Act of 1994 (Public Law 103-355, Sec. 7102)) for use of the Small Disadvantaged Business (SDB) price evaluation adjustment.\n(b) Use the price evaluation adjustment in competitive acquisitions in the authorized NAICS Industry Subsector.\n(c) Do not use the price evaluation adjustment in acquisitions  \n(1) That are less than or equal to the simplified acquisition threshold;\n(2) That are awarded pursuant to the 8(a) Program;\n(3) That are set aside for small business concerns;\n(4) That are set aside for HUBZone small business concerns;\n(5) That are set-aside for service-disabled veteran-owned small business concerns;\n(6) Where price is not a selection factor so that a price evaluation adjustment would not be considered ( e.g., architect/engineer acquisitions); or\n(7) Where all fair and reasonable offers are accepted ( e.g., the award of multiple award schedule contracts).\n19.1103 Procedures.\n(a) Give offers from small disadvantaged business concerns a price evaluation adjustment by adding the factor determined by the Department of Commerce to all offers, except  \n(1) Offers from small disadvantaged business concerns that have not waived the evaluation adjustment; or, if a price evaluation adjustment for small disadvantaged business concerns is authorized on a regional basis, offers from small disadvantaged business concerns, whose address is in such a region, that have not waived the evaluation adjustment; or\n(2) An otherwise successful offer from a historically black college or university or minority institution.\n(b) Apply the factor to a line item or a group of line items on which award may be made. Add other evaluation factors such as transportation costs or rent-free use of Government property to the offers before applying the price evaluation adjustment.\n(c) Do not evaluate offers using the price evaluation adjustment when it would cause award, as a result of this adjustment, to be made at a price that exceeds fair market price by more than the factor as determined by the Department of Commerce (see 19.202-6 (a)).\n19.1104 Contract clause.\nInsert the clause at 52.219-23 , Notice of Price Evaluation Adjustment for Small Disadvantaged Business Concerns, in solicitations and contracts when the circumstances in 19.1101 and 19.1102 apply. If a price evaluation adjustment is authorized on a regional basis, the clause shall be included in the solicitation even if the place of performance is outside an authorized region. The contracting officer shall insert the authorized price evaluation adjustment factor. The clause shall be used with its Alternate I when the contracting officer determines that there are no small disadvantaged business manufacturers that can meet the requirements of the solicitation. The clause shall be used with its Alternate II when a price evaluation adjustment is authorized on a regional basis.");
register_book(&s, "|19|12|", "Small Disadvantaged Business Participat", "Subpart 19.12  Small Disadvantaged Business Participation Program\n19.1201 General.\nThis subpart addresses the evaluation of the extent of participation of small disadvantaged business (SDB) concerns in performance of contracts in the North American Industry Classification System (NAICS) Industry Subsectors as determined by the Department of Commerce (see 19.201 (b)), and to the extent authorized by law. Two mechanisms are addressed in this subpart  \n(a) An evaluation factor or subfactor for the participation of SDB concerns in performance of the contract; and\n(b) An incentive subcontracting program for SDB concerns.\n19.1202 Evaluation factor or subfactor.\n19.1202-1 General.\nThe extent of participation of SDB concerns in performance of the contract, in the NAICS Industry Subsector as determined by the Department of Commerce, and to the extent authorized by law, shall be evaluated consistent with this section. Participation in performance of the contract includes joint ventures, teaming arrangements, and subcontracts. Credit under the evaluation factor or subfactor is not available to SDB concerns that receive a price evaluation adjustment under Subpart 19.11 . If an SDB concern waives the price evaluation adjustment at Subpart 19.11 , participation in performance of that contract includes the work expected to be performed by the SDB concern at the prime contract level.\n19.1202-2 Applicability.\n(a) Except as provided in paragraph (b) of this subsection, the extent of participation of SDB concerns in performance of the contract in the authorized NAICS Industry Subsector shall be evaluated in competitive, negotiated acquisitions expected to exceed $650,000 ($1.5 million for construction).\n(b) The extent of participation of SDB concerns in performance of the contract in the authorized NAICS Industry Subsector (see paragraph (a) of this subsection) shall not be evaluated in  \n(1) Small business set-asides (see subpart 19.5 ), HUBZone set-asides (see subpart 19.13 ), service-disabled veteran-owned small business set-asides (see subpart 19.14 ), economically disadvantaged women-owned small business set-asides, and set-asides for women-owned small business concerns eligible under the Women-Owned Small Business Program (see subpart 19.15 ).\n(2) 8(a) acquisitions (see Subpart 19.8 );\n(3) Negotiated acquisitions where the lowest price technically acceptable source selection process is used (see 15.101-2 ); or\n(4) Contract actions that will be performed entirely outside of the United States and its outlying areas.\n19.1202-3 Considerations in developing an evaluation factor or subfactor.\nIn developing an SDB participation evaluation factor or subfactor for the solicitation, agencies may consider  \n(a) The extent to which SDB concerns are specifically identified;\n(b) The extent of commitment to use SDB concerns (for example, enforceable commitments are to be weighted more heavily than non-enforceable ones);\n(c) The complexity and variety of the work SDB concerns are to perform;\n(d) The realism of the proposal;\n(e) Past performance of offerors in complying with subcontracting plan goals for SDB concerns and monetary targets for SDB participation; and\n(f) The extent of participation of SDB concerns in terms of the value of the total acquisition.\n19.1202-4 Procedures.\n(a) The solicitation shall describe the SDB participation evaluation factor or subfactor. The solicitation shall require offerors to provide, with their offers, targets, expressed as dollars and percentages of total contract value, in each of the applicable, authorized NAICS Industry Subsector, and a total target for SDB participation by the contractor, including joint venture partners, and team members, and a total target for SDB participation by subcontractors. The solicitation shall require an SDB offeror that waives the SDB price evaluation adjustment in the clause at 52.219-23 , Notice of Price Evaluation Adjustment for Small Disadvantaged Business Concerns, to provide with its offer a target for the work that it intends to perform as the prime contractor. The solicitation shall state that any targets will be incorporated into and become part of any resulting contract. Contractors with SDB participation targets shall be required to report SDB participation.\n(b) When an evaluation includes an SDB participation evaluation factor or subfactor that considers the extent to which SDB concerns are specifically identified, the SDB concerns considered in the evaluation shall be listed in the contract, and the contractor shall be required to notify the contracting officer of any substitutions of firms that are not SDB concerns.\n19.1203 Incentive subcontracting with small disadvantaged business concerns.\nThe contracting officer may encourage increased subcontracting opportunities in the NAICS Industry Subsector as determined by the Department of Commerce for SDB concerns in negotiated acquisitions by providing monetary incentives (see the clause at 52.219-26 , Small Disadvantaged Business Participation Program  Incentive Subcontracting, and 19.1204 (c)). Monetary incentives shall be based on actual achievement as compared to proposed monetary targets for SDB subcontracting. The incentive subcontracting program is separate and distinct from the establishment, monitoring, and enforcement of SDB subcontracting goals in a subcontracting plan.\n19.1204 Solicitation provisions and contract clauses.\n(a) The contracting officer may insert a provision substantially the same as the provision at 52.219-24 , Small Disadvantaged Business Participation Program  Targets, in solicitations that consider the extent of participation of SDB concerns in performance of the contract. The contracting officer may vary the terms of this provision consistent with the policies in 19.1202-4 .\n(b) The contracting officer shall insert the clause at 52.219-25 , Small Disadvantaged Business Participation Program  Disadvantaged Status and Reporting, in solicitations and contracts that consider the extent of participation of SDB concerns in performance of the contract.\n(c) The contracting officer may, when contracting by negotiation, insert in solicitations and contracts containing the clause at 52.219-25 , Small Disadvantaged Business Participation Program  Disadvantaged Status and Reporting, a clause substantially the same as the clause at 52.219-26 , Small Disadvantaged Business Participation Program  Incentive Subcontracting, when authorized (see 19.1203 ). The contracting officer may include an award fee provision in lieu of the incentive; in such cases, however, the contracting officer shall not use the clause at 52.219-26 .");
register_book(&s, "|19|13|", "Historically Underutilized Business Zon", "Subpart 19.13  Historically Underutilized Business Zone (HUBZone) Program\n19.1301 General.\n(a) The Historically Underutilized Business Zone (HUBZone) Act of 1997 ( 15 U.S.C. 631 note) created the HUBZone Program.\n(b) The purpose of the HUBZone Program is to provide Federal contracting assistance for qualified small business concerns located in historically underutilized business zones, in an effort to increase employment opportunities, investment, and economic development in those areas.\n19.1302 Applicability.\nThe procedures in this subpart apply to all Federal agencies that employ one or more contracting officers.\n19.1303 Status as a HUBZone small business concern.\n(a) Status as a HUBZone small business concern is determined by the Small Business Administration (SBA) in accordance with 13 CFR Part 126.\n(b) If the SBA determines that a concern is a HUBZone small business concern, it will issue a certification to that effect and will add the concern to the List of Qualified HUBZone Small Business Concerns at http://dsbs.sba.gov/dsbs/search/dsp_searchhubzone.cfm . Only firms on the list are HUBZone small business concerns, eligible for HUBZone preferences. HUBZone preferences apply without regard to the place of performance. Information on HUBZone small business concerns can also be obtained at www.sba.gov/hubzone or by writing to the Director for the HUBZone Program (Director/HUB) at U.S. Small Business Administration, 409 3rd Street, SW., Washington, DC 20416 or at hubzone@sba.gov.\n(c) A joint venture may be considered a HUBZone small business concern if it meets the criteria in the explanation of affiliates (see 19.101 ).\n(d) To be eligible for a HUBZone contract under this section, a HUBZone small business concern must be a HUBZone small business concern both at the time of its initial offer and at the time of contract award.\n(e) A HUBZone small business concern may submit an offer for supplies as a nonmanufacturer if it meets the requirements of the nonmanufacturer rule set forth at 13 CFR 121.406(b)(1) and if the small business manufacturer providing the end item is also a HUBZone small business concern.\n(1) There are no waivers to the nonmanufacturer rule for HUBZone contracts.\n(2) For HUBZone contracts at or below $25,000 in total value, a HUBZone small business concern may supply the end item of any manufacturer, including a large business, so long as the product acquired is manufactured or produced in the United States.\n19.1304 Exclusions.\nThis subpart does not apply to  \n(a) Requirements that can be satisfied through award to  \n(1) Federal Prison Industries, Inc. (see Subpart 8.6 ); or\n(2) Javits-Wagner-O  Day Act participating non-profit agencies for the blind or severely disabled (see Subpart 8.7 );\n(b) Orders under indefinite-delivery contracts (see subpart 16.5 ). (But see 16.505 (b)(2)(i)(F) for discretionary set-asides of orders);\n(c) Orders against Federal Supply Schedules (see subpart 8.4 ). (But see 8.405-5 for discretionary set-asides of orders);\n(d) Requirements currently being performed by an 8(a) participant or requirements SBA has accepted for performance under the authority of the 8(a) Program, unless SBA has consented to release the requirements from the 8(a) Program;\n(e) Requirements that do not exceed the micro-purchase threshold; or\n(f) Requirements for commissary or exchange resale items.\n19.1305 HUBZone set-aside procedures.\n(a) The contracting officer  \n(1) Shall comply with 19.203 before deciding to set aside an acquisition under the HUBZone Program;\n(2) May set aside acquisitions exceeding the micro-purchase threshold for competition restricted to HUBZone small business concerns when the requirements of paragraph (b) of this section can be satisfied; and\n(3) Shall consider HUBZone set-asides before considering HUBZone sole source awards (see 19.1306 ) or small business set-asides (see subpart 19.5 ).\n(b) To set aside an acquisition for competition restricted to HUBZone small business concerns, the contracting officer must have a reasonable expectation that  \n(1) Offers will be received from two or more HUBZone small business concerns; and\n(2) Award will be made at a fair market price.\n(c) If the contracting officer receives only one acceptable offer from a qualified HUBZone small business concern in response to a set aside, the contracting officer should make an award to that concern. If the contracting officer receives no acceptable offers from HUBZone small business concerns, the HUBZone set-aside shall be withdrawn and the requirement, if still valid, set aside for small business concerns, as appropriate (see 19.203 ).\n(d) The procedures at 19.202-1 and, except for acquisitions not exceeding the simplified acquisition threshold, at 19.402 apply to this section.\n(1) When the SBA intends to appeal a contracting officer  s decision to reject a recommendation of the SBA procurement center representative (or, if a procurement center representative is not assigned, see 19.402 (a)) to set aside an acquisition for competition restricted to HUBZone small business concerns, the SBA procurement center representative shall notify the contracting officer, in writing, of its intent within 5 business days of receiving the contracting officer  s notice of rejection.\n(2) Upon receipt of notice of SBA  s intent to appeal, the contracting officer shall suspend action on the acquisition unless the head of the contracting activity makes a written determination that urgent and compelling circumstances, which significantly affect the interests of the Government, exist.\n(3) Within 15 business days of SBA  s notification to the contracting officer, SBA must file its formal appeal with the head of the agency, or the appeal will be deemed withdrawn. The head of the agency shall reply to SBA within 15 business days of receiving the appeal. The decision of the head of the agency shall be final.\n19.1306 HUBZone sole source awards.\n(a) A contracting officer shall consider a contract award to a HUBZone small business concern on a sole source basis (see 6.302-5 (b)(5)) before considering a small business set-aside (see 19.203 and subpart 19.5 ), provided none of the exclusions at 19.1304 apply; and  \n(1) The contracting officer does not have a reasonable expectation that offers would be received from two or more HUBZone small business concerns;\n(2) The anticipated price of the contract, including options, will not exceed  \n(i) $6.5 million for a requirement within the North American Industry Classification System (NAICS) codes for manufacturing; or\n(ii) $4 million for a requirement within all other NAICS codes;\n(3) The requirement is not currently being performed by an 8(a) participant under the provisions of Subpart 19.8 or has been accepted as a requirement by SBA under Subpart 19.8 ;\n(4) The acquisition is greater than the simplified acquisition threshold (see Part 13 );\n(5) The HUBZone small business concern has been determined to be a responsible contractor with respect to performance; and\n(6) Award can be made at a fair and reasonable price.\n(b) The SBA has the right to appeal the contracting officer  s decision not to make a HUBZone sole source award.\n19.1307 Price evaluation preference for HUBZone small business concerns.\n(a) The price evaluation preference for HUBZone small business concerns shall be used in acquisitions conducted using full and open competition. The preference shall not be used  \n(1) Where price is not a selection factor so that a price evaluation preference would not be considered ( e.g., Architect/Engineer acquisitions); or\n(2) Where all fair and reasonable offers are accepted ( e.g., the award of multiple award schedule contracts).\n(b) The contracting officer shall give offers from HUBZone small business concerns a price evaluation preference by adding a factor of 10 percent to all offers, except  \n(1) Offers from HUBZone small business concerns that have not waived the evaluation preference; or\n(2) Otherwise successful offers from small business concerns.\n(c) The factor of 10 percent shall be applied on a line item basis or to any group of items on which award may be made. Other evaluation factors, such as transportation costs or rent-free use of Government property, shall be added to the offer to establish the base offer before adding the factor of 10 percent.\n(d) A concern that is both a HUBZone small business concern and a small disadvantaged business concern shall receive the benefit of both the HUBZone small business price evaluation preference and the small disadvantaged business price evaluation adjustment (see Subpart 19.11 ). Each applicable price evaluation preference or adjustment shall be calculated independently against an offeror  s base offer. These individual preference and adjustment amounts shall both be added to the base offer to arrive at the total evaluated price for that offer.\n(e) When the two highest rated offerors are a HUBZone small business concern and a large business, and the evaluated offer of the HUBZone small business concern is equal to the evaluated offer of the large business after considering the price evaluation preference, the contracting officer shall award the contract to the HUBZone small business concern.\n19.1308 Performance of work requirements (limitations on subcontracting) for general construction or construction by special trade contractors.\n(a) Before issuing a solicitation for general construction or construction by special trade contractors, the contracting officer shall determine if at least two HUBZone small business concerns can spend at least 50 percent of the cost of contract performance to be incurred for personnel on their own employees or subcontract employees of other HUBZone small business concerns.\n(b) The clause at 52.219-3 , Notice of HUBZone Set-Aside or Sole Source Award, or 52.219-4 , Notice of Price Evaluation Preference for HUBZone Small Business Concerns, shall be used, as applicable, with its Alternate I to waive the 50 percent requirement (see 19.1309 ) if at least two HUBZone small business concerns cannot meet the conditions of paragraph (a); but, the HUBZone prime contractor can still meet the following  \n(1) For general construction, at least 15 percent of the cost of the contract performance to be incurred for personnel using the concern  s employees; or\n(2) For construction by special trade contractors, at least 25 percent of the cost of contract performance to be incurred for personnel using the concern  s employees.\n(c) See 13 CFR 125.6 for definitions of terms used in paragraph (a) of this section.\n19.1309 Contract clauses.\n(a) The contracting officer shall insert the clause 52.219-3 , Notice of HUBZone Set-Aside or Sole Source Award, in solicitations and contracts for acquisitions that are set aside, or reserved for, or awarded on a sole source basis to, HUBZone small business concerns under 19.1305 or 19.1306 . This includes multiple-award contracts when orders may be set aside for HUBZone small business concerns as described in 8.405-5 and 16.505 (b)(2)(i)(F).\n(1) The contracting officer shall use the clause with its Alternate I to waive the 50 percent requirement if the conditions at 19.1308 (b) apply.\n(2) If a waiver is granted, the HUBZone small business prime contractor must still meet the performance of work requirements set forth in 13 CFR 125.6(c).\n(b) The contracting officer shall insert the clause at FAR 52.219-4 , Notice of Price Evaluation Preference for HUBZone Small Business Concerns, in solicitations and contracts for acquisitions conducted using full and open competition.\n(1) The contracting officer shall use the clause with its Alternate I to waive the 50 percent requirement if the conditions at 19.1308 (b) apply.\n(2) If a waiver is granted, the HUBZone small business prime contractor must still meet the performance of work requirements set forth in 13 CFR 125.6(c).");
register_book(&s, "|19|14|", "Service-Disabled Veteran-Owned Small Bu", "Subpart 19.14  Service-Disabled Veteran-Owned Small Business Procurement Program\n19.1401 General.\n(a) The Veterans Benefit Act of 2003 ( 15 U.S.C. 657f ) created the procurement program for small business concerns owned and controlled by service-disabled veterans (commonly referred to as the  Service-Disabled Veteran-owned Small Business (SDVOSB) Procurement Program  ).\n(b) The purpose of the Service-Disabled Veteran-Owned Small Business Program is to provide Federal contracting assistance to service-disabled veteran-owned small business concerns.\n19.1402 Applicability.\nThe procedures in this subpart apply to all Federal agencies that employ one or more contracting officers.\n19.1403 Status as a service-disabled veteran-owned small business concern.\n(a) Status as a service-disabled veteran-owned small business concern is determined in accordance with 13 CFR Parts 125.8 through 125.13; also see 19.307 .\n(b) At the time that a service-disabled veteran-owned small business concern submits its offer, it must represent to the contracting officer that it is a  \n(1) Service-disabled veteran-owned small business concern; and\n(2) Small business concern under the North American Industry Classification System (NAICS) code assigned to the procurement.\n(c) A joint venture may be considered a service-disabled veteran owned small business concern if  \n(1) At least one member of the joint venture is a service-disabled veteran-owned small business concern, and makes the representations in paragraph (b) of this section;\n(2) Each other concern is small under the size standard corresponding to the NAICS code assigned to the procurement;\n(3) The joint venture meets the requirements of paragraph 7 of the explanation of Affiliates in 19.101 ; and\n(4) The joint venture meets the requirements of 13 CFR 125.15(b).\n(d) Any service-disabled veteran-owned small business concern (nonmanufacturer) must meet the requirements in 19.102 (f) to receive a benefit under this program.\n19.1404 Exclusions.\nThis subpart does not apply to  \n(a) Requirements that can be satisfied through award to  \n(1) Federal Prison Industries, Inc. (see Subpart 8.6 );\n(2) Javits-Wagner-O  Day Act participating non-profit agencies for the blind or severely disabled (see Subpart 8.7 );\n(b) Orders under indefinite-delivery contracts (see subpart 16.5 ). (But see 16.505 (b)(2)(i)(F) for discretionary set-asides of orders);\n(c) Orders against Federal Supply Schedules (see subpart 8.4 ). (But see 8.405-5 for discretionary set-asides of orders); or\n(d) Requirements currently being performed by an 8(a) participant or requirements SBA has accepted for performance under the authority of the 8(a) Program, unless SBA has consented to release the requirements from the 8(a) Program.\n19.1405 Service-disabled veteran-owned small business set-aside procedures.\n(a) The contracting officer  \n(1) Shall comply with 19.203 before deciding to set aside an acquisition under the SDVOSB Program;\n(2) May set-aside acquisitions exceeding the micro-purchase threshold for competition restricted to SDVOSB concerns when the requirements of paragraph (b) of this section can be satisfied; and\n(3) Shall consider SDVOSB set-asides before considering SDVOSB sole source awards (see 19.1406 ) or small business set-asides (see subpart 19.5 ).\n(b) To set aside an acquisition for competition restricted to service-disabled veteran-owned small business concerns, the contracting officer must have a reasonable expectation that  \n(1) Offers will be received from two or more service-disabled veteran-owned small business concerns; and\n(2) Award will be made at a fair market price.\n(c) If the contracting officer receives only one acceptable offer from a service-disabled veteran-owned small business concern in response to a set-aside, the contracting officer should make an award to that concern. If the contracting officer receives no acceptable offers from service-disabled veteran-owned small business concerns, the service-disabled veteran-owned set-aside shall be withdrawn and the requirement, if still valid, set aside for small business concerns, as appropriate (see 19.203 ).\n(d) The procedures at 19.202-1 and, except for acquisitions not exceeding the simplified acquisition threshold, at 19.402 apply to this section. When the SBA intends to appeal a contracting officer  s decision to reject a recommendation of the SBA procurement center representative (or, if a procurement center representative is not assigned, see 19.402 (a)) to set aside an acquisition for competition restricted to service-disabled veteran-owned small business concerns, the SBA procurement center representative shall notify the contracting officer, in writing, of its intent within 5 working days of receiving the contracting officer  s notice of rejection. Upon receipt of notice of SBA  s intent to appeal, the contracting officer shall suspend action on the acquisition unless the head of the contracting activity makes a written determination that urgent and compelling circumstances, which significantly affect the interests of the Government, exist. Within 15 working days of SBA  s notification to the contracting officer, SBA shall file its formal appeal with the head of the contracting activity, or that agency may consider the appeal withdrawn. The head of the contracting activity shall reply to SBA within 15 working days of receiving the appeal. The decision of the head of the contracting activity shall be final.\n19.1406 Sole source awards to service-disabled veteran-owned small business concerns.\n(a) A contracting officer shall consider a contract award to a SDVOSB concern on a sole source basis (see 6.302-5 (b)(6)), before considering small business set-asides (see 19.203 and subpart 19.5 ) provided none of the exclusions of 19.1404 apply and  \n(1) The contracting officer does not have a reasonable expectation that offers would be received from two or more service-disabled veteran-owned small business concerns;\n(2) The anticipated award price of the contract, including options, will not exceed  \n(i) $6 million for a requirement within the NAICS codes for manufacturing; or\n(ii) $3.5 million for a requirement within any other NAICS code;\n(3) The requirement is not currently being performed by an 8(a) participant under the provisions of Subpart 19.8 or has been accepted as a requirement by SBA under Subpart 19.8 ;\n(4) The service-disabled veteran-owned small business concern has been determined to be a responsible contractor with respect to performance; and\n(5) Award can be made at a fair and reasonable price.\n(b) The SBA has the right to appeal the contracting officer  s decision not to make a service-disabled veteran-owned small business sole source award.\n19.1407 Contract clauses.\nThe contracting officer shall insert the clause 52.219-27 , Notice of Service-Disabled Veteran-Owned Small Business Set-Aside, in solicitations and contracts for acquisitions that are set aside or reserved for, or awarded on a sole source basis to, service-disabled veteran-owned small business concerns under 19.1405 and 19.1406 . This includes multiple-award contracts when orders may be set aside for service-disabled veteran-owned small business concerns as described in 8.405-5 and 16.505 (b)(2)(i)(F).");
register_book(&s, "|19|15|", "Women-Owned Small Business (WOSB) Progr", "Subpart 19.15  Women-Owned Small Business (WOSB) Program\n19.1500 General.\n(a) Section 8(m) of the Small Business Act ( 15 U.S.C. 637 (m)) created the Women-Owned Small Business (WOSB) Program.\n(b) The purpose of the WOSB Program is to ensure women-owned small business concerns have an equal opportunity to participate in Federal contracting and to assist agencies in achieving their women-owned small business participation goals (see 13 part CFR 127).\n(c) An economically disadvantaged women-owned small business (EDWOSB) concern or WOSB concern eligible under the WOSB Program is a subcategory of  women-owned small business concern  as defined in 2.101 .\n19.1501 Definition.\nWOSB Program Repository  means a secure, Web-based application that collects, stores, and disseminates documents to the contracting community and SBA, which verify the eligibility of a business concern for a contract to be awarded under the WOSB Program. \n19.1502 Applicability.\nThe procedures in this subpart apply to all Federal agencies that employ one or more contracting officers.\n19.1503 Status.\n(a) Status as an EDWOSB concern or WOSB concern eligible under the WOSB Program is determined in accordance with 13 CFR part 127.\n(b) The contracting officer shall verify that the offeror  \n(1) Is registered in the System for Award Management (SAM);\n(2) Is self-certified as an EDWOSB or WOSB concern in SAM; and\n(3) Has submitted documents verifying its eligibility at the time of initial offer to the WOSB Program Repository. The contract shall not be awarded until all required documents are received.\n(c)(1) An EDWOSB concern or WOSB concern eligible under the WOSB Program that has been certified by a SBA approved third party certifier, (which includes SBA certification under the 8(a) Program), must provide the following eligibility requirement documents  \n(i) The third-party certification;\n(ii) SBA  s WOSB Program Certification form (SBA Form 2413 for WOSB concerns eligible under the WOSB Program and SBA Form 2414 for EDWOSB concerns); and\n(iii) The joint venture agreement, if applicable.\n(2) An EDWOSB concern or WOSB concern eligible under the WOSB Program that has not been certified by an SBA approved third party certifier or by SBA under the 8(a) Program, must provide the following documents:\n(i) The U.S. birth certificate, naturalization documentation, or unexpired U.S. passport for each woman owner.\n(ii) The joint venture agreement, if applicable.\n(iii) For limited liability companies, articles of organization (also referred to as certificate of organization or articles of formation) and any amendments, and the operating agreement and any amendments.\n(iv) For corporations, articles of incorporation and any amendments, by-laws and any amendments, all issued stock certificates, including the front and back copies, signed in accord with the by-laws, stock ledger, and voting agreements, if any.\n(v) For partnerships, the partnership agreement and any amendments.\n(vi) For sole proprietorships, corporations, limited liability companies and partnerships if applicable, the assumed/fictitious name certificate(s).\n(vii) SBA  s WOSB Program Certification form (SBA Form 2413 for WOSB concerns eligible under the WOSB Program and SBA Form 2414 for EDWOSB concerns).\n(viii) For EDWOSB concerns, in addition to the above, the SBA Form 413, Personal Financial Statement, available to the public at http://www.sba.gov/tools/Forms/index.html , for each woman claiming economic disadvantage.\n(d)(1) A contracting officer may accept a concern  s self-certification as accurate for a specific procurement reserved for award under this subpart if  \n(i) The apparent successful WOSB eligible under the WOSB Program or EDWOSB offeror provided the required documents;\n(ii) There has been no protest or other credible information that calls into question the concern  s eligibility as an EDWOSB concern or WOSB concern eligible under the WOSB Program; and\n(iii) There has been no decision issued by SBA as a result of a current eligibility examination finding the concern did not qualify as an EDWOSB concern or WOSB concern eligible under the WOSB Program at the time it submitted its initial offer.\n(2) The contracting officer shall file a status protest in accordance with 19.308 if  \n(i) There is information that questions the eligibility of a concern; or\n(ii) The concern fails to provide all of the required documents to verify its eligibility.\n(e) If there is a decision issued by SBA as a result of a current eligibility examination finding that the concern did not qualify as an EDWOSB concern or WOSB concern eligible under the WOSB Program, the contracting officer may terminate the contract, and shall not exercise any option nor award further task or delivery orders. The contracting officer shall not count or include the award toward the small business accomplishments for an EDWOSB concern or WOSB concern eligible under the WOSB Program and must update FPDS from the date of award.\n(f) A joint venture may be considered an EDWOSB concern or WOSB concern eligible under the WOSB Program if it meets the requirements of 13 CFR 127.506.\n(g) An EDWOSB concern or WOSB concern eligible under the WOSB Program that is a non-manufacturer, as defined in 13 CFR 121.406(b), may submit an offer on a requirement set aside for an EDWOSB concern or a WOSB concern eligible under the WOSB Program with a NAICS code for supplies, if it meets the requirements under the non-manufacturer rule set forth in that regulation.\n19.1504 Exclusions.\nThis subpart does not apply to  \n(a) Requirements that an 8(a) concern is currently performing under the 8(a) Program or that SBA has accepted for performance under the authority of the 8(a) Program, unless SBA has consented to release the requirements from the 8(a) Program;\n(b) Requirements that can be satisfied through award to  \n(1) Federal Prison Industries, Inc. (see subpart 8.6 ); or\n(2) Javits-Wagner-O  Day Act participating non-profit agencies for the blind or severely disabled (see subpart 8.7 );\n(c) Orders under indefinite-delivery contracts (see subpart 16.5 ). (But see 16.505 (b)(2)(i)(F) for discretionary set-asides of orders); or\n(d) Orders against Federal Supply Schedules (see subpart 8.4 ). (But see 8.405-5 for discretionary set-asides of orders.)\n19.1505 Set-aside procedures.\n(a) The contracting officer  \n(1) Shall comply with 19.203 before deciding to set aside an acquisition under the WOSB Program.\n(2) May set aside acquisitions exceeding the micro-purchase threshold for competition restricted to EDWOSB concerns or WOSB concerns eligible under the WOSB Program in those NAICS codes in which SBA has determined that WOSB concerns eligible under the WOSB program are underrepresented or substantially underrepresented in Federal procurement, as specified on SBA  s Web site at http://www.sba.gov/WOSB .\n(b) For requirements in NAICS codes designated by SBA as underrepresented, a contracting officer may restrict competition to EDWOSB concerns if the contracting officer has a reasonable expectation based on market research that  \n(1) Two or more EDWOSB concerns will submit offers for the contract and;\n(2) Contract award will be made at a fair and reasonable price.\n(c) A contracting officer may restrict competition to WOSB concerns eligible under the WOSB Program (including EDWOSB concerns), for requirements in NAICS codes designated by SBA as substantially underrepresented if there is a reasonable expectation based on market research that  \n(1) Two or more WOSB concerns eligible under the WOSB Program (including EDWOSB concerns), will submit offers and;\n(2) Contract award may be made at a fair and reasonable price.\n(d) The contracting officer may make an award, if only one acceptable offer is received from a qualified EDWOSB concern or WOSB concern eligible under the WOSB Program.\n(e) The contracting officer must check whether the apparently successful offeror filed all the required eligibility documents, and file a status protest if any documents are missing. See 19.1503 (d)(2).\n(f) If no acceptable offers are received from an EDWOSB concern or WOSB concern eligible under the WOSB Program, the set-aside shall be withdrawn and the requirement, if still valid, must be considered for set aside in accordance with 19.203 and subpart 19.5 .\n(g) If the contracting officer rejects a recommendation by SBA  s Procurement Center Representative  \n(1) The contracting officer shall notify the procurement center representative as soon as practicable;\n(2) SBA shall notify the contracting officer of its intent to appeal the contracting officer  s decision no later than five business days after receiving notice of the contracting officer  s decision;\n(3) The contracting officer shall suspend further action regarding the procurement until the head of the agency issues a written decision on the appeal, unless the head of the agency makes a written determination that urgent and compelling circumstances which significantly affect the interests of the United States compel award of the contract;\n(4) Within 15 business days of SBA  s notification to the head of the contracting activity, SBA shall file a formal appeal to the head of the agency, or the appeal will be determined withdrawn; and\n(5) The head of the agency, or designee, shall specify in writing the reasons for a denial of an appeal brought under this section.\n19.1506 Contract clauses.\n(a) The contracting officer shall insert the clause 52.219-29 , Notice of Set-Aside for Economically Disadvantaged Women-owned Small Business Concerns, in solicitations and contracts for acquisitions that are set aside or reserved for economically disadvantaged women-owned small business (EDWOSB) concerns under 19.1505 (b). This includes multiple-award contracts when orders may be set aside for EDWOSB concerns as described in 8.405-5 and 16.505 (b)(2)(i)(F).\n(b) The contracting officer shall insert the clause 52.219-30 , Notice of Set-Aside for Women-Owned Small Business Concerns Eligible Under the Women-Owned Small Business Program, in solicitations and contracts for acquisitions that are set aside or reserved for women-owned small business (WOSB) concerns under 19.1505 (c). This includes multiple-award contracts when orders may be set aside for WOSB concerns eligible under the WOSB program as described in 8.405-5 and 16.505 (b)(2)(i)(F).\n*    *    *    *    *    *");
register_book(&s, "|22|2|", "Convict Labor", "Subpart 22.2  Convict Labor\n22.201 General.\n(a) Executive Order 11755, December 29, 1973, as amended by Executive Order 12608, September 9, 1987, and Executive Order 12943, December 13, 1994, states:  The development of the occupational and educational skills of prison inmates is essential to their rehabilitation and to their ability to make an effective return to free society. Meaningful employment serves to develop those skills. It is also true, however, that care must be exercised to avoid either the exploitation of convict labor or any unfair competition between convict labor and free labor in the production of goods and services.  The Executive order does not prohibit the contractor, in performing the contract, from employing  \n(1) Persons on parole or probation;\n(2) Persons who have been pardoned or who have served their terms;\n(3) Federal prisoners; or\n(4) Nonfederal prisoners authorized to work at paid employment in the community under the laws of a jurisdiction listed in the Executive order if  \n(i) The worker is paid or is in an approved work training program on a voluntary basis;\n(ii) Representatives of local union central bodies or similar labor union organizations have been consulted;\n(iii) Paid employment will not  \n(A) Result in the displacement of employed workers;\n(B) Be applied in skills, crafts, or trades in which there is a surplus of available gainful labor in the locality; or\n(C) Impair existing contracts for services;\n(iv) The rates of pay and other conditions of employment will not be less than those for work of a similar nature in the locality where the work is being performed; and\n(v) The Attorney General of the United States has certified that the work-release laws or regulations of the jurisdiction involved are in conformity with the requirements of Executive Order 11755, as amended.\n(b) Department of Justice regulations authorize the Director of the Bureau of Justice Assistance to exercise the power and authority vested in the Attorney General by the Executive order to certify and to revoke the certification of work-release laws or regulations (see 28 CFR 0.94-1(b)).\n22.202 Contract clause.\nInsert the clause at 52.222-3 , Convict Labor, in solicitations and contracts above the micro-purchase threshold, when the contract will be performed in the United States, Puerto Rico, the Northern Mariana Islands, American Samoa, Guam, or the U.S. Virgin Islands; unless  \n(a) The contract will be subject to the Walsh-Healey Public Contracts Act (see Subpart 22.6 ), which contains a separate prohibition against the employment of convict labor;\n(b) The supplies or services are to be purchased from Federal Prison Industries, Inc. (see Subpart 8.6 ); or\n(c) The acquisition involves the purchase, from any State prison, of finished supplies that may be secured in the open market or from existing stocks, as distinguished from supplies requiring special fabrication.");
register_book(&s, "|22|3|", "Contract Work Hours and Safety Standard", "Subpart 22.3  Contract Work Hours and Safety Standards Act\n22.300 Scope of subpart.\nThis subpart prescribes policies and procedures for applying the requirements of the Contract Work Hours and Safety Standards Act ( 40 U.S.C. 3701 et seq .) (the Act) to contracts that may require or involve laborers or mechanics. In this subpart, the term  laborers or mechanics  includes apprentices, trainees, helpers, watchmen, guards, firefighters, fireguards, and workmen who perform services in connection with dredging or rock excavation in rivers or harbors, but does not include any employee employed as a seaman.\n22.301 Statutory requirement.\nThe Act requires that certain contracts contain a clause specifying that no laborer or mechanic doing any part of the work contemplated by the contract shall be required or permitted to work more than 40 hours in any workweek unless paid for all such overtime hours at not less than 1 1/2 times the basic rate of pay.\n22.302 Liquidated damages and overtime pay.\n(a) When an overtime computation discloses under-payments, the responsible contractor or subcontractor must pay the affected employee any unpaid wages and pay liquidated damages to the Government. The contracting officer must assess liquidated damages at the rate of $10 per affected employee for each calendar day on which the employer required or permitted the employee to work in excess of the standard workweek of 40 hours without paying overtime wages required by the Act.\n(b) If the contractor or subcontractor fails or refuses to comply with overtime pay requirements of the Act and the funds withheld by Federal agencies for labor standards violations do not cover the unpaid wages due laborers and mechanics and the liquidated damages due the Government, make payments in the following order  \n(1) Pay laborers and mechanics the wages they are owed (or prorate available funds if they do not cover the entire amount owed); and\n(2) Pay liquidated damages.\n(c) If the head of an agency finds that the administratively determined liquidated damages due under paragraph (a) of this section are incorrect, or that the contractor or subcontractor inadvertently violated the Act despite the exercise of due care, the agency head may  \n(1) Reduce the amount of liquidated damages assessed for liquidated damages of $500 or less;\n(2) Release the contractor or subcontractor from the liability for liquidated damages of $500 or less; or\n(3) Recommend that the Secretary of Labor reduce or waive liquidated damages over $500.\n(d) After the contracting officer determines the liquidated damages and the contractor makes appropriate payments, disburse any remaining assessments in accordance with agency procedures.\n22.303 Administration and enforcement.\nThe procedures and reports required for construction contracts in Subpart 22.4 also apply to investigations of alleged violations of the Act on other than construction contracts.\n22.304 Variations, tolerances, and exemptions.\n(a) The Secretary of Labor, under 40 U.S.C. 3706 , upon the Secretary  s initiative or at the request of any Federal agency, may provide reasonable limitations and allow variations, tolerances, and exemptions to and from any or all provisions of the Act (see 29 CFR 5.15).\n(b) The Secretary of Labor may make variations, tolerances, and exemptions from the regulatory requirements of applicable parts of 29 CFR when the Secretary finds that such action is necessary and proper in the public interest or to prevent injustice and undue hardship (see 29 CFR 5.14).\n22.305 Contract clause.\nInsert the clause at 52.222-4 , Contract Work Hours and Safety Standards Act  Overtime Compensation, in solicitations and contracts (including, for this purpose, basic ordering agreements) when the contract may require or involve the employment of laborers or mechanics. However, do not include the clause in solicitations and contracts  \n(a) Valued at or below $150,000;\n(b) For commercial items;\n(c) For transportation or the transmission of intelligence;\n(d) To be performed outside the United States, Puerto Rico, American Samoa, Guam, the U.S. Virgin Islands, Johnston Island, Wake Island, and Outer Continental Shelf lands as defined in the Outer Continental Shelf Lands Act ( 43 U.S.C. 1331 ) (29 CFR 5.15);\n(e) For work to be done solely in accordance with the Walsh-Healey Public Contracts Act (see Subpart 22.6 );\n(f) For supplies that include incidental services that do not require substantial employment of laborers or mechanics; or\n(g) Exempt under regulations of the Secretary of Labor (29 CFR 5.15).");
register_book(&s, "|22|4|", "Labor Standards for Contracts Involving", "Subpart 22.4  Labor Standards for Contracts Involving Construction\n22.400 Scope of subpart.\nThis subpart implements the statutes which prescribe labor standards requirements for contracts in excess of $2,000 for construction, alteration, or repair, including painting and decorating, of public buildings and public works. (See definition of  Construction, alteration, or repair  in section 22.401 .) Labor relations requirements prescribed in other subparts of Part 22 may also apply.\n22.401 Definitions.\nAs used in this subpart  \nApprentice  means a person  \n(1) Employed and individually registered in a bona fide apprenticeship program registered with the U.S. Department of Labor, Employment and Training Administration, Office of Apprenticeship Training, Employer, and Labor Services (OATELS), or with a State Apprenticeship Agency recognized by OATELS; or\n(2) Who is in the first 90 days of probationary employment as an apprentice in an apprenticeship program, and is not individually registered in the program, but who has been certified by the OATELS or a State Apprenticeship Agency (where appropriate) to be eligible for probationary employment as an apprentice.\nConstruction, alteration, or repair  means all types of work done by laborers and mechanics employed by the construction contractor or construction subcontractor on a particular building or work at the site thereof, including without limitations  \n(1) Altering, remodeling, installation (if appropriate) on the site of the work of items fabricated off-site;\n(2) Painting and decorating;\n(3) Manufacturing or furnishing of materials, articles, supplies, or equipment on the site of the building or work;\n(4) Transportation of materials and supplies between the site of the work within the meaning of paragraphs (1)(i) and (ii) of the  site of the work  definition of this section, and a facility which is dedicated to the construction of the building or work and is deemed part of the site of the work within the meaning of paragraph (2) of the  site of work  definition of this section; and\n(5) Transportation of portions of the building or work between a secondary site where a significant portion of the building or work is constructed, which is part of the  site of the work  definition in paragraph (1)(ii) of this section, and the physical place or places where the building or work will remain (paragraph (1)(i) in the  site of the work  definition of this section).\nLaborers or mechanics.   \n(1) Means   \n(i) Workers, utilized by a contractor or subcontractor at any tier, whose duties are manual or physical in nature (including those workers who use tools or who are performing the work of a trade), as distinguished from mental or managerial;\n(ii) Apprentices, trainees, helpers, and, in the case of contracts subject to the Contract Work Hours and Safety Standards Act, watchmen and guards;\n(iii) Working foremen who devote more than 20 percent of their time during a workweek performing duties of a laborer or mechanic, and who do not meet the criteria of 29 CFR part 541, for the time so spent; and\n(iv) Every person performing the duties of a laborer or mechanic, regardless of any contractual relationship alleged to exist between the contractor and those individuals; and\n(2) Does not include workers whose duties are primarily executive, supervisory (except as provided in paragraph (1)(iii) of this definition), administrative, or clerical, rather than manual. Persons employed in a bona fide executive, administrative, or professional capacity as defined in 29 CFR part 541 are not deemed to be laborers or mechanics.\nPublic building or public work  means building or work, the construction, prosecution, completion, or repair of which, as defined in this section, is carried on directly by authority of, or with funds of, a Federal agency to serve the interest of the general public regardless of whether title thereof is in a Federal agency.\nSite of the work.    \n(1) Means  \n(i) The primary site of the work . The physical place or places where the construction called for in the contract will remain when work on it is completed; and\n(ii) The secondary site of the work, if any . Any other site where a significant portion of the building or work is constructed, provided that such site is  \n(A) Located in the United States; and\n(B) Established specifically for the performance of the contract or project;\n(2) Except as provided in paragraph (3) of this definition, includes fabrication plants, mobile factories, batch plants, borrow pits, job headquarters, tool yards, etc., provided  \n(i) They are dedicated exclusively, or nearly so, to performance of the contract or project; and\n(ii) They are adjacent or virtually adjacent to the  primary site of the work  as defined in paragraphs (1)(i) of  the secondary site of the work  as defined in paragraph (1)(ii) of this definition;\n(3) Does not include permanent home offices, branch plant establishments, fabrication plants, or tool yards of a contractor or subcontractor whose locations and continuance in operation are determined wholly without regard to a particular Federal contract or project. In addition, fabrication plants, batch plants, borrow pits, job headquarters, yards, etc., of a commercial or material supplier which are established by a supplier of materials for the project before opening of bids and not on the project site, are not included in the  site of the work.  Such permanent, previously established facilities are not a part of the  site of the work  , even if the operations for a period of time may be dedicated exclusively, or nearly so, to the performance of a contract.\nTrainee  means a person registered and receiving on-the-job training in a construction occupation under a program which has been approved in advance by the U.S. Department of Labor, Employment and Training Administration, Office of Apprenticeship Training, Employer, and Labor Services (OATELS), as meeting its standards for on-the-job training programs and which has been so certified by that Administration.\nWages  means the basic hourly rate of pay; any contribution irrevocably made by a contractor or subcontractor to a trustee or to a third person pursuant to a bona fide fringe benefit fund, plan, or program; and the rate of costs to the contractor or subcontractor which may be reasonably anticipated in providing bonafide fringe benefits to laborers and mechanics pursuant to an enforceable commitment to carry out a financially responsible plan or program, which was communicated in writing to the laborers and mechanics affected. The fringe benefits enumerated in the Davis-Bacon Act include medical or hospital care, pensions on retirement or death, compensation for injuries or illness resulting from occupational activity, or insurance to provide any of the foregoing; unemployment benefits; life insurance, disability insurance, sickness insurance, or accident insurance; vacation or holiday pay; defraying costs of apprenticeship or other similar programs; or other bona fide fringe benefits. Fringe benefits do not include benefits required by other Federal, State, or local law.\n22.402 Applicability.\n(a) Contracts for construction work.\n(1) The requirements of this subpart apply  \n(i) Only if the construction work is, or reasonably can be foreseen to be, performed at a particular site so that wage rates can be determined for the locality, and only to construction work that is performed by laborers and mechanics at the site of the work;\n(ii) To dismantling, demolition, or removal of improvements if a part of the construction contract, or if construction at that site is anticipated by another contract as provided in Subpart 37.3 ;\n(iii) To the manufacture or fabrication of construction materials and components conducted in connection with the construction and on the site of the work by the contractor or a subcontractor under a contract otherwise subject to this subpart; and\n(iv) To painting of public buildings or public works, whether performed in connection with the original construction or as alteration or repair of an existing structure.\n(2) The requirements of this subpart do not apply to  \n(i) The manufacturing of components or materials off the site of the work or their subsequent delivery to the site by the commercial supplier or materialman;\n(ii) Contracts requiring construction work that is so closely related to research, experiment, and development that it cannot be performed separately, or that is itself the subject of research, experiment, or development (see paragraph (b) of this section for applicability of this subpart to research and development contracts or portions thereof involving construction, alteration, or repair of a public building or public work);\n(iii) Employees of railroads operating under collective bargaining agreements that are subject to the Railway Labor Act; or\n(iv) Employees who work at contractors  or subcontractors  permanent home offices, fabrication shops, or tool yards not located at the site of the work. However, if the employees go to the site of the work and perform construction activities there, the requirements of this subpart are applicable for the actual time so spent, not including travel unless the employees transport materials or supplies to or from the site of the work.\n(b) Nonconstruction contracts involving some construction work.\n(1) The requirements of this subpart apply to construction work to be performed as part of nonconstruction contracts (supply, service, research and development, etc.) if  \n(i) The construction work is to be performed on a public building or public work;\n(ii) The contract contains specific requirements for a substantial amount of construction work exceeding the monetary threshold for application of the Davis-Bacon Act (the word  substantial  relates to the type and quantity of construction work to be performed and not merely to the total value of construction work as compared to the total value of the contract); and\n(iii) The construction work is physically or functionally separate from, and is capable of being performed on a segregated basis from, the other work required by the contract.\n(2) The requirements of this subpart do not apply if  \n(i) The construction work is incidental to the furnishing of supplies, equipment, or services (for example, the requirements do not apply to simple installation or alteration at a public building or public work that is incidental to furnishing supplies or equipment under a supply contract; however, if a substantial and segregable amount of construction, alteration, or repair is required, such as for installation of heavy generators or large refrigerator systems or for plant modification or rearrangement, the requirements of this subpart apply); or\n(ii) The construction work is so merged with non- construction work or so fragmented in terms of the locations or time spans in which it is to be performed, that it is not capable of being segregated as a separate contractual requirement.\n22.403 Statutory and regulatory requirements.\n22.403-1 Davis-Bacon Act.\nThe Davis-Bacon Act ( 40 U.S.C. 3141 et seq. ) provides that contracts in excess of $2,000 to which the United States or the District of Columbia is a party for construction, alteration, or repair (including painting and decorating) of public buildings or public works within the United States, shall contain a clause (see 52.222-6 ) that no laborer or mechanic employed directly upon the site of the work shall receive less than the prevailing wage rates as determined by the Secretary of Labor.\n22.403-2 Copeland Act.\nThe Copeland (Anti-Kickback) Act ( 18 U.S.C. 874 and 40 U.S.C. 3145 ) makes it unlawful to induce, by force, intimidation, threat of procuring dismissal from employment, or otherwise, any person employed in the construction or repair of public buildings or public works, financed in whole or in part by the United States, to give up any part of the compensation to which that person is entitled under a contract of employment. The Copeland Act also requires each contractor and subcontractor to furnish weekly a statement of compliance with respect to the wages paid each employee during the preceding week. Contracts subject to the Copeland Act shall contain a clause (see 52.222-10 ) requiring contractors and subcontractors to comply with the regulations issued by the Secretary of Labor under the Copeland Act.\n22.403-3 Contract Work Hours and Safety Standards Act.\nThe Contract Work Hours and Safety Standards Act ( 40 U.S.C. 3701 et seq. ) requires that certain contracts (see 22.305 ) contain a clause (see 52.222-4 ) specifying that no laborer or mechanic doing any part of the work contemplated by the contract shall be required or permitted to work more than 40 hours in any workweek unless paid for all additional hours at not less than 1 1/2 times the basic rate of pay (see 22.301 ).\n22.403-4 Department of Labor regulations.\n(a) Under the statutes referred to in this 22.403 and Reorganization Plan No. 14 of 1950 (3 CFR 1949-53 Comp, p. 1007), the Secretary of Labor has issued regulations in Title 29, Subtitle A, Code of Federal Regulations , prescribing standards and procedures to be observed by the Department of Labor and the Federal contracting agencies. Those standards and procedures applicable to contracts involving construction are implemented in this subpart.\n(b) The Department of Labor regulations include  \n(1) Part 1, relating to Davis-Bacon Act minimum wage rates;\n(2) Part 3, relating to the Copeland (Anti-Kickback) Act and requirements for submission of weekly statements of compliance and the preservation and inspection of weekly payroll records;\n(3) Part 5, relating to enforcement of the Davis-Bacon Act, Contract Work Hours and Safety Standards Act, and Copeland (Anti-Kickback) Act;\n(4) Part 6, relating to rules of practice for appealing the findings of the Administrator, Wage and Hour Division, in enforcement cases under the Davis-Bacon Act, Contract Work Hours and Safety Standards Act, Copeland (Anti-Kickback) Act, and Service Contract Act, and by which Administrative Law Judge hearings are held; and\n(5) Part 7, relating to rules of practice by which contractors and other interested parties may appeal to the Department of Labor Administrative Review Board, decisions issued by the Administrator, Wage and Hour Division, or administrative law judges under the Davis-Bacon Act, Contract Work Hours and Safety Standards Act, or Copeland (Anti-Kickback) Act.\n(c) Refer all questions relating to the application and interpretation of wage determinations (including the classifications therein) and the interpretation of the Department of Labor regulations in this subsection to the Administrator, Wage and Hour Division.\n22.404 Davis-Bacon Act wage determinations.\nThe Department of Labor is responsible for issuing wage determinations reflecting prevailing wages, including fringe benefits. The wage determinations apply only to those laborers and mechanics employed by a contractor upon the site of the work including drivers who transport to or from the site materials and equipment used in the course of contract operations. Determinations are issued for different types of construction, such as building, heavy, highway, and residential (referred to as rate schedules), and apply only to the types of construction designated in the determination.\n22.404-1 Types of wage determinations.\n(a) General wage determinations.\n(1) A general wage determination contains prevailing wage rates for the types of construction designated in the determination, and is used in contracts performed within a specified geographical area. General wage determinations contain no expiration date and remain valid until modified, superseded, or canceled by the Department of Labor. Once incorporated in a contract, a general wage determination normally remains effective for the life of the contract, unless the contracting officer exercises an option to extend the term of the contract (see 22.404-12 ). These determinations shall be used whenever possible. They are issued at the discretion of the Department of Labor either upon receipt of an agency request or on the Department of Labor  s own initiative.\n(2) General wage determinations are published on the WDOL website. General wage determinations are effective on the publication date of the wage determination or upon receipt of the wage determination by the contracting agency, whichever occurs first.  Publication  within the meaning of this section shall occur on the first date the wage determination is published on the WDOL. Archived Davis-Bacon Act general wage determinations that are no longer current may be accessed in the  Archived DB WD  database on WDOL for information purposes only. Contracting officers may not use an archived wage determination in a contract action without obtaining prior approval of the Department of Labor. To obtain prior approval, contact the Department of Labor, Wage and Hour Division, using http://www.wdol.gov , or contact the procurement agency labor advisor listed on http://www.wdol.gov .\n(b) Project wage determinations . A project wage determination is issued at the specific request of a contracting agency. It is used only when no general wage determination applies, and is effective for 180 calendar days from the date of the determination. However, if a determination expires before contract award, it may be possible to obtain an extension to the 180-day life of the determination (see 22.404-5 (b)(2)). Once incorporated in a contract, a project wage determination normally remains effective for the life of the contract, unless the contracting officer exercises an option to extend the term of the contract (see 22.404-12 ).\n22.404-2 General requirements.\n(a) The contracting officer must incorporate only the appropriate wage determinations in solicitations and contracts and must designate the work to which each determination or part thereof applies. The contracting officer must not include project wage determinations in contracts or options other than those for which they are issued. When exercising an option to extend the term of a contract, the contracting officer must select the most current wage determination(s) from the same schedule(s) as the wage determination(s) incorporated into the contract.\n(b) If the wage determination is a general wage determination or a project wage determination containing more than one rate schedule, the contracting officer shall either include only the rate schedules that apply to the particular types of construction (building, heavy, highway, etc.) or include the entire wage determination and clearly indicate the parts of the work to which each rate schedule shall be applied. Inclusion by reference is not permitted.\n(c) The Wage and Hour Division has issued the following general guidelines for use in selecting the proper schedule(s) of wage rates:\n(1) Building construction is generally the construction of sheltered enclosures with walk-in access, for housing persons, machinery, equipment, or supplies. It typically includes all construction of such structures, installation of utilities and equipment (both above and below grade level), as well as incidental grading, utilities and paving, unless there is an established area practice to the contrary.\n(2) Residential construction is generally the construction, alteration, or repair of single family houses or apartment buildings of no more than four (4) stories in height, and typically includes incidental items such as site work, parking areas, utilities, streets and sidewalks, unless there is an established area practice to the contrary.\n(3) Highway construction is generally the construction, alteration, or repair of roads, streets, highways, runways, taxiways, alleys, parking areas, and other similar projects that are not incidental to  building,    residential,  or  heavy  construction.\n(4) Heavy construction includes those projects that are not properly classified as either  building,    residential,  or  highway,  and is of a catch-all nature. Such heavy projects may sometimes be distinguished on the basis of their individual characteristics, and separate schedules issued ( e.g. ,  dredging,    water and sewer line,    dams,    flood control,  etc.).\n(5) When the nature of a project is not clear, it is necessary to look at additional factors, with primary consideration given to locally established area practices. If there is any doubt as to the proper application of wage rate schedules to the type or types of construction involved, guidance shall be sought before the opening of bids, or receipt of best and final offers, from the Administrator, Wage and Hour Division. Further examples are contained in Department of Labor All Agency Memoranda Numbers 130 and 131.\n22.404-3 Procedures for requesting wage determinations.\n(a) General wage determinations . If there is a general wage determination on the WDOL website applicable to the project, the agency may use it without notifying the Department of Labor. When necessary, a request for a general wage determination may be made by submitting Standard Form (SF) 308 , Request for Determination and Response to Request (see 53.301-308), to the Administrator, Wage and Hour Division, Attention: Branch of Construction Contract Wage Determinations, 200 Constitution Avenue, NW, Washington, DC 20210.\n(b) Project wage determinations. If a general wage determination is not available on WDOL, a contracting agency shall submit requests for project wage determinations on SF 308 to the Department of Labor. The requests shall include the following information:\n(1) The location, including the county (or other civil subdivision) and State in which the proposed project is located.\n(2) The name of the project and a sufficiently detailed description of the work to indicate the types of construction involved ( e.g., building, heavy, highway, residential, or other type).\n(3) Any available pertinent wage payment information, unless wage patterns in the area are clearly established.\n(4) The estimated cost of each project.\n(5) All the classifications of laborers and mechanics likely to be employed.\n(c) Time for submission of requests .\n(1) The time required by the Department of Labor for processing requests for project wage determinations varies according to the facts and circumstances in each case. An agency should expect the processing to take at least 30 days. Accordingly, agencies should submit requests for project wage determinations for the primary site of the work to the Department of Labor at least 45 days (60 days if possible) before issuing the solicitation or exercising an option to extend the term of a contract.\n(2) Agencies should promptly submit to the Department of Labor an offeror  s request for a project wage determination for a secondary site of the work.\n(d) Review of wage determinations . Immediately upon receipt, the contracting agency shall examine the wage determination and inform the Department of Labor of any changes necessary or appropriate to correct errors. Private parties requesting changes should be advised to submit their requests to the Department of Labor.\n22.404-4 Solicitations issued without wage determinations for the primary site of the work.\n(a) If a solicitation is issued before the wage determination for the primary site of the work is obtained, a notice shall be included in the solicitation that the schedule of minimum wage rates to be paid under the contract will be issued as an amendment to the solicitation.\n(b) In sealed bidding, bids may not be opened until a reasonable time after the wage determination for the primary site of the work has been furnished to all bidders.\n(c) In negotiated acquisitions, the contracting officer may open proposals and conduct negotiations before obtaining the wage determination for the primary site of the work. However, the contracting officer shall incorporate the wage determination for the primary site of the work into the solicitation before submission of best and final offers.\n22.404-5 Expiration of project wage determinations.\n(a) The contracting officer shall make every effort to ensure that contract award is made before expiration of the project wage determination included in the solicitation.\n(b) The following procedure applies when contracting by sealed bidding:\n(1) If a project wage determination for the primary site of the work expires before bid opening, or if it appears before bid opening that a project wage determination may expire before award, the contracting officer shall request a new determination early enough to ensure its receipt before bid opening. If necessary, the contracting officer shall postpone the bid opening date to allow a reasonable time to obtain the determination, amend the solicitation to incorporate the new determination, and permit bidders to amend their bids. If the new determination does not change the wage rates and would not warrant amended bids, the contracting officer shall amend the solicitation to include the number and date of the new determination.\n(2) If a project wage determination for the primary site of the work expires after bid opening but before award, the contracting officer shall request an extension of the project wage determination expiration date from the Administrator, Wage and Hour Division. The request for extension shall be supported by a written finding, which shall include a brief statement of factual support, that the extension is necessary and proper in the public interest to prevent injustice or undue hardship or to avoid serious impairment of the conduct of Government business. If necessary, the contracting officer shall delay award to permit either receipt of the extension or receipt and processing of a new determination. If the request is granted, the contracting officer shall award the contract and modify it to apply the extended expiration date to the already incorporated project wage determination. (See 43.103 (b)(1).) If the request is denied, the Administrator will proceed to issue a new project wage determination. Upon receipt, the contracting officer shall process the new determination as follows:\n(i) If If the new determination for the primary site of the work changes any wage rates for classifications to be used in the contract, the contracting officer may cancel the solicitation only in accordance with 14.404-1 . Otherwise the contracting officer shall award the contract and incorporate the new determination to be effective on the date of contract award. The contracting officer shall equitably adjust the contract price for any increased or decreased cost of performance resulting from any changed wage rates.\n(ii) If the new determination for the primary site of the work does not change any wage rates, the contracting officer shall award the contract and modify it to include the number and date of the new determination. (See 43.103 (b)(1).)\n(c) The following procedure applies when contracting by negotiation:\n(1) If a project wage determination will or does expire before contract award, the contracting officer shall request a new wage determination from the Department of Labor. If necessary, the contracting officer shall delay award while the new determination is obtained and processed.\n(2) The contracting officer need not delay opening and reviewing proposals or discussing them with the offerors while a new determination for the primary site of the work is being obtained. The contracting officer shall request offerors to extend the period for acceptance of any proposal if that period expires or may expire before receipt and full processing of the new determination.\n(3) If the new determination for the primary site of the work changes any wage rates, the contracting officer shall amend the solicitation to incorporate the new determination, and furnish the wage rate information to all prospective offerors that were sent a solicitation if the closing date for receipt of proposals has not yet occurred, or to all offerors that have not been eliminated from the competition if the closing date has passed. All offerors to whom wage rate information has been furnished shall be given reasonable opportunity to amend their proposals.\n(4) If the new determination for the primary site of the work does not change any wage rates, the contracting officer shall amend the solicitation to include the number and date of the new determination and award the contract.\n22.404-6 Modifications of wage determinations.\n(a) General.\n(1) The Department of Labor may modify a wage determination to make it current by specifying only the items being changed or by reissuing the entire determination with changes incorporated.\n(2) All project wage determination modifications expire on the same day as the original determination. The need to include a modification of a project wage determination for the primary site of the work in a solicitation is determined by the time of receipt of the modification by the contracting agency. Therefore, the contracting agency must annotate the modification of the project wage determination with the date and time immediately upon receipt.\n(3) The need for inclusion of the modification of a general wage determination for the primary site of the work in a solicitation is determined by the date the modified wage determination is published on the WDOL, or by the date the agency receives actual written notice of the modification from the Department of Labor, whichever occurs first. (Note the distinction between receipt by the agency (modification is effective) and receipt by the contracting officer, which may occur later.) During the course of the solicitation, the contracting officer shall monitor the WDOL website to determine whether the applicable wage determination has been revised. Revisions published on the WDOL website or otherwise communicated to the contracting officer within the timeframes prescribed at 22.404-6 (b) and (c) are applicable and must be included in the resulting contract. Monitoring can be accomplished by use of the WDOL website  s  Alert Service  .\n(b) The following applies when contracting by sealed bidding:\n(1) A written action modifying a wage determination shall be effective if:\n(i) It is received by the contracting agency, or is published on the WDOL, 10 or more calendar days before the date of bid opening; or\n(ii) It is received by the contracting agency, or is published on the WDOL, less than 10 calendar days before the date of bid opening, unless the contracting officer finds that there is not reasonable time available before bid opening to notify the prospective bidders. (If the contracting officer finds that there is not reasonable time to notify bidders, a written report of the finding shall be placed in the contract file and shall be made available to the Department of Labor upon request.)\n(2) All written actions modifying wage determinations received by the contracting agency after bid opening, or modifications to general wage determinations published on the WDOL after bid opening, shall not be effective and shall not be included in the solicitation (but see paragraph (b)(6) of this subsection).\n(3) If an effective modification of the wage determination for the primary site of the work is received by the contracting officer before bid opening, the contracting officer shall postpone the bid opening, if necessary, to allow a reasonable time to amend the solicitation to incorporate the modification and permit bidders to amend their bids. If the modification does not change the wage rates and would not warrant amended bids, the contracting officer shall amend the solicitation to include the number and date of the modification.\n(4) If an effective modification of the wage determination for the primary site of the work is received by the contracting officer after bid opening, but before award, the contracting officer shall follow the procedures in 22.404-5 (b)(2)(i) or (ii).\n(5) If an effective modification is received by the contracting officer after award, the contracting officer shall modify the contract to incorporate the wage modification retroactive to the date of award and equitably adjust the contract price for any increased or decreased cost of performance resulting from any changed wage rates. If the modification does not change any wage rates and would not warrant contract price adjustment, the contracting officer shall modify the contract to include the number and date of the modification.\n(6) If an award is not made within 90 days after bid opening, any modification to a general wage determination which is published on the WDOL before award, shall be effective for any resultant contract unless an extension of the 90-day period is obtained from the Administrator, Wage and Hour Division. An agency head may request such an extension from the Administrator. The request must be supported by a written finding, which shall include a brief statement of factual support, that the extension is necessary and proper in the public interest to prevent injustice, undue hardship, or to avoid serious impairment in the conduct of Government business. The contracting officer shall follow the procedures in 22.404-5 (b)(2).\n(c) The following applies when contracting by negotiation:\n(1) All written actions modifying wage determinations received by the contracting agency before contract award, or modifications to general wage determinations published on the WDOL before award, shall be effective.\n(2) If an effective wage modification is received by the contracting officer before award, the contracting officer shall follow the procedures in 22.404-5 (c)(3) or (4).\n(3) If an effective wage modification is received by the contracting officer after award, the contracting officer shall follow the procedures in 22.404-6 (b)(5).\n(d) The following applies when modifying a contract to exercise an option to extend the term of a contract:\n(1) A modified wage determination is effective if  \n(i) The contracting agency receives a written action from the Department of Labor prior to exercise of the option, or within 45 days after submission of a wage determination request ( 22.404-3 (c)), whichever is later; or\n(ii) The Department of Labor publishes the modification to a general wage determination on the WDOL before exercise of the option.\n(2) If the contracting officer receives an effective modified wage determination either before or after execution of the contract modification to exercise the option, the contracting officer must modify the contract to incorporate the modified wage determination, and any changed wage rates, effective as of the date that the option to extend was effective.\n22.404-7 Correction of wage determinations containing clerical errors.\nUpon the Department of Labor  s own initiative or at the request of the contracting agency, the Administrator, Wage and Hour Division, may correct any wage determination found to contain clerical errors. Such corrections will be effective immediately, and will apply to any solicitation or active contract. Before contract award, the contracting officer must follow the procedures in 22.404-5 (b)(1) or (2)(i) or (ii) in sealed bidding, and the procedures in 22.404-5 (c)(3) or (4) in negotiations. After contract award, the contracting officer must follow the procedures at 22.404-6 (b)(5), except that for contract modifications to exercise an option to extend the term of the contract, the contracting officer must follow the procedures at 22.404-6 (d)(2).\n22.404-8 Notification of improper wage determination before award.\n(a) The following written notifications by the Department of Labor shall be effective immediately without regard to 22.404-6 if received by the contracting officer prior to award:\n(1) A solicitation includes the wrong wage determination or the wrong rate schedule; or\n(2) A wage determination is withdrawn by the Administrative Review Board.\n(b) In sealed bidding, the contracting officer shall proceed in accordance with the following:\n(1) If the notification of an improper wage determination for the primary site of the work reaches the contracting officer before bid opening, the contracting officer shall postpone the bid opening date, if necessary, to allow a reasonable time to  \n(i) Obtain the appropriate determination if a new wage determination is required;\n(ii) Amend the solicitation to incorporate the determination (or rate schedule); and\n(iii) Permit bidders to amend their bids. If the appropriate wage determination does not change any wage rates and would not warrant amended bids, the contracting officer shall amend the solicitation to include the number and date of the new determination.\n(2) If the notification of an improper wage determination for the primary site of the work reaches the contracting officer after bid opening but before award, the contracting officer shall delay awarding the contract, if necessary, and if required, obtain the appropriate wage determination. The appropriate wage determination shall be processed in accordance with 22.404-5 (b)(2)(i) or (ii).\n(c) In negotiated acquisitions, the contracting officer shall delay award, if necessary, and process the notification of an improper wage determination for the primary site of the work in the manner prescribed for a new wage determination at 22.404-5 (c)(3).\n22.404-9 Award of contract without required wage determination.\n(a) If a contract is awarded without the required wage determination ( i.e., incorporating no determination, containing a clearly inapplicable general wage determination, or containing a project determination which is inapplicable because of an inaccurate description of the project or its location), the contracting officer shall initiate action to incorporate the required determination in the contract immediately upon discovery of the error. If a required wage determination (valid determination in effect on the date of award) is not available, the contracting officer shall expeditiously request a wage determination from the Department of Labor, including a statement explaining the circumstances and giving the date of the contract award.\n(b) The contracting officer shall  \n(1) Modify the contract to incorporate the required wage determination (retroactive to the date of award) and equitably adjust the contract price if appropriate; or\n(2) Terminate the contract.\n22.404-10 Posting wage determinations and notice.\nThe contractor must keep a copy of the applicable wage determination (and any approved additional classifications) posted at the site of the work in a prominent place where the workers can easily see it. The contracting officer shall furnish to the contractor, Department of Labor Form WH-1321, Notice to Employees Working on Federal and Federally Financed Construction Projects, for posting with the wage rates. The name, address, and telephone number of the Government officer responsible for the administration of the contract shall be indicated in the poster to inform workers to whom they may submit complaints or raise questions concerning labor standards.\n22.404-11 Wage determination appeals.\nThe Secretary of Labor has established an Administrative Review Board which decides appeals of final decisions made by the Department of Labor concerning Davis-Bacon Act wage determinations. A contracting agency or other interested party may file a petition for review under the procedures in 29 CFR Part 7 if reconsideration by the Administrator has been sought pursuant to 29 CFR 1.8 and denied.\n22.404-12 Labor standards for contracts containing construction requirements and option provisions that extend the term of the contract.\n(a) Each time the contracting officer exercises an option to extend the term of a contract for construction, or a contract that includes substantial and segregable construction work, the contracting officer must modify the contract to incorporate the most current wage determination.\n(b) If a contract with an option to extend the term of the contract has indefinite-delivery or indefinite-quantity construction requirements, the contracting officer must incorporate the wage determination incorporated into the contract at the exercise of the option into task orders issued during that option period. The wage determination will be effective for the complete period of performance of those task orders without further revision.\n(c) The contracting officer must include in fixed-price contracts a clause that specifies one of the following methods, suitable to the interest of the Government, to provide an allowance for any increases or decreases in labor costs that result from the inclusion of the current wage determination at the exercise of an option to extend the term of the contract:\n(1) The contracting officer may provide the offerors the opportunity to bid or propose separate prices for each option\nperiod. The contracting officer must not further adjust the contract price as a result of the incorporation of a new or revised wage determination at the exercise of each option to extend the term of the contract. Generally, this method is used in construction-only contracts (with options to extend the term) that are not expected to exceed a total of 3 years.\n(2) The contracting officer may include in the contract a separately specified pricing method that permits an adjustment to the contract price or contract labor unit price at the exercise of each option to extend the term of the contract. At the time of option exercise, the contracting officer must incorporate a new wage determination into the contract, and must apply the specific pricing method to calculate the contract price adjustment. An example of a contract pricing method that the contracting officer might separately specify is incorporation in the solicitation and resulting contract of the pricing data from an annually published unit pricing book ( e.g. , the U.S. Army Computer-Aided Cost Estimating System or similar commercial product), which is multiplied in the contract by a factor proposed by the contractor ( e.g. , .95 or 1.1). At option exercise, the contracting officer incorporates the pricing data from the latest annual edition of the unit pricing book, multiplied by the factor agreed to in the basic contract. The contracting officer must not further adjust the contract price as a result of the incorporation of the new or revised wage determination.\n(3) The contracting officer may provide for a contract price adjustment based solely on a percentage rate determined by the contracting officer using a published economic indicator incorporated into the solicitation and resulting contract. At the exercise of each option to extend the term of the contract, the contracting officer will apply the percentage rate, based on the economic indicator, to the portion of the contract price or contract unit price designated in the contract clause as labor costs subject to the provisions of the Davis-Bacon Act. The contracting officer must insert 50 percent as the estimated portion of the contract price that is labor unless the contracting officer determines, prior to issuance of the solicitation, that a different percentage is more appropriate for a particular contract or requirement. This percentage adjustment to the designated labor costs must be the only adjustment made to cover increases in wages and/or benefits resulting from the incorporation of a new or revised wage determination at the exercise of the option.\n(4) The contracting officer may provide a computation method to adjust the contract price to reflect the contractor  s actual increase or decrease in wages and fringe benefits (combined) to the extent that the increase is made to comply with, or the decrease is voluntarily made by the contractor as a result of incorporation of, a new or revised wage determination at the exercise of the option to extend the term of the contract. Generally, this method is appropriate for use only if contract requirements are predominately services subject to the Service Contract Act and the construction requirements are substantial and segregable. The methods used to adjust the contract price for the service requirements and the construction requirements would be similar.\n22.405 [Reserved]\n22.406 Administration and enforcement.\n22.406-1 Policy.\n(a) General . Contracting agencies are responsible for ensuring the full and impartial enforcement of labor standards in the administration of construction contracts. Contracting agencies shall maintain an effective program that shall include  \n(1) Ensuring that contractors and subcontractors are informed, before commencement of work, of their obligations under the labor standards clauses of the contract;\n(2) Adequate payroll reviews, on-site inspections, and employee interviews to determine compliance by the contractor and subcontractors, and prompt initiation of corrective action when required;\n(3) Prompt investigation and disposition of complaints; and\n(4) Prompt submission of all reports required by this subpart.\n(b) Preconstruction letters and conferences . Before construction begins, the contracting officer shall inform the contractor of the labor standards clauses and wage determination requirements of the contract and of the contractor  s and any subcontractor  s responsibilities under the contract. Unless it is clear that the contractor is fully aware of the requirements, the contracting officer shall issue an explanatory letter and/or arrange a conference with the contractor promptly after award of the contract.\n22.406-2 Wages, fringe benefits, and overtime.\n(a) In computing wages paid to a laborer or mechanic, the contractor may include only the following items:\n(1) Amounts paid in cash to the laborer or mechanic, or deducted from payments under the conditions set forth in 29 CFR 3.5.\n(2) Contributions (except those required by Federal, State, or local law) the contractor makes irrevocably to a trustee or a third party under any bona fide plan or program to provide for medical or hospital care, pensions, compensation for injuries or illness resulting from occupational activity, unemployment benefits, life insurance, disability and sickness insurance, accident insurance, or any other bona fide fringe benefit.\n(3) Other contributions or anticipated costs for bona fide fringe benefits to the extent expressly approved by the Secretary of Labor.\n(b)(1) The contractor may satisfy the obligation under the clause at 52.222-6 , Davis-Bacon Act, by providing wages consisting of any combination of contributions or costs as specified in paragraph (a) of this subsection, if the total cost of the combination is not less than the total of the basic hourly rate and fringe benefits payments prescribed in the wage determination for the classification of laborer or mechanic concerned.\n(2) Wages provided by the contractor and fringe benefits payments required by the wage determination may include items that are not stated as exact cash amounts. In these cases, the hourly cash equivalent of the cost of these items shall be determined by dividing the employer  s contributions or costs by the employee  s hours worked during the period covered by the costs or contributions. For example, if a contractor pays a monthly health insurance premium of $112 for a particular employee who worked 125 hours during the month, the hourly cash equivalent is determined by dividing $112 by 125 hours, which equals $0.90 per hour. Similarly, the calculation of hourly cash equivalent for nine paid holidays per year for an employee with a hourly rate of pay of $5.00 is determined by multiplying $5.00 by 72 (9 days at 8 hours each), and dividing the result of $360 by the number of hours worked by the employee during the year. If the interested parties (contractor, contracting officer, and employees or their representative) cannot agree on the cash equivalent, the contracting officer shall submit the question for final determination to the Department of Labor as prescribed by agency procedures. The information submitted shall include  \n(i) A comparison of the payments, contributions, or costs in the wage determination with those made or proposed as equivalents by the contractor; and\n(ii) The comments and recommendations of the contracting officer.\n(c) In computing required overtime payments, ( i.e., 1 1/2 times the basic hourly rate of pay) the contractor shall use the basic hourly rate of pay in the wage determination, or the basic hourly rate actually paid by the contractor, if higher. The basic rate of pay includes employee contributions to fringe benefits, but excludes the contractor  s contributions, costs, or payment of cash equivalents for fringe benefits. Overtime shall not be computed on a rate lower than the basic hourly rate in the wage determination.\n22.406-3 Additional classifications.\n(a) If any laborer or mechanic is to be employed in a classification that is not listed in the wage determination applicable to the contract, the contracting officer, pursuant to the clause at 52.222-6 , Davis-Bacon Act, shall require that the contractor submit to the contracting officer, Standard Form (SF) 1444 , Request for Authorization of Additional Classification and Rate, which, along with other pertinent data, contains the proposed additional classification and minimum wage rate including any fringe benefits payments.\n(b) Upon receipt of SF 1444 from the contractor, the contracting officer shall review the request to determine whether it meets the following criteria:\n(1) The classification is appropriate and the work to be performed by the classification is not performed by any classification contained in the applicable wage determination.\n(2) The classification is utilized in the area by the construction industry.\n(3) The proposed wage rate, including any fringe benefits, bears a reasonable relationship to the wage rates in the wage determination in the contract.\n(c)(1) If the criteria in paragraph (b) of this subsection are met and the contractor and the laborers or mechanics to be employed in the additional classification (if known) or their representatives agree to the proposed additional classification, and the contracting officer approves, the contracting officer shall submit a report (including a copy of SF 1444 ) of that action to the Administrator, Wage and Hour Division, for approval, modification, or disapproval of the additional classification and wage rate (including any amount designated for fringe benefits); or\n(2) If the contractor, the laborers or mechanics to be employed in the classification or their representatives, and the contracting officer do not agree on the proposed additional classification, or if the criteria are not met, the contracting officer shall submit a report (including a copy of SF 1444 ) giving the views of all interested parties and the contracting officer  s recommendation to the Administrator, Wage and Hour Division, for determination of appropriate classification and wage rate.\n(d)(1) Within 30 days of receipt of the report, the Administrator, Wage and Hour Division, will complete action and so advise the contracting officer, or will notify the contracting officer that additional time is necessary.\n(2) Upon receipt of the Department of Labor  s action, the contracting officer shall forward a copy of the action to the contractor, directing that the classification and wage rate be posted in accordance with paragraph (a) of the clause at 52.222-6 and that workers in the affected classification receive no less than the minimum rate indicated from the first day on which work under the contract was performed in the classification.\n(e) In each option to extend the term of the contract, if any laborer or mechanic is to be employed during the option in a classification that is not listed (or no longer listed) on the wage determination incorporated in that option, the contracting officer must require that the contractor submit a request for conformance using the procedures noted in paragraphs (a) through (d) of this section.\n22.406-4 Apprentices and trainees.\n(a) The contracting officer shall review the contractor  s employment and payment records of apprentices and trainees made available pursuant to the clause at 52.222-8 , Payrolls and Basic Records, to ensure that the contractor has complied with the clause at 52.222-9 , Apprentices and Trainees.\n(b) If a contractor has classified employees as apprentices, trainees, or helpers without complying with the requirements of the clause at 52.222-9 , the contracting officer shall reject the classification and require the contractor to pay the affected employees at the rates applicable to the classification of the work actually performed.\n22.406-5 Subcontracts.\nIn accordance with the requirements of the clause at 52.222-11 , Subcontracts (Labor Standards), the contractor and subcontractors at any tier are required to submit a fully executed SF 1413 , Statement and Acknowledgment, upon award of each subcontract.\n22.406-6 Payrolls and statements.\n(a) Submission . In accordance with the clause at 52.222-8 , Payrolls and Basic Records, the contractor must submit or cause to be submitted, within 7 calendar days after the regular payment date of the payroll week covered, for the contractor and each subcontractor, (1) copies of weekly payrolls applicable to the contract, and (2) weekly payroll statements of compliance. The contractor may use the Department of Labor Form WH-347 , Payroll (For Contractor  s Optional Use), or a similar form that provides the same data and identical representation.\n(b) Withholding for nonsubmission . If the contractor fails to submit copies of its or its subcontractors  payrolls promptly, the contracting officer shall, from any payment due to the contractor, withhold approval of an amount that the contracting officer considers necessary to protect the interest of the Government and the employees of the contractor or any subcontractor.\n(c) Examination.\n(1) The contracting officer shall examine the payrolls and payroll statements to ensure compliance with the contract and any statutory or regulatory requirements. Particular attention should be given to  \n(i) The correctness of classifications and rates;\n(ii) Fringe benefits payments;\n(iii) Hours worked;\n(iv) Deductions; and\n(v) Disproportionate employment ratios of laborers, apprentices or trainees to journeymen.\n(2) Fringe benefits payments, contributions made, or costs incurred on other than a weekly basis shall be considered as a part of weekly payments to the extent they are creditable to the particular weekly period involved and are otherwise acceptable.\n(d) Preservation . The contracting agency shall retain payrolls and statements of compliance for 3 years after completion of the contract and make them available when requested by the Department of Labor at any time during that period. Submitted payrolls shall not be returned to a contractor or subcontractor for any reason, but copies thereof may be furnished to the contractor or subcontractor who submitted them, or to a higher tier contractor or subcontractor.\n(e) Disclosure of payroll records . Contractor payroll records in the Government  s possession must be carefully protected from any public disclosure which is not required by law, since payroll records may contain information in which the contractor  s employees have a privacy interest, as well as information in which the contractor may have a proprietary interest that the Government may be obliged to protect. Questions concerning release of this information may involve the Freedom of Information Act (FOIA).\n22.406-7 Compliance checking.\n(a) General . The contracting officer shall make checks and investigations on all contracts covered by this subpart as may be necessary to ensure compliance with the labor standards requirements of the contract.\n(b) Regular compliance checks . Regular compliance checking includes the following activities:\n(1) Employee interviews to determine correctness of classifications, rates of pay, fringe benefits payments, and hours worked. (See Standard Form 1445 .)\n(2) On-site inspections to check type of work performed, number and classification of workers, and fulfillment of posting requirements.\n(3) Payroll reviews to ensure that payrolls of prime contractors and subcontractors have been submitted on time and are complete and in compliance with contract requirements.\n(4) Comparison of the information in this paragraph (b) with available data, including daily inspector  s report and daily logs of construction, to ensure consistency.\n(c) Special compliance checks . Situations that may require special compliance checks include  \n(1) Inconsistencies, errors, or omissions detected during regular compliance checks; or\n(2) Receipt of a complaint alleging violations. If the complaint is not specific enough, the complainant shall be so advised and invited to submit additional information.\n22.406-8 Investigations.\nConduct labor standards investigations when available information indicates such action is warranted. In addition, the Department of Labor may conduct an investigation on its own initiative or may request a contracting agency to do so.\n(a) Contracting agency responsibilities . Conduct an investigation when a compliance check indicates that substantial or willful violations may have occurred or violations have not been corrected.\n(1) The investigation must  \n(i) Include all aspects of the contractor  s compliance with contract labor standards requirements;\n(ii) Not be limited to specific areas raised in a complaint or uncovered during compliance checks; and\n(iii) Use personnel familiar with labor laws and their application to contracts.\n(2) Do not disclose contractor employees  oral or written statements taken during an investigation or the employee  s identity to anyone other than an authorized Government official without that employee  s prior signed consent.\n(3) Send a written request to the Administrator, Wage and Hour Division, to obtain  \n(i) Investigation and enforcement instructions; or\n(ii) Available pertinent Department of Labor files.\n(4) Obtain permission from the Department of Labor before disclosing material obtained from Labor Department files, other than computations of back wages and liquidated damages and summaries of back wages due, to anyone other than Government contract administrators.\n(b) Investigation report. The contracting officer must review the investigation report on receipt and make preliminary findings. The contracting officer normally must not base adverse findings solely on employee statements that the employee does not wish to have disclosed. However, if the investigation establishes a pattern of possible violations that are based on employees  statements that are not authorized for disclosure, the pattern itself may support a finding of noncompliance.\n(c) Contractor Notification. After completing the review, the contracting officer must  \n(1) Provide the contractor any written preliminary findings and proposed corrective actions, and notice that the contractor has the right to request that the basis for the findings be made available and to submit written rebuttal information.\n(2) Upon request, provide the contractor with rationale for the findings. However, under no circumstances will the contracting officer permit the contractor to examine the investigation report. Also, the contracting officer must not disclose the identity of any employee who filed a complaint or who was interviewed, without the prior consent of the employee.\n(3)(i) The contractor may rebut the findings in writing within 60 days after it receives a copy of the preliminary findings. The rebuttal becomes part of the official investigation record. If the contractor submits a rebuttal, evaluate the preliminary findings and notify the contractor of the final findings.\n(ii) If the contracting officer does not receive a timely rebuttal, the contracting officer must consider the preliminary findings final.\n(4) If appropriate, request the contractor to make restitution for underpaid wages and assess liquidated damages. If the request includes liquidated damages, the request must state that the contractor has 60 days to request relief from such assessment.\n(d) Contracting officer  s report. After taking the actions prescribed in paragraphs (b) and (c) of this subsection  \n(1) The contracting officer must prepare and forward a report of any violations, including findings and supporting evidence, to the agency head. Standard Form 1446 , Labor Standards Investigation Summary Sheet, is the first page of the report; and\n(2) The agency head must process the report as follows:\n(i) The contracting officer must send a detailed enforcement report to the Administrator, Wage and Hour Division, within 60 days after completion of the investigation, if  \n(A) A contractor or subcontractor underpaid by $1,000 or more;\n(B) The contracting officer believes that the violations are aggravated or willful (or there is reason to believe that the contractor has disregarded its obligations to employees and subcontractors under the Davis-Bacon Act);\n(C) The contractor or subcontractor has not made restitution; or\n(D) Future compliance has not been assured.\n(ii) If the Department of Labor expressly requested the investigation and none of the conditions in paragraph (d)(2)(i) of this subsection exist, submit a summary report to the Administrator, Wage and Hour Division. The report must include  \n(A) A summary of any violations;\n(B) The amount of restitution paid;\n(C) The number of workers who received restitution;\n(D) The amount of liquidated damages assessed under the Contract Work Hours and Safety Standards Act;\n(E) Corrective measures taken; and\n(F) Any information that may be necessary to review any recommendations for an appropriate adjustment in liquidated damages.\n(iii) If none of the conditions in paragraphs (d)(2)(i) or (ii) of this subsection are present, close the case and retain the report in the appropriate contract file.\n(iv) If substantial evidence is found that violations are willful and in violation of a criminal statute, (generally 18 U.S.C. 874 or 1001 ), forward the report (supplemented if necessary) to the Attorney General of the United States for prosecution if the facts warrant. Notify the Administrator, Wage and Hour Division, when the report is forwarded for the Attorney General  s consideration.\n(e) Department of Labor investigations . The Department of Labor will furnish the contracting officer an enforcement report detailing violations found and any corrective action taken by the contractor, in investigations that disclose  \n(1) Underpayments totaling $1,000 or more;\n(2) Aggravated or willful violations (or, when the contracting officer believes that the contractor has disregarded its obligations to employees and subcontractors under the Davis-Bacon Act); or\n(3) Potential assessment of liquidated damages under the Contract Work Hours and Safety Standards Act.\n(f) Other investigations . The Department of Labor will provide a letter summarizing the findings of the investigation to the contracting officer for all investigations that are not described in paragraph (e) of this subsection.\n22.406-9 Withholding from or suspension of contract payments.\n(a) Withholding from contract payments . If the contracting officer believes a violation exists (see 22.406-8 ), or upon request of the Department of Labor, the contracting officer must withhold from payments due the contractor an amount equal to the estimated wage underpayment and estimated liquidated damages due the United States under the Contract Work Hours and Safety Standards Act. (See 22.302 .)\n(1) If the contracting officer believes a violation exists or upon request of the Department of Labor, the contracting officer must withhold funds from any current Federal contract or Federally assisted contract with the same prime contractor that is subject to either Davis-Bacon Act or Contract Work Hours and Safety Standards Act requirements.\n(2) If a subsequent investigation confirms violations, the contracting officer must adjust the withholding as necessary. However, if the Department of Labor requested the withholding, the contracting officer must not reduce or release the withholding without written approval of the Department of Labor.\n(3) Use withheld funds as provided in paragraph (c) of this subsection to satisfy assessed liquidated damages, and unless the contractor makes restitution, validated wage underpayments.\n(b) Suspension of contract payments . If a contractor or subcontractor fails or refuses to comply with the labor standards clauses of the Davis-Bacon Act and related statutes, the agency, upon its own action or upon the written request of the Department of Labor, must suspend any further payment, advance, or guarantee of funds until the violations cease or until the agency has withheld sufficient funds to compensate employees for back wages, and to cover any liquidated damages due.\n(c) Disposition of contract payments withheld or suspended  \n(1) Forwarding wage underpayments to the Comptroller General . Upon final administrative determination, if the contractor or subcontractor has not made restitution, the contracting officer must forward to the appropriate disbursing office Standard Form (SF) 1093 , Schedule of Withholdings Under the Davis-Bacon Act ( 40 U.S.C. 276(a) ) and/or Contract Work Hours and Safety Standards Act ( 40 U.S.C. 327-333 ). Attach to the SF 1093 a list of the name, social security number, and last known address of each affected employee; the amount due each employee; employee claims if feasible; and a brief rationale for restitution. Also, the contracting officer must indicate if restitution was not made because the employee could not be located. The Government may assist underpaid employees in preparation of their claims. The disbursing office must submit the SF 1093 with attached additional data and the funds withheld (by check) to the Comptroller General (Claims Section).\n(2) Returning of withheld funds to contractor . When funds withheld exceed the amount required to satisfy validated wage underpayments and assessed liquidated damages, return the funds to the contractor.\n(3) Limitation on forwarding or returning funds . If the Department of Labor requested the withholding or if the findings are disputed (see 22.406-10 (e)), the contracting officer must not forward the funds to the Comptroller General, or return them to the contractor without approval by the Department of Labor.\n(4) Liquidated damages . Upon final administrative determination, the contracting officer must dispose of funds withheld or collected for liquidated damages in accordance with agency procedures.\n22.406-10 Disposition of disputes concerning construction contract labor standards enforcement.\n(a) The areas of possible differences of opinion between contracting officers and contractors in construction contract labor standards enforcement include  \n(1) Misclassification of workers;\n(2) Hours of work;\n(3) Wage rates and payment;\n(4) Payment of overtime;\n(5) Withholding practices; and\n(6) The applicability of the labor standards requirements under varying circumstances.\n(b) Generally, these differences are settled administratively at the project level by the contracting agency. If necessary, these differences may be settled with assistance from the Department of Labor.\n(c) When requesting the contractor to take corrective action in labor violation cases, the contracting officer shall inform the contractor of the following:\n(1) Disputes concerning the labor standards requirements of the contract are handled under the contract clause at 52.222-14 , Disputes Concerning Labor Standards, and not under the clause at 52.233-1 , Disputes.\n(2) The contractor may appeal the contracting officer  s findings or part thereof by furnishing the contracting officer a complete statement of the reasons for the disagreement with the findings.\n(d) The contracting officer shall promptly transmit the contracting officer  s findings and the contractor  s statement to the Administrator, Wage and Hour Division.\n(e) The Administrator, Wage and Hour Division, will respond directly to the contractor or subcontractor, with a copy to the contracting agency. The contractor or subcontractor may appeal the Administrator  s findings in accordance with the procedures outlined in Labor Department Regulations (29 CFR 5.11). Hearings before administrative law judges are conducted in accordance with 29 CFR Part 6, and hearings before the Labor Department Administrative Review Board are conducted in accordance with 29 CFR Part 7.\n(f) The Administrator, Wage and Hour Division, may institute debarment proceedings against the contractor or subcontractor if the Administrator finds reasonable cause to believe that the contractor or subcontractor has committed willful or aggravated violations of the Contract Work Hours and Safety Standards Act or the Copeland (Anti-Kickback) Act, or any of the applicable statutes listed in 29 CFR 5.1 other than the Davis-Bacon Act, or has committed violations of the Davis-Bacon Act that constitute a disregard of its obligations to employees or subcontractors under Section 3(a) of that Act.\n22.406-11 Contract terminations.\nIf a contract or subcontract is terminated for violation of the labor standards clauses, the contracting agency shall submit a report to the Administrator, Wage and Hour Division, and the Comptroller General. The report shall include  \n(a) The number of the terminated contract;\n(b) The name and address of the terminated contractor or subcontractor;\n(c) The name and address of the contractor or subcontractor, if any, who is to complete the work;\n(d) The amount and number of the replacement contract, if any; and\n(e) A description of the work.\n22.406-12 Cooperation with the Department of Labor.\n(a) The contracting agency shall cooperate with representatives of the Department of Labor in the inspection of records, interviews with workers, and all other aspects of investigations undertaken by the Department of Labor. When requested, the contracting agency shall furnish to the Secretary of Labor any available information on contractors, subcontractors, current and previous contracts, and the nature of the contract work.\n(b) If a Department of Labor representative undertakes an investigation at a construction project, the contracting officer shall inquire into the scope of the investigation, and request to be notified immediately of any violations discovered under the Davis-Bacon Act, the Contract Work Hours and Safety Standards Act, or the Copeland (Anti-Kickback) Act.\n22.406-13 Semiannual enforcement reports.\nA semiannual report on compliance with and enforcement of the construction labor standards requirements of the Davis-Bacon Act and Contract Work Hours and Safety Standards Act is required from each contracting agency. The reporting periods are October 1 through March 31 and April 1 through September 30. The reports shall only contain information as to the enforcement actions of the contracting agency and shall be prepared as prescribed in Department of Labor memoranda and submitted to the Department of Labor within 30 days after the end of the reporting period. This report has been assigned interagency report control number 1482-DOL-SA.\n22.407 Solicitation provision and contract clauses.\n(a) Insert the following clauses in solicitations and contracts in excess of $2,000 for construction within the United States:\n(1) 52.222-6 , Davis-Bacon Act.\n(2) 52.222-7 , Withholding of Funds.\n(3) 52.222-8 , Payrolls and Basic Records.\n(4) 52.222-9 , Apprentices and Trainees.\n(5) 52.222-10 , Compliance with Copeland Act Requirements.\n(6) 52.222-11 , Subcontracts (Labor Standards).\n(7) 52.222-12 , Contract Termination-Debarment.\n(8) 52.222-13 , Compliance with Davis-Bacon and Related Act Regulations.\n(9) 52.222-14 , Disputes Concerning Labor Standards.\n(10) 52.222-15 , Certification of Eligibility.\n(b) Insert the clause at 52.222-16 , Approval of Wage Rates, in solicitations and contracts in excess of $2,000 for cost-reimbursement construction to be performed within the United States, except for contracts with a State or political subdivision thereof.\n(c) A contract that is not primarily for construction may contain a requirement for some construction work to be performed in the United States. If under 22.402 (b) the requirements of this subpart apply to the construction work, insert in such solicitations and contracts the applicable construction labor standards clauses required in this section and identify the item or items of construction work to which the clauses apply.\n(d) [Reserved]\n(e) Insert the clause at 52.222-30 , Davis-Bacon Act  Price Adjustment (None or Separately Specified Pricing Method), in solicitations and contracts if the contract is expected to be  \n(1) A fixed-price contract subject to the Davis-Bacon Act that will contain option provisions by which the contracting officer may extend the term of the contract, and the contracting officer determines the most appropriate contract price adjustment method is the method at 22.404-12 (c)(1) or (2); or\n(2) A cost-reimbursable type contract subject to the Davis-Bacon Act that will contain option provisions by which the contracting officer may extend the term of the contract.\n(f) Insert the clause at 52.222-31 , Davis-Bacon Act  Price Adjustment (Percentage Method), in solicitations and contracts if the contract is expected to be a fixed-price contract subject to the Davis-Bacon Act that will contain option provisions by which the contracting officer may extend the term of the contract, and the contracting officer determines the most appropriate contract price adjustment method is the method at 22.404-12 (c)(3).\n(g) Insert the clause at 52.222-32 , Davis-Bacon Act  Price Adjustment (Actual Method), in solicitations and contracts if the contract is expected to be a fixed-price contract subject to the Davis-Bacon Act that will contain option provisions by which the contracting officer may extend the term of the contract, and the contracting officer determines the most appropriate method to establish contract price is the method at 22.404-12 (c)(4).\n(h) Insert the provision at 52.222-5 , Davis Bacon Act  Secondary Site of the Work, in solicitations in excess of $2,000 for construction within the United States.");
register_book(&s, "|22|6|", "Walsh-Healey Public Contracts Act", "Subpart 22.6  Walsh-Healey Public Contracts Act\n22.601 [Reserved]\n22.602 Statutory requirements.\nExcept for the exemptions at 22.604 , all contracts subject to the Walsh-Healey Public Contracts Act (the Act) ( 41 U.S.C. 35-45 ) and entered into by any executive department, independent establishment, or other agency or instrumentality of the United States, or by the District of Columbia, or by any corporation (all the stock of which is beneficially owned by the United States) for the manufacture or furnishing of materials, supplies, articles, and equipment (referred to in this subpart as supplies) in any amount exceeding $15,000, shall include or incorporate by reference the stipulations required by the Act pertaining to such matters as minimum wages, maximum hours, child labor, convict labor, and safe and sanitary working conditions.\n22.603 Applicability.\nThe requirements in 22.602 apply to contracts (including for this purpose, indefinite-delivery contracts, basic ordering agreements, and blanket purchase agreements) and subcontracts under Section 8(a) of the Small Business Act, for the manufacture or furnishing of supplies that  \n(a) Will be performed in the United States, Puerto Rico, or the U.S. Virgin Islands;\n(b) Exceed or may exceed $15,000; and\n(c) Are not exempt under 22.604 .\n22.604 Exemptions.\n22.604-1 Statutory exemptions.\nContracts for acquisition of the following supplies are exempt from the Act:\n(a) Any item in those situations where the contracting officer is authorized by the express language of a statute to purchase  in the open market  generally (such as commercial items, see Part 12 ); or where a specific purchase is made under the conditions described in 6.302-2 in circumstances where immediate delivery is required by the public exigency.\n(b) Perishables, including dairy, livestock, and nursery products.\n(c) Agricultural or farm products processed for first sale by the original producers.\n(d) Agricultural commodities or the products thereof purchased under contract by the Secretary of Agriculture.\n22.604-2 Regulatory exemptions.\n(a) Contracts for the following acquisitions are fully exempt from the Act (see 41 CFR 50-201.603):\n(1) Public utility services.\n(2) Supplies manufactured outside the United States, Puerto Rico, and the U.S. Virgin Islands.\n(3) Purchases against the account of a defaulting contractor where the stipulations of the Act were not included in the defaulted contract.\n(4) Newspapers, magazines, or periodicals, contracted for with sales agents or publisher representatives, which are to be delivered by the publishers thereof.\n(b)(1) Upon the request of the agency head, the Secretary of Labor may exempt specific contracts or classes of contracts from the inclusion or application of one or more of the Act  s stipulations; provided, that the request includes a finding by the agency head stating the reasons why the conduct of Government business will be seriously impaired unless the exemption is granted.\n(2) Those requests for exemption that relate solely to safety and health standards shall be transmitted to the  \nAssistant Secretary for Occupational Safety and Health U.S. Department of Labor Washington, DC 202l0.\nAll other requests shall be transmitted to the  \nAdministrator of the Wage and Hour Division U.S. Department of Labor Washington, DC 202l0.\n22.605 Rulings and interpretations of the Act.\n(a) As authorized by the Act, the Secretary of Labor has issued rulings and interpretations concerning the administration of the Act (see 41 CFR 50-206). The substance of certain rulings and interpretations is as follows:\n(1) If a contract for $15,000 or less is subsequently modified to exceed $15,000, the contract becomes subject to the Act for work performed after the date of the modification.\n(2) If a contract for more than $15,000 is subsequently modified by mutual agreement to $15,000 or less, the contract is not subject to the Act for work performed after the date of the modification.\n(3) If a contract awarded to a prime contractor contains a provision whereby the prime contractor is made an agent of the Government, the prime contractor is required to include the stipulations of the Act in contracts in excess of $15,000 awarded for and on behalf of the Government for supplies that are to be used in the construction and equipment of Government facilities.\n(4) If a contract subject to the Act is awarded to a contractor operating Government-owned facilities, the stipulations of the Act affect the employees of that contractor the same as employees of contractors operating privately owned facilities.\n(5) Indefinite-delivery contracts, including basic ordering agreements and blanket purchase agreements, are subject to the Act unless it can be determined in advance that the aggregate amount of all orders estimated to be placed thereunder for 1 year after the effective date of the agreement will not exceed $15,000. A determination shall be made annually thereafter if the contract or agreement is extended, and the contract or agreement modified if necessary.\n(b) [Reserved]\n22.606 [Reserved]\n22.607 [Reserved]\n22.608 Procedures.\n(a) Award . When a contract subject to the Act is awarded, the contracting officer, in accordance with regulations or instructions issued by the Secretary of Labor and individual agency procedures, shall furnish to the contractor DOL publication WH-1313, Notice to Employees Working on Government Contracts.\n(b) Breach of stipulation . In the event of a violation of a stipulation required under the Act, the contracting officer shall, in accordance with agency procedures, notify the appropriate regional office of the DOL, Wage and Hour Division (see 29 CFR part 1, Appendix B), and furnish any information available.\n22.609 [Reserved]\n22.610 Contract clause.\nThe contracting officer shall insert the clause at 52.222-20 , Walsh-Healey Public Contracts Act, in solicitations and contracts covered by the Act (see 22.603 , 22.604 , and 22.605 ).");
register_book(&s, "|22|8|", "Equal Employment Opportunity", "Subpart 22.8  Equal Employment Opportunity\n22.800 Scope of subpart.\nThis subpart prescribes policies and procedures pertaining to nondiscrimination in employment by contractors and subcontractors.\n22.801 Definitions.\nAs used in this subpart  \nAffirmative action program  means a contractor  s program that complies with Department of Labor regulations to ensure equal opportunity in employment to minorities and women.\nCompliance evaluation  means any one or combination of actions that the Office of Federal Contract Compliance Programs (OFCCP) may take to examine a Federal contractor  s compliance with one or more of the requirements of E.O. 11246.\nContractor  includes the terms  prime contractor  and  subcontractor.  \nDeputy Assistant Secretary  means the Deputy Assistant Secretary for Federal Contract Compliance, U.S. Department of Labor, or a designee.\nEqual Opportunity clause  means the clause at 52.222-26 , Equal Opportunity, as prescribed in 22.810 (e).\nE.O. 11246  means Parts II and IV of Executive Order 11246, September 24, 1965 (30 FR 12319), and any Executive order amending or superseding this order (see 22.802 ). This term specifically includes the Equal Opportunity clause at 52.222-26 , and the rules, regulations, and orders issued pursuant to E.O. 11246 by the Secretary of Labor or a designee.\nPrime contractor  means any person who holds, or has held, a Government contract subject to E.O. 11246.\nRecruiting and training agency  means any person who refers workers to any contractor or provides or supervises apprenticeship or training for employment by any contractor.\nSite of construction  means the general physical location of any building, highway, or other change or improvement to real property that is undergoing construction, rehabilitation, alteration, conversion, extension, demolition, or repair; and any temporary location or facility at which a contractor or other participating party meets a demand or performs a function relating to a Government contract or subcontract.\nSubcontract  means any agreement or arrangement between a contractor and any person (in which the parties do not stand in the relationship of an employer and an employee)  \n(1) For the purchase, sale, or use of personal property or nonpersonal services that, in whole or in part, are necessary to the performance of any one or more contracts; or\n(2) Under which any portion of the contractor  s obligation under any one or more contracts is performed, undertaken, or assumed.\nSubcontractor  means any person who holds, or has held, a subcontract subject to E.O. 11246. The term  first-tier subcontractor  means a subcontractor holding a subcontract with a prime contractor.\nUnited States  means the 50 States, the District of Columbia, Puerto Rico, the Northern Mariana Islands, American Samoa, Guam, the U.S. Virgin Islands, and Wake Island.\n22.802 General.\n(a) Executive Order 11246, as amended, sets forth the Equal Opportunity clause and requires that all agencies  \n(1) Include this clause in all nonexempt contracts and subcontracts (see 22.807 ); and\n(2) Act to ensure compliance with the clause and the regulations of the Secretary of Labor to promote the full realization of equal employment opportunity for all persons, regardless of race, color, religion, sex, or national origin.\n(b) No contract or modification involving new acquisition shall be entered into, and no subcontract shall be approved by a contracting officer, with a person who has been found ineligible by the Deputy Assistant Secretary for reasons of noncompliance with the requirements of E.O. 11246.\n(c) No contracting officer or contractor shall contract for supplies or services in a manner so as to avoid applicability of the requirements of E.O. 11246.\n(d) Contractor disputes related to compliance with its obligation shall be handled according to the rules, regulations, and relevant orders of the Secretary of Labor (see 41 CFR 60-1.1).\n22.803 Responsibilities.\n(a) The Secretary of Labor is responsible for the  \n(1) Administration and enforcement of prescribed parts of E.O. 11246; and\n(2) Adoption of rules and regulations and the issuance of orders necessary to achieve the purposes of E.O. 11246.\n(b) The Secretary of Labor has delegated authority and assigned responsibility to the Deputy Assistant Secretary for carrying out the responsibilities assigned to the Secretary by E.O. 11246, except for the issuance of rules and regulations of a general nature.\n(c) The head of each agency is responsible for ensuring that the requirements of this subpart are carried out within the agency, and for cooperating with and assisting the OFCCP in fulfilling its responsibilities.\n(d) In the event the applicability of E.O. 11246 and implementing regulations is questioned, the contracting officer shall forward the matter to the Deputy Assistant Secretary, through agency channels, for resolution.\n22.804 Affirmative action programs.\n22.804-1 Nonconstruction.\nExcept as provided in 22.807 , each nonconstruction prime contractor and each subcontractor with 50 or more employees and either a contract or subcontract of $50,000 or more, or Government bills of lading that in any 12-month period total, or can reasonably be expected to total, $50,000 or more, is required to develop a written affirmative action program for each of its establishments. Each contractor and subcontractor shall develop its written affirmative action programs within 120 days from the commencement of its first such Government contract, subcontract, or Government bill of lading.\n22.804-2 Construction.\n(a) Construction contractors that hold a nonexempt (see 22.807 ) Government construction contract are required to meet  \n(1) The contract terms and conditions citing affirmative action requirements applicable to covered geographical areas or projects; and\n(2) Applicable requirements of 41 CFR 60-1 and 60  4.\n(b) Each agency shall maintain a listing of covered geographical areas that are subject to affirmative action requirements that specify goals for minorities and women in covered construction trades. Information concerning, and additions to, this listing will be provided to the principally affected contracting officers in accordance with agency procedures. Any contracting officer contemplating a construction project in excess of $10,000 within a geographic area not known to be covered by specific affirmative action goals shall request instructions on the most current information from the OFCCP regional office, or as otherwise specified in agency regulations, before issuing the solicitation.\n(c) Contracting officers shall give written notice to the OFCCP regional office within 10 working days of award of a construction contract subject to these affirmative action requirements. The notification shall include the name, address, and telephone number of the contractor; employer identification number; dollar amount of the contract; estimated starting and completion dates of the contract; the contract number; and the geographical area in which the contract is to be performed. When requested by the OFCCP regional office, the contracting officer shall arrange a conference among contractor, contracting activity, and compliance personnel to discuss the contractor  s compliance responsibilities.\n22.805 Procedures.\n(a) Preaward clearances for contracts and subcontracts of $10 million or more (excluding construction).\n(1) Except as provided in paragraphs (a)(4) and (a)(8) of this section, if the estimated amount of the contract or subcontract is $10 million or more, the contracting officer shall request clearance from the appropriate OFCCP regional office before  \n(i) Award of any contract, including any indefinite delivery contract or letter contract; or\n(ii) Modification of an existing contract for new effort that would constitute a contract award.\n(2) Preaward clearance for each proposed contract and for each proposed first-tier subcontract of $10 million or more shall be requested by the contracting officer directly from the OFCCP regional office(s). Verbal requests shall be confirmed by letter or facsimile transmission.\n(3) When the contract work is to be performed outside the United States with employees recruited within the United States, the contracting officer shall send the request for a preaward clearance to the OFCCP regional office serving the area where the proposed contractor  s corporate home or branch office is located in the United States, or the corporate location where personnel recruiting is handled, if different from the contractor  s corporate home or branch office. If the proposed contractor has no corporate office or location within the United States, the preaward clearance request action should be based on the location of the recruiting and training agency in the United States.\n(4) The contracting officer does not need to request a preaward clearance if  \n(i) The specific proposed contractor is listed in OFCCP  s National Preaward Registry via the Internet at http://www.dol-esa.gov/preaward/ ;\n(ii) The projected award date is within 24 months of the proposed contractor  s Notice of Compliance completion date in the Registry; and\n(iii) The contracting officer documents the Registry review in the contract file.\n(5) The contracting officer shall include the following information in the preaward clearance request:\n(i) Name, address, and telephone number of the prospective contractor and of any corporate affiliate at which work is to be performed.\n(ii) Name, address, and telephone number of each proposed first-tier subcontractor with a proposed subcontract estimated at $10 million or more.\n(iii) Anticipated date of award.\n(iv) Information as to whether the contractor and first-tier subcontractors have previously held any Government contracts or subcontracts.\n(v) Place or places of performance of the prime contract and first-tier subcontracts estimated at $10 million or more, if known.\n(vi) The estimated dollar amount of the contract and each first-tier subcontract, if known.\n(6) The contracting officer shall allow as much time as feasible before award for the conduct of necessary compliance evaluation by OFCCP. As soon as the apparently successful offeror can be determined, the contracting officer shall process a preaward clearance request in accordance with agency procedures, assuring, if possible, that the preaward clearance request is submitted to the OFCCP regional office at least 30 days before the proposed award date.\n(7) Within 15 days of the clearance request, OFCCP will inform the awarding agency of its intention to conduct a preaward compliance evaluation. If OFCCP does not inform the awarding agency within that period of its intention to conduct a preaward compliance evaluation, clearance shall be presumed and the awarding agency is authorized to proceed with the award. If OFCCP informs the awarding agency of its intention to conduct a preaward compliance evaluation, OFCCP shall be allowed an additional 20 days after the date that it so informs the awarding agency to provide its conclusions. If OFCCP does not provide the awarding agency with its conclusions within that period, clearance shall be presumed and the awarding agency is authorized to proceed with the award.\n(8) If the procedures specified in paragraphs (a)(6) and (a)(7) of this section would delay award of an urgent and critical contract beyond the time necessary to make award or beyond the time specified in the offer or extension thereof, the contracting officer shall immediately inform the OFCCP regional office of the expiration date of the offer or the required date of award and request clearance be provided before that date. If the OFCCP regional office advises that a preaward evaluation cannot be completed by the required date, the contracting officer shall submit written justification for the award to the head of the contracting activity, who, after informing the OFCCP regional office, may then approve the award without the preaward clearance. If an award is made under this authority, the contracting officer shall immediately request a postaward evaluation from the OFCCP regional office.\n(9) If, under the provisions of paragraph (a)(8) of this section, a postaward evaluation determines the contractor to be in noncompliance with E.O. 11246, the Deputy Assistant Secretary may authorize the use of the enforcement procedures at 22.809 against the noncomplying contractor.\n(b) Furnishing posters . The contracting officer shall furnish to the contractor appropriate quantities of the poster entitled  Equal Employment Opportunity Is The Law.  These shall be obtained in accordance with agency procedures.\n22.806 Inquiries.\n(a) An inquiry from a contractor regarding status of its compliance with E.O. 11246, or rights of appeal to any of the actions in 22.809 , shall be referred to the OFCCP regional office.\n(b) Labor union inquiries regarding the revision of a collective bargaining agreement in order to comply with E.O. 11246 shall be referred to the Deputy Assistant Secretary.\n22.807 Exemptions.\n(a) Under the following exemptions, all or part of the requirements of E.O. 11246 may be excluded from a contract subject to E.O. 11246:\n(1) National security . The agency head may determine that a contract is essential to the national security and that the award of the contract without complying with one or more of the requirements of this subpart is necessary to the national security. Upon making such a determination, the agency shall notify the Deputy Assistant Secretary in writing within 30 days.\n(2) Specific contracts . The Deputy Assistant Secretary may exempt an agency from requiring the inclusion of one or more of the requirements of E.O. 11246 in any contract if the Deputy Assistant Secretary deems that special circumstances in the national interest so require. Groups or categories of contracts of the same type may also be exempted if the Deputy Assistant Secretary finds it impracticable to act upon each request individually or if group exemptions will contribute to convenience in the administration of E.O. 11246.\n(b) The following exemptions apply even though a contract or subcontract contains the Equal Opportunity clause:\n(1) Transactions of $10,000 or less . The Equal Opportunity clause is required to be included in prime contracts and subcontracts by 22.802 (a). Individual prime contracts or subcontracts of $10,000 or less are exempt from application of the Equal Opportunity clause, unless the aggregate value of all prime contracts or subcontracts awarded to a contractor in any 12-month period exceeds, or can reasonably be expected to exceed, $10,000. (Note: Government bills of lading, regardless of amount, are not exempt.)\n(2) Work outside the United States. Contracts are exempt from the requirements of E.O. 11246 for work performed outside the United States by employees who were not recruited within the United States.\n(3) Contracts with State or local governments . The requirements of E.O. 11246 in any contract with a State or local government (or any agency, instrumentality, or subdivision thereof) shall not be applicable to any agency, instrumentality, or subdivision of such government that does not participate in work on or under the contract.\n(4) Work on or near Indian reservations . It shall not be a violation of E.O. 11246 for a contractor to extend a publicly announced preference in employment to Indians living on or near an Indian reservation in connection with employment opportunities on or near an Indian reservation. This applies to that area where a person seeking employment could reasonably be expected to commute to and from in the course of a work day. Contractors extending such a preference shall not, however, discriminate among Indians on the basis of religion, sex, or tribal affiliation, and the use of such preference shall not excuse a contractor from complying with E.O. 11246, rules and regulations of the Secretary of Labor, and applicable clauses in the contract.\n(5) Facilities not connected with contracts . The Deputy Assistant Secretary may exempt from the requirements of E.O. 11246 any of a contractor  s facilities that the Deputy Assistant Secretary finds to be in all respects separate and distinct from activities of the contractor related to performing the contract, provided, that the Deputy Assistant Secretary also finds that the exemption will not interfere with, or impede the effectiveness of, E.O. 11246.\n(6) Indefinite-quantity contracts . With respect to indefinite-quantity contracts and subcontracts, the Equal Opportunity clause applies unless the contracting officer has reason to believe that the amount to be ordered in any year under the contract will not exceed $10,000. The applicability of the Equal Opportunity clause shall be determined by the contracting officer at the time of award for the first year, and annually thereafter for succeeding years, if any. Notwithstanding the above, the Equal Opportunity clause shall be applied to the contract whenever the amount of a single order exceeds $10,000. Once the Equal Opportunity clause is determined to be applicable, the contract shall continue to be subject to such clause for its duration regardless of the amounts ordered, or reasonably expected to be ordered, in any year.\n(7) Contracts with religious entities . Pursuant to E.O. 13279, Section 202 of E.O. 11246, shall not apply to a Government contractor or subcontractor that is a religious corporation, association, educational institution, or society, with respect to the employment of individuals of a particular religion to perform work connected with the carrying on by such corporation, association, educational institution, or society of its activities. Such contractors and subcontractors are not exempted or excused from complying with the other requirements contained in the order.\n(c) To request an exemption under paragraph (a)(2) or (b)(5) of this section, the contracting officer shall submit, under agency procedures, a detailed justification for omitting all, or part of, the requirements of E.O. 11246. Requests for exemptions under paragraph (a)(2) or (b)(5) of this section shall be submitted to the Deputy Assistant Secretary for approval.\n(d) The Deputy Assistant Secretary may withdraw the exemption for a specific contract, or group of contracts, if the Deputy Assistant Secretary deems that such action is necessary and appropriate to achieve the purposes of E.O. 11246. Such withdrawal shall not apply  \n(1) To contracts awarded before the withdrawal; or\n(2) To any sealed bid contract (including restricted sealed bidding), unless the withdrawal is made more than 10 days before the bid opening date.\n22.808 Complaints.\nComplaints received by the contracting officer alleging violation of the requirements of E.O. 11246 shall be referred immediately to the OFCCP regional office. The complainant shall be advised in writing of the referral. The contractor that is the subject of a complaint shall not be advised in any manner or for any reason of the complainant  s name, the nature of the complaint, or the fact that the complaint was received.\n22.809 Enforcement.\nUpon the written direction of the Deputy Assistant Secretary, one or more of the following actions, as well as administrative sanctions and penalties, may be exercised against contractors found to be in violation of E.O. 11246, the regulations of the Secretary of Labor, or the applicable contract clauses:\n(a) Publication of the names of the contractor or its unions.\n(b) Cancellation, termination, or suspension of the contractor  s contracts or portion thereof.\n(c) Debarment from future Government contracts, or extensions or modifications of existing contracts, until the contractor has established and carried out personnel and employment policies in compliance with E.O. 11246 and the regulations of the Secretary of Labor.\n(d) Referral by the Deputy Assistant Secretary of any matter arising under E.O. 11246 to the Department of Justice or to the Equal Employment Opportunity Commission (EEOC) for the institution of appropriate civil or criminal proceedings.\n22.810 Solicitation provisions and contract clauses.\n(a) When a contract is contemplated that will include the clause at 52.222-26 , Equal Opportunity, the contracting officer shall insert  \n(1) The clause at 52.222-21 , Prohibition of Segregated Facilities, in the solicitation and contract; and\n(2) The provision at 52.222-22 , Previous Contracts and Compliance Reports, in the solicitation.\n(b) The contracting officer shall insert the provision at 52.222-23 , Notice of Requirement for Affirmative Action to Ensure Equal Employment Opportunity for Construction, in solicitations for construction when a contract is contemplated that will include the clause at 52.222-26 , Equal Opportunity, and the amount of the contract is expected to be in excess of $10,000.\n(c) The contracting officer shall insert the provision at 52.222-24 , Preaward On-Site Equal Opportunity Compliance Evaluation, in solicitations other than those for construction when a contract is contemplated that will include the clause at 52.222-26 , Equal Opportunity, and the amount of the contract is expected be $10 million or more.\n(d) The contracting officer shall insert the provision at 52.222-25 , Affirmative Action Compliance, in solicitations, other than those for construction, when a contract is contemplated that will include the clause at 52.222-26 , Equal Opportunity.\n(e) The contracting officer shall insert the clause at 52.222-26 , Equal Opportunity, in solicitations and contracts (see 22.802 ) unless the contract is exempt from all of the requirements of E.O. 11246 (see 22.807 (a)). If the contract is exempt from one or more, but not all, of the requirements of E.O. 11246, the contracting officer shall use the clause with its Alternate I.\n(f) The contracting officer shall insert the clause at 52.222-27 , Affirmative Action Compliance Requirements for Construction, in solicitations and contracts for construction that will include the clause at 52.222-26 , Equal Opportunity, when the amount of the contract is expected to be in excess of $10,000.\n(g) The contracting officer shall insert the clause at 52.222-29 , Notification of Visa Denial, in contracts that will include the clause at 52.222-26 , Equal Opportunity, if the contractor is required to perform in or on behalf of a foreign country.");
register_book(&s, "|22|9|", "Nondiscrimination Because of Age", "Subpart 22.9  Nondiscrimination Because of Age\n22.901 Policy.\nExecutive Order 11141, February 12, 1964 (29 FR 2477), states that the Government policy is as follows:\n(a) Contractors and subcontractors shall not, in connection with employment, advancement, or discharge of employees, or the terms, conditions, or privileges of their employment, discriminate against persons because of their age except upon the basis of a bona fide occupational qualification, retirement plan, or statutory requirement.\n(b) Contractors and subcontractors, or persons acting on their behalf, shall not specify in solicitations or advertisements for employees to work on Government contracts, a maximum age limit for employment unless the specified maximum age limit is based upon a bona fide occupational qualification, retirement plan, or statutory requirement.\n(c) Agencies will bring this policy to the attention of contractors. The use of contract clauses is not required.\n22.902 Handling complaints.\nAgencies shall bring complaints regarding a contractor  s compliance with this policy to that contractor  s attention (in writing, if appropriate), stating the policy, indicating that the contractor  s compliance has been questioned, and requesting that the contractor take any appropriate steps that may be necessary to comply.");
register_book(&s, "|22|10|", "Service Contract Act of 1965, as Amende", "Subpart 22.10  Service Contract Act of 1965, as Amended\n22.1000 Scope of subpart.\nThis subpart prescribes policies and procedures implementing the provisions of the Service Contract Act of 1965, as amended ( 41 U.S.C. 351 , et seq. ), the applicable provisions of the Fair Labor Standards Act of 1938, as amended ( 29 U.S.C. 201 , et seq. ), and related Secretary of Labor regulations and instructions (29 CFR Parts 4, 6, 8, and 1925).\n22.1001 Definitions.\nAs used in this subpart  \nAct  or  Service Contract Act  means the Service Contract Act of 1965.\nAgency labor advisor  means an individual responsible for advising contracting agency officials on Federal contract labor matters.\nContractor  includes a subcontractor at any tier whose subcontract is subject to the provisions of the Act.\nMultiple year contracts  means contracts having a term of more than 1 year regardless of fiscal year funding. The term includes multiyear contracts (see 17.103 ).\nUnited States  means the 50 States, the District of Columbia, Puerto Rico, the Northern Mariana Islands, American Samoa, Guam, the U.S. Virgin Islands, Johnston Island, Wake Island, and Outer Continental Shelf lands as defined in the Outer Continental Shelf Lands Act ( 43 U.S.C. 1331 , et seq .), but does not include any other place subject to U.S. jurisdiction or any U.S. base or possession in a foreign country (29 CFR 4.112).\nWage and Hour Division  means the unit in the Employment Standards Administration of the Department of Labor to which is assigned functions of the Secretary of Labor under the Act.\nWage determination  means a determination of minimum wages or fringe benefits made under sections 2(a) or 4(c) of the Act ( 41 U.S.C. 351(a) or 353(c)) applicable to the employment in a given locality of one or more classes of service employees.\n22.1002 Statutory requirements.\n22.1002-1 General.\nService contracts over $2,500 shall contain mandatory provisions regarding minimum wages and fringe benefits, safe and sanitary working conditions, notification to employees of the minimum allowable compensation, and equivalent Federal employee classifications and wage rates. Under 41 U.S.C. 353(d) , service contracts may not exceed 5 years.\n22.1002-2 Wage determinations based on prevailing rates.\nContractors performing on service contracts in excess of $2,500 to which no predecessor contractor  s collective bargaining agreement applies shall pay their employees at least the wages and fringe benefits found by the Department of Labor to prevail in the locality or, in the absence of a wage determination, the minimum wage set forth in the Fair Labor Standards Act.\n22.1002-3 Wage determinations based on collective bargaining agreements.\n(a) Successor contractors performing on contracts in excess of $2,500 for substantially the same services performed in the same locality must pay wages and fringe benefits (including accrued wages and benefits and prospective increases) at least equal to those contained in any bona fide collective bargaining agreement entered into under the predecessor contract. This requirement is self-executing and is not contingent upon incorporating a wage determination or the wage and fringe benefit terms of the predecessor contractor  s collective bargaining agreement in the successor contract. This requirement will not apply if the Secretary of Labor determines  \n(1) After a hearing, that the wages and fringe benefits are substantially at variance with those which prevail for services of a similar character in the locality; or\n(2) That the wages and fringe benefits are not the result of arm  s length negotiations.\n(b) Paragraphs in this Subpart 22.10 which deal with this statutory requirement and the Department of Labor  s implementing regulations are 22.1010 , concerning notification to contractors and bargaining representatives of procurement dates; 22.1012-2 , explaining when a collective bargaining agreement will not apply due to late receipt by the contracting officer; and 22.1013 and 22.1021 , explaining when the application of a collective bargaining agreement can be challenged due to a variance with prevailing rates or lack of arm  s length bargaining.\n22.1002-4 Application of the Fair Labor Standards Act minimum wage.\nNo contractor or subcontractor holding a service contract for any dollar amount shall pay any of its employees working on the contract less than the minimum wage specified in section 6(a)(1) of the Fair Labor Standards Act ( 29 U.S.C. 206 ).\n22.1003 Applicability.\n22.1003-1 General.\nThis Subpart 22.10 applies to all Government contracts, the principal purpose of which is to furnish services in the United States through the use of service employees, except as exempted in 22.1003-3 and 22.1003-4 of this section, or any subcontract at any tier thereunder. This subpart does not apply to individual contract requirements for services in contracts not having as their principal purpose the furnishing of services. The nomenclature, type, or particular form of contract used by contracting agencies is not determinative of coverage.\n22.1003-2 Geographical coverage of the Act.\nThe Act applies to service contracts performed in the United States (see 22.1001 ). The Act does not apply to contracts performed outside the United States.\n22.1003-3 Statutory exemptions.\nThe Act does not apply to  \n(a) Any contract for construction, alteration, or repair of public buildings or public works, including painting and decorating;\n(b) Any work required to be done in accordance with the provisions of the Walsh-Healey Public Contracts Act ( 41 U.S.C. 35-45 );\n(c) Any contract for transporting freight or personnel by vessel, aircraft, bus, truck, express, railroad, or oil or gas pipeline where published tariff rates are in effect;\n(d) Any contract for furnishing services by radio, telephone, telegraph, or cable companies subject to the Communications Act of 1934;\n(e) Any contract for public utility services;\n(f) Any employment contract providing for direct services to a Federal agency by an individual or individuals; or\n(g) Any contract for operating postal contract stations for the U.S. Postal Service.\n22.1003-4 Administrative limitations, variations, tolerances, and exemptions.\n(a) The Secretary of Labor may provide reasonable limitations and may make rules and regulations allowing reasonable variations, tolerances, and exemptions to and from any or all provisions of the Act other than section 10 ( 41 U.S.C. 358 ). These will be made only in special circumstances where it has been determined that the limitation, variation, tolerance, or exemption is necessary and proper in the public interest or to avoid the serious impairment of Government business, and is in accord with the remedial purpose of the Act to protect prevailing labor standards ( 41 U.S.C. 353(b) ). See 29 CFR 4.123 for a listing of administrative exemptions, tolerances, and variations. Requests for limitations, variances, tolerances, and exemptions from the Act shall be submitted in writing through contracting channels and the agency labor advisor to the Wage and Hour Administrator.\n(b) In addition to the statutory exemptions cited in 22.1003-3 of this subsection, the Secretary of Labor has exempted the following types of contracts from all provisions of the Act:\n(1) Contracts entered into by the United States with common carriers for the carriage of mail by rail, air (except air star routes), bus, and ocean vessel, where such carriage is performed on regularly scheduled runs of the trains, airplanes, buses, and vessels over regularly established routes and accounts for an insubstantial portion of the revenue therefrom.\n(2) Any contract entered into by the U.S. Postal Service with an individual owner-operator for mail service if it is not contemplated at the time the contract is made that the owner-operator will hire any service employee to perform the services under the contract except for short periods of vacation time or for unexpected contingencies or emergency situations such as illness, or accident.\n(3) Contracts for the carriage of freight or personnel if such carriage is subject to rates covered by section 10721 of the Interstate Commerce Act.\n(c) Contracts for maintenance, calibration or repair of certain equipment .  \n(1) Exemption . The Secretary of Labor has exempted from the Act contracts and subcontracts in which the primary purpose is to furnish maintenance, calibration, or repair of the following types of equipment, if the conditions at paragraph (c)(2) of this subsection are met:\n(i) Automated data processing equipment and office information/word processing systems. \n(ii) Scientific equipment and medical apparatus or equipment if the application of micro-electronic circuitry or other technology of at least similar sophistication is an essential element (for example, Federal Supply Classification (FSC) Group 65, Class 6515,  Medical Diagnostic Equipment;  Class 6525,  X-Ray Equipment;  FSC Group 66, Class 6630,  Chemical Analysis Instruments;  and Class 6665,  Geographical and Astronomical Instruments,  are largely composed of the types of equipment exempted in this paragraph). \n(iii) Office/business machines not otherwise exempt pursuant to paragraph (c)(1)(i) of this subsection, if such services are performed by the manufacturer or supplier of the equipment. \n(2) Conditions . The exemption at paragraph (c)(1) of this subsection applies if all the following conditions are met for a contract (or a subcontract): \n(i) 	The items of equipment to be serviced under the contract are used regularly for other than Government purposes and are sold or traded by the contractor in substantial quantities to the general public in the course of normal business operations. \n(ii) The services will be furnished at prices which are, or are based on, established catalog or market prices for the maintenance, calibration, or repair of such equipment. As defined at 29 CFR 4.123(e)(1)(ii)(B)  \n(A) An established catalog price is a price included in a catalog price list, schedule, or other form that is regularly maintained by the manufacturer or the contractor, is either published or otherwise available for inspection by customers, and states prices at which sales currently, or were last, made to a significant number of buyers constituting the general public.\n(B) An established market price is a current price, established in the usual course of trade between buyers and sellers free to bargain, which can be substantiated from sources independent of the manufacturer or contractor.\n(iii) The contractor will use the same compensation (wage and fringe benefits) plan for all service employees performing work under the contract as the contractor uses for these employees and equivalent employees servicing the same equipment of commercial customers. \n(iv) The apparent successful offeror certifies to the conditions in paragraph (c)(2)(i) through (iii) of this subsection. (See 22.1006 (e).) \n(3) Affirmative determination and contract award . \n(i) For source selections where the contracting officer has established a competitive range, if the contracting officer determines that one or more of the conditions in paragraphs 22.1003-4 (c)(2)(i) through (iii) of an offeror  s certification will not be met, the contracting officer shall identify the deficiency to the offeror before receipt of the final proposal revisions. Unless the offeror provides a revised offer acknowledging applicability of the Service Contract Act or demonstrating to the satisfaction of the contracting officer an ability to meet all required conditions for exemption, the offer will not be further considered for award.\n(ii) The contracting officer shall determine in writing the applicability of this exemption to the contract before contract award. If the apparent successful offeror will meet all conditions in paragraph (c)(2) of this subsection, the contracting officer shall make an affirmative determination and award the contract without the otherwise applicable Service Contract Act clause(s). \n(iii) If the apparent successful offeror does not certify to the conditions in paragraph (c)(2)(i) through (iii) of this subsection, the contracting officer shall incorporate in the contract the Service Contract Act clause (see 22.1006 (a)) and, if the contract will exceed $2,500, the appropriate Department of Labor wage determination (see 22.1007 ). \n(4) Department of Labor determination . \n(i) If the Department of Labor determines after award of the contract that any condition for exemption in paragraph (c)(2) of this subsection has not been met, the exemption shall be deemed inapplicable, and the contract shall become subject to the Service Contract Act, effective as of the date of the Department of Labor determination. In such case, the procedures at 29 CFR 4.123(e)(1)(iv) and 29 CFR 4.5(c) shall be followed.\n(ii) If the Department of Labor determines that any conditions in paragraph (c)(2) of this subsection have not been met with respect to a subcontract, the exemption shall be deemed inapplicable. The contractor may be responsible for ensuring that the subcontractor complies with the Act, effective as of the date of the subcontract award.\n(d) Contracts for certain services .  \n(1) Exemption . Except as provided in paragraph (d)(5) of this subsection, the Secretary of Labor has exempted from the Act contracts and subcontracts in which the primary purpose is to provide the following services, if the conditions in paragraph (d)(2) of this subsection are met: \n(i) Automobile or other vehicle ( e.g ., aircraft) maintenance services (other than contracts or subcontracts to operate a Government motor pool or similar facility).\n(ii) Financial services involving the issuance and servicing of cards (including credit cards, debit cards, purchase cards, smart cards, and similar card services).\n(iii) Hotel/motel services for conferences, including lodging and/or meals, that are part of the contract or subcontract for the conference (which must not include ongoing contracts for lodging on an as needed or continuing basis).\n(iv) Maintenance, calibration, repair, and/or installation (where the installation is not subject to the Davis-Bacon Act, as provided in 29 CFR 4.116(c)(2)) services for all types of equipment where the services are obtained from the manufacturer or supplier of the equipment under a contract awarded on a sole source basis.\n(v) Transportation by common carrier of persons by air, motor vehicle, rail, or marine vessel on regularly scheduled routes or via standard commercial services (not including charter services).\n(vi) Real estate services, including real property appraisal services, related to housing Federal agencies or disposing of real property owned by the Government. \n(vii) Relocation services, including services of real estate brokers and appraisers to assist Federal employees or military personnel in buying and selling homes (which shall not include actual moving or storage of household goods and related services). 	\n(2) Conditions . The exemption for the services in paragraph (d)(1) of this subsection applies if all the following conditions are met for a contract (or for a subcontract):\n(i)(A) Except for services identified in paragraph (d)(1)(iv) of this subsection, the contractor will be selected for award based on other factors in addition to price or cost, with the combination of other factors at least as important as price or cost; or\n(B) The contract will be awarded on a sole source basis.\n(ii) The services under the contract are offered and sold regularly to non-Governmental customers, and are provided by the contractor (or subcontractor in the case of an exempt subcontract) to the general public in substantial quantities in the course of normal business operations. \n(iii) The contract services are furnished at prices that are, or are based on, established catalog or market prices. As defined at 29 CFR 4.123(e)(2)(ii)(C)  \n(A) An established catalog price is a price included in a catalog, price list, schedule, or other form that is regularly maintained by the contractor, is either published or otherwise available for inspection by customers, and states prices at which sales are currently, or were last, made to a significant number of buyers constituting the general public; and\n(B) An established market price is a current price, established in the usual course of trade between buyers and sellers free to bargain, which can be substantiated from sources independent of the manufacturer or contractor.\n(iv) Each service employee who will perform the services under the contract will spend only a small portion of his or her time (a monthly average of less than 20 percent of the available hours on an annualized basis, or less than 20 percent of available hours during the contract period if the contract period is less than a month) servicing the Government contract.\n(v) The contractor will use the same compensation (wage and fringe benefits) plan for all service employees performing work under the contract as the contractor uses for these employees and equivalent employees servicing commercial customers. \n(vi) The contracting officer (or contractor with respect to a subcontract) determines in advance before issuing the solicitation, based on the nature of the contract requirements and knowledge of the practices of likely offerors, that all or nearly all offerors will meet the conditions in paragraph (d)(2)(ii) through (v) of this subsection. If the services are currently being performed under contract, the contracting officer (or contractor with respect to a subcontract) shall consider the practices of the existing contractor in making a determination regarding the conditions in paragraphs (d)(2)(ii) through (v) of this subsection. \n(vii)(A) The apparent successful offeror certifies that the conditions in paragraphs (d)(2)(ii) through (v) will be met; and \n(B) For other than sole source awards, the contracting officer determines that the same certification is obtained from substantially all other offerors that are  \n(1) In the competitive range, if discussions are to be conducted (see FAR 15.306 (c)); or\n(2) Considered responsive, if award is to be made without discussions (see FAR 15.306 (a)). \n(3) Contract award or resolicitation . \n(i) If the apparent successful offeror does not certify to the conditions, the contracting officer shall insert in the contract the applicable Service Contract Act clause(s) (see 22.1006 ) and, if the contract will exceed $2,500, the appropriate Department of Labor wage determination (see 22.1007 ).\n(ii) The contracting officer shall award the contract without the otherwise applicable Service Contract Act clause(s) if  \n(A) The apparent successful offeror certifies to the conditions in paragraphs (d)(2)(ii) through (v) of this subsection;\n(B) The contracting officer determines that the same certification is obtained from substantially all other offerors that are  \n(1) In the competitive range, if discussions are to be conducted (see FAR 15.306 ); or\n(2) Considered responsive, if award is to be made without discussions (see FAR 15.306 (a)); and \n(C) The contracting officer has no reason to doubt the certification.\n(iii) If the conditions in paragraph (d)(3)(ii) of this subsection are not met, then the contracting officer shall resolicit, amending the solicitation by removing the exemption provision from the solicitation as prescribed at 22.1006 (e)(3). The contract will include the applicable Service Contract Act clause(s) as prescribed at 22.1006 and, if the contract will exceed $2,500, the appropriate Department of Labor wage determination (see 22.1007 ).\n(4) Department of Labor determination . \n(i) If the Department of Labor determines after award of the contract that any conditions for exemption at paragraph (d)(2) of this subsection have not been met, the exemption shall be deemed inapplicable, and the contract shall become subject to the Service Contract Act. In such case, the procedures at 29 CFR 4.123(e)(2)(iii) and 29 CFR 4.5(c) shall be followed.\n(ii) If the Department of Labor determines that any conditions in paragraph (d)(2) of this subsection have not been met with respect to a subcontract, the exemption shall be deemed inapplicable. The contractor may be responsible for ensuring that the subcontractor complies with the Act, effective as of the date of the subcontract award. \n(5) Exceptions . The exemption at paragraph (d)(1) of this subsection does not apply to solicitations and contracts (subcontracts)  \n(i) Awarded under the Javits-Wagner-O  Day Act, 41 U.S.C. 47 (see Subpart 8.7 ).\n(ii) For the operation of a Government facility, or part of a Government facility (but may be applicable to subcontracts for services); or\n(iii) Subject to Section 4(c) of the Service Contract Act (see 22.1002-3 ). \n22.1003-5 Some examples of contracts covered.\nThe following examples, while not definitive or exclusive, illustrate some of the types of services that have been found to be covered by the Act (see 29 CFR 4.130 for additional examples):\n(a) Motor pool operation, parking, taxicab, and ambulance services.\n(b) Packing, crating, and storage.\n(c) Custodial, janitorial, housekeeping, and guard services.\n(d) Food service and lodging.\n(e) Laundry, dry-cleaning, linen-supply, and clothing alteration and repair services.\n(f) Snow, trash, and garbage removal.\n(g) Aerial spraying and aerial reconnaissance for fire detection.\n(h) Some support services at installations, including grounds maintenance and landscaping.\n(i) Certain specialized services requiring specific skills, such as drafting, illustrating, graphic arts, stenographic reporting, or mortuary services.\n(j) Electronic equipment maintenance and operation and engineering support services.\n(k) Maintenance and repair of all types of equipment, for example, aircraft, engines, electrical motors, vehicles, and electronic, office and related business and construction equipment. (But see 22.1003-4 (c)(1) and (d)(1)(iv).)\n(l) Operation, maintenance, or logistics support of a Federal facility.\n(m) Data collection, processing and analysis services.\n22.1003-6 Repair distinguished from remanufacturing of equipment.\n(a) Contracts principally for remanufacturing of equipment which is so extensive as to be equivalent to manufacturing are subject to the Walsh-Healey Public Contracts Act, rather than to the Service Contract Act. Remanufacturing shall be deemed to be manufacturing when the criteria in either subparagraphs (a)(1) or (a)(2) of this subsection are met.\n(1) Major overhaul of an item, piece of equipment, or material which is degraded or inoperable, and under which all of the following conditions exist:\n(i) The item or equipment is required to be completely or substantially torn down into individual component parts.\n(ii) Substantially all of the parts are reworked, rehabilitated, altered and/or replaced.\n(iii) The parts are reassembled so as to furnish a totally rebuilt item or piece of equipment.\n(iv) Manufacturing processes similar to those which were used in the manufacturing of the item or piece of equipment are utilized.\n(v) The disassembled components, if usable (except for situations where the number of items or pieces of equipment involved are too few to make it practicable) are commingled with existing inventory and, as such, lose their identification with respect to a particular piece of equipment.\n(vi) The items or equipment overhauled are restored to original life expectancy, or nearly so.\n(vii) Such work is performed in a facility owned or operated by the contractor.\n(2) Major modification of an item, piece of equipment, or material which is wholly or partially obsolete, and under which all of the following conditions exist:\n(i) The item or equipment is required to be completely or substantially torn down.\n(ii) Outmoded parts are replaced.\n(iii) The item or equipment is rebuilt or reassembled.\n(iv) The contract work results in the furnishing of a substantially modified item in a usable and serviceable condition.\n(v) The work is performed in a facility owned or operated by the contractor.\n(b) Remanufacturing does not include the repair of damaged or broken equipment which does not require a complete teardown, overhaul, and rebuild as described in subparagraphs (a)(1) and (a)(2) of this subsection, or the periodic and routine maintenance, preservation, care, adjustment, upkeep, or servicing of equipment to keep it in usable, serviceable, working order. Such contracts typically are billed on an hourly rate (labor plus materials and parts) basis. Any contract principally for this type of work is subject to the Service Contract Act. Examples of such work include the following:\n(1) Repair of an automobile, truck, or other vehicle, construction equipment, tractor, crane, aerospace, air conditioning and refrigeration equipment, electric motors, and ground powered industrial or vehicular equipment.\n(2) Repair of typewriters and other office equipment (but see 22.1003-4 (c)(1) and (d)(1)(iv)).\n(3) Repair of appliances, radios, television sets, calculators, and other electronic equipment.\n(4) Inspecting, testing, calibration, painting, packaging, lubrication, tune-up, or replacement of internal parts of equipment listed in subparagraphs (b)(1), (b)(2), and (b)(3) of this subsection.\n(5) Reupholstering, reconditioning, repair, and refinishing of furniture.\n22.1003-7 Questions concerning applicability of the Act.\nIf the contracting officer questions the applicability of the Act to an acquisition, the contracting officer shall request the advice of the agency labor advisor. Unresolved questions shall be submitted in a timely manner to the Administrator, Wage and Hour Division, for determination.\n22.1004 Department of Labor responsibilities and regulations.\nUnder the Act, the Secretary of Labor is authorized and directed to enforce the provisions of the Act, make rules and regulations, issue orders, hold hearings, make decisions, and take other appropriate action. The Department of Labor has issued implementing regulations on such matters as  \n(a) Service contract labor standards provisions and procedures (29 CFR Part 4, Subpart A);\n(b) Wage determination procedures (29 CFR part 4, subparts A and B);\n(c) Application of the Act (rulings and interpretations) (29 CFR Part 4, Subpart C);\n(d) Compensation standards (29 CFR Part 4, Subpart D);\n(e) Enforcement (29 CFR Part 4, Subpart E);\n(f) Safe and sanitary working conditions (29 CFR Part 1925);\n(g) Rules of practice for administrative proceedings enforcing service contract labor standards (29 CFR Part 6); and\n(h) Practice before the Administrative Review Board (29 CFR part 8).\n22.1005 [Reserved]\n22.1006 Solicitation provisions and contract clauses.\n(a)(1) The contracting officer shall insert the clause at 52.222-41 , Service Contract Act of 1965, in solicitations and contracts (except as provided in paragraph (a)(2) of this section) if the contract is subject to the Act and is  \n(i) Over $2,500; or \n(ii) For an indefinite dollar amount and the contracting officer does not know in advance that the contract amount will be $2,500 or less.\n(2) The contracting officer shall not insert the clause at 52.222-41 (or any of the associated Service Contract Act clauses as prescribed in this section for possible use when 52.222-41 applies) in the resultant contract if  \n(i) The solicitation includes the provision at  \n(A) 52.222-48 , Exemption from Application of the Service Contract Act to Contracts for Maintenance, Calibration, or Repair of Certain Equipment  Certification;\n(B) 52.222-52 , Exemption from Application of the Service Contract Act to Contracts for Certain Services  Certification; or\n(C) Either of the comparable certifications is checked as applicable in the provision at 52.204-8 (c)(2)(iii) or (iv) or 52.212-3 (k); and\n(ii) The contracting officer has made the determination, in accordance with paragraphs (c)(3) or (d)(3) of subsection 22.1003-4 , that the Service Contract Act does not apply to the contract. (In such case, insert the clause at 52.222-51 , Exemption from Application of the Service Contract Act to Contracts for Maintenance, Calibration, or Repair of Certain Equipment  Requirements, or 52.222-53 , Exemption from Application of the Service Contract Act to Contracts for Certain Services  Requirements, in the contract, in accordance with the prescription at paragraph (e)(2)(ii) or (e)(4)(ii) of this subsection).\n(b) The contracting officer shall insert the clause at 52.222-42 , Statement of Equivalent Rates for Federal Hires, in solicitations and contracts if the contract amount is expected to be over $2,500 and the Act is applicable. (See 22.1016 .)\n(c)(1) The contracting officer shall insert the clause at 52.222-43 , Fair Labor Standards Act and Service Contract Act  Price Adjustment (Multiple Year and Option Contracts), or another clause which accomplishes the same purpose, in solicitations and contracts if the contract is expected to be a fixed-price, time-and-materials, or labor-hour service contract containing the clause at 52.222-41 , Service Contract Act of 1965, and is a multiple year contract or is a contract with options to renew which exceeds the simplified acquisition threshold. The clause may be used in contracts that do not exceed the simplified acquisition threshold. The clause at 52.222-43 , Fair Labor Standards Act and Service Contract Act  Price Adjustment (Multiple Year and Option Contracts), applies to both contracts subject to area prevailing wage determinations and contracts subject to the incumbent contractor  s collective bargaining agreement in effect during this contract  s preceding contract period (see 22.1002-2 and 22.1002-3 ). Contracting officers shall ensure that contract prices or contract unit price labor rates are adjusted only to the extent that a contractor  s increases or decreases in applicable wages and fringe benefits are made to comply with the requirements set forth in the clauses at 52.222-43 (subparagraphs (d)(1), (2) and (3)), or 52.222-44 (subparagraphs (b)(1) and (2)). (For example, the prior year wage determination required a minimum wage rate of $4.00 per hour. The contractor actually paid $4.10. The new wage determination increases the minimum rate to $4.50. The contractor increases the rate actually paid to $4.75 per hour. The allowable price adjustment is $.40 per hour.)\n(2) The contracting officer shall insert the clause at 52.222-44 , Fair Labor Standards Act and Service Contract Act  Price Adjustment, in solicitations and contracts if the contract is expected to be a fixed-price, time-and-materials, or labor-hour service contract containing the clause at 52.222-41 , Service Contract Act of 1965, exceeds the simplified acquisition threshold, and is not a multiple year contract or is not a contract with options to renew. The clause may be used in contracts that do not exceed the simplified acquisition threshold. The clause at 52.222-44 , Fair Labor Standards Act and Service Contract Act  Price Adjustment, applies to both contracts subject to area prevailing wage determinations and contracts subject to contractor collective bargaining agreements (see 22.1002-2 and 22.1002-3 ).\n(3) The clauses prescribed in paragraph 22.1006 (c)(1) cover situations in which revised minimum wage rates are applied to contracts by operation of law, or by revision of a wage determination in connection with (i) exercise of a contract option or (ii) extension of a multiple year contract into a new program year. If a clause prescribed in 16.203-4 (d) is used, it must not conflict with, or duplicate payment under, the clauses prescribed in this paragraph 22.1006 (c).\n(d) [Reserved]\n(e)(1) The contracting officer shall insert the provision at 52.222-48 , Exemption from Application of the Service Contract Act to Contracts for Maintenance, Calibration, or Repair of Certain Equipment Certification, in solicitations that  \n(i) Include the clause at 52.222-41 , Service Contract Act of 1965; and\n(ii) The contract may be exempt from the Service Contract Act in accordance with 22.1003-4 (c).\n(2) The contracting officer shall insert the clause at 52.222-51 , Exemption from Application of the Service Contract Act to Contracts for Maintenance, Calibration, or Repair of Certain Equipment  Requirements  \n(i) In solicitations that include the provision at 52.222-48 , or the comparable provision is checked as applicable in the clause at 52.204-8 (c)(2)(iii) or 52.212-3 (k)(1); and \n(ii) In resulting contracts in which the contracting officer has determined, in accordance with 22.1003-4 (c)(3), that the Service Contract Act does not apply.\n(3)(i) Except as provided in paragraph (e)(3)(ii) of this section, the contracting officer shall insert the provision at 52.222-52 , Exemption from Application of the Service Contract Act to Contracts for Certain Services  Certification, in solicitations that  \n(A) Include the clause at 52.222-41 , Service Contract Act of 1965; and\n(B) The contract may be exempt from the Service Contract Act in accordance with 22.1003-4 (d).\n(ii) When resoliciting in accordance with 22.1003-4 (d)(3)(iii), amend the solicitation by removing the provision at 52.222-52 from the solicitation.\n(4) The contracting officer shall insert the clause at 52.222-53 , Exemption from Application of the Service Contract Act to Contracts for Certain Services  Requirements  \n(i) In solicitations that include the provision at 52.222-52 , or the comparable provision is checked as applicable in 52.204-8 (c)(2)(iv) or 52.212-3 (k)(2); and\n(ii) In resulting contracts in which the contracting officer has determined, in accordance with 22.1003-4 (d)(3), that the Service Contract Act does not apply.\n(f) The contracting officer shall insert the clause at 52.222-49 , Service Contract Act  Place of Performance Unknown, if using the procedures prescribed in 22.1009-4 .\n22.1007 Requirement to obtain wage determinations.\nThe contracting officer shall obtain wage determinations for the following service contracts:\n(a) Each new solicitation and contract in excess of $2,500.\n(b) Each contract modification which brings the contract above $2,500 and  \n(1) Extends the existing contract pursuant to an option clause or otherwise; or\n(2) Changes the scope of the contract whereby labor requirements are affected significantly.\n(c) Each multiple year contract in excess of $2,500 upon  \n(1) Annual anniversary date if the contract is subject to annual appropriations; or\n(2) Biennial anniversary date if the contract is not subject to annual appropriations and its proposed term exceeds 2 years  unless otherwise advised by the Wage and Hour Division.\n22.1008 Procedures for obtaining wage determinations.\n22.1008-1 Obtaining wage determinations.\n(a) Contracting officers may obtain most prevailing wage determinations using the WDOL website. Contracting officers may also use the Department of Labor  s e98 electronic process, located on the WDOL website, to request a wage determination directly from the Department of Labor. If the WDOL database does not contain the applicable prevailing wage determination for a contract action, the contracting officer must use the e98 process to request a wage determination from the Department of Labor.\n(b) In using the e98 process to obtain prevailing wage determinations, contracting officers shall provide as complete and accurate information on the e98 as possible. Contracting officers shall ensure that the email address submitted on an e98 request is accurate.\n(c) The contracting officer must anticipate the amount of time required to gather the information necessary to obtain a wage determination, including sufficient time, if necessary, to contact the Department of Labor to request wage determinations that are not available through use of the WDOL.\n(d) Although the WDOL website provides assistance to the contracting agency to select the correct wage determination, the contracting agency remains responsible for the wage determination selected. If the contracting agency has used the e98 process, the Department of Labor will respond to the contracting agency based on the information provided on the e98. The contracting agency may rely upon the Department of Labor response as the correct wage determination for the contract.\n(e) To obtain the applicable wage determination for each contract action, the contracting officer shall determine the following information concerning the service employees expected to be employed by the contractor and any subcontractors in performing the contract:\n(1) Determine the classes of service employees to be utilized in performance of the contract using the Wage and Hour Division  s Service Contract Act Directory of Occupations (Directory). The Directory can be found on WDOL  s Library Page, and is for sale by the Superintendent of Documents, U.S. Government Printing Office.\n(2) Determine the locality where the services will be performed (see 22.1009 ).\n(3) Determine whether Section 4(c) of the Act applies (see 22.1008-2 , 22.1010 and 22.1002-2 ).\n(4) Determine the wage rate that would be paid each class if employed by the agency and subject to the wage provisions of 5 U.S.C. 5341 and/or 5332 (see 22.1016 ).\n(f) If the contracting officer has questions regarding the procedures for obtaining a wage determination, or questions regarding the selection of a wage determination, the contracting officer should request assistance from the agency labor advisor.\n22.1008-2 Section 4(c) successorship with incumbent contractor collective bargaining agreement.\n(a) Early in the acquisition cycle, the contracting officer shall determine whether section 4(c) of the Act affects the new acquisition. The contracting officer shall determine whether there is a predecessor contract covered by the Act and, if so, whether the incumbent prime contractor or its subcontractors and any of their employees have a collective bargaining agreement.\n(b) Section 4(c) of the Act provides that a successor contractor must pay wages and fringe benefits (including accrued wages and benefits and prospective increases) to service employees at least equal to those agreed upon by a predecessor contractor under the following conditions:\n(1) The services to be furnished under the proposed contract will be substantially the same as services being furnished by an incumbent contractor whose contract the proposed contract will succeed.\n(2) The services will be performed in the same locality.\n(3) The incumbent prime contractor or subcontractor is furnishing such services through the use of service employees whose wages and fringe benefits are the subject of one or more collective bargaining agreements.\n(c) The application of section 4(c) of the Act is subject to the following limitations:\n(1) Section 4(c) of the Act will not apply if the incumbent contractor enters into a collective bargaining agreement for the first time and the agreement does not become effective until after the expiration of the incumbent  s contract.\n(2) If the incumbent contractor enters into a new or revised collective bargaining agreement during the period of the incumbent  s performance on the current contract, the terms of the new or revised agreement shall not be effective for the purposes of section 4(c) of the Act under the following conditions:\n(i)(A) In sealed bidding, the contracting agency receives notice of the terms of the collective bargaining agreement less than 10 days before bid opening and finds that there is not reasonable time still available to notify bidders (see 22.1002-2 (a)); or\n(B) For contractual actions other than sealed bidding, the contracting agency receives notice of the terms of the collective bargaining agreement after award, provided that the start of performance is within 30 days of award (see 22.1002-2 (b)); and\n(ii) The contracting officer has given both the incumbent contractor and its employees  collective bargaining agent timely written notification of the applicable acquisition dates (see 22.1010 ).\n(d)(1) If section 4(c) of the Act applies, the contracting officer shall obtain a copy of any collective bargaining agreement between an incumbent contractor or subcontractor and its employees. Obtaining a copy of an incumbent contractor  s collective bargaining agreement may involve coordination with the administrative contracting officer responsible for administering the predecessor contract. (Paragraph (m) of the clause at 52.222-41 , Service Contract Act of 1965, requires the incumbent prime contractor to furnish the contracting officer a copy of each collective bargaining agreement.)\n(2) If the contracting officer has timely received the collective bargaining agreement, the contracting officer may use the WDOL website to prepare a wage determination referencing the agreement and incorporate that wage determination, attached to a complete copy of the collective bargaining agreement, into the successor contract action. In using the WDOL process, it is not necessary to submit a copy of the collective bargaining agreement to the Department of Labor unless requested to do so.\n(3) The contracting officer may also use the e98 process on WDOL to request that the Department of Labor prepare the cover wage determination. The Department of Labor  s response to the e98 may include a request for the contracting officer to submit a complete copy of the collective bargaining agreement. Any questions regarding the applicability of the Act to a collective bargaining agreement should be directed to the agency labor advisor.\n(e)(1) Section 4(c) of the Act will not apply if the Secretary of Labor determines (i) after a hearing, that the wages and fringe benefits in the predecessor contractor  s collective bargaining agreement are substantially at variance with those which prevail for services of a similar character in the locality, or (ii) that the wages and fringe benefits in the predecessor contractor  s collective bargaining agreement are not the result of arm  s length negotiations (see 22.1013 and 22.1021 ). The Department of Labor (DOL) has concluded that contingent collective bargaining agreement provisions that attempt to limit a contractor  s obligations by means such as requiring issuance of a wage determination by the DOL, requiring inclusion of the wage determination in the contract, or requiring the Government to adequately reimburse the contractor, generally reflect a lack of arm  s length negotiations.\n(2) If the contracting officer  s review (see 22.1013 ) indicates that monetary provisions of the collective bargaining agreement may be substantially at variance or may not have been reached as a result of arm  s length bargaining, the contracting officer shall immediately contact the agency labor advisor to consider if further action is warranted.\n(f) If the services are being furnished at more than one location and the collectively bargained wage rates and fringe benefits are different at different locations or do not apply to one or more locations, the contracting officer shall identify the locations to which the agreements apply.\n(g) If the collective bargaining agreement does not apply to all service employees under the contract, the contracting officer shall access WDOL to obtain the prevailing wage determination for those service employee classifications that are not covered by the collective bargaining agreement. The contracting officer shall separately list in the solicitation and contract the service employee classifications  \n(1) Subject to the collective bargaining agreement; and\n(2) Not subject to any collective bargaining agreement.\n22.1009 Place of performance unknown.\n22.1009-1 General.\nIf the place of performance is unknown, the contracting officer may use the procedures in this section. The contracting officer should first attempt to identify the specific places or geographical areas where the services might be performed (see 22.1009-2 ) and then may follow the procedures either in 22.1009-3 or in 22.1009-4 .\n22.1009-2 Attempt to identify possible places of performance.\nThe contracting officer should attempt to identify the specific places or geographical areas where the services might be performed. The following may indicate possible places of performance:\n(a) Locations of previous contractors and their competitors.\n(b) Databases available via the Internet for lists of prospective offerors and contractors.\n(c) Responses to a presolicitation notice (see 5.204 ).\n22.1009-3 All possible places of performance identified.\n(a) If the contracting officer can identify all the possible places or areas of performance (even though the actual place of performance will not be known until the successful offeror is chosen), the contracting officer shall obtain a wage determination for each locality where services may be performed (see 22.1008 ).\n(b) If the contracting officer subsequently learns of any potential offerors in previously unidentified places before the closing date for submission of offers, the contracting officer shall  \n(1) Obtain wage determinations for the additional places of performance and amend the solicitation to include all wage determinations. If necessary, the contracting officer shall extend the time for submission of final offers; and\n(2) Follow the procedures in 22.1009-4 .\n22.1009-4 All possible places of performance not identified.\nIf the contracting officer believes that there may be offerors interested in performing in unidentified places or areas, the contracting officer may use the following procedures:\n(a) Include the following information in the synopsis and solicitation:\n(1) That the place of performance is unknown.\n(2) The possible places or areas of performance that the contracting officer has already identified.\n(3) That the contracting officer will obtain wage determinations for additional possible places of performance if asked to do so in writing.\n(4) The time and date by which offerors must notify the contracting officer of additional places of performance.\n(b) Include the information required by paragraphs (a)(2) and (a)(4) of this section in the clause at 52.222-49 , Service Contract Act  Place of Performance Unknown (see 22.1006 (f)). The closing date for receipt of offerors  requests for wage determinations for additional possible places of performance should allow reasonable time for potential offerors to review the solicitation and determine their interest in competing. Generally, 10 to 15 days from the date of issuance of the solicitation may be considered a reasonable period of time.\n(c) The procedures in 14.304 shall apply to late receipt of offerors  requests for wage determinations for additional places of performance. However, late receipt of an offeror  s request for a wage determination for additional places of performance does not preclude the offeror  s competing for the proposed acquisition.\n(d) If the contracting officer receives any timely requests for wage determinations for additional places of performance the contracting officer shall  \n(1) Obtain wage determinations for the additional places of performance; and\n(2) Amend the solicitation to include all wage determinations and, if necessary, extend the time for submission of final offers.\n(e) If the successful offeror did not make a timely request for a wage determination and will perform in a place of performance for which the contracting officer therefore did not request a wage determination, the contracting officer shall  \n(1) Award the contract;\n(2) Obtain a wage determination; and\n(3) Incorporate the wage determination in the contract, retroactive to the date of contract award and with no adjustment in contract price, pursuant to the clause at 52.222-49 , Service Contract  Place of Performance Unknown.\n22.1010 Notification to interested parties under collective bargaining agreements.\n(a) The contracting officer should determine whether the incumbent prime contractor  s or its subcontractors  service employees performing on the current contract are represented by a collective bargaining agent. If there is a collective bargaining agent, the contracting officer shall give both the incumbent contractor and its employees  collective bargaining agent written notification of  \n(1) The forthcoming successor contract and the applicable acquisition dates (issuance of solicitation, opening of bids, commencement of negotiations, award of contract, or start of performance, as the case may be); or\n(2) The forthcoming contract modification and applicable acquisition dates (exercise of option, extension of contract, change in scope, or start of performance, as the case may be); or\n(3) The forthcoming multiple year contract anniversary date (annual anniversary date or biennial date, as the case may be).\n(b) This written notification must be given at least 30 days in advance of the earliest applicable acquisition date or the applicable annual or biennial anniversary date in order for the time-of-receipt limitations in paragraphs 22.1012-2 (a) and (b) to apply. The contracting officer shall retain a copy of the notification in the contract file.\n22.1011 [Reserved]\n22.1012 Applicability of revisions to wage determinations.\n22.1012-1 Prevailing wage determinations.\n(a)(1) The Wage and Hour Administrator may issue revisions to prevailing wage determinations periodically. The need for inclusion of a revised prevailing wage determination in a solicitation, contract or contract modification (see 22.1007 ) is determined by the date of receipt of the revised prevailing wage determination by the contracting agency. (Note the distinction between receipt by the agency and receipt by the contracting officer which may occur later.)\n(i) For purposes of using WDOL, the time of receipt by the contracting agency shall be the first day of publication of the revised prevailing wage determination on the website.\n(ii) For purposes of using the e98 process, the time of receipt by the contracting agency shall be the date the agency receives actual notice of a new or revised prevailing wage determination from the Department of Labor as an e98 response.\n(2) In selecting a prevailing wage determination from the WDOL website for use in a solicitation or other contract action, the contracting officer shall monitor the WDOL website to determine whether the applicable wage determination has been revised. Revisions published on the WDOL website or otherwise communicated to the contracting officer within the timeframes prescribed at 22.1012-1 (b) and (c) are effective and must be included in the resulting contract. Monitoring can be accomplished by use of the WDOL website  s  Alert Service  .\n(b) The following shall apply when contracting by sealed bidding: a revised prevailing wage determination shall not be effective if it is received by the contracting agency less than 10 days before the opening of bids, and the contracting officer finds that there is not reasonable time to incorporate the revision in the solicitation.\n(c) For contractual actions other than sealed bidding, a revised prevailing wage determination received by the contracting agency after award of a new contract or a modification as specified in 22.1007 (b) shall not be effective provided that the start of performance is within 30 days of the award or the specified modification. If the contract does not specify a start of performance date which is within 30 days of the award or the specified modification, and if contract performance does not commence within 30 days of the award or the specified modification, any revision received by the contracting agency not less than 10 days before commencement of the work shall be effective.\n(d) If the contracting officer has submitted an e98 to the Department of Labor requesting a prevailing wage determination and has not received a response within 10 days, the contracting officer shall contact the Wage and Hour Division by telephone to determine when the wage determination can be expected. (The telephone number is provided on the e98 website.)\n22.1012-2 Wage determinations based on collective bargaining agreements.\n(a) In sealed bidding, a new or changed collective bargaining agreement shall not be effective under section 4(c) of the Act if the contracting agency has received notice of the terms of the new or changed collective bargaining agreement less than 10 days before bid opening and the contracting officer determines that there is not reasonable time to incorporate the new or changed terms of the collective bargaining agreement in the solicitation.\n(b) For contractual actions other than sealed bidding, a new or changed collective bargaining agreement shall not be effective under section 4(c) of the Act if notice of the terms of the new or changed collective bargaining agreement is received by the contracting agency after award of a successor contract or a modification as specified in 22.1007 (b), provided that the contract start of performance is within 30 days of the award of the contract or of the specified modification. If the contract does not specify a start of performance date which is within 30 days of the award of the contract or of the specified modification, or if contract performance does not commence within 30 days of the award of the contract or of the specified modification, any notice of the terms of a new or changed collective bargaining agreement received by the agency not less than 10 days before commencement of the work shall be effective for purposes of the successor contract under section 4(c) of the Act.\n(c) The limitations in paragraphs (a) and (b) of this subsection shall apply only if timely notification required in 22.1010 has been given.\n(d) If the contracting officer has submitted an e98 to Department of Labor requesting a wage determination based on a collective bargaining agreement and has not received a response from the Department of Labor within 10 days, the contracting officer shall contact the Wage and Hour Division by telephone to determine when the wage determination can be expected. (The telephone number is provided on the e98 website.) If the Department of Labor is unable to provide the wage determination by the latest date needed to maintain the acquisition schedule, the contracting officer shall incorporate the collective bargaining agreement itself in a solicitation or other contract action ( e.g., exercise of option) and include a wage determination referencing that collective bargaining agreement created by use of the WDOL website (see 22.1008-1 (d)(2)).\n22.1013 Review of wage determination.\n(a) Based on incumbent collective bargaining agreement. (1) If wages, fringe benefits, or periodic increases provided for in a collective bargaining agreement vary substantially from those prevailing for similar services in the locality, the contracting officer shall immediately contact the agency labor advisor to consider instituting the procedures in 22.1021 .\n(1) If the contracting officer believes that an incumbent or predecessor contractor  s agreement was not the result of arm  s length negotiations, the contracting officer shall contact the agency labor advisor to determine appropriate action.\n(b) Based on other than incumbent collective bargaining agreement. Upon receiving a wage determination not predicated upon a collective bargaining agreement, the contracting officer shall ascertain  \n(1) If the wage determination does not conform with wages and fringe benefits prevailing for similar services in the locality; or\n(2) If the wage determination contains significant errors or omissions. If either subparagraph (b)(1) or (b)(2) of this section is evident, the contracting officer shall contact the agency labor advisor to determine appropriate action.\n22.1014 Delay over 60 days in bid opening or commencement of work.\nIf a wage determination was obtained through the e98 process, and bid opening, or commencement of work under a negotiated contract has been delayed, for whatever reason, more than 60 days from the date indicated on the previously submitted e98, the contracting officer shall submit a new e98. Any revision of a wage determination received by the contracting agency as a result of that communication shall supersede the earlier response as the wage determination applicable to the particular acquisition subject to the time frames in 22.1012-1 (b) and (c).\n22.1015 Discovery of errors by the Department of Labor.\nIf the Department of Labor discovers and determines, whether before or after a contract award, that a contracting officer made an erroneous determination that the Service Contract Act did not apply to a particular acquisition or failed to include an appropriate wage determination in a covered contract, the contracting officer, within 30 days of notification by the Department of Labor, shall include in the contract the clause at 52.222-41 and any applicable wage determination issued by the Administrator. If the contract is subject to section 10 of the Act ( 41 U.S.C. 358 ), the Administrator may require retroactive application of that wage determination. The contracting officer shall equitably adjust the contract price to reflect any changed cost of performance resulting from incorporating a wage determination or revision.\n22.1016 Statement of equivalent rates for Federal hires.\n(a) The statement required under the clause at 52.222-42 , Statement of Equivalent Rates for Federal Hires, (see 22.1006 (b)) shall set forth those wage rates and fringe benefits that would be paid by the contracting activity to the various classes of service employees expected to be utilized under the contract if 5 U.S.C. 5332 (General Schedule  white collar) and/or 5 U.S.C. 5341 (Wage Board  blue collar) were applicable.\n(b) Procedures for computation of these rates are as follows:\n(1) Wages paid blue collar employees shall be the basic hourly rate for each class. The rate shall be Wage Board pay schedule step two for nonsupervisory service employees and step three for supervisory service employees.\n(2) Wages paid white collar employees shall be an hourly rate for each class. The rate shall be obtained by dividing the general pay schedule step one biweekly rate by 80.\n(3) Local civilian personnel offices can assist in determining and providing grade and salary data.\n22.1017 [Reserved]\n22.1018 Notification to contractors and employees.\nThe contracting officer shall take the following steps to ensure that service employees are notified of minimum wages and fringe benefits.\n(a) As soon as possible after contract award, inform the contractor of the labor standards requirements of the contract relating to the Act and of the contractor  s responsibilities under these requirements, unless it is clear that the contractor is fully informed.\n(b) At the time of award, furnish the contractor Department of Labor Publication WH-1313, Notice to Employees Working on Government Contracts, for posting at a prominent and accessible place at the worksite before contract performance begins. The publication advises employees of the compensation (wages and fringe benefits) required to be paid or furnished under the Act and satisfies the notice requirements in paragraph (g) of the clause at 52.222-41 , Service Contract Act of 1965.\n(c) Attach any applicable wage determination to Publication WH-1313.\n22.1019 Additional classes of service employees.\n(a) If the contracting officer is aware that contract performance involves classes of service employees not included in the wage determination, the contracting officer shall require the contractor to classify the unlisted classes so as to provide a reasonable relationship ( i.e., appropriate level of skill comparison) between the unlisted classifications and the classifications listed in the determination (see paragraph (c) of the clause at 52.222-41 , Service Contract Act of 1965). The contractor shall initiate the conforming procedure before unlisted classes of employees perform contract work. The contractor shall submit Standard Form (SF) 1444 , Request For Authorization of Additional Classification and Rate. The contracting officer shall review the proposed classification and rate and promptly submit the completed SF 1444 (which must include information regarding the agreement or disagreement of the employees  representative or the employees themselves together with the agency recommendation) and all other pertinent information to the Wage and Hour Division. Within 30 days of receipt of the request, the Wage and Hour Division will (1) approve, modify, or disapprove the request when the parties are in agreement or (2) render a final determination in the event of disagreement among the parties. If the Wage and Hour Division will require more than 30 days to take action, it will notify the contracting officer within 30 days of receipt of the request that additional time is necessary.\n(b) Some wage determinations will list a series of classes within a job classification family, for example, Computer Operators, level I, II, and III, or Electronic Technicians, level I, II, and III, or Clerk Typist, level I and II. Generally, level I is the lowest level. It is the entry level, and establishment of a lower level through conformance is not permissible. Further, trainee classifications may not be conformed. Helpers in skilled maintenance trades (for example, electricians, machinists, and automobile mechanics) whose duties constitute, in fact, separate and distinct jobs may also be used if listed on the wage determination, but may not be conformed. Conformance may not be used to artificially split or subdivide classifications listed in the wage determination. However, conforming procedures may be used if the work which an employee performs under the contract is not within the scope of any classification listed on the wage determination, regardless of job title. (See 29 CFR 4.152.)\n(c) Subminimum rates for apprentices, student learners, and handicapped workers are permissible in accordance with paragraph (q) of the clause at 52.222-41 , Service Contract Act of 1965.\n22.1020 Seniority lists.\nIf a contract is performed at a Federal facility where employees may be hired/retained by a succeeding contractor, the incumbent prime contractor is required to furnish a certified list of all service employees on the contractor  s or subcontractor  s payroll during the last month of the contract, together with anniversary dates of employment, to the contracting officer no later than 10 days before contract completion. (See paragraph (n) of the clause at 52.222-41 , Service Contract Act of 1965.) At the commencement of the succeeding contract, the contracting officer shall provide a copy of the list to the successor contractor for determining employee eligibility for vacation or other fringe benefits which are based upon length of service, including service with predecessor contractors if such benefit is required by an applicable wage determination.\n22.1021 Request for hearing.\n(a) A contracting agency or other interested party may request a hearing on an issue presented in 22.1013 (a). To obtain a hearing for the contracting agency, the contracting officer shall submit a written request through appropriate channels (ordinarily the agency labor advisor) to  \nAdministrator, Wage and Hour Division Employment Standards Administration U.S. Department of Labor Washington, DC 20210\n(b) A request for a substantial variance hearing shall include sufficient data to show that the rates at issue vary substantially from those prevailing for similar services in the locality. The request shall also include  \n(1) The number of the wage determinations at issue;\n(2) The name of the contracting agency whose contract is involved;\n(3) A brief description of the services to be performed under the contract;\n(4) The status of the procurement and any estimated procurement dates, such as bid opening, contract award, and commencement date of the contract or its follow-up option period;\n(5) A statement of the applicant  s case, setting forth in detail the reasons why the applicant believes that a substantial variance exists with respect to some or all of the wages and/or fringe benefits;\n(6) Names and addresses (to the extent known) of interested parties; and\n(7) Any other data required by the Administrator.\n(c) A request for an arm  s length hearing shall include  \n(1) A statement of the applicant  s case, setting forth in detail the reasons why the applicant believes that the wages and fringe benefits contained in the collective bargaining agreement were not reached as a result of arm  s length negotiations;\n(2) A statement regarding the status of the procurement and any estimated procurement dates, such as bid opening, contract award, and commencement date of the contract or its follow-up option period; and\n(3) Names and addresses (to the extent known) of interested parties.\n(d) Unless the Administrator determines that extraordinary circumstances exist, the Administrator will not consider requests for a hearing unless received as follows:\n(1) For sealed bid contracts, more than 10 days before the award of the contract; or\n(2) For negotiated contracts and for contracts with provisions exceeding the initial term by option, before the commencement date of the contract or the follow-up option period.\n22.1022 Withholding of contract payments.\nAny violations of the clause at 52.222-41 , Service Contract Act of 1965, as amended, renders the responsible contractor liable for the amount of any deductions, rebates, refunds, or underpayments (which includes nonpayment) of compensation due employees performing the contract. The contracting officer may withhold  or, upon written request of the Department of Labor from a level no lower than that of Deputy Regional Administrator, Wage and Hour Division, Employment Standards Administration, Department of Labor, shall withhold  the amount needed to pay such underpaid employees from accrued payments due the contractor on the contract, or on any other prime contract (whether subject to the Service Contract Act or not) with the contractor. The agency shall place the amount withheld in a deposit fund. Such withheld funds shall be transferred to the Department of Labor for disbursement to the underpaid employees on order of the Secretary (or authorized representatives), and Administrative Law Judge, or the Administrative Review Board. In addition, the Department of Labor has given blanket approval to forward withheld funds pending completion of an investigation or other administrative proceeding when disposition of withheld funds remains the final action necessary to close out a contract.\n22.1023 Termination for default.\nAs provided by the Act, any contractor failure to comply with the requirements of the contract clauses related to the Act may be grounds for termination for default (see paragraph (k) of the clause at 52.222-41 , Service Contract Act of 1965).\n22.1024 Cooperation with the Department of Labor.\nThe contracting officer shall cooperate with Department of Labor representatives in the examination of records, interviews with service employees, and all other aspects of investigations undertaken by the Department. When asked, agencies shall furnish the Wage and Hour Administrator or a designee, any available information on contractors, subcontractors, their contracts, and the nature of the contract services. The contracting officer shall promptly refer, in writing to the appropriate regional office of the Department, apparent violations and complaints received. Employee complaints shall not be disclosed to the employer.\n22.1025 Ineligibility of violators.\nA list of persons or firms found to be in violation of the Act is contained in the System for Award Management Exclusions (see 9.404 ). No Government contract may be awarded to any violator so listed because of a violation of the Act, or to any firm, corporation, partnership, or association in which the violator has a substantial interest, without the approval of the Secretary of Labor. This prohibition against award to an ineligible contractor applies to both prime and subcontracts.\n22.1026 Disputes concerning labor standards.\nDisputes concerning labor standards requirements of the contract are handled under paragraph (t) of the contract clause at 52.222-41 , Service Contract Act of 1965, and not under the clause at 52.233-1 , Disputes.");
register_book(&s, "|22|11|", "Professional Employee Compensation", "Subpart 22.11  Professional Employee Compensation\n22.1101 Applicability.\nThe Service Contract Act of 1965 was enacted to ensure that Government contractors compensate their blue-collar service workers and some white-collar service workers fairly, but it does not cover bona fide executive, administrative, or professional employees.\n22.1102 Definition.\nProfessional employee,  as used in this subpart, means any person meeting the definition of  employee employed in a bona fide . . . professional capacity  given in 29 CFR 541. The term embraces members of those professions having a recognized status based upon acquiring professional knowledge through prolonged study. Examples of these professions include accountancy, actuarial computation, architecture, dentistry, engineering, law, medicine, nursing, pharmacy, the sciences (such as biology, chemistry, and physics, and teaching). To be a professional employee, a person must not only be a professional but must be involved essentially in discharging professional duties.\n22.1103 Policy, procedures, and solicitation provision.\nAll professional employees shall be compensated fairly and properly. Accordingly, the contracting officer shall insert the provision at 52.222-46 , Evaluation of Compensation for Professional Employees, in solicitations for negotiated contracts when the contract amount is expected to exceed $650,000 and services are to be provided which will require meaningful numbers of professional employees. This provision requires that offerors submit for evaluation a total compensation plan setting forth proposed salaries and fringe benefits for professional employees working on the contract. Supporting information will include data, such as recognized national and regional compensation surveys and studies of professional, public and private organizations, used in establishing the total compensation structure. Plans indicating unrealistically low professional employee compensation may be assessed adversely as one of the factors considered in making an award.");
register_book(&s, "|22|12|", "Nondisplacement of Qualified Workers Un", "Subpart 22.12  Nondisplacement of Qualified Workers Under Service Contracts\n22.1200 Scope of subpart.\nThis subpart prescribes policies and procedures for implementing Executive Order 13495 of January 30, 2009, Nondisplacement of Qualified Workers Under Service Contracts, and related Secretary of Labor regulations and instructions (see 29 CFR part 9).\n22.1201 Definitions.\nAs used in this subpart  \nUnited States  means the 50 States, the District of Columbia, Puerto Rico, the Northern Mariana Islands, American Samoa, Guam, the U.S. Virgin Islands, Johnston Island, Wake Island, and outer Continental Shelf as defined in the Outer Continental Shelf Lands Act (43 U.S.C. 1331, et seq .), but does not include any other place subject to United States jurisdiction or any United States base or possession in a foreign country (see 29 CFR 4.112).\n22.1202 Policy.\n(a) When a service contract succeeds a contract for performance of the same or similar services, as defined at 29 CFR 9.2, at the same location, the successor contractor and its subcontractors are required to offer those service employees that are employed under the predecessor contract, and whose employment will be terminated as a result of the award of the successor contract, a right of first refusal of employment under the contract in positions for which they are qualified. Executive Order 13495 generally prohibits employment openings under the successor contract until such right of first refusal has been provided, when consistent with applicable law. \n(b) Nothing in Executive Order 13495 shall be construed to permit a contractor or subcontractor to fail to comply with any provision of any other Executive order or law. For example, the requirements of the HUBZone Program (see subpart 19.13 ), Executive Order 11246 (Equal Employment Opportunity), and the Vietnam Era Veterans  Readjustment Assistance Act of 1974 may, in certain circumstances, conflict with the requirements of Executive Order 13495. All applicable laws and Executive orders must be satisfied in tandem with, and if necessary prior to, the requirements of Executive Order 13495 and this subpart. \n22.1203 Applicability. \n22.1203-1 General.\nThis subpart applies to service contracts that succeed contracts for the same or similar services (29 CFR 9.2) at the same location.\n22.1203-2 Exemptions.\n(a) This subpart does not apply to  \n(1) Contracts and subcontracts under the simplified acquisition threshold; \n(2) Contracts or subcontracts awarded pursuant to 41 U.S.C. chapter 85, Committee for Purchase from People Who Are Blind or Severely Disabled;\n(3) Guard, elevator operator, messenger, or custodial services provided to the Government under contracts or subcontracts with sheltered workshops employing the  severely handicapped  as described in 40 U.S.C. 593;\n(4) Agreements for vending facilities entered into pursuant to the preference regulations issued under the Randolph Sheppard Act, 20 U.S.C. 107; or\n(5) Service employees who were hired to work under a Federal service contract and one or more nonfederal service contracts as part of a single job, provided that the service employees were not deployed in a manner that was designed to avoid the purposes of this subpart.\n(b) The exemptions in paragraphs (a)(2) through (a)(4) of this subsection apply when either the predecessor or successor contract has been awarded for services produced or provided by the  severely handicapped.  \n22.1203-3 Waiver.\n(a) The senior procurement executive of the procuring agency may waive some or all of the provisions of this subpart after determining in writing that the application of this subpart would not serve the purposes of Executive Order 13495 or would impair the ability of the Federal Government to procure services on an economical and efficient basis. Such waivers may be made for a contract, subcontract, or purchase order, or with respect to a class of contracts, subcontracts, or purchase orders. See 29 CFR 9.4(d)(4) for regulatory provisions addressing circumstances in which a waiver could or would not be appropriate. The waiver must be reflected in a written analysis as described in 29 CFR 9.4(d)(4)(i) and must be completed by the contract solicitation date, or the waiver is inoperative. The senior procurement executive shall not redelegate this waiver authority. \n(b)(1) When an agency exercises its waiver authority with respect to any contract, subcontract, or purchase order, the contracting officer shall direct the contractor to notify affected workers and their collective bargaining representative in writing, no later than five business days after the solicitation issuance date, of the agency  s determination. The notice shall include facts supporting the determination. The contracting officer  s failure to direct that the contractor provide the notice as provided in this subparagraph shall render the waiver decision inoperative, and the contracting officer shall include the clause at 52.222-17 in the solicitation. \n(2) Where a contracting agency waives application to a class of contracts, subcontracts, or purchase orders, the contracting officer shall, with respect to each individual solicitation, direct the contractor to notify incumbent workers and their collective bargaining representatives in writing, no later than five business days after each solicitation issuance date, of the agency  s determination. The notice shall include facts supporting the determination. The contracting officer  s failure to direct that the contractor provide the notice provided in this subparagraph shall render the waiver decision inoperative, and the contracting officer shall include the clause at 52.222-17 in the solicitation.\n(3) In addition, the agency shall notify the Department of Labor of its waiver decision and provide the Department of Labor with a copy of its written analysis no later than five business days after the solicitation issuance date (see 29 CFR 9.4(d)(2)). Failure to comply with this notification requirement shall render the waiver decision inoperative, and the contracting officer shall include the clause at 52.222-17 in the solicitation. The waiver decision and related written analysis shall be sent to the following address: U.S. Department of Labor, Wage and Hour Division, Branch of Government Contracts Enforcement, 200 Constitution Avenue, Room S-3006, Washington, D.C. 20210, or email to: Displaced@dol.gov .\n22.1203-4 Method of job offer.\nA job offer made by a successor contractor must be a bona fide express offer of employment on the contract. Each bona fide express offer made to a qualified service employee on the predecessor contract must have a stated time limit of not less than 10 days for an employee response. Prior to the expiration of the 10-day period, the contractor is prohibited from offering employment on the contract to any other person, subject to the exceptions at 22.1203-5 . Any question concerning an employee  s qualifications shall be decided based upon the individual  s education and employment history, with particular emphasis on the employee  s experience on the predecessor contract, and a contractor may utilize employment screening processes only when such processes are provided for by the contracting agency, are conditions of the service contract, and are consistent with the Executive Order. An offer of employment will be presumed to be bona fide even if it is not for a position similar to the one the employee previously held, but is one for which the employee is qualified, and even if it is subject to different employment terms and conditions, including changes to pay or benefits. (See 29 CFR 9.12(b) for regulatory provisions addressing circumstances in which a bona fide offer of employment can occur.)\n22.1203-5 Exceptions.\n(a) A successor contractor or its subcontractors are not required to offer employment to any service employee of the predecessor contractor who  \n(1) Will be retained by the predecessor contractor. \n(2) The successor contractor or any of its subcontractors reasonably believes, based on the particular service employee  s past performance, has failed to perform suitably on the job. (See 29 CFR 9.12(c)(4) for regulatory provisions addressing circumstances in which this exception would or would not be appropriate.) \n(b) A successor contractor or its subcontractors may employ under the contract any of its current service employees who (1) have worked for the successor contractor or its subcontractors for at least three months immediately preceding the commencement of the successor contract, and (2) would otherwise face lay-off or discharge.\n(c) The successor contractor bears the responsibility of demonstrating the appropriateness of claiming any of the preceding exceptions and the exemption listed at 22.1203-2 (a)(5) involving nonfederal work.\n22.1203-6 Reduced staffing.\nA successor contractor and its subcontractors may employ fewer service employees than the predecessor contractor employed in connection with performance of the work. Thus, the successor contractor need not offer employment on the contract to all service employees on the predecessor contract, but must offer employment only to the number of eligible service employees the successor contractor believes necessary to meet its anticipated staffing pattern. Where a successor contractor does not initially offer employment to all the predecessor contract service employees, the obligation to offer employment shall continue for 90 days after the successor contractor  s first date of performance on the contract. (See 29 CFR 9.12(d) for regulatory provisions addressing circumstances in which reduced staffing can occur.)\n22.1204 Certified service employee lists. \n(a) Not less than 30 days before completion of the contract, the predecessor contractor is required to furnish to the contracting officer a certified list of the names of all service employees working under the contract and its subcontracts at the time the list is submitted. The certified list must also contain anniversary dates of employment of each service employee under the contract and subcontracts for services. The information on this list is the same as that on the seniority list required by paragraph (n) of the clause at 52.222-41 , Service Contract Act of 1965. If there are no changes to the workforce before the predecessor contract is completed, then the predecessor contractor is not required to submit a revised list 10 days prior to completion of performance and the requirements of 52.222-41 (n) are met. When there are changes to the workforce after submission of the 30-day list, the predecessor contractor shall submit a revised certified list not less than 10 days prior to performance completion.\n(b) Immediately upon receipt of the certified service employee list but not before contract award, the contracting officer shall provide the certified service employee list to the successor contractor, and, if requested, to employees of the predecessor contractor or subcontractors or their authorized representatives.\n22.1205 Notification to contractors and service employees. \n(a) The contracting officer shall direct that the predecessor contractor provides written notice to service employees of their possible right to an offer of employment with the successor contractor. The written notice shall be  \n(1) Posted in a conspicuous place at the worksite; or\n(2) Delivered to the service employees individually. If such delivery is via e-mail, the notification must result in an electronic delivery receipt or some other reliable confirmation that the intended recipient received the notice. \n(b) Contracting officers may advise contractors to provide the notice in Appendix B to 29 CFR chapter 9. Where a significant portion of the predecessor contractor  s workforce is not fluent in English, the contractor shall provide the notice in English and the language(s) with which service employees are more familiar. English and Spanish versions of the notice are available on the Department of Labor website at http://www.dol.gov/whd/govcontracts . \n22.1206 Remedies and sanctions for violations of this subpart. \n(a) The Secretary of Labor has the authority to issue orders prescribing appropriate remedies, including, but not limited to, requiring the successor contractor to offer employment, in positions for which the employees are qualified, to service employees from the predecessor contract and payment of wages lost. (See 29 CFR 9.24(a)).\n(b) After an investigation (see 29 CFR 9.23) and a determination by the Administrator, Wage and Hour Division, Department of Labor, that lost wages or other monetary relief is due, the Administrator may direct that so much of the accrued payments due on either the contract or any other contract between the contractor and the Government shall be withheld as are necessary to pay the monies due. Upon the final order of the Secretary of Labor that such monies are due, the Administrator may direct that such withheld funds be transferred to the Department of Labor for disbursement. (See 29 CFR 9.24(c)). \n(c) If the contracting officer or the Administrator, Wage and Hour Division, Department of Labor, finds that the predecessor contractor has failed to provide the list required by 22.1204 , the contracting officer may, in his or her discretion, or on request by the Administrator, suspend contract payment until such time as the contractor provides the list to the contracting officer.\n(d) The Secretary of Labor may also suspend or debar a contractor or subcontractor for a period of up to three years for violations of 29 CFR part 9. \n22.1207 Contract clause.\nThe contracting officer shall insert the clause at 52.222-17 , Nondisplacement of Qualified Workers, in solicitations and contracts for (1) service contracts, as defined at 22.001 , (2) that succeed contracts for performance of the same or similar work at the same location and (3) that are not exempted by 22.1203-2 or waived in accordance with 22.1203-3 .");
register_book(&s, "|22|14|", "Employment of Workers with Disabilities", "Subpart 22.14  Employment of Workers with Disabilities\n22.1400 Scope of subpart.\nThis subpart prescribes policies and procedures for implementing Section 503 of the Rehabilitation Act of 1973, as amended ( 29 U.S.C. 793 ) (the Act); Executive Order 11758, January 15, 1974; and the regulations of the Secretary of Labor (41 CFR Part 60-741). In this subpart, the terms  contract  and  contractor  include  subcontract  and  subcontractor.  \n22.1401 Policy.\nGovernment contractors, when entering into contracts subject to the Act, are required to take affirmative action to employ, and advance in employment, qualified individuals with disabilities, without discrimination based on their physical or mental disability.\n22.1402 Applicability.\n(a) Section 503 of the Act applies to all Government contracts in excess of $15,000 for supplies and services (including construction) except as waived by the Secretary of Labor. The clause at 52.222-36 , Affirmative Action for Workers with Disabilities, implements the Act.\n(b) The requirements of the clause at 52.222-36 , Affirmative Action for Workers with Disabilities, in any contract with a State or local government (or any agency, instrumentality, or subdivision) shall not apply to any agency, instrumentality, or subdivision of that government that does not participate in work on or under the contract.\n22.1403 Waivers.\n(a) The agency head, with the concurrence of the Deputy Assistant Secretary for Federal Contract Compliance of the U.S. Department of Labor (Deputy Assistant Secretary), may waive any or all of the terms of the clause at 52.222-36 , Affirmative Action for Workers with Disabilities, for  \n(1) Any contract if a waiver is deemed to be in the national interest; or\n(2) Groups or categories of contracts if a waiver is in the national interest and it is  \n(i) Impracticable to act on each request individually; and\n(ii) Determined that the waiver will substantially contribute to convenience in administering the Act.\n(b)(1) The head of a civilian agency, with the concurrence of the Deputy Assistant Secretary, or (2) the Secretary of Defense, may waive any requirement in this subpart when it is determined that the contract is essential to the national security, and that its award without complying with such requirements is necessary to the national security. Upon making such a determination, the head of a civilian agency shall notify the Deputy Assistant Secretary in writing within 30 days.\n(c) The contracting officer shall submit requests for waivers in accordance with agency procedures.\n(d) A waiver granted for a particular class of contracts may be withdrawn for any contract within that class whenever considered necessary by the Deputy Assistant Secretary to achieve the purposes of the Act. The withdrawal shall not apply to contracts awarded before the withdrawal. The withdrawal shall not apply to solicitations under any means of sealed bidding unless it is made more than 10 days before the date set for bid opening.\n22.1404 Department of Labor notices.\nThe contracting officer shall furnish to the contractor appropriate notices that state the contractor  s obligations and the rights of individuals with disabilities. The contracting officer may obtain these notices from the Office of Federal Contract Compliance Programs (OFCCP) regional office.\n22.1405 Collective bargaining agreements.\nIf performance under the clause at 52.222-36 , Affirmative Action for Workers with Disabilities, may necessitate a revision of a collective bargaining agreement, the contracting officer shall advise the affected labor unions that the Department of Labor will give them appropriate opportunity to present their views. However, neither the contracting officer nor any representative of the contracting officer shall discuss with the contractor or any labor representative any aspect of the collective bargaining agreement.\n22.1406 Complaint procedures.\nFollowing agency procedures, the contracting office shall forward any complaints received about the administration of the Act to the  \nDeputy Assistant Secretary for Federal Contract  Compliance 200 Constitution Avenue, NW Washington, DC 20210\nor to any OFCCP regional or area office. The OFCCP shall institute investigation of each complaint and shall be responsible for developing a complete case record.\n22.1407 Actions because of noncompliance.\nThe contracting officer shall take necessary action, as soon as possible upon notification by the appropriate agency official, to implement any sanctions imposed on a contractor by the Department of Labor for violations of the clause at 52.222-36 , Affirmative Action for Workers with Disabilities. These sanctions (see 41 CFR 60-741.66) may include  \n(a) Withholding from payments otherwise due;\n(b) Termination or suspension of the contract; or\n(c) Debarment of the contractor.\n22.1408 Contract clause.\n(a) Insert the clause at 52.222-36 , Affirmative Action for Workers with Disabilities, in solicitations and contracts that exceed or are expected to exceed $15,000, except when  \n(1) Both the performance of the work and the recruitment of workers will occur outside the United States, Puerto Rico, the Northern Mariana Islands, American Samoa, Guam, the U.S. Virgin Islands, and Wake Island; or\n(2) The agency head has waived, in accordance with 22.1403 (a) or 22.1403 (b) all the terms of the clause.\n(b) If the agency head waives one or more (but not all) of the terms of the clause in accordance with 22.1403 (a) or 22.1403 (b), use the basic clause with its Alternate I.");
register_book(&s, "|22|15|", "Prohibition of Acquisition of Products", "Subpart 22.15  Prohibition of Acquisition of Products Produced by Forced or Indentured Child Labor\n22.1500 Scope.\nThis subpart applies to acquisitions of supplies that exceed the micro-purchase threshold.\n22.1501 Definitions.\nAs used in this subpart  \nForced or indentured child labor  means all work or service  \n(1) Exacted from any person under the age of 18 under the menace of any penalty for its nonperformance and for which the worker does not offer himself voluntarily; or\n(2) Performed by any person under the age of 18 pursuant to a contract the enforcement of which can be accomplished by process or penalties.\nList of Products Requiring Contractor Certification as to Forced or Indentured Child Labor  means the list published by the Department of Labor in accordance with E.O. 13126 of June 12, 1999, Prohibition of Acquisition of Products Produced by Forced or Indentured Child Labor. The list identifies products, by their country of origin, that the Departments of Labor, Treasury, and State have a reasonable basis to believe might have been mined, produced, or manufactured by forced or indentured child labor.\n22.1502 Policy.\nAgencies must take appropriate action to enforce the laws prohibiting the manufacture or importation of products that have been mined, produced, or manufactured wholly or in part by forced or indentured child labor ( 19 U.S.C. 1307 , 29 U.S.C. 201 , et seq ., and 41 U.S.C. 35 , et seq .). Agencies should make every effort to avoid acquiring such products.\n22.1503 Procedures for acquiring end products on the List of Products Requiring Contractor Certification as to Forced or Indentured Child Labor.\n(a) When issuing a solicitation for supplies expected to exceed the micro-purchase threshold, the contracting officer must check the List of Products Requiring Contractor Certification as to Forced or Indentured Child Labor (the List) ( www.dol.gov/ilab/ ) (see 22.1505 (a)). Appearance of a product on the List is not a bar to purchase of any such product mined, produced, or manufactured in the identified country, but rather is an alert that there is a reasonable basis to believe that such product may have been mined, produced, or manufactured by forced or indentured child labor.\n(b) The requirements of this subpart that result from the appearance of any end product on the List do not apply to a solicitation or contract if the identified country of origin on the List is  \n(1) Canada, and the anticipated value of the acquisition is $25,000 or more ( Subpart 25.4 );\n(2) Israel, and the anticipated value of the acquisition is $50,000 or more (see 25.406 );\n(3) Mexico, and the anticipated value of the acquisition is $79,507 or more (see Subpart 25.4 ); or\n(4) Armenia, Aruba, Austria, Belgium, Bulgaria, Croatia, Cyprus, Czech Republic, Denmark, Estonia, Finland, France, Germany, Greece, Hong Kong, Hungary, Iceland, Ireland, Italy, Japan, Korea, Latvia, Liechtenstein, Lithuania, Luxembourg, Malta, Netherlands, Norway, Poland, Portugal, Romania, Singapore, Slovak Republic, Slovenia, Spain, Sweden, Switzerland, Taiwan, or the United Kingdom and the anticipated value of the acquisition is $204,000 or more (see 25.402 (b)).\n(c) Except as provided in paragraph (b) of this section, before the contracting officer may make an award for an end product (regardless of country of origin) of a type identified by country of origin on the List the offeror must certify that  \n(1) It will not supply any end product on the List that was mined, produced, or manufactured in a country identified on the List for that product, as specified in the solicitation by the contracting officer in the Certification Regarding Knowledge of Child Labor for Listed End Products; or\n(2)(i) It has made a good faith effort to determine whether forced or indentured child labor was used to mine, produce, or manufacture any end product to be furnished under the contract that is on the List and was mined, produced, or manufactured in a country identified on the List for that product; and\n(ii) On the basis of those efforts, the offeror is unaware of any such use of child labor.\n(d) Absent any actual knowledge that the certification is false, the contracting officer must rely on the offerors  certifications in making award decisions.\n(e) Whenever a contracting officer has reason to believe that forced or indentured child labor was used to mine, produce, or manufacture an end product furnished pursuant to a contract awarded subject to the certification required in paragraph (c) of this section, the contracting officer must refer the matter for investigation by the agency  s Inspector General, the Attorney General, or the Secretary of the Treasury, whichever is determined appropriate in accordance with agency procedures, except to the extent that the end product is from the country listed in paragraph (b) of this section, under a contract exceeding the applicable threshold.\n(f) Proper certification will not prevent the head of an agency from imposing remedies in accordance with section 22.1504 (a)(4) if it is later discovered that the contractor has furnished an end product or component that has in fact been mined, produced, or manufactured, wholly or in part, using forced or indentured child labor.\n22.1504 Violations and remedies.\n(a) Violations. The Government may impose remedies set forth in paragraph (b) of this section for the following violations (note that the violations in paragraphs (a)(3) and (a)(4) of this section go beyond violations of the requirements relating to certification of end products) (see 22.1503 ):\n(1) The contractor has submitted a false certification regarding knowledge of the use of forced or indentured child labor.\n(2) The contractor has failed to cooperate as required in accordance with the clause at 52.222-19 , Child Labor Cooperation with Authorities and Remedies, with an investigation of the use of forced or indentured child labor by an Inspector General, the Attorney General, or the Secretary of the Treasury.\n(3) The contractor uses forced or indentured child labor in its mining, production, or manufacturing processes.\n(4) The contractor has furnished an end product or component mined, produced, or manufactured, wholly or in part, by forced or indentured child labor. Remedies in paragraphs (b)(2) and (b)(3) of this section are inappropriate unless the contractor knew of the violation.\n(b) Remedies.\n(1) The contracting officer may terminate the contract.\n(2) The suspending official may suspend the contractor in accordance with the procedures in Subpart 9.4 .\n(3) The debarring official may debar the contractor for a period not to exceed 3 years in accordance with the procedures in Subpart 9.4 .\n22.1505 Solicitation provision and contract clause.\n(a) Except as provided in paragraph (b) of 22.1503 , insert the provision at 52.222-18 , Certification Regarding Knowledge of Child Labor for Listed End Products, in all solicitations that are expected to exceed the micro-purchase threshold and are for the acquisition of end products (regardless of country of origin) of a type identified by country of origin on the List of Products Requiring Contractor Certification as to Forced or Indentured Child Labor, except solicitations for commercial items that include the provision at 52.212-3 , Offeror Representations and Certifications  Commercial Items. The contracting officer must identify in paragraph (b) of the provision at 52.222-18 , Certification Regarding Knowledge of Child Labor for Listed End Products, or paragraph (i)(1) of the provision at 52.212-3 , any applicable end products and countries of origin from the List. For solicitations estimated to equal or exceed $25,000, the contracting officer must exclude from the List in the solicitation end products from any countries identified at 22.1503 (b), in accordance with the specified thresholds.\n(b) Insert the clause at 52.222-19 , Child Labor  Cooperation with Authorities and Remedies, in all solicitations and contracts for the acquisition of supplies that are expected to exceed the micro-purchase thresholds.");
register_book(&s, "|22|16|", "Notification of Employee Rights Under t", "Subpart 22.16  Notification of Employee Rights Under the National Labor Relations Act\n22.1600 Scope of subpart.\nThis subpart prescribes policies and procedures to implement Executive Order 13496, dated January 30, 2009 (74 FR 6107, February 4, 2009).\n22.1601 Definitions. \nAs used in this subpart  \nSecretary  means the Secretary of Labor, U.S. Department of Labor.\nUnited States  means the 50 States, the District of Columbia, Puerto Rico, the Commonwealth of the Northern Mariana Islands, American Samoa, Guam, the U.S. Virgin Islands, and Wake Island.\n22.1602 Policy.\n(a) Executive Order 13496 requires contractors to post a notice informing employees of their rights under Federal labor laws.\n(b) The Secretary has determined that the notice must contain employee rights under the National Labor Relations Act (Act), 29 U.S.C. 151 et seq . The Act encourages collective bargaining, and protects the exercise by employees of their freedom to associate, to self-organize, and to designate representatives of their own choosing for the purpose of negotiating the terms and conditions of their employment or other mutual aid or protection.\n22.1603 Exceptions.\n(a) The requirements of this subpart do not apply to  \n(1) Contracts under the simplified acquisition threshold;\n(2) Subcontracts of $10,000 or less; and\n(3) Contracts or subcontracts for work performed exclusively outside the United States.\n(b) Exemptions granted by the Secretary.\n(1) If the Secretary finds that the requirements of the Executive Order impair the ability of the Government to procure goods and services on an economical and efficient basis or if special circumstances require an exemption in order to serve the national interest, the Secretary may exempt a contracting department or agency, or groups of departments or agencies, from the requirements of any or all of the provisions of this Executive Order with respect to a particular contract or subcontract, or any class of contracts or subcontracts, including the requirement to include the clause at 52.222-40 , or parts of that clause, in contracts.\n(2) Requests for exemptions may be submitted in accordance with Department of Labor regulations at 29 CFR 471.3.\n22.1604 Compliance evaluation and complaint investigations and sanctions for violations.\n(a) The Secretary may conduct compliance evaluations or investigate complaints of any contractor or subcontractor to determine if any of the requirements of the clause at 52.222-40 have been violated.\n(b) Contracting departments and agencies shall cooperate with the Secretary and provide such information and assistance as the Secretary may require in the performance of the Secretary  s functions.\n(c) If the Secretary determines that there has been a violation, the Secretary may take such actions as set forth in 29 CFR 471.14.\n(d) The Secretary may not terminate or suspend a contract or suspend or debar a contractor if the agency head has provided written objections, which must include a statement of reasons for the objection and a finding that the contractor  s performance is essential to the agency  s mission, and continues to object to the imposition of such sanctions and penalties. Procedures for enforcement by the Secretary are set out in 29 CFR 471.10 through 29 CFR 471.16.\n22.1605 Contract clause.\n(a) Insert the clause at 52.222-40 , Notification of Employee Rights under the National Labor Relations Act, in all solicitations and contracts, including acquisitions for commercial items and commercially available off-the-shelf items, except acquisitions  \n(1) Under the simplified acquisition threshold . For indefinite-quantity contracts, include the clause only if the value of orders in any calendar year of the contract is expected to exceed the simplified acquisition threshold; \n(2) For work performed exclusively outside the United States; or\n(3) Covered (in their entirety) by an exemption granted by the Secretary.\n(b) A contracting agency may modify the clause at 52.222-40 , if necessary, to reflect an exemption granted by the Secretary (see 22.1603 (b)).");
register_book(&s, "|22|17|", "Combating Trafficking in Persons", "Subpart 22.17  Combating Trafficking in Persons\n22.1700 Scope of subpart.\nThis subpart prescribes policy for implementing 22 U.S.C. 7104 .\n22.1701 Applicability.\nThis subpart applies to all acquisitions.\n22.1702 Definitions.\nAs used in this subpart  \nCoercion  means  \n(1) Threats of serious harm to or physical restraint against any person;\n(2) Any scheme, plan, or pattern intended to cause a person to believe that failure to perform an act would result in serious harm to or physical restraint against any person; or\n(3) The abuse or threatened abuse of the legal process.\nCommercial sex act   means any sex act on account of which anything of value is given to or received by any person.\nDebt bondage  means the status or condition of a debtor arising from a pledge by the debtor of his or her personal services or of those of a person under his or her control as a security for debt, if the value of those services as reasonably assessed is not applied toward the liquidation of the debt or the length and nature of those services are not respectively limited and defined.\nEmployee  means an employee of the Contractor directly engaged in the performance of work under the contract who has other than a minimal impact or involvement in contract performance.\nForced labor  means knowingly providing or obtaining the labor or services of a person  \n(1) By threats of serious harm to, or physical restraint against, that person or another person;\n(2) By means of any scheme, plan, or pattern intended to cause the person to believe that, if the person did not perform such labor or services, that person or another person would suffer serious harm or physical restraint; or\n(3) By means of the abuse or threatened abuse of law or the legal process.\nInvoluntary servitude  includes a condition of servitude induced by means of  \n(1) Any scheme, plan, or pattern intended to cause a person to believe that, if the person did not enter into or continue in such conditions, that person or another person would suffer serious harm or physical restraint; or\n(2) The abuse or threatened abuse of the legal process.\nSevere forms of trafficking in persons  means  \n(1) Sex trafficking in which a commercial sex act is induced by force, fraud, or coercion, or in which the person induced to perform such act has not attained 18 years of age; or\n(2) The recruitment, harboring, transportation, provision, or obtaining of a person for labor or services, through the use of force, fraud, or coercion for the purpose of subjection to involuntary servitude, peonage, debt bondage, or slavery.\nSex trafficking  means the recruitment, harboring, transportation, provision, or obtaining of a person for the purpose of a commercial sex act.\n22.1703 Policy.\nThe United States Government has adopted a zero tolerance policy regarding trafficking in persons. Additional information about trafficking in persons may be found at the website for the Department of State  s Office to Monitor and Combat Trafficking in Persons  at http://www.state.gov/g/tip . Government contracts shall  \n(a) Prohibit contractors, contractor employees, subcontractors, and subcontractor employees from  \n(1) Engaging in severe forms of trafficking in persons during the period of performance of the contract;\n(2) Procuring commercial sex acts during the period of performance of the contract; or\n(3) Using forced labor in the performance of the contract;\n(b) Require contractors and subcontractors to notify employees of the prohibited activities described in paragraph (a) of this section and the actions that may be taken against them for violations; and\n(c) Impose suitable remedies, including termination, on contractors that fail to comply with the requirements of paragraphs (a) and (b) of this section.\n22.1704 Violations and remedies.\n(a) Violations . The Government may impose the remedies set forth in paragraph (b) of this section if  \n(1) The contractor, contractor employee, subcontractor, or subcontractor employee engages in severe forms of trafficking in persons during the period of performance of the contract;\n(2) The contractor, contractor employee, subcontractor, or subcontractor employee procures a commercial sex act during the period of performance of the contract;\n(3) The contractor, contractor employee, subcontractor, or subcontractor employee uses forced labor in the performance of the contract; or\n(4) The contractor fails to comply with the requirements of the clause at 52.222-50 , Combating Trafficking in Persons.\n(b) Remedies . After determining in writing that adequate evidence exists to suspect any of the violations at paragraph (a) of this section, the contracting officer may pursue any of the remedies specified in paragraph (e) of the clause at 52.222-50 , Combating Trafficking in Persons. The contracting officer may take into consideration whether the contractor had a Trafficking in Persons awareness program at the time of the violation as a mitigating factor when determining the appropriate remedies. These remedies are in addition to any other remedies available to the United States Government.\n22.1705 Contract clause.\n(a) Insert the clause at 52.222-50 , Combating Trafficking in Persons, in all solicitations and contracts.\n(b) Use the basic clause with its Alternate I when the contract will be performed outside the United States (as defined at 25.003 ) and the contracting officer has been notified of specific U.S. directives or notices regarding combating trafficking in persons (such as general orders or military listings of  off-limits  local establishments) that apply to contractor employees at the contract place of performance.\n*    *    *    *    *    *");
register_book(&s, "|22|18|", "Employment Eligibility Verification", "Subpart 22.18  Employment Eligibility Verification\n22.1800 Scope.\nThis subpart prescribes policies and procedures requiring contractors to utilize the Department of Homeland Security (DHS), United States Citizenship and Immigration Service  s employment eligibility verification program (E-Verify) as the means for verifying employment eligibility of certain employees.\n22.1801 Definitions.\nAs used in this subpart  \nCommercially available off-the-shelf (COTS) item   \n(1) Means any item of supply that is  \n(i) A commercial item (as defined in paragraph (1) of the definition at 2.101 );\n(ii) Sold in substantial quantities in the commercial marketplace; and\n(iii) Offered to the Government, without modification, in the same form in which it is sold in the commercial marketplace; and \n(2) Does not include bulk cargo, as defined in 46 U.S.C. 40102(4) , such as agricultural products and petroleum products. Per 46 CFR 525.1 (c)(2),  bulk cargo  means cargo that is loaded and carried in bulk onboard ship without mark or count, in a loose unpackaged form, having homogenous characteristics. Bulk cargo loaded into intermodal equipment, except LASH or Seabee barges, is subject to mark and count and, therefore, ceases to be bulk cargo.\nEmployee assigned to the contract  means an employee who was hired after November 6, 1986 (after November 27, 2009, in the Commonwealth of the Northern Mariana Islands), who is directly performing work, in the United States, under a contract that is required to include the clause prescribed at 22.1803 . An employee is not considered to be directly performing work under a contract if the employee  \n(1) Normally performs support work, such as indirect or overhead functions; and\n(2) Does not perform any substantial duties applicable to the contract.\nSubcontract  means any contract, as defined in 2.101 , entered into by a subcontractor to furnish supplies or services for performance of a prime contract or a subcontract. It includes but is not limited to purchase orders, and changes and modifications to purchase orders.\nSubcontractor  means any supplier, distributor, vendor, or firm that furnishes supplies or services to or for a prime contractor or another subcontractor. \nUnited States  , as defined in 8 U.S.C. 1101(a)(38) , means the 50 States, the District of Columbia, Puerto Rico, Guam, the Commonwealth of Northern Mariana Islands, and the U.S. Virgin Islands.\n22.1802 Policy.\n(a) Statutes and Executive orders require employers to abide by the immigration laws of the United States and to employ in the United States only individuals who are eligible to work in the United States. The E-Verify program provides an Internet-based means of verifying employment eligibility of workers employed in the United States, but is not a substitute for any other employment eligibility verification requirements.\n(b) Contracting officers shall include in solicitations and contracts, as prescribed at 22.1803 , requirements that Federal contractors must  \n(1) Enroll as Federal contractors in E-Verify; \n(2) Use E-Verify to verify employment eligibility of all new hires working in the United States, except that the contractor may choose to verify only new hires assigned to the contract if the contractor is  \n(i) An institution of higher education (as defined at 20 U.S.C. 1001(a) ); \n(ii) A State or local government or the government of a Federally recognized Indian tribe; or\n(iii) A surety performing under a takeover agreement entered into with a Federal agency pursuant to a performance bond;\n(3) Use E-Verify to verify employment eligibility of all employees assigned to the contract; and\n(4) Include these requirements, as required by the clause at 52.222-54 , in subcontracts for  \n(i) Commercial or noncommercial services, except for commercial services that are part of the purchase of a COTS item (or an item that would be a COTS item, but for minor modifications), performed by the COTS provider, and are normally provided for that COTS item; and \n(ii) Construction.\n(c) Contractors may elect to verify employment eligibility of all existing employees working in the United States who were hired after November 6, 1986 (after November 27, 2009, in the Commonwealth of the Northern Mariana Islands) instead of just those employees assigned to the contract. The contractor is not required to verify employment eligibility of  \n(1) Employees who hold an active security clearance of confidential, secret, or top secret; or\n(2) Employees for whom background investigations have been completed and credentials issued pursuant to Homeland Security Presidential Directive (HSPD)-12. \n(d) In exceptional cases, the head of the contracting activity may waive the E-Verify requirement for a contract or subcontract or a class of contracts or subcontracts, either temporarily or for the period of performance. This waiver authority may not be delegated.\n(e) DHS and the Social Security Administration (SSA) may terminate a contractor  s MOU and deny access to the E-Verify system in accordance with the terms of the MOU. If DHS or SSA terminates a contractor  s MOU, the terminating agency must refer the contractor to a suspension or debarment official for possible suspension or debarment action. During the period between termination of the MOU and a decision by the suspension or debarment official whether to suspend or debar, the contractor is excused from its obligations under paragraph (b) of the clause at 52.222-54 . If the contractor is suspended or debarred as a result of the MOU termination, the contractor is not eligible to participate in E-Verify during the period of its suspension or debarment. If the suspension or debarment official determines not to suspend or debar the contractor, then the contractor must reenroll in E-Verify.\n22.1803 Contract clause.\nInsert the clause at 52.222-54 , Employment Eligibility Verification, in all solicitations and contracts that exceed the simplified acquisition threshold, except those that  \n(a) Are only for work that will be performed outside the United States;\n(b) Are for a period of performance of less than 120 days; or\n(c) Are only for  \n(1) Commercially available off-the-shelf items; \n(2) Items that would be COTS items, but for minor modifications (as defined at paragraph (3)(ii) of the definition of  commercial item  at 2.101 ); \n(3) Items that would be COTS items if they were not bulk cargo; or\n(4) Commercial services that are  \n(i) Part of the purchase of a COTS item (or an item that would be a COTS item, but for minor modifications);\n(ii) Performed by the COTS provider; and \n(iii) Are normally provided for that COTS item.\n*    *    *    *    *    *");
register_book(&s, "|23|10|", "Federal Compliance with Right-to-Know L", "Subpart 23.10  Federal Compliance with Right-to-Know Laws and Pollution Prevention Requirements\n23.1000 Scope.\nThis subpart prescribes policies and procedures for obtaining information needed for Government  \n(a) Compliance with right-to-know laws and pollution prevention requirements;\n(b) Implementation of an environmental management system (EMS) at a Federal facility; and\n(c) Completion of facility compliance audits (FCAs) at a Federal facility.\n23.1001 Authorities.\n(a) Emergency Planning and Community Right-to-Know Act of 1986, 42 U.S.C. 11001-11050 (EPCRA).\n(b) Pollution Prevention Act of 1990, 42 U.S.C. 13101-13109 (PPA).\n(c) Executive Order 13423 of January 24, 2007, Strengthening Federal Environmental, Energy, and Transportation Management. \n(d) Executive Order 13514 of October 5, 2009, Federal Leadership in Environmental, Energy, and Economic Performance.\n23.1002 Applicability.\nThe requirements of this subpart apply to facilities owned or operated by an agency in the customs territory of the United States.\n23.1003 Definitions.\nAs used in this subpart  \nFederal agency  means an executive agency (see 2.101 ).\n23.1004 Requirements.\n(a) Federal facilities are required to comply with  \n(1) The emergency planning and toxic release reporting requirements in EPCRA and PPA; and \n(2) The toxic chemical, and hazardous substance release and use reduction goals of sections 2(e) and 3(a)(vi) of Executive Order 13423.\n(b) Pursuant to EPCRA, PPA, E.O. 13423, and any agency implementing procedures, every new contract that provides for performance on a Federal facility shall require the contractor to provide information necessary for the Federal agency to comply with the  \n(1) Requirements in paragraph (a) of this section; and\n(2) Requirements for EMSs and FCAs if the place of performance is at a Federal facility designated by the agency.\n23.1005 Contract clause.\n(a) Insert the clause at 52.223-5 , Pollution Prevention and Right-to-Know Information, in solicitations and contracts that provide for performance, in whole or in part, on a Federal facility.\n(b) Use the clause with its Alternate I if the contract provides for contractor  \n(1) Operation or maintenance of a Federal facility at which the agency has implemented or plans to implement an EMS; or\n(2) Activities and operations  \n(i) To be performed at a Government-operated Federal facility that has implemented or plans to implement an EMS; and\n(ii) That the agency has determined are covered within the EMS.\n(c) Use the clause with its Alternate II if  \n(1) The contract provides for contractor activities on a Federal facility; and\n(2) The agency has determined that the contractor activities should be included within the FCA or an environmental management system audit.");
register_book(&s, "|23|11|", "Encouraging Contractor Policies to Ban", "Subpart 23.11  Encouraging Contractor Policies to Ban Text Messaging While Driving\n23.1101 Purpose.\nThis subpart implements the requirements of the Executive Order (E.O.) 13513, dated October 1, 2009 (74 FR 51225, October 6, 2009), Federal Leadership on Reducing Text Messaging while Driving.\n23.1102 Applicability.\nThis subpart applies to all solicitations and contracts.\n23.1103 Definitions.\nAs used in this subpart  \nDriving    \n(1) Means operating a motor vehicle on an active roadway with the motor running, including while temporarily stationary because of traffic, a traffic light, stop sign, or otherwise.\n(2) Does not include operating a motor vehicle with or without the motor running when one has pulled over to the side of, or off, an active roadway and has halted in a location where one can safely remain stationary.\nText messaging  means reading from or entering data into any handheld or other electronic device, including for the purpose of short message service texting, e-mailing, instant messaging, obtaining navigational information, or engaging in any other form of electronic data retrieval or electronic data communication. The term does not include glancing at or listening to a navigational device that is secured in a commercially designed holder affixed to the vehicle, provided that the destination and route are programmed into the device either before driving or while stopped in a location off the roadway where it is safe and legal to park.\n23.1104 Policy.\nAgencies shall encourage contractors and subcontractors to adopt and enforce policies that ban text messaging while driving  \n(a) Company-owned or -rented vehicles or Government-owned vehicles; or\n(b) Privately-owned vehicles when on official Government business or when performing any work for or on behalf of the Government.\n23.1105 Contract clause.\nThe contracting officer shall insert the clause at 52.223-18 , Encouraging Contractor Policies to Ban Text Messaging While Driving, in all solicitations and contracts.\n*    *    *    *    *    *");
